/*  This file is part of PaceMaker Estimator 2.0.
    PaceMaker Estimator 2.0 is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
    PaceMaker Estimator 2.0 is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along with PaceMaker Estimator 2.0. If not, see <https://www.gnu.org/licenses/>.
*/

#include "mainwindow.h"

void MainWindow::clearLib(QString defaultRefcode)
{
    long rw;

    for( rw=1L; rw<=LIBROWCOUNT-1; ++rw )
    {
        libRow[rw]->fileQtyBlock = nullptr;
        libRow[rw]->refcode = defaultRefcode;

        libRow[rw]->col[1]->clear();
        libRow[rw]->col[2]->clear();
        libRow[rw]->col[3]->clear();
        libRow[rw]->col[4]->clear();
    }

    clearLibStack();

    return;
}

void MainWindow::clearEst()
{
    long rw;

    if( oneHeader != nullptr )
        oneHeader->blankHeaderFields();

    for( rw=1L; rw<ESTROWCOUNT; ++rw )
    {
        estRow[rw]->col[1]->setReadOnly(false); // subtotals leave these true
        estRow[rw]->col[2]->setReadOnly(false); // so reset them to writable.

        estRow[rw]->col[1]->clear();
        estRow[rw]->col[2]->clear();       
        estRow[rw]->col[3]->clear();
        estRow[rw]->col[4]->clear();
        estRow[rw]->col[5]->clear();
        estRow[rw]->col[6]->clear();
        estRow[rw]->col[7]->clear();

        // if any qtymathHidden objects were created, then delete them:
        if( estRow[rw]->fileQtyBlock != nullptr )
        {
            delete (estRow[rw]->fileQtyBlock);
            estRow[rw]->fileQtyBlock = nullptr;
        }

        estRow[rw]->refcode = nullptr;
    }

    clearTabPages(); // these are Tab 1 to Tab 10 tabs_plusEstReadWrite.cpp
    clearEstStack();
    zerosetDRAGtotalsBottomSubtotalRow();

    estimateFilename = "";

    return;
}

void MainWindow::zerosetDRAGtotalsBottomSubtotalRow()
{
    double sumC = 0, sumH = 0;

    bottomSubtotalRow = -1L; // signal no descriptionTOTAL "=" block of lines
    ui->TotalHours->setDescription( QString(DRAGtotalhours).arg(sumH, 6, 'f', 2)); // 100\n    qty x hours
    ui->TotalCost->setDescription( QString(DRAGtotalcosts).arg(sumC, 6, 'f', 2));

    return;
}
