
/*  This file is part of PaceMaker Estimator 2.0.
    PaceMaker Estimator 2.0 is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
    PaceMaker Estimator 2.0 is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along with PaceMaker Estimator 2.0. If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef DIALOGHEADEROFESTIMATE_H
#define DIALOGHEADEROFESTIMATE_H

#include "qlineedit.h"
#include "QtWidgets/qdialog.h"
#include <QDialog>

namespace Ui {
class DialogHeaderOfEstimate;
}

class DialogHeaderOfEstimate : public QDialog
{
    Q_OBJECT

public:
    explicit DialogHeaderOfEstimate(QWidget *parent = nullptr);
    ~DialogHeaderOfEstimate();

    void blankHeaderFields();
    bool estimateReadHeader( QString *filename );
    bool estimateWriteHeader( QString *filename );
    bool existsAndNotEstimateMaker( QString filename );

    Ui::DialogHeaderOfEstimate *ui; // moved to here, public:, because Print function accesses it.

/* see dialogheaderofestimate.ui instead of this:
    QLineEdit clientLineEdit;
    QLineEdit addressLineEdit;
    QLineEdit cityLineEdit;
    QLineEdit postalCodeLineEdit;
    QLineEdit siteLineEdit;

    QLineEdit dateLineEdit;
    QLineEdit projectLineEdit;
    QLineEdit homePhoneLineEdit;
    QLineEdit businessPhoneLineEdit;
    QLineEdit contactNameLineEdit;
    QLineEdit emailLineEdit;
*/

private slots:
    void on_New_clicked();

    void on_Open_clicked();

    void on_SaveEstimate_clicked();

    void on_cancelPushButton_clicked();

    void on_okPushButton_clicked();

    QString stripFilename2( QString *ss );

    void snprintfreverse( QLineEdit *arg1, char *arg2, size_t max );
    char *stripEnd( char *ee, size_t );

private:
    char headstr[401];
    int qdec,mdec,tdec,ttdec,tmdec;
    char setstr[7], timecode;
};

#endif // DIALOGHEADEROFESTIMATE_H
