/*  This file is part of  PaceMaker Estimator 2.0.
     PaceMaker Estimator 2.0 is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
     PaceMaker Estimator 2.0 is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along with PaceMaker Estimator 2.0. If not, see <https://www.gnu.org/licenses/>.
*/

#include "mainwindow.h"

void MainWindow::doCalc()
{
    int ww, hh;
    QLineEdit *qle = nullptr, *product;
    long ll6, ll7;
    //QString ss;
    bool skipthe_calc_one_estline = false;

    if( (currentKeyboardLineEdit()) != nullptr)
    //if( (qle = currentKeyboardLineEdit()) != nullptr)
    {
        /* This is new March2023 for the libcode "==" for totals and subtotals
         * We stop all editing of these lines since
         * Drag and Drop controls these line
         * and we will allow Qty on one or two lines.
         */
        if( keyboardnow.libest == 2
                && estRow[ keyboardnow.row ]->col[1]->text().indexOf("=") >= 0 )
        {
#ifdef AllThisIsNowDoneIn_doInsertHoursTotalSubtotal

            if( estRow[ keyboardnow.row ]->col[2]->text().indexOf(SUBTOTALHOURSDESCRIPTION) >= 0
                && keyboardnow.col == 3 )
            {
                // then allow changes to Qty which is the multiplier
                ss = "x " + estRow[keyboardnow.row]->col[3]->text();
                estRow[keyboardnow.row]->col[6]->setText( ss );

                if( estRow[keyboardnow.row+3]->col[6]->text().indexOf("---") >= 0 )
                    product = estRow[keyboardnow.row+4]->col[6];
                else
                    product = estRow[keyboardnow.row+3]->col[6];

                calc_subtotalTotal(   estRow[keyboardnow.row]->col[6]->text(),
                                    estRow[keyboardnow.row+1]->col[6]->text(),
                                    product
                                    );
            }
            else if( estRow[ keyboardnow.row ]->col[2]->text().indexOf(SUBTOTALCOSTSDESCRIPTION) >= 0
                && keyboardnow.col == 3 )
            {
                // then allow changes to Qty which is the multiplier
                ss = "x " + estRow[keyboardnow.row]->col[3]->text();
                estRow[keyboardnow.row]->col[7]->setText( ss );

                if( estRow[keyboardnow.row+3]->col[7]->text().indexOf("---") >= 0 )
                    product = estRow[keyboardnow.row+4]->col[7];
                else
                    product = estRow[keyboardnow.row+3]->col[7];

                calc_subtotalTotal( estRow[keyboardnow.row]->col[7]->text(),
                                  estRow[keyboardnow.row+1]->col[7]->text(),
                                  product
                                    );
            }
            else
                ;//zzz trouble Mar26 qle->undo();

#endif

            skipthe_calc_one_estline = true;
        }

        //;//qDebugA() << "doCalc() is sometimes called twice because \n" << "  editingFinished, FocusOut, verticalSlider(), Tab, qtymath, all call doCalc() \n";

        /* Be sure the QLineText is scrolled into view before
         * doing calculations. An example of not in view
         * is scroll away and then press TAB or click on a
         * new square. This would be bad if a user did not know
         * he had changed a line accidentally. If no change was
         * made then doCalc is not called and this scroll
         * back to origin effect will not happen. So there is
         * no harm in checking if in view.
         */

        // you cannot send qle as an argument ! because it is a connect() signal and it cannot send arguments.
        if( skipthe_calc_one_estline == false )
            validateField();

        if( keyboardnow.libest == 2 ) // only scroll into view one side or the other.
        {
#ifdef Mar112024
            /*Mar 11, 2024 omit scroll_est...() because est was jumping up dn
             *just on key FocusIn because FocusOut does a docalc(). This one made more sense
             *than the lib one. I was concerned somebody would make a big
             *unseen change and click away. The jumpiness is worse. So let them not see changes.
             */
                scroll_est_into_view( qle );
#endif

                /* this is used in menuNewOpen.cpp
                 * void MainWindow::dialogCloseFilename_sub()
                 * to ask user for a filename to save estimate
                 * if no name has been assigned.
                 */
                estimateWasChanged = true;

                ;//qDebugA() << "calculations. estimateWasChanged=" << estimateWasChanged;

                // Qty|Cost|Hours affect the horizontal totals. Nothing else does.
                                                 // except drag and drop from library
                                                 // It will require some changes here.
                if( keyboardnow.col == 3
                        || keyboardnow.col == 4
                        || keyboardnow.col == 5 )
                {
                    // We will redo them all instead of investigating which field changed.
                    // It is just one row. It is very fast math.

                    // col 3 is Qty, col 6 and 7 are the results Totals.
                    // This is a rough summary of the QLineEdits, (wrong syntax):
                    //    estRow[ keyboardnow.row ]->col[3]
                    //  x estRow[ keyboardnow.row ]->col[4]
                    //  = estRow[ keyboardnow.row ]->col[7] ;

                    //    estRow[ keyboardnow.row ]->col[3]
                    //  x estRow[ keyboardnow.row ]->col[5]
                    //  = estRow[ keyboardnow.row ]->col[6] ;

                    if( skipthe_calc_one_estline == false )  // skip "===" lines, for example.
                        calc_one_estline( keyboardnow.row );

                    ;//qDebugA() << "searchForSubtotalTotalUpdateThem( keyboardnow.row="<<keyboardnow.row;

                    searchForSubtotalTotalUpdateThem( keyboardnow.row );
                }
        }
        else
        {
#ifdef Mar112024
            /*Mar 11, 2024 omit scroll_lib...() because lib was jumping up dn just on key FocusIn
             * because FocusOut does a docalc()
             * I also put a if(libside) do no docalc() in event*.cpp on FocusOut.
             *
              scroll_lib_into_view( qle );
             */
#endif
                ;//qDebugA() << "library side: no calculations";
        }
    }
    return;
}

/* 64 bit double precision is good up to 15 digits of one integer.
 * 2^53 to be precise.
 * What about 2 decimals for money?
 *
 * I should use the bigdecimal library instead of double precision
 * only if I want more than 13 digit dollar plus cents totals.
 * How wide are the totals columns right now?
 * See load2.cpp, as of Feb 17, 2023:
 * maxlength 8 for Qty
 * maxlength 11 for cost
 * maxlength 11 for hrs
 * maxlength 15 for each totals columns, which is 12.2
 * and 12 is 1 digit less than 13. So double is perfect accuracy.
 */
void MainWindow::calc_one_estline( long row )
{
    double dd3, dd4, dd5, dd6, dd7;
    QString ss;

    ss = estRow[ row ]->col[1]->text();
    if( *ss.data() == '=' ) // do not operate on =   == === subtotal/total blocks
        return;

    /* If Qty is blank then set the
     * two totals columns blank
     * instead of 0.0
     */
    if( estRow[ row ]->col[3]->text().isEmpty() == true )
    {
        estRow[ row ]->col[6]->setText( "" );
        estRow[ row ]->col[7]->setText( "" );
    }
    else
    {
        dd3 = estRow[ row ]->col[3]->text().toDouble();

        if( estRow[ row ]->col[5]->text().isEmpty() == true )
            // dd5 was blank
        {
            estRow[ row ]->col[6]->setText( "" );
        }
        else
        {
            dd5 = estRow[ row ]->col[5]->text().toDouble();
            dd6 = dd3 * dd5;

            // QString("delta: %1").arg(d, 0, 'E', 3); from the help section QString
            ss = QString("%1").arg( dd6, 6, 'f', 2);
            estRow[ row ]->col[6]->setText( ss );
        }

        if( estRow[ row ]->col[4]->text().isEmpty() == true )
            // dd4 was blank
        {
            estRow[ row ]->col[7]->setText( "" );
        }
        else
        {
            dd4 = estRow[ row ]->col[4]->text().toDouble();
            dd7 = dd3 * dd4;

            ss = QString("%1").arg( dd7, 6, 'f', 2);
            estRow[ row ]->col[7]->setText( ss );
        }
    }
    /* Since March 2023 I added subtotal/total.
     * There is a smarter way to do this, but let's do it the stupid
     * error-free way for now:
     */
    setDRAGtotalsBottomSubtotalRow(); // just updates the DRAG buttons

    return;
}

/* A smart way to speed up this function is to put a global row tracker inside
 * calc_one_estline() which always increases and never decreases while
 * the user is typing. Then you know the highest ever touched row.
 * This global row number can be set to zero when an clearEst() is called.
 * It can be set to the last line when estimateRead() is called.
 * Never bother tracking a shrinking estimate during Del.
 * Then use the global row as the maximum
 * in the for() loop, instead of using ESTROWCOUNT.
 * That would eliminate several hundred rows for most estimates
 * and speed processing.
 */
void MainWindow::setDRAGtotalsBottomSubtotalRow() // Insert sums into DRAG buttons: ui->TotalHours ui->TotalCost
{
    double sumH = 0.0, sumC = 0.0;
    QString ss;

    bottomSubtotalRow = -1L; //"=" block of est lines

    for( int rr=ESTROWCOUNT-1; rr >= 1; --rr)
    {
        /* quit at the first descriptionSUBTOTAL because that one summed everything above it.
           if( estRow[rr]->col[2]->text().indexOf( descriptionSUBTOTALS ) == 0 )
                break;
         */

        ss = estRow[rr]->col[1]->text();
        if( *ss.data() != '=' )
        {
            ss = estRow[rr]->col[6]->text();
            sumH += ss.toDouble();
            ss = estRow[rr]->col[7]->text();
            sumC += ss.toDouble();
        }
        else
        {
            if( rr >= bottomSubtotalRow
                || (bottomSubtotalRow-1) == rr)
             /* || adjacent row, so slide up to top of subtotal block.
                 * Do not point at bottom of block or else insertTotalSubtotal()
                 * fails to add the two TOTALS lines because the bottomSubtotalRow
                 * value is a couple rows too large after insertBlankLineEstSide().
                 * My bug fix does not precisely say how it failed before
                 * this "adjacent" test. I am pointing at which functions.
                 */
            {
                bottomSubtotalRow = rr;
                ;//qDebugA() << "setDRAG SETS" << rr;
            }
        }
    }
    ui->TotalHours->setDescription( QString(DRAGtotalhours).arg(sumH, 6, 'f', 2)); // 100\n    qty x hours
    ui->TotalCost->setDescription( QString( DRAGtotalcosts).arg(sumC, 6, 'f', 2));

    return;
}

#ifdef AllThisIsNowDoneIn_doInsertHoursTotalSubtotal
void MainWindow::calc_subtotalTotal( QString multiplier,
                                       QString multiplicand,
                                       QLineEdit *product )
{
    double dd3, dd5, dd6;
    QString ss;

    multiplicand.replace( "X", " "); // X 1.23 changes to 1.23 before toDouble()
    multiplicand.replace( "x", " "); // x 1.23 changes to 1.23 before toDouble()

    if( multiplier.isEmpty() == true )
    {
        product->setText( "" );
    }
    else
    {
        dd3 = multiplier.toDouble();

        if( multiplicand.isEmpty() == true )
        {
            product->setText( "" );
        }
        else
        {
            dd5 = multiplicand.toDouble();
            dd6 = dd3 * dd5;

        // QString("delta: %1").arg(d, 0, 'E', 3); from the help section QString
            ss = QString("%1").arg( dd6, 6, 'f', 2);
            product->setText( ss );
        }
    }

    return;
}
#endif

