
/*  This file is part of PaceMaker Estimator 2.0.
    PaceMaker Estimator 2.0 is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
    PaceMaker Estimator 2.0 is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along with PaceMaker Estimator 2.0. If not, see <https://www.gnu.org/licenses/>.
*/

#include "estlineedithistory.h"

#ifndef ESTUNDOCOMMAND_H
#define ESTUNDOCOMMAND_H

#include <QUndoCommand>

namespace Ui {
class estUndoCommand;
}

// QUndoStack is the class, which is called inside MainWindow,
// and does the push of this command, an instance of
// QUndoCommand, onto a stack and more than
// one stack instance can exist.
// I had to study 3m53s and 13m26s snap-shots in the .mp4 video.
// It is ridiculous to do this in video and I could not find
// a cut and paste print example and Qt doc was not enough.
// That trick with the connect( , , { QUndoCommand() } );
// creates a new instance of the item to be redone/undone
// for each checkbox.

// I could not understand if the QUndoCommand/QUndoStack set of functions
// required a QWidget of my own making via inheritance, eg. qcheckbox,
// OR were those arguments arbitrary and overloads and could be
// anything and is it sufficient I accomplish creation of
// qunstack->redo override and qunstack->undo override functions?
// I am going with the latter (everything after "OR") being true,
// with no instruction saying I am right.

// There is also an interesting example with no arguments
// and no rewriting-inheritance-undo/redo,
// for simpler than my undo/redo goal:
// https://doc.qt.io/qt-6/qundocommand.html#details
// I read it initially and I got completely misled about QUndoCommand
// capabilities because it is so very different and unrelated,
// almost like a completely different class.

// Feb16, 2023: Now that it works, I realize my libLineEditHistory
// object could have been combined into the libUndoCommand object
// and instead of passing one pointer, I could have passed
// the same three arguments as the libLineEditHistory object
// and did it all as one object.
// Now I get the point of QUnDoCommand. It is just any object,
// with any number of arguments, with a redo, undo function added.
// I am not re-writing it amalgamated. It works as is.

class estUndoCommand : public QUndoCommand
{
 public:
    estUndoCommand( estLineEditHistory *xx, QUndoCommand *parent = nullptr);
    void undo() override;
    void redo() override;
    void delete_estLineEditHistory();

    estLineEditHistory *archive;

private:
    Ui::estUndoCommand *ui;

};

#endif // ESTUNDOCOMMAND_H
