
/*  This file is part of PaceMaker Estimator 2.0.
    PaceMaker Estimator 2.0 is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
    PaceMaker Estimator 2.0 is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along with PaceMaker Estimator 2.0. If not, see <https://www.gnu.org/licenses/>.
*/

#include "mainwindow.h"
#include "qundostack.h"
#include "libundocommand.h"
#include "estundocommand.h"

// These functions largely moved to libundocommand.cpp and estundocommand.cpp
// as redo/undo

void MainWindow::libraryLibtoEst()
{
    bool ok;
    long targ, src;
    QMessageBox msgBox;
    //QPushButton *okButton = msgBox.addButton(tr("OK"), QMessageBox::ActionRole);
    //QPushButton *abortButton = msgBox.addButton(QMessageBox::Abort);

    estimateWasChanged = true;

    //bbbb

    // FocusOut happened due to this button press. See events.cpp.

    // Next immitate setting the src line as if we clicked on a lineEdit.
    // Copied from FocusIn() events.cpp:  (It finds the currentEstbuttonrow)
    getrowcol_ofcursors( &keyboardnow.libest, &keyboardnow.row, &keyboardnow.rowL, &keyboardnow.rowE, &keyboardnow.col, &keyboardnow.colL, &keyboardnow.colE);

    ;//qDebugA( << "\nhighlightedLibArrowRow"<<  keyboardnow.litLibButton;

    // force an equal row highlight on both sides if user did not select one by clicking cursor on both sides.
    if( keyboardnow.litLibButton == 0L ) //lib side arrow-row is off. Turn is on by using the currentLibbutton row that must have been pressed.
    {
        keyboardnow.rowL = keyboardnow.litLibButton = keyboardnow.row; // = keyboardnow.currentLibbuttonrow;
        keyboardnow.colL = keyboardnow.colE=keyboardnow.col;
        show_linenums_showHighlights( &keyboardnow.litLibButton, &keyboardnow.litEstButton, keyboardnow.litLibButton, keyboardnow.litEstButton );
    }
    if( keyboardnow.litEstButton == 0L ) // est side arrow-row is off. So use the same row as the currentLibbutton that must have been pressed and tell user with a message.
    {
        keyboardnow.rowE = keyboardnow.litEstButton = keyboardnow.row; // = keyboardnow.currentLibbuttonrow;
        keyboardnow.colL = keyboardnow.colE=keyboardnow.col;
        show_linenums_showHighlights( &keyboardnow.litLibButton, &keyboardnow.litEstButton, keyboardnow.litLibButton, keyboardnow.litEstButton );

        // Non-highlightedbutton target is not visible (scrolled out of view) then ask
        //failed idea because isVisible() does not mean seeable. if( libRow[ keyboardnow.currentEstbuttonrow ]->pushbutton->isVisible() == false )

        msgBox.setText("You pressed a LibToEst copy button.\nThe estimate side was not highlighted,\ntherefore the equal line number\nis used and will scroll into view.");
        msgBox.exec();

        //if (msgBox.clickedButton() == okButton)
        //{
            // OK
        //}
        //else if (msgBox.clickedButton() == abortButton)
        //{
            // abort
            //return;
        //}
    }

    // pre-load what a lineedit FocusIn will need in case the targ/src if() fails
    keyboardnow.rowL = keyboardnow.litLibButton;
    keyboardnow.rowE = keyboardnow.litEstButton;

    src = keyboardnow.row; // = keyboardnow.currentLibbuttonrow;
    ;//qDebugA( << "\nThe bug was turning on eventFilter for left/right buttons. Do not do it.\nsrc-LibArrowRow"<< src << keyboardnow.litLibButton << (src-keyboardnow.litLibButton);
    // move down or up the opposite side equally, as we click sequential items
    targ = keyboardnow.litEstButton + (src-keyboardnow.litLibButton);
    if( targ >= 1 && targ <= ESTROWCOUNT-1)
    {
        show_linenums_showHighlights( &keyboardnow.litLibButton, &keyboardnow.litEstButton, src, targ );

        // carefully load what a lineedit FocusIn will need.
        keyboardnow.rowL = keyboardnow.litLibButton;
        keyboardnow.rowE = keyboardnow.litEstButton;

        /* The new estLineEditHistory saves the est line to storage,
         * and then modifies the est line with the lib line source
         * and thirdly creates a redo storage of the new est line
         * for two versions of est line available to the
         * redo() undo() stack, which may or may not ever be used.
         * See Menu->Edit->Undo-lib/Redo-lib Undo-est/Redo-est.
         */

        // Feb 15,2023: note to self re: this form of xx.
        // estLineEditHistory *xx = new estLineEditHistory( this, targ, src, "LibEst" );
        // new estLineEditHistory is a memory leak.

        // When I clear() the QUndoCommand stack
        // I will delete all the estLineEditHistory instances.

        // QUndoCommand stack must be cleared when an old library
        // is cleared and when an old estimate is ended,
        // to prevent do/redo on the wrong
        // lib or est.

        if( estRow[targ]->col[1]->text().indexOf("=") >= 0 )
        {
            msgBox.setText("The estimate side = == ===\nare for subtotals. Delete the subtotal.");
            msgBox.exec();
        }
        else
        {
        // Does multiple lines of code as it creates the object:
        estLineEditHistory *xx = new estLineEditHistory( this, targ, src, TYPELibEst );
        // transfer a pointer to the object:
        estUndoCommand *command = new estUndoCommand( xx );
        // no delete because the stack needs it.
        //delete xx;   Instead, delete *archive variable later
        // See clearLibEst.cpp and clearEstStack().

        est_undo_stack.push(command);
        }

        // Feb 16, 2023: Now that it works, I realize my
        // estLineEditHistory object could have been combined
        // into the libUndoCommand object
        // instead of passing a pointer.

        // I cannot put ui->scrollArea
        // in the stack because ui is unavailable.
        // Later when stack.redo/undo() I must scrollArea again.
        scroll_est_into_view( estRow[targ]->col[1] );

#ifdef MoveHigherSoNoStackpushpop
        /* new March 2023. Never let = == == libcodes get into the undo
         * stack because those are subtotal/total blocks of the estimate
         * and you must not recover one line of these. They are blocks.
         * User can drag/drop a new one, instead.
         */
        if( estRow[targ]->col[1]->text().indexOf("=") >= 0 )
        {
            msgBox.setText("The estimate side = == ===\nare for subtotals. Delete the subtotal.");
            msgBox.exec();
            on_bundoEst_pressed();  // undo est side
            //clearEstStack();
            /* Instead of clearing the entire stack, do a stack activity so the
             * recovery of the = == === by redo is impossible, by
             * writing on the stack an Ins line, which user can undo().
             */
            estLineEditHistory *yy = new estLineEditHistory(
                                this, ESTROWCOUNT-1, targ, TYPEIns);
            command = new estUndoCommand( yy );
            est_undo_stack.push(command);
        }
#endif
    }
    else
    {
        //https://doc.qt.io/qt-6/qmessagebox.html

        msgBox.setText("The estimate side highlighted line\nis beyond the screen as a target.\nClick on an estimate side rectangle\nto set the target row and try again.");
        msgBox.exec();
    }
}

void MainWindow::libraryEsttoLib()
{
    bool ok;
    long targ, src;
    QMessageBox msgBox;
    //QPushButton *okButton = msgBox.addButton(tr("OK"), QMessageBox::ActionRole);
    //QPushButton *abortButton = msgBox.addButton(QMessageBox::Abort);
    libUndoCommand *commandLib;

    // FocusOut happened due to this button press. See events.cpp.

    // Next imitate setting the src line as if we clicked on a lineEdit.
    // Copied from FocusIn() events.cpp:  (It finds the currentEstbuttonrow)
    getrowcol_ofcursors( &keyboardnow.libest, &keyboardnow.row, &keyboardnow.rowL, &keyboardnow.rowE, &keyboardnow.col, &keyboardnow.colL, &keyboardnow.colE);

    // force an equal highlight on both sides if user did not select one by lineEdit:
    if( keyboardnow.litLibButton == 0L )
    {
        // Non-highlightedbutton target is not visible (scrolled out of view) then ask
        //failed idea because isVisible() does not mean seeable. if( libRow[ keyboardnow.currentEstbuttonrow ]->pushbutton->isVisible() == false )
        //{

        //mmmm }
        keyboardnow.rowL = keyboardnow.litLibButton = keyboardnow.row; // = keyboardnow.currentEstbuttonrow;
        keyboardnow.colL = keyboardnow.colE = keyboardnow.col;
        show_linenums_showHighlights( &keyboardnow.litLibButton, &keyboardnow.litEstButton, keyboardnow.litLibButton, keyboardnow.litEstButton );
        if( keyboardnow.litEstButton == 0L )
        {
            keyboardnow.rowE = keyboardnow.litEstButton = keyboardnow.row; // = keyboardnow.currentEstbuttonrow;
            keyboardnow.colL = keyboardnow.colE = keyboardnow.col;
            show_linenums_showHighlights( &keyboardnow.litLibButton, &keyboardnow.litEstButton, keyboardnow.litLibButton, keyboardnow.litEstButton );
        }

#ifdef ESTtoLIBisNICELYinsertingBLANKlinesNowSoSKIPthisMSG
        msgBox.setText("You pressed an EstToLib copy button.\nThe library side was not highlighted,\ntherefore the equal line number\nis used and will scroll into view.");
        msgBox.exec();

        if (msgBox.clickedButton() == okButton)
        {
            // OK
        }
        else if (msgBox.clickedButton() == abortButton)
        {
            // abort

            /* xxxx  experiment for implementing undo() failed.
                if( libRow[keyboardnow.litLibButton]->col[2]->isUndoAvailable() == true )
                    ;//qDebugA() << "undoAvailable" <<  "true";
                else
                    ;//qDebugA() << "undoAvailable" <<  "false";
            */

            return;
        }
#endif
    }
    else if( keyboardnow.litEstButton == 0L )
    {
        keyboardnow.rowE = keyboardnow.litEstButton = keyboardnow.row; // = keyboardnow.currentEstbuttonrow;
        keyboardnow.colL = keyboardnow.colE = keyboardnow.col;
        show_linenums_showHighlights( &keyboardnow.litLibButton, &keyboardnow.litEstButton, keyboardnow.litLibButton, keyboardnow.litEstButton );
    }

    // carefully load what a lineedit FocusIn will need in case the targ/src if() fails
    keyboardnow.rowL = keyboardnow.litLibButton;
    keyboardnow.rowE = keyboardnow.litEstButton;

    src = keyboardnow.row; // = keyboardnow.currentEstbuttonrow;
    // move down or up the opposite side equally, as we click sequential items
    targ = keyboardnow.litLibButton + (src-keyboardnow.litEstButton);
    if( targ >= 1 && targ <= LIBROWCOUNT-1)
    {
        //;//qDebugA() << "column is" << keyboardnow.col;
        show_linenums_showHighlights( &keyboardnow.litLibButton, &keyboardnow.litEstButton, targ, src );

        // carefully load what a lineedit FocusIn will need.
        keyboardnow.rowL = keyboardnow.litLibButton;
        keyboardnow.rowE = keyboardnow.litEstButton;

        /* The new libLineEditHistory saves the lib line to storage,
         * and then modifies the lib line with the est line source
         * and thirdly creates a redo storage of the new lib line
         * for two versions of lib line available to the
         * redo() undo() stack, which may or may not ever be used.
         * See Menu->Edit->Undo-lib/Redo-lib Undo-est/Redo-est.
         */

        // Feb 15,2023: note to self re: this form of xx.
        // libLineEditHistory *xx = new libLineEditHistory( this, targ, src, TYPEEstLib );
        // new libLineEditHistory is a memory leak.

        // When I clear() the QUndoCommand stack
        // I will delete all the copies inside of my QUndoCommand.

        // QUndoCommand stack must be cleared when an old library
        // is cleared and when an old estimate is ended,
        // to prevent do/redo on the wrong
        // lib or est.

        /* save the refcode for this new library line
         * into both the library line and the source
         * estimate lines. They are now the same.
         * The refcode is the library name's 2 chars, WD, of *WD, for example.
         * (a bug or a feature is the undo/redo buttons loses the new refcode).
         */
      if( estRow[src]->col[1]->text().indexOf("=") < 0 )
      {
        QString ss;
        if( ui->comboBox->currentIndex() != -1)
        {
            ss = ui->comboBox->currentText();
            ss.truncate(2);
        }
        else
            ss = "";

#ifndef ESTtoLIBisNICELYinsertingBLANKlinesNowSoSKIPthisMSG
        // Before copying the line from est to lib, insert a blank line
        libLineEditHistory *eH = new libLineEditHistory(
                    this, LIBROWCOUNT-1, targ, TYPEIns);
        libUndoCommand *command = new libUndoCommand( eH );
        lib_undo_stack.push(command);
#endif

        /* My observation Mar 2023: libRow[targ]->refcode is an odd concept
         * because ALL refcodes for one library list are the same.
         * I made an innocuous design mistake by including
         * libRow[]->refcode in mainwindow.h but it is handy for
         * libraryLibtoEst(). So I looked there and then I had to go to
         * estlineedithistory.cpp and sure enough libRow[]->refcode
         * is used in that handy way! (but I could have drawn from the title).
         *
         * In this function, est to lib refcode is used from the
         * currentText() which is the title, not from the libRow[]->refcode.
         * because this is a new libRow which has no refcode. However
         * none of this had to be done if I designed with
         * no libRow[]->refcode and only used estRow[]->refcode drawn
         * from the lib titles, which is all that is needed for a design.
         */
        estRow[src]->refcode = libRow[targ]->refcode = ss.trimmed();

        // Does multiple lines of code as it creates the object:
        libLineEditHistory *xx = new libLineEditHistory( this, targ, src, TYPEEstLib );
        // transfer a pointer to the object:
        commandLib = new libUndoCommand( xx );
        // no delete because the stack needs it.
        //delete xx;   Instead, delete *archive variable later
        // See clearLibEst.cpp and clearLibStack() below.

        lib_undo_stack.push(commandLib);

        // Feb 16, 2023: Now that it works, I realize my
        // libLineEditHistory object could have been combined
        // into the libUndoCommand object
        // instead of passing a pointer.

        // I cannot put ui->scrollArea
        // in the stack because ui is unavailable.(Edit Mar 4, 2023: I am
        // not sure if "unavailable is true. It might be before I learned how to
        // access parent-> from QWidget to MainWindow pointer conversion.
        // I am not changing it. It works.)
        // Later when stack.redo/undo() I must scrollArea again.

        if( currentLibSortON == true ) // I am calling sort because autoSort is ON
        {
            on_sortOnce_triggered();
            searchLibrary( estRow[src]->col[1]->text() );
            /* I think this is better than scroll_lib...() because it highlights target
             * but I do it because targ is wrong after a sort.
             */
        }
        else
            scroll_lib_into_view( libRow[targ]->col[4] );
      }
    }
    else
    {
        //https://doc.qt.io/qt-6/qmessagebox.html
        msgBox.setText("The library side highlighted line\nsets the target beyond the top or bottom.\nClick on a library side row\nto lower the highlight target and try again.");
        msgBox.exec();
    }
    return;
}

// lib undo
void MainWindow::on_bundoLib_pressed()
{
    if( lib_undo_stack.canUndo() == true )
    {
        lib_undo_stack.undo();

        // do it AFTER .undo() completed because index() is redo.
        libUndoCommand *xx = (libUndoCommand *)lib_undo_stack.command( lib_undo_stack.index() );
        scroll_lib_into_view( xx->archive->preferredScrollIntoViewQle );
    }
}

// lib redo
void MainWindow::on_bredoLib_pressed()
{
    if( lib_undo_stack.canRedo() == true )
    {
        libUndoCommand *xx = (libUndoCommand *)lib_undo_stack.command( lib_undo_stack.index() );
        scroll_lib_into_view( xx->archive->preferredScrollIntoViewQle );

        lib_undo_stack.redo();
    }
}

//est undo
void MainWindow::on_bundoEst_pressed()
{
    long row;

    if( est_undo_stack.canUndo() == true )
    {
        est_undo_stack.undo();

        // do it AFTER .undo() completed because index() is redo.
        estUndoCommand *xx = (estUndoCommand *)est_undo_stack.command( est_undo_stack.index() );
        scroll_est_into_view( xx->archive->preferredScrollIntoViewQle );
        if( parseRowFromStatusTip( &row,  xx->archive->preferredScrollIntoViewQle  ) == true )
            calc_one_estline( row );
    }
}

//est redo
void MainWindow::on_bredoEst_pressed()
{
    long row;

    if( est_undo_stack.canRedo() == true )
    {
        estUndoCommand *xx = (estUndoCommand *)est_undo_stack.command( est_undo_stack.index() );
        scroll_est_into_view( xx->archive->preferredScrollIntoViewQle );
        est_undo_stack.redo();
        if( parseRowFromStatusTip( &row,  xx->archive->preferredScrollIntoViewQle  ) == true )
            calc_one_estline( row );
    }
}

void MainWindow::clearEstStack()
{
    int cc;
    libUndoCommand *command;

    // See clearLibEst.cpp

    /*
const QUndoCommand *QUndoStack::command(int index) const
Returns a const pointer to the command at index.

This function returns a const pointer, because modifying a command, once it has been pushed onto the stack and executed, almost always causes corruption of the state of the document, if the command is later undone or redone.

See also QUndoCommand::child().

int QUndoStack::count() const
Returns the number of commands on the stack. Macro commands are counted as one command.
*/
    for( cc=est_undo_stack.count(); --cc>=0; )
    {
        ;//qDebugA() << "delete estStack count:" << cc;

        estUndoCommand *command = (estUndoCommand *)est_undo_stack.command(cc);
        command->delete_estLineEditHistory();
    }
    est_undo_stack.clear();
    return;
}

void MainWindow::clearLibStack()
{
    int cc;
    libUndoCommand *command;

    // See clearLibEst.cpp

    /*
const QUndoCommand *QUndoStack::command(int index) const
Returns a const pointer to the command at index.

This function returns a const pointer, because modifying a command,
once it has been pushed onto the stack and executed, almost always
causes corruption of the state of the document, if the command is
later undone or redone.

See also QUndoCommand::child().

int QUndoStack::count() const
Returns the number of commands on the stack. Macro commands are counted as one command.
*/
    for( cc=lib_undo_stack.count(); --cc>=0; )
    {
        //;//qDebugA() << "delete libStack count:" << cc;

        libUndoCommand *command = (libUndoCommand *)lib_undo_stack.command(cc);
        command->delete_libLineEditHistory();
    }
    lib_undo_stack.clear();
    return;
}

void MainWindow::scroll_est_into_view( QLineEdit *qle )
{
    int hh,ww;
    //QPushButton *pb = qlea->pushbutton;
    //QLineEdit *pb = qle->col[1];

    hh = qle->frameGeometry().height();
    ww = qle->frameGeometry().width();
    ui->scrollArea->ensureWidgetVisible( qle, ww, hh);
}

void MainWindow::scroll_lib_into_view( QLineEdit *qle )
{
    int hh,ww;
    //QPushButton *pb = qlea->pushbutton;
    //QLineEdit *pb = qlea->col[4];

#ifdef DEBUG
    long row;

    if( parseRowFromStatusTip( &row,  qle  ) )
        qDebug() << "did a scroll_lib_into_view()" << row;
    else
        qDebug() << "did a scroll_lib_into_view() no row";

#endif

    hh = qle->frameGeometry().height();
    ww = qle->frameGeometry().width();
    ui->scrollArea_2->ensureWidgetVisible( qle, ww, hh);
}

long MainWindow::searchLibrarySlowly( QString libcode )
{
    long rw, sz=LIBROWCOUNT-1;

    for( rw=1; rw<=sz; ++rw )
    {
        /* works but switch to QString compare.
        if( strncmp( libRow[rw]->col[1]->text().toStdString().c_str(),
                     libcode.toStdString().c_str(),
                     3 ) >= 0
                    )
        */
        if( libRow[rw]->col[1]->text().compare( libcode,
                                       Qt::CaseInsensitive ) >= 0 )
        {
            break;
        }
    }
    return(rw);
}

qsizetype MainWindow::searchLibrary( QString libcode )
{
    long rw, sz=LIBROWCOUNT-1;
    /* This could be speed-improved by putting li in libraryRead()
     * and updating it in libundocommand.cpp where libToest and
     * Del and Ins occur. But that would add potential errors.
     *
     * A simpler improvement is load it as a static variable (or external)
     * upon keyboard focus, instead of as a local variable,
     * and erase it upon keyboard exit. See these:
     *(event->type() == QEvent::FocusIn )    eventMouseKeyboard.cpp
     *(event->type() == QEvent::FocusOut )
     *
     * Recreating the QStringList upon every single keystroke in col[1]
     * is retarded. Fortunately libcode is only 3 chars x 1000 lines.
     * So I am going to improve it the simple way now. March 2023.
     * I added a li.clear() and changed it to: static QStringList li;
     */
    static QLineEdit *saveHighlightedSelected;
    static QStringList li;
    QString ss, libcode1, libcodeChop;
    qsizetype idx;
    QRegularExpression re; //re("abc|ab"); or "abc*"

    if( libcode.isEmpty() ) // See FocusIn in eventMouseKeyboard.cpp
    {
        if( saveHighlightedSelected != nullptr )
        {
           saveHighlightedSelected->deselect();
           saveHighlightedSelected = nullptr;
        }
        li.clear();  // sets isEmpty()
        return(0);
    }

    // this creates a list because there is none. It can be reused. Notice it is static var..
   if( li.isEmpty() )
   {
       ;//qDebugA() << "loading QStringList li:" << libcode;
       // find the count from bottom up because do not quit on middleblanks
       for(sz=LIBROWCOUNT-1;sz>=1;--sz)
       {
           ss = libRow[sz]->col[1]->text();
           if( ss.isEmpty()
                   && libRow[sz]->col[2]->text().isEmpty()
                   //&& libRow[sz]->col[3]->text().isEmpty()
                   //&& libRow[sz]->col[4]->text().isEmpty()
                   )
               continue;
           else
               break;
       }
       if( sz == 0 ) //none, so fill one in case of crash-bug on li none.
           li << "   ";
       // sz is now the correct last row because it has data when sz>0
;//qDebugA() << "after li load, li.count() is" << sz;

       for( rw=1; rw<=sz;++rw)
       {
           ss = libRow[rw]->col[1]->text();
           if( ss.isEmpty() )
               li << "   ";
           else
               li << ss;

           /* old way goofed up on middle blanks omitted.
           if( ss.isEmpty()
                   && libRow[rw]->col[2]->text().isEmpty()
                   //&& libRow[rw]->col[3]->text().isEmpty()
                   //&& libRow[rw]->col[4]->text().isEmpty()
                   )
               continue;
           else
               li << ss;
           */
       }
   }
   else
   {
       ;//qDebugA() << "good: searching" << libcode <<" without loading library list";
   }

   // This next step does the actual search:

    //libcode1="";
    rw=0;
    libcode1 = libcodeChop = libcode;
    do{
        if( ++rw>4 )
            break;
        //;//qDebugA() << libcode1;

re.setPattern( QRegularExpression::wildcardToRegularExpression(libcode1) );
        if( (idx=li.indexOf( re,0 )) >= 0 )
        {
            break;
        }

        if( libcodeChop.isEmpty()==false )
        {
            //libcode1 += "|";
            libcode1 = libcodeChop + "*";
        }
        else
            break;
        libcodeChop.chop(1);

    }while(1);

    // experiments:
    //libcode1 = QRegularExpression::wildcardToRegularExpression(libcode1);
    //MatchType QRegularExpression::PartialPreferCompleteMatch;
    //re.match( libcode1, 0, QRegularExpression::PartialPreferCompleteMatch,

    if( idx >= 0 )
    {
        /* we found a F* or exact FRM. Let's do some incremental
         * improvement by linear steps
         * by using strncmp() which discerns greater/lesser order.
         */
        sz = li.count();
        for( rw = idx + 1; rw<=sz; ++rw, ++idx)
        {
            //;//qDebugA() << libcode1 << "|" << rw << "|" << sz << "|"<< libRow[rw]->col[1]->text();

            /*if( strncmp( libRow[rw]->col[1]->text().toStdString().c_str(),
                         libcode.toStdString().c_str(),
                         3 ) >= 0
                        )
               */
            if( libRow[rw]->col[1]->text().compare( libcode,
                                       Qt::CaseInsensitive ) >= 0 )

            {
                break;
            }
        }

        if( saveHighlightedSelected != nullptr )
            saveHighlightedSelected->deselect();

        scroll_lib_into_view( libRow[rw]->col[1] );
        qDebug() << "did a searchlibrary()" << libcode;

        saveHighlightedSelected = libRow[rw]->col[1];
        libRow[rw]->col[1]->selectAll();
    }
    else
        rw = idx + 1;  // same as for() initializer

    // idx can be -1 and then return is 0, which is failure for search.
    return(rw); // li starts at 0, while libRow[1] starts at 1, so +1.
}

void MainWindow::on_sortOnce_triggered()
{
    long rw;
    QStringList li;
    QString ss;

    for(rw=1; rw<=LIBROWCOUNT-1;++rw)
    {
        /* attach a ,rw lookup (a comma and row) so we can
         * use the actual libRow[rw] QLineEdit()s
         * during rewrite of the lib side QLineEdits
         * as we later read this list in the new sorted order.
         */
        qleToUpper( libRow[rw]->col[1] );

        if(        libRow[rw]->col[1]->text().isEmpty()
                && libRow[rw]->col[2]->text().isEmpty()
                && libRow[rw]->col[3]->text().isEmpty()
                && libRow[rw]->col[4]->text().isEmpty()
                )
            continue;
        else
        {
            ss = QString("%1,%2").arg(libRow[rw]->col[1]->text(),-3,' ').arg(rw);
            //;//qDebugA() << ss;
            li << ss;
        }
    }
    li.sort();
    //;//qDebugA() << "li.count() after sort:" << li.count();

    if( libraryFilename.isEmpty() == false )
    {
        /* write to disk, overwriting est.lib/WD or whatever library
         * name. What is the library name? libraryFilename external
         * in MainWindow.h. That libraryFilename was set inside the
         * function libraryRead( filename ) which did the initial
         * library read. We cannot use libraryWrite(); wrong order.
         */
        QString qfnp = nullptr;
        QString combotext;
        long xx, stop;
        unsigned yy;
        qsizetype offset;
        char *buf, buffer[51];
        buf = buffer;
        struct libraryold {
            QLineEdit *title;  // first line of file has the "*WD and Bricks Title", eg..
            QLineEdit *libcode;  // library 3 char code library line. Never blank.
            QLineEdit *description;
            QLineEdit *hours;
            QLineEdit *cost;
        }lib;
        QFile fp(libraryFilename);

        // open file in write mode like in libraryWrite() menuNewOpen.cpp
        if( fp.open(QIODeviceBase::WriteOnly) == false)
              ;
        else
        {
            qfnp = libraryFilename;
            qfnp = stripFilename( &qfnp );

            // The format needs *WD description, but * is never used.
            // where WD is the refcode.

            combotext = ui->comboBox->currentText();
            if( combotext.size() < 3)
                combotext.resize(3,' ');

            ss = QString("*%1 %2\n").arg(qfnp,-2,' ').arg(combotext.sliced(2),-42,' ');
            ss.truncate(47);
            strncpy( buf, ss.toStdString().c_str(),48 );

            for( yy=0; yy<42; ++yy)
                if( buf[yy] == '\0' )
                    buf[yy] = ' ';
            buf[42]='\r';
            buf[43]='\n';

            //;//qDebugA() << "buf>" << buf << "<buf";

            if( fp.write( buf, 44) < 44 )
            {
              ;//qDebugA() <<"Error: Cannot save.";
              fp.close();
              return;
            }

          //QString *liDat = li.data();
          for( xx=0, stop=li.count(); stop>0; --stop,++xx)
          {
            /* rw is grabbed from the li ",rw" appendage.
             * Ignore the before "," data. Just grab the row.
             */
            QString data = li.at(xx);

            if( (offset=data.indexOf(",")) >= 0 )
            {
                rw = data.sliced(offset+1).toLong();
                //;//qDebugA() << "stop" << stop << "li.count():" << li.count() << "row" << rw;
                //;//qDebugA() << "\ndata>" << data << "<data";

                // write one libRow[rw].col[] exactly like libraryWrite()

                /* This is copy/paste from libraryWrite().
                 * It would be better as a function so changes are shared.
                 */
                //sprintf( buf, "% 43s", "" ); // warning undefined behaviour
                memset( buf,' ', 43); // fill with spaces.
                buf[43] = '\0';

                lib.libcode = libRow[rw]->col[1];
                // skip saving = == === lines (which are unlikely now but I had some).
                if( lib.libcode->text().indexOf("=") >= 0 )
                    continue;
                lib.description = libRow[rw]->col[2];
                lib.hours = libRow[rw]->col[3];
                lib.cost = libRow[rw]->col[4];

                sprintfreverse( lib.libcode, (char *)"%.3s", buf );
                sprintfreverse( lib.description, (char *)"%.24s", buf+4 );

                sprintfreverse( lib.hours,(char *)"%5.5s", buf+30 );
                sprintfreverse( lib.cost, (char *)"%5.5s", buf+35 );

                //;//qDebugA() << lib.libcode->text() << lib.description->text() << '|';

                for( yy=0; yy<42; ++yy)
                    if( buf[yy] == '\0' )
                        buf[yy] = ' ';
                buf[42]='\r';
                buf[43]='\n';

                if( fp.write(buf,44) < 44)
                {
                    ;//qDebugA() << "failed write lib in sort libTOest.cpp.";
                    break;
                }
            }
          }
          fp.close();

          clearLib(qfnp);
          //clear because library can be short by removed blank lines,
          //like Ins-erted blank lines for example.

          /* Reread the now-sorted library to refill the QLineEdit()s */
          libraryRead( &libraryFilename, &combotext, false );
        }
    }

    return;
}

void MainWindow::on_sortAlways_triggered()
{
    /* if ON turn OFF and show it in the menu
     * and the status tip and the tool tip.
     */
    if( currentLibSortON == false )
    {
        currentLibSortON = true;
        ui->sortAlways->setText("Sort is ON");
        ui->sortAlways->setToolTip("Auto-Sort change to OFF");
        ui->sortAlways->setStatusTip("Always-sort library now ON");

        on_sortOnce_triggered();  // do a sort to start the new status
    }
    else
    {
        currentLibSortON = false;
        ui->sortAlways->setText("Sort is OFF");
        ui->sortAlways->setToolTip("Auto-Sort change to ON");
        ui->sortAlways->setStatusTip("Always-sort library now OFF");
    }

    return;
}
