/*  This file is part of PaceMaker Estimator 2.0.
    PaceMaker Estimator 2.0 is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
    PaceMaker Estimator 2.0 is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along with PaceMaker Estimator 2.0. If not, see <https://www.gnu.org/licenses/>.
*/


#include "mainwindow.h"
#ifndef LIBTOESTDOREDOUNDO_H
#define LIBTOESTDOREDOUNDO_H

#include <QUndoCommand>

namespace Ui {
class libTOestDoRedoUndo;
}

class myCheckBox;

// QUndoStack is the class, which is called inside MainWindow,
// and does the push of this command, an instance of
// QUndoCommand, onto a stack and more than
// one stack instance can exist.
// I had to study 3m53s and 13m26s snap-shots in the .mp4 video.
// It is ridiculous to do this in video and I could not find
// a cut and paste print example and Qt doc was not enough.
// I could not understand if the QUndoCommand/QUndoStack set of functions
// required a QWidget of my own making via inheritance, eg. qcheckbox,
// or were those arguments arbitrary and overloads and could be
// anything, and it is sufficient I accomplish creation of
// qunstack->redo override and qunstack->undo override functions.
// I am going with the latter being true,
// with no instruction saying I am right. DavidP.

// There is also an interesting example with no arguments
// and no rewriting-inheritance-undo/redo,
// for simpler than my undo/redo goal:
// https://doc.qt.io/qt-6/qundocommand.html#details
// I read it initially and I got completely misled about QUndoCommand
// capabilities because it is so very different and unrelated,
// almost like a completely different class.

class libTOestDoRedoUndo : public QUndoCommand
{
 public:
    libTOestDoRedoUndo( myCheckBox *mm, bool oo, bool nn, QUndoCommand *parent = nullptr);
    void undo() override;
    void redo() override;

    void doLibToEst( MainWindow *, long, long);
    //void doEstToLib( MainWindow *);

private:
    Ui::libTOestDoRedoUndo *ui;

};

#endif // LIBTOESTDOREDOUNDO_H
