
/*  This file is part of PaceMaker Estimator 2.0.
    PaceMaker Estimator 2.0 is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
    PaceMaker Estimator 2.0 is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along with PaceMaker Estimator 2.0. If not, see <https://www.gnu.org/licenses/>.
*/

//#include "qtimer.h"
#include <QDialog>
#include "menuEdit.h"
#include "libundocommand.h"
#include "estundocommand.h"

/* All the menuEdit functions are below.
void dialogChooseSelectCount();
void EditCopy( );
void EditCut( );
void EditInsert( );
void EditPaste( );
void EditUndo( );
void EditRedo( );
*/

void MainWindow::dialogChooseSelectCount()
{
    bool ret;
    int fontPtSz;
    long chose;
    QDialog *QDia;
    QMessageBox msgBox;

    ;//qDebugA() << "Opening point size" << globalFont2.pointSize();

    QInputDialog qiDia;
    qiDia.setFont(globalFont2);
    //qiDia.setGeometry( ui->scrollArea_2->geometry() );
    // this does not move it to the right spot
    //qiDia.adjustSize();
    // this does not move it to the right spot. I tried.

    if( keyboardnow.row<=0 )
        keyboardnow.row=1;
    chose = qiDia.getInt( ui->label_3, QString("%1: %2 to %3").arg(tr("Pick")).arg(1).arg((int)(ESTROWCOUNT-1-keyboardnow.row)),
                         tr(". This many rows:  ."), prefSelectCount, 1, ESTROWCOUNT-1, 1, &ret);

    if (ret && chose>0 )
    {
        ui->actionCount->setText( QString("Count %1").arg(chose) );
        prefSelectCount = chose;
        writeSettings(QDir::homePath());
    }

    return;
}

void MainWindow::EditCopy( )
{
    long rr;
    int cc;

    if( keyboardnow.row )
    {
        if( keyboardnow.libest==1 ) //est is different than lib
        {   /*libest==1 means library side
             *not doing this because lib side is not tabs:
             *copyE->unloadQLineEditsToTab();
             */
            if( copyL != nullptr )
                delete copyL;
            copyL = new libMenuEdit(keyboardnow.rowL, prefSelectCount);

            for( long copyrr=1,rr=copyL->row; rr<=copyL->max; ++rr, ++copyrr)
            {
                for( cc=1; cc<MAXCOL_libest; ++cc)
                {

                    /* I think the triangle compiler warning is
                     * saying the col[] *QLineEdits are uninitialized.
                     * However, I do initialize some, not all.
                     * Compiler does not know I did just enough.
                     *
                     * Similarly if(copyL->libRow[55]) is undefined.
                     */
                    if( libRow[rr]->col[cc] != nullptr )
                    {
                        copyL->libRow[copyrr]->col[cc]->setText( libRow[rr]->col[cc]->text() );
                    }
                }
                //qDebug()<< "\n" << copyL->libRow[copyrr]->col[2]->text();
            }
        }
        else
        {
            if( copyE != nullptr )
                delete copyE;
            copyE = new estMenuEdit(keyboardnow.rowE, prefSelectCount);

            /* I tried to put all below in this constructor.
             * You cannot do that because the estRow[] data
             * is in MainWindow.h. So I only initialized
             * as much as possible in the constructor of estMenuEdit()
             */

            for( long copyrr=1,rr=copyE->row; rr<=copyE->max; ++rr, ++copyrr)
            {
                for( cc=1; cc<MAXCOL_libest; ++cc)
                {
                    /* I think the triangle compiler warning is
                     * saying the col[] *QLineEdits are uninitialized.
                     * However, I do initialize some, not all.
                     * Compiler does not know I did just enough.
                     * If rr > copyL->max - copyL->row then ->col[]
                     * is undefined. I agree. But, I never go that high.
                     * Similarly if( copyE->estRow[55] ) is undefined.
                     */
                    if( estRow[rr]->col[cc] != nullptr )
                    {
                        /*if( copyE->estRow[55] )*/
                        copyE->estRow[copyrr]->col[cc]->setText( estRow[rr]->col[cc]->text() );
                    }
                }
                if( estRow[rr]->fileQtyBlock != nullptr )
                {
                    copyE->estRow[copyrr]->fileQtyBlock = new qtymathHidden;

                    for(int xx=0;xx<17;++xx)
                    {
                        copyE->estRow[copyrr]->fileQtyBlock->block[xx] = estRow[rr]->fileQtyBlock->block[xx];  // 680 chars 17x40
                        //qDebug() <<copyE->estRow[copyrr]->fileQtyBlock->block[xx];
                    }
                    //unused I think: copyE->estRow[copyrr]->fileQtyBlock->refcode = estRow[rr]->fileQtyBlock->refcode;
                }
                copyE->estRow[copyrr]->refcode = estRow[rr]->refcode;
            }
        }
    }

    return;
}


/* Sending the key press event is a short cut. The coding is the same. */
void MainWindow::EditCut( )
{
    QLineEdit *qle;

    if( keyboardnow.row )
    {
        // if user did not do a copy first then set to insert 0 rows.
        if( copyE == nullptr )
            copyE = new estMenuEdit(keyboardnow.row, 0);
        if( copyL == nullptr )
            copyL = new libMenuEdit(keyboardnow.row, 0);

        /* Do a call to EditCopy() instead of writing all that code again
         * and then do a simple Qt::Key_Delete which already
         * pushes onto the stack so EditUndo() works.
         */
        EditCopy();

        if( keyboardnow.libest==1 )
        {
            qle = libRow[keyboardnow.row]->col[2];
            copyL->undoDepth = prefSelectCount; // for Undo and Redo
        }
        else
        {
            qle = estRow[keyboardnow.row]->col[2];
            copyE->undoDepth = prefSelectCount; // for Undo and Redo
        }

        for( int xx=prefSelectCount; --xx>=0;)
        {   
            //ui->estRow[keyboardnow.row]->col[2]->setFocus();
            QKeyEvent *key_press = new QKeyEvent(QKeyEvent::KeyPress, Qt::Key_Delete, Qt::NoModifier, "");
            QApplication::sendEvent( qle, key_press);
        }
    }
    return;
}

/* Sending the button press event is a short cut. The coding is the same. */
void MainWindow::EditInsert( )
{
    long targ=1L;
    int cc;
    long rr;

    if( keyboardnow.row ) //if any active cell is clicked on lib or est sides
    {
        // if user did not do a copy first then set to insert 0 rows.
        if( copyE == nullptr )
            copyE = new estMenuEdit(keyboardnow.row, 0);
        if( copyL == nullptr )
            copyL = new libMenuEdit(keyboardnow.row, 0);

        if( keyboardnow.libest==1 )
        {
            libUndoCommand *command;
            libLineEditHistory *eH;

            copyL->undoDepth=0L;
            targ=keyboardnow.row; //in this case rowL is the same as .row
            for( rr=copyL->count;rr>=1; --rr )
            {
                if( isFullRow( libRow[LIBROWCOUNT-1]) )
                    break;

                eH = new libLineEditHistory(
                    this, LIBROWCOUNT-1, targ, TYPEIns);
                command = new libUndoCommand( eH );
                lib_undo_stack.push(command);
                ++copyL->undoDepth;

                // write on the blank line
                for( cc=1; cc<MAXCOL_libest; ++cc)
                {
                    if( libRow[targ]->col[cc] )
                        libRow[targ]->col[cc]->setText( copyL->libRow[rr]->col[cc]->text() );
                }

                eH = new libLineEditHistory( this, targ, rr, TYPEmenuEdit );
                // transfer a pointer to the object:
                command = new libUndoCommand( eH );
                lib_undo_stack.push(command);
                ++copyL->undoDepth;
            }
        }
        else if( keyboardnow.libest==2 )
        {
            estUndoCommand *command;
            estLineEditHistory *eH;

            copyE->undoDepth=0L;
            targ=keyboardnow.row; //in this case rowE is the same as .row
            for( rr=copyE->count;rr>=1; --rr )
            {
                if( isFullRow( estRow[ESTROWCOUNT-1] ) )
                    break;

                eH = new estLineEditHistory(
                    this, ESTROWCOUNT-1, targ, TYPEIns);
                command = new estUndoCommand( eH );
                est_undo_stack.push(command);
                ++copyE->undoDepth;

                for( cc=1; cc<MAXCOL_libest; ++cc)
                {
                    if( estRow[targ]->col[cc] )
                        estRow[targ]->col[cc]->setText( copyE->estRow[rr]->col[cc]->text() );
                }
                if( copyE->estRow[rr]->fileQtyBlock != nullptr )
                {
                    if( estRow[targ]->fileQtyBlock == nullptr )
                        estRow[targ]->fileQtyBlock = new qtymathHidden;

                    for(int xx=0;xx<17;++xx)
                    {
                        estRow[targ]->fileQtyBlock->block[xx] = copyE->estRow[rr]->fileQtyBlock->block[xx];  // 680 chars 17x40
                    }
                    //unused I think: estRow[targ]->fileQtyBlock->refcode = copyE->estRow[rr]->fileQtyBlock->refcode;
                }
                estRow[targ]->refcode = copyE->estRow[rr]->refcode;

                eH = new estLineEditHistory( this, targ, rr, TYPEmenuEdit );
                // transfer a pointer to the object:
                command = new estUndoCommand( eH );
                est_undo_stack.push(command);
                ++copyE->undoDepth;

                calc_one_estline( targ );
            }
        }
    }

    return;
}

/* Paste is similar to EditInsert()
 * The only coding difference is the
 * step where a blank line is inserted
 * by using a stack push of a blank line.
 * So why not call the EditInsert()
 * function with an argument to
 * if( paste) skip the stack push?
 * Yes, let us try that instead
 * of copy pasting C++ code to
 * here and maintaining two versions.
 *
 * Edit: It mostly worked but targ was different too
 * and Undo failed sometimes and isFull() does not
 * apply the same way. And it needed an extra
 * normal stack push!
 *
 * So I am rewriting the code here after all so as to not damage
 * EditInsert() while debugging EditUndo.
 */
void MainWindow::EditPaste( )
{
    long targ=1L;
    int cc;
    long rr;

    if( keyboardnow.row ) //if any active cell is clicked on lib or est sides
    {
        // if user did not do a copy first then set to insert 0 rows.
        if( copyE == nullptr )
            copyE = new estMenuEdit(keyboardnow.row, 0);
        if( copyL == nullptr )
            copyL = new libMenuEdit(keyboardnow.row, 0);

        if( keyboardnow.libest==1 )
        {
            libUndoCommand *command;
            libLineEditHistory *eH;

            copyL->undoDepth=0L;

            for( rr=copyL->count;rr>=1; --rr )
            {
                targ = keyboardnow.row + rr - 1;
                if( targ > LIBROWCOUNT-1 )
                    targ = LIBROWCOUNT-1;

                // Save the current targ row onto Undo stack before beginning.
                eH = new libLineEditHistory( this, targ, rr, TYPEmenuEdit );
                // transfer a pointer to the object:
                command = new libUndoCommand( eH );
                lib_undo_stack.push(command);
                ++copyL->undoDepth;

                for( cc=1; cc<MAXCOL_libest; ++cc)
                {
                    if( libRow[targ]->col[cc] )
                        libRow[targ]->col[cc]->setText( copyL->libRow[rr]->col[cc]->text() );
                }

                //qDebug()<< copyL->libRow[rr]->col[2]->text();
                eH = new libLineEditHistory( this, targ, rr, TYPEmenuEdit );
                // transfer a pointer to the object:
                command = new libUndoCommand( eH );
                lib_undo_stack.push(command);
                ++copyL->undoDepth;
            }
        }
        else if( keyboardnow.libest==2 )
        {
            estUndoCommand *command;
            estLineEditHistory *eH;

            copyE->undoDepth=0L;
            for( rr=copyE->count;rr>=1; --rr )
            {
                targ = keyboardnow.row + rr - 1;
                if( targ > ESTROWCOUNT-1 )
                    targ = ESTROWCOUNT-1;

                eH = new estLineEditHistory( this, targ, rr, TYPEmenuEdit );
                // transfer a pointer to the object:
                command = new estUndoCommand( eH );
                est_undo_stack.push(command);
                ++copyE->undoDepth;

                for( cc=1; cc<MAXCOL_libest; ++cc)
                {
                    if( estRow[targ]->col[cc] )
                        estRow[targ]->col[cc]->setText( copyE->estRow[rr]->col[cc]->text() );
                }
                if( copyE->estRow[rr]->fileQtyBlock != nullptr )
                {
                    if( estRow[targ]->fileQtyBlock == nullptr )
                        estRow[targ]->fileQtyBlock = new qtymathHidden;

                    for(int xx=0;xx<17;++xx)
                    {
                        estRow[targ]->fileQtyBlock->block[xx] = copyE->estRow[rr]->fileQtyBlock->block[xx];  // 680 chars 17x40
                        //qDebug() << estRow[targ]->fileQtyBlock->block[xx];
                    }
                    //unused I think: estRow[targ]->fileQtyBlock->refcode = copyE->estRow[rr]->fileQtyBlock->refcode;
                }
                estRow[targ]->refcode = copyE->estRow[rr]->refcode;

                eH = new estLineEditHistory( this, targ, rr, TYPEmenuEdit );
                // transfer a pointer to the object:
                command = new estUndoCommand( eH );
                est_undo_stack.push(command);
                ++copyE->undoDepth;

                //qDebug()<< copyE->estRow[rr]->col[2]->text();
                calc_one_estline( targ );
            }
        }
    }

    return;
}

/* Sending the button press event is a short cut. The coding is the same. */
void MainWindow::EditUndo( )
{
    long xx;

    // if user did not do a copy first then set to 0 rows.
    if( copyE == nullptr )
        copyE = new estMenuEdit(keyboardnow.row, 0);
    if( copyL == nullptr )
        copyL = new libMenuEdit(keyboardnow.row, 0);

    if( keyboardnow.libest==2 )
    {
        if( copyE->undoDepth )
        {
            xx = copyE->redoDepth = copyE->undoDepth;
            copyE->undoDepth = 0L;
            while( --xx>=0 )
                on_bundoEst_pressed();

            long scrll = keyboardnow.rowE;
            if(scrll>1)
                --scrll;
            if(scrll>1)
                --scrll;
            scroll_est_into_view( estRow[scrll]->col[2] );
        }
    }
    else
    {
        if( copyL->undoDepth )
        {
            xx = copyL->redoDepth = copyL->undoDepth;
            copyL->undoDepth = 0L;
            while( --xx>=0 )
                on_bundoLib_pressed();

            long scrll = keyboardnow.rowL;
            if(scrll>1)
                --scrll;
            if(scrll>1)
                --scrll;
            scroll_lib_into_view( libRow[scrll]->col[2] );
        }
    }

    return;
}

/* Sending the button press event is a short cut. The coding is the same. */
void MainWindow::EditRedo( )
{
    long xx;

        // if user did not do a copy first then set to 0 rows.
        if( copyE == nullptr )
            copyE = new estMenuEdit(keyboardnow.row, 0);
        if( copyL == nullptr )
            copyL = new libMenuEdit(keyboardnow.row, 0);

        if( keyboardnow.libest==2 )
        {
            if( copyE->redoDepth )
            {
                xx = copyE->undoDepth = copyE->redoDepth;
                copyE->redoDepth = 0L;
                while( --xx>=0 )
                    on_bredoEst_pressed();
            }
        }
        else
        {
            if( copyL->redoDepth )
            {
                xx = copyL->undoDepth = copyL->redoDepth;
                copyL->redoDepth = 0L;
                while( --xx>=0 )
                    on_bredoLib_pressed();

            }
        }

    return;
}

/* This is just setting menu words */
void MainWindow::setEditSelected_Row()
{
    QString selected;

    if( keyboardnow.row==0L )
        selected = "Click a Row";
    else
        selected = QString("Clicked Row %1").arg(keyboardnow.row);
    ui->actionSelected_Row->setText( selected );

    return;
}

