#ifndef MENUEDIT_H
#define MENUEDIT_H

#include "qlineedit.h"
#include "qtymathhidden.h"

#ifndef FROMMAINWINDOWH
#define LIBROWCOUNT 232 /*(231+1)*/
/* Why 231? 33 is typical horizontal lines on a computer screen and 80 is typical
 * of a sheet of paper, so 3x11x7=231 and that is 3x11=33 (7 full pages)
 * and 11x7=77 (almost 80) (3 full pages).
 */
//up to; not including; eg.row[ESTROWCOUNT]
#define ESTROWCOUNT 232 /*(231+1)*/

// +1 because I am starting the rows and cols at 1, not 0 so as to
// match the names in the statusTips and increase my likelihood of
// spotting coding errors and so a 7 col array needs 0 through 7,
// which is 8 items, not 7,
#define MAXCOL_libest 8 /*(7+1)*/

#else
#define LIBROWCOUNT (231+1)
#define ESTROWCOUNT (231+1)
#define MAXCOL_libest (7+1)
#endif

namespace Ui {
class libMenuEdit;
}

class libMenuEdit
{
public:
    libMenuEdit( long keyboardnowrow, long prefcount )
    {
        long xx;
        int  yy;       

        /* initialize only enough QLineEdits for the job size
         *      of copy and paste and insert start finish. Save memory/time.
         */
        max = keyboardnowrow+prefcount-1;
        if( max>LIBROWCOUNT-1 )
            max = LIBROWCOUNT-1;
        row = keyboardnowrow;
        count = prefcount;

        for( xx=1; xx<=prefcount; ++xx)
        {
            libRow[xx] = new libMenuStruct();

            for( yy=0; ++yy<MAXCOL_libest; )
            {
                libRow[xx]->col[yy] = new QLineEdit();
            }
        }

        return;
    }

    struct libMenuStruct {
        //qtymathHidden *fileQtyBlock;
        QLineEdit *col[MAXCOL_libest];
        //QPushButton *pushbutton;
        QString refcode;
    } *libRow[LIBROWCOUNT];

    // some data for copy and paste and insert start finish
    long row;
    long max;
    long count;
    long undoDepth=0;  // this counts the menuInsert() stack pushes for later pops
    long redoDepth=0;
private:

};

class estMenuEdit
{
public:
    estMenuEdit( long keyboardnowrow, long prefcount )
    {
        long xx;
        int yy;

        /* initialize only enough QLineEdits for the job size
         *      of copy and paste and insert start finish. Save memory/time.
         */
        max = keyboardnowrow+prefcount-1;
        if( max>ESTROWCOUNT-1 )
            max = ESTROWCOUNT-1;
        row = keyboardnowrow;
        count = prefcount;

        for( xx=1; xx<=prefcount; ++xx)
        {
            estRow[xx] = new estMenuStruct();

            estRow[xx]->fileQtyBlock = nullptr;
            for( yy=0; ++yy<MAXCOL_libest; )
            {
                estRow[xx]->col[yy] = nullptr;
                estRow[xx]->col[yy] = new QLineEdit();
            }
            estRow[xx]->refcode = nullptr;
        }

        return;
    }

    struct estMenuStruct {
        qtymathHidden *fileQtyBlock;
        QString refcode;//two chars says *WD or *B, listname
        QLineEdit *col[MAXCOL_libest];
        //QPushButton *pushbutton;
    } *estRow[ESTROWCOUNT];

    // source row start to max for copy and paste and insert start finish
    long row;
    long max;
    long count;
    long undoDepth=0;
    long redoDepth=0;
private:

};


#endif // MENUEDIT_H
