
/*  This file is part of PaceMaker Estimator 2.0.
    PaceMaker Estimator 2.0 is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
    PaceMaker Estimator 2.0 is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along with PaceMaker Estimator 2.0. If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef QTYMATH_H
#define QTYMATH_H

#include "qlineedit.h"
#include "qpushbutton.h"
#include "qscrollarea.h"
#include "qtymathhidden.h"
#include <QWidget>

namespace Ui {
class qtymath;
}

class qtymath : public QWidget
{
    Q_OBJECT

public:
    explicit qtymath(QWidget *parent = nullptr);
    ~qtymath();

    double sumOf17Lines = 0.0;
    QString filenameRefcodeLibcode="_"; // set the default or else Archive of Calcs lists all lists if no refcode has been established in the estimate line

    bool loadUiFromFileQtyBlock( qtymathHidden *fileQtyBlock );
    bool arith( char *arithstr, double *output, bool errormsgOn );
    char *noErrorHelper( char *str );

  /* I could move this from menuNewOpen.cpp to make it a
   * qtymath().procedure rather than sending qtytemp as an arg..
   * It got used in validate.cpp usefully. Feb 10, 2024.
   * tediously_meticulously1987compatibility(char *str, qtymath *qtytemp);
   */

private slots:

    void on_qtyCalcOK_pressed();
    void on_qtyCalcOK_released();
    void on_cancelButton_clicked();
    void on_deleteButton_clicked();

    void on_comboBox_currentIndexChanged(int index);

    /* The estimate and library QLineEdits were
     * done with connect() calls in load2().
     * Here I do 17 slots instead, for these qtymath QLineEdits.
     */
    void on_qtyDetail_returnPressed();
    void on_qtyDetail2_returnPressed();
    void on_qtyDetail3_returnPressed();
    void on_qtyDetail4_returnPressed();
    void on_qtyDetail5_returnPressed();
    void on_qtyDetail6_returnPressed();
    void on_qtyDetail7_returnPressed();
    void on_qtyDetail8_returnPressed();
    void on_qtyDetail9_returnPressed();
    void on_qtyDetail10_returnPressed();
    void on_qtyDetail11_returnPressed();
    void on_qtyDetail12_returnPressed();
    void on_qtyDetail13_returnPressed();
    void on_qtyDetail14_returnPressed();
    void on_qtyDetail15_returnPressed();
    void on_qtyDetail16_returnPressed();
    void on_qtyDetail17_returnPressed();

    void on_qtyDetail_editingFinished();
    void on_qtyDetail2_editingFinished();
    void on_qtyDetail3_editingFinished();
    void on_qtyDetail4_editingFinished();
    void on_qtyDetail5_editingFinished();
    void on_qtyDetail6_editingFinished();
    void on_qtyDetail7_editingFinished();
    void on_qtyDetail8_editingFinished();
    void on_qtyDetail9_editingFinished();
    void on_qtyDetail10_editingFinished();
    void on_qtyDetail11_editingFinished();
    void on_qtyDetail12_editingFinished();
    void on_qtyDetail13_editingFinished();
    void on_qtyDetail14_editingFinished();
    void on_qtyDetail15_editingFinished();
    void on_qtyDetail16_editingFinished();
    void on_qtyDetail17_editingFinished();


private:
    Ui::qtymath *ui;

    QScrollArea *scra;
    QPushButton *pb;
    QRect geoscra;
    QRect geopb;
    int sz;


    void on_qtyDetail_byRow( QLineEdit *inMathEquation, QLineEdit *outEquationResult, bool errorMsgOn );
    bool do_op(double xx, double xx2, char op, double *output, short errormsgOn );
    double lookahead(char *str);
    bool noErrors(char *str, short errormsg);

    bool saveUiToFileQtyBlock( long row, QWidget *parent );
    QString formatQtymathOutput( double output );
    double qtymath_sumOf17Lines();
    bool loadComboboxLibMenu( QString estlib, QString search );

};

#endif // QTYMATH_H
