
/*  This file is part of PaceMaker Estimator 2.0.
    PaceMaker Estimator 2.0 is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
    PaceMaker Estimator 2.0 is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along with PaceMaker Estimator 2.0. If not, see <https://www.gnu.org/licenses/>.
*/
#ifndef TABS_PLUSESTREADWRITE_H
#define TABS_PLUSESTREADWRITE_H

#include "mainwindow.h"

#define TABCOUNT 11 /*(10+1)*/

namespace Ui {
    class tabPage;
    //class MainWindow;
}

class tabPage
{
public:
    //MainWindow *parent2 = MainWindow::parent;
    //qobject_cast<MainWindow*>(this->parent());

    //explicit tabPage(QWidget *parent = nullptr);
    tabPage(QWidget *parent)
    {
        int xx, yy;

        parent2 = qobject_cast<MainWindow*>(parent); //just pass a variable called "parent".

        /* These are similar initializations as mainwindow.cpp for estRow[];
     * so when the data is copied back to estRow[] then nothing unexpected happens
     * but I think the only required one is the "new estTab" to allocate memory
     * for each row. The rest are entirely updated by copyQLineEditsToTab();
     * so why initialize them twice; March 1, 2024?  I might come back and delete most.
     */
        for( xx=0L; ++xx<ESTROWCOUNT; )
        {
            estTabRow[xx] = new estTab;
            for( yy=0; ++yy<MAXCOL_libest; )
            {
                estTabRow[xx]->col[yy] = nullptr;
            }
            estTabRow[xx]->fileQtyBlock = nullptr;
            estTabRow[xx]->refcode = nullptr;
        }
        return;
    }

    void unloadQLineEditsToTab();
    void loadTabtoQLineEdits();
    bool nextTab( int tt );

    struct estTab {
        qtymathHidden *fileQtyBlock;
        QString refcode;
        QString col[MAXCOL_libest];
    } *estTabRow[ESTROWCOUNT];

private:
    MainWindow *parent2;

    /* struct is this, from mainwindow.h:
     *   typedef struct estTab
     *   {

            qtymathHidden *fileQtyBlock;
            QString refcode;
            QString col[MAXCOL_libest];

            } *estTabRow[ESTROWCOUNT];

        and the QLineEdits look similar, like this:

    struct QLineEditArray {

            qtymathHidden *fileQtyBlock;
            QString refcode;
            QLineEdit *col[MAXCOL_libest];
            QPushButton *pushbutton;

            } *libRow[ESTROWCOUNT], *estRow[ESTROWCOUNT];

      */
};


#endif // TABS_PLUSESTREADWRITE_H
