
/*  This file is part of PaceMaker Estimator 2.0.
    PaceMaker Estimator 2.0 is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
    PaceMaker Estimator 2.0 is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along with PaceMaker Estimator 2.0. If not, see <https://www.gnu.org/licenses/>.
*/

#include "mainwindow.h"
#include <QProgressDialog>
#include "calculator.inc"

//#define TRUNCATEDforfastcompilingZZZzzz

void MainWindow::load2( QFont font2 )
{  
    int trail;

    hide();

    trail = font2.pointSize();
    qApp->setStyleSheet(QString( "QLabel,QMenuBar,QMenu,QLineEdit,QToolTip { font: %2pt }").arg(trail) );
    //qApp->setStyleSheet(QString( "QLabel,QMenuBar,QMenu,QLineEdit,QToolTip { padding: %1px;font: %2pt }").arg(trail/16).arg(trail) );
    trail = font2.pointSize();  //reload on purpose

    /* These are repeated math below which can be changed centrally here */
    unsigned int m7traild3 = (4*trail)/3;
    unsigned int m7trailp3 = (1+(37*trail/10))/2; //16font is 30 = 1+37*16/10
    unsigned int m6trail = 3 * trail;
    unsigned int m9trail = 9 * trail/2;
    unsigned int m11trail = 11 * trail/2;
    unsigned int m12trail = 6 * trail;
    unsigned int m14trail = 7 * trail;
    unsigned int m25trail = 25 * trail/2;
    unsigned int m26trail = 13 * trail;
    unsigned int m2trail = trail;
    unsigned int m4trail = 2 * trail;

    unsigned int fiveColsSummed = m6trail+m6trail+m6trail+m9trail+m9trail;

    setStyleSheet(QString( "QPushButton {background-color: rgb(90%,81%,73%); border-style: outset; border-width: %1px; border-radius: %2px; border-color: black; font: bold %3pt;} QPushButton:pressed {background-color: rgb(60%, 44%, 33%);border-style: inset;} QPushButton:default {border-color: red;}").arg(1+(trail/14)).arg(1+(trail/5)).arg(trail-1));
    //setStyleSheet(QString( "QPushButton {background-color: rgb(90%,81%,73%); border-style: outset; border-width: %1px; border-radius: %2px; border-color: black; padding: %3px; font: bold %4pt;} QPushButton:pressed {background-color: rgb(60%, 44%, 33%);border-style: inset;} QPushButton:default {border-color: red;}").arg(1+(trail/14)).arg(1+(trail/5)).arg(0).arg(trail-1));
    //setStyleSheet(QString( "QPushButton {background-color: rgb(90%,81%,73%); border-style: outset; border-width: %1px; border-radius: %2px; border-color: black; padding: %3px; font: bold %4pt;} QPushButton:pressed {background-color: rgb(60%, 44%, 33%);border-style: inset;} QPushButton:default {border-color: red;}").arg(1+(trail/14)).arg(1+(trail/5)).arg(trail/8).arg(trail-1));

    QSize qs = QGuiApplication::primaryScreen()->availableGeometry().size();
    // Use the font size to determine the comfortable window geometry.

    // Use the full screen if need be, but try for less
    // so the columns are not over-sized with gaps between them.
    // width of (fivenine+oneonetwo)* trail is perfect max. per scrollAreaWidgetContents_3 and 4
    // So (9 * width)/16 = height for HDTV is good too.

/* Feb 9, 2024 I changed these from 52 and 107 to 63 and 102
 *  because the lib spacing was crowded.
 */

#define fivenine 63
#define oneonetwo 102

    // if font is too big for the monitor screen then choose full screen.
    //old: if( (fivenine+oneonetwo)*trail > qs.width() )

    long widthy = ((long)trail * 246L)/3;
    //long widthy = ((long)trail * 177L)/2L;

    /* font 18 works here:
     * unsigned long heighty = (21L*widthy)/26L;
     * font 12 or something works here:
     * unsigned long heighty = (13L*qs.height())/16L;
     * So the math is wrong.
     * Here is better math: 16xtrail is the vertical sum of the header and footer
     * because I counted the lines. The body is not a fixed number of lines.
     * The fonts are squares. So turn width vertically and subtract header 18
     * to calculate the optimum vertical. Snag: Qt makes it 36 for half size
     * font, not 18 lines. Therefore eighteen equals ... .
     */
    unsigned long eighteen = 18L*16L/trail;

    if(eighteen<2)
       eighteen = 2L;

    // focus on the 17L and the 18L. The fraction is 17/18. Fine adjust those if need be.
    unsigned long heighty = 17L*eighteen/18L*(widthy-(trail*eighteen))/18L;
    ;//qDebugA() << "\n83xtrail=" << widthy <<" "<< heighty << "<-pick.monitor width/height-screenactual->:" << qs.width() << "/" << qs.height();
    if( widthy > qs.width() )
    {
        widthy = qs.width();  // full width of screen, but less height
    }
    else  // or else smaller. Smaller is better.
    {
        /* Bug Feb 29, 2024: When I go from 18 to 8 pt font and call load2()
         * then this resize sets the height correctly but leaves the
         * width incorrectly too large by about double. I check the values.
         * They are correct. I manually resize by grabbing the corner
         * with the mouse and then the layout improves to normal!
         * Furthermore, if I exit and restart estimatemaker2 then
         * the load2() performs perfectly without manual
         * intervention. I put the same note in menuEdit.cpp dialogFontChange()
 * https://stackoverflow.com/questions/48831898/qt-window-incorrect-size-until-user-event
         *
         */

        ;
    }
    if( heighty >qs.height() )
    {
        heighty = qs.height();
    }
    ;//qDebugA( << "\n83xtrail=" << this->width() <<" "<< this->height() ; //<< "<-pick.monitor width/height-screenactual->:" << qs.width() << "/" << qs.height();
    resize( widthy, heighty );  // nicest screen for the given font
    ;//qDebugA( << "\n83xtrail=" << this->width() <<" "<< this->height() ; //<< "<-pick.monitor width/height-screenactual->:" << qs.width() << "/" << qs.height();

    // special fixed-width font for 40 char qtyDetail box:
    //qtyDetailBoxMonospaceFont("nonexistent");
    qtyDetailBoxMonospaceFont = property("monospace").value<QFont>();
    qtyDetailBoxMonospaceFont.setStyleHint(QFont::Monospace);
    qtyDetailBoxMonospaceFont.setPointSize(1+(17*trail/12));

    ui->actionNew->setFont( font2 );
    ui->actionOpen->setFont( font2 );
    ui->actionSave->setFont( font2 );
    ui->actionPrint->setFont( font2 );
    ui->actionQuit->setFont( font2 );

    /* moved to mainwindow.h
     * QString aboutTitle="Estimate Maker (c)1987-24 Greenstone Software Inc."));
     */
    ui->menuAbout->setFont( font2 );
    ui->actionGreenstone_Software_Licence->setFont( font2 );
    ui->actionGreenstone_Software_Licence->setText( aboutTitle );
    ui->menuAbout->setMinimumWidth( 24*trail ); //aboutTitle.length()+12);
    /*does not exist as a function so set the menuAbout:
     *ui->actionGreenstone_Software_License->setMinimumWidth( aboutTitle.length()+4 );
     */

    ui->Settings->setFont( font2 );
    ui->Settings->setMinimumWidth( 11*trail);  // Libraries Recover is longer than the others
    ui->libSort->setFont( font2 );
    ui->libSort->setMinimumWidth( 9*trail);
    ui->actionFont->setFont( font2 );
    ui->actionFont->setText( QString("Font %1").arg(globalFont2.pointSize() ) );

    ui->action_xHours->setFont( font2 );
    ui->action_xCosts->setFont( font2 );
    ui->actionSave_As->setFont( font2 );

    ui->sortOnce->setFont( font2 );
    ui->sortAlways->setFont( font2 );
    ui->actionHeader->setFont( font2 );
    ui->actionLibrariesDelete->setFont( font2 );
    ui->actionLibrariesRecover->setFont( font2 );

    ui->menuEdit->setMinimumWidth( 11*trail);
    ui->actionSelected_Row->setFont( font2 );
    setEditSelected_Row();
    ui->actionCount->setFont( font2 );
    ui->actionCount->setText( QString("Count %1").arg( prefSelectCount ) );

    // these are New,Open, ... Subtotal, menus and they are set in the parent menu.
    ui->menuFile->setMinimumWidth( 9*trail);

    ui->pushHeaderButton->setFont( font2 );
    ui->TotalHours->setFont( font2 ); //QCommandButton
    ui->TotalCost->setFont( font2 );  //QCommandButton

    //https://doc.qt.io/qt-6/stylesheet-examples.html#customizing-qpushbutton
    // I moved this from dialogChooseFont() so QLineEdit is not being set twice; once for px and once for font. I think it is 30seconds slower that way.
    //ss = QString( "QLabel,QMenuBar,QMenu { Font : %1pt }").arg(trail);
    //qApp->setStyleSheet(ss);

    ui->tabWidget->setFont( font2 );
    ui->tab->setFont( font2 );
    ui->tab_2->setFont( font2 );
    ui->tab_3->setFont( font2 );
    ui->tab_4->setFont( font2 );
    ui->tab_5->setFont( font2 );
    ui->tab_6->setFont( font2 );
    ui->tab_7->setFont( font2 );
    ui->tab_8->setFont( font2 );
    ui->tab_9->setFont( font2 );
    ui->tab_10->setFont( font2 );

    //ui->tabWidget->clear();
    ui->tabWidget->setCurrentIndex(0);
    ui->tabWidget->setToolTip("Add estimate pages by selecting Tabs.");
    ui->tabWidget->setTabPosition(QTabWidget::North);
    //ui->tabWidget->setStyleSheet("pane { border-top: 2px solid red;}");
ui->tabWidget->tabBar()->setStyleSheet( "tab:selected { background-color: rgb(90%,81%,73%); border-bottom-color: palette(); }" );
    ui->tabWidget->setFixedHeight( 9*trail/4 );
    ui->tabWidget->setFixedWidth( 44*m14trail/10 );

    // This needs fixed size because the button is set to Fixed in .ui
    int pushHeaderButtonHeight = (2+(36*trail/20));
    ui->pushHeaderButton->setFixedSize( 1+(5*trail), pushHeaderButtonHeight ); //golden ratio

    ui->qtymath->setStyleSheet(" QPushButton {background-color: beige;border-style: outset;border-width: 1px;border-radius: 3px;border-color: black;padding-bottom: 1px; } QPushButton:pressed {background-color: rgb(60%, 44%, 33%);border-style: inset;}");
    //ui->qtymath->setStyleSheet(" QPushButton {background-color: beige;border-style: outset;border-width: 1px;border-radius: 3px;border-color: black;font: bold 16px;padding: 2px; } QPushButton:pressed {background-color: rgb(60%, 44%, 33%);border-style: inset;}");
    ui->qtymath->setFont( font2 );
    ui->qtymath->setMinimumWidth( trail );
    ui->qtymath->setMinimumHeight( trail );

    QPixmap qp,rightPng,leftPng;
    if( (qp.loadFromData( calculatorPng, nullptr, Qt::AutoColor)) )
    //if( (qp.load("/usr/share/doc/qt6/examples/widgets/effects/blurpicker/images/accessories-calculator.png") ))
    {
        QIcon qi(qp);
        ui->qtymath->setIcon( qi );    //QIcon(const QPixmap &pixmap)
        ui->qtymath->setIconSize( QSize(8*trail/4,8*trail/4) ); // was9 not8
    }

    QIcon iconLeft2;
    if( (leftPng.loadFromData( leftArrowPng, nullptr, Qt::AutoColor)) )
    {
        QIcon iconLeft(leftPng);
        //ui->pushButtonLib1->setIcon( iconLeft );
        //ui->pushButtonLib1->setText("");
        //ui->pushButtonLib1->setIconSize( QSize(trail,trail) );
        //ui->pushButtonLib1->setLayoutDirection(Qt::LeftToRight);
        iconLeft2= iconLeft;
    }

    QIcon iconRight2;
    if( (rightPng.loadFromData( rightArrowPng, nullptr, Qt::AutoColor)) )
    {
        QIcon iconRight(rightPng);
        //ui->pushButtonEst1->setIcon( iconRight );
        //ui->pushButtonEst1->setText("");
        //ui->pushButtonEst1->setIconSize( QSize(trail,trail) );
        //ui->pushButtonEst1->setLayoutDirection(Qt::RightToLeft);
        iconRight2= iconRight;
    }

    ui->bundoLib->setFont( font2 );
    ui->bredoLib->setFont( font2 );
    ui->bundoEst->setFont( font2 );
    ui->bredoEst->setFont( font2 );
    ui->bundoLib->setFixedWidth( 4*trail );
    ui->bredoLib->setFixedWidth( 4*trail );
    ui->bundoEst->setFixedWidth( 4*trail );
    ui->bredoEst->setFixedWidth( 4*trail );
    ui->bundoLib->setStyleSheet( QString( "QPushButton {background-color: rgb(90%,81%,73%); border-style: outset; border-width: %1px; border-radius: %2px; border-color: black; font: %3pt;} QPushButton:pressed {background-color: rgb(60%, 44%, 33%);border-style: inset;}").arg(1+(trail/14)).arg(1+(trail/5)).arg(7*trail/8));
    ui->bredoLib->setStyleSheet( QString( "QPushButton {background-color: rgb(90%,81%,73%); border-style: outset; border-width: %1px; border-radius: %2px; border-color: black; font: %3pt;} QPushButton:pressed {background-color: rgb(60%, 44%, 33%);border-style: inset;}").arg(1+(trail/14)).arg(1+(trail/5)).arg(7*trail/8));
    ui->bundoEst->setStyleSheet( QString( "QPushButton {background-color: rgb(90%,81%,73%); border-style: outset; border-width: %1px; border-radius: %2px; border-color: black; font: %3pt;} QPushButton:pressed {background-color: rgb(60%, 44%, 33%);border-style: inset;}").arg(1+(trail/14)).arg(1+(trail/5)).arg(7*trail/8));
    ui->bredoEst->setStyleSheet( QString( "QPushButton {background-color: rgb(90%,81%,73%); border-style: outset; border-width: %1px; border-radius: %2px; border-color: black; font: %3pt;} QPushButton:pressed {background-color: rgb(60%, 44%, 33%);border-style: inset;}").arg(1+(trail/14)).arg(1+(trail/5)).arg(7*trail/8));

    // I do not like Header button to have a red outline. I only changed red to black.
    ui->pushHeaderButton->setStyleSheet( QString( "QPushButton {background-color: rgb(90%,81%,73%); border-style: outset; border-width: %1px; border-radius: %2px; border-color: black; font: %3pt;} QPushButton:pressed {background-color: rgb(60%, 44%, 33%);border-style: inset;}").arg(1+(trail/14)).arg(1+(trail/5)).arg(7*trail/8));

    ui->TotalHours->setDescription( QString(DRAGtotalhours).arg(0.0, 6, 'f', 2)); // 100\n    qty x hours
    ui->TotalCost->setDescription( QString( DRAGtotalcosts).arg(0.0, 6, 'f', 2));
    ui->TotalHours->setStyleSheet( QString( "QPushButton {background-color: rgb(90%,81%,73%); border-style: outset; border-width: %1px; border-radius: %2px; border-color: black; font: %3pt;} QPushButton:pressed {background-color: rgb(60%, 44%, 33%);border-style: inset;}").arg(1+(trail/14)).arg(1+(trail/5)).arg(7*trail/8));
    ui->TotalCost->setStyleSheet(  QString( "QPushButton {background-color: rgb(90%,81%,73%); border-style: outset; border-width: %1px; border-radius: %2px; border-color: black; font: %3pt;} QPushButton:pressed {background-color: rgb(60%, 44%, 33%);border-style: inset;}").arg(1+(trail/14)).arg(1+(trail/5)).arg(7*trail/8));

    ui->statusbar->setFont( font2 );


    /* This is the estimate side header: scrollArea_4
     * This is the estimate side typing area: scrollArea
     * This is the library side header: scrollArea_3
     * and library typing area:  scrollArea_2
     * The +2 -2 jogs the header leftward by a small amount.
     */
    // these are the four columns in the library typing area:
    //ui->scrollArea_3->setMaximumWidth( m6trail+m26trail+m6trail+m6trail );
    //ui->scrollArea_3->setMaximumWidth( (fivenine-2)*trail/2 );
    ui->scrollArea_3->setMaximumWidth( (9*fivenine/16) * trail);

    //ui->scrollArea_3->setMinimumWidth( m6trail+m25trail+m6trail+m6trail /*why this?I do not know:"+m12trail+m6trail/*smaller fonts need less:*/-2 ); // 42 * trail );
    ui->scrollArea_3->setMinimumWidth( 34L*widthy/100L ); //32L
    // this is the estimate side: scrollAreaWidgetContents_4
    ui->scrollArea_4->setMaximumWidth( 69L*widthy/100L ); //68L
    ui->scrollArea_4->setMinimumWidth( 65L*widthy/100L ); //63L
    //ui->scrollArea_4->setMinimumWidth( m6trail+m25trail+fiveColsSummed +trail/2/*for arrow*/ ); //65 * trail );

    ui->scrollArea_2->setMaximumWidth( (9*fivenine/16) * trail );

    // these are the four columns in the library typing area:
    ui->scrollArea_2->setMinimumWidth( m4trail+m25trail+m6trail+m6trail /*smaller fonts need less:*/ -2); //35 * trail );

    //ui->scrollArea->setMaximumWidth( oneonetwo * trail/2 );
    ui->scrollArea->setMaximumWidth( 7*(widthy/10) );
    ui->scrollArea->setMinimumWidth( m6trail+m25trail+fiveColsSummed ); //65 * trail );

    // lib code size for the lib cursor row display in the title
    ui->rowLibkbd->setMaximumWidth( m6trail);
    ui->rowLibkbd->setMinimumWidth( m6trail);
    //                  Library
    ui->label->setMaximumWidth(5  * trail );
    ui->label->setMinimumWidth( 4 * trail );

    // library selector
    ui->comboBox->setFont( font2 );
    if( ui->comboBox->lineEdit() != nullptr )
    {
        ui->comboBox->lineEdit()->setFont( font2 );
        ui->comboBox->lineEdit()->setMaxLength( 16 );
        ui->comboBox->lineEdit()->setFixedHeight( m7trailp3 );
    }
    // comboBox
    ui->comboBox->setMaximumWidth( 12 * trail );
    ui->comboBox->setMinimumWidth( 9 * trail );
    ui->comboBox->setFixedHeight( m7trailp3 );

    // Hours display in the title
    ui->label_3->setMaximumWidth( m12trail );
    ui->label_3->setMinimumWidth( m6trail );
    // Cost size for the lib cursor row display in the title
    ui->label_4->setMaximumWidth( m12trail );
    ui->label_4->setMinimumWidth( m6trail );
// estimate side:
    ui->verticalSlider->setMaximumWidth( 3 * trail/2 );
    ui->verticalSlider->setMinimumWidth( trail );
    ui->clearSlider->setMaximumWidth( trail );
    ui->clearSlider->setMinimumSize( trail, trail );

    // lib code size for the lib cursor row display in the title
    // Description Estimate side
    ui->label_6->setMaximumWidth( m26trail);
    ui->label_6->setMinimumWidth( 12 * trail );
    ui->label_6->setMaximumHeight( 3*pushHeaderButtonHeight/4 );

    // line# est side
    ui->rowEstkbd->setMaximumWidth( m6trail);
    ui->rowEstkbd->setMinimumWidth( m6trail );
    // refcode [WD]
    ui->libcodeEstside->setStyleSheet(" QPushButton {background-color: cyan;border-style: outset;border-width: 1px;border-radius: 3px;border-color: black;padding-bottom: 1px; } QPushButton:pressed {background-color: rgb(60%, 44%, 33%);border-style: inset;}");
    ui->libcodeEstside->setMaximumWidth( 2 * trail );
    ui->libcodeEstside->setMinimumWidth( 2 * trail );
    ui->libcodeEstside->setFixedHeight( m7trailp3 );
    ui->libcodeEstside->setText("    ");
    ui->libcodeEstside->setToolTip( "This is the 2char library code for the cursor's estimate line.\nIt is also a button. You may pressed it to show its cost library." );
    /* I thought of a trick to make the ScrollArea_4 scroll down to the lowest
     * widget if ScrollArea_4() is accidentally in scroll mode vertically because
     * of a too large font choice. libcodeEstside is the lowest widget. It works!
     * This might work too: scrollContentsBy(int dx, int dy).
     */
    ui->scrollArea_4->ensureWidgetVisible( ui->libcodeEstside, trail, trail);

    ui->libcode2char->setStyleSheet(" QPushButton {background-color: cyan;border-style: outset;border-width: 1px;border-radius: 3px;border-color: black;padding-bottom: 1px; } QPushButton:pressed {background-color: cyan;border-style: inset;}");
                    //setStyleSheet(" QPushButton {background-color: cyan;border-style: outset;border-width: 1px;border-radius: 3px;border-color: black;padding: 2px; } QPushButton:pressed {background-color: rgb(60%, 44%, 33%);border-style: inset;}");
    ui->libcode2char->setMaximumWidth( 2 * trail );
    ui->libcode2char->setMinimumWidth( 2 * trail );
    ui->libcode2char->setFixedHeight( m7trailp3 );
    ui->libcode2char->setText("    ");
    ui->libcode2char->setToolTip( "2 char library code for this library list." );

    // qty size for the lib cursor row display in the title
    ui->label_11->setMaximumWidth(m12trail );
    ui->label_11->setMinimumWidth( 7 * trail/2 );
    // hours size for the lib cursor row display in the title
    ui->label_10->setMaximumWidth( 7 * trail );
    ui->label_10->setMinimumWidth( m6trail);
    // cost size for the lib cursor row display in the title
    ui->label_5->setMaximumWidth( 7 * trail );
    ui->label_5->setMinimumWidth( m6trail);
    // total cost for the lib cursor row display in the title


     //ui->TotalHours->setMaximumWidth( m14trail ); // same as col 6
     //ui->TotalCost->setMaximumWidth( m14trail );  // same as col 7
     //ui->TotalHours->setMinimumWidth( m9trail);
     //ui->TotalCost->setMinimumWidth( m9trail);
     //ui->TotalCostSpacer->setFixedWidth(trail/2); label_9 got pushed on me by QtCreator rebuild
     ui->label_9->setFixedWidth(trail/2);

    //same as col 6
    ui->TotalHours->setFixedSize(m14trail,1+(pushHeaderButtonHeight*3));
    //same as col 7
    ui->TotalCost->setFixedSize( m14trail,1+(pushHeaderButtonHeight*3));
    // worse:Slightly more height than TotalCost button is the scrollArea_4 header:
 //worse:ui->scrollArea_4->setFixedHeight(m2trail+((1+pushHeaderButtonHeight)*2) );

    ui->spaceLabel0->setMaximumWidth( 1700 * trail );
    ui->spaceLabel0->setMinimumWidth( 6*trail );
    ui->spaceLabel0->setText(""); // unused feature. It's a spacer now.
    ui->spaceLabel1->setFont( font2 );
    ui->spaceLabel1->setFixedWidth( 18*trail );
    ui->spaceLabel2->setFont( font2 );
    ui->spaceLabel2->setFixedWidth( 9*trail );


	 libRow[1]->col[1] = ui->lib11;
	 libRow[1]->col[2] = ui->lib12;
	 libRow[1]->col[3] = ui->lib13;
	 libRow[1]->col[4] = ui->lib14;

	 libRow[1]->pushbutton = ui->pushButtonLib1;
	 estRow[1]->pushbutton = ui->pushButtonEst1;
     estRow[1]->col[1] = ui->est11;
	 estRow[1]->col[2] = ui->est12;
	 estRow[1]->col[3] = ui->est13;
	 estRow[1]->col[4] = ui->est14;
	 estRow[1]->col[5] = ui->est15;
	 estRow[1]->col[6] = ui->est16;
	 estRow[1]->col[7] = ui->est17;


	 libRow[2]->col[1] = ui->lib21;
	 libRow[2]->col[2] = ui->lib22;
	 libRow[2]->col[3] = ui->lib23;
	 libRow[2]->col[4] = ui->lib24;

	 libRow[2]->pushbutton = ui->pushButtonLib2;
	 estRow[2]->pushbutton = ui->pushButtonEst2;
	 estRow[2]->col[1] = ui->est21;
	 estRow[2]->col[2] = ui->est22;
	 estRow[2]->col[3] = ui->est23;
	 estRow[2]->col[4] = ui->est24;
	 estRow[2]->col[5] = ui->est25;
	 estRow[2]->col[6] = ui->est26;
	 estRow[2]->col[7] = ui->est27;


	 libRow[3]->col[1] = ui->lib31;
	 libRow[3]->col[2] = ui->lib32;
	 libRow[3]->col[3] = ui->lib33;
	 libRow[3]->col[4] = ui->lib34;

	 libRow[3]->pushbutton = ui->pushButtonLib3;
	 estRow[3]->pushbutton = ui->pushButtonEst3;
	 estRow[3]->col[1] = ui->est31;
	 estRow[3]->col[2] = ui->est32;
	 estRow[3]->col[3] = ui->est33;
	 estRow[3]->col[4] = ui->est34;
	 estRow[3]->col[5] = ui->est35;
	 estRow[3]->col[6] = ui->est36;
	 estRow[3]->col[7] = ui->est37;


	 libRow[4]->col[1] = ui->lib41;
	 libRow[4]->col[2] = ui->lib42;
	 libRow[4]->col[3] = ui->lib43;
	 libRow[4]->col[4] = ui->lib44;

	 libRow[4]->pushbutton = ui->pushButtonLib4;
	 estRow[4]->pushbutton = ui->pushButtonEst4;
	 estRow[4]->col[1] = ui->est41;
	 estRow[4]->col[2] = ui->est42;
	 estRow[4]->col[3] = ui->est43;
	 estRow[4]->col[4] = ui->est44;
	 estRow[4]->col[5] = ui->est45;
	 estRow[4]->col[6] = ui->est46;
	 estRow[4]->col[7] = ui->est47;


	 libRow[5]->col[1] = ui->lib51;
	 libRow[5]->col[2] = ui->lib52;
	 libRow[5]->col[3] = ui->lib53;
	 libRow[5]->col[4] = ui->lib54;

	 libRow[5]->pushbutton = ui->pushButtonLib5;
	 estRow[5]->pushbutton = ui->pushButtonEst5;
	 estRow[5]->col[1] = ui->est51;
	 estRow[5]->col[2] = ui->est52;
	 estRow[5]->col[3] = ui->est53;
	 estRow[5]->col[4] = ui->est54;
	 estRow[5]->col[5] = ui->est55;
	 estRow[5]->col[6] = ui->est56;
	 estRow[5]->col[7] = ui->est57;


	 libRow[6]->col[1] = ui->lib61;
	 libRow[6]->col[2] = ui->lib62;
	 libRow[6]->col[3] = ui->lib63;
	 libRow[6]->col[4] = ui->lib64;

	 libRow[6]->pushbutton = ui->pushButtonLib6;
	 estRow[6]->pushbutton = ui->pushButtonEst6;
	 estRow[6]->col[1] = ui->est61;
	 estRow[6]->col[2] = ui->est62;
	 estRow[6]->col[3] = ui->est63;
	 estRow[6]->col[4] = ui->est64;
	 estRow[6]->col[5] = ui->est65;
	 estRow[6]->col[6] = ui->est66;
	 estRow[6]->col[7] = ui->est67;


	 libRow[7]->col[1] = ui->lib71;
	 libRow[7]->col[2] = ui->lib72;
	 libRow[7]->col[3] = ui->lib73;
	 libRow[7]->col[4] = ui->lib74;

	 libRow[7]->pushbutton = ui->pushButtonLib7;
	 estRow[7]->pushbutton = ui->pushButtonEst7;
	 estRow[7]->col[1] = ui->est71;
	 estRow[7]->col[2] = ui->est72;
	 estRow[7]->col[3] = ui->est73;
	 estRow[7]->col[4] = ui->est74;
	 estRow[7]->col[5] = ui->est75;
	 estRow[7]->col[6] = ui->est76;
	 estRow[7]->col[7] = ui->est77;


	 libRow[8]->col[1] = ui->lib81;
	 libRow[8]->col[2] = ui->lib82;
	 libRow[8]->col[3] = ui->lib83;
	 libRow[8]->col[4] = ui->lib84;

	 libRow[8]->pushbutton = ui->pushButtonLib8;
	 estRow[8]->pushbutton = ui->pushButtonEst8;
	 estRow[8]->col[1] = ui->est81;
	 estRow[8]->col[2] = ui->est82;
	 estRow[8]->col[3] = ui->est83;
	 estRow[8]->col[4] = ui->est84;
	 estRow[8]->col[5] = ui->est85;
	 estRow[8]->col[6] = ui->est86;
	 estRow[8]->col[7] = ui->est87;


	 libRow[9]->col[1] = ui->lib91;
	 libRow[9]->col[2] = ui->lib92;
	 libRow[9]->col[3] = ui->lib93;
	 libRow[9]->col[4] = ui->lib94;

	 libRow[9]->pushbutton = ui->pushButtonLib9;
	 estRow[9]->pushbutton = ui->pushButtonEst9;
	 estRow[9]->col[1] = ui->est91;
	 estRow[9]->col[2] = ui->est92;
	 estRow[9]->col[3] = ui->est93;
	 estRow[9]->col[4] = ui->est94;
	 estRow[9]->col[5] = ui->est95;
	 estRow[9]->col[6] = ui->est96;
	 estRow[9]->col[7] = ui->est97;


	 libRow[10]->col[1] = ui->lib101;
	 libRow[10]->col[2] = ui->lib102;
	 libRow[10]->col[3] = ui->lib103;
	 libRow[10]->col[4] = ui->lib104;

	 libRow[10]->pushbutton = ui->pushButtonLib10;
	 estRow[10]->pushbutton = ui->pushButtonEst10;
	 estRow[10]->col[1] = ui->est101;
	 estRow[10]->col[2] = ui->est102;
	 estRow[10]->col[3] = ui->est103;
	 estRow[10]->col[4] = ui->est104;
	 estRow[10]->col[5] = ui->est105;
	 estRow[10]->col[6] = ui->est106;
	 estRow[10]->col[7] = ui->est107;


	 libRow[11]->col[1] = ui->lib111;
	 libRow[11]->col[2] = ui->lib112;
	 libRow[11]->col[3] = ui->lib113;
	 libRow[11]->col[4] = ui->lib114;

	 libRow[11]->pushbutton = ui->pushButtonLib11;
	 estRow[11]->pushbutton = ui->pushButtonEst11;
	 estRow[11]->col[1] = ui->est111;
	 estRow[11]->col[2] = ui->est112;
	 estRow[11]->col[3] = ui->est113;
	 estRow[11]->col[4] = ui->est114;
	 estRow[11]->col[5] = ui->est115;
	 estRow[11]->col[6] = ui->est116;
	 estRow[11]->col[7] = ui->est117;


	 libRow[12]->col[1] = ui->lib121;
	 libRow[12]->col[2] = ui->lib122;
	 libRow[12]->col[3] = ui->lib123;
	 libRow[12]->col[4] = ui->lib124;

	 libRow[12]->pushbutton = ui->pushButtonLib12;
	 estRow[12]->pushbutton = ui->pushButtonEst12;
	 estRow[12]->col[1] = ui->est121;
	 estRow[12]->col[2] = ui->est122;
	 estRow[12]->col[3] = ui->est123;
	 estRow[12]->col[4] = ui->est124;
	 estRow[12]->col[5] = ui->est125;
	 estRow[12]->col[6] = ui->est126;
	 estRow[12]->col[7] = ui->est127;


	 libRow[13]->col[1] = ui->lib131;
	 libRow[13]->col[2] = ui->lib132;
	 libRow[13]->col[3] = ui->lib133;
	 libRow[13]->col[4] = ui->lib134;

	 libRow[13]->pushbutton = ui->pushButtonLib13;
	 estRow[13]->pushbutton = ui->pushButtonEst13;
	 estRow[13]->col[1] = ui->est131;
	 estRow[13]->col[2] = ui->est132;
	 estRow[13]->col[3] = ui->est133;
	 estRow[13]->col[4] = ui->est134;
	 estRow[13]->col[5] = ui->est135;
	 estRow[13]->col[6] = ui->est136;
	 estRow[13]->col[7] = ui->est137;


	 libRow[14]->col[1] = ui->lib141;
	 libRow[14]->col[2] = ui->lib142;
	 libRow[14]->col[3] = ui->lib143;
	 libRow[14]->col[4] = ui->lib144;

	 libRow[14]->pushbutton = ui->pushButtonLib14;
	 estRow[14]->pushbutton = ui->pushButtonEst14;
	 estRow[14]->col[1] = ui->est141;
	 estRow[14]->col[2] = ui->est142;
	 estRow[14]->col[3] = ui->est143;
	 estRow[14]->col[4] = ui->est144;
	 estRow[14]->col[5] = ui->est145;
	 estRow[14]->col[6] = ui->est146;
	 estRow[14]->col[7] = ui->est147;


	 libRow[15]->col[1] = ui->lib151;
	 libRow[15]->col[2] = ui->lib152;
	 libRow[15]->col[3] = ui->lib153;
	 libRow[15]->col[4] = ui->lib154;

	 libRow[15]->pushbutton = ui->pushButtonLib15;
	 estRow[15]->pushbutton = ui->pushButtonEst15;
	 estRow[15]->col[1] = ui->est151;
	 estRow[15]->col[2] = ui->est152;
	 estRow[15]->col[3] = ui->est153;
	 estRow[15]->col[4] = ui->est154;
	 estRow[15]->col[5] = ui->est155;
	 estRow[15]->col[6] = ui->est156;
	 estRow[15]->col[7] = ui->est157;


	 libRow[16]->col[1] = ui->lib161;
	 libRow[16]->col[2] = ui->lib162;
	 libRow[16]->col[3] = ui->lib163;
	 libRow[16]->col[4] = ui->lib164;

	 libRow[16]->pushbutton = ui->pushButtonLib16;
	 estRow[16]->pushbutton = ui->pushButtonEst16;
	 estRow[16]->col[1] = ui->est161;
	 estRow[16]->col[2] = ui->est162;
	 estRow[16]->col[3] = ui->est163;
	 estRow[16]->col[4] = ui->est164;
	 estRow[16]->col[5] = ui->est165;
	 estRow[16]->col[6] = ui->est166;
	 estRow[16]->col[7] = ui->est167;


	 libRow[17]->col[1] = ui->lib171;
	 libRow[17]->col[2] = ui->lib172;
	 libRow[17]->col[3] = ui->lib173;
	 libRow[17]->col[4] = ui->lib174;

	 libRow[17]->pushbutton = ui->pushButtonLib17;
	 estRow[17]->pushbutton = ui->pushButtonEst17;
	 estRow[17]->col[1] = ui->est171;
	 estRow[17]->col[2] = ui->est172;
	 estRow[17]->col[3] = ui->est173;
	 estRow[17]->col[4] = ui->est174;
	 estRow[17]->col[5] = ui->est175;
	 estRow[17]->col[6] = ui->est176;
	 estRow[17]->col[7] = ui->est177;


	 libRow[18]->col[1] = ui->lib181;
	 libRow[18]->col[2] = ui->lib182;
	 libRow[18]->col[3] = ui->lib183;
	 libRow[18]->col[4] = ui->lib184;

	 libRow[18]->pushbutton = ui->pushButtonLib18;
	 estRow[18]->pushbutton = ui->pushButtonEst18;
	 estRow[18]->col[1] = ui->est181;
	 estRow[18]->col[2] = ui->est182;
	 estRow[18]->col[3] = ui->est183;
	 estRow[18]->col[4] = ui->est184;
	 estRow[18]->col[5] = ui->est185;
	 estRow[18]->col[6] = ui->est186;
	 estRow[18]->col[7] = ui->est187;


	 libRow[19]->col[1] = ui->lib191;
	 libRow[19]->col[2] = ui->lib192;
	 libRow[19]->col[3] = ui->lib193;
	 libRow[19]->col[4] = ui->lib194;

	 libRow[19]->pushbutton = ui->pushButtonLib19;
	 estRow[19]->pushbutton = ui->pushButtonEst19;
	 estRow[19]->col[1] = ui->est191;
	 estRow[19]->col[2] = ui->est192;
	 estRow[19]->col[3] = ui->est193;
	 estRow[19]->col[4] = ui->est194;
	 estRow[19]->col[5] = ui->est195;
	 estRow[19]->col[6] = ui->est196;
	 estRow[19]->col[7] = ui->est197;


	 libRow[20]->col[1] = ui->lib201;
	 libRow[20]->col[2] = ui->lib202;
	 libRow[20]->col[3] = ui->lib203;
	 libRow[20]->col[4] = ui->lib204;

	 libRow[20]->pushbutton = ui->pushButtonLib20;
	 estRow[20]->pushbutton = ui->pushButtonEst20;
	 estRow[20]->col[1] = ui->est201;
	 estRow[20]->col[2] = ui->est202;
	 estRow[20]->col[3] = ui->est203;
	 estRow[20]->col[4] = ui->est204;
	 estRow[20]->col[5] = ui->est205;
	 estRow[20]->col[6] = ui->est206;
	 estRow[20]->col[7] = ui->est207;


	 libRow[21]->col[1] = ui->lib211;
	 libRow[21]->col[2] = ui->lib212;
	 libRow[21]->col[3] = ui->lib213;
	 libRow[21]->col[4] = ui->lib214;

	 libRow[21]->pushbutton = ui->pushButtonLib21;
	 estRow[21]->pushbutton = ui->pushButtonEst21;
	 estRow[21]->col[1] = ui->est211;
	 estRow[21]->col[2] = ui->est212;
	 estRow[21]->col[3] = ui->est213;
	 estRow[21]->col[4] = ui->est214;
	 estRow[21]->col[5] = ui->est215;
	 estRow[21]->col[6] = ui->est216;
	 estRow[21]->col[7] = ui->est217;


	 libRow[22]->col[1] = ui->lib221;
	 libRow[22]->col[2] = ui->lib222;
	 libRow[22]->col[3] = ui->lib223;
	 libRow[22]->col[4] = ui->lib224;

	 libRow[22]->pushbutton = ui->pushButtonLib22;
	 estRow[22]->pushbutton = ui->pushButtonEst22;
	 estRow[22]->col[1] = ui->est221;
	 estRow[22]->col[2] = ui->est222;
	 estRow[22]->col[3] = ui->est223;
	 estRow[22]->col[4] = ui->est224;
	 estRow[22]->col[5] = ui->est225;
	 estRow[22]->col[6] = ui->est226;
	 estRow[22]->col[7] = ui->est227;


	 libRow[23]->col[1] = ui->lib231;
	 libRow[23]->col[2] = ui->lib232;
	 libRow[23]->col[3] = ui->lib233;
	 libRow[23]->col[4] = ui->lib234;

	 libRow[23]->pushbutton = ui->pushButtonLib23;
	 estRow[23]->pushbutton = ui->pushButtonEst23;
	 estRow[23]->col[1] = ui->est231;
	 estRow[23]->col[2] = ui->est232;
	 estRow[23]->col[3] = ui->est233;
	 estRow[23]->col[4] = ui->est234;
	 estRow[23]->col[5] = ui->est235;
	 estRow[23]->col[6] = ui->est236;
	 estRow[23]->col[7] = ui->est237;


	 libRow[24]->col[1] = ui->lib241;
	 libRow[24]->col[2] = ui->lib242;
	 libRow[24]->col[3] = ui->lib243;
	 libRow[24]->col[4] = ui->lib244;

	 libRow[24]->pushbutton = ui->pushButtonLib24;
	 estRow[24]->pushbutton = ui->pushButtonEst24;
	 estRow[24]->col[1] = ui->est241;
	 estRow[24]->col[2] = ui->est242;
	 estRow[24]->col[3] = ui->est243;
	 estRow[24]->col[4] = ui->est244;
	 estRow[24]->col[5] = ui->est245;
	 estRow[24]->col[6] = ui->est246;
	 estRow[24]->col[7] = ui->est247;


	 libRow[25]->col[1] = ui->lib251;
	 libRow[25]->col[2] = ui->lib252;
	 libRow[25]->col[3] = ui->lib253;
	 libRow[25]->col[4] = ui->lib254;

	 libRow[25]->pushbutton = ui->pushButtonLib25;
	 estRow[25]->pushbutton = ui->pushButtonEst25;
	 estRow[25]->col[1] = ui->est251;
	 estRow[25]->col[2] = ui->est252;
	 estRow[25]->col[3] = ui->est253;
	 estRow[25]->col[4] = ui->est254;
	 estRow[25]->col[5] = ui->est255;
	 estRow[25]->col[6] = ui->est256;
	 estRow[25]->col[7] = ui->est257;


	 libRow[26]->col[1] = ui->lib261;
	 libRow[26]->col[2] = ui->lib262;
	 libRow[26]->col[3] = ui->lib263;
	 libRow[26]->col[4] = ui->lib264;

	 libRow[26]->pushbutton = ui->pushButtonLib26;
	 estRow[26]->pushbutton = ui->pushButtonEst26;
	 estRow[26]->col[1] = ui->est261;
	 estRow[26]->col[2] = ui->est262;
	 estRow[26]->col[3] = ui->est263;
	 estRow[26]->col[4] = ui->est264;
	 estRow[26]->col[5] = ui->est265;
	 estRow[26]->col[6] = ui->est266;
	 estRow[26]->col[7] = ui->est267;


	 libRow[27]->col[1] = ui->lib271;
	 libRow[27]->col[2] = ui->lib272;
	 libRow[27]->col[3] = ui->lib273;
	 libRow[27]->col[4] = ui->lib274;

	 libRow[27]->pushbutton = ui->pushButtonLib27;
	 estRow[27]->pushbutton = ui->pushButtonEst27;
	 estRow[27]->col[1] = ui->est271;
	 estRow[27]->col[2] = ui->est272;
	 estRow[27]->col[3] = ui->est273;
	 estRow[27]->col[4] = ui->est274;
	 estRow[27]->col[5] = ui->est275;
	 estRow[27]->col[6] = ui->est276;
	 estRow[27]->col[7] = ui->est277;


	 libRow[28]->col[1] = ui->lib281;
	 libRow[28]->col[2] = ui->lib282;
	 libRow[28]->col[3] = ui->lib283;
	 libRow[28]->col[4] = ui->lib284;

	 libRow[28]->pushbutton = ui->pushButtonLib28;
	 estRow[28]->pushbutton = ui->pushButtonEst28;
	 estRow[28]->col[1] = ui->est281;
	 estRow[28]->col[2] = ui->est282;
	 estRow[28]->col[3] = ui->est283;
	 estRow[28]->col[4] = ui->est284;
	 estRow[28]->col[5] = ui->est285;
	 estRow[28]->col[6] = ui->est286;
	 estRow[28]->col[7] = ui->est287;


	 libRow[29]->col[1] = ui->lib291;
	 libRow[29]->col[2] = ui->lib292;
	 libRow[29]->col[3] = ui->lib293;
	 libRow[29]->col[4] = ui->lib294;

	 libRow[29]->pushbutton = ui->pushButtonLib29;
	 estRow[29]->pushbutton = ui->pushButtonEst29;
	 estRow[29]->col[1] = ui->est291;
	 estRow[29]->col[2] = ui->est292;
	 estRow[29]->col[3] = ui->est293;
	 estRow[29]->col[4] = ui->est294;
	 estRow[29]->col[5] = ui->est295;
	 estRow[29]->col[6] = ui->est296;
	 estRow[29]->col[7] = ui->est297;


	 libRow[30]->col[1] = ui->lib301;
	 libRow[30]->col[2] = ui->lib302;
	 libRow[30]->col[3] = ui->lib303;
	 libRow[30]->col[4] = ui->lib304;

	 libRow[30]->pushbutton = ui->pushButtonLib30;
	 estRow[30]->pushbutton = ui->pushButtonEst30;
	 estRow[30]->col[1] = ui->est301;
	 estRow[30]->col[2] = ui->est302;
	 estRow[30]->col[3] = ui->est303;
	 estRow[30]->col[4] = ui->est304;
	 estRow[30]->col[5] = ui->est305;
	 estRow[30]->col[6] = ui->est306;
	 estRow[30]->col[7] = ui->est307;


	 libRow[31]->col[1] = ui->lib311;
	 libRow[31]->col[2] = ui->lib312;
	 libRow[31]->col[3] = ui->lib313;
	 libRow[31]->col[4] = ui->lib314;

	 libRow[31]->pushbutton = ui->pushButtonLib31;
	 estRow[31]->pushbutton = ui->pushButtonEst31;
	 estRow[31]->col[1] = ui->est311;
	 estRow[31]->col[2] = ui->est312;
	 estRow[31]->col[3] = ui->est313;
	 estRow[31]->col[4] = ui->est314;
	 estRow[31]->col[5] = ui->est315;
	 estRow[31]->col[6] = ui->est316;
	 estRow[31]->col[7] = ui->est317;


	 libRow[32]->col[1] = ui->lib321;
	 libRow[32]->col[2] = ui->lib322;
	 libRow[32]->col[3] = ui->lib323;
	 libRow[32]->col[4] = ui->lib324;

	 libRow[32]->pushbutton = ui->pushButtonLib32;
	 estRow[32]->pushbutton = ui->pushButtonEst32;
	 estRow[32]->col[1] = ui->est321;
	 estRow[32]->col[2] = ui->est322;
	 estRow[32]->col[3] = ui->est323;
	 estRow[32]->col[4] = ui->est324;
	 estRow[32]->col[5] = ui->est325;
	 estRow[32]->col[6] = ui->est326;
	 estRow[32]->col[7] = ui->est327;


	 libRow[33]->col[1] = ui->lib331;
	 libRow[33]->col[2] = ui->lib332;
	 libRow[33]->col[3] = ui->lib333;
	 libRow[33]->col[4] = ui->lib334;

	 libRow[33]->pushbutton = ui->pushButtonLib33;
	 estRow[33]->pushbutton = ui->pushButtonEst33;
	 estRow[33]->col[1] = ui->est331;
	 estRow[33]->col[2] = ui->est332;
	 estRow[33]->col[3] = ui->est333;
	 estRow[33]->col[4] = ui->est334;
	 estRow[33]->col[5] = ui->est335;
	 estRow[33]->col[6] = ui->est336;
	 estRow[33]->col[7] = ui->est337;


	 libRow[34]->col[1] = ui->lib341;
	 libRow[34]->col[2] = ui->lib342;
	 libRow[34]->col[3] = ui->lib343;
	 libRow[34]->col[4] = ui->lib344;

	 libRow[34]->pushbutton = ui->pushButtonLib34;
	 estRow[34]->pushbutton = ui->pushButtonEst34;
	 estRow[34]->col[1] = ui->est341;
	 estRow[34]->col[2] = ui->est342;
	 estRow[34]->col[3] = ui->est343;
	 estRow[34]->col[4] = ui->est344;
	 estRow[34]->col[5] = ui->est345;
	 estRow[34]->col[6] = ui->est346;
	 estRow[34]->col[7] = ui->est347;


	 libRow[35]->col[1] = ui->lib351;
	 libRow[35]->col[2] = ui->lib352;
	 libRow[35]->col[3] = ui->lib353;
	 libRow[35]->col[4] = ui->lib354;

	 libRow[35]->pushbutton = ui->pushButtonLib35;
	 estRow[35]->pushbutton = ui->pushButtonEst35;
	 estRow[35]->col[1] = ui->est351;
	 estRow[35]->col[2] = ui->est352;
	 estRow[35]->col[3] = ui->est353;
	 estRow[35]->col[4] = ui->est354;
	 estRow[35]->col[5] = ui->est355;
	 estRow[35]->col[6] = ui->est356;
	 estRow[35]->col[7] = ui->est357;


	 libRow[36]->col[1] = ui->lib361;
	 libRow[36]->col[2] = ui->lib362;
	 libRow[36]->col[3] = ui->lib363;
	 libRow[36]->col[4] = ui->lib364;

	 libRow[36]->pushbutton = ui->pushButtonLib36;
	 estRow[36]->pushbutton = ui->pushButtonEst36;
	 estRow[36]->col[1] = ui->est361;
	 estRow[36]->col[2] = ui->est362;
	 estRow[36]->col[3] = ui->est363;
	 estRow[36]->col[4] = ui->est364;
	 estRow[36]->col[5] = ui->est365;
	 estRow[36]->col[6] = ui->est366;
	 estRow[36]->col[7] = ui->est367;


	 libRow[37]->col[1] = ui->lib371;
	 libRow[37]->col[2] = ui->lib372;
	 libRow[37]->col[3] = ui->lib373;
	 libRow[37]->col[4] = ui->lib374;

	 libRow[37]->pushbutton = ui->pushButtonLib37;
	 estRow[37]->pushbutton = ui->pushButtonEst37;
	 estRow[37]->col[1] = ui->est371;
	 estRow[37]->col[2] = ui->est372;
	 estRow[37]->col[3] = ui->est373;
	 estRow[37]->col[4] = ui->est374;
	 estRow[37]->col[5] = ui->est375;
	 estRow[37]->col[6] = ui->est376;
	 estRow[37]->col[7] = ui->est377;


	 libRow[38]->col[1] = ui->lib381;
	 libRow[38]->col[2] = ui->lib382;
	 libRow[38]->col[3] = ui->lib383;
	 libRow[38]->col[4] = ui->lib384;

	 libRow[38]->pushbutton = ui->pushButtonLib38;
	 estRow[38]->pushbutton = ui->pushButtonEst38;
	 estRow[38]->col[1] = ui->est381;
	 estRow[38]->col[2] = ui->est382;
	 estRow[38]->col[3] = ui->est383;
	 estRow[38]->col[4] = ui->est384;
	 estRow[38]->col[5] = ui->est385;
	 estRow[38]->col[6] = ui->est386;
	 estRow[38]->col[7] = ui->est387;


	 libRow[39]->col[1] = ui->lib391;
	 libRow[39]->col[2] = ui->lib392;
	 libRow[39]->col[3] = ui->lib393;
	 libRow[39]->col[4] = ui->lib394;

	 libRow[39]->pushbutton = ui->pushButtonLib39;
	 estRow[39]->pushbutton = ui->pushButtonEst39;
	 estRow[39]->col[1] = ui->est391;
	 estRow[39]->col[2] = ui->est392;
	 estRow[39]->col[3] = ui->est393;
	 estRow[39]->col[4] = ui->est394;
	 estRow[39]->col[5] = ui->est395;
	 estRow[39]->col[6] = ui->est396;
	 estRow[39]->col[7] = ui->est397;


	 libRow[40]->col[1] = ui->lib401;
	 libRow[40]->col[2] = ui->lib402;
	 libRow[40]->col[3] = ui->lib403;
	 libRow[40]->col[4] = ui->lib404;

	 libRow[40]->pushbutton = ui->pushButtonLib40;
	 estRow[40]->pushbutton = ui->pushButtonEst40;
	 estRow[40]->col[1] = ui->est401;
	 estRow[40]->col[2] = ui->est402;
	 estRow[40]->col[3] = ui->est403;
	 estRow[40]->col[4] = ui->est404;
	 estRow[40]->col[5] = ui->est405;
	 estRow[40]->col[6] = ui->est406;
	 estRow[40]->col[7] = ui->est407;


	 libRow[41]->col[1] = ui->lib411;
	 libRow[41]->col[2] = ui->lib412;
	 libRow[41]->col[3] = ui->lib413;
	 libRow[41]->col[4] = ui->lib414;

	 libRow[41]->pushbutton = ui->pushButtonLib41;
	 estRow[41]->pushbutton = ui->pushButtonEst41;
	 estRow[41]->col[1] = ui->est411;
	 estRow[41]->col[2] = ui->est412;
	 estRow[41]->col[3] = ui->est413;
	 estRow[41]->col[4] = ui->est414;
	 estRow[41]->col[5] = ui->est415;
	 estRow[41]->col[6] = ui->est416;
	 estRow[41]->col[7] = ui->est417;


	 libRow[42]->col[1] = ui->lib421;
	 libRow[42]->col[2] = ui->lib422;
	 libRow[42]->col[3] = ui->lib423;
	 libRow[42]->col[4] = ui->lib424;

	 libRow[42]->pushbutton = ui->pushButtonLib42;
	 estRow[42]->pushbutton = ui->pushButtonEst42;
	 estRow[42]->col[1] = ui->est421;
	 estRow[42]->col[2] = ui->est422;
	 estRow[42]->col[3] = ui->est423;
	 estRow[42]->col[4] = ui->est424;
	 estRow[42]->col[5] = ui->est425;
	 estRow[42]->col[6] = ui->est426;
	 estRow[42]->col[7] = ui->est427;


	 libRow[43]->col[1] = ui->lib431;
	 libRow[43]->col[2] = ui->lib432;
	 libRow[43]->col[3] = ui->lib433;
	 libRow[43]->col[4] = ui->lib434;

	 libRow[43]->pushbutton = ui->pushButtonLib43;
	 estRow[43]->pushbutton = ui->pushButtonEst43;
	 estRow[43]->col[1] = ui->est431;
	 estRow[43]->col[2] = ui->est432;
	 estRow[43]->col[3] = ui->est433;
	 estRow[43]->col[4] = ui->est434;
	 estRow[43]->col[5] = ui->est435;
	 estRow[43]->col[6] = ui->est436;
	 estRow[43]->col[7] = ui->est437;


	 libRow[44]->col[1] = ui->lib441;
	 libRow[44]->col[2] = ui->lib442;
	 libRow[44]->col[3] = ui->lib443;
	 libRow[44]->col[4] = ui->lib444;

	 libRow[44]->pushbutton = ui->pushButtonLib44;
	 estRow[44]->pushbutton = ui->pushButtonEst44;
	 estRow[44]->col[1] = ui->est441;
	 estRow[44]->col[2] = ui->est442;
	 estRow[44]->col[3] = ui->est443;
	 estRow[44]->col[4] = ui->est444;
	 estRow[44]->col[5] = ui->est445;
	 estRow[44]->col[6] = ui->est446;
	 estRow[44]->col[7] = ui->est447;


	 libRow[45]->col[1] = ui->lib451;
	 libRow[45]->col[2] = ui->lib452;
	 libRow[45]->col[3] = ui->lib453;
	 libRow[45]->col[4] = ui->lib454;

	 libRow[45]->pushbutton = ui->pushButtonLib45;
	 estRow[45]->pushbutton = ui->pushButtonEst45;
	 estRow[45]->col[1] = ui->est451;
	 estRow[45]->col[2] = ui->est452;
	 estRow[45]->col[3] = ui->est453;
	 estRow[45]->col[4] = ui->est454;
	 estRow[45]->col[5] = ui->est455;
	 estRow[45]->col[6] = ui->est456;
	 estRow[45]->col[7] = ui->est457;


	 libRow[46]->col[1] = ui->lib461;
	 libRow[46]->col[2] = ui->lib462;
	 libRow[46]->col[3] = ui->lib463;
	 libRow[46]->col[4] = ui->lib464;

	 libRow[46]->pushbutton = ui->pushButtonLib46;
	 estRow[46]->pushbutton = ui->pushButtonEst46;
	 estRow[46]->col[1] = ui->est461;
	 estRow[46]->col[2] = ui->est462;
	 estRow[46]->col[3] = ui->est463;
	 estRow[46]->col[4] = ui->est464;
	 estRow[46]->col[5] = ui->est465;
	 estRow[46]->col[6] = ui->est466;
	 estRow[46]->col[7] = ui->est467;


	 libRow[47]->col[1] = ui->lib471;
	 libRow[47]->col[2] = ui->lib472;
	 libRow[47]->col[3] = ui->lib473;
	 libRow[47]->col[4] = ui->lib474;

	 libRow[47]->pushbutton = ui->pushButtonLib47;
	 estRow[47]->pushbutton = ui->pushButtonEst47;
	 estRow[47]->col[1] = ui->est471;
	 estRow[47]->col[2] = ui->est472;
	 estRow[47]->col[3] = ui->est473;
	 estRow[47]->col[4] = ui->est474;
	 estRow[47]->col[5] = ui->est475;
	 estRow[47]->col[6] = ui->est476;
	 estRow[47]->col[7] = ui->est477;


	 libRow[48]->col[1] = ui->lib481;
	 libRow[48]->col[2] = ui->lib482;
	 libRow[48]->col[3] = ui->lib483;
	 libRow[48]->col[4] = ui->lib484;

	 libRow[48]->pushbutton = ui->pushButtonLib48;
	 estRow[48]->pushbutton = ui->pushButtonEst48;
	 estRow[48]->col[1] = ui->est481;
	 estRow[48]->col[2] = ui->est482;
	 estRow[48]->col[3] = ui->est483;
	 estRow[48]->col[4] = ui->est484;
	 estRow[48]->col[5] = ui->est485;
	 estRow[48]->col[6] = ui->est486;
	 estRow[48]->col[7] = ui->est487;


	 libRow[49]->col[1] = ui->lib491;
	 libRow[49]->col[2] = ui->lib492;
	 libRow[49]->col[3] = ui->lib493;
	 libRow[49]->col[4] = ui->lib494;

	 libRow[49]->pushbutton = ui->pushButtonLib49;
	 estRow[49]->pushbutton = ui->pushButtonEst49;
	 estRow[49]->col[1] = ui->est491;
	 estRow[49]->col[2] = ui->est492;
	 estRow[49]->col[3] = ui->est493;
	 estRow[49]->col[4] = ui->est494;
	 estRow[49]->col[5] = ui->est495;
	 estRow[49]->col[6] = ui->est496;
	 estRow[49]->col[7] = ui->est497;


	 libRow[50]->col[1] = ui->lib501;
	 libRow[50]->col[2] = ui->lib502;
	 libRow[50]->col[3] = ui->lib503;
	 libRow[50]->col[4] = ui->lib504;

	 libRow[50]->pushbutton = ui->pushButtonLib50;
	 estRow[50]->pushbutton = ui->pushButtonEst50;
	 estRow[50]->col[1] = ui->est501;
	 estRow[50]->col[2] = ui->est502;
	 estRow[50]->col[3] = ui->est503;
	 estRow[50]->col[4] = ui->est504;
	 estRow[50]->col[5] = ui->est505;
	 estRow[50]->col[6] = ui->est506;
	 estRow[50]->col[7] = ui->est507;


	 libRow[51]->col[1] = ui->lib511;
	 libRow[51]->col[2] = ui->lib512;
	 libRow[51]->col[3] = ui->lib513;
	 libRow[51]->col[4] = ui->lib514;

	 libRow[51]->pushbutton = ui->pushButtonLib51;
	 estRow[51]->pushbutton = ui->pushButtonEst51;
	 estRow[51]->col[1] = ui->est511;
	 estRow[51]->col[2] = ui->est512;
	 estRow[51]->col[3] = ui->est513;
	 estRow[51]->col[4] = ui->est514;
	 estRow[51]->col[5] = ui->est515;
	 estRow[51]->col[6] = ui->est516;
	 estRow[51]->col[7] = ui->est517;


	 libRow[52]->col[1] = ui->lib521;
	 libRow[52]->col[2] = ui->lib522;
	 libRow[52]->col[3] = ui->lib523;
	 libRow[52]->col[4] = ui->lib524;

	 libRow[52]->pushbutton = ui->pushButtonLib52;
	 estRow[52]->pushbutton = ui->pushButtonEst52;
	 estRow[52]->col[1] = ui->est521;
	 estRow[52]->col[2] = ui->est522;
	 estRow[52]->col[3] = ui->est523;
	 estRow[52]->col[4] = ui->est524;
	 estRow[52]->col[5] = ui->est525;
	 estRow[52]->col[6] = ui->est526;
	 estRow[52]->col[7] = ui->est527;


	 libRow[53]->col[1] = ui->lib531;
	 libRow[53]->col[2] = ui->lib532;
	 libRow[53]->col[3] = ui->lib533;
	 libRow[53]->col[4] = ui->lib534;

	 libRow[53]->pushbutton = ui->pushButtonLib53;
	 estRow[53]->pushbutton = ui->pushButtonEst53;
	 estRow[53]->col[1] = ui->est531;
	 estRow[53]->col[2] = ui->est532;
	 estRow[53]->col[3] = ui->est533;
	 estRow[53]->col[4] = ui->est534;
	 estRow[53]->col[5] = ui->est535;
	 estRow[53]->col[6] = ui->est536;
	 estRow[53]->col[7] = ui->est537;


	 libRow[54]->col[1] = ui->lib541;
	 libRow[54]->col[2] = ui->lib542;
	 libRow[54]->col[3] = ui->lib543;
	 libRow[54]->col[4] = ui->lib544;

	 libRow[54]->pushbutton = ui->pushButtonLib54;
	 estRow[54]->pushbutton = ui->pushButtonEst54;
	 estRow[54]->col[1] = ui->est541;
	 estRow[54]->col[2] = ui->est542;
	 estRow[54]->col[3] = ui->est543;
	 estRow[54]->col[4] = ui->est544;
	 estRow[54]->col[5] = ui->est545;
	 estRow[54]->col[6] = ui->est546;
	 estRow[54]->col[7] = ui->est547;


	 libRow[55]->col[1] = ui->lib551;
	 libRow[55]->col[2] = ui->lib552;
	 libRow[55]->col[3] = ui->lib553;
	 libRow[55]->col[4] = ui->lib554;

	 libRow[55]->pushbutton = ui->pushButtonLib55;
	 estRow[55]->pushbutton = ui->pushButtonEst55;
	 estRow[55]->col[1] = ui->est551;
	 estRow[55]->col[2] = ui->est552;
	 estRow[55]->col[3] = ui->est553;
	 estRow[55]->col[4] = ui->est554;
	 estRow[55]->col[5] = ui->est555;
	 estRow[55]->col[6] = ui->est556;
	 estRow[55]->col[7] = ui->est557;


	 libRow[56]->col[1] = ui->lib561;
	 libRow[56]->col[2] = ui->lib562;
	 libRow[56]->col[3] = ui->lib563;
	 libRow[56]->col[4] = ui->lib564;

	 libRow[56]->pushbutton = ui->pushButtonLib56;
	 estRow[56]->pushbutton = ui->pushButtonEst56;
	 estRow[56]->col[1] = ui->est561;
	 estRow[56]->col[2] = ui->est562;
	 estRow[56]->col[3] = ui->est563;
	 estRow[56]->col[4] = ui->est564;
	 estRow[56]->col[5] = ui->est565;
	 estRow[56]->col[6] = ui->est566;
	 estRow[56]->col[7] = ui->est567;


	 libRow[57]->col[1] = ui->lib571;
	 libRow[57]->col[2] = ui->lib572;
	 libRow[57]->col[3] = ui->lib573;
	 libRow[57]->col[4] = ui->lib574;

	 libRow[57]->pushbutton = ui->pushButtonLib57;
	 estRow[57]->pushbutton = ui->pushButtonEst57;
	 estRow[57]->col[1] = ui->est571;
	 estRow[57]->col[2] = ui->est572;
	 estRow[57]->col[3] = ui->est573;
	 estRow[57]->col[4] = ui->est574;
	 estRow[57]->col[5] = ui->est575;
	 estRow[57]->col[6] = ui->est576;
	 estRow[57]->col[7] = ui->est577;


	 libRow[58]->col[1] = ui->lib581;
	 libRow[58]->col[2] = ui->lib582;
	 libRow[58]->col[3] = ui->lib583;
	 libRow[58]->col[4] = ui->lib584;

	 libRow[58]->pushbutton = ui->pushButtonLib58;
	 estRow[58]->pushbutton = ui->pushButtonEst58;
	 estRow[58]->col[1] = ui->est581;
	 estRow[58]->col[2] = ui->est582;
	 estRow[58]->col[3] = ui->est583;
	 estRow[58]->col[4] = ui->est584;
	 estRow[58]->col[5] = ui->est585;
	 estRow[58]->col[6] = ui->est586;
	 estRow[58]->col[7] = ui->est587;


	 libRow[59]->col[1] = ui->lib591;
	 libRow[59]->col[2] = ui->lib592;
	 libRow[59]->col[3] = ui->lib593;
	 libRow[59]->col[4] = ui->lib594;

	 libRow[59]->pushbutton = ui->pushButtonLib59;
	 estRow[59]->pushbutton = ui->pushButtonEst59;
	 estRow[59]->col[1] = ui->est591;
	 estRow[59]->col[2] = ui->est592;
	 estRow[59]->col[3] = ui->est593;
	 estRow[59]->col[4] = ui->est594;
	 estRow[59]->col[5] = ui->est595;
	 estRow[59]->col[6] = ui->est596;
	 estRow[59]->col[7] = ui->est597;


	 libRow[60]->col[1] = ui->lib601;
	 libRow[60]->col[2] = ui->lib602;
	 libRow[60]->col[3] = ui->lib603;
	 libRow[60]->col[4] = ui->lib604;

	 libRow[60]->pushbutton = ui->pushButtonLib60;
	 estRow[60]->pushbutton = ui->pushButtonEst60;
	 estRow[60]->col[1] = ui->est601;
	 estRow[60]->col[2] = ui->est602;
	 estRow[60]->col[3] = ui->est603;
	 estRow[60]->col[4] = ui->est604;
	 estRow[60]->col[5] = ui->est605;
	 estRow[60]->col[6] = ui->est606;
	 estRow[60]->col[7] = ui->est607;


	 libRow[61]->col[1] = ui->lib611;
	 libRow[61]->col[2] = ui->lib612;
	 libRow[61]->col[3] = ui->lib613;
	 libRow[61]->col[4] = ui->lib614;

	 libRow[61]->pushbutton = ui->pushButtonLib61;
	 estRow[61]->pushbutton = ui->pushButtonEst61;
	 estRow[61]->col[1] = ui->est611;
	 estRow[61]->col[2] = ui->est612;
	 estRow[61]->col[3] = ui->est613;
	 estRow[61]->col[4] = ui->est614;
	 estRow[61]->col[5] = ui->est615;
	 estRow[61]->col[6] = ui->est616;
	 estRow[61]->col[7] = ui->est617;


	 libRow[62]->col[1] = ui->lib621;
	 libRow[62]->col[2] = ui->lib622;
	 libRow[62]->col[3] = ui->lib623;
	 libRow[62]->col[4] = ui->lib624;

	 libRow[62]->pushbutton = ui->pushButtonLib62;
	 estRow[62]->pushbutton = ui->pushButtonEst62;
	 estRow[62]->col[1] = ui->est621;
	 estRow[62]->col[2] = ui->est622;
	 estRow[62]->col[3] = ui->est623;
	 estRow[62]->col[4] = ui->est624;
	 estRow[62]->col[5] = ui->est625;
	 estRow[62]->col[6] = ui->est626;
	 estRow[62]->col[7] = ui->est627;


	 libRow[63]->col[1] = ui->lib631;
	 libRow[63]->col[2] = ui->lib632;
	 libRow[63]->col[3] = ui->lib633;
	 libRow[63]->col[4] = ui->lib634;

	 libRow[63]->pushbutton = ui->pushButtonLib63;
	 estRow[63]->pushbutton = ui->pushButtonEst63;
	 estRow[63]->col[1] = ui->est631;
	 estRow[63]->col[2] = ui->est632;
	 estRow[63]->col[3] = ui->est633;
	 estRow[63]->col[4] = ui->est634;
	 estRow[63]->col[5] = ui->est635;
	 estRow[63]->col[6] = ui->est636;
	 estRow[63]->col[7] = ui->est637;


	 libRow[64]->col[1] = ui->lib641;
	 libRow[64]->col[2] = ui->lib642;
	 libRow[64]->col[3] = ui->lib643;
	 libRow[64]->col[4] = ui->lib644;

	 libRow[64]->pushbutton = ui->pushButtonLib64;
	 estRow[64]->pushbutton = ui->pushButtonEst64;
	 estRow[64]->col[1] = ui->est641;
	 estRow[64]->col[2] = ui->est642;
	 estRow[64]->col[3] = ui->est643;
	 estRow[64]->col[4] = ui->est644;
	 estRow[64]->col[5] = ui->est645;
	 estRow[64]->col[6] = ui->est646;
	 estRow[64]->col[7] = ui->est647;


	 libRow[65]->col[1] = ui->lib651;
	 libRow[65]->col[2] = ui->lib652;
	 libRow[65]->col[3] = ui->lib653;
	 libRow[65]->col[4] = ui->lib654;

	 libRow[65]->pushbutton = ui->pushButtonLib65;
	 estRow[65]->pushbutton = ui->pushButtonEst65;
	 estRow[65]->col[1] = ui->est651;
	 estRow[65]->col[2] = ui->est652;
	 estRow[65]->col[3] = ui->est653;
	 estRow[65]->col[4] = ui->est654;
	 estRow[65]->col[5] = ui->est655;
	 estRow[65]->col[6] = ui->est656;
	 estRow[65]->col[7] = ui->est657;


	 libRow[66]->col[1] = ui->lib661;
	 libRow[66]->col[2] = ui->lib662;
	 libRow[66]->col[3] = ui->lib663;
	 libRow[66]->col[4] = ui->lib664;

	 libRow[66]->pushbutton = ui->pushButtonLib66;
	 estRow[66]->pushbutton = ui->pushButtonEst66;
	 estRow[66]->col[1] = ui->est661;
	 estRow[66]->col[2] = ui->est662;
	 estRow[66]->col[3] = ui->est663;
	 estRow[66]->col[4] = ui->est664;
	 estRow[66]->col[5] = ui->est665;
	 estRow[66]->col[6] = ui->est666;
	 estRow[66]->col[7] = ui->est667;


	 libRow[67]->col[1] = ui->lib671;
	 libRow[67]->col[2] = ui->lib672;
	 libRow[67]->col[3] = ui->lib673;
	 libRow[67]->col[4] = ui->lib674;

	 libRow[67]->pushbutton = ui->pushButtonLib67;
	 estRow[67]->pushbutton = ui->pushButtonEst67;
	 estRow[67]->col[1] = ui->est671;
	 estRow[67]->col[2] = ui->est672;
	 estRow[67]->col[3] = ui->est673;
	 estRow[67]->col[4] = ui->est674;
	 estRow[67]->col[5] = ui->est675;
	 estRow[67]->col[6] = ui->est676;
	 estRow[67]->col[7] = ui->est677;


	 libRow[68]->col[1] = ui->lib681;
	 libRow[68]->col[2] = ui->lib682;
	 libRow[68]->col[3] = ui->lib683;
	 libRow[68]->col[4] = ui->lib684;

	 libRow[68]->pushbutton = ui->pushButtonLib68;
	 estRow[68]->pushbutton = ui->pushButtonEst68;
	 estRow[68]->col[1] = ui->est681;
	 estRow[68]->col[2] = ui->est682;
	 estRow[68]->col[3] = ui->est683;
	 estRow[68]->col[4] = ui->est684;
	 estRow[68]->col[5] = ui->est685;
	 estRow[68]->col[6] = ui->est686;
	 estRow[68]->col[7] = ui->est687;


	 libRow[69]->col[1] = ui->lib691;
	 libRow[69]->col[2] = ui->lib692;
	 libRow[69]->col[3] = ui->lib693;
	 libRow[69]->col[4] = ui->lib694;

	 libRow[69]->pushbutton = ui->pushButtonLib69;
	 estRow[69]->pushbutton = ui->pushButtonEst69;
	 estRow[69]->col[1] = ui->est691;
	 estRow[69]->col[2] = ui->est692;
	 estRow[69]->col[3] = ui->est693;
	 estRow[69]->col[4] = ui->est694;
	 estRow[69]->col[5] = ui->est695;
	 estRow[69]->col[6] = ui->est696;
	 estRow[69]->col[7] = ui->est697;


	 libRow[70]->col[1] = ui->lib701;
	 libRow[70]->col[2] = ui->lib702;
	 libRow[70]->col[3] = ui->lib703;
	 libRow[70]->col[4] = ui->lib704;

	 libRow[70]->pushbutton = ui->pushButtonLib70;
	 estRow[70]->pushbutton = ui->pushButtonEst70;
	 estRow[70]->col[1] = ui->est701;
	 estRow[70]->col[2] = ui->est702;
	 estRow[70]->col[3] = ui->est703;
	 estRow[70]->col[4] = ui->est704;
	 estRow[70]->col[5] = ui->est705;
	 estRow[70]->col[6] = ui->est706;
	 estRow[70]->col[7] = ui->est707;


	 libRow[71]->col[1] = ui->lib711;
	 libRow[71]->col[2] = ui->lib712;
	 libRow[71]->col[3] = ui->lib713;
	 libRow[71]->col[4] = ui->lib714;

	 libRow[71]->pushbutton = ui->pushButtonLib71;
	 estRow[71]->pushbutton = ui->pushButtonEst71;
	 estRow[71]->col[1] = ui->est711;
	 estRow[71]->col[2] = ui->est712;
	 estRow[71]->col[3] = ui->est713;
	 estRow[71]->col[4] = ui->est714;
	 estRow[71]->col[5] = ui->est715;
	 estRow[71]->col[6] = ui->est716;
	 estRow[71]->col[7] = ui->est717;


	 libRow[72]->col[1] = ui->lib721;
	 libRow[72]->col[2] = ui->lib722;
	 libRow[72]->col[3] = ui->lib723;
	 libRow[72]->col[4] = ui->lib724;

	 libRow[72]->pushbutton = ui->pushButtonLib72;
	 estRow[72]->pushbutton = ui->pushButtonEst72;
	 estRow[72]->col[1] = ui->est721;
	 estRow[72]->col[2] = ui->est722;
	 estRow[72]->col[3] = ui->est723;
	 estRow[72]->col[4] = ui->est724;
	 estRow[72]->col[5] = ui->est725;
	 estRow[72]->col[6] = ui->est726;
	 estRow[72]->col[7] = ui->est727;


	 libRow[73]->col[1] = ui->lib731;
	 libRow[73]->col[2] = ui->lib732;
	 libRow[73]->col[3] = ui->lib733;
	 libRow[73]->col[4] = ui->lib734;

	 libRow[73]->pushbutton = ui->pushButtonLib73;
	 estRow[73]->pushbutton = ui->pushButtonEst73;
	 estRow[73]->col[1] = ui->est731;
	 estRow[73]->col[2] = ui->est732;
	 estRow[73]->col[3] = ui->est733;
	 estRow[73]->col[4] = ui->est734;
	 estRow[73]->col[5] = ui->est735;
	 estRow[73]->col[6] = ui->est736;
	 estRow[73]->col[7] = ui->est737;


	 libRow[74]->col[1] = ui->lib741;
	 libRow[74]->col[2] = ui->lib742;
	 libRow[74]->col[3] = ui->lib743;
	 libRow[74]->col[4] = ui->lib744;

	 libRow[74]->pushbutton = ui->pushButtonLib74;
	 estRow[74]->pushbutton = ui->pushButtonEst74;
	 estRow[74]->col[1] = ui->est741;
	 estRow[74]->col[2] = ui->est742;
	 estRow[74]->col[3] = ui->est743;
	 estRow[74]->col[4] = ui->est744;
	 estRow[74]->col[5] = ui->est745;
	 estRow[74]->col[6] = ui->est746;
	 estRow[74]->col[7] = ui->est747;


	 libRow[75]->col[1] = ui->lib751;
	 libRow[75]->col[2] = ui->lib752;
	 libRow[75]->col[3] = ui->lib753;
	 libRow[75]->col[4] = ui->lib754;

	 libRow[75]->pushbutton = ui->pushButtonLib75;
	 estRow[75]->pushbutton = ui->pushButtonEst75;
	 estRow[75]->col[1] = ui->est751;
	 estRow[75]->col[2] = ui->est752;
	 estRow[75]->col[3] = ui->est753;
	 estRow[75]->col[4] = ui->est754;
	 estRow[75]->col[5] = ui->est755;
	 estRow[75]->col[6] = ui->est756;
	 estRow[75]->col[7] = ui->est757;


	 libRow[76]->col[1] = ui->lib761;
	 libRow[76]->col[2] = ui->lib762;
	 libRow[76]->col[3] = ui->lib763;
	 libRow[76]->col[4] = ui->lib764;

	 libRow[76]->pushbutton = ui->pushButtonLib76;
	 estRow[76]->pushbutton = ui->pushButtonEst76;
	 estRow[76]->col[1] = ui->est761;
	 estRow[76]->col[2] = ui->est762;
	 estRow[76]->col[3] = ui->est763;
	 estRow[76]->col[4] = ui->est764;
	 estRow[76]->col[5] = ui->est765;
	 estRow[76]->col[6] = ui->est766;
	 estRow[76]->col[7] = ui->est767;


	 libRow[77]->col[1] = ui->lib771;
	 libRow[77]->col[2] = ui->lib772;
	 libRow[77]->col[3] = ui->lib773;
	 libRow[77]->col[4] = ui->lib774;

	 libRow[77]->pushbutton = ui->pushButtonLib77;
	 estRow[77]->pushbutton = ui->pushButtonEst77;
	 estRow[77]->col[1] = ui->est771;
	 estRow[77]->col[2] = ui->est772;
	 estRow[77]->col[3] = ui->est773;
	 estRow[77]->col[4] = ui->est774;
	 estRow[77]->col[5] = ui->est775;
	 estRow[77]->col[6] = ui->est776;
	 estRow[77]->col[7] = ui->est777;


	 libRow[78]->col[1] = ui->lib781;
	 libRow[78]->col[2] = ui->lib782;
	 libRow[78]->col[3] = ui->lib783;
	 libRow[78]->col[4] = ui->lib784;

	 libRow[78]->pushbutton = ui->pushButtonLib78;
	 estRow[78]->pushbutton = ui->pushButtonEst78;
	 estRow[78]->col[1] = ui->est781;
	 estRow[78]->col[2] = ui->est782;
	 estRow[78]->col[3] = ui->est783;
	 estRow[78]->col[4] = ui->est784;
	 estRow[78]->col[5] = ui->est785;
	 estRow[78]->col[6] = ui->est786;
	 estRow[78]->col[7] = ui->est787;


	 libRow[79]->col[1] = ui->lib791;
	 libRow[79]->col[2] = ui->lib792;
	 libRow[79]->col[3] = ui->lib793;
	 libRow[79]->col[4] = ui->lib794;

	 libRow[79]->pushbutton = ui->pushButtonLib79;
	 estRow[79]->pushbutton = ui->pushButtonEst79;
	 estRow[79]->col[1] = ui->est791;
	 estRow[79]->col[2] = ui->est792;
	 estRow[79]->col[3] = ui->est793;
	 estRow[79]->col[4] = ui->est794;
	 estRow[79]->col[5] = ui->est795;
	 estRow[79]->col[6] = ui->est796;
	 estRow[79]->col[7] = ui->est797;


	 libRow[80]->col[1] = ui->lib801;
	 libRow[80]->col[2] = ui->lib802;
	 libRow[80]->col[3] = ui->lib803;
	 libRow[80]->col[4] = ui->lib804;

	 libRow[80]->pushbutton = ui->pushButtonLib80;
	 estRow[80]->pushbutton = ui->pushButtonEst80;
	 estRow[80]->col[1] = ui->est801;
	 estRow[80]->col[2] = ui->est802;
	 estRow[80]->col[3] = ui->est803;
	 estRow[80]->col[4] = ui->est804;
	 estRow[80]->col[5] = ui->est805;
	 estRow[80]->col[6] = ui->est806;
	 estRow[80]->col[7] = ui->est807;


	 libRow[81]->col[1] = ui->lib811;
	 libRow[81]->col[2] = ui->lib812;
	 libRow[81]->col[3] = ui->lib813;
	 libRow[81]->col[4] = ui->lib814;

	 libRow[81]->pushbutton = ui->pushButtonLib81;
	 estRow[81]->pushbutton = ui->pushButtonEst81;
	 estRow[81]->col[1] = ui->est811;
	 estRow[81]->col[2] = ui->est812;
	 estRow[81]->col[3] = ui->est813;
	 estRow[81]->col[4] = ui->est814;
	 estRow[81]->col[5] = ui->est815;
	 estRow[81]->col[6] = ui->est816;
	 estRow[81]->col[7] = ui->est817;


	 libRow[82]->col[1] = ui->lib821;
	 libRow[82]->col[2] = ui->lib822;
	 libRow[82]->col[3] = ui->lib823;
	 libRow[82]->col[4] = ui->lib824;

	 libRow[82]->pushbutton = ui->pushButtonLib82;
	 estRow[82]->pushbutton = ui->pushButtonEst82;
	 estRow[82]->col[1] = ui->est821;
	 estRow[82]->col[2] = ui->est822;
	 estRow[82]->col[3] = ui->est823;
	 estRow[82]->col[4] = ui->est824;
	 estRow[82]->col[5] = ui->est825;
	 estRow[82]->col[6] = ui->est826;
	 estRow[82]->col[7] = ui->est827;

#ifndef TRUNCATEDforfastcompilingZZZzzz

	 libRow[83]->col[1] = ui->lib831;
	 libRow[83]->col[2] = ui->lib832;
	 libRow[83]->col[3] = ui->lib833;
	 libRow[83]->col[4] = ui->lib834;

	 libRow[83]->pushbutton = ui->pushButtonLib83;
	 estRow[83]->pushbutton = ui->pushButtonEst83;
	 estRow[83]->col[1] = ui->est831;
	 estRow[83]->col[2] = ui->est832;
	 estRow[83]->col[3] = ui->est833;
	 estRow[83]->col[4] = ui->est834;
	 estRow[83]->col[5] = ui->est835;
	 estRow[83]->col[6] = ui->est836;
	 estRow[83]->col[7] = ui->est837;


	 libRow[84]->col[1] = ui->lib841;
	 libRow[84]->col[2] = ui->lib842;
	 libRow[84]->col[3] = ui->lib843;
	 libRow[84]->col[4] = ui->lib844;

	 libRow[84]->pushbutton = ui->pushButtonLib84;
	 estRow[84]->pushbutton = ui->pushButtonEst84;
	 estRow[84]->col[1] = ui->est841;
	 estRow[84]->col[2] = ui->est842;
	 estRow[84]->col[3] = ui->est843;
	 estRow[84]->col[4] = ui->est844;
	 estRow[84]->col[5] = ui->est845;
	 estRow[84]->col[6] = ui->est846;
	 estRow[84]->col[7] = ui->est847;


	 libRow[85]->col[1] = ui->lib851;
	 libRow[85]->col[2] = ui->lib852;
	 libRow[85]->col[3] = ui->lib853;
	 libRow[85]->col[4] = ui->lib854;

	 libRow[85]->pushbutton = ui->pushButtonLib85;
	 estRow[85]->pushbutton = ui->pushButtonEst85;
	 estRow[85]->col[1] = ui->est851;
	 estRow[85]->col[2] = ui->est852;
	 estRow[85]->col[3] = ui->est853;
	 estRow[85]->col[4] = ui->est854;
	 estRow[85]->col[5] = ui->est855;
	 estRow[85]->col[6] = ui->est856;
	 estRow[85]->col[7] = ui->est857;


	 libRow[86]->col[1] = ui->lib861;
	 libRow[86]->col[2] = ui->lib862;
	 libRow[86]->col[3] = ui->lib863;
	 libRow[86]->col[4] = ui->lib864;

	 libRow[86]->pushbutton = ui->pushButtonLib86;
	 estRow[86]->pushbutton = ui->pushButtonEst86;
	 estRow[86]->col[1] = ui->est861;
	 estRow[86]->col[2] = ui->est862;
	 estRow[86]->col[3] = ui->est863;
	 estRow[86]->col[4] = ui->est864;
	 estRow[86]->col[5] = ui->est865;
	 estRow[86]->col[6] = ui->est866;
	 estRow[86]->col[7] = ui->est867;


	 libRow[87]->col[1] = ui->lib871;
	 libRow[87]->col[2] = ui->lib872;
	 libRow[87]->col[3] = ui->lib873;
	 libRow[87]->col[4] = ui->lib874;

	 libRow[87]->pushbutton = ui->pushButtonLib87;
	 estRow[87]->pushbutton = ui->pushButtonEst87;
	 estRow[87]->col[1] = ui->est871;
	 estRow[87]->col[2] = ui->est872;
	 estRow[87]->col[3] = ui->est873;
	 estRow[87]->col[4] = ui->est874;
	 estRow[87]->col[5] = ui->est875;
	 estRow[87]->col[6] = ui->est876;
	 estRow[87]->col[7] = ui->est877;


	 libRow[88]->col[1] = ui->lib881;
	 libRow[88]->col[2] = ui->lib882;
	 libRow[88]->col[3] = ui->lib883;
	 libRow[88]->col[4] = ui->lib884;

	 libRow[88]->pushbutton = ui->pushButtonLib88;
	 estRow[88]->pushbutton = ui->pushButtonEst88;
	 estRow[88]->col[1] = ui->est881;
	 estRow[88]->col[2] = ui->est882;
	 estRow[88]->col[3] = ui->est883;
	 estRow[88]->col[4] = ui->est884;
	 estRow[88]->col[5] = ui->est885;
	 estRow[88]->col[6] = ui->est886;
	 estRow[88]->col[7] = ui->est887;


	 libRow[89]->col[1] = ui->lib891;
	 libRow[89]->col[2] = ui->lib892;
	 libRow[89]->col[3] = ui->lib893;
	 libRow[89]->col[4] = ui->lib894;

	 libRow[89]->pushbutton = ui->pushButtonLib89;
	 estRow[89]->pushbutton = ui->pushButtonEst89;
	 estRow[89]->col[1] = ui->est891;
	 estRow[89]->col[2] = ui->est892;
	 estRow[89]->col[3] = ui->est893;
	 estRow[89]->col[4] = ui->est894;
	 estRow[89]->col[5] = ui->est895;
	 estRow[89]->col[6] = ui->est896;
	 estRow[89]->col[7] = ui->est897;


	 libRow[90]->col[1] = ui->lib901;
	 libRow[90]->col[2] = ui->lib902;
	 libRow[90]->col[3] = ui->lib903;
	 libRow[90]->col[4] = ui->lib904;

	 libRow[90]->pushbutton = ui->pushButtonLib90;
	 estRow[90]->pushbutton = ui->pushButtonEst90;
	 estRow[90]->col[1] = ui->est901;
	 estRow[90]->col[2] = ui->est902;
	 estRow[90]->col[3] = ui->est903;
	 estRow[90]->col[4] = ui->est904;
	 estRow[90]->col[5] = ui->est905;
	 estRow[90]->col[6] = ui->est906;
	 estRow[90]->col[7] = ui->est907;


	 libRow[91]->col[1] = ui->lib911;
	 libRow[91]->col[2] = ui->lib912;
	 libRow[91]->col[3] = ui->lib913;
	 libRow[91]->col[4] = ui->lib914;

	 libRow[91]->pushbutton = ui->pushButtonLib91;
	 estRow[91]->pushbutton = ui->pushButtonEst91;
	 estRow[91]->col[1] = ui->est911;
	 estRow[91]->col[2] = ui->est912;
	 estRow[91]->col[3] = ui->est913;
	 estRow[91]->col[4] = ui->est914;
	 estRow[91]->col[5] = ui->est915;
	 estRow[91]->col[6] = ui->est916;
	 estRow[91]->col[7] = ui->est917;


	 libRow[92]->col[1] = ui->lib921;
	 libRow[92]->col[2] = ui->lib922;
	 libRow[92]->col[3] = ui->lib923;
	 libRow[92]->col[4] = ui->lib924;

	 libRow[92]->pushbutton = ui->pushButtonLib92;
	 estRow[92]->pushbutton = ui->pushButtonEst92;
	 estRow[92]->col[1] = ui->est921;
	 estRow[92]->col[2] = ui->est922;
	 estRow[92]->col[3] = ui->est923;
	 estRow[92]->col[4] = ui->est924;
	 estRow[92]->col[5] = ui->est925;
	 estRow[92]->col[6] = ui->est926;
	 estRow[92]->col[7] = ui->est927;


	 libRow[93]->col[1] = ui->lib931;
	 libRow[93]->col[2] = ui->lib932;
	 libRow[93]->col[3] = ui->lib933;
	 libRow[93]->col[4] = ui->lib934;

	 libRow[93]->pushbutton = ui->pushButtonLib93;
	 estRow[93]->pushbutton = ui->pushButtonEst93;
	 estRow[93]->col[1] = ui->est931;
	 estRow[93]->col[2] = ui->est932;
	 estRow[93]->col[3] = ui->est933;
	 estRow[93]->col[4] = ui->est934;
	 estRow[93]->col[5] = ui->est935;
	 estRow[93]->col[6] = ui->est936;
	 estRow[93]->col[7] = ui->est937;


	 libRow[94]->col[1] = ui->lib941;
	 libRow[94]->col[2] = ui->lib942;
	 libRow[94]->col[3] = ui->lib943;
	 libRow[94]->col[4] = ui->lib944;

	 libRow[94]->pushbutton = ui->pushButtonLib94;
	 estRow[94]->pushbutton = ui->pushButtonEst94;
	 estRow[94]->col[1] = ui->est941;
	 estRow[94]->col[2] = ui->est942;
	 estRow[94]->col[3] = ui->est943;
	 estRow[94]->col[4] = ui->est944;
	 estRow[94]->col[5] = ui->est945;
	 estRow[94]->col[6] = ui->est946;
	 estRow[94]->col[7] = ui->est947;


	 libRow[95]->col[1] = ui->lib951;
	 libRow[95]->col[2] = ui->lib952;
	 libRow[95]->col[3] = ui->lib953;
	 libRow[95]->col[4] = ui->lib954;

	 libRow[95]->pushbutton = ui->pushButtonLib95;
	 estRow[95]->pushbutton = ui->pushButtonEst95;
	 estRow[95]->col[1] = ui->est951;
	 estRow[95]->col[2] = ui->est952;
	 estRow[95]->col[3] = ui->est953;
	 estRow[95]->col[4] = ui->est954;
	 estRow[95]->col[5] = ui->est955;
	 estRow[95]->col[6] = ui->est956;
	 estRow[95]->col[7] = ui->est957;


	 libRow[96]->col[1] = ui->lib961;
	 libRow[96]->col[2] = ui->lib962;
	 libRow[96]->col[3] = ui->lib963;
	 libRow[96]->col[4] = ui->lib964;

	 libRow[96]->pushbutton = ui->pushButtonLib96;
	 estRow[96]->pushbutton = ui->pushButtonEst96;
	 estRow[96]->col[1] = ui->est961;
	 estRow[96]->col[2] = ui->est962;
	 estRow[96]->col[3] = ui->est963;
	 estRow[96]->col[4] = ui->est964;
	 estRow[96]->col[5] = ui->est965;
	 estRow[96]->col[6] = ui->est966;
	 estRow[96]->col[7] = ui->est967;


	 libRow[97]->col[1] = ui->lib971;
	 libRow[97]->col[2] = ui->lib972;
	 libRow[97]->col[3] = ui->lib973;
	 libRow[97]->col[4] = ui->lib974;

	 libRow[97]->pushbutton = ui->pushButtonLib97;
	 estRow[97]->pushbutton = ui->pushButtonEst97;
	 estRow[97]->col[1] = ui->est971;
	 estRow[97]->col[2] = ui->est972;
	 estRow[97]->col[3] = ui->est973;
	 estRow[97]->col[4] = ui->est974;
	 estRow[97]->col[5] = ui->est975;
	 estRow[97]->col[6] = ui->est976;
	 estRow[97]->col[7] = ui->est977;


	 libRow[98]->col[1] = ui->lib981;
	 libRow[98]->col[2] = ui->lib982;
	 libRow[98]->col[3] = ui->lib983;
	 libRow[98]->col[4] = ui->lib984;

	 libRow[98]->pushbutton = ui->pushButtonLib98;
	 estRow[98]->pushbutton = ui->pushButtonEst98;
	 estRow[98]->col[1] = ui->est981;
	 estRow[98]->col[2] = ui->est982;
	 estRow[98]->col[3] = ui->est983;
	 estRow[98]->col[4] = ui->est984;
	 estRow[98]->col[5] = ui->est985;
	 estRow[98]->col[6] = ui->est986;
	 estRow[98]->col[7] = ui->est987;


	 libRow[99]->col[1] = ui->lib991;
	 libRow[99]->col[2] = ui->lib992;
	 libRow[99]->col[3] = ui->lib993;
	 libRow[99]->col[4] = ui->lib994;

	 libRow[99]->pushbutton = ui->pushButtonLib99;
	 estRow[99]->pushbutton = ui->pushButtonEst99;
	 estRow[99]->col[1] = ui->est991;
	 estRow[99]->col[2] = ui->est992;
	 estRow[99]->col[3] = ui->est993;
	 estRow[99]->col[4] = ui->est994;
	 estRow[99]->col[5] = ui->est995;
	 estRow[99]->col[6] = ui->est996;
	 estRow[99]->col[7] = ui->est997;


	 libRow[100]->col[1] = ui->lib1001;
	 libRow[100]->col[2] = ui->lib1002;
	 libRow[100]->col[3] = ui->lib1003;
	 libRow[100]->col[4] = ui->lib1004;

	 libRow[100]->pushbutton = ui->pushButtonLib100;
	 estRow[100]->pushbutton = ui->pushButtonEst100;
	 estRow[100]->col[1] = ui->est1001;
	 estRow[100]->col[2] = ui->est1002;
	 estRow[100]->col[3] = ui->est1003;
	 estRow[100]->col[4] = ui->est1004;
	 estRow[100]->col[5] = ui->est1005;
	 estRow[100]->col[6] = ui->est1006;
	 estRow[100]->col[7] = ui->est1007;


	 libRow[101]->col[1] = ui->lib1011;
	 libRow[101]->col[2] = ui->lib1012;
	 libRow[101]->col[3] = ui->lib1013;
	 libRow[101]->col[4] = ui->lib1014;

	 libRow[101]->pushbutton = ui->pushButtonLib101;
	 estRow[101]->pushbutton = ui->pushButtonEst101;
	 estRow[101]->col[1] = ui->est1011;
	 estRow[101]->col[2] = ui->est1012;
	 estRow[101]->col[3] = ui->est1013;
	 estRow[101]->col[4] = ui->est1014;
	 estRow[101]->col[5] = ui->est1015;
	 estRow[101]->col[6] = ui->est1016;
	 estRow[101]->col[7] = ui->est1017;


	 libRow[102]->col[1] = ui->lib1021;
	 libRow[102]->col[2] = ui->lib1022;
	 libRow[102]->col[3] = ui->lib1023;
	 libRow[102]->col[4] = ui->lib1024;

	 libRow[102]->pushbutton = ui->pushButtonLib102;
	 estRow[102]->pushbutton = ui->pushButtonEst102;
	 estRow[102]->col[1] = ui->est1021;
	 estRow[102]->col[2] = ui->est1022;
	 estRow[102]->col[3] = ui->est1023;
	 estRow[102]->col[4] = ui->est1024;
	 estRow[102]->col[5] = ui->est1025;
	 estRow[102]->col[6] = ui->est1026;
	 estRow[102]->col[7] = ui->est1027;


	 libRow[103]->col[1] = ui->lib1031;
	 libRow[103]->col[2] = ui->lib1032;
	 libRow[103]->col[3] = ui->lib1033;
	 libRow[103]->col[4] = ui->lib1034;

	 libRow[103]->pushbutton = ui->pushButtonLib103;
	 estRow[103]->pushbutton = ui->pushButtonEst103;
	 estRow[103]->col[1] = ui->est1031;
	 estRow[103]->col[2] = ui->est1032;
	 estRow[103]->col[3] = ui->est1033;
	 estRow[103]->col[4] = ui->est1034;
	 estRow[103]->col[5] = ui->est1035;
	 estRow[103]->col[6] = ui->est1036;
	 estRow[103]->col[7] = ui->est1037;


	 libRow[104]->col[1] = ui->lib1041;
	 libRow[104]->col[2] = ui->lib1042;
	 libRow[104]->col[3] = ui->lib1043;
	 libRow[104]->col[4] = ui->lib1044;

	 libRow[104]->pushbutton = ui->pushButtonLib104;
	 estRow[104]->pushbutton = ui->pushButtonEst104;
	 estRow[104]->col[1] = ui->est1041;
	 estRow[104]->col[2] = ui->est1042;
	 estRow[104]->col[3] = ui->est1043;
	 estRow[104]->col[4] = ui->est1044;
	 estRow[104]->col[5] = ui->est1045;
	 estRow[104]->col[6] = ui->est1046;
	 estRow[104]->col[7] = ui->est1047;


	 libRow[105]->col[1] = ui->lib1051;
	 libRow[105]->col[2] = ui->lib1052;
	 libRow[105]->col[3] = ui->lib1053;
	 libRow[105]->col[4] = ui->lib1054;

	 libRow[105]->pushbutton = ui->pushButtonLib105;
	 estRow[105]->pushbutton = ui->pushButtonEst105;
	 estRow[105]->col[1] = ui->est1051;
	 estRow[105]->col[2] = ui->est1052;
	 estRow[105]->col[3] = ui->est1053;
	 estRow[105]->col[4] = ui->est1054;
	 estRow[105]->col[5] = ui->est1055;
	 estRow[105]->col[6] = ui->est1056;
	 estRow[105]->col[7] = ui->est1057;


	 libRow[106]->col[1] = ui->lib1061;
	 libRow[106]->col[2] = ui->lib1062;
	 libRow[106]->col[3] = ui->lib1063;
	 libRow[106]->col[4] = ui->lib1064;

	 libRow[106]->pushbutton = ui->pushButtonLib106;
	 estRow[106]->pushbutton = ui->pushButtonEst106;
	 estRow[106]->col[1] = ui->est1061;
	 estRow[106]->col[2] = ui->est1062;
	 estRow[106]->col[3] = ui->est1063;
	 estRow[106]->col[4] = ui->est1064;
	 estRow[106]->col[5] = ui->est1065;
	 estRow[106]->col[6] = ui->est1066;
	 estRow[106]->col[7] = ui->est1067;


	 libRow[107]->col[1] = ui->lib1071;
	 libRow[107]->col[2] = ui->lib1072;
	 libRow[107]->col[3] = ui->lib1073;
	 libRow[107]->col[4] = ui->lib1074;

	 libRow[107]->pushbutton = ui->pushButtonLib107;
	 estRow[107]->pushbutton = ui->pushButtonEst107;
	 estRow[107]->col[1] = ui->est1071;
	 estRow[107]->col[2] = ui->est1072;
	 estRow[107]->col[3] = ui->est1073;
	 estRow[107]->col[4] = ui->est1074;
	 estRow[107]->col[5] = ui->est1075;
	 estRow[107]->col[6] = ui->est1076;
	 estRow[107]->col[7] = ui->est1077;


	 libRow[108]->col[1] = ui->lib1081;
	 libRow[108]->col[2] = ui->lib1082;
	 libRow[108]->col[3] = ui->lib1083;
	 libRow[108]->col[4] = ui->lib1084;

	 libRow[108]->pushbutton = ui->pushButtonLib108;
	 estRow[108]->pushbutton = ui->pushButtonEst108;
	 estRow[108]->col[1] = ui->est1081;
	 estRow[108]->col[2] = ui->est1082;
	 estRow[108]->col[3] = ui->est1083;
	 estRow[108]->col[4] = ui->est1084;
	 estRow[108]->col[5] = ui->est1085;
	 estRow[108]->col[6] = ui->est1086;
	 estRow[108]->col[7] = ui->est1087;


	 libRow[109]->col[1] = ui->lib1091;
	 libRow[109]->col[2] = ui->lib1092;
	 libRow[109]->col[3] = ui->lib1093;
	 libRow[109]->col[4] = ui->lib1094;

	 libRow[109]->pushbutton = ui->pushButtonLib109;
	 estRow[109]->pushbutton = ui->pushButtonEst109;
	 estRow[109]->col[1] = ui->est1091;
	 estRow[109]->col[2] = ui->est1092;
	 estRow[109]->col[3] = ui->est1093;
	 estRow[109]->col[4] = ui->est1094;
	 estRow[109]->col[5] = ui->est1095;
	 estRow[109]->col[6] = ui->est1096;
	 estRow[109]->col[7] = ui->est1097;


	 libRow[110]->col[1] = ui->lib1101;
	 libRow[110]->col[2] = ui->lib1102;
	 libRow[110]->col[3] = ui->lib1103;
	 libRow[110]->col[4] = ui->lib1104;

	 libRow[110]->pushbutton = ui->pushButtonLib110;
	 estRow[110]->pushbutton = ui->pushButtonEst110;
	 estRow[110]->col[1] = ui->est1101;
	 estRow[110]->col[2] = ui->est1102;
	 estRow[110]->col[3] = ui->est1103;
	 estRow[110]->col[4] = ui->est1104;
	 estRow[110]->col[5] = ui->est1105;
	 estRow[110]->col[6] = ui->est1106;
	 estRow[110]->col[7] = ui->est1107;


	 libRow[111]->col[1] = ui->lib1111;
	 libRow[111]->col[2] = ui->lib1112;
	 libRow[111]->col[3] = ui->lib1113;
	 libRow[111]->col[4] = ui->lib1114;

	 libRow[111]->pushbutton = ui->pushButtonLib111;
	 estRow[111]->pushbutton = ui->pushButtonEst111;
	 estRow[111]->col[1] = ui->est1111;
	 estRow[111]->col[2] = ui->est1112;
	 estRow[111]->col[3] = ui->est1113;
	 estRow[111]->col[4] = ui->est1114;
	 estRow[111]->col[5] = ui->est1115;
	 estRow[111]->col[6] = ui->est1116;
	 estRow[111]->col[7] = ui->est1117;


	 libRow[112]->col[1] = ui->lib1121;
	 libRow[112]->col[2] = ui->lib1122;
	 libRow[112]->col[3] = ui->lib1123;
	 libRow[112]->col[4] = ui->lib1124;

	 libRow[112]->pushbutton = ui->pushButtonLib112;
	 estRow[112]->pushbutton = ui->pushButtonEst112;
	 estRow[112]->col[1] = ui->est1121;
	 estRow[112]->col[2] = ui->est1122;
	 estRow[112]->col[3] = ui->est1123;
	 estRow[112]->col[4] = ui->est1124;
	 estRow[112]->col[5] = ui->est1125;
	 estRow[112]->col[6] = ui->est1126;
	 estRow[112]->col[7] = ui->est1127;


	 libRow[113]->col[1] = ui->lib1131;
	 libRow[113]->col[2] = ui->lib1132;
	 libRow[113]->col[3] = ui->lib1133;
	 libRow[113]->col[4] = ui->lib1134;

	 libRow[113]->pushbutton = ui->pushButtonLib113;
	 estRow[113]->pushbutton = ui->pushButtonEst113;
	 estRow[113]->col[1] = ui->est1131;
	 estRow[113]->col[2] = ui->est1132;
	 estRow[113]->col[3] = ui->est1133;
	 estRow[113]->col[4] = ui->est1134;
	 estRow[113]->col[5] = ui->est1135;
	 estRow[113]->col[6] = ui->est1136;
	 estRow[113]->col[7] = ui->est1137;


	 libRow[114]->col[1] = ui->lib1141;
	 libRow[114]->col[2] = ui->lib1142;
	 libRow[114]->col[3] = ui->lib1143;
	 libRow[114]->col[4] = ui->lib1144;

	 libRow[114]->pushbutton = ui->pushButtonLib114;
	 estRow[114]->pushbutton = ui->pushButtonEst114;
	 estRow[114]->col[1] = ui->est1141;
	 estRow[114]->col[2] = ui->est1142;
	 estRow[114]->col[3] = ui->est1143;
	 estRow[114]->col[4] = ui->est1144;
	 estRow[114]->col[5] = ui->est1145;
	 estRow[114]->col[6] = ui->est1146;
	 estRow[114]->col[7] = ui->est1147;


	 libRow[115]->col[1] = ui->lib1151;
	 libRow[115]->col[2] = ui->lib1152;
	 libRow[115]->col[3] = ui->lib1153;
	 libRow[115]->col[4] = ui->lib1154;

	 libRow[115]->pushbutton = ui->pushButtonLib115;
	 estRow[115]->pushbutton = ui->pushButtonEst115;
	 estRow[115]->col[1] = ui->est1151;
	 estRow[115]->col[2] = ui->est1152;
	 estRow[115]->col[3] = ui->est1153;
	 estRow[115]->col[4] = ui->est1154;
	 estRow[115]->col[5] = ui->est1155;
	 estRow[115]->col[6] = ui->est1156;
	 estRow[115]->col[7] = ui->est1157;


	 libRow[116]->col[1] = ui->lib1161;
	 libRow[116]->col[2] = ui->lib1162;
	 libRow[116]->col[3] = ui->lib1163;
	 libRow[116]->col[4] = ui->lib1164;

	 libRow[116]->pushbutton = ui->pushButtonLib116;
	 estRow[116]->pushbutton = ui->pushButtonEst116;
	 estRow[116]->col[1] = ui->est1161;
	 estRow[116]->col[2] = ui->est1162;
	 estRow[116]->col[3] = ui->est1163;
	 estRow[116]->col[4] = ui->est1164;
	 estRow[116]->col[5] = ui->est1165;
	 estRow[116]->col[6] = ui->est1166;
	 estRow[116]->col[7] = ui->est1167;


	 libRow[117]->col[1] = ui->lib1171;
	 libRow[117]->col[2] = ui->lib1172;
	 libRow[117]->col[3] = ui->lib1173;
	 libRow[117]->col[4] = ui->lib1174;

	 libRow[117]->pushbutton = ui->pushButtonLib117;
	 estRow[117]->pushbutton = ui->pushButtonEst117;
	 estRow[117]->col[1] = ui->est1171;
	 estRow[117]->col[2] = ui->est1172;
	 estRow[117]->col[3] = ui->est1173;
	 estRow[117]->col[4] = ui->est1174;
	 estRow[117]->col[5] = ui->est1175;
	 estRow[117]->col[6] = ui->est1176;
	 estRow[117]->col[7] = ui->est1177;


	 libRow[118]->col[1] = ui->lib1181;
	 libRow[118]->col[2] = ui->lib1182;
	 libRow[118]->col[3] = ui->lib1183;
	 libRow[118]->col[4] = ui->lib1184;

	 libRow[118]->pushbutton = ui->pushButtonLib118;
	 estRow[118]->pushbutton = ui->pushButtonEst118;
	 estRow[118]->col[1] = ui->est1181;
	 estRow[118]->col[2] = ui->est1182;
	 estRow[118]->col[3] = ui->est1183;
	 estRow[118]->col[4] = ui->est1184;
	 estRow[118]->col[5] = ui->est1185;
	 estRow[118]->col[6] = ui->est1186;
	 estRow[118]->col[7] = ui->est1187;


	 libRow[119]->col[1] = ui->lib1191;
	 libRow[119]->col[2] = ui->lib1192;
	 libRow[119]->col[3] = ui->lib1193;
	 libRow[119]->col[4] = ui->lib1194;

	 libRow[119]->pushbutton = ui->pushButtonLib119;
	 estRow[119]->pushbutton = ui->pushButtonEst119;
	 estRow[119]->col[1] = ui->est1191;
	 estRow[119]->col[2] = ui->est1192;
	 estRow[119]->col[3] = ui->est1193;
	 estRow[119]->col[4] = ui->est1194;
	 estRow[119]->col[5] = ui->est1195;
	 estRow[119]->col[6] = ui->est1196;
	 estRow[119]->col[7] = ui->est1197;


	 libRow[120]->col[1] = ui->lib1201;
	 libRow[120]->col[2] = ui->lib1202;
	 libRow[120]->col[3] = ui->lib1203;
	 libRow[120]->col[4] = ui->lib1204;

	 libRow[120]->pushbutton = ui->pushButtonLib120;
	 estRow[120]->pushbutton = ui->pushButtonEst120;
	 estRow[120]->col[1] = ui->est1201;
	 estRow[120]->col[2] = ui->est1202;
	 estRow[120]->col[3] = ui->est1203;
	 estRow[120]->col[4] = ui->est1204;
	 estRow[120]->col[5] = ui->est1205;
	 estRow[120]->col[6] = ui->est1206;
	 estRow[120]->col[7] = ui->est1207;


	 libRow[121]->col[1] = ui->lib1211;
	 libRow[121]->col[2] = ui->lib1212;
	 libRow[121]->col[3] = ui->lib1213;
	 libRow[121]->col[4] = ui->lib1214;

	 libRow[121]->pushbutton = ui->pushButtonLib121;
	 estRow[121]->pushbutton = ui->pushButtonEst121;
	 estRow[121]->col[1] = ui->est1211;
	 estRow[121]->col[2] = ui->est1212;
	 estRow[121]->col[3] = ui->est1213;
	 estRow[121]->col[4] = ui->est1214;
	 estRow[121]->col[5] = ui->est1215;
	 estRow[121]->col[6] = ui->est1216;
	 estRow[121]->col[7] = ui->est1217;


	 libRow[122]->col[1] = ui->lib1221;
	 libRow[122]->col[2] = ui->lib1222;
	 libRow[122]->col[3] = ui->lib1223;
	 libRow[122]->col[4] = ui->lib1224;

	 libRow[122]->pushbutton = ui->pushButtonLib122;
	 estRow[122]->pushbutton = ui->pushButtonEst122;
	 estRow[122]->col[1] = ui->est1221;
	 estRow[122]->col[2] = ui->est1222;
	 estRow[122]->col[3] = ui->est1223;
	 estRow[122]->col[4] = ui->est1224;
	 estRow[122]->col[5] = ui->est1225;
	 estRow[122]->col[6] = ui->est1226;
	 estRow[122]->col[7] = ui->est1227;


	 libRow[123]->col[1] = ui->lib1231;
	 libRow[123]->col[2] = ui->lib1232;
	 libRow[123]->col[3] = ui->lib1233;
	 libRow[123]->col[4] = ui->lib1234;

	 libRow[123]->pushbutton = ui->pushButtonLib123;
	 estRow[123]->pushbutton = ui->pushButtonEst123;
	 estRow[123]->col[1] = ui->est1231;
	 estRow[123]->col[2] = ui->est1232;
	 estRow[123]->col[3] = ui->est1233;
	 estRow[123]->col[4] = ui->est1234;
	 estRow[123]->col[5] = ui->est1235;
	 estRow[123]->col[6] = ui->est1236;
	 estRow[123]->col[7] = ui->est1237;


	 libRow[124]->col[1] = ui->lib1241;
	 libRow[124]->col[2] = ui->lib1242;
	 libRow[124]->col[3] = ui->lib1243;
	 libRow[124]->col[4] = ui->lib1244;

	 libRow[124]->pushbutton = ui->pushButtonLib124;
	 estRow[124]->pushbutton = ui->pushButtonEst124;
	 estRow[124]->col[1] = ui->est1241;
	 estRow[124]->col[2] = ui->est1242;
	 estRow[124]->col[3] = ui->est1243;
	 estRow[124]->col[4] = ui->est1244;
	 estRow[124]->col[5] = ui->est1245;
	 estRow[124]->col[6] = ui->est1246;
	 estRow[124]->col[7] = ui->est1247;


	 libRow[125]->col[1] = ui->lib1251;
	 libRow[125]->col[2] = ui->lib1252;
	 libRow[125]->col[3] = ui->lib1253;
	 libRow[125]->col[4] = ui->lib1254;

	 libRow[125]->pushbutton = ui->pushButtonLib125;
	 estRow[125]->pushbutton = ui->pushButtonEst125;
	 estRow[125]->col[1] = ui->est1251;
	 estRow[125]->col[2] = ui->est1252;
	 estRow[125]->col[3] = ui->est1253;
	 estRow[125]->col[4] = ui->est1254;
	 estRow[125]->col[5] = ui->est1255;
	 estRow[125]->col[6] = ui->est1256;
	 estRow[125]->col[7] = ui->est1257;


	 libRow[126]->col[1] = ui->lib1261;
	 libRow[126]->col[2] = ui->lib1262;
	 libRow[126]->col[3] = ui->lib1263;
	 libRow[126]->col[4] = ui->lib1264;

	 libRow[126]->pushbutton = ui->pushButtonLib126;
	 estRow[126]->pushbutton = ui->pushButtonEst126;
	 estRow[126]->col[1] = ui->est1261;
	 estRow[126]->col[2] = ui->est1262;
	 estRow[126]->col[3] = ui->est1263;
	 estRow[126]->col[4] = ui->est1264;
	 estRow[126]->col[5] = ui->est1265;
	 estRow[126]->col[6] = ui->est1266;
	 estRow[126]->col[7] = ui->est1267;


	 libRow[127]->col[1] = ui->lib1271;
	 libRow[127]->col[2] = ui->lib1272;
	 libRow[127]->col[3] = ui->lib1273;
	 libRow[127]->col[4] = ui->lib1274;

	 libRow[127]->pushbutton = ui->pushButtonLib127;
	 estRow[127]->pushbutton = ui->pushButtonEst127;
	 estRow[127]->col[1] = ui->est1271;
	 estRow[127]->col[2] = ui->est1272;
	 estRow[127]->col[3] = ui->est1273;
	 estRow[127]->col[4] = ui->est1274;
	 estRow[127]->col[5] = ui->est1275;
	 estRow[127]->col[6] = ui->est1276;
	 estRow[127]->col[7] = ui->est1277;


	 libRow[128]->col[1] = ui->lib1281;
	 libRow[128]->col[2] = ui->lib1282;
	 libRow[128]->col[3] = ui->lib1283;
	 libRow[128]->col[4] = ui->lib1284;

	 libRow[128]->pushbutton = ui->pushButtonLib128;
	 estRow[128]->pushbutton = ui->pushButtonEst128;
	 estRow[128]->col[1] = ui->est1281;
	 estRow[128]->col[2] = ui->est1282;
	 estRow[128]->col[3] = ui->est1283;
	 estRow[128]->col[4] = ui->est1284;
	 estRow[128]->col[5] = ui->est1285;
	 estRow[128]->col[6] = ui->est1286;
	 estRow[128]->col[7] = ui->est1287;


	 libRow[129]->col[1] = ui->lib1291;
	 libRow[129]->col[2] = ui->lib1292;
	 libRow[129]->col[3] = ui->lib1293;
	 libRow[129]->col[4] = ui->lib1294;

	 libRow[129]->pushbutton = ui->pushButtonLib129;
	 estRow[129]->pushbutton = ui->pushButtonEst129;
	 estRow[129]->col[1] = ui->est1291;
	 estRow[129]->col[2] = ui->est1292;
	 estRow[129]->col[3] = ui->est1293;
	 estRow[129]->col[4] = ui->est1294;
	 estRow[129]->col[5] = ui->est1295;
	 estRow[129]->col[6] = ui->est1296;
	 estRow[129]->col[7] = ui->est1297;


	 libRow[130]->col[1] = ui->lib1301;
	 libRow[130]->col[2] = ui->lib1302;
	 libRow[130]->col[3] = ui->lib1303;
	 libRow[130]->col[4] = ui->lib1304;

	 libRow[130]->pushbutton = ui->pushButtonLib130;
	 estRow[130]->pushbutton = ui->pushButtonEst130;
	 estRow[130]->col[1] = ui->est1301;
	 estRow[130]->col[2] = ui->est1302;
	 estRow[130]->col[3] = ui->est1303;
	 estRow[130]->col[4] = ui->est1304;
	 estRow[130]->col[5] = ui->est1305;
	 estRow[130]->col[6] = ui->est1306;
	 estRow[130]->col[7] = ui->est1307;


	 libRow[131]->col[1] = ui->lib1311;
	 libRow[131]->col[2] = ui->lib1312;
	 libRow[131]->col[3] = ui->lib1313;
	 libRow[131]->col[4] = ui->lib1314;

	 libRow[131]->pushbutton = ui->pushButtonLib131;
	 estRow[131]->pushbutton = ui->pushButtonEst131;
	 estRow[131]->col[1] = ui->est1311;
	 estRow[131]->col[2] = ui->est1312;
	 estRow[131]->col[3] = ui->est1313;
	 estRow[131]->col[4] = ui->est1314;
	 estRow[131]->col[5] = ui->est1315;
	 estRow[131]->col[6] = ui->est1316;
	 estRow[131]->col[7] = ui->est1317;


	 libRow[132]->col[1] = ui->lib1321;
	 libRow[132]->col[2] = ui->lib1322;
	 libRow[132]->col[3] = ui->lib1323;
	 libRow[132]->col[4] = ui->lib1324;

	 libRow[132]->pushbutton = ui->pushButtonLib132;
	 estRow[132]->pushbutton = ui->pushButtonEst132;
	 estRow[132]->col[1] = ui->est1321;
	 estRow[132]->col[2] = ui->est1322;
	 estRow[132]->col[3] = ui->est1323;
	 estRow[132]->col[4] = ui->est1324;
	 estRow[132]->col[5] = ui->est1325;
	 estRow[132]->col[6] = ui->est1326;
	 estRow[132]->col[7] = ui->est1327;


	 libRow[133]->col[1] = ui->lib1331;
	 libRow[133]->col[2] = ui->lib1332;
	 libRow[133]->col[3] = ui->lib1333;
	 libRow[133]->col[4] = ui->lib1334;

	 libRow[133]->pushbutton = ui->pushButtonLib133;
	 estRow[133]->pushbutton = ui->pushButtonEst133;
	 estRow[133]->col[1] = ui->est1331;
	 estRow[133]->col[2] = ui->est1332;
	 estRow[133]->col[3] = ui->est1333;
	 estRow[133]->col[4] = ui->est1334;
	 estRow[133]->col[5] = ui->est1335;
	 estRow[133]->col[6] = ui->est1336;
	 estRow[133]->col[7] = ui->est1337;


	 libRow[134]->col[1] = ui->lib1341;
	 libRow[134]->col[2] = ui->lib1342;
	 libRow[134]->col[3] = ui->lib1343;
	 libRow[134]->col[4] = ui->lib1344;

	 libRow[134]->pushbutton = ui->pushButtonLib134;
	 estRow[134]->pushbutton = ui->pushButtonEst134;
	 estRow[134]->col[1] = ui->est1341;
	 estRow[134]->col[2] = ui->est1342;
	 estRow[134]->col[3] = ui->est1343;
	 estRow[134]->col[4] = ui->est1344;
	 estRow[134]->col[5] = ui->est1345;
	 estRow[134]->col[6] = ui->est1346;
	 estRow[134]->col[7] = ui->est1347;


	 libRow[135]->col[1] = ui->lib1351;
	 libRow[135]->col[2] = ui->lib1352;
	 libRow[135]->col[3] = ui->lib1353;
	 libRow[135]->col[4] = ui->lib1354;

	 libRow[135]->pushbutton = ui->pushButtonLib135;
	 estRow[135]->pushbutton = ui->pushButtonEst135;
	 estRow[135]->col[1] = ui->est1351;
	 estRow[135]->col[2] = ui->est1352;
	 estRow[135]->col[3] = ui->est1353;
	 estRow[135]->col[4] = ui->est1354;
	 estRow[135]->col[5] = ui->est1355;
	 estRow[135]->col[6] = ui->est1356;
	 estRow[135]->col[7] = ui->est1357;


	 libRow[136]->col[1] = ui->lib1361;
	 libRow[136]->col[2] = ui->lib1362;
	 libRow[136]->col[3] = ui->lib1363;
	 libRow[136]->col[4] = ui->lib1364;

	 libRow[136]->pushbutton = ui->pushButtonLib136;
	 estRow[136]->pushbutton = ui->pushButtonEst136;
	 estRow[136]->col[1] = ui->est1361;
	 estRow[136]->col[2] = ui->est1362;
	 estRow[136]->col[3] = ui->est1363;
	 estRow[136]->col[4] = ui->est1364;
	 estRow[136]->col[5] = ui->est1365;
	 estRow[136]->col[6] = ui->est1366;
	 estRow[136]->col[7] = ui->est1367;


	 libRow[137]->col[1] = ui->lib1371;
	 libRow[137]->col[2] = ui->lib1372;
	 libRow[137]->col[3] = ui->lib1373;
	 libRow[137]->col[4] = ui->lib1374;

	 libRow[137]->pushbutton = ui->pushButtonLib137;
	 estRow[137]->pushbutton = ui->pushButtonEst137;
	 estRow[137]->col[1] = ui->est1371;
	 estRow[137]->col[2] = ui->est1372;
	 estRow[137]->col[3] = ui->est1373;
	 estRow[137]->col[4] = ui->est1374;
	 estRow[137]->col[5] = ui->est1375;
	 estRow[137]->col[6] = ui->est1376;
	 estRow[137]->col[7] = ui->est1377;


	 libRow[138]->col[1] = ui->lib1381;
	 libRow[138]->col[2] = ui->lib1382;
	 libRow[138]->col[3] = ui->lib1383;
	 libRow[138]->col[4] = ui->lib1384;

	 libRow[138]->pushbutton = ui->pushButtonLib138;
	 estRow[138]->pushbutton = ui->pushButtonEst138;
	 estRow[138]->col[1] = ui->est1381;
	 estRow[138]->col[2] = ui->est1382;
	 estRow[138]->col[3] = ui->est1383;
	 estRow[138]->col[4] = ui->est1384;
	 estRow[138]->col[5] = ui->est1385;
	 estRow[138]->col[6] = ui->est1386;
	 estRow[138]->col[7] = ui->est1387;


	 libRow[139]->col[1] = ui->lib1391;
	 libRow[139]->col[2] = ui->lib1392;
	 libRow[139]->col[3] = ui->lib1393;
	 libRow[139]->col[4] = ui->lib1394;

	 libRow[139]->pushbutton = ui->pushButtonLib139;
	 estRow[139]->pushbutton = ui->pushButtonEst139;
	 estRow[139]->col[1] = ui->est1391;
	 estRow[139]->col[2] = ui->est1392;
	 estRow[139]->col[3] = ui->est1393;
	 estRow[139]->col[4] = ui->est1394;
	 estRow[139]->col[5] = ui->est1395;
	 estRow[139]->col[6] = ui->est1396;
	 estRow[139]->col[7] = ui->est1397;


	 libRow[140]->col[1] = ui->lib1401;
	 libRow[140]->col[2] = ui->lib1402;
	 libRow[140]->col[3] = ui->lib1403;
	 libRow[140]->col[4] = ui->lib1404;

	 libRow[140]->pushbutton = ui->pushButtonLib140;
	 estRow[140]->pushbutton = ui->pushButtonEst140;
	 estRow[140]->col[1] = ui->est1401;
	 estRow[140]->col[2] = ui->est1402;
	 estRow[140]->col[3] = ui->est1403;
	 estRow[140]->col[4] = ui->est1404;
	 estRow[140]->col[5] = ui->est1405;
	 estRow[140]->col[6] = ui->est1406;
	 estRow[140]->col[7] = ui->est1407;


	 libRow[141]->col[1] = ui->lib1411;
	 libRow[141]->col[2] = ui->lib1412;
	 libRow[141]->col[3] = ui->lib1413;
	 libRow[141]->col[4] = ui->lib1414;

	 libRow[141]->pushbutton = ui->pushButtonLib141;
	 estRow[141]->pushbutton = ui->pushButtonEst141;
	 estRow[141]->col[1] = ui->est1411;
	 estRow[141]->col[2] = ui->est1412;
	 estRow[141]->col[3] = ui->est1413;
	 estRow[141]->col[4] = ui->est1414;
	 estRow[141]->col[5] = ui->est1415;
	 estRow[141]->col[6] = ui->est1416;
	 estRow[141]->col[7] = ui->est1417;


	 libRow[142]->col[1] = ui->lib1421;
	 libRow[142]->col[2] = ui->lib1422;
	 libRow[142]->col[3] = ui->lib1423;
	 libRow[142]->col[4] = ui->lib1424;

	 libRow[142]->pushbutton = ui->pushButtonLib142;
	 estRow[142]->pushbutton = ui->pushButtonEst142;
	 estRow[142]->col[1] = ui->est1421;
	 estRow[142]->col[2] = ui->est1422;
	 estRow[142]->col[3] = ui->est1423;
	 estRow[142]->col[4] = ui->est1424;
	 estRow[142]->col[5] = ui->est1425;
	 estRow[142]->col[6] = ui->est1426;
	 estRow[142]->col[7] = ui->est1427;


	 libRow[143]->col[1] = ui->lib1431;
	 libRow[143]->col[2] = ui->lib1432;
	 libRow[143]->col[3] = ui->lib1433;
	 libRow[143]->col[4] = ui->lib1434;

	 libRow[143]->pushbutton = ui->pushButtonLib143;
	 estRow[143]->pushbutton = ui->pushButtonEst143;
	 estRow[143]->col[1] = ui->est1431;
	 estRow[143]->col[2] = ui->est1432;
	 estRow[143]->col[3] = ui->est1433;
	 estRow[143]->col[4] = ui->est1434;
	 estRow[143]->col[5] = ui->est1435;
	 estRow[143]->col[6] = ui->est1436;
	 estRow[143]->col[7] = ui->est1437;


	 libRow[144]->col[1] = ui->lib1441;
	 libRow[144]->col[2] = ui->lib1442;
	 libRow[144]->col[3] = ui->lib1443;
	 libRow[144]->col[4] = ui->lib1444;

	 libRow[144]->pushbutton = ui->pushButtonLib144;
	 estRow[144]->pushbutton = ui->pushButtonEst144;
	 estRow[144]->col[1] = ui->est1441;
	 estRow[144]->col[2] = ui->est1442;
	 estRow[144]->col[3] = ui->est1443;
	 estRow[144]->col[4] = ui->est1444;
	 estRow[144]->col[5] = ui->est1445;
	 estRow[144]->col[6] = ui->est1446;
	 estRow[144]->col[7] = ui->est1447;


	 libRow[145]->col[1] = ui->lib1451;
	 libRow[145]->col[2] = ui->lib1452;
	 libRow[145]->col[3] = ui->lib1453;
	 libRow[145]->col[4] = ui->lib1454;

	 libRow[145]->pushbutton = ui->pushButtonLib145;
	 estRow[145]->pushbutton = ui->pushButtonEst145;
	 estRow[145]->col[1] = ui->est1451;
	 estRow[145]->col[2] = ui->est1452;
	 estRow[145]->col[3] = ui->est1453;
	 estRow[145]->col[4] = ui->est1454;
	 estRow[145]->col[5] = ui->est1455;
	 estRow[145]->col[6] = ui->est1456;
	 estRow[145]->col[7] = ui->est1457;


	 libRow[146]->col[1] = ui->lib1461;
	 libRow[146]->col[2] = ui->lib1462;
	 libRow[146]->col[3] = ui->lib1463;
	 libRow[146]->col[4] = ui->lib1464;

	 libRow[146]->pushbutton = ui->pushButtonLib146;
	 estRow[146]->pushbutton = ui->pushButtonEst146;
	 estRow[146]->col[1] = ui->est1461;
	 estRow[146]->col[2] = ui->est1462;
	 estRow[146]->col[3] = ui->est1463;
	 estRow[146]->col[4] = ui->est1464;
	 estRow[146]->col[5] = ui->est1465;
	 estRow[146]->col[6] = ui->est1466;
	 estRow[146]->col[7] = ui->est1467;


	 libRow[147]->col[1] = ui->lib1471;
	 libRow[147]->col[2] = ui->lib1472;
	 libRow[147]->col[3] = ui->lib1473;
	 libRow[147]->col[4] = ui->lib1474;

	 libRow[147]->pushbutton = ui->pushButtonLib147;
	 estRow[147]->pushbutton = ui->pushButtonEst147;
	 estRow[147]->col[1] = ui->est1471;
	 estRow[147]->col[2] = ui->est1472;
	 estRow[147]->col[3] = ui->est1473;
	 estRow[147]->col[4] = ui->est1474;
	 estRow[147]->col[5] = ui->est1475;
	 estRow[147]->col[6] = ui->est1476;
	 estRow[147]->col[7] = ui->est1477;


	 libRow[148]->col[1] = ui->lib1481;
	 libRow[148]->col[2] = ui->lib1482;
	 libRow[148]->col[3] = ui->lib1483;
	 libRow[148]->col[4] = ui->lib1484;

	 libRow[148]->pushbutton = ui->pushButtonLib148;
	 estRow[148]->pushbutton = ui->pushButtonEst148;
	 estRow[148]->col[1] = ui->est1481;
	 estRow[148]->col[2] = ui->est1482;
	 estRow[148]->col[3] = ui->est1483;
	 estRow[148]->col[4] = ui->est1484;
	 estRow[148]->col[5] = ui->est1485;
	 estRow[148]->col[6] = ui->est1486;
	 estRow[148]->col[7] = ui->est1487;


	 libRow[149]->col[1] = ui->lib1491;
	 libRow[149]->col[2] = ui->lib1492;
	 libRow[149]->col[3] = ui->lib1493;
	 libRow[149]->col[4] = ui->lib1494;

	 libRow[149]->pushbutton = ui->pushButtonLib149;
	 estRow[149]->pushbutton = ui->pushButtonEst149;
	 estRow[149]->col[1] = ui->est1491;
	 estRow[149]->col[2] = ui->est1492;
	 estRow[149]->col[3] = ui->est1493;
	 estRow[149]->col[4] = ui->est1494;
	 estRow[149]->col[5] = ui->est1495;
	 estRow[149]->col[6] = ui->est1496;
	 estRow[149]->col[7] = ui->est1497;


	 libRow[150]->col[1] = ui->lib1501;
	 libRow[150]->col[2] = ui->lib1502;
	 libRow[150]->col[3] = ui->lib1503;
	 libRow[150]->col[4] = ui->lib1504;

	 libRow[150]->pushbutton = ui->pushButtonLib150;
	 estRow[150]->pushbutton = ui->pushButtonEst150;
	 estRow[150]->col[1] = ui->est1501;
	 estRow[150]->col[2] = ui->est1502;
	 estRow[150]->col[3] = ui->est1503;
	 estRow[150]->col[4] = ui->est1504;
	 estRow[150]->col[5] = ui->est1505;
	 estRow[150]->col[6] = ui->est1506;
	 estRow[150]->col[7] = ui->est1507;


	 libRow[151]->col[1] = ui->lib1511;
	 libRow[151]->col[2] = ui->lib1512;
	 libRow[151]->col[3] = ui->lib1513;
	 libRow[151]->col[4] = ui->lib1514;

	 libRow[151]->pushbutton = ui->pushButtonLib151;
	 estRow[151]->pushbutton = ui->pushButtonEst151;
	 estRow[151]->col[1] = ui->est1511;
	 estRow[151]->col[2] = ui->est1512;
	 estRow[151]->col[3] = ui->est1513;
	 estRow[151]->col[4] = ui->est1514;
	 estRow[151]->col[5] = ui->est1515;
	 estRow[151]->col[6] = ui->est1516;
	 estRow[151]->col[7] = ui->est1517;


	 libRow[152]->col[1] = ui->lib1521;
	 libRow[152]->col[2] = ui->lib1522;
	 libRow[152]->col[3] = ui->lib1523;
	 libRow[152]->col[4] = ui->lib1524;

	 libRow[152]->pushbutton = ui->pushButtonLib152;
	 estRow[152]->pushbutton = ui->pushButtonEst152;
	 estRow[152]->col[1] = ui->est1521;
	 estRow[152]->col[2] = ui->est1522;
	 estRow[152]->col[3] = ui->est1523;
	 estRow[152]->col[4] = ui->est1524;
	 estRow[152]->col[5] = ui->est1525;
	 estRow[152]->col[6] = ui->est1526;
	 estRow[152]->col[7] = ui->est1527;


	 libRow[153]->col[1] = ui->lib1531;
	 libRow[153]->col[2] = ui->lib1532;
	 libRow[153]->col[3] = ui->lib1533;
	 libRow[153]->col[4] = ui->lib1534;

	 libRow[153]->pushbutton = ui->pushButtonLib153;
	 estRow[153]->pushbutton = ui->pushButtonEst153;
	 estRow[153]->col[1] = ui->est1531;
	 estRow[153]->col[2] = ui->est1532;
	 estRow[153]->col[3] = ui->est1533;
	 estRow[153]->col[4] = ui->est1534;
	 estRow[153]->col[5] = ui->est1535;
	 estRow[153]->col[6] = ui->est1536;
	 estRow[153]->col[7] = ui->est1537;


	 libRow[154]->col[1] = ui->lib1541;
	 libRow[154]->col[2] = ui->lib1542;
	 libRow[154]->col[3] = ui->lib1543;
	 libRow[154]->col[4] = ui->lib1544;

	 libRow[154]->pushbutton = ui->pushButtonLib154;
	 estRow[154]->pushbutton = ui->pushButtonEst154;
	 estRow[154]->col[1] = ui->est1541;
	 estRow[154]->col[2] = ui->est1542;
	 estRow[154]->col[3] = ui->est1543;
	 estRow[154]->col[4] = ui->est1544;
	 estRow[154]->col[5] = ui->est1545;
	 estRow[154]->col[6] = ui->est1546;
	 estRow[154]->col[7] = ui->est1547;


	 libRow[155]->col[1] = ui->lib1551;
	 libRow[155]->col[2] = ui->lib1552;
	 libRow[155]->col[3] = ui->lib1553;
	 libRow[155]->col[4] = ui->lib1554;

	 libRow[155]->pushbutton = ui->pushButtonLib155;
	 estRow[155]->pushbutton = ui->pushButtonEst155;
	 estRow[155]->col[1] = ui->est1551;
	 estRow[155]->col[2] = ui->est1552;
	 estRow[155]->col[3] = ui->est1553;
	 estRow[155]->col[4] = ui->est1554;
	 estRow[155]->col[5] = ui->est1555;
	 estRow[155]->col[6] = ui->est1556;
	 estRow[155]->col[7] = ui->est1557;


	 libRow[156]->col[1] = ui->lib1561;
	 libRow[156]->col[2] = ui->lib1562;
	 libRow[156]->col[3] = ui->lib1563;
	 libRow[156]->col[4] = ui->lib1564;

	 libRow[156]->pushbutton = ui->pushButtonLib156;
	 estRow[156]->pushbutton = ui->pushButtonEst156;
	 estRow[156]->col[1] = ui->est1561;
	 estRow[156]->col[2] = ui->est1562;
	 estRow[156]->col[3] = ui->est1563;
	 estRow[156]->col[4] = ui->est1564;
	 estRow[156]->col[5] = ui->est1565;
	 estRow[156]->col[6] = ui->est1566;
	 estRow[156]->col[7] = ui->est1567;


	 libRow[157]->col[1] = ui->lib1571;
	 libRow[157]->col[2] = ui->lib1572;
	 libRow[157]->col[3] = ui->lib1573;
	 libRow[157]->col[4] = ui->lib1574;

	 libRow[157]->pushbutton = ui->pushButtonLib157;
	 estRow[157]->pushbutton = ui->pushButtonEst157;
	 estRow[157]->col[1] = ui->est1571;
	 estRow[157]->col[2] = ui->est1572;
	 estRow[157]->col[3] = ui->est1573;
	 estRow[157]->col[4] = ui->est1574;
	 estRow[157]->col[5] = ui->est1575;
	 estRow[157]->col[6] = ui->est1576;
	 estRow[157]->col[7] = ui->est1577;


	 libRow[158]->col[1] = ui->lib1581;
	 libRow[158]->col[2] = ui->lib1582;
	 libRow[158]->col[3] = ui->lib1583;
	 libRow[158]->col[4] = ui->lib1584;

	 libRow[158]->pushbutton = ui->pushButtonLib158;
	 estRow[158]->pushbutton = ui->pushButtonEst158;
	 estRow[158]->col[1] = ui->est1581;
	 estRow[158]->col[2] = ui->est1582;
	 estRow[158]->col[3] = ui->est1583;
	 estRow[158]->col[4] = ui->est1584;
	 estRow[158]->col[5] = ui->est1585;
	 estRow[158]->col[6] = ui->est1586;
	 estRow[158]->col[7] = ui->est1587;


	 libRow[159]->col[1] = ui->lib1591;
	 libRow[159]->col[2] = ui->lib1592;
	 libRow[159]->col[3] = ui->lib1593;
	 libRow[159]->col[4] = ui->lib1594;

	 libRow[159]->pushbutton = ui->pushButtonLib159;
	 estRow[159]->pushbutton = ui->pushButtonEst159;
	 estRow[159]->col[1] = ui->est1591;
	 estRow[159]->col[2] = ui->est1592;
	 estRow[159]->col[3] = ui->est1593;
	 estRow[159]->col[4] = ui->est1594;
	 estRow[159]->col[5] = ui->est1595;
	 estRow[159]->col[6] = ui->est1596;
	 estRow[159]->col[7] = ui->est1597;


	 libRow[160]->col[1] = ui->lib1601;
	 libRow[160]->col[2] = ui->lib1602;
	 libRow[160]->col[3] = ui->lib1603;
	 libRow[160]->col[4] = ui->lib1604;

	 libRow[160]->pushbutton = ui->pushButtonLib160;
	 estRow[160]->pushbutton = ui->pushButtonEst160;
	 estRow[160]->col[1] = ui->est1601;
	 estRow[160]->col[2] = ui->est1602;
	 estRow[160]->col[3] = ui->est1603;
	 estRow[160]->col[4] = ui->est1604;
	 estRow[160]->col[5] = ui->est1605;
	 estRow[160]->col[6] = ui->est1606;
	 estRow[160]->col[7] = ui->est1607;


	 libRow[161]->col[1] = ui->lib1611;
	 libRow[161]->col[2] = ui->lib1612;
	 libRow[161]->col[3] = ui->lib1613;
	 libRow[161]->col[4] = ui->lib1614;

	 libRow[161]->pushbutton = ui->pushButtonLib161;
	 estRow[161]->pushbutton = ui->pushButtonEst161;
	 estRow[161]->col[1] = ui->est1611;
	 estRow[161]->col[2] = ui->est1612;
	 estRow[161]->col[3] = ui->est1613;
	 estRow[161]->col[4] = ui->est1614;
	 estRow[161]->col[5] = ui->est1615;
	 estRow[161]->col[6] = ui->est1616;
	 estRow[161]->col[7] = ui->est1617;


	 libRow[162]->col[1] = ui->lib1621;
	 libRow[162]->col[2] = ui->lib1622;
	 libRow[162]->col[3] = ui->lib1623;
	 libRow[162]->col[4] = ui->lib1624;

	 libRow[162]->pushbutton = ui->pushButtonLib162;
	 estRow[162]->pushbutton = ui->pushButtonEst162;
	 estRow[162]->col[1] = ui->est1621;
	 estRow[162]->col[2] = ui->est1622;
	 estRow[162]->col[3] = ui->est1623;
	 estRow[162]->col[4] = ui->est1624;
	 estRow[162]->col[5] = ui->est1625;
	 estRow[162]->col[6] = ui->est1626;
	 estRow[162]->col[7] = ui->est1627;


	 libRow[163]->col[1] = ui->lib1631;
	 libRow[163]->col[2] = ui->lib1632;
	 libRow[163]->col[3] = ui->lib1633;
	 libRow[163]->col[4] = ui->lib1634;

	 libRow[163]->pushbutton = ui->pushButtonLib163;
	 estRow[163]->pushbutton = ui->pushButtonEst163;
	 estRow[163]->col[1] = ui->est1631;
	 estRow[163]->col[2] = ui->est1632;
	 estRow[163]->col[3] = ui->est1633;
	 estRow[163]->col[4] = ui->est1634;
	 estRow[163]->col[5] = ui->est1635;
	 estRow[163]->col[6] = ui->est1636;
	 estRow[163]->col[7] = ui->est1637;


	 libRow[164]->col[1] = ui->lib1641;
	 libRow[164]->col[2] = ui->lib1642;
	 libRow[164]->col[3] = ui->lib1643;
	 libRow[164]->col[4] = ui->lib1644;

	 libRow[164]->pushbutton = ui->pushButtonLib164;
	 estRow[164]->pushbutton = ui->pushButtonEst164;
	 estRow[164]->col[1] = ui->est1641;
	 estRow[164]->col[2] = ui->est1642;
	 estRow[164]->col[3] = ui->est1643;
	 estRow[164]->col[4] = ui->est1644;
	 estRow[164]->col[5] = ui->est1645;
	 estRow[164]->col[6] = ui->est1646;
	 estRow[164]->col[7] = ui->est1647;


	 libRow[165]->col[1] = ui->lib1651;
	 libRow[165]->col[2] = ui->lib1652;
	 libRow[165]->col[3] = ui->lib1653;
	 libRow[165]->col[4] = ui->lib1654;

	 libRow[165]->pushbutton = ui->pushButtonLib165;
	 estRow[165]->pushbutton = ui->pushButtonEst165;
	 estRow[165]->col[1] = ui->est1651;
	 estRow[165]->col[2] = ui->est1652;
	 estRow[165]->col[3] = ui->est1653;
	 estRow[165]->col[4] = ui->est1654;
	 estRow[165]->col[5] = ui->est1655;
	 estRow[165]->col[6] = ui->est1656;
	 estRow[165]->col[7] = ui->est1657;


	 libRow[166]->col[1] = ui->lib1661;
	 libRow[166]->col[2] = ui->lib1662;
	 libRow[166]->col[3] = ui->lib1663;
	 libRow[166]->col[4] = ui->lib1664;

	 libRow[166]->pushbutton = ui->pushButtonLib166;
	 estRow[166]->pushbutton = ui->pushButtonEst166;
	 estRow[166]->col[1] = ui->est1661;
	 estRow[166]->col[2] = ui->est1662;
	 estRow[166]->col[3] = ui->est1663;
	 estRow[166]->col[4] = ui->est1664;
	 estRow[166]->col[5] = ui->est1665;
	 estRow[166]->col[6] = ui->est1666;
	 estRow[166]->col[7] = ui->est1667;


	 libRow[167]->col[1] = ui->lib1671;
	 libRow[167]->col[2] = ui->lib1672;
	 libRow[167]->col[3] = ui->lib1673;
	 libRow[167]->col[4] = ui->lib1674;

	 libRow[167]->pushbutton = ui->pushButtonLib167;
	 estRow[167]->pushbutton = ui->pushButtonEst167;
	 estRow[167]->col[1] = ui->est1671;
	 estRow[167]->col[2] = ui->est1672;
	 estRow[167]->col[3] = ui->est1673;
	 estRow[167]->col[4] = ui->est1674;
	 estRow[167]->col[5] = ui->est1675;
	 estRow[167]->col[6] = ui->est1676;
	 estRow[167]->col[7] = ui->est1677;


	 libRow[168]->col[1] = ui->lib1681;
	 libRow[168]->col[2] = ui->lib1682;
	 libRow[168]->col[3] = ui->lib1683;
	 libRow[168]->col[4] = ui->lib1684;

	 libRow[168]->pushbutton = ui->pushButtonLib168;
	 estRow[168]->pushbutton = ui->pushButtonEst168;
	 estRow[168]->col[1] = ui->est1681;
	 estRow[168]->col[2] = ui->est1682;
	 estRow[168]->col[3] = ui->est1683;
	 estRow[168]->col[4] = ui->est1684;
	 estRow[168]->col[5] = ui->est1685;
	 estRow[168]->col[6] = ui->est1686;
	 estRow[168]->col[7] = ui->est1687;


	 libRow[169]->col[1] = ui->lib1691;
	 libRow[169]->col[2] = ui->lib1692;
	 libRow[169]->col[3] = ui->lib1693;
	 libRow[169]->col[4] = ui->lib1694;

	 libRow[169]->pushbutton = ui->pushButtonLib169;
	 estRow[169]->pushbutton = ui->pushButtonEst169;
	 estRow[169]->col[1] = ui->est1691;
	 estRow[169]->col[2] = ui->est1692;
	 estRow[169]->col[3] = ui->est1693;
	 estRow[169]->col[4] = ui->est1694;
	 estRow[169]->col[5] = ui->est1695;
	 estRow[169]->col[6] = ui->est1696;
	 estRow[169]->col[7] = ui->est1697;


	 libRow[170]->col[1] = ui->lib1701;
	 libRow[170]->col[2] = ui->lib1702;
	 libRow[170]->col[3] = ui->lib1703;
	 libRow[170]->col[4] = ui->lib1704;

	 libRow[170]->pushbutton = ui->pushButtonLib170;
	 estRow[170]->pushbutton = ui->pushButtonEst170;
	 estRow[170]->col[1] = ui->est1701;
	 estRow[170]->col[2] = ui->est1702;
	 estRow[170]->col[3] = ui->est1703;
	 estRow[170]->col[4] = ui->est1704;
	 estRow[170]->col[5] = ui->est1705;
	 estRow[170]->col[6] = ui->est1706;
	 estRow[170]->col[7] = ui->est1707;


	 libRow[171]->col[1] = ui->lib1711;
	 libRow[171]->col[2] = ui->lib1712;
	 libRow[171]->col[3] = ui->lib1713;
	 libRow[171]->col[4] = ui->lib1714;

	 libRow[171]->pushbutton = ui->pushButtonLib171;
	 estRow[171]->pushbutton = ui->pushButtonEst171;
	 estRow[171]->col[1] = ui->est1711;
	 estRow[171]->col[2] = ui->est1712;
	 estRow[171]->col[3] = ui->est1713;
	 estRow[171]->col[4] = ui->est1714;
	 estRow[171]->col[5] = ui->est1715;
	 estRow[171]->col[6] = ui->est1716;
	 estRow[171]->col[7] = ui->est1717;


	 libRow[172]->col[1] = ui->lib1721;
	 libRow[172]->col[2] = ui->lib1722;
	 libRow[172]->col[3] = ui->lib1723;
	 libRow[172]->col[4] = ui->lib1724;

	 libRow[172]->pushbutton = ui->pushButtonLib172;
	 estRow[172]->pushbutton = ui->pushButtonEst172;
	 estRow[172]->col[1] = ui->est1721;
	 estRow[172]->col[2] = ui->est1722;
	 estRow[172]->col[3] = ui->est1723;
	 estRow[172]->col[4] = ui->est1724;
	 estRow[172]->col[5] = ui->est1725;
	 estRow[172]->col[6] = ui->est1726;
	 estRow[172]->col[7] = ui->est1727;


	 libRow[173]->col[1] = ui->lib1731;
	 libRow[173]->col[2] = ui->lib1732;
	 libRow[173]->col[3] = ui->lib1733;
	 libRow[173]->col[4] = ui->lib1734;

	 libRow[173]->pushbutton = ui->pushButtonLib173;
	 estRow[173]->pushbutton = ui->pushButtonEst173;
	 estRow[173]->col[1] = ui->est1731;
	 estRow[173]->col[2] = ui->est1732;
	 estRow[173]->col[3] = ui->est1733;
	 estRow[173]->col[4] = ui->est1734;
	 estRow[173]->col[5] = ui->est1735;
	 estRow[173]->col[6] = ui->est1736;
	 estRow[173]->col[7] = ui->est1737;


	 libRow[174]->col[1] = ui->lib1741;
	 libRow[174]->col[2] = ui->lib1742;
	 libRow[174]->col[3] = ui->lib1743;
	 libRow[174]->col[4] = ui->lib1744;

	 libRow[174]->pushbutton = ui->pushButtonLib174;
	 estRow[174]->pushbutton = ui->pushButtonEst174;
	 estRow[174]->col[1] = ui->est1741;
	 estRow[174]->col[2] = ui->est1742;
	 estRow[174]->col[3] = ui->est1743;
	 estRow[174]->col[4] = ui->est1744;
	 estRow[174]->col[5] = ui->est1745;
	 estRow[174]->col[6] = ui->est1746;
	 estRow[174]->col[7] = ui->est1747;


	 libRow[175]->col[1] = ui->lib1751;
	 libRow[175]->col[2] = ui->lib1752;
	 libRow[175]->col[3] = ui->lib1753;
	 libRow[175]->col[4] = ui->lib1754;

	 libRow[175]->pushbutton = ui->pushButtonLib175;
	 estRow[175]->pushbutton = ui->pushButtonEst175;
	 estRow[175]->col[1] = ui->est1751;
	 estRow[175]->col[2] = ui->est1752;
	 estRow[175]->col[3] = ui->est1753;
	 estRow[175]->col[4] = ui->est1754;
	 estRow[175]->col[5] = ui->est1755;
	 estRow[175]->col[6] = ui->est1756;
	 estRow[175]->col[7] = ui->est1757;


	 libRow[176]->col[1] = ui->lib1761;
	 libRow[176]->col[2] = ui->lib1762;
	 libRow[176]->col[3] = ui->lib1763;
	 libRow[176]->col[4] = ui->lib1764;

	 libRow[176]->pushbutton = ui->pushButtonLib176;
	 estRow[176]->pushbutton = ui->pushButtonEst176;
	 estRow[176]->col[1] = ui->est1761;
	 estRow[176]->col[2] = ui->est1762;
	 estRow[176]->col[3] = ui->est1763;
	 estRow[176]->col[4] = ui->est1764;
	 estRow[176]->col[5] = ui->est1765;
	 estRow[176]->col[6] = ui->est1766;
	 estRow[176]->col[7] = ui->est1767;


	 libRow[177]->col[1] = ui->lib1771;
	 libRow[177]->col[2] = ui->lib1772;
	 libRow[177]->col[3] = ui->lib1773;
	 libRow[177]->col[4] = ui->lib1774;

	 libRow[177]->pushbutton = ui->pushButtonLib177;
	 estRow[177]->pushbutton = ui->pushButtonEst177;
	 estRow[177]->col[1] = ui->est1771;
	 estRow[177]->col[2] = ui->est1772;
	 estRow[177]->col[3] = ui->est1773;
	 estRow[177]->col[4] = ui->est1774;
	 estRow[177]->col[5] = ui->est1775;
	 estRow[177]->col[6] = ui->est1776;
	 estRow[177]->col[7] = ui->est1777;


	 libRow[178]->col[1] = ui->lib1781;
	 libRow[178]->col[2] = ui->lib1782;
	 libRow[178]->col[3] = ui->lib1783;
	 libRow[178]->col[4] = ui->lib1784;

	 libRow[178]->pushbutton = ui->pushButtonLib178;
	 estRow[178]->pushbutton = ui->pushButtonEst178;
	 estRow[178]->col[1] = ui->est1781;
	 estRow[178]->col[2] = ui->est1782;
	 estRow[178]->col[3] = ui->est1783;
	 estRow[178]->col[4] = ui->est1784;
	 estRow[178]->col[5] = ui->est1785;
	 estRow[178]->col[6] = ui->est1786;
	 estRow[178]->col[7] = ui->est1787;


	 libRow[179]->col[1] = ui->lib1791;
	 libRow[179]->col[2] = ui->lib1792;
	 libRow[179]->col[3] = ui->lib1793;
	 libRow[179]->col[4] = ui->lib1794;

	 libRow[179]->pushbutton = ui->pushButtonLib179;
	 estRow[179]->pushbutton = ui->pushButtonEst179;
	 estRow[179]->col[1] = ui->est1791;
	 estRow[179]->col[2] = ui->est1792;
	 estRow[179]->col[3] = ui->est1793;
	 estRow[179]->col[4] = ui->est1794;
	 estRow[179]->col[5] = ui->est1795;
	 estRow[179]->col[6] = ui->est1796;
	 estRow[179]->col[7] = ui->est1797;


	 libRow[180]->col[1] = ui->lib1801;
	 libRow[180]->col[2] = ui->lib1802;
	 libRow[180]->col[3] = ui->lib1803;
	 libRow[180]->col[4] = ui->lib1804;

	 libRow[180]->pushbutton = ui->pushButtonLib180;
	 estRow[180]->pushbutton = ui->pushButtonEst180;
	 estRow[180]->col[1] = ui->est1801;
	 estRow[180]->col[2] = ui->est1802;
	 estRow[180]->col[3] = ui->est1803;
	 estRow[180]->col[4] = ui->est1804;
	 estRow[180]->col[5] = ui->est1805;
	 estRow[180]->col[6] = ui->est1806;
	 estRow[180]->col[7] = ui->est1807;


	 libRow[181]->col[1] = ui->lib1811;
	 libRow[181]->col[2] = ui->lib1812;
	 libRow[181]->col[3] = ui->lib1813;
	 libRow[181]->col[4] = ui->lib1814;

	 libRow[181]->pushbutton = ui->pushButtonLib181;
	 estRow[181]->pushbutton = ui->pushButtonEst181;
	 estRow[181]->col[1] = ui->est1811;
	 estRow[181]->col[2] = ui->est1812;
	 estRow[181]->col[3] = ui->est1813;
	 estRow[181]->col[4] = ui->est1814;
	 estRow[181]->col[5] = ui->est1815;
	 estRow[181]->col[6] = ui->est1816;
	 estRow[181]->col[7] = ui->est1817;


	 libRow[182]->col[1] = ui->lib1821;
	 libRow[182]->col[2] = ui->lib1822;
	 libRow[182]->col[3] = ui->lib1823;
	 libRow[182]->col[4] = ui->lib1824;

	 libRow[182]->pushbutton = ui->pushButtonLib182;
	 estRow[182]->pushbutton = ui->pushButtonEst182;
	 estRow[182]->col[1] = ui->est1821;
	 estRow[182]->col[2] = ui->est1822;
	 estRow[182]->col[3] = ui->est1823;
	 estRow[182]->col[4] = ui->est1824;
	 estRow[182]->col[5] = ui->est1825;
	 estRow[182]->col[6] = ui->est1826;
	 estRow[182]->col[7] = ui->est1827;


	 libRow[183]->col[1] = ui->lib1831;
	 libRow[183]->col[2] = ui->lib1832;
	 libRow[183]->col[3] = ui->lib1833;
	 libRow[183]->col[4] = ui->lib1834;

	 libRow[183]->pushbutton = ui->pushButtonLib183;
	 estRow[183]->pushbutton = ui->pushButtonEst183;
	 estRow[183]->col[1] = ui->est1831;
	 estRow[183]->col[2] = ui->est1832;
	 estRow[183]->col[3] = ui->est1833;
	 estRow[183]->col[4] = ui->est1834;
	 estRow[183]->col[5] = ui->est1835;
	 estRow[183]->col[6] = ui->est1836;
	 estRow[183]->col[7] = ui->est1837;


	 libRow[184]->col[1] = ui->lib1841;
	 libRow[184]->col[2] = ui->lib1842;
	 libRow[184]->col[3] = ui->lib1843;
	 libRow[184]->col[4] = ui->lib1844;

	 libRow[184]->pushbutton = ui->pushButtonLib184;
	 estRow[184]->pushbutton = ui->pushButtonEst184;
	 estRow[184]->col[1] = ui->est1841;
	 estRow[184]->col[2] = ui->est1842;
	 estRow[184]->col[3] = ui->est1843;
	 estRow[184]->col[4] = ui->est1844;
	 estRow[184]->col[5] = ui->est1845;
	 estRow[184]->col[6] = ui->est1846;
	 estRow[184]->col[7] = ui->est1847;


	 libRow[185]->col[1] = ui->lib1851;
	 libRow[185]->col[2] = ui->lib1852;
	 libRow[185]->col[3] = ui->lib1853;
	 libRow[185]->col[4] = ui->lib1854;

	 libRow[185]->pushbutton = ui->pushButtonLib185;
	 estRow[185]->pushbutton = ui->pushButtonEst185;
	 estRow[185]->col[1] = ui->est1851;
	 estRow[185]->col[2] = ui->est1852;
	 estRow[185]->col[3] = ui->est1853;
	 estRow[185]->col[4] = ui->est1854;
	 estRow[185]->col[5] = ui->est1855;
	 estRow[185]->col[6] = ui->est1856;
	 estRow[185]->col[7] = ui->est1857;


	 libRow[186]->col[1] = ui->lib1861;
	 libRow[186]->col[2] = ui->lib1862;
	 libRow[186]->col[3] = ui->lib1863;
	 libRow[186]->col[4] = ui->lib1864;

	 libRow[186]->pushbutton = ui->pushButtonLib186;
	 estRow[186]->pushbutton = ui->pushButtonEst186;
	 estRow[186]->col[1] = ui->est1861;
	 estRow[186]->col[2] = ui->est1862;
	 estRow[186]->col[3] = ui->est1863;
	 estRow[186]->col[4] = ui->est1864;
	 estRow[186]->col[5] = ui->est1865;
	 estRow[186]->col[6] = ui->est1866;
	 estRow[186]->col[7] = ui->est1867;


	 libRow[187]->col[1] = ui->lib1871;
	 libRow[187]->col[2] = ui->lib1872;
	 libRow[187]->col[3] = ui->lib1873;
	 libRow[187]->col[4] = ui->lib1874;

	 libRow[187]->pushbutton = ui->pushButtonLib187;
	 estRow[187]->pushbutton = ui->pushButtonEst187;
	 estRow[187]->col[1] = ui->est1871;
	 estRow[187]->col[2] = ui->est1872;
	 estRow[187]->col[3] = ui->est1873;
	 estRow[187]->col[4] = ui->est1874;
	 estRow[187]->col[5] = ui->est1875;
	 estRow[187]->col[6] = ui->est1876;
	 estRow[187]->col[7] = ui->est1877;


	 libRow[188]->col[1] = ui->lib1881;
	 libRow[188]->col[2] = ui->lib1882;
	 libRow[188]->col[3] = ui->lib1883;
	 libRow[188]->col[4] = ui->lib1884;

	 libRow[188]->pushbutton = ui->pushButtonLib188;
	 estRow[188]->pushbutton = ui->pushButtonEst188;
	 estRow[188]->col[1] = ui->est1881;
	 estRow[188]->col[2] = ui->est1882;
	 estRow[188]->col[3] = ui->est1883;
	 estRow[188]->col[4] = ui->est1884;
	 estRow[188]->col[5] = ui->est1885;
	 estRow[188]->col[6] = ui->est1886;
	 estRow[188]->col[7] = ui->est1887;


	 libRow[189]->col[1] = ui->lib1891;
	 libRow[189]->col[2] = ui->lib1892;
	 libRow[189]->col[3] = ui->lib1893;
	 libRow[189]->col[4] = ui->lib1894;

	 libRow[189]->pushbutton = ui->pushButtonLib189;
	 estRow[189]->pushbutton = ui->pushButtonEst189;
	 estRow[189]->col[1] = ui->est1891;
	 estRow[189]->col[2] = ui->est1892;
	 estRow[189]->col[3] = ui->est1893;
	 estRow[189]->col[4] = ui->est1894;
	 estRow[189]->col[5] = ui->est1895;
	 estRow[189]->col[6] = ui->est1896;
	 estRow[189]->col[7] = ui->est1897;


	 libRow[190]->col[1] = ui->lib1901;
	 libRow[190]->col[2] = ui->lib1902;
	 libRow[190]->col[3] = ui->lib1903;
	 libRow[190]->col[4] = ui->lib1904;

	 libRow[190]->pushbutton = ui->pushButtonLib190;
	 estRow[190]->pushbutton = ui->pushButtonEst190;
	 estRow[190]->col[1] = ui->est1901;
	 estRow[190]->col[2] = ui->est1902;
	 estRow[190]->col[3] = ui->est1903;
	 estRow[190]->col[4] = ui->est1904;
	 estRow[190]->col[5] = ui->est1905;
	 estRow[190]->col[6] = ui->est1906;
	 estRow[190]->col[7] = ui->est1907;


	 libRow[191]->col[1] = ui->lib1911;
	 libRow[191]->col[2] = ui->lib1912;
	 libRow[191]->col[3] = ui->lib1913;
	 libRow[191]->col[4] = ui->lib1914;

	 libRow[191]->pushbutton = ui->pushButtonLib191;
	 estRow[191]->pushbutton = ui->pushButtonEst191;
	 estRow[191]->col[1] = ui->est1911;
	 estRow[191]->col[2] = ui->est1912;
	 estRow[191]->col[3] = ui->est1913;
	 estRow[191]->col[4] = ui->est1914;
	 estRow[191]->col[5] = ui->est1915;
	 estRow[191]->col[6] = ui->est1916;
	 estRow[191]->col[7] = ui->est1917;


	 libRow[192]->col[1] = ui->lib1921;
	 libRow[192]->col[2] = ui->lib1922;
	 libRow[192]->col[3] = ui->lib1923;
	 libRow[192]->col[4] = ui->lib1924;

	 libRow[192]->pushbutton = ui->pushButtonLib192;
	 estRow[192]->pushbutton = ui->pushButtonEst192;
	 estRow[192]->col[1] = ui->est1921;
	 estRow[192]->col[2] = ui->est1922;
	 estRow[192]->col[3] = ui->est1923;
	 estRow[192]->col[4] = ui->est1924;
	 estRow[192]->col[5] = ui->est1925;
	 estRow[192]->col[6] = ui->est1926;
	 estRow[192]->col[7] = ui->est1927;


	 libRow[193]->col[1] = ui->lib1931;
	 libRow[193]->col[2] = ui->lib1932;
	 libRow[193]->col[3] = ui->lib1933;
	 libRow[193]->col[4] = ui->lib1934;

	 libRow[193]->pushbutton = ui->pushButtonLib193;
	 estRow[193]->pushbutton = ui->pushButtonEst193;
	 estRow[193]->col[1] = ui->est1931;
	 estRow[193]->col[2] = ui->est1932;
	 estRow[193]->col[3] = ui->est1933;
	 estRow[193]->col[4] = ui->est1934;
	 estRow[193]->col[5] = ui->est1935;
	 estRow[193]->col[6] = ui->est1936;
	 estRow[193]->col[7] = ui->est1937;


	 libRow[194]->col[1] = ui->lib1941;
	 libRow[194]->col[2] = ui->lib1942;
	 libRow[194]->col[3] = ui->lib1943;
	 libRow[194]->col[4] = ui->lib1944;

	 libRow[194]->pushbutton = ui->pushButtonLib194;
	 estRow[194]->pushbutton = ui->pushButtonEst194;
	 estRow[194]->col[1] = ui->est1941;
	 estRow[194]->col[2] = ui->est1942;
	 estRow[194]->col[3] = ui->est1943;
	 estRow[194]->col[4] = ui->est1944;
	 estRow[194]->col[5] = ui->est1945;
	 estRow[194]->col[6] = ui->est1946;
	 estRow[194]->col[7] = ui->est1947;


	 libRow[195]->col[1] = ui->lib1951;
	 libRow[195]->col[2] = ui->lib1952;
	 libRow[195]->col[3] = ui->lib1953;
	 libRow[195]->col[4] = ui->lib1954;

	 libRow[195]->pushbutton = ui->pushButtonLib195;
	 estRow[195]->pushbutton = ui->pushButtonEst195;
	 estRow[195]->col[1] = ui->est1951;
	 estRow[195]->col[2] = ui->est1952;
	 estRow[195]->col[3] = ui->est1953;
	 estRow[195]->col[4] = ui->est1954;
	 estRow[195]->col[5] = ui->est1955;
	 estRow[195]->col[6] = ui->est1956;
	 estRow[195]->col[7] = ui->est1957;


	 libRow[196]->col[1] = ui->lib1961;
	 libRow[196]->col[2] = ui->lib1962;
	 libRow[196]->col[3] = ui->lib1963;
	 libRow[196]->col[4] = ui->lib1964;

	 libRow[196]->pushbutton = ui->pushButtonLib196;
	 estRow[196]->pushbutton = ui->pushButtonEst196;
	 estRow[196]->col[1] = ui->est1961;
	 estRow[196]->col[2] = ui->est1962;
	 estRow[196]->col[3] = ui->est1963;
	 estRow[196]->col[4] = ui->est1964;
	 estRow[196]->col[5] = ui->est1965;
	 estRow[196]->col[6] = ui->est1966;
	 estRow[196]->col[7] = ui->est1967;


	 libRow[197]->col[1] = ui->lib1971;
	 libRow[197]->col[2] = ui->lib1972;
	 libRow[197]->col[3] = ui->lib1973;
	 libRow[197]->col[4] = ui->lib1974;

	 libRow[197]->pushbutton = ui->pushButtonLib197;
	 estRow[197]->pushbutton = ui->pushButtonEst197;
	 estRow[197]->col[1] = ui->est1971;
	 estRow[197]->col[2] = ui->est1972;
	 estRow[197]->col[3] = ui->est1973;
	 estRow[197]->col[4] = ui->est1974;
	 estRow[197]->col[5] = ui->est1975;
	 estRow[197]->col[6] = ui->est1976;
	 estRow[197]->col[7] = ui->est1977;


	 libRow[198]->col[1] = ui->lib1981;
	 libRow[198]->col[2] = ui->lib1982;
	 libRow[198]->col[3] = ui->lib1983;
	 libRow[198]->col[4] = ui->lib1984;

	 libRow[198]->pushbutton = ui->pushButtonLib198;
	 estRow[198]->pushbutton = ui->pushButtonEst198;
	 estRow[198]->col[1] = ui->est1981;
	 estRow[198]->col[2] = ui->est1982;
	 estRow[198]->col[3] = ui->est1983;
	 estRow[198]->col[4] = ui->est1984;
	 estRow[198]->col[5] = ui->est1985;
	 estRow[198]->col[6] = ui->est1986;
	 estRow[198]->col[7] = ui->est1987;


	 libRow[199]->col[1] = ui->lib1991;
	 libRow[199]->col[2] = ui->lib1992;
	 libRow[199]->col[3] = ui->lib1993;
	 libRow[199]->col[4] = ui->lib1994;

	 libRow[199]->pushbutton = ui->pushButtonLib199;
	 estRow[199]->pushbutton = ui->pushButtonEst199;
	 estRow[199]->col[1] = ui->est1991;
	 estRow[199]->col[2] = ui->est1992;
	 estRow[199]->col[3] = ui->est1993;
	 estRow[199]->col[4] = ui->est1994;
	 estRow[199]->col[5] = ui->est1995;
	 estRow[199]->col[6] = ui->est1996;
	 estRow[199]->col[7] = ui->est1997;


	 libRow[200]->col[1] = ui->lib2001;
	 libRow[200]->col[2] = ui->lib2002;
	 libRow[200]->col[3] = ui->lib2003;
	 libRow[200]->col[4] = ui->lib2004;

	 libRow[200]->pushbutton = ui->pushButtonLib200;
	 estRow[200]->pushbutton = ui->pushButtonEst200;
	 estRow[200]->col[1] = ui->est2001;
	 estRow[200]->col[2] = ui->est2002;
	 estRow[200]->col[3] = ui->est2003;
	 estRow[200]->col[4] = ui->est2004;
	 estRow[200]->col[5] = ui->est2005;
	 estRow[200]->col[6] = ui->est2006;
	 estRow[200]->col[7] = ui->est2007;


	 libRow[201]->col[1] = ui->lib2011;
	 libRow[201]->col[2] = ui->lib2012;
	 libRow[201]->col[3] = ui->lib2013;
	 libRow[201]->col[4] = ui->lib2014;

	 libRow[201]->pushbutton = ui->pushButtonLib201;
	 estRow[201]->pushbutton = ui->pushButtonEst201;
	 estRow[201]->col[1] = ui->est2011;
	 estRow[201]->col[2] = ui->est2012;
	 estRow[201]->col[3] = ui->est2013;
	 estRow[201]->col[4] = ui->est2014;
	 estRow[201]->col[5] = ui->est2015;
	 estRow[201]->col[6] = ui->est2016;
	 estRow[201]->col[7] = ui->est2017;


	 libRow[202]->col[1] = ui->lib2021;
	 libRow[202]->col[2] = ui->lib2022;
	 libRow[202]->col[3] = ui->lib2023;
	 libRow[202]->col[4] = ui->lib2024;

	 libRow[202]->pushbutton = ui->pushButtonLib202;
	 estRow[202]->pushbutton = ui->pushButtonEst202;
	 estRow[202]->col[1] = ui->est2021;
	 estRow[202]->col[2] = ui->est2022;
	 estRow[202]->col[3] = ui->est2023;
	 estRow[202]->col[4] = ui->est2024;
	 estRow[202]->col[5] = ui->est2025;
	 estRow[202]->col[6] = ui->est2026;
	 estRow[202]->col[7] = ui->est2027;


	 libRow[203]->col[1] = ui->lib2031;
	 libRow[203]->col[2] = ui->lib2032;
	 libRow[203]->col[3] = ui->lib2033;
	 libRow[203]->col[4] = ui->lib2034;

	 libRow[203]->pushbutton = ui->pushButtonLib203;
	 estRow[203]->pushbutton = ui->pushButtonEst203;
	 estRow[203]->col[1] = ui->est2031;
	 estRow[203]->col[2] = ui->est2032;
	 estRow[203]->col[3] = ui->est2033;
	 estRow[203]->col[4] = ui->est2034;
	 estRow[203]->col[5] = ui->est2035;
	 estRow[203]->col[6] = ui->est2036;
	 estRow[203]->col[7] = ui->est2037;


	 libRow[204]->col[1] = ui->lib2041;
	 libRow[204]->col[2] = ui->lib2042;
	 libRow[204]->col[3] = ui->lib2043;
	 libRow[204]->col[4] = ui->lib2044;

	 libRow[204]->pushbutton = ui->pushButtonLib204;
	 estRow[204]->pushbutton = ui->pushButtonEst204;
	 estRow[204]->col[1] = ui->est2041;
	 estRow[204]->col[2] = ui->est2042;
	 estRow[204]->col[3] = ui->est2043;
	 estRow[204]->col[4] = ui->est2044;
	 estRow[204]->col[5] = ui->est2045;
	 estRow[204]->col[6] = ui->est2046;
	 estRow[204]->col[7] = ui->est2047;


	 libRow[205]->col[1] = ui->lib2051;
	 libRow[205]->col[2] = ui->lib2052;
	 libRow[205]->col[3] = ui->lib2053;
	 libRow[205]->col[4] = ui->lib2054;

	 libRow[205]->pushbutton = ui->pushButtonLib205;
	 estRow[205]->pushbutton = ui->pushButtonEst205;
	 estRow[205]->col[1] = ui->est2051;
	 estRow[205]->col[2] = ui->est2052;
	 estRow[205]->col[3] = ui->est2053;
	 estRow[205]->col[4] = ui->est2054;
	 estRow[205]->col[5] = ui->est2055;
	 estRow[205]->col[6] = ui->est2056;
	 estRow[205]->col[7] = ui->est2057;


	 libRow[206]->col[1] = ui->lib2061;
	 libRow[206]->col[2] = ui->lib2062;
	 libRow[206]->col[3] = ui->lib2063;
	 libRow[206]->col[4] = ui->lib2064;

	 libRow[206]->pushbutton = ui->pushButtonLib206;
	 estRow[206]->pushbutton = ui->pushButtonEst206;
	 estRow[206]->col[1] = ui->est2061;
	 estRow[206]->col[2] = ui->est2062;
	 estRow[206]->col[3] = ui->est2063;
	 estRow[206]->col[4] = ui->est2064;
	 estRow[206]->col[5] = ui->est2065;
	 estRow[206]->col[6] = ui->est2066;
	 estRow[206]->col[7] = ui->est2067;


	 libRow[207]->col[1] = ui->lib2071;
	 libRow[207]->col[2] = ui->lib2072;
	 libRow[207]->col[3] = ui->lib2073;
	 libRow[207]->col[4] = ui->lib2074;

	 libRow[207]->pushbutton = ui->pushButtonLib207;
	 estRow[207]->pushbutton = ui->pushButtonEst207;
	 estRow[207]->col[1] = ui->est2071;
	 estRow[207]->col[2] = ui->est2072;
	 estRow[207]->col[3] = ui->est2073;
	 estRow[207]->col[4] = ui->est2074;
	 estRow[207]->col[5] = ui->est2075;
	 estRow[207]->col[6] = ui->est2076;
	 estRow[207]->col[7] = ui->est2077;


	 libRow[208]->col[1] = ui->lib2081;
	 libRow[208]->col[2] = ui->lib2082;
	 libRow[208]->col[3] = ui->lib2083;
	 libRow[208]->col[4] = ui->lib2084;

	 libRow[208]->pushbutton = ui->pushButtonLib208;
	 estRow[208]->pushbutton = ui->pushButtonEst208;
	 estRow[208]->col[1] = ui->est2081;
	 estRow[208]->col[2] = ui->est2082;
	 estRow[208]->col[3] = ui->est2083;
	 estRow[208]->col[4] = ui->est2084;
	 estRow[208]->col[5] = ui->est2085;
	 estRow[208]->col[6] = ui->est2086;
	 estRow[208]->col[7] = ui->est2087;


	 libRow[209]->col[1] = ui->lib2091;
	 libRow[209]->col[2] = ui->lib2092;
	 libRow[209]->col[3] = ui->lib2093;
	 libRow[209]->col[4] = ui->lib2094;

	 libRow[209]->pushbutton = ui->pushButtonLib209;
	 estRow[209]->pushbutton = ui->pushButtonEst209;
	 estRow[209]->col[1] = ui->est2091;
	 estRow[209]->col[2] = ui->est2092;
	 estRow[209]->col[3] = ui->est2093;
	 estRow[209]->col[4] = ui->est2094;
	 estRow[209]->col[5] = ui->est2095;
	 estRow[209]->col[6] = ui->est2096;
	 estRow[209]->col[7] = ui->est2097;


	 libRow[210]->col[1] = ui->lib2101;
	 libRow[210]->col[2] = ui->lib2102;
	 libRow[210]->col[3] = ui->lib2103;
	 libRow[210]->col[4] = ui->lib2104;

	 libRow[210]->pushbutton = ui->pushButtonLib210;
	 estRow[210]->pushbutton = ui->pushButtonEst210;
	 estRow[210]->col[1] = ui->est2101;
	 estRow[210]->col[2] = ui->est2102;
	 estRow[210]->col[3] = ui->est2103;
	 estRow[210]->col[4] = ui->est2104;
	 estRow[210]->col[5] = ui->est2105;
	 estRow[210]->col[6] = ui->est2106;
	 estRow[210]->col[7] = ui->est2107;


	 libRow[211]->col[1] = ui->lib2111;
	 libRow[211]->col[2] = ui->lib2112;
	 libRow[211]->col[3] = ui->lib2113;
	 libRow[211]->col[4] = ui->lib2114;

	 libRow[211]->pushbutton = ui->pushButtonLib211;
	 estRow[211]->pushbutton = ui->pushButtonEst211;
	 estRow[211]->col[1] = ui->est2111;
	 estRow[211]->col[2] = ui->est2112;
	 estRow[211]->col[3] = ui->est2113;
	 estRow[211]->col[4] = ui->est2114;
	 estRow[211]->col[5] = ui->est2115;
	 estRow[211]->col[6] = ui->est2116;
	 estRow[211]->col[7] = ui->est2117;


	 libRow[212]->col[1] = ui->lib2121;
	 libRow[212]->col[2] = ui->lib2122;
	 libRow[212]->col[3] = ui->lib2123;
	 libRow[212]->col[4] = ui->lib2124;

	 libRow[212]->pushbutton = ui->pushButtonLib212;
	 estRow[212]->pushbutton = ui->pushButtonEst212;
	 estRow[212]->col[1] = ui->est2121;
	 estRow[212]->col[2] = ui->est2122;
	 estRow[212]->col[3] = ui->est2123;
	 estRow[212]->col[4] = ui->est2124;
	 estRow[212]->col[5] = ui->est2125;
	 estRow[212]->col[6] = ui->est2126;
	 estRow[212]->col[7] = ui->est2127;


	 libRow[213]->col[1] = ui->lib2131;
	 libRow[213]->col[2] = ui->lib2132;
	 libRow[213]->col[3] = ui->lib2133;
	 libRow[213]->col[4] = ui->lib2134;

	 libRow[213]->pushbutton = ui->pushButtonLib213;
	 estRow[213]->pushbutton = ui->pushButtonEst213;
	 estRow[213]->col[1] = ui->est2131;
	 estRow[213]->col[2] = ui->est2132;
	 estRow[213]->col[3] = ui->est2133;
	 estRow[213]->col[4] = ui->est2134;
	 estRow[213]->col[5] = ui->est2135;
	 estRow[213]->col[6] = ui->est2136;
	 estRow[213]->col[7] = ui->est2137;


	 libRow[214]->col[1] = ui->lib2141;
	 libRow[214]->col[2] = ui->lib2142;
	 libRow[214]->col[3] = ui->lib2143;
	 libRow[214]->col[4] = ui->lib2144;

	 libRow[214]->pushbutton = ui->pushButtonLib214;
	 estRow[214]->pushbutton = ui->pushButtonEst214;
	 estRow[214]->col[1] = ui->est2141;
	 estRow[214]->col[2] = ui->est2142;
	 estRow[214]->col[3] = ui->est2143;
	 estRow[214]->col[4] = ui->est2144;
	 estRow[214]->col[5] = ui->est2145;
	 estRow[214]->col[6] = ui->est2146;
	 estRow[214]->col[7] = ui->est2147;


	 libRow[215]->col[1] = ui->lib2151;
	 libRow[215]->col[2] = ui->lib2152;
	 libRow[215]->col[3] = ui->lib2153;
	 libRow[215]->col[4] = ui->lib2154;

	 libRow[215]->pushbutton = ui->pushButtonLib215;
	 estRow[215]->pushbutton = ui->pushButtonEst215;
	 estRow[215]->col[1] = ui->est2151;
	 estRow[215]->col[2] = ui->est2152;
	 estRow[215]->col[3] = ui->est2153;
	 estRow[215]->col[4] = ui->est2154;
	 estRow[215]->col[5] = ui->est2155;
	 estRow[215]->col[6] = ui->est2156;
	 estRow[215]->col[7] = ui->est2157;


	 libRow[216]->col[1] = ui->lib2161;
	 libRow[216]->col[2] = ui->lib2162;
	 libRow[216]->col[3] = ui->lib2163;
	 libRow[216]->col[4] = ui->lib2164;

	 libRow[216]->pushbutton = ui->pushButtonLib216;
	 estRow[216]->pushbutton = ui->pushButtonEst216;
	 estRow[216]->col[1] = ui->est2161;
	 estRow[216]->col[2] = ui->est2162;
	 estRow[216]->col[3] = ui->est2163;
	 estRow[216]->col[4] = ui->est2164;
	 estRow[216]->col[5] = ui->est2165;
	 estRow[216]->col[6] = ui->est2166;
	 estRow[216]->col[7] = ui->est2167;


	 libRow[217]->col[1] = ui->lib2171;
	 libRow[217]->col[2] = ui->lib2172;
	 libRow[217]->col[3] = ui->lib2173;
	 libRow[217]->col[4] = ui->lib2174;

	 libRow[217]->pushbutton = ui->pushButtonLib217;
	 estRow[217]->pushbutton = ui->pushButtonEst217;
	 estRow[217]->col[1] = ui->est2171;
	 estRow[217]->col[2] = ui->est2172;
	 estRow[217]->col[3] = ui->est2173;
	 estRow[217]->col[4] = ui->est2174;
	 estRow[217]->col[5] = ui->est2175;
	 estRow[217]->col[6] = ui->est2176;
	 estRow[217]->col[7] = ui->est2177;


	 libRow[218]->col[1] = ui->lib2181;
	 libRow[218]->col[2] = ui->lib2182;
	 libRow[218]->col[3] = ui->lib2183;
	 libRow[218]->col[4] = ui->lib2184;

	 libRow[218]->pushbutton = ui->pushButtonLib218;
	 estRow[218]->pushbutton = ui->pushButtonEst218;
	 estRow[218]->col[1] = ui->est2181;
	 estRow[218]->col[2] = ui->est2182;
	 estRow[218]->col[3] = ui->est2183;
	 estRow[218]->col[4] = ui->est2184;
	 estRow[218]->col[5] = ui->est2185;
	 estRow[218]->col[6] = ui->est2186;
	 estRow[218]->col[7] = ui->est2187;


	 libRow[219]->col[1] = ui->lib2191;
	 libRow[219]->col[2] = ui->lib2192;
	 libRow[219]->col[3] = ui->lib2193;
	 libRow[219]->col[4] = ui->lib2194;

	 libRow[219]->pushbutton = ui->pushButtonLib219;
	 estRow[219]->pushbutton = ui->pushButtonEst219;
	 estRow[219]->col[1] = ui->est2191;
	 estRow[219]->col[2] = ui->est2192;
	 estRow[219]->col[3] = ui->est2193;
	 estRow[219]->col[4] = ui->est2194;
	 estRow[219]->col[5] = ui->est2195;
	 estRow[219]->col[6] = ui->est2196;
	 estRow[219]->col[7] = ui->est2197;


	 libRow[220]->col[1] = ui->lib2201;
	 libRow[220]->col[2] = ui->lib2202;
	 libRow[220]->col[3] = ui->lib2203;
	 libRow[220]->col[4] = ui->lib2204;

	 libRow[220]->pushbutton = ui->pushButtonLib220;
	 estRow[220]->pushbutton = ui->pushButtonEst220;
	 estRow[220]->col[1] = ui->est2201;
	 estRow[220]->col[2] = ui->est2202;
	 estRow[220]->col[3] = ui->est2203;
	 estRow[220]->col[4] = ui->est2204;
	 estRow[220]->col[5] = ui->est2205;
	 estRow[220]->col[6] = ui->est2206;
	 estRow[220]->col[7] = ui->est2207;


	 libRow[221]->col[1] = ui->lib2211;
	 libRow[221]->col[2] = ui->lib2212;
	 libRow[221]->col[3] = ui->lib2213;
	 libRow[221]->col[4] = ui->lib2214;

	 libRow[221]->pushbutton = ui->pushButtonLib221;
	 estRow[221]->pushbutton = ui->pushButtonEst221;
	 estRow[221]->col[1] = ui->est2211;
	 estRow[221]->col[2] = ui->est2212;
	 estRow[221]->col[3] = ui->est2213;
	 estRow[221]->col[4] = ui->est2214;
	 estRow[221]->col[5] = ui->est2215;
	 estRow[221]->col[6] = ui->est2216;
	 estRow[221]->col[7] = ui->est2217;


	 libRow[222]->col[1] = ui->lib2221;
	 libRow[222]->col[2] = ui->lib2222;
	 libRow[222]->col[3] = ui->lib2223;
	 libRow[222]->col[4] = ui->lib2224;

	 libRow[222]->pushbutton = ui->pushButtonLib222;
	 estRow[222]->pushbutton = ui->pushButtonEst222;
	 estRow[222]->col[1] = ui->est2221;
	 estRow[222]->col[2] = ui->est2222;
	 estRow[222]->col[3] = ui->est2223;
	 estRow[222]->col[4] = ui->est2224;
	 estRow[222]->col[5] = ui->est2225;
	 estRow[222]->col[6] = ui->est2226;
	 estRow[222]->col[7] = ui->est2227;


	 libRow[223]->col[1] = ui->lib2231;
	 libRow[223]->col[2] = ui->lib2232;
	 libRow[223]->col[3] = ui->lib2233;
	 libRow[223]->col[4] = ui->lib2234;

	 libRow[223]->pushbutton = ui->pushButtonLib223;
	 estRow[223]->pushbutton = ui->pushButtonEst223;
	 estRow[223]->col[1] = ui->est2231;
	 estRow[223]->col[2] = ui->est2232;
	 estRow[223]->col[3] = ui->est2233;
	 estRow[223]->col[4] = ui->est2234;
	 estRow[223]->col[5] = ui->est2235;
	 estRow[223]->col[6] = ui->est2236;
	 estRow[223]->col[7] = ui->est2237;


	 libRow[224]->col[1] = ui->lib2241;
	 libRow[224]->col[2] = ui->lib2242;
	 libRow[224]->col[3] = ui->lib2243;
	 libRow[224]->col[4] = ui->lib2244;

	 libRow[224]->pushbutton = ui->pushButtonLib224;
	 estRow[224]->pushbutton = ui->pushButtonEst224;
	 estRow[224]->col[1] = ui->est2241;
	 estRow[224]->col[2] = ui->est2242;
	 estRow[224]->col[3] = ui->est2243;
	 estRow[224]->col[4] = ui->est2244;
	 estRow[224]->col[5] = ui->est2245;
	 estRow[224]->col[6] = ui->est2246;
	 estRow[224]->col[7] = ui->est2247;


	 libRow[225]->col[1] = ui->lib2251;
	 libRow[225]->col[2] = ui->lib2252;
	 libRow[225]->col[3] = ui->lib2253;
	 libRow[225]->col[4] = ui->lib2254;

	 libRow[225]->pushbutton = ui->pushButtonLib225;
	 estRow[225]->pushbutton = ui->pushButtonEst225;
	 estRow[225]->col[1] = ui->est2251;
	 estRow[225]->col[2] = ui->est2252;
	 estRow[225]->col[3] = ui->est2253;
	 estRow[225]->col[4] = ui->est2254;
	 estRow[225]->col[5] = ui->est2255;
	 estRow[225]->col[6] = ui->est2256;
	 estRow[225]->col[7] = ui->est2257;


	 libRow[226]->col[1] = ui->lib2261;
	 libRow[226]->col[2] = ui->lib2262;
	 libRow[226]->col[3] = ui->lib2263;
	 libRow[226]->col[4] = ui->lib2264;

	 libRow[226]->pushbutton = ui->pushButtonLib226;
	 estRow[226]->pushbutton = ui->pushButtonEst226;
	 estRow[226]->col[1] = ui->est2261;
	 estRow[226]->col[2] = ui->est2262;
	 estRow[226]->col[3] = ui->est2263;
	 estRow[226]->col[4] = ui->est2264;
	 estRow[226]->col[5] = ui->est2265;
	 estRow[226]->col[6] = ui->est2266;
	 estRow[226]->col[7] = ui->est2267;


	 libRow[227]->col[1] = ui->lib2271;
	 libRow[227]->col[2] = ui->lib2272;
	 libRow[227]->col[3] = ui->lib2273;
	 libRow[227]->col[4] = ui->lib2274;

	 libRow[227]->pushbutton = ui->pushButtonLib227;
	 estRow[227]->pushbutton = ui->pushButtonEst227;
	 estRow[227]->col[1] = ui->est2271;
	 estRow[227]->col[2] = ui->est2272;
	 estRow[227]->col[3] = ui->est2273;
	 estRow[227]->col[4] = ui->est2274;
	 estRow[227]->col[5] = ui->est2275;
	 estRow[227]->col[6] = ui->est2276;
	 estRow[227]->col[7] = ui->est2277;


	 libRow[228]->col[1] = ui->lib2281;
	 libRow[228]->col[2] = ui->lib2282;
	 libRow[228]->col[3] = ui->lib2283;
	 libRow[228]->col[4] = ui->lib2284;

	 libRow[228]->pushbutton = ui->pushButtonLib228;
	 estRow[228]->pushbutton = ui->pushButtonEst228;
	 estRow[228]->col[1] = ui->est2281;
	 estRow[228]->col[2] = ui->est2282;
	 estRow[228]->col[3] = ui->est2283;
	 estRow[228]->col[4] = ui->est2284;
	 estRow[228]->col[5] = ui->est2285;
	 estRow[228]->col[6] = ui->est2286;
	 estRow[228]->col[7] = ui->est2287;


	 libRow[229]->col[1] = ui->lib2291;
	 libRow[229]->col[2] = ui->lib2292;
	 libRow[229]->col[3] = ui->lib2293;
	 libRow[229]->col[4] = ui->lib2294;

	 libRow[229]->pushbutton = ui->pushButtonLib229;
	 estRow[229]->pushbutton = ui->pushButtonEst229;
	 estRow[229]->col[1] = ui->est2291;
	 estRow[229]->col[2] = ui->est2292;
	 estRow[229]->col[3] = ui->est2293;
	 estRow[229]->col[4] = ui->est2294;
	 estRow[229]->col[5] = ui->est2295;
	 estRow[229]->col[6] = ui->est2296;
	 estRow[229]->col[7] = ui->est2297;


	 libRow[230]->col[1] = ui->lib2301;
	 libRow[230]->col[2] = ui->lib2302;
	 libRow[230]->col[3] = ui->lib2303;
	 libRow[230]->col[4] = ui->lib2304;

	 libRow[230]->pushbutton = ui->pushButtonLib230;
	 estRow[230]->pushbutton = ui->pushButtonEst230;
	 estRow[230]->col[1] = ui->est2301;
	 estRow[230]->col[2] = ui->est2302;
	 estRow[230]->col[3] = ui->est2303;
	 estRow[230]->col[4] = ui->est2304;
	 estRow[230]->col[5] = ui->est2305;
	 estRow[230]->col[6] = ui->est2306;
	 estRow[230]->col[7] = ui->est2307;


	 libRow[231]->col[1] = ui->lib2311;
	 libRow[231]->col[2] = ui->lib2312;
	 libRow[231]->col[3] = ui->lib2313;
	 libRow[231]->col[4] = ui->lib2314;

	 libRow[231]->pushbutton = ui->pushButtonLib231;
	 estRow[231]->pushbutton = ui->pushButtonEst231;
	 estRow[231]->col[1] = ui->est2311;
	 estRow[231]->col[2] = ui->est2312;
	 estRow[231]->col[3] = ui->est2313;
	 estRow[231]->col[4] = ui->est2314;
	 estRow[231]->col[5] = ui->est2315;
	 estRow[231]->col[6] = ui->est2316;
	 estRow[231]->col[7] = ui->est2317;

     for( int rr=ESTROWCOUNT-1; rr >= 1; --rr)
     {
        if( iconLeft2.isNull() )
            libRow[rr]->pushbutton->setText(">");
        else
        {
            libRow[rr]->pushbutton->setIcon( iconRight2 );
            libRow[rr]->pushbutton->setIconSize( QSize(m2trail,m2trail) );
        }
        libRow[rr]->pushbutton->setLayoutDirection(Qt::LeftToRight);

        if( iconRight2.isNull() )
            estRow[rr]->pushbutton->setText("<");
        else
        {
            estRow[rr]->pushbutton->setIcon( iconLeft2 );
            estRow[rr]->pushbutton->setIconSize( QSize(m2trail,m2trail) );
        }

        estRow[rr]->pushbutton->setLayoutDirection(Qt::RightToLeft);

        /* See settings*.c settings*.txt for notes about using the QtCreator
         * .ui unarrayed unique names, which cannot be put inside a for() loop,
         * but worked perfectly, writing out 110,000+ lines of c++ code,
         * but is slow to compile load2.c.
         * Thus the coding is thousands of lines shorter now, March 1, 2024,
         * and changes are easily done here instead of regeneration of
         * C++ using settings-for-ui.c. Compiling is 15s instead of 11 minutes!
-rwxr-xr-x 1 david david   15936 Feb 27 04:11 settings-for-ui
-rw-r--r-- 1 david david    7623 Feb 27 04:10 settings-for-ui.c
-rw-r--r-- 1 david david 1435992 Feb 27 04:11 settings-for-ui.c-out
-rw-r--r-- 1 david david    5550 Feb 14 21:17 settings-for-ui.txt
         */

        QString ss = QString("%1     ").arg(rr); //"231   " for rr==231
        ss.truncate(6);

        // This is one row of library,button,button,estimate:

        libRow[rr]->col[1]->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, ss ));
        connect( libRow[rr]->col[1], &QLineEdit::editingFinished, this, &MainWindow::doCalc );
        connect( libRow[rr]->col[1], &QLineEdit::inputRejected, this, &MainWindow::validateField );
        libRow[rr]->col[1]->installEventFilter(this);
        libRow[rr]->col[1]->setMaximumWidth( m6trail);
        libRow[rr]->col[1]->setMinimumWidth( m6trail);
        //libRow[rr]->col[1]->setMaximumHeight( m7traild3 );
        libRow[rr]->col[1]->setFixedHeight( m7trailp3 );

        libRow[rr]->col[1]->setMaxLength(3);
        libRow[rr]->col[1]->setFrame(globalFrame);

        libRow[rr]->col[2]->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, ss ));
        connect( libRow[rr]->col[2], &QLineEdit::editingFinished, this, &MainWindow::doCalc );
        connect( libRow[rr]->col[2], &QLineEdit::inputRejected, this, &MainWindow::validateField );
        libRow[rr]->col[2]->installEventFilter(this);
        libRow[rr]->col[2]->setMaximumWidth( m26trail);
        libRow[rr]->col[2]->setMinimumWidth( m25trail);
        //libRow[rr]->col[2]->setMaximumHeight( m7traild3 );
        libRow[rr]->col[2]->setFixedHeight( m7trailp3 );

        libRow[rr]->col[2]->setMaxLength(24);
        libRow[rr]->col[2]->setFrame(globalFrame);

        libRow[rr]->col[3]->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, ss ));
        connect( libRow[rr]->col[3], &QLineEdit::editingFinished, this, &MainWindow::doCalc );
        connect( libRow[rr]->col[3], &QLineEdit::inputRejected, this, &MainWindow::validateField );
        libRow[rr]->col[3]->installEventFilter(this);
        libRow[rr]->col[3]->setAlignment(Qt::AlignCenter);
        libRow[rr]->col[3]->setMaximumWidth( m12trail);
        libRow[rr]->col[3]->setMinimumWidth( m6trail);
        //libRow[rr]->col[3]->setMaximumHeight( m7traild3 );
        libRow[rr]->col[3]->setFixedHeight( m7trailp3 );

        libRow[rr]->col[3]->setMaxLength(11);
        libRow[rr]->col[3]->setFrame(globalFrame);

        libRow[rr]->col[4]->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, ss ));
        connect( libRow[rr]->col[4], &QLineEdit::editingFinished, this, &MainWindow::doCalc );
        connect( libRow[rr]->col[4], &QLineEdit::inputRejected, this, &MainWindow::validateField );
        libRow[rr]->col[4]->installEventFilter(this);
        libRow[rr]->col[4]->setAlignment(Qt::AlignCenter);
        libRow[rr]->col[4]->setMaximumWidth( m12trail);
        libRow[rr]->col[4]->setMinimumWidth( m6trail);
        //libRow[rr]->col[4]->setMaximumHeight( m7traild3 );
        libRow[rr]->col[4]->setFixedHeight( m7trailp3 );

        libRow[rr]->col[4]->setMaxLength(11);
        libRow[rr]->col[4]->setFrame(globalFrame);

        libRow[rr]->pushbutton->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, ss ));
        libRow[rr]->pushbutton->setMaximumWidth( m7traild3 );
        //libRow[rr]->pushbutton->setMaximumHeight( m7traild3 );
        libRow[rr]->pushbutton->setFixedHeight( m7trailp3 );


        /* Do not turn on the installEventFilter() in load2.cpp on hundreds of
         * estRow[]->pushbutton
         * libRow[]->pushbutton
         * because the currentLibbuttonrow is turned on by event_...cpp
         * instead of by connect() SLOT alone and that causes
         * the void MainWindow::libraryLibtoEst()
         * and void MainWindow::libraryEsttoLib()
         * to fail by diff is always 0, instead of +15 or -15 to increment up down the row.
         * ;//qDebugA( << "\nsrc-LibArrowRow"<< src << keyboardnow.highlightedLibbuttonrow << (src-keyboardnow.highlightedLibbuttonrow);
         */
        connect( libRow[rr]->pushbutton, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
        //libRow[rr]->pushbutton->installEventFilter(this);
        connect( estRow[rr]->pushbutton, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
        //estRow[rr]->pushbutton->installEventFilter(this);

        estRow[rr]->pushbutton->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, ss ));
        estRow[rr]->pushbutton->setMaximumWidth( m7traild3 );
        //estRow[rr]->pushbutton->setMaximumHeight( m7traild3 );
        estRow[rr]->pushbutton->setFixedHeight( m7trailp3 );


        estRow[rr]->col[1]->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, ss ));
        connect( estRow[rr]->col[1], &QLineEdit::editingFinished, this, &MainWindow::doCalc );
        connect( estRow[rr]->col[1], &QLineEdit::inputRejected, this, &MainWindow::validateField );
        estRow[rr]->col[1]->installEventFilter(this);
        estRow[rr]->col[1]->setMaximumWidth( m6trail);
        estRow[rr]->col[1]->setMinimumWidth( m6trail);
        //estRow[rr]->col[1]->setMaximumHeight( m7traild3 );
        estRow[rr]->col[1]->setFixedHeight( m7trailp3 );

        estRow[rr]->col[1]->setMaxLength(3);
        estRow[rr]->col[1]->setFrame(globalFrame);

        estRow[rr]->col[2]->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, ss ));
        connect( estRow[rr]->col[2], &QLineEdit::editingFinished, this, &MainWindow::doCalc );
        connect( estRow[rr]->col[2], &QLineEdit::inputRejected, this, &MainWindow::validateField );
        estRow[rr]->col[2]->installEventFilter(this);
        estRow[rr]->col[2]->setMaximumWidth( m26trail);
        estRow[rr]->col[2]->setMinimumWidth( m25trail);
        //estRow[rr]->col[2]->setMaximumHeight( m7traild3 );
        estRow[rr]->col[2]->setFixedHeight( m7trailp3 );

        estRow[rr]->col[2]->setMaxLength(24);
        estRow[rr]->col[2]->setFrame(globalFrame);

        estRow[rr]->col[3]->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, ss ));
        connect( estRow[rr]->col[3], &QLineEdit::editingFinished, this, &MainWindow::doCalc );
        connect( estRow[rr]->col[3], &QLineEdit::inputRejected, this, &MainWindow::validateField );
        estRow[rr]->col[3]->installEventFilter(this);
        estRow[rr]->col[3]->setAlignment(Qt::AlignCenter);
        estRow[rr]->col[3]->setMaximumWidth( m11trail);
        estRow[rr]->col[3]->setMinimumWidth( m6trail);
        //estRow[rr]->col[3]->setMaximumHeight( m7traild3 );
        estRow[rr]->col[3]->setFixedHeight( m7trailp3 );

        estRow[rr]->col[3]->setMaxLength(8);
        estRow[rr]->col[3]->setFrame(globalFrame);

        estRow[rr]->col[4]->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, ss ));
        connect( estRow[rr]->col[4], &QLineEdit::editingFinished, this, &MainWindow::doCalc );
        connect( estRow[rr]->col[4], &QLineEdit::inputRejected, this, &MainWindow::validateField );
        estRow[rr]->col[4]->installEventFilter(this);
        estRow[rr]->col[4]->setAlignment(Qt::AlignCenter);
        estRow[rr]->col[4]->setMaximumWidth( m12trail);
        estRow[rr]->col[4]->setMinimumWidth( m6trail);
        //estRow[rr]->col[4]->setMaximumHeight( m7traild3 );
        estRow[rr]->col[4]->setFixedHeight( m7trailp3 );

        estRow[rr]->col[4]->setMaxLength(11);
        estRow[rr]->col[4]->setFrame(globalFrame);

        estRow[rr]->col[5]->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, ss ));
        connect( estRow[rr]->col[5], &QLineEdit::editingFinished, this, &MainWindow::doCalc );
        connect( estRow[rr]->col[5], &QLineEdit::inputRejected, this, &MainWindow::validateField );
        estRow[rr]->col[5]->installEventFilter(this);
        estRow[rr]->col[5]->setAlignment(Qt::AlignCenter);
        estRow[rr]->col[5]->setMaximumWidth( m12trail);
        estRow[rr]->col[5]->setMinimumWidth( m6trail);
        //estRow[rr]->col[5]->setMaximumHeight( m7traild3 );
        estRow[rr]->col[5]->setFixedHeight( m7trailp3 );

        estRow[rr]->col[5]->setMaxLength(11);
        estRow[rr]->col[5]->setFrame(globalFrame);

        estRow[rr]->col[6]->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, ss ));
        estRow[rr]->col[6]->setReadOnly(true);
        estRow[rr]->col[6]->setAlignment(Qt::AlignRight);
        estRow[rr]->col[6]->setMaximumWidth( m14trail);
        estRow[rr]->col[6]->setMinimumWidth( m9trail);
        //estRow[rr]->col[6]->setMaximumHeight( m7traild3 );
        estRow[rr]->col[6]->setFixedHeight( m7trailp3 );

        estRow[rr]->col[6]->setMaxLength(15);
        estRow[rr]->col[6]->setFrame(globalFrame);

        estRow[rr]->col[7]->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, ss ));
        estRow[rr]->col[7]->setReadOnly(true);
        estRow[rr]->col[7]->setAlignment(Qt::AlignRight);
        estRow[rr]->col[7]->setMaximumWidth( m14trail);
        estRow[rr]->col[7]->setMinimumWidth( m9trail);
        //estRow[rr]->col[7]->setMaximumHeight( m7traild3 );
        estRow[rr]->col[7]->setFixedHeight( m7trailp3 );

        estRow[rr]->col[7]->setMaxLength(15);
        estRow[rr]->col[7]->setFrame(globalFrame);
     }

#ifdef OLDWAYOrElseYouWouldNotBelieveItExisted
     ui->lib11->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "1     ") );
     connect( ui->lib11, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
     connect( ui->lib11, &QLineEdit::inputRejected, this, &MainWindow::validateField );
     connect( ui->pushButtonLib1, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
     connect( ui->pushButtonEst1, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
     ui->lib11->installEventFilter(this);
     ui->lib11->setMaximumWidth( m6trail);
     ui->lib11->setMinimumWidth( m6trail);
     ui->lib11->setMaximumHeight( m7traild3 );
     ui->lib11->setMaxLength(3);
     ui->lib11->setFrame(globalFrame);

     ui->lib12->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "1     ") );
     connect( ui->lib12, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
     connect( ui->lib12, &QLineEdit::inputRejected, this, &MainWindow::validateField );
     ui->lib12->installEventFilter(this);
     ui->lib12->setMaximumWidth( m26trail);
     ui->lib12->setMinimumWidth( m25trail);
     ui->lib12->setMaximumHeight( m7traild3 );
     ui->lib12->setMaxLength(24);
     ui->lib12->setFrame(globalFrame);

     ui->lib13->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "1     ") );
     connect( ui->lib13, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
     connect( ui->lib13, &QLineEdit::inputRejected, this, &MainWindow::validateField );
     ui->lib13->installEventFilter(this);
     ui->lib13->setAlignment(Qt::AlignCenter);
     ui->lib13->setMaximumWidth( m12trail);
     ui->lib13->setMinimumWidth( m6trail);
     ui->lib13->setMaximumHeight( m7traild3 );
     ui->lib13->setMaxLength(11);
     ui->lib13->setFrame(globalFrame);

     ui->lib14->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "1     ") );
     connect( ui->lib14, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
     connect( ui->lib14, &QLineEdit::inputRejected, this, &MainWindow::validateField );
     ui->lib14->installEventFilter(this);
     ui->lib14->setAlignment(Qt::AlignCenter);
     ui->lib14->setMaximumWidth( m12trail);
     ui->lib14->setMinimumWidth( m6trail);
     ui->lib14->setMaximumHeight( m7traild3 );
     ui->lib14->setMaxLength(11);
     ui->lib14->setFrame(globalFrame);

     ui->pushButtonEst1->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "1     ") );
     ui->pushButtonEst1->setMaximumWidth( m7traild3 );
     ui->pushButtonEst1->setMaximumHeight( m7traild3 );
     ui->pushButtonLib1->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "1     ") );
     ui->pushButtonLib1->setMaximumWidth( m7traild3 );
     ui->pushButtonLib1->setMaximumHeight( m7traild3 );

     ui->est11->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "1     ") );
     connect( ui->est11, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
     connect( ui->est11, &QLineEdit::inputRejected, this, &MainWindow::validateField );
     ui->est11->installEventFilter(this);
     ui->est11->setMaximumWidth( m6trail);
     ui->est11->setMinimumWidth( m6trail);
     ui->est11->setMaximumHeight( m7traild3 );
     ui->est11->setMaxLength(3);
     ui->est11->setFrame(globalFrame);

     ui->est12->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "1     ") );
     connect( ui->est12, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
     connect( ui->est12, &QLineEdit::inputRejected, this, &MainWindow::validateField );
     ui->est12->installEventFilter(this);
     ui->est12->setMaximumWidth( m26trail);
     ui->est12->setMinimumWidth( m25trail);
     ui->est12->setMaximumHeight( m7traild3 );
     ui->est12->setMaxLength(24);
     ui->est12->setFrame(globalFrame);

     ui->est13->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "1     ") );
     connect( ui->est13, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
     connect( ui->est13, &QLineEdit::inputRejected, this, &MainWindow::validateField );
     ui->est13->installEventFilter(this);
     ui->est13->setAlignment(Qt::AlignCenter);
     ui->est13->setMaximumWidth( m11trail);
     ui->est13->setMinimumWidth( m6trail);
     ui->est13->setMaximumHeight( m7traild3 );
     ui->est13->setMaxLength(8);
     ui->est13->setFrame(globalFrame);

     ui->est14->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "1     ") );
     connect( ui->est14, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
     connect( ui->est14, &QLineEdit::inputRejected, this, &MainWindow::validateField );
     ui->est14->installEventFilter(this);
     ui->est14->setAlignment(Qt::AlignCenter);
     ui->est14->setMaximumWidth( m12trail);
     ui->est14->setMinimumWidth( m6trail);
     ui->est14->setMaximumHeight( m7traild3 );
     ui->est14->setMaxLength(11);
     ui->est14->setFrame(globalFrame);

     ui->est15->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "1     ") );
     connect( ui->est15, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
     connect( ui->est15, &QLineEdit::inputRejected, this, &MainWindow::validateField );
     ui->est15->installEventFilter(this);
     ui->est15->setAlignment(Qt::AlignCenter);
     ui->est15->setMaximumWidth( m12trail);
     ui->est15->setMinimumWidth( m6trail);
     ui->est15->setMaximumHeight( m7traild3 );
     ui->est15->setMaxLength(11);
     ui->est15->setFrame(globalFrame);

     ui->est16->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "1     ") );
     ui->est16->setReadOnly(true);
     ui->est16->setAlignment(Qt::AlignRight);
     ui->est16->setMaximumWidth( m14trail);
     ui->est16->setMinimumWidth( m9trail);
     ui->est16->setMaximumHeight( m7traild3 );
     ui->est16->setMaxLength(15);
     ui->est16->setFrame(globalFrame);

     ui->est17->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "1     ") );
     ui->est17->setReadOnly(true);
     ui->est17->setAlignment(Qt::AlignRight);
     ui->est17->setMaximumWidth( m14trail);
     ui->est17->setMinimumWidth( m9trail);
     ui->est17->setMaximumHeight( m7traild3 );
     ui->est17->setMaxLength(15);
     ui->est17->setFrame(globalFrame);

ui->lib21->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "2     ") );
connect( ui->lib21, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib21, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib2, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst2, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib21->installEventFilter(this);
ui->lib21->setMaximumWidth( m6trail);
ui->lib21->setMinimumWidth( m6trail);
ui->lib21->setMaximumHeight( m7traild3 );
ui->lib21->setMaxLength(3);
ui->lib21->setFrame(globalFrame);

ui->lib22->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "2     ") );
connect( ui->lib22, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib22, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib22->installEventFilter(this);
ui->lib22->setMaximumWidth( m26trail);
ui->lib22->setMinimumWidth( m25trail);
ui->lib22->setMaximumHeight( m7traild3 );
ui->lib22->setMaxLength(24);
ui->lib22->setFrame(globalFrame);

ui->lib23->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "2     ") );
connect( ui->lib23, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib23, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib23->installEventFilter(this);
ui->lib23->setAlignment(Qt::AlignCenter);
ui->lib23->setMaximumWidth( m12trail);
ui->lib23->setMinimumWidth( m6trail);
ui->lib23->setMaximumHeight( m7traild3 );
ui->lib23->setMaxLength(11);
ui->lib23->setFrame(globalFrame);

ui->lib24->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "2     ") );
connect( ui->lib24, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib24, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib24->installEventFilter(this);
ui->lib24->setAlignment(Qt::AlignCenter);
ui->lib24->setMaximumWidth( m12trail);
ui->lib24->setMinimumWidth( m6trail);
ui->lib24->setMaximumHeight( m7traild3 );
ui->lib24->setMaxLength(11);
ui->lib24->setFrame(globalFrame);

ui->pushButtonEst2->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "2     ") );
ui->pushButtonEst2->setMaximumWidth( m7traild3 );
ui->pushButtonEst2->setMaximumHeight( m7traild3 );
ui->pushButtonLib2->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "2     ") );
ui->pushButtonLib2->setMaximumWidth( m7traild3 );
ui->pushButtonLib2->setMaximumHeight( m7traild3 );

ui->est21->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "2     ") );
connect( ui->est21, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est21, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est21->installEventFilter(this);
ui->est21->setMaximumWidth( m6trail);
ui->est21->setMinimumWidth( m6trail);
ui->est21->setMaximumHeight( m7traild3 );
ui->est21->setMaxLength(3);
ui->est21->setFrame(globalFrame);

ui->est22->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "2     ") );
connect( ui->est22, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est22, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est22->installEventFilter(this);
ui->est22->setMaximumWidth( m26trail);
ui->est22->setMinimumWidth( m25trail);
ui->est22->setMaximumHeight( m7traild3 );
ui->est22->setMaxLength(24);
ui->est22->setFrame(globalFrame);

ui->est23->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "2     ") );
connect( ui->est23, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est23, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est23->installEventFilter(this);
ui->est23->setAlignment(Qt::AlignCenter);
ui->est23->setMaximumWidth( m11trail);
ui->est23->setMinimumWidth( m6trail);
ui->est23->setMaximumHeight( m7traild3 );
ui->est23->setMaxLength(8);
ui->est23->setFrame(globalFrame);

ui->est24->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "2     ") );
connect( ui->est24, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est24, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est24->installEventFilter(this);
ui->est24->setAlignment(Qt::AlignCenter);
ui->est24->setMaximumWidth( m12trail);
ui->est24->setMinimumWidth( m6trail);
ui->est24->setMaximumHeight( m7traild3 );
ui->est24->setMaxLength(11);
ui->est24->setFrame(globalFrame);

ui->est25->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "2     ") );
connect( ui->est25, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est25, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est25->installEventFilter(this);
ui->est25->setAlignment(Qt::AlignCenter);
ui->est25->setMaximumWidth( m12trail);
ui->est25->setMinimumWidth( m6trail);
ui->est25->setMaximumHeight( m7traild3 );
ui->est25->setMaxLength(11);
ui->est25->setFrame(globalFrame);

ui->est26->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "2     ") );
ui->est26->setReadOnly(true);
ui->est26->setAlignment(Qt::AlignRight);
ui->est26->setMaximumWidth( m14trail);
ui->est26->setMinimumWidth( m9trail);
ui->est26->setMaximumHeight( m7traild3 );
ui->est26->setMaxLength(15);
ui->est26->setFrame(globalFrame);

ui->est27->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "2     ") );
ui->est27->setReadOnly(true);
ui->est27->setAlignment(Qt::AlignRight);
ui->est27->setMaximumWidth( m14trail);
ui->est27->setMinimumWidth( m9trail);
ui->est27->setMaximumHeight( m7traild3 );
ui->est27->setMaxLength(15);
ui->est27->setFrame(globalFrame);

ui->lib31->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "3     ") );
connect( ui->lib31, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib31, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib3, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst3, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib31->installEventFilter(this);
ui->lib31->setMaximumWidth( m6trail);
ui->lib31->setMinimumWidth( m6trail);
ui->lib31->setMaximumHeight( m7traild3 );
ui->lib31->setMaxLength(3);
ui->lib31->setFrame(globalFrame);

ui->lib32->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "3     ") );
connect( ui->lib32, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib32, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib32->installEventFilter(this);
ui->lib32->setMaximumWidth( m26trail);
ui->lib32->setMinimumWidth( m25trail);
ui->lib32->setMaximumHeight( m7traild3 );
ui->lib32->setMaxLength(24);
ui->lib32->setFrame(globalFrame);

ui->lib33->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "3     ") );
connect( ui->lib33, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib33, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib33->installEventFilter(this);
ui->lib33->setAlignment(Qt::AlignCenter);
ui->lib33->setMaximumWidth( m12trail);
ui->lib33->setMinimumWidth( m6trail);
ui->lib33->setMaximumHeight( m7traild3 );
ui->lib33->setMaxLength(11);
ui->lib33->setFrame(globalFrame);

ui->lib34->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "3     ") );
connect( ui->lib34, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib34, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib34->installEventFilter(this);
ui->lib34->setAlignment(Qt::AlignCenter);
ui->lib34->setMaximumWidth( m12trail);
ui->lib34->setMinimumWidth( m6trail);
ui->lib34->setMaximumHeight( m7traild3 );
ui->lib34->setMaxLength(11);
ui->lib34->setFrame(globalFrame);

ui->pushButtonEst3->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "3     ") );
ui->pushButtonEst3->setMaximumWidth( m7traild3 );
ui->pushButtonEst3->setMaximumHeight( m7traild3 );
ui->pushButtonLib3->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "3     ") );
ui->pushButtonLib3->setMaximumWidth( m7traild3 );
ui->pushButtonLib3->setMaximumHeight( m7traild3 );

ui->est31->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "3     ") );
connect( ui->est31, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est31, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est31->installEventFilter(this);
ui->est31->setMaximumWidth( m6trail);
ui->est31->setMinimumWidth( m6trail);
ui->est31->setMaximumHeight( m7traild3 );
ui->est31->setMaxLength(3);
ui->est31->setFrame(globalFrame);

ui->est32->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "3     ") );
connect( ui->est32, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est32, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est32->installEventFilter(this);
ui->est32->setMaximumWidth( m26trail);
ui->est32->setMinimumWidth( m25trail);
ui->est32->setMaximumHeight( m7traild3 );
ui->est32->setMaxLength(24);
ui->est32->setFrame(globalFrame);

ui->est33->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "3     ") );
connect( ui->est33, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est33, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est33->installEventFilter(this);
ui->est33->setAlignment(Qt::AlignCenter);
ui->est33->setMaximumWidth( m11trail);
ui->est33->setMinimumWidth( m6trail);
ui->est33->setMaximumHeight( m7traild3 );
ui->est33->setMaxLength(8);
ui->est33->setFrame(globalFrame);

ui->est34->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "3     ") );
connect( ui->est34, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est34, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est34->installEventFilter(this);
ui->est34->setAlignment(Qt::AlignCenter);
ui->est34->setMaximumWidth( m12trail);
ui->est34->setMinimumWidth( m6trail);
ui->est34->setMaximumHeight( m7traild3 );
ui->est34->setMaxLength(11);
ui->est34->setFrame(globalFrame);

ui->est35->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "3     ") );
connect( ui->est35, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est35, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est35->installEventFilter(this);
ui->est35->setAlignment(Qt::AlignCenter);
ui->est35->setMaximumWidth( m12trail);
ui->est35->setMinimumWidth( m6trail);
ui->est35->setMaximumHeight( m7traild3 );
ui->est35->setMaxLength(11);
ui->est35->setFrame(globalFrame);

ui->est36->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "3     ") );
ui->est36->setReadOnly(true);
ui->est36->setAlignment(Qt::AlignRight);
ui->est36->setMaximumWidth( m14trail);
ui->est36->setMinimumWidth( m9trail);
ui->est36->setMaximumHeight( m7traild3 );
ui->est36->setMaxLength(15);
ui->est36->setFrame(globalFrame);

ui->est37->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "3     ") );
ui->est37->setReadOnly(true);
ui->est37->setAlignment(Qt::AlignRight);
ui->est37->setMaximumWidth( m14trail);
ui->est37->setMinimumWidth( m9trail);
ui->est37->setMaximumHeight( m7traild3 );
ui->est37->setMaxLength(15);
ui->est37->setFrame(globalFrame);

ui->lib41->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "4     ") );
connect( ui->lib41, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib41, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib4, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst4, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib41->installEventFilter(this);
ui->lib41->setMaximumWidth( m6trail);
ui->lib41->setMinimumWidth( m6trail);
ui->lib41->setMaximumHeight( m7traild3 );
ui->lib41->setMaxLength(3);
ui->lib41->setFrame(globalFrame);

ui->lib42->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "4     ") );
connect( ui->lib42, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib42, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib42->installEventFilter(this);
ui->lib42->setMaximumWidth( m26trail);
ui->lib42->setMinimumWidth( m25trail);
ui->lib42->setMaximumHeight( m7traild3 );
ui->lib42->setMaxLength(24);
ui->lib42->setFrame(globalFrame);

ui->lib43->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "4     ") );
connect( ui->lib43, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib43, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib43->installEventFilter(this);
ui->lib43->setAlignment(Qt::AlignCenter);
ui->lib43->setMaximumWidth( m12trail);
ui->lib43->setMinimumWidth( m6trail);
ui->lib43->setMaximumHeight( m7traild3 );
ui->lib43->setMaxLength(11);
ui->lib43->setFrame(globalFrame);

ui->lib44->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "4     ") );
connect( ui->lib44, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib44, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib44->installEventFilter(this);
ui->lib44->setAlignment(Qt::AlignCenter);
ui->lib44->setMaximumWidth( m12trail);
ui->lib44->setMinimumWidth( m6trail);
ui->lib44->setMaximumHeight( m7traild3 );
ui->lib44->setMaxLength(11);
ui->lib44->setFrame(globalFrame);

ui->pushButtonEst4->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "4     ") );
ui->pushButtonEst4->setMaximumWidth( m7traild3 );
ui->pushButtonEst4->setMaximumHeight( m7traild3 );
ui->pushButtonLib4->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "4     ") );
ui->pushButtonLib4->setMaximumWidth( m7traild3 );
ui->pushButtonLib4->setMaximumHeight( m7traild3 );

ui->est41->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "4     ") );
connect( ui->est41, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est41, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est41->installEventFilter(this);
ui->est41->setMaximumWidth( m6trail);
ui->est41->setMinimumWidth( m6trail);
ui->est41->setMaximumHeight( m7traild3 );
ui->est41->setMaxLength(3);
ui->est41->setFrame(globalFrame);

ui->est42->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "4     ") );
connect( ui->est42, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est42, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est42->installEventFilter(this);
ui->est42->setMaximumWidth( m26trail);
ui->est42->setMinimumWidth( m25trail);
ui->est42->setMaximumHeight( m7traild3 );
ui->est42->setMaxLength(24);
ui->est42->setFrame(globalFrame);

ui->est43->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "4     ") );
connect( ui->est43, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est43, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est43->installEventFilter(this);
ui->est43->setAlignment(Qt::AlignCenter);
ui->est43->setMaximumWidth( m11trail);
ui->est43->setMinimumWidth( m6trail);
ui->est43->setMaximumHeight( m7traild3 );
ui->est43->setMaxLength(8);
ui->est43->setFrame(globalFrame);

ui->est44->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "4     ") );
connect( ui->est44, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est44, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est44->installEventFilter(this);
ui->est44->setAlignment(Qt::AlignCenter);
ui->est44->setMaximumWidth( m12trail);
ui->est44->setMinimumWidth( m6trail);
ui->est44->setMaximumHeight( m7traild3 );
ui->est44->setMaxLength(11);
ui->est44->setFrame(globalFrame);

ui->est45->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "4     ") );
connect( ui->est45, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est45, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est45->installEventFilter(this);
ui->est45->setAlignment(Qt::AlignCenter);
ui->est45->setMaximumWidth( m12trail);
ui->est45->setMinimumWidth( m6trail);
ui->est45->setMaximumHeight( m7traild3 );
ui->est45->setMaxLength(11);
ui->est45->setFrame(globalFrame);

ui->est46->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "4     ") );
ui->est46->setReadOnly(true);
ui->est46->setAlignment(Qt::AlignRight);
ui->est46->setMaximumWidth( m14trail);
ui->est46->setMinimumWidth( m9trail);
ui->est46->setMaximumHeight( m7traild3 );
ui->est46->setMaxLength(15);
ui->est46->setFrame(globalFrame);

ui->est47->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "4     ") );
ui->est47->setReadOnly(true);
ui->est47->setAlignment(Qt::AlignRight);
ui->est47->setMaximumWidth( m14trail);
ui->est47->setMinimumWidth( m9trail);
ui->est47->setMaximumHeight( m7traild3 );
ui->est47->setMaxLength(15);
ui->est47->setFrame(globalFrame);

ui->lib51->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "5     ") );
connect( ui->lib51, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib51, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib5, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst5, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib51->installEventFilter(this);
ui->lib51->setMaximumWidth( m6trail);
ui->lib51->setMinimumWidth( m6trail);
ui->lib51->setMaximumHeight( m7traild3 );
ui->lib51->setMaxLength(3);
ui->lib51->setFrame(globalFrame);

ui->lib52->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "5     ") );
connect( ui->lib52, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib52, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib52->installEventFilter(this);
ui->lib52->setMaximumWidth( m26trail);
ui->lib52->setMinimumWidth( m25trail);
ui->lib52->setMaximumHeight( m7traild3 );
ui->lib52->setMaxLength(24);
ui->lib52->setFrame(globalFrame);

ui->lib53->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "5     ") );
connect( ui->lib53, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib53, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib53->installEventFilter(this);
ui->lib53->setAlignment(Qt::AlignCenter);
ui->lib53->setMaximumWidth( m12trail);
ui->lib53->setMinimumWidth( m6trail);
ui->lib53->setMaximumHeight( m7traild3 );
ui->lib53->setMaxLength(11);
ui->lib53->setFrame(globalFrame);

ui->lib54->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "5     ") );
connect( ui->lib54, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib54, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib54->installEventFilter(this);
ui->lib54->setAlignment(Qt::AlignCenter);
ui->lib54->setMaximumWidth( m12trail);
ui->lib54->setMinimumWidth( m6trail);
ui->lib54->setMaximumHeight( m7traild3 );
ui->lib54->setMaxLength(11);
ui->lib54->setFrame(globalFrame);

ui->pushButtonEst5->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "5     ") );
ui->pushButtonEst5->setMaximumWidth( m7traild3 );
ui->pushButtonEst5->setMaximumHeight( m7traild3 );
ui->pushButtonLib5->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "5     ") );
ui->pushButtonLib5->setMaximumWidth( m7traild3 );
ui->pushButtonLib5->setMaximumHeight( m7traild3 );

ui->est51->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "5     ") );
connect( ui->est51, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est51, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est51->installEventFilter(this);
ui->est51->setMaximumWidth( m6trail);
ui->est51->setMinimumWidth( m6trail);
ui->est51->setMaximumHeight( m7traild3 );
ui->est51->setMaxLength(3);
ui->est51->setFrame(globalFrame);

ui->est52->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "5     ") );
connect( ui->est52, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est52, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est52->installEventFilter(this);
ui->est52->setMaximumWidth( m26trail);
ui->est52->setMinimumWidth( m25trail);
ui->est52->setMaximumHeight( m7traild3 );
ui->est52->setMaxLength(24);
ui->est52->setFrame(globalFrame);

ui->est53->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "5     ") );
connect( ui->est53, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est53, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est53->installEventFilter(this);
ui->est53->setAlignment(Qt::AlignCenter);
ui->est53->setMaximumWidth( m11trail);
ui->est53->setMinimumWidth( m6trail);
ui->est53->setMaximumHeight( m7traild3 );
ui->est53->setMaxLength(8);
ui->est53->setFrame(globalFrame);

ui->est54->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "5     ") );
connect( ui->est54, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est54, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est54->installEventFilter(this);
ui->est54->setAlignment(Qt::AlignCenter);
ui->est54->setMaximumWidth( m12trail);
ui->est54->setMinimumWidth( m6trail);
ui->est54->setMaximumHeight( m7traild3 );
ui->est54->setMaxLength(11);
ui->est54->setFrame(globalFrame);

ui->est55->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "5     ") );
connect( ui->est55, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est55, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est55->installEventFilter(this);
ui->est55->setAlignment(Qt::AlignCenter);
ui->est55->setMaximumWidth( m12trail);
ui->est55->setMinimumWidth( m6trail);
ui->est55->setMaximumHeight( m7traild3 );
ui->est55->setMaxLength(11);
ui->est55->setFrame(globalFrame);

ui->est56->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "5     ") );
ui->est56->setReadOnly(true);
ui->est56->setAlignment(Qt::AlignRight);
ui->est56->setMaximumWidth( m14trail);
ui->est56->setMinimumWidth( m9trail);
ui->est56->setMaximumHeight( m7traild3 );
ui->est56->setMaxLength(15);
ui->est56->setFrame(globalFrame);

ui->est57->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "5     ") );
ui->est57->setReadOnly(true);
ui->est57->setAlignment(Qt::AlignRight);
ui->est57->setMaximumWidth( m14trail);
ui->est57->setMinimumWidth( m9trail);
ui->est57->setMaximumHeight( m7traild3 );
ui->est57->setMaxLength(15);
ui->est57->setFrame(globalFrame);

ui->lib61->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "6     ") );
connect( ui->lib61, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib61, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib6, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst6, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib61->installEventFilter(this);
ui->lib61->setMaximumWidth( m6trail);
ui->lib61->setMinimumWidth( m6trail);
ui->lib61->setMaximumHeight( m7traild3 );
ui->lib61->setMaxLength(3);
ui->lib61->setFrame(globalFrame);

ui->lib62->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "6     ") );
connect( ui->lib62, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib62, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib62->installEventFilter(this);
ui->lib62->setMaximumWidth( m26trail);
ui->lib62->setMinimumWidth( m25trail);
ui->lib62->setMaximumHeight( m7traild3 );
ui->lib62->setMaxLength(24);
ui->lib62->setFrame(globalFrame);

ui->lib63->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "6     ") );
connect( ui->lib63, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib63, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib63->installEventFilter(this);
ui->lib63->setAlignment(Qt::AlignCenter);
ui->lib63->setMaximumWidth( m12trail);
ui->lib63->setMinimumWidth( m6trail);
ui->lib63->setMaximumHeight( m7traild3 );
ui->lib63->setMaxLength(11);
ui->lib63->setFrame(globalFrame);

ui->lib64->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "6     ") );
connect( ui->lib64, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib64, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib64->installEventFilter(this);
ui->lib64->setAlignment(Qt::AlignCenter);
ui->lib64->setMaximumWidth( m12trail);
ui->lib64->setMinimumWidth( m6trail);
ui->lib64->setMaximumHeight( m7traild3 );
ui->lib64->setMaxLength(11);
ui->lib64->setFrame(globalFrame);

ui->pushButtonEst6->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "6     ") );
ui->pushButtonEst6->setMaximumWidth( m7traild3 );
ui->pushButtonEst6->setMaximumHeight( m7traild3 );
ui->pushButtonLib6->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "6     ") );
ui->pushButtonLib6->setMaximumWidth( m7traild3 );
ui->pushButtonLib6->setMaximumHeight( m7traild3 );

ui->est61->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "6     ") );
connect( ui->est61, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est61, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est61->installEventFilter(this);
ui->est61->setMaximumWidth( m6trail);
ui->est61->setMinimumWidth( m6trail);
ui->est61->setMaximumHeight( m7traild3 );
ui->est61->setMaxLength(3);
ui->est61->setFrame(globalFrame);

ui->est62->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "6     ") );
connect( ui->est62, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est62, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est62->installEventFilter(this);
ui->est62->setMaximumWidth( m26trail);
ui->est62->setMinimumWidth( m25trail);
ui->est62->setMaximumHeight( m7traild3 );
ui->est62->setMaxLength(24);
ui->est62->setFrame(globalFrame);

ui->est63->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "6     ") );
connect( ui->est63, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est63, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est63->installEventFilter(this);
ui->est63->setAlignment(Qt::AlignCenter);
ui->est63->setMaximumWidth( m11trail);
ui->est63->setMinimumWidth( m6trail);
ui->est63->setMaximumHeight( m7traild3 );
ui->est63->setMaxLength(8);
ui->est63->setFrame(globalFrame);

ui->est64->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "6     ") );
connect( ui->est64, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est64, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est64->installEventFilter(this);
ui->est64->setAlignment(Qt::AlignCenter);
ui->est64->setMaximumWidth( m12trail);
ui->est64->setMinimumWidth( m6trail);
ui->est64->setMaximumHeight( m7traild3 );
ui->est64->setMaxLength(11);
ui->est64->setFrame(globalFrame);

ui->est65->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "6     ") );
connect( ui->est65, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est65, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est65->installEventFilter(this);
ui->est65->setAlignment(Qt::AlignCenter);
ui->est65->setMaximumWidth( m12trail);
ui->est65->setMinimumWidth( m6trail);
ui->est65->setMaximumHeight( m7traild3 );
ui->est65->setMaxLength(11);
ui->est65->setFrame(globalFrame);

ui->est66->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "6     ") );
ui->est66->setReadOnly(true);
ui->est66->setAlignment(Qt::AlignRight);
ui->est66->setMaximumWidth( m14trail);
ui->est66->setMinimumWidth( m9trail);
ui->est66->setMaximumHeight( m7traild3 );
ui->est66->setMaxLength(15);
ui->est66->setFrame(globalFrame);

ui->est67->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "6     ") );
ui->est67->setReadOnly(true);
ui->est67->setAlignment(Qt::AlignRight);
ui->est67->setMaximumWidth( m14trail);
ui->est67->setMinimumWidth( m9trail);
ui->est67->setMaximumHeight( m7traild3 );
ui->est67->setMaxLength(15);
ui->est67->setFrame(globalFrame);

ui->lib71->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "7     ") );
connect( ui->lib71, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib71, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib7, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst7, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib71->installEventFilter(this);
ui->lib71->setMaximumWidth( m6trail);
ui->lib71->setMinimumWidth( m6trail);
ui->lib71->setMaximumHeight( m7traild3 );
ui->lib71->setMaxLength(3);
ui->lib71->setFrame(globalFrame);

ui->lib72->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "7     ") );
connect( ui->lib72, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib72, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib72->installEventFilter(this);
ui->lib72->setMaximumWidth( m26trail);
ui->lib72->setMinimumWidth( m25trail);
ui->lib72->setMaximumHeight( m7traild3 );
ui->lib72->setMaxLength(24);
ui->lib72->setFrame(globalFrame);

ui->lib73->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "7     ") );
connect( ui->lib73, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib73, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib73->installEventFilter(this);
ui->lib73->setAlignment(Qt::AlignCenter);
ui->lib73->setMaximumWidth( m12trail);
ui->lib73->setMinimumWidth( m6trail);
ui->lib73->setMaximumHeight( m7traild3 );
ui->lib73->setMaxLength(11);
ui->lib73->setFrame(globalFrame);

ui->lib74->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "7     ") );
connect( ui->lib74, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib74, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib74->installEventFilter(this);
ui->lib74->setAlignment(Qt::AlignCenter);
ui->lib74->setMaximumWidth( m12trail);
ui->lib74->setMinimumWidth( m6trail);
ui->lib74->setMaximumHeight( m7traild3 );
ui->lib74->setMaxLength(11);
ui->lib74->setFrame(globalFrame);

ui->pushButtonEst7->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "7     ") );
ui->pushButtonEst7->setMaximumWidth( m7traild3 );
ui->pushButtonEst7->setMaximumHeight( m7traild3 );
ui->pushButtonLib7->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "7     ") );
ui->pushButtonLib7->setMaximumWidth( m7traild3 );
ui->pushButtonLib7->setMaximumHeight( m7traild3 );

ui->est71->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "7     ") );
connect( ui->est71, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est71, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est71->installEventFilter(this);
ui->est71->setMaximumWidth( m6trail);
ui->est71->setMinimumWidth( m6trail);
ui->est71->setMaximumHeight( m7traild3 );
ui->est71->setMaxLength(3);
ui->est71->setFrame(globalFrame);

ui->est72->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "7     ") );
connect( ui->est72, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est72, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est72->installEventFilter(this);
ui->est72->setMaximumWidth( m26trail);
ui->est72->setMinimumWidth( m25trail);
ui->est72->setMaximumHeight( m7traild3 );
ui->est72->setMaxLength(24);
ui->est72->setFrame(globalFrame);

ui->est73->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "7     ") );
connect( ui->est73, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est73, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est73->installEventFilter(this);
ui->est73->setAlignment(Qt::AlignCenter);
ui->est73->setMaximumWidth( m11trail);
ui->est73->setMinimumWidth( m6trail);
ui->est73->setMaximumHeight( m7traild3 );
ui->est73->setMaxLength(8);
ui->est73->setFrame(globalFrame);

ui->est74->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "7     ") );
connect( ui->est74, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est74, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est74->installEventFilter(this);
ui->est74->setAlignment(Qt::AlignCenter);
ui->est74->setMaximumWidth( m12trail);
ui->est74->setMinimumWidth( m6trail);
ui->est74->setMaximumHeight( m7traild3 );
ui->est74->setMaxLength(11);
ui->est74->setFrame(globalFrame);

ui->est75->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "7     ") );
connect( ui->est75, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est75, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est75->installEventFilter(this);
ui->est75->setAlignment(Qt::AlignCenter);
ui->est75->setMaximumWidth( m12trail);
ui->est75->setMinimumWidth( m6trail);
ui->est75->setMaximumHeight( m7traild3 );
ui->est75->setMaxLength(11);
ui->est75->setFrame(globalFrame);

ui->est76->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "7     ") );
ui->est76->setReadOnly(true);
ui->est76->setAlignment(Qt::AlignRight);
ui->est76->setMaximumWidth( m14trail);
ui->est76->setMinimumWidth( m9trail);
ui->est76->setMaximumHeight( m7traild3 );
ui->est76->setMaxLength(15);
ui->est76->setFrame(globalFrame);

ui->est77->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "7     ") );
ui->est77->setReadOnly(true);
ui->est77->setAlignment(Qt::AlignRight);
ui->est77->setMaximumWidth( m14trail);
ui->est77->setMinimumWidth( m9trail);
ui->est77->setMaximumHeight( m7traild3 );
ui->est77->setMaxLength(15);
ui->est77->setFrame(globalFrame);

ui->lib81->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "8     ") );
connect( ui->lib81, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib81, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib8, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst8, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib81->installEventFilter(this);
ui->lib81->setMaximumWidth( m6trail);
ui->lib81->setMinimumWidth( m6trail);
ui->lib81->setMaximumHeight( m7traild3 );
ui->lib81->setMaxLength(3);
ui->lib81->setFrame(globalFrame);

ui->lib82->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "8     ") );
connect( ui->lib82, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib82, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib82->installEventFilter(this);
ui->lib82->setMaximumWidth( m26trail);
ui->lib82->setMinimumWidth( m25trail);
ui->lib82->setMaximumHeight( m7traild3 );
ui->lib82->setMaxLength(24);
ui->lib82->setFrame(globalFrame);

ui->lib83->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "8     ") );
connect( ui->lib83, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib83, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib83->installEventFilter(this);
ui->lib83->setAlignment(Qt::AlignCenter);
ui->lib83->setMaximumWidth( m12trail);
ui->lib83->setMinimumWidth( m6trail);
ui->lib83->setMaximumHeight( m7traild3 );
ui->lib83->setMaxLength(11);
ui->lib83->setFrame(globalFrame);

ui->lib84->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "8     ") );
connect( ui->lib84, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib84, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib84->installEventFilter(this);
ui->lib84->setAlignment(Qt::AlignCenter);
ui->lib84->setMaximumWidth( m12trail);
ui->lib84->setMinimumWidth( m6trail);
ui->lib84->setMaximumHeight( m7traild3 );
ui->lib84->setMaxLength(11);
ui->lib84->setFrame(globalFrame);

ui->pushButtonEst8->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "8     ") );
ui->pushButtonEst8->setMaximumWidth( m7traild3 );
ui->pushButtonEst8->setMaximumHeight( m7traild3 );
ui->pushButtonLib8->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "8     ") );
ui->pushButtonLib8->setMaximumWidth( m7traild3 );
ui->pushButtonLib8->setMaximumHeight( m7traild3 );

ui->est81->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "8     ") );
connect( ui->est81, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est81, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est81->installEventFilter(this);
ui->est81->setMaximumWidth( m6trail);
ui->est81->setMinimumWidth( m6trail);
ui->est81->setMaximumHeight( m7traild3 );
ui->est81->setMaxLength(3);
ui->est81->setFrame(globalFrame);

ui->est82->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "8     ") );
connect( ui->est82, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est82, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est82->installEventFilter(this);
ui->est82->setMaximumWidth( m26trail);
ui->est82->setMinimumWidth( m25trail);
ui->est82->setMaximumHeight( m7traild3 );
ui->est82->setMaxLength(24);
ui->est82->setFrame(globalFrame);

ui->est83->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "8     ") );
connect( ui->est83, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est83, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est83->installEventFilter(this);
ui->est83->setAlignment(Qt::AlignCenter);
ui->est83->setMaximumWidth( m11trail);
ui->est83->setMinimumWidth( m6trail);
ui->est83->setMaximumHeight( m7traild3 );
ui->est83->setMaxLength(8);
ui->est83->setFrame(globalFrame);

ui->est84->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "8     ") );
connect( ui->est84, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est84, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est84->installEventFilter(this);
ui->est84->setAlignment(Qt::AlignCenter);
ui->est84->setMaximumWidth( m12trail);
ui->est84->setMinimumWidth( m6trail);
ui->est84->setMaximumHeight( m7traild3 );
ui->est84->setMaxLength(11);
ui->est84->setFrame(globalFrame);

ui->est85->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "8     ") );
connect( ui->est85, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est85, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est85->installEventFilter(this);
ui->est85->setAlignment(Qt::AlignCenter);
ui->est85->setMaximumWidth( m12trail);
ui->est85->setMinimumWidth( m6trail);
ui->est85->setMaximumHeight( m7traild3 );
ui->est85->setMaxLength(11);
ui->est85->setFrame(globalFrame);

ui->est86->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "8     ") );
ui->est86->setReadOnly(true);
ui->est86->setAlignment(Qt::AlignRight);
ui->est86->setMaximumWidth( m14trail);
ui->est86->setMinimumWidth( m9trail);
ui->est86->setMaximumHeight( m7traild3 );
ui->est86->setMaxLength(15);
ui->est86->setFrame(globalFrame);

ui->est87->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "8     ") );
ui->est87->setReadOnly(true);
ui->est87->setAlignment(Qt::AlignRight);
ui->est87->setMaximumWidth( m14trail);
ui->est87->setMinimumWidth( m9trail);
ui->est87->setMaximumHeight( m7traild3 );
ui->est87->setMaxLength(15);
ui->est87->setFrame(globalFrame);

ui->lib91->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "9     ") );
connect( ui->lib91, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib91, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib9, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst9, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib91->installEventFilter(this);
ui->lib91->setMaximumWidth( m6trail);
ui->lib91->setMinimumWidth( m6trail);
ui->lib91->setMaximumHeight( m7traild3 );
ui->lib91->setMaxLength(3);
ui->lib91->setFrame(globalFrame);

ui->lib92->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "9     ") );
connect( ui->lib92, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib92, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib92->installEventFilter(this);
ui->lib92->setMaximumWidth( m26trail);
ui->lib92->setMinimumWidth( m25trail);
ui->lib92->setMaximumHeight( m7traild3 );
ui->lib92->setMaxLength(24);
ui->lib92->setFrame(globalFrame);

ui->lib93->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "9     ") );
connect( ui->lib93, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib93, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib93->installEventFilter(this);
ui->lib93->setAlignment(Qt::AlignCenter);
ui->lib93->setMaximumWidth( m12trail);
ui->lib93->setMinimumWidth( m6trail);
ui->lib93->setMaximumHeight( m7traild3 );
ui->lib93->setMaxLength(11);
ui->lib93->setFrame(globalFrame);

ui->lib94->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "9     ") );
connect( ui->lib94, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib94, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib94->installEventFilter(this);
ui->lib94->setAlignment(Qt::AlignCenter);
ui->lib94->setMaximumWidth( m12trail);
ui->lib94->setMinimumWidth( m6trail);
ui->lib94->setMaximumHeight( m7traild3 );
ui->lib94->setMaxLength(11);
ui->lib94->setFrame(globalFrame);

ui->pushButtonEst9->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "9     ") );
ui->pushButtonEst9->setMaximumWidth( m7traild3 );
ui->pushButtonEst9->setMaximumHeight( m7traild3 );
ui->pushButtonLib9->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "9     ") );
ui->pushButtonLib9->setMaximumWidth( m7traild3 );
ui->pushButtonLib9->setMaximumHeight( m7traild3 );

ui->est91->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "9     ") );
connect( ui->est91, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est91, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est91->installEventFilter(this);
ui->est91->setMaximumWidth( m6trail);
ui->est91->setMinimumWidth( m6trail);
ui->est91->setMaximumHeight( m7traild3 );
ui->est91->setMaxLength(3);
ui->est91->setFrame(globalFrame);

ui->est92->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "9     ") );
connect( ui->est92, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est92, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est92->installEventFilter(this);
ui->est92->setMaximumWidth( m26trail);
ui->est92->setMinimumWidth( m25trail);
ui->est92->setMaximumHeight( m7traild3 );
ui->est92->setMaxLength(24);
ui->est92->setFrame(globalFrame);

ui->est93->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "9     ") );
connect( ui->est93, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est93, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est93->installEventFilter(this);
ui->est93->setAlignment(Qt::AlignCenter);
ui->est93->setMaximumWidth( m11trail);
ui->est93->setMinimumWidth( m6trail);
ui->est93->setMaximumHeight( m7traild3 );
ui->est93->setMaxLength(8);
ui->est93->setFrame(globalFrame);

ui->est94->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "9     ") );
connect( ui->est94, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est94, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est94->installEventFilter(this);
ui->est94->setAlignment(Qt::AlignCenter);
ui->est94->setMaximumWidth( m12trail);
ui->est94->setMinimumWidth( m6trail);
ui->est94->setMaximumHeight( m7traild3 );
ui->est94->setMaxLength(11);
ui->est94->setFrame(globalFrame);

ui->est95->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "9     ") );
connect( ui->est95, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est95, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est95->installEventFilter(this);
ui->est95->setAlignment(Qt::AlignCenter);
ui->est95->setMaximumWidth( m12trail);
ui->est95->setMinimumWidth( m6trail);
ui->est95->setMaximumHeight( m7traild3 );
ui->est95->setMaxLength(11);
ui->est95->setFrame(globalFrame);

ui->est96->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "9     ") );
ui->est96->setReadOnly(true);
ui->est96->setAlignment(Qt::AlignRight);
ui->est96->setMaximumWidth( m14trail);
ui->est96->setMinimumWidth( m9trail);
ui->est96->setMaximumHeight( m7traild3 );
ui->est96->setMaxLength(15);
ui->est96->setFrame(globalFrame);

ui->est97->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "9     ") );
ui->est97->setReadOnly(true);
ui->est97->setAlignment(Qt::AlignRight);
ui->est97->setMaximumWidth( m14trail);
ui->est97->setMinimumWidth( m9trail);
ui->est97->setMaximumHeight( m7traild3 );
ui->est97->setMaxLength(15);
ui->est97->setFrame(globalFrame);

ui->lib101->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "10    ") );
connect( ui->lib101, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib101, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib10, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst10, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib101->installEventFilter(this);
ui->lib101->setMaximumWidth( m6trail);
ui->lib101->setMinimumWidth( m6trail);
ui->lib101->setMaximumHeight( m7traild3 );
ui->lib101->setMaxLength(3);
ui->lib101->setFrame(globalFrame);

ui->lib102->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "10    ") );
connect( ui->lib102, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib102, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib102->installEventFilter(this);
ui->lib102->setMaximumWidth( m26trail);
ui->lib102->setMinimumWidth( m25trail);
ui->lib102->setMaximumHeight( m7traild3 );
ui->lib102->setMaxLength(24);
ui->lib102->setFrame(globalFrame);

ui->lib103->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "10    ") );
connect( ui->lib103, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib103, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib103->installEventFilter(this);
ui->lib103->setAlignment(Qt::AlignCenter);
ui->lib103->setMaximumWidth( m12trail);
ui->lib103->setMinimumWidth( m6trail);
ui->lib103->setMaximumHeight( m7traild3 );
ui->lib103->setMaxLength(11);
ui->lib103->setFrame(globalFrame);

ui->lib104->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "10    ") );
connect( ui->lib104, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib104, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib104->installEventFilter(this);
ui->lib104->setAlignment(Qt::AlignCenter);
ui->lib104->setMaximumWidth( m12trail);
ui->lib104->setMinimumWidth( m6trail);
ui->lib104->setMaximumHeight( m7traild3 );
ui->lib104->setMaxLength(11);
ui->lib104->setFrame(globalFrame);

ui->pushButtonEst10->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "10    ") );
ui->pushButtonEst10->setMaximumWidth( m7traild3 );
ui->pushButtonEst10->setMaximumHeight( m7traild3 );
ui->pushButtonLib10->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "10    ") );
ui->pushButtonLib10->setMaximumWidth( m7traild3 );
ui->pushButtonLib10->setMaximumHeight( m7traild3 );

ui->est101->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "10    ") );
connect( ui->est101, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est101, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est101->installEventFilter(this);
ui->est101->setMaximumWidth( m6trail);
ui->est101->setMinimumWidth( m6trail);
ui->est101->setMaximumHeight( m7traild3 );
ui->est101->setMaxLength(3);
ui->est101->setFrame(globalFrame);

ui->est102->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "10    ") );
connect( ui->est102, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est102, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est102->installEventFilter(this);
ui->est102->setMaximumWidth( m26trail);
ui->est102->setMinimumWidth( m25trail);
ui->est102->setMaximumHeight( m7traild3 );
ui->est102->setMaxLength(24);
ui->est102->setFrame(globalFrame);

ui->est103->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "10    ") );
connect( ui->est103, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est103, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est103->installEventFilter(this);
ui->est103->setAlignment(Qt::AlignCenter);
ui->est103->setMaximumWidth( m11trail);
ui->est103->setMinimumWidth( m6trail);
ui->est103->setMaximumHeight( m7traild3 );
ui->est103->setMaxLength(8);
ui->est103->setFrame(globalFrame);

ui->est104->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "10    ") );
connect( ui->est104, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est104, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est104->installEventFilter(this);
ui->est104->setAlignment(Qt::AlignCenter);
ui->est104->setMaximumWidth( m12trail);
ui->est104->setMinimumWidth( m6trail);
ui->est104->setMaximumHeight( m7traild3 );
ui->est104->setMaxLength(11);
ui->est104->setFrame(globalFrame);

ui->est105->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "10    ") );
connect( ui->est105, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est105, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est105->installEventFilter(this);
ui->est105->setAlignment(Qt::AlignCenter);
ui->est105->setMaximumWidth( m12trail);
ui->est105->setMinimumWidth( m6trail);
ui->est105->setMaximumHeight( m7traild3 );
ui->est105->setMaxLength(11);
ui->est105->setFrame(globalFrame);

ui->est106->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "10    ") );
ui->est106->setReadOnly(true);
ui->est106->setAlignment(Qt::AlignRight);
ui->est106->setMaximumWidth( m14trail);
ui->est106->setMinimumWidth( m9trail);
ui->est106->setMaximumHeight( m7traild3 );
ui->est106->setMaxLength(15);
ui->est106->setFrame(globalFrame);

ui->est107->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "10    ") );
ui->est107->setReadOnly(true);
ui->est107->setAlignment(Qt::AlignRight);
ui->est107->setMaximumWidth( m14trail);
ui->est107->setMinimumWidth( m9trail);
ui->est107->setMaximumHeight( m7traild3 );
ui->est107->setMaxLength(15);
ui->est107->setFrame(globalFrame);

ui->lib111->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "11    ") );
connect( ui->lib111, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib111, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib11, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst11, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib111->installEventFilter(this);
ui->lib111->setMaximumWidth( m6trail);
ui->lib111->setMinimumWidth( m6trail);
ui->lib111->setMaximumHeight( m7traild3 );
ui->lib111->setMaxLength(3);
ui->lib111->setFrame(globalFrame);

ui->lib112->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "11    ") );
connect( ui->lib112, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib112, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib112->installEventFilter(this);
ui->lib112->setMaximumWidth( m26trail);
ui->lib112->setMinimumWidth( m25trail);
ui->lib112->setMaximumHeight( m7traild3 );
ui->lib112->setMaxLength(24);
ui->lib112->setFrame(globalFrame);

ui->lib113->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "11    ") );
connect( ui->lib113, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib113, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib113->installEventFilter(this);
ui->lib113->setAlignment(Qt::AlignCenter);
ui->lib113->setMaximumWidth( m12trail);
ui->lib113->setMinimumWidth( m6trail);
ui->lib113->setMaximumHeight( m7traild3 );
ui->lib113->setMaxLength(11);
ui->lib113->setFrame(globalFrame);

ui->lib114->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "11    ") );
connect( ui->lib114, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib114, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib114->installEventFilter(this);
ui->lib114->setAlignment(Qt::AlignCenter);
ui->lib114->setMaximumWidth( m12trail);
ui->lib114->setMinimumWidth( m6trail);
ui->lib114->setMaximumHeight( m7traild3 );
ui->lib114->setMaxLength(11);
ui->lib114->setFrame(globalFrame);

ui->pushButtonEst11->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "11    ") );
ui->pushButtonEst11->setMaximumWidth( m7traild3 );
ui->pushButtonEst11->setMaximumHeight( m7traild3 );
ui->pushButtonLib11->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "11    ") );
ui->pushButtonLib11->setMaximumWidth( m7traild3 );
ui->pushButtonLib11->setMaximumHeight( m7traild3 );

ui->est111->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "11    ") );
connect( ui->est111, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est111, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est111->installEventFilter(this);
ui->est111->setMaximumWidth( m6trail);
ui->est111->setMinimumWidth( m6trail);
ui->est111->setMaximumHeight( m7traild3 );
ui->est111->setMaxLength(3);
ui->est111->setFrame(globalFrame);

ui->est112->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "11    ") );
connect( ui->est112, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est112, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est112->installEventFilter(this);
ui->est112->setMaximumWidth( m26trail);
ui->est112->setMinimumWidth( m25trail);
ui->est112->setMaximumHeight( m7traild3 );
ui->est112->setMaxLength(24);
ui->est112->setFrame(globalFrame);

ui->est113->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "11    ") );
connect( ui->est113, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est113, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est113->installEventFilter(this);
ui->est113->setAlignment(Qt::AlignCenter);
ui->est113->setMaximumWidth( m11trail);
ui->est113->setMinimumWidth( m6trail);
ui->est113->setMaximumHeight( m7traild3 );
ui->est113->setMaxLength(8);
ui->est113->setFrame(globalFrame);

ui->est114->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "11    ") );
connect( ui->est114, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est114, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est114->installEventFilter(this);
ui->est114->setAlignment(Qt::AlignCenter);
ui->est114->setMaximumWidth( m12trail);
ui->est114->setMinimumWidth( m6trail);
ui->est114->setMaximumHeight( m7traild3 );
ui->est114->setMaxLength(11);
ui->est114->setFrame(globalFrame);

ui->est115->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "11    ") );
connect( ui->est115, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est115, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est115->installEventFilter(this);
ui->est115->setAlignment(Qt::AlignCenter);
ui->est115->setMaximumWidth( m12trail);
ui->est115->setMinimumWidth( m6trail);
ui->est115->setMaximumHeight( m7traild3 );
ui->est115->setMaxLength(11);
ui->est115->setFrame(globalFrame);

ui->est116->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "11    ") );
ui->est116->setReadOnly(true);
ui->est116->setAlignment(Qt::AlignRight);
ui->est116->setMaximumWidth( m14trail);
ui->est116->setMinimumWidth( m9trail);
ui->est116->setMaximumHeight( m7traild3 );
ui->est116->setMaxLength(15);
ui->est116->setFrame(globalFrame);

ui->est117->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "11    ") );
ui->est117->setReadOnly(true);
ui->est117->setAlignment(Qt::AlignRight);
ui->est117->setMaximumWidth( m14trail);
ui->est117->setMinimumWidth( m9trail);
ui->est117->setMaximumHeight( m7traild3 );
ui->est117->setMaxLength(15);
ui->est117->setFrame(globalFrame);

ui->lib121->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "12    ") );
connect( ui->lib121, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib121, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib12, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst12, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib121->installEventFilter(this);
ui->lib121->setMaximumWidth( m6trail);
ui->lib121->setMinimumWidth( m6trail);
ui->lib121->setMaximumHeight( m7traild3 );
ui->lib121->setMaxLength(3);
ui->lib121->setFrame(globalFrame);

ui->lib122->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "12    ") );
connect( ui->lib122, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib122, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib122->installEventFilter(this);
ui->lib122->setMaximumWidth( m26trail);
ui->lib122->setMinimumWidth( m25trail);
ui->lib122->setMaximumHeight( m7traild3 );
ui->lib122->setMaxLength(24);
ui->lib122->setFrame(globalFrame);

ui->lib123->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "12    ") );
connect( ui->lib123, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib123, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib123->installEventFilter(this);
ui->lib123->setAlignment(Qt::AlignCenter);
ui->lib123->setMaximumWidth( m12trail);
ui->lib123->setMinimumWidth( m6trail);
ui->lib123->setMaximumHeight( m7traild3 );
ui->lib123->setMaxLength(11);
ui->lib123->setFrame(globalFrame);

ui->lib124->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "12    ") );
connect( ui->lib124, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib124, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib124->installEventFilter(this);
ui->lib124->setAlignment(Qt::AlignCenter);
ui->lib124->setMaximumWidth( m12trail);
ui->lib124->setMinimumWidth( m6trail);
ui->lib124->setMaximumHeight( m7traild3 );
ui->lib124->setMaxLength(11);
ui->lib124->setFrame(globalFrame);

ui->pushButtonEst12->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "12    ") );
ui->pushButtonEst12->setMaximumWidth( m7traild3 );
ui->pushButtonEst12->setMaximumHeight( m7traild3 );
ui->pushButtonLib12->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "12    ") );
ui->pushButtonLib12->setMaximumWidth( m7traild3 );
ui->pushButtonLib12->setMaximumHeight( m7traild3 );

ui->est121->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "12    ") );
connect( ui->est121, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est121, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est121->installEventFilter(this);
ui->est121->setMaximumWidth( m6trail);
ui->est121->setMinimumWidth( m6trail);
ui->est121->setMaximumHeight( m7traild3 );
ui->est121->setMaxLength(3);
ui->est121->setFrame(globalFrame);

ui->est122->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "12    ") );
connect( ui->est122, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est122, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est122->installEventFilter(this);
ui->est122->setMaximumWidth( m26trail);
ui->est122->setMinimumWidth( m25trail);
ui->est122->setMaximumHeight( m7traild3 );
ui->est122->setMaxLength(24);
ui->est122->setFrame(globalFrame);

ui->est123->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "12    ") );
connect( ui->est123, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est123, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est123->installEventFilter(this);
ui->est123->setAlignment(Qt::AlignCenter);
ui->est123->setMaximumWidth( m11trail);
ui->est123->setMinimumWidth( m6trail);
ui->est123->setMaximumHeight( m7traild3 );
ui->est123->setMaxLength(8);
ui->est123->setFrame(globalFrame);

ui->est124->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "12    ") );
connect( ui->est124, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est124, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est124->installEventFilter(this);
ui->est124->setAlignment(Qt::AlignCenter);
ui->est124->setMaximumWidth( m12trail);
ui->est124->setMinimumWidth( m6trail);
ui->est124->setMaximumHeight( m7traild3 );
ui->est124->setMaxLength(11);
ui->est124->setFrame(globalFrame);

ui->est125->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "12    ") );
connect( ui->est125, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est125, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est125->installEventFilter(this);
ui->est125->setAlignment(Qt::AlignCenter);
ui->est125->setMaximumWidth( m12trail);
ui->est125->setMinimumWidth( m6trail);
ui->est125->setMaximumHeight( m7traild3 );
ui->est125->setMaxLength(11);
ui->est125->setFrame(globalFrame);

ui->est126->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "12    ") );
ui->est126->setReadOnly(true);
ui->est126->setAlignment(Qt::AlignRight);
ui->est126->setMaximumWidth( m14trail);
ui->est126->setMinimumWidth( m9trail);
ui->est126->setMaximumHeight( m7traild3 );
ui->est126->setMaxLength(15);
ui->est126->setFrame(globalFrame);

ui->est127->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "12    ") );
ui->est127->setReadOnly(true);
ui->est127->setAlignment(Qt::AlignRight);
ui->est127->setMaximumWidth( m14trail);
ui->est127->setMinimumWidth( m9trail);
ui->est127->setMaximumHeight( m7traild3 );
ui->est127->setMaxLength(15);
ui->est127->setFrame(globalFrame);

ui->lib131->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "13    ") );
connect( ui->lib131, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib131, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib13, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst13, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib131->installEventFilter(this);
ui->lib131->setMaximumWidth( m6trail);
ui->lib131->setMinimumWidth( m6trail);
ui->lib131->setMaximumHeight( m7traild3 );
ui->lib131->setMaxLength(3);
ui->lib131->setFrame(globalFrame);

ui->lib132->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "13    ") );
connect( ui->lib132, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib132, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib132->installEventFilter(this);
ui->lib132->setMaximumWidth( m26trail);
ui->lib132->setMinimumWidth( m25trail);
ui->lib132->setMaximumHeight( m7traild3 );
ui->lib132->setMaxLength(24);
ui->lib132->setFrame(globalFrame);

ui->lib133->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "13    ") );
connect( ui->lib133, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib133, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib133->installEventFilter(this);
ui->lib133->setAlignment(Qt::AlignCenter);
ui->lib133->setMaximumWidth( m12trail);
ui->lib133->setMinimumWidth( m6trail);
ui->lib133->setMaximumHeight( m7traild3 );
ui->lib133->setMaxLength(11);
ui->lib133->setFrame(globalFrame);

ui->lib134->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "13    ") );
connect( ui->lib134, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib134, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib134->installEventFilter(this);
ui->lib134->setAlignment(Qt::AlignCenter);
ui->lib134->setMaximumWidth( m12trail);
ui->lib134->setMinimumWidth( m6trail);
ui->lib134->setMaximumHeight( m7traild3 );
ui->lib134->setMaxLength(11);
ui->lib134->setFrame(globalFrame);

ui->pushButtonEst13->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "13    ") );
ui->pushButtonEst13->setMaximumWidth( m7traild3 );
ui->pushButtonEst13->setMaximumHeight( m7traild3 );
ui->pushButtonLib13->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "13    ") );
ui->pushButtonLib13->setMaximumWidth( m7traild3 );
ui->pushButtonLib13->setMaximumHeight( m7traild3 );

ui->est131->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "13    ") );
connect( ui->est131, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est131, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est131->installEventFilter(this);
ui->est131->setMaximumWidth( m6trail);
ui->est131->setMinimumWidth( m6trail);
ui->est131->setMaximumHeight( m7traild3 );
ui->est131->setMaxLength(3);
ui->est131->setFrame(globalFrame);

ui->est132->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "13    ") );
connect( ui->est132, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est132, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est132->installEventFilter(this);
ui->est132->setMaximumWidth( m26trail);
ui->est132->setMinimumWidth( m25trail);
ui->est132->setMaximumHeight( m7traild3 );
ui->est132->setMaxLength(24);
ui->est132->setFrame(globalFrame);

ui->est133->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "13    ") );
connect( ui->est133, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est133, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est133->installEventFilter(this);
ui->est133->setAlignment(Qt::AlignCenter);
ui->est133->setMaximumWidth( m11trail);
ui->est133->setMinimumWidth( m6trail);
ui->est133->setMaximumHeight( m7traild3 );
ui->est133->setMaxLength(8);
ui->est133->setFrame(globalFrame);

ui->est134->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "13    ") );
connect( ui->est134, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est134, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est134->installEventFilter(this);
ui->est134->setAlignment(Qt::AlignCenter);
ui->est134->setMaximumWidth( m12trail);
ui->est134->setMinimumWidth( m6trail);
ui->est134->setMaximumHeight( m7traild3 );
ui->est134->setMaxLength(11);
ui->est134->setFrame(globalFrame);

ui->est135->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "13    ") );
connect( ui->est135, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est135, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est135->installEventFilter(this);
ui->est135->setAlignment(Qt::AlignCenter);
ui->est135->setMaximumWidth( m12trail);
ui->est135->setMinimumWidth( m6trail);
ui->est135->setMaximumHeight( m7traild3 );
ui->est135->setMaxLength(11);
ui->est135->setFrame(globalFrame);

ui->est136->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "13    ") );
ui->est136->setReadOnly(true);
ui->est136->setAlignment(Qt::AlignRight);
ui->est136->setMaximumWidth( m14trail);
ui->est136->setMinimumWidth( m9trail);
ui->est136->setMaximumHeight( m7traild3 );
ui->est136->setMaxLength(15);
ui->est136->setFrame(globalFrame);

ui->est137->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "13    ") );
ui->est137->setReadOnly(true);
ui->est137->setAlignment(Qt::AlignRight);
ui->est137->setMaximumWidth( m14trail);
ui->est137->setMinimumWidth( m9trail);
ui->est137->setMaximumHeight( m7traild3 );
ui->est137->setMaxLength(15);
ui->est137->setFrame(globalFrame);

ui->lib141->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "14    ") );
connect( ui->lib141, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib141, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib14, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst14, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib141->installEventFilter(this);
ui->lib141->setMaximumWidth( m6trail);
ui->lib141->setMinimumWidth( m6trail);
ui->lib141->setMaximumHeight( m7traild3 );
ui->lib141->setMaxLength(3);
ui->lib141->setFrame(globalFrame);

ui->lib142->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "14    ") );
connect( ui->lib142, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib142, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib142->installEventFilter(this);
ui->lib142->setMaximumWidth( m26trail);
ui->lib142->setMinimumWidth( m25trail);
ui->lib142->setMaximumHeight( m7traild3 );
ui->lib142->setMaxLength(24);
ui->lib142->setFrame(globalFrame);

ui->lib143->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "14    ") );
connect( ui->lib143, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib143, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib143->installEventFilter(this);
ui->lib143->setAlignment(Qt::AlignCenter);
ui->lib143->setMaximumWidth( m12trail);
ui->lib143->setMinimumWidth( m6trail);
ui->lib143->setMaximumHeight( m7traild3 );
ui->lib143->setMaxLength(11);
ui->lib143->setFrame(globalFrame);

ui->lib144->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "14    ") );
connect( ui->lib144, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib144, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib144->installEventFilter(this);
ui->lib144->setAlignment(Qt::AlignCenter);
ui->lib144->setMaximumWidth( m12trail);
ui->lib144->setMinimumWidth( m6trail);
ui->lib144->setMaximumHeight( m7traild3 );
ui->lib144->setMaxLength(11);
ui->lib144->setFrame(globalFrame);

ui->pushButtonEst14->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "14    ") );
ui->pushButtonEst14->setMaximumWidth( m7traild3 );
ui->pushButtonEst14->setMaximumHeight( m7traild3 );
ui->pushButtonLib14->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "14    ") );
ui->pushButtonLib14->setMaximumWidth( m7traild3 );
ui->pushButtonLib14->setMaximumHeight( m7traild3 );

ui->est141->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "14    ") );
connect( ui->est141, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est141, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est141->installEventFilter(this);
ui->est141->setMaximumWidth( m6trail);
ui->est141->setMinimumWidth( m6trail);
ui->est141->setMaximumHeight( m7traild3 );
ui->est141->setMaxLength(3);
ui->est141->setFrame(globalFrame);

ui->est142->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "14    ") );
connect( ui->est142, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est142, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est142->installEventFilter(this);
ui->est142->setMaximumWidth( m26trail);
ui->est142->setMinimumWidth( m25trail);
ui->est142->setMaximumHeight( m7traild3 );
ui->est142->setMaxLength(24);
ui->est142->setFrame(globalFrame);

ui->est143->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "14    ") );
connect( ui->est143, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est143, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est143->installEventFilter(this);
ui->est143->setAlignment(Qt::AlignCenter);
ui->est143->setMaximumWidth( m11trail);
ui->est143->setMinimumWidth( m6trail);
ui->est143->setMaximumHeight( m7traild3 );
ui->est143->setMaxLength(8);
ui->est143->setFrame(globalFrame);

ui->est144->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "14    ") );
connect( ui->est144, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est144, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est144->installEventFilter(this);
ui->est144->setAlignment(Qt::AlignCenter);
ui->est144->setMaximumWidth( m12trail);
ui->est144->setMinimumWidth( m6trail);
ui->est144->setMaximumHeight( m7traild3 );
ui->est144->setMaxLength(11);
ui->est144->setFrame(globalFrame);

ui->est145->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "14    ") );
connect( ui->est145, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est145, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est145->installEventFilter(this);
ui->est145->setAlignment(Qt::AlignCenter);
ui->est145->setMaximumWidth( m12trail);
ui->est145->setMinimumWidth( m6trail);
ui->est145->setMaximumHeight( m7traild3 );
ui->est145->setMaxLength(11);
ui->est145->setFrame(globalFrame);

ui->est146->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "14    ") );
ui->est146->setReadOnly(true);
ui->est146->setAlignment(Qt::AlignRight);
ui->est146->setMaximumWidth( m14trail);
ui->est146->setMinimumWidth( m9trail);
ui->est146->setMaximumHeight( m7traild3 );
ui->est146->setMaxLength(15);
ui->est146->setFrame(globalFrame);

ui->est147->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "14    ") );
ui->est147->setReadOnly(true);
ui->est147->setAlignment(Qt::AlignRight);
ui->est147->setMaximumWidth( m14trail);
ui->est147->setMinimumWidth( m9trail);
ui->est147->setMaximumHeight( m7traild3 );
ui->est147->setMaxLength(15);
ui->est147->setFrame(globalFrame);

ui->lib151->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "15    ") );
connect( ui->lib151, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib151, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib15, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst15, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib151->installEventFilter(this);
ui->lib151->setMaximumWidth( m6trail);
ui->lib151->setMinimumWidth( m6trail);
ui->lib151->setMaximumHeight( m7traild3 );
ui->lib151->setMaxLength(3);
ui->lib151->setFrame(globalFrame);

ui->lib152->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "15    ") );
connect( ui->lib152, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib152, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib152->installEventFilter(this);
ui->lib152->setMaximumWidth( m26trail);
ui->lib152->setMinimumWidth( m25trail);
ui->lib152->setMaximumHeight( m7traild3 );
ui->lib152->setMaxLength(24);
ui->lib152->setFrame(globalFrame);

ui->lib153->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "15    ") );
connect( ui->lib153, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib153, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib153->installEventFilter(this);
ui->lib153->setAlignment(Qt::AlignCenter);
ui->lib153->setMaximumWidth( m12trail);
ui->lib153->setMinimumWidth( m6trail);
ui->lib153->setMaximumHeight( m7traild3 );
ui->lib153->setMaxLength(11);
ui->lib153->setFrame(globalFrame);

ui->lib154->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "15    ") );
connect( ui->lib154, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib154, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib154->installEventFilter(this);
ui->lib154->setAlignment(Qt::AlignCenter);
ui->lib154->setMaximumWidth( m12trail);
ui->lib154->setMinimumWidth( m6trail);
ui->lib154->setMaximumHeight( m7traild3 );
ui->lib154->setMaxLength(11);
ui->lib154->setFrame(globalFrame);

ui->pushButtonEst15->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "15    ") );
ui->pushButtonEst15->setMaximumWidth( m7traild3 );
ui->pushButtonEst15->setMaximumHeight( m7traild3 );
ui->pushButtonLib15->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "15    ") );
ui->pushButtonLib15->setMaximumWidth( m7traild3 );
ui->pushButtonLib15->setMaximumHeight( m7traild3 );

ui->est151->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "15    ") );
connect( ui->est151, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est151, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est151->installEventFilter(this);
ui->est151->setMaximumWidth( m6trail);
ui->est151->setMinimumWidth( m6trail);
ui->est151->setMaximumHeight( m7traild3 );
ui->est151->setMaxLength(3);
ui->est151->setFrame(globalFrame);

ui->est152->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "15    ") );
connect( ui->est152, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est152, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est152->installEventFilter(this);
ui->est152->setMaximumWidth( m26trail);
ui->est152->setMinimumWidth( m25trail);
ui->est152->setMaximumHeight( m7traild3 );
ui->est152->setMaxLength(24);
ui->est152->setFrame(globalFrame);

ui->est153->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "15    ") );
connect( ui->est153, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est153, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est153->installEventFilter(this);
ui->est153->setAlignment(Qt::AlignCenter);
ui->est153->setMaximumWidth( m11trail);
ui->est153->setMinimumWidth( m6trail);
ui->est153->setMaximumHeight( m7traild3 );
ui->est153->setMaxLength(8);
ui->est153->setFrame(globalFrame);

ui->est154->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "15    ") );
connect( ui->est154, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est154, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est154->installEventFilter(this);
ui->est154->setAlignment(Qt::AlignCenter);
ui->est154->setMaximumWidth( m12trail);
ui->est154->setMinimumWidth( m6trail);
ui->est154->setMaximumHeight( m7traild3 );
ui->est154->setMaxLength(11);
ui->est154->setFrame(globalFrame);

ui->est155->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "15    ") );
connect( ui->est155, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est155, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est155->installEventFilter(this);
ui->est155->setAlignment(Qt::AlignCenter);
ui->est155->setMaximumWidth( m12trail);
ui->est155->setMinimumWidth( m6trail);
ui->est155->setMaximumHeight( m7traild3 );
ui->est155->setMaxLength(11);
ui->est155->setFrame(globalFrame);

ui->est156->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "15    ") );
ui->est156->setReadOnly(true);
ui->est156->setAlignment(Qt::AlignRight);
ui->est156->setMaximumWidth( m14trail);
ui->est156->setMinimumWidth( m9trail);
ui->est156->setMaximumHeight( m7traild3 );
ui->est156->setMaxLength(15);
ui->est156->setFrame(globalFrame);

ui->est157->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "15    ") );
ui->est157->setReadOnly(true);
ui->est157->setAlignment(Qt::AlignRight);
ui->est157->setMaximumWidth( m14trail);
ui->est157->setMinimumWidth( m9trail);
ui->est157->setMaximumHeight( m7traild3 );
ui->est157->setMaxLength(15);
ui->est157->setFrame(globalFrame);

ui->lib161->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "16    ") );
connect( ui->lib161, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib161, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib16, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst16, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib161->installEventFilter(this);
ui->lib161->setMaximumWidth( m6trail);
ui->lib161->setMinimumWidth( m6trail);
ui->lib161->setMaximumHeight( m7traild3 );
ui->lib161->setMaxLength(3);
ui->lib161->setFrame(globalFrame);

ui->lib162->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "16    ") );
connect( ui->lib162, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib162, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib162->installEventFilter(this);
ui->lib162->setMaximumWidth( m26trail);
ui->lib162->setMinimumWidth( m25trail);
ui->lib162->setMaximumHeight( m7traild3 );
ui->lib162->setMaxLength(24);
ui->lib162->setFrame(globalFrame);

ui->lib163->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "16    ") );
connect( ui->lib163, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib163, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib163->installEventFilter(this);
ui->lib163->setAlignment(Qt::AlignCenter);
ui->lib163->setMaximumWidth( m12trail);
ui->lib163->setMinimumWidth( m6trail);
ui->lib163->setMaximumHeight( m7traild3 );
ui->lib163->setMaxLength(11);
ui->lib163->setFrame(globalFrame);

ui->lib164->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "16    ") );
connect( ui->lib164, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib164, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib164->installEventFilter(this);
ui->lib164->setAlignment(Qt::AlignCenter);
ui->lib164->setMaximumWidth( m12trail);
ui->lib164->setMinimumWidth( m6trail);
ui->lib164->setMaximumHeight( m7traild3 );
ui->lib164->setMaxLength(11);
ui->lib164->setFrame(globalFrame);

ui->pushButtonEst16->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "16    ") );
ui->pushButtonEst16->setMaximumWidth( m7traild3 );
ui->pushButtonEst16->setMaximumHeight( m7traild3 );
ui->pushButtonLib16->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "16    ") );
ui->pushButtonLib16->setMaximumWidth( m7traild3 );
ui->pushButtonLib16->setMaximumHeight( m7traild3 );

ui->est161->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "16    ") );
connect( ui->est161, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est161, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est161->installEventFilter(this);
ui->est161->setMaximumWidth( m6trail);
ui->est161->setMinimumWidth( m6trail);
ui->est161->setMaximumHeight( m7traild3 );
ui->est161->setMaxLength(3);
ui->est161->setFrame(globalFrame);

ui->est162->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "16    ") );
connect( ui->est162, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est162, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est162->installEventFilter(this);
ui->est162->setMaximumWidth( m26trail);
ui->est162->setMinimumWidth( m25trail);
ui->est162->setMaximumHeight( m7traild3 );
ui->est162->setMaxLength(24);
ui->est162->setFrame(globalFrame);

ui->est163->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "16    ") );
connect( ui->est163, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est163, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est163->installEventFilter(this);
ui->est163->setAlignment(Qt::AlignCenter);
ui->est163->setMaximumWidth( m11trail);
ui->est163->setMinimumWidth( m6trail);
ui->est163->setMaximumHeight( m7traild3 );
ui->est163->setMaxLength(8);
ui->est163->setFrame(globalFrame);

ui->est164->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "16    ") );
connect( ui->est164, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est164, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est164->installEventFilter(this);
ui->est164->setAlignment(Qt::AlignCenter);
ui->est164->setMaximumWidth( m12trail);
ui->est164->setMinimumWidth( m6trail);
ui->est164->setMaximumHeight( m7traild3 );
ui->est164->setMaxLength(11);
ui->est164->setFrame(globalFrame);

ui->est165->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "16    ") );
connect( ui->est165, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est165, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est165->installEventFilter(this);
ui->est165->setAlignment(Qt::AlignCenter);
ui->est165->setMaximumWidth( m12trail);
ui->est165->setMinimumWidth( m6trail);
ui->est165->setMaximumHeight( m7traild3 );
ui->est165->setMaxLength(11);
ui->est165->setFrame(globalFrame);

ui->est166->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "16    ") );
ui->est166->setReadOnly(true);
ui->est166->setAlignment(Qt::AlignRight);
ui->est166->setMaximumWidth( m14trail);
ui->est166->setMinimumWidth( m9trail);
ui->est166->setMaximumHeight( m7traild3 );
ui->est166->setMaxLength(15);
ui->est166->setFrame(globalFrame);

ui->est167->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "16    ") );
ui->est167->setReadOnly(true);
ui->est167->setAlignment(Qt::AlignRight);
ui->est167->setMaximumWidth( m14trail);
ui->est167->setMinimumWidth( m9trail);
ui->est167->setMaximumHeight( m7traild3 );
ui->est167->setMaxLength(15);
ui->est167->setFrame(globalFrame);

ui->lib171->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "17    ") );
connect( ui->lib171, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib171, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib17, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst17, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib171->installEventFilter(this);
ui->lib171->setMaximumWidth( m6trail);
ui->lib171->setMinimumWidth( m6trail);
ui->lib171->setMaximumHeight( m7traild3 );
ui->lib171->setMaxLength(3);
ui->lib171->setFrame(globalFrame);

ui->lib172->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "17    ") );
connect( ui->lib172, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib172, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib172->installEventFilter(this);
ui->lib172->setMaximumWidth( m26trail);
ui->lib172->setMinimumWidth( m25trail);
ui->lib172->setMaximumHeight( m7traild3 );
ui->lib172->setMaxLength(24);
ui->lib172->setFrame(globalFrame);

ui->lib173->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "17    ") );
connect( ui->lib173, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib173, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib173->installEventFilter(this);
ui->lib173->setAlignment(Qt::AlignCenter);
ui->lib173->setMaximumWidth( m12trail);
ui->lib173->setMinimumWidth( m6trail);
ui->lib173->setMaximumHeight( m7traild3 );
ui->lib173->setMaxLength(11);
ui->lib173->setFrame(globalFrame);

ui->lib174->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "17    ") );
connect( ui->lib174, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib174, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib174->installEventFilter(this);
ui->lib174->setAlignment(Qt::AlignCenter);
ui->lib174->setMaximumWidth( m12trail);
ui->lib174->setMinimumWidth( m6trail);
ui->lib174->setMaximumHeight( m7traild3 );
ui->lib174->setMaxLength(11);
ui->lib174->setFrame(globalFrame);

ui->pushButtonEst17->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "17    ") );
ui->pushButtonEst17->setMaximumWidth( m7traild3 );
ui->pushButtonEst17->setMaximumHeight( m7traild3 );
ui->pushButtonLib17->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "17    ") );
ui->pushButtonLib17->setMaximumWidth( m7traild3 );
ui->pushButtonLib17->setMaximumHeight( m7traild3 );

ui->est171->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "17    ") );
connect( ui->est171, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est171, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est171->installEventFilter(this);
ui->est171->setMaximumWidth( m6trail);
ui->est171->setMinimumWidth( m6trail);
ui->est171->setMaximumHeight( m7traild3 );
ui->est171->setMaxLength(3);
ui->est171->setFrame(globalFrame);

ui->est172->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "17    ") );
connect( ui->est172, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est172, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est172->installEventFilter(this);
ui->est172->setMaximumWidth( m26trail);
ui->est172->setMinimumWidth( m25trail);
ui->est172->setMaximumHeight( m7traild3 );
ui->est172->setMaxLength(24);
ui->est172->setFrame(globalFrame);

ui->est173->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "17    ") );
connect( ui->est173, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est173, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est173->installEventFilter(this);
ui->est173->setAlignment(Qt::AlignCenter);
ui->est173->setMaximumWidth( m11trail);
ui->est173->setMinimumWidth( m6trail);
ui->est173->setMaximumHeight( m7traild3 );
ui->est173->setMaxLength(8);
ui->est173->setFrame(globalFrame);

ui->est174->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "17    ") );
connect( ui->est174, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est174, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est174->installEventFilter(this);
ui->est174->setAlignment(Qt::AlignCenter);
ui->est174->setMaximumWidth( m12trail);
ui->est174->setMinimumWidth( m6trail);
ui->est174->setMaximumHeight( m7traild3 );
ui->est174->setMaxLength(11);
ui->est174->setFrame(globalFrame);

ui->est175->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "17    ") );
connect( ui->est175, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est175, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est175->installEventFilter(this);
ui->est175->setAlignment(Qt::AlignCenter);
ui->est175->setMaximumWidth( m12trail);
ui->est175->setMinimumWidth( m6trail);
ui->est175->setMaximumHeight( m7traild3 );
ui->est175->setMaxLength(11);
ui->est175->setFrame(globalFrame);

ui->est176->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "17    ") );
ui->est176->setReadOnly(true);
ui->est176->setAlignment(Qt::AlignRight);
ui->est176->setMaximumWidth( m14trail);
ui->est176->setMinimumWidth( m9trail);
ui->est176->setMaximumHeight( m7traild3 );
ui->est176->setMaxLength(15);
ui->est176->setFrame(globalFrame);

ui->est177->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "17    ") );
ui->est177->setReadOnly(true);
ui->est177->setAlignment(Qt::AlignRight);
ui->est177->setMaximumWidth( m14trail);
ui->est177->setMinimumWidth( m9trail);
ui->est177->setMaximumHeight( m7traild3 );
ui->est177->setMaxLength(15);
ui->est177->setFrame(globalFrame);

ui->lib181->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "18    ") );
connect( ui->lib181, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib181, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib18, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst18, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib181->installEventFilter(this);
ui->lib181->setMaximumWidth( m6trail);
ui->lib181->setMinimumWidth( m6trail);
ui->lib181->setMaximumHeight( m7traild3 );
ui->lib181->setMaxLength(3);
ui->lib181->setFrame(globalFrame);

ui->lib182->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "18    ") );
connect( ui->lib182, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib182, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib182->installEventFilter(this);
ui->lib182->setMaximumWidth( m26trail);
ui->lib182->setMinimumWidth( m25trail);
ui->lib182->setMaximumHeight( m7traild3 );
ui->lib182->setMaxLength(24);
ui->lib182->setFrame(globalFrame);

ui->lib183->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "18    ") );
connect( ui->lib183, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib183, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib183->installEventFilter(this);
ui->lib183->setAlignment(Qt::AlignCenter);
ui->lib183->setMaximumWidth( m12trail);
ui->lib183->setMinimumWidth( m6trail);
ui->lib183->setMaximumHeight( m7traild3 );
ui->lib183->setMaxLength(11);
ui->lib183->setFrame(globalFrame);

ui->lib184->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "18    ") );
connect( ui->lib184, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib184, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib184->installEventFilter(this);
ui->lib184->setAlignment(Qt::AlignCenter);
ui->lib184->setMaximumWidth( m12trail);
ui->lib184->setMinimumWidth( m6trail);
ui->lib184->setMaximumHeight( m7traild3 );
ui->lib184->setMaxLength(11);
ui->lib184->setFrame(globalFrame);

ui->pushButtonEst18->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "18    ") );
ui->pushButtonEst18->setMaximumWidth( m7traild3 );
ui->pushButtonEst18->setMaximumHeight( m7traild3 );
ui->pushButtonLib18->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "18    ") );
ui->pushButtonLib18->setMaximumWidth( m7traild3 );
ui->pushButtonLib18->setMaximumHeight( m7traild3 );

ui->est181->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "18    ") );
connect( ui->est181, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est181, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est181->installEventFilter(this);
ui->est181->setMaximumWidth( m6trail);
ui->est181->setMinimumWidth( m6trail);
ui->est181->setMaximumHeight( m7traild3 );
ui->est181->setMaxLength(3);
ui->est181->setFrame(globalFrame);

ui->est182->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "18    ") );
connect( ui->est182, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est182, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est182->installEventFilter(this);
ui->est182->setMaximumWidth( m26trail);
ui->est182->setMinimumWidth( m25trail);
ui->est182->setMaximumHeight( m7traild3 );
ui->est182->setMaxLength(24);
ui->est182->setFrame(globalFrame);

ui->est183->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "18    ") );
connect( ui->est183, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est183, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est183->installEventFilter(this);
ui->est183->setAlignment(Qt::AlignCenter);
ui->est183->setMaximumWidth( m11trail);
ui->est183->setMinimumWidth( m6trail);
ui->est183->setMaximumHeight( m7traild3 );
ui->est183->setMaxLength(8);
ui->est183->setFrame(globalFrame);

ui->est184->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "18    ") );
connect( ui->est184, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est184, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est184->installEventFilter(this);
ui->est184->setAlignment(Qt::AlignCenter);
ui->est184->setMaximumWidth( m12trail);
ui->est184->setMinimumWidth( m6trail);
ui->est184->setMaximumHeight( m7traild3 );
ui->est184->setMaxLength(11);
ui->est184->setFrame(globalFrame);

ui->est185->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "18    ") );
connect( ui->est185, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est185, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est185->installEventFilter(this);
ui->est185->setAlignment(Qt::AlignCenter);
ui->est185->setMaximumWidth( m12trail);
ui->est185->setMinimumWidth( m6trail);
ui->est185->setMaximumHeight( m7traild3 );
ui->est185->setMaxLength(11);
ui->est185->setFrame(globalFrame);

ui->est186->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "18    ") );
ui->est186->setReadOnly(true);
ui->est186->setAlignment(Qt::AlignRight);
ui->est186->setMaximumWidth( m14trail);
ui->est186->setMinimumWidth( m9trail);
ui->est186->setMaximumHeight( m7traild3 );
ui->est186->setMaxLength(15);
ui->est186->setFrame(globalFrame);

ui->est187->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "18    ") );
ui->est187->setReadOnly(true);
ui->est187->setAlignment(Qt::AlignRight);
ui->est187->setMaximumWidth( m14trail);
ui->est187->setMinimumWidth( m9trail);
ui->est187->setMaximumHeight( m7traild3 );
ui->est187->setMaxLength(15);
ui->est187->setFrame(globalFrame);

ui->lib191->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "19    ") );
connect( ui->lib191, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib191, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib19, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst19, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib191->installEventFilter(this);
ui->lib191->setMaximumWidth( m6trail);
ui->lib191->setMinimumWidth( m6trail);
ui->lib191->setMaximumHeight( m7traild3 );
ui->lib191->setMaxLength(3);
ui->lib191->setFrame(globalFrame);

ui->lib192->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "19    ") );
connect( ui->lib192, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib192, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib192->installEventFilter(this);
ui->lib192->setMaximumWidth( m26trail);
ui->lib192->setMinimumWidth( m25trail);
ui->lib192->setMaximumHeight( m7traild3 );
ui->lib192->setMaxLength(24);
ui->lib192->setFrame(globalFrame);

ui->lib193->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "19    ") );
connect( ui->lib193, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib193, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib193->installEventFilter(this);
ui->lib193->setAlignment(Qt::AlignCenter);
ui->lib193->setMaximumWidth( m12trail);
ui->lib193->setMinimumWidth( m6trail);
ui->lib193->setMaximumHeight( m7traild3 );
ui->lib193->setMaxLength(11);
ui->lib193->setFrame(globalFrame);

ui->lib194->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "19    ") );
connect( ui->lib194, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib194, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib194->installEventFilter(this);
ui->lib194->setAlignment(Qt::AlignCenter);
ui->lib194->setMaximumWidth( m12trail);
ui->lib194->setMinimumWidth( m6trail);
ui->lib194->setMaximumHeight( m7traild3 );
ui->lib194->setMaxLength(11);
ui->lib194->setFrame(globalFrame);

ui->pushButtonEst19->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "19    ") );
ui->pushButtonEst19->setMaximumWidth( m7traild3 );
ui->pushButtonEst19->setMaximumHeight( m7traild3 );
ui->pushButtonLib19->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "19    ") );
ui->pushButtonLib19->setMaximumWidth( m7traild3 );
ui->pushButtonLib19->setMaximumHeight( m7traild3 );

ui->est191->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "19    ") );
connect( ui->est191, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est191, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est191->installEventFilter(this);
ui->est191->setMaximumWidth( m6trail);
ui->est191->setMinimumWidth( m6trail);
ui->est191->setMaximumHeight( m7traild3 );
ui->est191->setMaxLength(3);
ui->est191->setFrame(globalFrame);

ui->est192->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "19    ") );
connect( ui->est192, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est192, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est192->installEventFilter(this);
ui->est192->setMaximumWidth( m26trail);
ui->est192->setMinimumWidth( m25trail);
ui->est192->setMaximumHeight( m7traild3 );
ui->est192->setMaxLength(24);
ui->est192->setFrame(globalFrame);

ui->est193->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "19    ") );
connect( ui->est193, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est193, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est193->installEventFilter(this);
ui->est193->setAlignment(Qt::AlignCenter);
ui->est193->setMaximumWidth( m11trail);
ui->est193->setMinimumWidth( m6trail);
ui->est193->setMaximumHeight( m7traild3 );
ui->est193->setMaxLength(8);
ui->est193->setFrame(globalFrame);

ui->est194->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "19    ") );
connect( ui->est194, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est194, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est194->installEventFilter(this);
ui->est194->setAlignment(Qt::AlignCenter);
ui->est194->setMaximumWidth( m12trail);
ui->est194->setMinimumWidth( m6trail);
ui->est194->setMaximumHeight( m7traild3 );
ui->est194->setMaxLength(11);
ui->est194->setFrame(globalFrame);

ui->est195->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "19    ") );
connect( ui->est195, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est195, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est195->installEventFilter(this);
ui->est195->setAlignment(Qt::AlignCenter);
ui->est195->setMaximumWidth( m12trail);
ui->est195->setMinimumWidth( m6trail);
ui->est195->setMaximumHeight( m7traild3 );
ui->est195->setMaxLength(11);
ui->est195->setFrame(globalFrame);

ui->est196->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "19    ") );
ui->est196->setReadOnly(true);
ui->est196->setAlignment(Qt::AlignRight);
ui->est196->setMaximumWidth( m14trail);
ui->est196->setMinimumWidth( m9trail);
ui->est196->setMaximumHeight( m7traild3 );
ui->est196->setMaxLength(15);
ui->est196->setFrame(globalFrame);

ui->est197->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "19    ") );
ui->est197->setReadOnly(true);
ui->est197->setAlignment(Qt::AlignRight);
ui->est197->setMaximumWidth( m14trail);
ui->est197->setMinimumWidth( m9trail);
ui->est197->setMaximumHeight( m7traild3 );
ui->est197->setMaxLength(15);
ui->est197->setFrame(globalFrame);

ui->lib201->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "20    ") );
connect( ui->lib201, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib201, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib20, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst20, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib201->installEventFilter(this);
ui->lib201->setMaximumWidth( m6trail);
ui->lib201->setMinimumWidth( m6trail);
ui->lib201->setMaximumHeight( m7traild3 );
ui->lib201->setMaxLength(3);
ui->lib201->setFrame(globalFrame);

ui->lib202->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "20    ") );
connect( ui->lib202, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib202, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib202->installEventFilter(this);
ui->lib202->setMaximumWidth( m26trail);
ui->lib202->setMinimumWidth( m25trail);
ui->lib202->setMaximumHeight( m7traild3 );
ui->lib202->setMaxLength(24);
ui->lib202->setFrame(globalFrame);

ui->lib203->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "20    ") );
connect( ui->lib203, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib203, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib203->installEventFilter(this);
ui->lib203->setAlignment(Qt::AlignCenter);
ui->lib203->setMaximumWidth( m12trail);
ui->lib203->setMinimumWidth( m6trail);
ui->lib203->setMaximumHeight( m7traild3 );
ui->lib203->setMaxLength(11);
ui->lib203->setFrame(globalFrame);

ui->lib204->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "20    ") );
connect( ui->lib204, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib204, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib204->installEventFilter(this);
ui->lib204->setAlignment(Qt::AlignCenter);
ui->lib204->setMaximumWidth( m12trail);
ui->lib204->setMinimumWidth( m6trail);
ui->lib204->setMaximumHeight( m7traild3 );
ui->lib204->setMaxLength(11);
ui->lib204->setFrame(globalFrame);

ui->pushButtonEst20->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "20    ") );
ui->pushButtonEst20->setMaximumWidth( m7traild3 );
ui->pushButtonEst20->setMaximumHeight( m7traild3 );
ui->pushButtonLib20->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "20    ") );
ui->pushButtonLib20->setMaximumWidth( m7traild3 );
ui->pushButtonLib20->setMaximumHeight( m7traild3 );

ui->est201->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "20    ") );
connect( ui->est201, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est201, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est201->installEventFilter(this);
ui->est201->setMaximumWidth( m6trail);
ui->est201->setMinimumWidth( m6trail);
ui->est201->setMaximumHeight( m7traild3 );
ui->est201->setMaxLength(3);
ui->est201->setFrame(globalFrame);

ui->est202->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "20    ") );
connect( ui->est202, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est202, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est202->installEventFilter(this);
ui->est202->setMaximumWidth( m26trail);
ui->est202->setMinimumWidth( m25trail);
ui->est202->setMaximumHeight( m7traild3 );
ui->est202->setMaxLength(24);
ui->est202->setFrame(globalFrame);

ui->est203->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "20    ") );
connect( ui->est203, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est203, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est203->installEventFilter(this);
ui->est203->setAlignment(Qt::AlignCenter);
ui->est203->setMaximumWidth( m11trail);
ui->est203->setMinimumWidth( m6trail);
ui->est203->setMaximumHeight( m7traild3 );
ui->est203->setMaxLength(8);
ui->est203->setFrame(globalFrame);

ui->est204->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "20    ") );
connect( ui->est204, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est204, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est204->installEventFilter(this);
ui->est204->setAlignment(Qt::AlignCenter);
ui->est204->setMaximumWidth( m12trail);
ui->est204->setMinimumWidth( m6trail);
ui->est204->setMaximumHeight( m7traild3 );
ui->est204->setMaxLength(11);
ui->est204->setFrame(globalFrame);

ui->est205->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "20    ") );
connect( ui->est205, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est205, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est205->installEventFilter(this);
ui->est205->setAlignment(Qt::AlignCenter);
ui->est205->setMaximumWidth( m12trail);
ui->est205->setMinimumWidth( m6trail);
ui->est205->setMaximumHeight( m7traild3 );
ui->est205->setMaxLength(11);
ui->est205->setFrame(globalFrame);

ui->est206->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "20    ") );
ui->est206->setReadOnly(true);
ui->est206->setAlignment(Qt::AlignRight);
ui->est206->setMaximumWidth( m14trail);
ui->est206->setMinimumWidth( m9trail);
ui->est206->setMaximumHeight( m7traild3 );
ui->est206->setMaxLength(15);
ui->est206->setFrame(globalFrame);

ui->est207->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "20    ") );
ui->est207->setReadOnly(true);
ui->est207->setAlignment(Qt::AlignRight);
ui->est207->setMaximumWidth( m14trail);
ui->est207->setMinimumWidth( m9trail);
ui->est207->setMaximumHeight( m7traild3 );
ui->est207->setMaxLength(15);
ui->est207->setFrame(globalFrame);

ui->lib211->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "21    ") );
connect( ui->lib211, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib211, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib21, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst21, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib211->installEventFilter(this);
ui->lib211->setMaximumWidth( m6trail);
ui->lib211->setMinimumWidth( m6trail);
ui->lib211->setMaximumHeight( m7traild3 );
ui->lib211->setMaxLength(3);
ui->lib211->setFrame(globalFrame);

ui->lib212->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "21    ") );
connect( ui->lib212, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib212, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib212->installEventFilter(this);
ui->lib212->setMaximumWidth( m26trail);
ui->lib212->setMinimumWidth( m25trail);
ui->lib212->setMaximumHeight( m7traild3 );
ui->lib212->setMaxLength(24);
ui->lib212->setFrame(globalFrame);

ui->lib213->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "21    ") );
connect( ui->lib213, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib213, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib213->installEventFilter(this);
ui->lib213->setAlignment(Qt::AlignCenter);
ui->lib213->setMaximumWidth( m12trail);
ui->lib213->setMinimumWidth( m6trail);
ui->lib213->setMaximumHeight( m7traild3 );
ui->lib213->setMaxLength(11);
ui->lib213->setFrame(globalFrame);

ui->lib214->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "21    ") );
connect( ui->lib214, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib214, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib214->installEventFilter(this);
ui->lib214->setAlignment(Qt::AlignCenter);
ui->lib214->setMaximumWidth( m12trail);
ui->lib214->setMinimumWidth( m6trail);
ui->lib214->setMaximumHeight( m7traild3 );
ui->lib214->setMaxLength(11);
ui->lib214->setFrame(globalFrame);

ui->pushButtonEst21->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "21    ") );
ui->pushButtonEst21->setMaximumWidth( m7traild3 );
ui->pushButtonEst21->setMaximumHeight( m7traild3 );
ui->pushButtonLib21->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "21    ") );
ui->pushButtonLib21->setMaximumWidth( m7traild3 );
ui->pushButtonLib21->setMaximumHeight( m7traild3 );

ui->est211->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "21    ") );
connect( ui->est211, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est211, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est211->installEventFilter(this);
ui->est211->setMaximumWidth( m6trail);
ui->est211->setMinimumWidth( m6trail);
ui->est211->setMaximumHeight( m7traild3 );
ui->est211->setMaxLength(3);
ui->est211->setFrame(globalFrame);

ui->est212->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "21    ") );
connect( ui->est212, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est212, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est212->installEventFilter(this);
ui->est212->setMaximumWidth( m26trail);
ui->est212->setMinimumWidth( m25trail);
ui->est212->setMaximumHeight( m7traild3 );
ui->est212->setMaxLength(24);
ui->est212->setFrame(globalFrame);

ui->est213->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "21    ") );
connect( ui->est213, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est213, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est213->installEventFilter(this);
ui->est213->setAlignment(Qt::AlignCenter);
ui->est213->setMaximumWidth( m11trail);
ui->est213->setMinimumWidth( m6trail);
ui->est213->setMaximumHeight( m7traild3 );
ui->est213->setMaxLength(8);
ui->est213->setFrame(globalFrame);

ui->est214->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "21    ") );
connect( ui->est214, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est214, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est214->installEventFilter(this);
ui->est214->setAlignment(Qt::AlignCenter);
ui->est214->setMaximumWidth( m12trail);
ui->est214->setMinimumWidth( m6trail);
ui->est214->setMaximumHeight( m7traild3 );
ui->est214->setMaxLength(11);
ui->est214->setFrame(globalFrame);

ui->est215->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "21    ") );
connect( ui->est215, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est215, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est215->installEventFilter(this);
ui->est215->setAlignment(Qt::AlignCenter);
ui->est215->setMaximumWidth( m12trail);
ui->est215->setMinimumWidth( m6trail);
ui->est215->setMaximumHeight( m7traild3 );
ui->est215->setMaxLength(11);
ui->est215->setFrame(globalFrame);

ui->est216->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "21    ") );
ui->est216->setReadOnly(true);
ui->est216->setAlignment(Qt::AlignRight);
ui->est216->setMaximumWidth( m14trail);
ui->est216->setMinimumWidth( m9trail);
ui->est216->setMaximumHeight( m7traild3 );
ui->est216->setMaxLength(15);
ui->est216->setFrame(globalFrame);

ui->est217->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "21    ") );
ui->est217->setReadOnly(true);
ui->est217->setAlignment(Qt::AlignRight);
ui->est217->setMaximumWidth( m14trail);
ui->est217->setMinimumWidth( m9trail);
ui->est217->setMaximumHeight( m7traild3 );
ui->est217->setMaxLength(15);
ui->est217->setFrame(globalFrame);

ui->lib221->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "22    ") );
connect( ui->lib221, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib221, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib22, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst22, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib221->installEventFilter(this);
ui->lib221->setMaximumWidth( m6trail);
ui->lib221->setMinimumWidth( m6trail);
ui->lib221->setMaximumHeight( m7traild3 );
ui->lib221->setMaxLength(3);
ui->lib221->setFrame(globalFrame);

ui->lib222->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "22    ") );
connect( ui->lib222, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib222, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib222->installEventFilter(this);
ui->lib222->setMaximumWidth( m26trail);
ui->lib222->setMinimumWidth( m25trail);
ui->lib222->setMaximumHeight( m7traild3 );
ui->lib222->setMaxLength(24);
ui->lib222->setFrame(globalFrame);

ui->lib223->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "22    ") );
connect( ui->lib223, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib223, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib223->installEventFilter(this);
ui->lib223->setAlignment(Qt::AlignCenter);
ui->lib223->setMaximumWidth( m12trail);
ui->lib223->setMinimumWidth( m6trail);
ui->lib223->setMaximumHeight( m7traild3 );
ui->lib223->setMaxLength(11);
ui->lib223->setFrame(globalFrame);

ui->lib224->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "22    ") );
connect( ui->lib224, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib224, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib224->installEventFilter(this);
ui->lib224->setAlignment(Qt::AlignCenter);
ui->lib224->setMaximumWidth( m12trail);
ui->lib224->setMinimumWidth( m6trail);
ui->lib224->setMaximumHeight( m7traild3 );
ui->lib224->setMaxLength(11);
ui->lib224->setFrame(globalFrame);

ui->pushButtonEst22->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "22    ") );
ui->pushButtonEst22->setMaximumWidth( m7traild3 );
ui->pushButtonEst22->setMaximumHeight( m7traild3 );
ui->pushButtonLib22->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "22    ") );
ui->pushButtonLib22->setMaximumWidth( m7traild3 );
ui->pushButtonLib22->setMaximumHeight( m7traild3 );

ui->est221->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "22    ") );
connect( ui->est221, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est221, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est221->installEventFilter(this);
ui->est221->setMaximumWidth( m6trail);
ui->est221->setMinimumWidth( m6trail);
ui->est221->setMaximumHeight( m7traild3 );
ui->est221->setMaxLength(3);
ui->est221->setFrame(globalFrame);

ui->est222->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "22    ") );
connect( ui->est222, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est222, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est222->installEventFilter(this);
ui->est222->setMaximumWidth( m26trail);
ui->est222->setMinimumWidth( m25trail);
ui->est222->setMaximumHeight( m7traild3 );
ui->est222->setMaxLength(24);
ui->est222->setFrame(globalFrame);

ui->est223->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "22    ") );
connect( ui->est223, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est223, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est223->installEventFilter(this);
ui->est223->setAlignment(Qt::AlignCenter);
ui->est223->setMaximumWidth( m11trail);
ui->est223->setMinimumWidth( m6trail);
ui->est223->setMaximumHeight( m7traild3 );
ui->est223->setMaxLength(8);
ui->est223->setFrame(globalFrame);

ui->est224->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "22    ") );
connect( ui->est224, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est224, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est224->installEventFilter(this);
ui->est224->setAlignment(Qt::AlignCenter);
ui->est224->setMaximumWidth( m12trail);
ui->est224->setMinimumWidth( m6trail);
ui->est224->setMaximumHeight( m7traild3 );
ui->est224->setMaxLength(11);
ui->est224->setFrame(globalFrame);

ui->est225->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "22    ") );
connect( ui->est225, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est225, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est225->installEventFilter(this);
ui->est225->setAlignment(Qt::AlignCenter);
ui->est225->setMaximumWidth( m12trail);
ui->est225->setMinimumWidth( m6trail);
ui->est225->setMaximumHeight( m7traild3 );
ui->est225->setMaxLength(11);
ui->est225->setFrame(globalFrame);

ui->est226->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "22    ") );
ui->est226->setReadOnly(true);
ui->est226->setAlignment(Qt::AlignRight);
ui->est226->setMaximumWidth( m14trail);
ui->est226->setMinimumWidth( m9trail);
ui->est226->setMaximumHeight( m7traild3 );
ui->est226->setMaxLength(15);
ui->est226->setFrame(globalFrame);

ui->est227->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "22    ") );
ui->est227->setReadOnly(true);
ui->est227->setAlignment(Qt::AlignRight);
ui->est227->setMaximumWidth( m14trail);
ui->est227->setMinimumWidth( m9trail);
ui->est227->setMaximumHeight( m7traild3 );
ui->est227->setMaxLength(15);
ui->est227->setFrame(globalFrame);

ui->lib231->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "23    ") );
connect( ui->lib231, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib231, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib23, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst23, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib231->installEventFilter(this);
ui->lib231->setMaximumWidth( m6trail);
ui->lib231->setMinimumWidth( m6trail);
ui->lib231->setMaximumHeight( m7traild3 );
ui->lib231->setMaxLength(3);
ui->lib231->setFrame(globalFrame);

ui->lib232->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "23    ") );
connect( ui->lib232, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib232, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib232->installEventFilter(this);
ui->lib232->setMaximumWidth( m26trail);
ui->lib232->setMinimumWidth( m25trail);
ui->lib232->setMaximumHeight( m7traild3 );
ui->lib232->setMaxLength(24);
ui->lib232->setFrame(globalFrame);

ui->lib233->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "23    ") );
connect( ui->lib233, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib233, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib233->installEventFilter(this);
ui->lib233->setAlignment(Qt::AlignCenter);
ui->lib233->setMaximumWidth( m12trail);
ui->lib233->setMinimumWidth( m6trail);
ui->lib233->setMaximumHeight( m7traild3 );
ui->lib233->setMaxLength(11);
ui->lib233->setFrame(globalFrame);

ui->lib234->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "23    ") );
connect( ui->lib234, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib234, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib234->installEventFilter(this);
ui->lib234->setAlignment(Qt::AlignCenter);
ui->lib234->setMaximumWidth( m12trail);
ui->lib234->setMinimumWidth( m6trail);
ui->lib234->setMaximumHeight( m7traild3 );
ui->lib234->setMaxLength(11);
ui->lib234->setFrame(globalFrame);

ui->pushButtonEst23->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "23    ") );
ui->pushButtonEst23->setMaximumWidth( m7traild3 );
ui->pushButtonEst23->setMaximumHeight( m7traild3 );
ui->pushButtonLib23->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "23    ") );
ui->pushButtonLib23->setMaximumWidth( m7traild3 );
ui->pushButtonLib23->setMaximumHeight( m7traild3 );

ui->est231->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "23    ") );
connect( ui->est231, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est231, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est231->installEventFilter(this);
ui->est231->setMaximumWidth( m6trail);
ui->est231->setMinimumWidth( m6trail);
ui->est231->setMaximumHeight( m7traild3 );
ui->est231->setMaxLength(3);
ui->est231->setFrame(globalFrame);

ui->est232->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "23    ") );
connect( ui->est232, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est232, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est232->installEventFilter(this);
ui->est232->setMaximumWidth( m26trail);
ui->est232->setMinimumWidth( m25trail);
ui->est232->setMaximumHeight( m7traild3 );
ui->est232->setMaxLength(24);
ui->est232->setFrame(globalFrame);

ui->est233->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "23    ") );
connect( ui->est233, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est233, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est233->installEventFilter(this);
ui->est233->setAlignment(Qt::AlignCenter);
ui->est233->setMaximumWidth( m11trail);
ui->est233->setMinimumWidth( m6trail);
ui->est233->setMaximumHeight( m7traild3 );
ui->est233->setMaxLength(8);
ui->est233->setFrame(globalFrame);

ui->est234->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "23    ") );
connect( ui->est234, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est234, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est234->installEventFilter(this);
ui->est234->setAlignment(Qt::AlignCenter);
ui->est234->setMaximumWidth( m12trail);
ui->est234->setMinimumWidth( m6trail);
ui->est234->setMaximumHeight( m7traild3 );
ui->est234->setMaxLength(11);
ui->est234->setFrame(globalFrame);

ui->est235->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "23    ") );
connect( ui->est235, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est235, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est235->installEventFilter(this);
ui->est235->setAlignment(Qt::AlignCenter);
ui->est235->setMaximumWidth( m12trail);
ui->est235->setMinimumWidth( m6trail);
ui->est235->setMaximumHeight( m7traild3 );
ui->est235->setMaxLength(11);
ui->est235->setFrame(globalFrame);

ui->est236->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "23    ") );
ui->est236->setReadOnly(true);
ui->est236->setAlignment(Qt::AlignRight);
ui->est236->setMaximumWidth( m14trail);
ui->est236->setMinimumWidth( m9trail);
ui->est236->setMaximumHeight( m7traild3 );
ui->est236->setMaxLength(15);
ui->est236->setFrame(globalFrame);

ui->est237->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "23    ") );
ui->est237->setReadOnly(true);
ui->est237->setAlignment(Qt::AlignRight);
ui->est237->setMaximumWidth( m14trail);
ui->est237->setMinimumWidth( m9trail);
ui->est237->setMaximumHeight( m7traild3 );
ui->est237->setMaxLength(15);
ui->est237->setFrame(globalFrame);

ui->lib241->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "24    ") );
connect( ui->lib241, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib241, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib24, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst24, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib241->installEventFilter(this);
ui->lib241->setMaximumWidth( m6trail);
ui->lib241->setMinimumWidth( m6trail);
ui->lib241->setMaximumHeight( m7traild3 );
ui->lib241->setMaxLength(3);
ui->lib241->setFrame(globalFrame);

ui->lib242->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "24    ") );
connect( ui->lib242, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib242, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib242->installEventFilter(this);
ui->lib242->setMaximumWidth( m26trail);
ui->lib242->setMinimumWidth( m25trail);
ui->lib242->setMaximumHeight( m7traild3 );
ui->lib242->setMaxLength(24);
ui->lib242->setFrame(globalFrame);

ui->lib243->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "24    ") );
connect( ui->lib243, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib243, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib243->installEventFilter(this);
ui->lib243->setAlignment(Qt::AlignCenter);
ui->lib243->setMaximumWidth( m12trail);
ui->lib243->setMinimumWidth( m6trail);
ui->lib243->setMaximumHeight( m7traild3 );
ui->lib243->setMaxLength(11);
ui->lib243->setFrame(globalFrame);

ui->lib244->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "24    ") );
connect( ui->lib244, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib244, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib244->installEventFilter(this);
ui->lib244->setAlignment(Qt::AlignCenter);
ui->lib244->setMaximumWidth( m12trail);
ui->lib244->setMinimumWidth( m6trail);
ui->lib244->setMaximumHeight( m7traild3 );
ui->lib244->setMaxLength(11);
ui->lib244->setFrame(globalFrame);

ui->pushButtonEst24->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "24    ") );
ui->pushButtonEst24->setMaximumWidth( m7traild3 );
ui->pushButtonEst24->setMaximumHeight( m7traild3 );
ui->pushButtonLib24->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "24    ") );
ui->pushButtonLib24->setMaximumWidth( m7traild3 );
ui->pushButtonLib24->setMaximumHeight( m7traild3 );

ui->est241->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "24    ") );
connect( ui->est241, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est241, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est241->installEventFilter(this);
ui->est241->setMaximumWidth( m6trail);
ui->est241->setMinimumWidth( m6trail);
ui->est241->setMaximumHeight( m7traild3 );
ui->est241->setMaxLength(3);
ui->est241->setFrame(globalFrame);

ui->est242->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "24    ") );
connect( ui->est242, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est242, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est242->installEventFilter(this);
ui->est242->setMaximumWidth( m26trail);
ui->est242->setMinimumWidth( m25trail);
ui->est242->setMaximumHeight( m7traild3 );
ui->est242->setMaxLength(24);
ui->est242->setFrame(globalFrame);

ui->est243->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "24    ") );
connect( ui->est243, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est243, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est243->installEventFilter(this);
ui->est243->setAlignment(Qt::AlignCenter);
ui->est243->setMaximumWidth( m11trail);
ui->est243->setMinimumWidth( m6trail);
ui->est243->setMaximumHeight( m7traild3 );
ui->est243->setMaxLength(8);
ui->est243->setFrame(globalFrame);

ui->est244->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "24    ") );
connect( ui->est244, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est244, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est244->installEventFilter(this);
ui->est244->setAlignment(Qt::AlignCenter);
ui->est244->setMaximumWidth( m12trail);
ui->est244->setMinimumWidth( m6trail);
ui->est244->setMaximumHeight( m7traild3 );
ui->est244->setMaxLength(11);
ui->est244->setFrame(globalFrame);

ui->est245->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "24    ") );
connect( ui->est245, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est245, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est245->installEventFilter(this);
ui->est245->setAlignment(Qt::AlignCenter);
ui->est245->setMaximumWidth( m12trail);
ui->est245->setMinimumWidth( m6trail);
ui->est245->setMaximumHeight( m7traild3 );
ui->est245->setMaxLength(11);
ui->est245->setFrame(globalFrame);

ui->est246->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "24    ") );
ui->est246->setReadOnly(true);
ui->est246->setAlignment(Qt::AlignRight);
ui->est246->setMaximumWidth( m14trail);
ui->est246->setMinimumWidth( m9trail);
ui->est246->setMaximumHeight( m7traild3 );
ui->est246->setMaxLength(15);
ui->est246->setFrame(globalFrame);

ui->est247->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "24    ") );
ui->est247->setReadOnly(true);
ui->est247->setAlignment(Qt::AlignRight);
ui->est247->setMaximumWidth( m14trail);
ui->est247->setMinimumWidth( m9trail);
ui->est247->setMaximumHeight( m7traild3 );
ui->est247->setMaxLength(15);
ui->est247->setFrame(globalFrame);

ui->lib251->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "25    ") );
connect( ui->lib251, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib251, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib25, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst25, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib251->installEventFilter(this);
ui->lib251->setMaximumWidth( m6trail);
ui->lib251->setMinimumWidth( m6trail);
ui->lib251->setMaximumHeight( m7traild3 );
ui->lib251->setMaxLength(3);
ui->lib251->setFrame(globalFrame);

ui->lib252->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "25    ") );
connect( ui->lib252, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib252, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib252->installEventFilter(this);
ui->lib252->setMaximumWidth( m26trail);
ui->lib252->setMinimumWidth( m25trail);
ui->lib252->setMaximumHeight( m7traild3 );
ui->lib252->setMaxLength(24);
ui->lib252->setFrame(globalFrame);

ui->lib253->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "25    ") );
connect( ui->lib253, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib253, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib253->installEventFilter(this);
ui->lib253->setAlignment(Qt::AlignCenter);
ui->lib253->setMaximumWidth( m12trail);
ui->lib253->setMinimumWidth( m6trail);
ui->lib253->setMaximumHeight( m7traild3 );
ui->lib253->setMaxLength(11);
ui->lib253->setFrame(globalFrame);

ui->lib254->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "25    ") );
connect( ui->lib254, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib254, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib254->installEventFilter(this);
ui->lib254->setAlignment(Qt::AlignCenter);
ui->lib254->setMaximumWidth( m12trail);
ui->lib254->setMinimumWidth( m6trail);
ui->lib254->setMaximumHeight( m7traild3 );
ui->lib254->setMaxLength(11);
ui->lib254->setFrame(globalFrame);

ui->pushButtonEst25->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "25    ") );
ui->pushButtonEst25->setMaximumWidth( m7traild3 );
ui->pushButtonEst25->setMaximumHeight( m7traild3 );
ui->pushButtonLib25->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "25    ") );
ui->pushButtonLib25->setMaximumWidth( m7traild3 );
ui->pushButtonLib25->setMaximumHeight( m7traild3 );

ui->est251->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "25    ") );
connect( ui->est251, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est251, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est251->installEventFilter(this);
ui->est251->setMaximumWidth( m6trail);
ui->est251->setMinimumWidth( m6trail);
ui->est251->setMaximumHeight( m7traild3 );
ui->est251->setMaxLength(3);
ui->est251->setFrame(globalFrame);

ui->est252->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "25    ") );
connect( ui->est252, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est252, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est252->installEventFilter(this);
ui->est252->setMaximumWidth( m26trail);
ui->est252->setMinimumWidth( m25trail);
ui->est252->setMaximumHeight( m7traild3 );
ui->est252->setMaxLength(24);
ui->est252->setFrame(globalFrame);

ui->est253->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "25    ") );
connect( ui->est253, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est253, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est253->installEventFilter(this);
ui->est253->setAlignment(Qt::AlignCenter);
ui->est253->setMaximumWidth( m11trail);
ui->est253->setMinimumWidth( m6trail);
ui->est253->setMaximumHeight( m7traild3 );
ui->est253->setMaxLength(8);
ui->est253->setFrame(globalFrame);

ui->est254->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "25    ") );
connect( ui->est254, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est254, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est254->installEventFilter(this);
ui->est254->setAlignment(Qt::AlignCenter);
ui->est254->setMaximumWidth( m12trail);
ui->est254->setMinimumWidth( m6trail);
ui->est254->setMaximumHeight( m7traild3 );
ui->est254->setMaxLength(11);
ui->est254->setFrame(globalFrame);

ui->est255->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "25    ") );
connect( ui->est255, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est255, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est255->installEventFilter(this);
ui->est255->setAlignment(Qt::AlignCenter);
ui->est255->setMaximumWidth( m12trail);
ui->est255->setMinimumWidth( m6trail);
ui->est255->setMaximumHeight( m7traild3 );
ui->est255->setMaxLength(11);
ui->est255->setFrame(globalFrame);

ui->est256->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "25    ") );
ui->est256->setReadOnly(true);
ui->est256->setAlignment(Qt::AlignRight);
ui->est256->setMaximumWidth( m14trail);
ui->est256->setMinimumWidth( m9trail);
ui->est256->setMaximumHeight( m7traild3 );
ui->est256->setMaxLength(15);
ui->est256->setFrame(globalFrame);

ui->est257->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "25    ") );
ui->est257->setReadOnly(true);
ui->est257->setAlignment(Qt::AlignRight);
ui->est257->setMaximumWidth( m14trail);
ui->est257->setMinimumWidth( m9trail);
ui->est257->setMaximumHeight( m7traild3 );
ui->est257->setMaxLength(15);
ui->est257->setFrame(globalFrame);

ui->lib261->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "26    ") );
connect( ui->lib261, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib261, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib26, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst26, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib261->installEventFilter(this);
ui->lib261->setMaximumWidth( m6trail);
ui->lib261->setMinimumWidth( m6trail);
ui->lib261->setMaximumHeight( m7traild3 );
ui->lib261->setMaxLength(3);
ui->lib261->setFrame(globalFrame);

ui->lib262->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "26    ") );
connect( ui->lib262, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib262, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib262->installEventFilter(this);
ui->lib262->setMaximumWidth( m26trail);
ui->lib262->setMinimumWidth( m25trail);
ui->lib262->setMaximumHeight( m7traild3 );
ui->lib262->setMaxLength(24);
ui->lib262->setFrame(globalFrame);

ui->lib263->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "26    ") );
connect( ui->lib263, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib263, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib263->installEventFilter(this);
ui->lib263->setAlignment(Qt::AlignCenter);
ui->lib263->setMaximumWidth( m12trail);
ui->lib263->setMinimumWidth( m6trail);
ui->lib263->setMaximumHeight( m7traild3 );
ui->lib263->setMaxLength(11);
ui->lib263->setFrame(globalFrame);

ui->lib264->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "26    ") );
connect( ui->lib264, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib264, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib264->installEventFilter(this);
ui->lib264->setAlignment(Qt::AlignCenter);
ui->lib264->setMaximumWidth( m12trail);
ui->lib264->setMinimumWidth( m6trail);
ui->lib264->setMaximumHeight( m7traild3 );
ui->lib264->setMaxLength(11);
ui->lib264->setFrame(globalFrame);

ui->pushButtonEst26->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "26    ") );
ui->pushButtonEst26->setMaximumWidth( m7traild3 );
ui->pushButtonEst26->setMaximumHeight( m7traild3 );
ui->pushButtonLib26->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "26    ") );
ui->pushButtonLib26->setMaximumWidth( m7traild3 );
ui->pushButtonLib26->setMaximumHeight( m7traild3 );

ui->est261->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "26    ") );
connect( ui->est261, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est261, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est261->installEventFilter(this);
ui->est261->setMaximumWidth( m6trail);
ui->est261->setMinimumWidth( m6trail);
ui->est261->setMaximumHeight( m7traild3 );
ui->est261->setMaxLength(3);
ui->est261->setFrame(globalFrame);

ui->est262->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "26    ") );
connect( ui->est262, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est262, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est262->installEventFilter(this);
ui->est262->setMaximumWidth( m26trail);
ui->est262->setMinimumWidth( m25trail);
ui->est262->setMaximumHeight( m7traild3 );
ui->est262->setMaxLength(24);
ui->est262->setFrame(globalFrame);

ui->est263->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "26    ") );
connect( ui->est263, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est263, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est263->installEventFilter(this);
ui->est263->setAlignment(Qt::AlignCenter);
ui->est263->setMaximumWidth( m11trail);
ui->est263->setMinimumWidth( m6trail);
ui->est263->setMaximumHeight( m7traild3 );
ui->est263->setMaxLength(8);
ui->est263->setFrame(globalFrame);

ui->est264->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "26    ") );
connect( ui->est264, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est264, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est264->installEventFilter(this);
ui->est264->setAlignment(Qt::AlignCenter);
ui->est264->setMaximumWidth( m12trail);
ui->est264->setMinimumWidth( m6trail);
ui->est264->setMaximumHeight( m7traild3 );
ui->est264->setMaxLength(11);
ui->est264->setFrame(globalFrame);

ui->est265->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "26    ") );
connect( ui->est265, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est265, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est265->installEventFilter(this);
ui->est265->setAlignment(Qt::AlignCenter);
ui->est265->setMaximumWidth( m12trail);
ui->est265->setMinimumWidth( m6trail);
ui->est265->setMaximumHeight( m7traild3 );
ui->est265->setMaxLength(11);
ui->est265->setFrame(globalFrame);

ui->est266->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "26    ") );
ui->est266->setReadOnly(true);
ui->est266->setAlignment(Qt::AlignRight);
ui->est266->setMaximumWidth( m14trail);
ui->est266->setMinimumWidth( m9trail);
ui->est266->setMaximumHeight( m7traild3 );
ui->est266->setMaxLength(15);
ui->est266->setFrame(globalFrame);

ui->est267->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "26    ") );
ui->est267->setReadOnly(true);
ui->est267->setAlignment(Qt::AlignRight);
ui->est267->setMaximumWidth( m14trail);
ui->est267->setMinimumWidth( m9trail);
ui->est267->setMaximumHeight( m7traild3 );
ui->est267->setMaxLength(15);
ui->est267->setFrame(globalFrame);

ui->lib271->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "27    ") );
connect( ui->lib271, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib271, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib27, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst27, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib271->installEventFilter(this);
ui->lib271->setMaximumWidth( m6trail);
ui->lib271->setMinimumWidth( m6trail);
ui->lib271->setMaximumHeight( m7traild3 );
ui->lib271->setMaxLength(3);
ui->lib271->setFrame(globalFrame);

ui->lib272->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "27    ") );
connect( ui->lib272, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib272, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib272->installEventFilter(this);
ui->lib272->setMaximumWidth( m26trail);
ui->lib272->setMinimumWidth( m25trail);
ui->lib272->setMaximumHeight( m7traild3 );
ui->lib272->setMaxLength(24);
ui->lib272->setFrame(globalFrame);

ui->lib273->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "27    ") );
connect( ui->lib273, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib273, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib273->installEventFilter(this);
ui->lib273->setAlignment(Qt::AlignCenter);
ui->lib273->setMaximumWidth( m12trail);
ui->lib273->setMinimumWidth( m6trail);
ui->lib273->setMaximumHeight( m7traild3 );
ui->lib273->setMaxLength(11);
ui->lib273->setFrame(globalFrame);

ui->lib274->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "27    ") );
connect( ui->lib274, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib274, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib274->installEventFilter(this);
ui->lib274->setAlignment(Qt::AlignCenter);
ui->lib274->setMaximumWidth( m12trail);
ui->lib274->setMinimumWidth( m6trail);
ui->lib274->setMaximumHeight( m7traild3 );
ui->lib274->setMaxLength(11);
ui->lib274->setFrame(globalFrame);

ui->pushButtonEst27->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "27    ") );
ui->pushButtonEst27->setMaximumWidth( m7traild3 );
ui->pushButtonEst27->setMaximumHeight( m7traild3 );
ui->pushButtonLib27->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "27    ") );
ui->pushButtonLib27->setMaximumWidth( m7traild3 );
ui->pushButtonLib27->setMaximumHeight( m7traild3 );

ui->est271->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "27    ") );
connect( ui->est271, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est271, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est271->installEventFilter(this);
ui->est271->setMaximumWidth( m6trail);
ui->est271->setMinimumWidth( m6trail);
ui->est271->setMaximumHeight( m7traild3 );
ui->est271->setMaxLength(3);
ui->est271->setFrame(globalFrame);

ui->est272->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "27    ") );
connect( ui->est272, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est272, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est272->installEventFilter(this);
ui->est272->setMaximumWidth( m26trail);
ui->est272->setMinimumWidth( m25trail);
ui->est272->setMaximumHeight( m7traild3 );
ui->est272->setMaxLength(24);
ui->est272->setFrame(globalFrame);

ui->est273->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "27    ") );
connect( ui->est273, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est273, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est273->installEventFilter(this);
ui->est273->setAlignment(Qt::AlignCenter);
ui->est273->setMaximumWidth( m11trail);
ui->est273->setMinimumWidth( m6trail);
ui->est273->setMaximumHeight( m7traild3 );
ui->est273->setMaxLength(8);
ui->est273->setFrame(globalFrame);

ui->est274->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "27    ") );
connect( ui->est274, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est274, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est274->installEventFilter(this);
ui->est274->setAlignment(Qt::AlignCenter);
ui->est274->setMaximumWidth( m12trail);
ui->est274->setMinimumWidth( m6trail);
ui->est274->setMaximumHeight( m7traild3 );
ui->est274->setMaxLength(11);
ui->est274->setFrame(globalFrame);

ui->est275->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "27    ") );
connect( ui->est275, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est275, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est275->installEventFilter(this);
ui->est275->setAlignment(Qt::AlignCenter);
ui->est275->setMaximumWidth( m12trail);
ui->est275->setMinimumWidth( m6trail);
ui->est275->setMaximumHeight( m7traild3 );
ui->est275->setMaxLength(11);
ui->est275->setFrame(globalFrame);

ui->est276->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "27    ") );
ui->est276->setReadOnly(true);
ui->est276->setAlignment(Qt::AlignRight);
ui->est276->setMaximumWidth( m14trail);
ui->est276->setMinimumWidth( m9trail);
ui->est276->setMaximumHeight( m7traild3 );
ui->est276->setMaxLength(15);
ui->est276->setFrame(globalFrame);

ui->est277->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "27    ") );
ui->est277->setReadOnly(true);
ui->est277->setAlignment(Qt::AlignRight);
ui->est277->setMaximumWidth( m14trail);
ui->est277->setMinimumWidth( m9trail);
ui->est277->setMaximumHeight( m7traild3 );
ui->est277->setMaxLength(15);
ui->est277->setFrame(globalFrame);

ui->lib281->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "28    ") );
connect( ui->lib281, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib281, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib28, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst28, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib281->installEventFilter(this);
ui->lib281->setMaximumWidth( m6trail);
ui->lib281->setMinimumWidth( m6trail);
ui->lib281->setMaximumHeight( m7traild3 );
ui->lib281->setMaxLength(3);
ui->lib281->setFrame(globalFrame);

ui->lib282->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "28    ") );
connect( ui->lib282, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib282, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib282->installEventFilter(this);
ui->lib282->setMaximumWidth( m26trail);
ui->lib282->setMinimumWidth( m25trail);
ui->lib282->setMaximumHeight( m7traild3 );
ui->lib282->setMaxLength(24);
ui->lib282->setFrame(globalFrame);

ui->lib283->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "28    ") );
connect( ui->lib283, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib283, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib283->installEventFilter(this);
ui->lib283->setAlignment(Qt::AlignCenter);
ui->lib283->setMaximumWidth( m12trail);
ui->lib283->setMinimumWidth( m6trail);
ui->lib283->setMaximumHeight( m7traild3 );
ui->lib283->setMaxLength(11);
ui->lib283->setFrame(globalFrame);

ui->lib284->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "28    ") );
connect( ui->lib284, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib284, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib284->installEventFilter(this);
ui->lib284->setAlignment(Qt::AlignCenter);
ui->lib284->setMaximumWidth( m12trail);
ui->lib284->setMinimumWidth( m6trail);
ui->lib284->setMaximumHeight( m7traild3 );
ui->lib284->setMaxLength(11);
ui->lib284->setFrame(globalFrame);

ui->pushButtonEst28->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "28    ") );
ui->pushButtonEst28->setMaximumWidth( m7traild3 );
ui->pushButtonEst28->setMaximumHeight( m7traild3 );
ui->pushButtonLib28->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "28    ") );
ui->pushButtonLib28->setMaximumWidth( m7traild3 );
ui->pushButtonLib28->setMaximumHeight( m7traild3 );

ui->est281->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "28    ") );
connect( ui->est281, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est281, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est281->installEventFilter(this);
ui->est281->setMaximumWidth( m6trail);
ui->est281->setMinimumWidth( m6trail);
ui->est281->setMaximumHeight( m7traild3 );
ui->est281->setMaxLength(3);
ui->est281->setFrame(globalFrame);

ui->est282->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "28    ") );
connect( ui->est282, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est282, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est282->installEventFilter(this);
ui->est282->setMaximumWidth( m26trail);
ui->est282->setMinimumWidth( m25trail);
ui->est282->setMaximumHeight( m7traild3 );
ui->est282->setMaxLength(24);
ui->est282->setFrame(globalFrame);

ui->est283->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "28    ") );
connect( ui->est283, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est283, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est283->installEventFilter(this);
ui->est283->setAlignment(Qt::AlignCenter);
ui->est283->setMaximumWidth( m11trail);
ui->est283->setMinimumWidth( m6trail);
ui->est283->setMaximumHeight( m7traild3 );
ui->est283->setMaxLength(8);
ui->est283->setFrame(globalFrame);

ui->est284->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "28    ") );
connect( ui->est284, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est284, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est284->installEventFilter(this);
ui->est284->setAlignment(Qt::AlignCenter);
ui->est284->setMaximumWidth( m12trail);
ui->est284->setMinimumWidth( m6trail);
ui->est284->setMaximumHeight( m7traild3 );
ui->est284->setMaxLength(11);
ui->est284->setFrame(globalFrame);

ui->est285->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "28    ") );
connect( ui->est285, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est285, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est285->installEventFilter(this);
ui->est285->setAlignment(Qt::AlignCenter);
ui->est285->setMaximumWidth( m12trail);
ui->est285->setMinimumWidth( m6trail);
ui->est285->setMaximumHeight( m7traild3 );
ui->est285->setMaxLength(11);
ui->est285->setFrame(globalFrame);

ui->est286->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "28    ") );
ui->est286->setReadOnly(true);
ui->est286->setAlignment(Qt::AlignRight);
ui->est286->setMaximumWidth( m14trail);
ui->est286->setMinimumWidth( m9trail);
ui->est286->setMaximumHeight( m7traild3 );
ui->est286->setMaxLength(15);
ui->est286->setFrame(globalFrame);

ui->est287->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "28    ") );
ui->est287->setReadOnly(true);
ui->est287->setAlignment(Qt::AlignRight);
ui->est287->setMaximumWidth( m14trail);
ui->est287->setMinimumWidth( m9trail);
ui->est287->setMaximumHeight( m7traild3 );
ui->est287->setMaxLength(15);
ui->est287->setFrame(globalFrame);

ui->lib291->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "29    ") );
connect( ui->lib291, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib291, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib29, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst29, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib291->installEventFilter(this);
ui->lib291->setMaximumWidth( m6trail);
ui->lib291->setMinimumWidth( m6trail);
ui->lib291->setMaximumHeight( m7traild3 );
ui->lib291->setMaxLength(3);
ui->lib291->setFrame(globalFrame);

ui->lib292->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "29    ") );
connect( ui->lib292, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib292, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib292->installEventFilter(this);
ui->lib292->setMaximumWidth( m26trail);
ui->lib292->setMinimumWidth( m25trail);
ui->lib292->setMaximumHeight( m7traild3 );
ui->lib292->setMaxLength(24);
ui->lib292->setFrame(globalFrame);

ui->lib293->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "29    ") );
connect( ui->lib293, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib293, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib293->installEventFilter(this);
ui->lib293->setAlignment(Qt::AlignCenter);
ui->lib293->setMaximumWidth( m12trail);
ui->lib293->setMinimumWidth( m6trail);
ui->lib293->setMaximumHeight( m7traild3 );
ui->lib293->setMaxLength(11);
ui->lib293->setFrame(globalFrame);

ui->lib294->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "29    ") );
connect( ui->lib294, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib294, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib294->installEventFilter(this);
ui->lib294->setAlignment(Qt::AlignCenter);
ui->lib294->setMaximumWidth( m12trail);
ui->lib294->setMinimumWidth( m6trail);
ui->lib294->setMaximumHeight( m7traild3 );
ui->lib294->setMaxLength(11);
ui->lib294->setFrame(globalFrame);

ui->pushButtonEst29->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "29    ") );
ui->pushButtonEst29->setMaximumWidth( m7traild3 );
ui->pushButtonEst29->setMaximumHeight( m7traild3 );
ui->pushButtonLib29->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "29    ") );
ui->pushButtonLib29->setMaximumWidth( m7traild3 );
ui->pushButtonLib29->setMaximumHeight( m7traild3 );

ui->est291->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "29    ") );
connect( ui->est291, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est291, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est291->installEventFilter(this);
ui->est291->setMaximumWidth( m6trail);
ui->est291->setMinimumWidth( m6trail);
ui->est291->setMaximumHeight( m7traild3 );
ui->est291->setMaxLength(3);
ui->est291->setFrame(globalFrame);

ui->est292->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "29    ") );
connect( ui->est292, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est292, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est292->installEventFilter(this);
ui->est292->setMaximumWidth( m26trail);
ui->est292->setMinimumWidth( m25trail);
ui->est292->setMaximumHeight( m7traild3 );
ui->est292->setMaxLength(24);
ui->est292->setFrame(globalFrame);

ui->est293->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "29    ") );
connect( ui->est293, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est293, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est293->installEventFilter(this);
ui->est293->setAlignment(Qt::AlignCenter);
ui->est293->setMaximumWidth( m11trail);
ui->est293->setMinimumWidth( m6trail);
ui->est293->setMaximumHeight( m7traild3 );
ui->est293->setMaxLength(8);
ui->est293->setFrame(globalFrame);

ui->est294->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "29    ") );
connect( ui->est294, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est294, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est294->installEventFilter(this);
ui->est294->setAlignment(Qt::AlignCenter);
ui->est294->setMaximumWidth( m12trail);
ui->est294->setMinimumWidth( m6trail);
ui->est294->setMaximumHeight( m7traild3 );
ui->est294->setMaxLength(11);
ui->est294->setFrame(globalFrame);

ui->est295->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "29    ") );
connect( ui->est295, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est295, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est295->installEventFilter(this);
ui->est295->setAlignment(Qt::AlignCenter);
ui->est295->setMaximumWidth( m12trail);
ui->est295->setMinimumWidth( m6trail);
ui->est295->setMaximumHeight( m7traild3 );
ui->est295->setMaxLength(11);
ui->est295->setFrame(globalFrame);

ui->est296->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "29    ") );
ui->est296->setReadOnly(true);
ui->est296->setAlignment(Qt::AlignRight);
ui->est296->setMaximumWidth( m14trail);
ui->est296->setMinimumWidth( m9trail);
ui->est296->setMaximumHeight( m7traild3 );
ui->est296->setMaxLength(15);
ui->est296->setFrame(globalFrame);

ui->est297->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "29    ") );
ui->est297->setReadOnly(true);
ui->est297->setAlignment(Qt::AlignRight);
ui->est297->setMaximumWidth( m14trail);
ui->est297->setMinimumWidth( m9trail);
ui->est297->setMaximumHeight( m7traild3 );
ui->est297->setMaxLength(15);
ui->est297->setFrame(globalFrame);

ui->lib301->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "30    ") );
connect( ui->lib301, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib301, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib30, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst30, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib301->installEventFilter(this);
ui->lib301->setMaximumWidth( m6trail);
ui->lib301->setMinimumWidth( m6trail);
ui->lib301->setMaximumHeight( m7traild3 );
ui->lib301->setMaxLength(3);
ui->lib301->setFrame(globalFrame);

ui->lib302->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "30    ") );
connect( ui->lib302, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib302, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib302->installEventFilter(this);
ui->lib302->setMaximumWidth( m26trail);
ui->lib302->setMinimumWidth( m25trail);
ui->lib302->setMaximumHeight( m7traild3 );
ui->lib302->setMaxLength(24);
ui->lib302->setFrame(globalFrame);

ui->lib303->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "30    ") );
connect( ui->lib303, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib303, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib303->installEventFilter(this);
ui->lib303->setAlignment(Qt::AlignCenter);
ui->lib303->setMaximumWidth( m12trail);
ui->lib303->setMinimumWidth( m6trail);
ui->lib303->setMaximumHeight( m7traild3 );
ui->lib303->setMaxLength(11);
ui->lib303->setFrame(globalFrame);

ui->lib304->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "30    ") );
connect( ui->lib304, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib304, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib304->installEventFilter(this);
ui->lib304->setAlignment(Qt::AlignCenter);
ui->lib304->setMaximumWidth( m12trail);
ui->lib304->setMinimumWidth( m6trail);
ui->lib304->setMaximumHeight( m7traild3 );
ui->lib304->setMaxLength(11);
ui->lib304->setFrame(globalFrame);

ui->pushButtonEst30->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "30    ") );
ui->pushButtonEst30->setMaximumWidth( m7traild3 );
ui->pushButtonEst30->setMaximumHeight( m7traild3 );
ui->pushButtonLib30->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "30    ") );
ui->pushButtonLib30->setMaximumWidth( m7traild3 );
ui->pushButtonLib30->setMaximumHeight( m7traild3 );

ui->est301->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "30    ") );
connect( ui->est301, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est301, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est301->installEventFilter(this);
ui->est301->setMaximumWidth( m6trail);
ui->est301->setMinimumWidth( m6trail);
ui->est301->setMaximumHeight( m7traild3 );
ui->est301->setMaxLength(3);
ui->est301->setFrame(globalFrame);

ui->est302->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "30    ") );
connect( ui->est302, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est302, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est302->installEventFilter(this);
ui->est302->setMaximumWidth( m26trail);
ui->est302->setMinimumWidth( m25trail);
ui->est302->setMaximumHeight( m7traild3 );
ui->est302->setMaxLength(24);
ui->est302->setFrame(globalFrame);

ui->est303->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "30    ") );
connect( ui->est303, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est303, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est303->installEventFilter(this);
ui->est303->setAlignment(Qt::AlignCenter);
ui->est303->setMaximumWidth( m11trail);
ui->est303->setMinimumWidth( m6trail);
ui->est303->setMaximumHeight( m7traild3 );
ui->est303->setMaxLength(8);
ui->est303->setFrame(globalFrame);

ui->est304->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "30    ") );
connect( ui->est304, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est304, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est304->installEventFilter(this);
ui->est304->setAlignment(Qt::AlignCenter);
ui->est304->setMaximumWidth( m12trail);
ui->est304->setMinimumWidth( m6trail);
ui->est304->setMaximumHeight( m7traild3 );
ui->est304->setMaxLength(11);
ui->est304->setFrame(globalFrame);

ui->est305->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "30    ") );
connect( ui->est305, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est305, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est305->installEventFilter(this);
ui->est305->setAlignment(Qt::AlignCenter);
ui->est305->setMaximumWidth( m12trail);
ui->est305->setMinimumWidth( m6trail);
ui->est305->setMaximumHeight( m7traild3 );
ui->est305->setMaxLength(11);
ui->est305->setFrame(globalFrame);

ui->est306->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "30    ") );
ui->est306->setReadOnly(true);
ui->est306->setAlignment(Qt::AlignRight);
ui->est306->setMaximumWidth( m14trail);
ui->est306->setMinimumWidth( m9trail);
ui->est306->setMaximumHeight( m7traild3 );
ui->est306->setMaxLength(15);
ui->est306->setFrame(globalFrame);

ui->est307->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "30    ") );
ui->est307->setReadOnly(true);
ui->est307->setAlignment(Qt::AlignRight);
ui->est307->setMaximumWidth( m14trail);
ui->est307->setMinimumWidth( m9trail);
ui->est307->setMaximumHeight( m7traild3 );
ui->est307->setMaxLength(15);
ui->est307->setFrame(globalFrame);

ui->lib311->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "31    ") );
connect( ui->lib311, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib311, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib31, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst31, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib311->installEventFilter(this);
ui->lib311->setMaximumWidth( m6trail);
ui->lib311->setMinimumWidth( m6trail);
ui->lib311->setMaximumHeight( m7traild3 );
ui->lib311->setMaxLength(3);
ui->lib311->setFrame(globalFrame);

ui->lib312->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "31    ") );
connect( ui->lib312, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib312, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib312->installEventFilter(this);
ui->lib312->setMaximumWidth( m26trail);
ui->lib312->setMinimumWidth( m25trail);
ui->lib312->setMaximumHeight( m7traild3 );
ui->lib312->setMaxLength(24);
ui->lib312->setFrame(globalFrame);

ui->lib313->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "31    ") );
connect( ui->lib313, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib313, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib313->installEventFilter(this);
ui->lib313->setAlignment(Qt::AlignCenter);
ui->lib313->setMaximumWidth( m12trail);
ui->lib313->setMinimumWidth( m6trail);
ui->lib313->setMaximumHeight( m7traild3 );
ui->lib313->setMaxLength(11);
ui->lib313->setFrame(globalFrame);

ui->lib314->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "31    ") );
connect( ui->lib314, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib314, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib314->installEventFilter(this);
ui->lib314->setAlignment(Qt::AlignCenter);
ui->lib314->setMaximumWidth( m12trail);
ui->lib314->setMinimumWidth( m6trail);
ui->lib314->setMaximumHeight( m7traild3 );
ui->lib314->setMaxLength(11);
ui->lib314->setFrame(globalFrame);

ui->pushButtonEst31->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "31    ") );
ui->pushButtonEst31->setMaximumWidth( m7traild3 );
ui->pushButtonEst31->setMaximumHeight( m7traild3 );
ui->pushButtonLib31->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "31    ") );
ui->pushButtonLib31->setMaximumWidth( m7traild3 );
ui->pushButtonLib31->setMaximumHeight( m7traild3 );

ui->est311->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "31    ") );
connect( ui->est311, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est311, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est311->installEventFilter(this);
ui->est311->setMaximumWidth( m6trail);
ui->est311->setMinimumWidth( m6trail);
ui->est311->setMaximumHeight( m7traild3 );
ui->est311->setMaxLength(3);
ui->est311->setFrame(globalFrame);

ui->est312->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "31    ") );
connect( ui->est312, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est312, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est312->installEventFilter(this);
ui->est312->setMaximumWidth( m26trail);
ui->est312->setMinimumWidth( m25trail);
ui->est312->setMaximumHeight( m7traild3 );
ui->est312->setMaxLength(24);
ui->est312->setFrame(globalFrame);

ui->est313->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "31    ") );
connect( ui->est313, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est313, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est313->installEventFilter(this);
ui->est313->setAlignment(Qt::AlignCenter);
ui->est313->setMaximumWidth( m11trail);
ui->est313->setMinimumWidth( m6trail);
ui->est313->setMaximumHeight( m7traild3 );
ui->est313->setMaxLength(8);
ui->est313->setFrame(globalFrame);

ui->est314->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "31    ") );
connect( ui->est314, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est314, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est314->installEventFilter(this);
ui->est314->setAlignment(Qt::AlignCenter);
ui->est314->setMaximumWidth( m12trail);
ui->est314->setMinimumWidth( m6trail);
ui->est314->setMaximumHeight( m7traild3 );
ui->est314->setMaxLength(11);
ui->est314->setFrame(globalFrame);

ui->est315->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "31    ") );
connect( ui->est315, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est315, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est315->installEventFilter(this);
ui->est315->setAlignment(Qt::AlignCenter);
ui->est315->setMaximumWidth( m12trail);
ui->est315->setMinimumWidth( m6trail);
ui->est315->setMaximumHeight( m7traild3 );
ui->est315->setMaxLength(11);
ui->est315->setFrame(globalFrame);

ui->est316->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "31    ") );
ui->est316->setReadOnly(true);
ui->est316->setAlignment(Qt::AlignRight);
ui->est316->setMaximumWidth( m14trail);
ui->est316->setMinimumWidth( m9trail);
ui->est316->setMaximumHeight( m7traild3 );
ui->est316->setMaxLength(15);
ui->est316->setFrame(globalFrame);

ui->est317->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "31    ") );
ui->est317->setReadOnly(true);
ui->est317->setAlignment(Qt::AlignRight);
ui->est317->setMaximumWidth( m14trail);
ui->est317->setMinimumWidth( m9trail);
ui->est317->setMaximumHeight( m7traild3 );
ui->est317->setMaxLength(15);
ui->est317->setFrame(globalFrame);

ui->lib321->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "32    ") );
connect( ui->lib321, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib321, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib32, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst32, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib321->installEventFilter(this);
ui->lib321->setMaximumWidth( m6trail);
ui->lib321->setMinimumWidth( m6trail);
ui->lib321->setMaximumHeight( m7traild3 );
ui->lib321->setMaxLength(3);
ui->lib321->setFrame(globalFrame);

ui->lib322->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "32    ") );
connect( ui->lib322, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib322, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib322->installEventFilter(this);
ui->lib322->setMaximumWidth( m26trail);
ui->lib322->setMinimumWidth( m25trail);
ui->lib322->setMaximumHeight( m7traild3 );
ui->lib322->setMaxLength(24);
ui->lib322->setFrame(globalFrame);

ui->lib323->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "32    ") );
connect( ui->lib323, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib323, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib323->installEventFilter(this);
ui->lib323->setAlignment(Qt::AlignCenter);
ui->lib323->setMaximumWidth( m12trail);
ui->lib323->setMinimumWidth( m6trail);
ui->lib323->setMaximumHeight( m7traild3 );
ui->lib323->setMaxLength(11);
ui->lib323->setFrame(globalFrame);

ui->lib324->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "32    ") );
connect( ui->lib324, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib324, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib324->installEventFilter(this);
ui->lib324->setAlignment(Qt::AlignCenter);
ui->lib324->setMaximumWidth( m12trail);
ui->lib324->setMinimumWidth( m6trail);
ui->lib324->setMaximumHeight( m7traild3 );
ui->lib324->setMaxLength(11);
ui->lib324->setFrame(globalFrame);

ui->pushButtonEst32->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "32    ") );
ui->pushButtonEst32->setMaximumWidth( m7traild3 );
ui->pushButtonEst32->setMaximumHeight( m7traild3 );
ui->pushButtonLib32->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "32    ") );
ui->pushButtonLib32->setMaximumWidth( m7traild3 );
ui->pushButtonLib32->setMaximumHeight( m7traild3 );

ui->est321->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "32    ") );
connect( ui->est321, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est321, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est321->installEventFilter(this);
ui->est321->setMaximumWidth( m6trail);
ui->est321->setMinimumWidth( m6trail);
ui->est321->setMaximumHeight( m7traild3 );
ui->est321->setMaxLength(3);
ui->est321->setFrame(globalFrame);

ui->est322->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "32    ") );
connect( ui->est322, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est322, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est322->installEventFilter(this);
ui->est322->setMaximumWidth( m26trail);
ui->est322->setMinimumWidth( m25trail);
ui->est322->setMaximumHeight( m7traild3 );
ui->est322->setMaxLength(24);
ui->est322->setFrame(globalFrame);

ui->est323->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "32    ") );
connect( ui->est323, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est323, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est323->installEventFilter(this);
ui->est323->setAlignment(Qt::AlignCenter);
ui->est323->setMaximumWidth( m11trail);
ui->est323->setMinimumWidth( m6trail);
ui->est323->setMaximumHeight( m7traild3 );
ui->est323->setMaxLength(8);
ui->est323->setFrame(globalFrame);

ui->est324->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "32    ") );
connect( ui->est324, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est324, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est324->installEventFilter(this);
ui->est324->setAlignment(Qt::AlignCenter);
ui->est324->setMaximumWidth( m12trail);
ui->est324->setMinimumWidth( m6trail);
ui->est324->setMaximumHeight( m7traild3 );
ui->est324->setMaxLength(11);
ui->est324->setFrame(globalFrame);

ui->est325->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "32    ") );
connect( ui->est325, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est325, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est325->installEventFilter(this);
ui->est325->setAlignment(Qt::AlignCenter);
ui->est325->setMaximumWidth( m12trail);
ui->est325->setMinimumWidth( m6trail);
ui->est325->setMaximumHeight( m7traild3 );
ui->est325->setMaxLength(11);
ui->est325->setFrame(globalFrame);

ui->est326->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "32    ") );
ui->est326->setReadOnly(true);
ui->est326->setAlignment(Qt::AlignRight);
ui->est326->setMaximumWidth( m14trail);
ui->est326->setMinimumWidth( m9trail);
ui->est326->setMaximumHeight( m7traild3 );
ui->est326->setMaxLength(15);
ui->est326->setFrame(globalFrame);

ui->est327->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "32    ") );
ui->est327->setReadOnly(true);
ui->est327->setAlignment(Qt::AlignRight);
ui->est327->setMaximumWidth( m14trail);
ui->est327->setMinimumWidth( m9trail);
ui->est327->setMaximumHeight( m7traild3 );
ui->est327->setMaxLength(15);
ui->est327->setFrame(globalFrame);

ui->lib331->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "33    ") );
connect( ui->lib331, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib331, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib33, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst33, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib331->installEventFilter(this);
ui->lib331->setMaximumWidth( m6trail);
ui->lib331->setMinimumWidth( m6trail);
ui->lib331->setMaximumHeight( m7traild3 );
ui->lib331->setMaxLength(3);
ui->lib331->setFrame(globalFrame);

ui->lib332->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "33    ") );
connect( ui->lib332, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib332, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib332->installEventFilter(this);
ui->lib332->setMaximumWidth( m26trail);
ui->lib332->setMinimumWidth( m25trail);
ui->lib332->setMaximumHeight( m7traild3 );
ui->lib332->setMaxLength(24);
ui->lib332->setFrame(globalFrame);

ui->lib333->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "33    ") );
connect( ui->lib333, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib333, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib333->installEventFilter(this);
ui->lib333->setAlignment(Qt::AlignCenter);
ui->lib333->setMaximumWidth( m12trail);
ui->lib333->setMinimumWidth( m6trail);
ui->lib333->setMaximumHeight( m7traild3 );
ui->lib333->setMaxLength(11);
ui->lib333->setFrame(globalFrame);

ui->lib334->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "33    ") );
connect( ui->lib334, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib334, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib334->installEventFilter(this);
ui->lib334->setAlignment(Qt::AlignCenter);
ui->lib334->setMaximumWidth( m12trail);
ui->lib334->setMinimumWidth( m6trail);
ui->lib334->setMaximumHeight( m7traild3 );
ui->lib334->setMaxLength(11);
ui->lib334->setFrame(globalFrame);

ui->pushButtonEst33->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "33    ") );
ui->pushButtonEst33->setMaximumWidth( m7traild3 );
ui->pushButtonEst33->setMaximumHeight( m7traild3 );
ui->pushButtonLib33->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "33    ") );
ui->pushButtonLib33->setMaximumWidth( m7traild3 );
ui->pushButtonLib33->setMaximumHeight( m7traild3 );

ui->est331->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "33    ") );
connect( ui->est331, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est331, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est331->installEventFilter(this);
ui->est331->setMaximumWidth( m6trail);
ui->est331->setMinimumWidth( m6trail);
ui->est331->setMaximumHeight( m7traild3 );
ui->est331->setMaxLength(3);
ui->est331->setFrame(globalFrame);

ui->est332->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "33    ") );
connect( ui->est332, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est332, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est332->installEventFilter(this);
ui->est332->setMaximumWidth( m26trail);
ui->est332->setMinimumWidth( m25trail);
ui->est332->setMaximumHeight( m7traild3 );
ui->est332->setMaxLength(24);
ui->est332->setFrame(globalFrame);

ui->est333->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "33    ") );
connect( ui->est333, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est333, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est333->installEventFilter(this);
ui->est333->setAlignment(Qt::AlignCenter);
ui->est333->setMaximumWidth( m11trail);
ui->est333->setMinimumWidth( m6trail);
ui->est333->setMaximumHeight( m7traild3 );
ui->est333->setMaxLength(8);
ui->est333->setFrame(globalFrame);

ui->est334->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "33    ") );
connect( ui->est334, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est334, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est334->installEventFilter(this);
ui->est334->setAlignment(Qt::AlignCenter);
ui->est334->setMaximumWidth( m12trail);
ui->est334->setMinimumWidth( m6trail);
ui->est334->setMaximumHeight( m7traild3 );
ui->est334->setMaxLength(11);
ui->est334->setFrame(globalFrame);

ui->est335->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "33    ") );
connect( ui->est335, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est335, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est335->installEventFilter(this);
ui->est335->setAlignment(Qt::AlignCenter);
ui->est335->setMaximumWidth( m12trail);
ui->est335->setMinimumWidth( m6trail);
ui->est335->setMaximumHeight( m7traild3 );
ui->est335->setMaxLength(11);
ui->est335->setFrame(globalFrame);

ui->est336->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "33    ") );
ui->est336->setReadOnly(true);
ui->est336->setAlignment(Qt::AlignRight);
ui->est336->setMaximumWidth( m14trail);
ui->est336->setMinimumWidth( m9trail);
ui->est336->setMaximumHeight( m7traild3 );
ui->est336->setMaxLength(15);
ui->est336->setFrame(globalFrame);

ui->est337->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "33    ") );
ui->est337->setReadOnly(true);
ui->est337->setAlignment(Qt::AlignRight);
ui->est337->setMaximumWidth( m14trail);
ui->est337->setMinimumWidth( m9trail);
ui->est337->setMaximumHeight( m7traild3 );
ui->est337->setMaxLength(15);
ui->est337->setFrame(globalFrame);

ui->lib341->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "34    ") );
connect( ui->lib341, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib341, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib34, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst34, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib341->installEventFilter(this);
ui->lib341->setMaximumWidth( m6trail);
ui->lib341->setMinimumWidth( m6trail);
ui->lib341->setMaximumHeight( m7traild3 );
ui->lib341->setMaxLength(3);
ui->lib341->setFrame(globalFrame);

ui->lib342->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "34    ") );
connect( ui->lib342, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib342, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib342->installEventFilter(this);
ui->lib342->setMaximumWidth( m26trail);
ui->lib342->setMinimumWidth( m25trail);
ui->lib342->setMaximumHeight( m7traild3 );
ui->lib342->setMaxLength(24);
ui->lib342->setFrame(globalFrame);

ui->lib343->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "34    ") );
connect( ui->lib343, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib343, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib343->installEventFilter(this);
ui->lib343->setAlignment(Qt::AlignCenter);
ui->lib343->setMaximumWidth( m12trail);
ui->lib343->setMinimumWidth( m6trail);
ui->lib343->setMaximumHeight( m7traild3 );
ui->lib343->setMaxLength(11);
ui->lib343->setFrame(globalFrame);

ui->lib344->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "34    ") );
connect( ui->lib344, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib344, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib344->installEventFilter(this);
ui->lib344->setAlignment(Qt::AlignCenter);
ui->lib344->setMaximumWidth( m12trail);
ui->lib344->setMinimumWidth( m6trail);
ui->lib344->setMaximumHeight( m7traild3 );
ui->lib344->setMaxLength(11);
ui->lib344->setFrame(globalFrame);

ui->pushButtonEst34->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "34    ") );
ui->pushButtonEst34->setMaximumWidth( m7traild3 );
ui->pushButtonEst34->setMaximumHeight( m7traild3 );
ui->pushButtonLib34->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "34    ") );
ui->pushButtonLib34->setMaximumWidth( m7traild3 );
ui->pushButtonLib34->setMaximumHeight( m7traild3 );

ui->est341->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "34    ") );
connect( ui->est341, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est341, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est341->installEventFilter(this);
ui->est341->setMaximumWidth( m6trail);
ui->est341->setMinimumWidth( m6trail);
ui->est341->setMaximumHeight( m7traild3 );
ui->est341->setMaxLength(3);
ui->est341->setFrame(globalFrame);

ui->est342->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "34    ") );
connect( ui->est342, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est342, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est342->installEventFilter(this);
ui->est342->setMaximumWidth( m26trail);
ui->est342->setMinimumWidth( m25trail);
ui->est342->setMaximumHeight( m7traild3 );
ui->est342->setMaxLength(24);
ui->est342->setFrame(globalFrame);

ui->est343->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "34    ") );
connect( ui->est343, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est343, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est343->installEventFilter(this);
ui->est343->setAlignment(Qt::AlignCenter);
ui->est343->setMaximumWidth( m11trail);
ui->est343->setMinimumWidth( m6trail);
ui->est343->setMaximumHeight( m7traild3 );
ui->est343->setMaxLength(8);
ui->est343->setFrame(globalFrame);

ui->est344->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "34    ") );
connect( ui->est344, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est344, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est344->installEventFilter(this);
ui->est344->setAlignment(Qt::AlignCenter);
ui->est344->setMaximumWidth( m12trail);
ui->est344->setMinimumWidth( m6trail);
ui->est344->setMaximumHeight( m7traild3 );
ui->est344->setMaxLength(11);
ui->est344->setFrame(globalFrame);

ui->est345->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "34    ") );
connect( ui->est345, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est345, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est345->installEventFilter(this);
ui->est345->setAlignment(Qt::AlignCenter);
ui->est345->setMaximumWidth( m12trail);
ui->est345->setMinimumWidth( m6trail);
ui->est345->setMaximumHeight( m7traild3 );
ui->est345->setMaxLength(11);
ui->est345->setFrame(globalFrame);

ui->est346->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "34    ") );
ui->est346->setReadOnly(true);
ui->est346->setAlignment(Qt::AlignRight);
ui->est346->setMaximumWidth( m14trail);
ui->est346->setMinimumWidth( m9trail);
ui->est346->setMaximumHeight( m7traild3 );
ui->est346->setMaxLength(15);
ui->est346->setFrame(globalFrame);

ui->est347->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "34    ") );
ui->est347->setReadOnly(true);
ui->est347->setAlignment(Qt::AlignRight);
ui->est347->setMaximumWidth( m14trail);
ui->est347->setMinimumWidth( m9trail);
ui->est347->setMaximumHeight( m7traild3 );
ui->est347->setMaxLength(15);
ui->est347->setFrame(globalFrame);

ui->lib351->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "35    ") );
connect( ui->lib351, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib351, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib35, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst35, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib351->installEventFilter(this);
ui->lib351->setMaximumWidth( m6trail);
ui->lib351->setMinimumWidth( m6trail);
ui->lib351->setMaximumHeight( m7traild3 );
ui->lib351->setMaxLength(3);
ui->lib351->setFrame(globalFrame);

ui->lib352->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "35    ") );
connect( ui->lib352, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib352, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib352->installEventFilter(this);
ui->lib352->setMaximumWidth( m26trail);
ui->lib352->setMinimumWidth( m25trail);
ui->lib352->setMaximumHeight( m7traild3 );
ui->lib352->setMaxLength(24);
ui->lib352->setFrame(globalFrame);

ui->lib353->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "35    ") );
connect( ui->lib353, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib353, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib353->installEventFilter(this);
ui->lib353->setAlignment(Qt::AlignCenter);
ui->lib353->setMaximumWidth( m12trail);
ui->lib353->setMinimumWidth( m6trail);
ui->lib353->setMaximumHeight( m7traild3 );
ui->lib353->setMaxLength(11);
ui->lib353->setFrame(globalFrame);

ui->lib354->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "35    ") );
connect( ui->lib354, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib354, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib354->installEventFilter(this);
ui->lib354->setAlignment(Qt::AlignCenter);
ui->lib354->setMaximumWidth( m12trail);
ui->lib354->setMinimumWidth( m6trail);
ui->lib354->setMaximumHeight( m7traild3 );
ui->lib354->setMaxLength(11);
ui->lib354->setFrame(globalFrame);

ui->pushButtonEst35->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "35    ") );
ui->pushButtonEst35->setMaximumWidth( m7traild3 );
ui->pushButtonEst35->setMaximumHeight( m7traild3 );
ui->pushButtonLib35->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "35    ") );
ui->pushButtonLib35->setMaximumWidth( m7traild3 );
ui->pushButtonLib35->setMaximumHeight( m7traild3 );

ui->est351->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "35    ") );
connect( ui->est351, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est351, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est351->installEventFilter(this);
ui->est351->setMaximumWidth( m6trail);
ui->est351->setMinimumWidth( m6trail);
ui->est351->setMaximumHeight( m7traild3 );
ui->est351->setMaxLength(3);
ui->est351->setFrame(globalFrame);

ui->est352->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "35    ") );
connect( ui->est352, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est352, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est352->installEventFilter(this);
ui->est352->setMaximumWidth( m26trail);
ui->est352->setMinimumWidth( m25trail);
ui->est352->setMaximumHeight( m7traild3 );
ui->est352->setMaxLength(24);
ui->est352->setFrame(globalFrame);

ui->est353->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "35    ") );
connect( ui->est353, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est353, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est353->installEventFilter(this);
ui->est353->setAlignment(Qt::AlignCenter);
ui->est353->setMaximumWidth( m11trail);
ui->est353->setMinimumWidth( m6trail);
ui->est353->setMaximumHeight( m7traild3 );
ui->est353->setMaxLength(8);
ui->est353->setFrame(globalFrame);

ui->est354->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "35    ") );
connect( ui->est354, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est354, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est354->installEventFilter(this);
ui->est354->setAlignment(Qt::AlignCenter);
ui->est354->setMaximumWidth( m12trail);
ui->est354->setMinimumWidth( m6trail);
ui->est354->setMaximumHeight( m7traild3 );
ui->est354->setMaxLength(11);
ui->est354->setFrame(globalFrame);

ui->est355->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "35    ") );
connect( ui->est355, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est355, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est355->installEventFilter(this);
ui->est355->setAlignment(Qt::AlignCenter);
ui->est355->setMaximumWidth( m12trail);
ui->est355->setMinimumWidth( m6trail);
ui->est355->setMaximumHeight( m7traild3 );
ui->est355->setMaxLength(11);
ui->est355->setFrame(globalFrame);

ui->est356->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "35    ") );
ui->est356->setReadOnly(true);
ui->est356->setAlignment(Qt::AlignRight);
ui->est356->setMaximumWidth( m14trail);
ui->est356->setMinimumWidth( m9trail);
ui->est356->setMaximumHeight( m7traild3 );
ui->est356->setMaxLength(15);
ui->est356->setFrame(globalFrame);

ui->est357->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "35    ") );
ui->est357->setReadOnly(true);
ui->est357->setAlignment(Qt::AlignRight);
ui->est357->setMaximumWidth( m14trail);
ui->est357->setMinimumWidth( m9trail);
ui->est357->setMaximumHeight( m7traild3 );
ui->est357->setMaxLength(15);
ui->est357->setFrame(globalFrame);

ui->lib361->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "36    ") );
connect( ui->lib361, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib361, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib36, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst36, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib361->installEventFilter(this);
ui->lib361->setMaximumWidth( m6trail);
ui->lib361->setMinimumWidth( m6trail);
ui->lib361->setMaximumHeight( m7traild3 );
ui->lib361->setMaxLength(3);
ui->lib361->setFrame(globalFrame);

ui->lib362->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "36    ") );
connect( ui->lib362, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib362, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib362->installEventFilter(this);
ui->lib362->setMaximumWidth( m26trail);
ui->lib362->setMinimumWidth( m25trail);
ui->lib362->setMaximumHeight( m7traild3 );
ui->lib362->setMaxLength(24);
ui->lib362->setFrame(globalFrame);

ui->lib363->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "36    ") );
connect( ui->lib363, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib363, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib363->installEventFilter(this);
ui->lib363->setAlignment(Qt::AlignCenter);
ui->lib363->setMaximumWidth( m12trail);
ui->lib363->setMinimumWidth( m6trail);
ui->lib363->setMaximumHeight( m7traild3 );
ui->lib363->setMaxLength(11);
ui->lib363->setFrame(globalFrame);

ui->lib364->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "36    ") );
connect( ui->lib364, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib364, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib364->installEventFilter(this);
ui->lib364->setAlignment(Qt::AlignCenter);
ui->lib364->setMaximumWidth( m12trail);
ui->lib364->setMinimumWidth( m6trail);
ui->lib364->setMaximumHeight( m7traild3 );
ui->lib364->setMaxLength(11);
ui->lib364->setFrame(globalFrame);

ui->pushButtonEst36->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "36    ") );
ui->pushButtonEst36->setMaximumWidth( m7traild3 );
ui->pushButtonEst36->setMaximumHeight( m7traild3 );
ui->pushButtonLib36->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "36    ") );
ui->pushButtonLib36->setMaximumWidth( m7traild3 );
ui->pushButtonLib36->setMaximumHeight( m7traild3 );

ui->est361->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "36    ") );
connect( ui->est361, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est361, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est361->installEventFilter(this);
ui->est361->setMaximumWidth( m6trail);
ui->est361->setMinimumWidth( m6trail);
ui->est361->setMaximumHeight( m7traild3 );
ui->est361->setMaxLength(3);
ui->est361->setFrame(globalFrame);

ui->est362->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "36    ") );
connect( ui->est362, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est362, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est362->installEventFilter(this);
ui->est362->setMaximumWidth( m26trail);
ui->est362->setMinimumWidth( m25trail);
ui->est362->setMaximumHeight( m7traild3 );
ui->est362->setMaxLength(24);
ui->est362->setFrame(globalFrame);

ui->est363->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "36    ") );
connect( ui->est363, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est363, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est363->installEventFilter(this);
ui->est363->setAlignment(Qt::AlignCenter);
ui->est363->setMaximumWidth( m11trail);
ui->est363->setMinimumWidth( m6trail);
ui->est363->setMaximumHeight( m7traild3 );
ui->est363->setMaxLength(8);
ui->est363->setFrame(globalFrame);

ui->est364->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "36    ") );
connect( ui->est364, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est364, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est364->installEventFilter(this);
ui->est364->setAlignment(Qt::AlignCenter);
ui->est364->setMaximumWidth( m12trail);
ui->est364->setMinimumWidth( m6trail);
ui->est364->setMaximumHeight( m7traild3 );
ui->est364->setMaxLength(11);
ui->est364->setFrame(globalFrame);

ui->est365->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "36    ") );
connect( ui->est365, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est365, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est365->installEventFilter(this);
ui->est365->setAlignment(Qt::AlignCenter);
ui->est365->setMaximumWidth( m12trail);
ui->est365->setMinimumWidth( m6trail);
ui->est365->setMaximumHeight( m7traild3 );
ui->est365->setMaxLength(11);
ui->est365->setFrame(globalFrame);

ui->est366->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "36    ") );
ui->est366->setReadOnly(true);
ui->est366->setAlignment(Qt::AlignRight);
ui->est366->setMaximumWidth( m14trail);
ui->est366->setMinimumWidth( m9trail);
ui->est366->setMaximumHeight( m7traild3 );
ui->est366->setMaxLength(15);
ui->est366->setFrame(globalFrame);

ui->est367->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "36    ") );
ui->est367->setReadOnly(true);
ui->est367->setAlignment(Qt::AlignRight);
ui->est367->setMaximumWidth( m14trail);
ui->est367->setMinimumWidth( m9trail);
ui->est367->setMaximumHeight( m7traild3 );
ui->est367->setMaxLength(15);
ui->est367->setFrame(globalFrame);

ui->lib371->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "37    ") );
connect( ui->lib371, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib371, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib37, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst37, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib371->installEventFilter(this);
ui->lib371->setMaximumWidth( m6trail);
ui->lib371->setMinimumWidth( m6trail);
ui->lib371->setMaximumHeight( m7traild3 );
ui->lib371->setMaxLength(3);
ui->lib371->setFrame(globalFrame);

ui->lib372->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "37    ") );
connect( ui->lib372, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib372, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib372->installEventFilter(this);
ui->lib372->setMaximumWidth( m26trail);
ui->lib372->setMinimumWidth( m25trail);
ui->lib372->setMaximumHeight( m7traild3 );
ui->lib372->setMaxLength(24);
ui->lib372->setFrame(globalFrame);

ui->lib373->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "37    ") );
connect( ui->lib373, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib373, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib373->installEventFilter(this);
ui->lib373->setAlignment(Qt::AlignCenter);
ui->lib373->setMaximumWidth( m12trail);
ui->lib373->setMinimumWidth( m6trail);
ui->lib373->setMaximumHeight( m7traild3 );
ui->lib373->setMaxLength(11);
ui->lib373->setFrame(globalFrame);

ui->lib374->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "37    ") );
connect( ui->lib374, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib374, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib374->installEventFilter(this);
ui->lib374->setAlignment(Qt::AlignCenter);
ui->lib374->setMaximumWidth( m12trail);
ui->lib374->setMinimumWidth( m6trail);
ui->lib374->setMaximumHeight( m7traild3 );
ui->lib374->setMaxLength(11);
ui->lib374->setFrame(globalFrame);

ui->pushButtonEst37->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "37    ") );
ui->pushButtonEst37->setMaximumWidth( m7traild3 );
ui->pushButtonEst37->setMaximumHeight( m7traild3 );
ui->pushButtonLib37->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "37    ") );
ui->pushButtonLib37->setMaximumWidth( m7traild3 );
ui->pushButtonLib37->setMaximumHeight( m7traild3 );

ui->est371->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "37    ") );
connect( ui->est371, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est371, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est371->installEventFilter(this);
ui->est371->setMaximumWidth( m6trail);
ui->est371->setMinimumWidth( m6trail);
ui->est371->setMaximumHeight( m7traild3 );
ui->est371->setMaxLength(3);
ui->est371->setFrame(globalFrame);

ui->est372->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "37    ") );
connect( ui->est372, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est372, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est372->installEventFilter(this);
ui->est372->setMaximumWidth( m26trail);
ui->est372->setMinimumWidth( m25trail);
ui->est372->setMaximumHeight( m7traild3 );
ui->est372->setMaxLength(24);
ui->est372->setFrame(globalFrame);

ui->est373->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "37    ") );
connect( ui->est373, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est373, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est373->installEventFilter(this);
ui->est373->setAlignment(Qt::AlignCenter);
ui->est373->setMaximumWidth( m11trail);
ui->est373->setMinimumWidth( m6trail);
ui->est373->setMaximumHeight( m7traild3 );
ui->est373->setMaxLength(8);
ui->est373->setFrame(globalFrame);

ui->est374->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "37    ") );
connect( ui->est374, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est374, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est374->installEventFilter(this);
ui->est374->setAlignment(Qt::AlignCenter);
ui->est374->setMaximumWidth( m12trail);
ui->est374->setMinimumWidth( m6trail);
ui->est374->setMaximumHeight( m7traild3 );
ui->est374->setMaxLength(11);
ui->est374->setFrame(globalFrame);

ui->est375->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "37    ") );
connect( ui->est375, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est375, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est375->installEventFilter(this);
ui->est375->setAlignment(Qt::AlignCenter);
ui->est375->setMaximumWidth( m12trail);
ui->est375->setMinimumWidth( m6trail);
ui->est375->setMaximumHeight( m7traild3 );
ui->est375->setMaxLength(11);
ui->est375->setFrame(globalFrame);

ui->est376->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "37    ") );
ui->est376->setReadOnly(true);
ui->est376->setAlignment(Qt::AlignRight);
ui->est376->setMaximumWidth( m14trail);
ui->est376->setMinimumWidth( m9trail);
ui->est376->setMaximumHeight( m7traild3 );
ui->est376->setMaxLength(15);
ui->est376->setFrame(globalFrame);

ui->est377->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "37    ") );
ui->est377->setReadOnly(true);
ui->est377->setAlignment(Qt::AlignRight);
ui->est377->setMaximumWidth( m14trail);
ui->est377->setMinimumWidth( m9trail);
ui->est377->setMaximumHeight( m7traild3 );
ui->est377->setMaxLength(15);
ui->est377->setFrame(globalFrame);

ui->lib381->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "38    ") );
connect( ui->lib381, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib381, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib38, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst38, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib381->installEventFilter(this);
ui->lib381->setMaximumWidth( m6trail);
ui->lib381->setMinimumWidth( m6trail);
ui->lib381->setMaximumHeight( m7traild3 );
ui->lib381->setMaxLength(3);
ui->lib381->setFrame(globalFrame);

ui->lib382->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "38    ") );
connect( ui->lib382, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib382, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib382->installEventFilter(this);
ui->lib382->setMaximumWidth( m26trail);
ui->lib382->setMinimumWidth( m25trail);
ui->lib382->setMaximumHeight( m7traild3 );
ui->lib382->setMaxLength(24);
ui->lib382->setFrame(globalFrame);

ui->lib383->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "38    ") );
connect( ui->lib383, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib383, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib383->installEventFilter(this);
ui->lib383->setAlignment(Qt::AlignCenter);
ui->lib383->setMaximumWidth( m12trail);
ui->lib383->setMinimumWidth( m6trail);
ui->lib383->setMaximumHeight( m7traild3 );
ui->lib383->setMaxLength(11);
ui->lib383->setFrame(globalFrame);

ui->lib384->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "38    ") );
connect( ui->lib384, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib384, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib384->installEventFilter(this);
ui->lib384->setAlignment(Qt::AlignCenter);
ui->lib384->setMaximumWidth( m12trail);
ui->lib384->setMinimumWidth( m6trail);
ui->lib384->setMaximumHeight( m7traild3 );
ui->lib384->setMaxLength(11);
ui->lib384->setFrame(globalFrame);

ui->pushButtonEst38->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "38    ") );
ui->pushButtonEst38->setMaximumWidth( m7traild3 );
ui->pushButtonEst38->setMaximumHeight( m7traild3 );
ui->pushButtonLib38->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "38    ") );
ui->pushButtonLib38->setMaximumWidth( m7traild3 );
ui->pushButtonLib38->setMaximumHeight( m7traild3 );

ui->est381->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "38    ") );
connect( ui->est381, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est381, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est381->installEventFilter(this);
ui->est381->setMaximumWidth( m6trail);
ui->est381->setMinimumWidth( m6trail);
ui->est381->setMaximumHeight( m7traild3 );
ui->est381->setMaxLength(3);
ui->est381->setFrame(globalFrame);

ui->est382->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "38    ") );
connect( ui->est382, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est382, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est382->installEventFilter(this);
ui->est382->setMaximumWidth( m26trail);
ui->est382->setMinimumWidth( m25trail);
ui->est382->setMaximumHeight( m7traild3 );
ui->est382->setMaxLength(24);
ui->est382->setFrame(globalFrame);

ui->est383->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "38    ") );
connect( ui->est383, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est383, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est383->installEventFilter(this);
ui->est383->setAlignment(Qt::AlignCenter);
ui->est383->setMaximumWidth( m11trail);
ui->est383->setMinimumWidth( m6trail);
ui->est383->setMaximumHeight( m7traild3 );
ui->est383->setMaxLength(8);
ui->est383->setFrame(globalFrame);

ui->est384->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "38    ") );
connect( ui->est384, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est384, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est384->installEventFilter(this);
ui->est384->setAlignment(Qt::AlignCenter);
ui->est384->setMaximumWidth( m12trail);
ui->est384->setMinimumWidth( m6trail);
ui->est384->setMaximumHeight( m7traild3 );
ui->est384->setMaxLength(11);
ui->est384->setFrame(globalFrame);

ui->est385->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "38    ") );
connect( ui->est385, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est385, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est385->installEventFilter(this);
ui->est385->setAlignment(Qt::AlignCenter);
ui->est385->setMaximumWidth( m12trail);
ui->est385->setMinimumWidth( m6trail);
ui->est385->setMaximumHeight( m7traild3 );
ui->est385->setMaxLength(11);
ui->est385->setFrame(globalFrame);

ui->est386->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "38    ") );
ui->est386->setReadOnly(true);
ui->est386->setAlignment(Qt::AlignRight);
ui->est386->setMaximumWidth( m14trail);
ui->est386->setMinimumWidth( m9trail);
ui->est386->setMaximumHeight( m7traild3 );
ui->est386->setMaxLength(15);
ui->est386->setFrame(globalFrame);

ui->est387->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "38    ") );
ui->est387->setReadOnly(true);
ui->est387->setAlignment(Qt::AlignRight);
ui->est387->setMaximumWidth( m14trail);
ui->est387->setMinimumWidth( m9trail);
ui->est387->setMaximumHeight( m7traild3 );
ui->est387->setMaxLength(15);
ui->est387->setFrame(globalFrame);

ui->lib391->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "39    ") );
connect( ui->lib391, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib391, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib39, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst39, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib391->installEventFilter(this);
ui->lib391->setMaximumWidth( m6trail);
ui->lib391->setMinimumWidth( m6trail);
ui->lib391->setMaximumHeight( m7traild3 );
ui->lib391->setMaxLength(3);
ui->lib391->setFrame(globalFrame);

ui->lib392->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "39    ") );
connect( ui->lib392, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib392, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib392->installEventFilter(this);
ui->lib392->setMaximumWidth( m26trail);
ui->lib392->setMinimumWidth( m25trail);
ui->lib392->setMaximumHeight( m7traild3 );
ui->lib392->setMaxLength(24);
ui->lib392->setFrame(globalFrame);

ui->lib393->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "39    ") );
connect( ui->lib393, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib393, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib393->installEventFilter(this);
ui->lib393->setAlignment(Qt::AlignCenter);
ui->lib393->setMaximumWidth( m12trail);
ui->lib393->setMinimumWidth( m6trail);
ui->lib393->setMaximumHeight( m7traild3 );
ui->lib393->setMaxLength(11);
ui->lib393->setFrame(globalFrame);

ui->lib394->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "39    ") );
connect( ui->lib394, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib394, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib394->installEventFilter(this);
ui->lib394->setAlignment(Qt::AlignCenter);
ui->lib394->setMaximumWidth( m12trail);
ui->lib394->setMinimumWidth( m6trail);
ui->lib394->setMaximumHeight( m7traild3 );
ui->lib394->setMaxLength(11);
ui->lib394->setFrame(globalFrame);

ui->pushButtonEst39->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "39    ") );
ui->pushButtonEst39->setMaximumWidth( m7traild3 );
ui->pushButtonEst39->setMaximumHeight( m7traild3 );
ui->pushButtonLib39->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "39    ") );
ui->pushButtonLib39->setMaximumWidth( m7traild3 );
ui->pushButtonLib39->setMaximumHeight( m7traild3 );

ui->est391->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "39    ") );
connect( ui->est391, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est391, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est391->installEventFilter(this);
ui->est391->setMaximumWidth( m6trail);
ui->est391->setMinimumWidth( m6trail);
ui->est391->setMaximumHeight( m7traild3 );
ui->est391->setMaxLength(3);
ui->est391->setFrame(globalFrame);

ui->est392->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "39    ") );
connect( ui->est392, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est392, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est392->installEventFilter(this);
ui->est392->setMaximumWidth( m26trail);
ui->est392->setMinimumWidth( m25trail);
ui->est392->setMaximumHeight( m7traild3 );
ui->est392->setMaxLength(24);
ui->est392->setFrame(globalFrame);

ui->est393->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "39    ") );
connect( ui->est393, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est393, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est393->installEventFilter(this);
ui->est393->setAlignment(Qt::AlignCenter);
ui->est393->setMaximumWidth( m11trail);
ui->est393->setMinimumWidth( m6trail);
ui->est393->setMaximumHeight( m7traild3 );
ui->est393->setMaxLength(8);
ui->est393->setFrame(globalFrame);

ui->est394->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "39    ") );
connect( ui->est394, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est394, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est394->installEventFilter(this);
ui->est394->setAlignment(Qt::AlignCenter);
ui->est394->setMaximumWidth( m12trail);
ui->est394->setMinimumWidth( m6trail);
ui->est394->setMaximumHeight( m7traild3 );
ui->est394->setMaxLength(11);
ui->est394->setFrame(globalFrame);

ui->est395->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "39    ") );
connect( ui->est395, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est395, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est395->installEventFilter(this);
ui->est395->setAlignment(Qt::AlignCenter);
ui->est395->setMaximumWidth( m12trail);
ui->est395->setMinimumWidth( m6trail);
ui->est395->setMaximumHeight( m7traild3 );
ui->est395->setMaxLength(11);
ui->est395->setFrame(globalFrame);

ui->est396->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "39    ") );
ui->est396->setReadOnly(true);
ui->est396->setAlignment(Qt::AlignRight);
ui->est396->setMaximumWidth( m14trail);
ui->est396->setMinimumWidth( m9trail);
ui->est396->setMaximumHeight( m7traild3 );
ui->est396->setMaxLength(15);
ui->est396->setFrame(globalFrame);

ui->est397->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "39    ") );
ui->est397->setReadOnly(true);
ui->est397->setAlignment(Qt::AlignRight);
ui->est397->setMaximumWidth( m14trail);
ui->est397->setMinimumWidth( m9trail);
ui->est397->setMaximumHeight( m7traild3 );
ui->est397->setMaxLength(15);
ui->est397->setFrame(globalFrame);

ui->lib401->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "40    ") );
connect( ui->lib401, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib401, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib40, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst40, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib401->installEventFilter(this);
ui->lib401->setMaximumWidth( m6trail);
ui->lib401->setMinimumWidth( m6trail);
ui->lib401->setMaximumHeight( m7traild3 );
ui->lib401->setMaxLength(3);
ui->lib401->setFrame(globalFrame);

ui->lib402->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "40    ") );
connect( ui->lib402, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib402, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib402->installEventFilter(this);
ui->lib402->setMaximumWidth( m26trail);
ui->lib402->setMinimumWidth( m25trail);
ui->lib402->setMaximumHeight( m7traild3 );
ui->lib402->setMaxLength(24);
ui->lib402->setFrame(globalFrame);

ui->lib403->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "40    ") );
connect( ui->lib403, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib403, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib403->installEventFilter(this);
ui->lib403->setAlignment(Qt::AlignCenter);
ui->lib403->setMaximumWidth( m12trail);
ui->lib403->setMinimumWidth( m6trail);
ui->lib403->setMaximumHeight( m7traild3 );
ui->lib403->setMaxLength(11);
ui->lib403->setFrame(globalFrame);

ui->lib404->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "40    ") );
connect( ui->lib404, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib404, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib404->installEventFilter(this);
ui->lib404->setAlignment(Qt::AlignCenter);
ui->lib404->setMaximumWidth( m12trail);
ui->lib404->setMinimumWidth( m6trail);
ui->lib404->setMaximumHeight( m7traild3 );
ui->lib404->setMaxLength(11);
ui->lib404->setFrame(globalFrame);

ui->pushButtonEst40->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "40    ") );
ui->pushButtonEst40->setMaximumWidth( m7traild3 );
ui->pushButtonEst40->setMaximumHeight( m7traild3 );
ui->pushButtonLib40->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "40    ") );
ui->pushButtonLib40->setMaximumWidth( m7traild3 );
ui->pushButtonLib40->setMaximumHeight( m7traild3 );

ui->est401->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "40    ") );
connect( ui->est401, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est401, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est401->installEventFilter(this);
ui->est401->setMaximumWidth( m6trail);
ui->est401->setMinimumWidth( m6trail);
ui->est401->setMaximumHeight( m7traild3 );
ui->est401->setMaxLength(3);
ui->est401->setFrame(globalFrame);

ui->est402->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "40    ") );
connect( ui->est402, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est402, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est402->installEventFilter(this);
ui->est402->setMaximumWidth( m26trail);
ui->est402->setMinimumWidth( m25trail);
ui->est402->setMaximumHeight( m7traild3 );
ui->est402->setMaxLength(24);
ui->est402->setFrame(globalFrame);

ui->est403->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "40    ") );
connect( ui->est403, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est403, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est403->installEventFilter(this);
ui->est403->setAlignment(Qt::AlignCenter);
ui->est403->setMaximumWidth( m11trail);
ui->est403->setMinimumWidth( m6trail);
ui->est403->setMaximumHeight( m7traild3 );
ui->est403->setMaxLength(8);
ui->est403->setFrame(globalFrame);

ui->est404->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "40    ") );
connect( ui->est404, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est404, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est404->installEventFilter(this);
ui->est404->setAlignment(Qt::AlignCenter);
ui->est404->setMaximumWidth( m12trail);
ui->est404->setMinimumWidth( m6trail);
ui->est404->setMaximumHeight( m7traild3 );
ui->est404->setMaxLength(11);
ui->est404->setFrame(globalFrame);

ui->est405->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "40    ") );
connect( ui->est405, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est405, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est405->installEventFilter(this);
ui->est405->setAlignment(Qt::AlignCenter);
ui->est405->setMaximumWidth( m12trail);
ui->est405->setMinimumWidth( m6trail);
ui->est405->setMaximumHeight( m7traild3 );
ui->est405->setMaxLength(11);
ui->est405->setFrame(globalFrame);

ui->est406->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "40    ") );
ui->est406->setReadOnly(true);
ui->est406->setAlignment(Qt::AlignRight);
ui->est406->setMaximumWidth( m14trail);
ui->est406->setMinimumWidth( m9trail);
ui->est406->setMaximumHeight( m7traild3 );
ui->est406->setMaxLength(15);
ui->est406->setFrame(globalFrame);

ui->est407->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "40    ") );
ui->est407->setReadOnly(true);
ui->est407->setAlignment(Qt::AlignRight);
ui->est407->setMaximumWidth( m14trail);
ui->est407->setMinimumWidth( m9trail);
ui->est407->setMaximumHeight( m7traild3 );
ui->est407->setMaxLength(15);
ui->est407->setFrame(globalFrame);

ui->lib411->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "41    ") );
connect( ui->lib411, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib411, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib41, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst41, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib411->installEventFilter(this);
ui->lib411->setMaximumWidth( m6trail);
ui->lib411->setMinimumWidth( m6trail);
ui->lib411->setMaximumHeight( m7traild3 );
ui->lib411->setMaxLength(3);
ui->lib411->setFrame(globalFrame);

ui->lib412->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "41    ") );
connect( ui->lib412, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib412, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib412->installEventFilter(this);
ui->lib412->setMaximumWidth( m26trail);
ui->lib412->setMinimumWidth( m25trail);
ui->lib412->setMaximumHeight( m7traild3 );
ui->lib412->setMaxLength(24);
ui->lib412->setFrame(globalFrame);

ui->lib413->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "41    ") );
connect( ui->lib413, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib413, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib413->installEventFilter(this);
ui->lib413->setAlignment(Qt::AlignCenter);
ui->lib413->setMaximumWidth( m12trail);
ui->lib413->setMinimumWidth( m6trail);
ui->lib413->setMaximumHeight( m7traild3 );
ui->lib413->setMaxLength(11);
ui->lib413->setFrame(globalFrame);

ui->lib414->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "41    ") );
connect( ui->lib414, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib414, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib414->installEventFilter(this);
ui->lib414->setAlignment(Qt::AlignCenter);
ui->lib414->setMaximumWidth( m12trail);
ui->lib414->setMinimumWidth( m6trail);
ui->lib414->setMaximumHeight( m7traild3 );
ui->lib414->setMaxLength(11);
ui->lib414->setFrame(globalFrame);

ui->pushButtonEst41->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "41    ") );
ui->pushButtonEst41->setMaximumWidth( m7traild3 );
ui->pushButtonEst41->setMaximumHeight( m7traild3 );
ui->pushButtonLib41->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "41    ") );
ui->pushButtonLib41->setMaximumWidth( m7traild3 );
ui->pushButtonLib41->setMaximumHeight( m7traild3 );

ui->est411->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "41    ") );
connect( ui->est411, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est411, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est411->installEventFilter(this);
ui->est411->setMaximumWidth( m6trail);
ui->est411->setMinimumWidth( m6trail);
ui->est411->setMaximumHeight( m7traild3 );
ui->est411->setMaxLength(3);
ui->est411->setFrame(globalFrame);

ui->est412->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "41    ") );
connect( ui->est412, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est412, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est412->installEventFilter(this);
ui->est412->setMaximumWidth( m26trail);
ui->est412->setMinimumWidth( m25trail);
ui->est412->setMaximumHeight( m7traild3 );
ui->est412->setMaxLength(24);
ui->est412->setFrame(globalFrame);

ui->est413->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "41    ") );
connect( ui->est413, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est413, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est413->installEventFilter(this);
ui->est413->setAlignment(Qt::AlignCenter);
ui->est413->setMaximumWidth( m11trail);
ui->est413->setMinimumWidth( m6trail);
ui->est413->setMaximumHeight( m7traild3 );
ui->est413->setMaxLength(8);
ui->est413->setFrame(globalFrame);

ui->est414->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "41    ") );
connect( ui->est414, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est414, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est414->installEventFilter(this);
ui->est414->setAlignment(Qt::AlignCenter);
ui->est414->setMaximumWidth( m12trail);
ui->est414->setMinimumWidth( m6trail);
ui->est414->setMaximumHeight( m7traild3 );
ui->est414->setMaxLength(11);
ui->est414->setFrame(globalFrame);

ui->est415->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "41    ") );
connect( ui->est415, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est415, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est415->installEventFilter(this);
ui->est415->setAlignment(Qt::AlignCenter);
ui->est415->setMaximumWidth( m12trail);
ui->est415->setMinimumWidth( m6trail);
ui->est415->setMaximumHeight( m7traild3 );
ui->est415->setMaxLength(11);
ui->est415->setFrame(globalFrame);

ui->est416->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "41    ") );
ui->est416->setReadOnly(true);
ui->est416->setAlignment(Qt::AlignRight);
ui->est416->setMaximumWidth( m14trail);
ui->est416->setMinimumWidth( m9trail);
ui->est416->setMaximumHeight( m7traild3 );
ui->est416->setMaxLength(15);
ui->est416->setFrame(globalFrame);

ui->est417->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "41    ") );
ui->est417->setReadOnly(true);
ui->est417->setAlignment(Qt::AlignRight);
ui->est417->setMaximumWidth( m14trail);
ui->est417->setMinimumWidth( m9trail);
ui->est417->setMaximumHeight( m7traild3 );
ui->est417->setMaxLength(15);
ui->est417->setFrame(globalFrame);

ui->lib421->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "42    ") );
connect( ui->lib421, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib421, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib42, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst42, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib421->installEventFilter(this);
ui->lib421->setMaximumWidth( m6trail);
ui->lib421->setMinimumWidth( m6trail);
ui->lib421->setMaximumHeight( m7traild3 );
ui->lib421->setMaxLength(3);
ui->lib421->setFrame(globalFrame);

ui->lib422->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "42    ") );
connect( ui->lib422, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib422, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib422->installEventFilter(this);
ui->lib422->setMaximumWidth( m26trail);
ui->lib422->setMinimumWidth( m25trail);
ui->lib422->setMaximumHeight( m7traild3 );
ui->lib422->setMaxLength(24);
ui->lib422->setFrame(globalFrame);

ui->lib423->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "42    ") );
connect( ui->lib423, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib423, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib423->installEventFilter(this);
ui->lib423->setAlignment(Qt::AlignCenter);
ui->lib423->setMaximumWidth( m12trail);
ui->lib423->setMinimumWidth( m6trail);
ui->lib423->setMaximumHeight( m7traild3 );
ui->lib423->setMaxLength(11);
ui->lib423->setFrame(globalFrame);

ui->lib424->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "42    ") );
connect( ui->lib424, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib424, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib424->installEventFilter(this);
ui->lib424->setAlignment(Qt::AlignCenter);
ui->lib424->setMaximumWidth( m12trail);
ui->lib424->setMinimumWidth( m6trail);
ui->lib424->setMaximumHeight( m7traild3 );
ui->lib424->setMaxLength(11);
ui->lib424->setFrame(globalFrame);

ui->pushButtonEst42->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "42    ") );
ui->pushButtonEst42->setMaximumWidth( m7traild3 );
ui->pushButtonEst42->setMaximumHeight( m7traild3 );
ui->pushButtonLib42->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "42    ") );
ui->pushButtonLib42->setMaximumWidth( m7traild3 );
ui->pushButtonLib42->setMaximumHeight( m7traild3 );

ui->est421->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "42    ") );
connect( ui->est421, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est421, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est421->installEventFilter(this);
ui->est421->setMaximumWidth( m6trail);
ui->est421->setMinimumWidth( m6trail);
ui->est421->setMaximumHeight( m7traild3 );
ui->est421->setMaxLength(3);
ui->est421->setFrame(globalFrame);

ui->est422->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "42    ") );
connect( ui->est422, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est422, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est422->installEventFilter(this);
ui->est422->setMaximumWidth( m26trail);
ui->est422->setMinimumWidth( m25trail);
ui->est422->setMaximumHeight( m7traild3 );
ui->est422->setMaxLength(24);
ui->est422->setFrame(globalFrame);

ui->est423->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "42    ") );
connect( ui->est423, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est423, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est423->installEventFilter(this);
ui->est423->setAlignment(Qt::AlignCenter);
ui->est423->setMaximumWidth( m11trail);
ui->est423->setMinimumWidth( m6trail);
ui->est423->setMaximumHeight( m7traild3 );
ui->est423->setMaxLength(8);
ui->est423->setFrame(globalFrame);

ui->est424->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "42    ") );
connect( ui->est424, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est424, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est424->installEventFilter(this);
ui->est424->setAlignment(Qt::AlignCenter);
ui->est424->setMaximumWidth( m12trail);
ui->est424->setMinimumWidth( m6trail);
ui->est424->setMaximumHeight( m7traild3 );
ui->est424->setMaxLength(11);
ui->est424->setFrame(globalFrame);

ui->est425->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "42    ") );
connect( ui->est425, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est425, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est425->installEventFilter(this);
ui->est425->setAlignment(Qt::AlignCenter);
ui->est425->setMaximumWidth( m12trail);
ui->est425->setMinimumWidth( m6trail);
ui->est425->setMaximumHeight( m7traild3 );
ui->est425->setMaxLength(11);
ui->est425->setFrame(globalFrame);

ui->est426->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "42    ") );
ui->est426->setReadOnly(true);
ui->est426->setAlignment(Qt::AlignRight);
ui->est426->setMaximumWidth( m14trail);
ui->est426->setMinimumWidth( m9trail);
ui->est426->setMaximumHeight( m7traild3 );
ui->est426->setMaxLength(15);
ui->est426->setFrame(globalFrame);

ui->est427->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "42    ") );
ui->est427->setReadOnly(true);
ui->est427->setAlignment(Qt::AlignRight);
ui->est427->setMaximumWidth( m14trail);
ui->est427->setMinimumWidth( m9trail);
ui->est427->setMaximumHeight( m7traild3 );
ui->est427->setMaxLength(15);
ui->est427->setFrame(globalFrame);

ui->lib431->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "43    ") );
connect( ui->lib431, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib431, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib43, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst43, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib431->installEventFilter(this);
ui->lib431->setMaximumWidth( m6trail);
ui->lib431->setMinimumWidth( m6trail);
ui->lib431->setMaximumHeight( m7traild3 );
ui->lib431->setMaxLength(3);
ui->lib431->setFrame(globalFrame);

ui->lib432->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "43    ") );
connect( ui->lib432, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib432, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib432->installEventFilter(this);
ui->lib432->setMaximumWidth( m26trail);
ui->lib432->setMinimumWidth( m25trail);
ui->lib432->setMaximumHeight( m7traild3 );
ui->lib432->setMaxLength(24);
ui->lib432->setFrame(globalFrame);

ui->lib433->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "43    ") );
connect( ui->lib433, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib433, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib433->installEventFilter(this);
ui->lib433->setAlignment(Qt::AlignCenter);
ui->lib433->setMaximumWidth( m12trail);
ui->lib433->setMinimumWidth( m6trail);
ui->lib433->setMaximumHeight( m7traild3 );
ui->lib433->setMaxLength(11);
ui->lib433->setFrame(globalFrame);

ui->lib434->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "43    ") );
connect( ui->lib434, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib434, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib434->installEventFilter(this);
ui->lib434->setAlignment(Qt::AlignCenter);
ui->lib434->setMaximumWidth( m12trail);
ui->lib434->setMinimumWidth( m6trail);
ui->lib434->setMaximumHeight( m7traild3 );
ui->lib434->setMaxLength(11);
ui->lib434->setFrame(globalFrame);

ui->pushButtonEst43->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "43    ") );
ui->pushButtonEst43->setMaximumWidth( m7traild3 );
ui->pushButtonEst43->setMaximumHeight( m7traild3 );
ui->pushButtonLib43->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "43    ") );
ui->pushButtonLib43->setMaximumWidth( m7traild3 );
ui->pushButtonLib43->setMaximumHeight( m7traild3 );

ui->est431->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "43    ") );
connect( ui->est431, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est431, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est431->installEventFilter(this);
ui->est431->setMaximumWidth( m6trail);
ui->est431->setMinimumWidth( m6trail);
ui->est431->setMaximumHeight( m7traild3 );
ui->est431->setMaxLength(3);
ui->est431->setFrame(globalFrame);

ui->est432->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "43    ") );
connect( ui->est432, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est432, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est432->installEventFilter(this);
ui->est432->setMaximumWidth( m26trail);
ui->est432->setMinimumWidth( m25trail);
ui->est432->setMaximumHeight( m7traild3 );
ui->est432->setMaxLength(24);
ui->est432->setFrame(globalFrame);

ui->est433->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "43    ") );
connect( ui->est433, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est433, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est433->installEventFilter(this);
ui->est433->setAlignment(Qt::AlignCenter);
ui->est433->setMaximumWidth( m11trail);
ui->est433->setMinimumWidth( m6trail);
ui->est433->setMaximumHeight( m7traild3 );
ui->est433->setMaxLength(8);
ui->est433->setFrame(globalFrame);

ui->est434->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "43    ") );
connect( ui->est434, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est434, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est434->installEventFilter(this);
ui->est434->setAlignment(Qt::AlignCenter);
ui->est434->setMaximumWidth( m12trail);
ui->est434->setMinimumWidth( m6trail);
ui->est434->setMaximumHeight( m7traild3 );
ui->est434->setMaxLength(11);
ui->est434->setFrame(globalFrame);

ui->est435->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "43    ") );
connect( ui->est435, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est435, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est435->installEventFilter(this);
ui->est435->setAlignment(Qt::AlignCenter);
ui->est435->setMaximumWidth( m12trail);
ui->est435->setMinimumWidth( m6trail);
ui->est435->setMaximumHeight( m7traild3 );
ui->est435->setMaxLength(11);
ui->est435->setFrame(globalFrame);

ui->est436->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "43    ") );
ui->est436->setReadOnly(true);
ui->est436->setAlignment(Qt::AlignRight);
ui->est436->setMaximumWidth( m14trail);
ui->est436->setMinimumWidth( m9trail);
ui->est436->setMaximumHeight( m7traild3 );
ui->est436->setMaxLength(15);
ui->est436->setFrame(globalFrame);

ui->est437->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "43    ") );
ui->est437->setReadOnly(true);
ui->est437->setAlignment(Qt::AlignRight);
ui->est437->setMaximumWidth( m14trail);
ui->est437->setMinimumWidth( m9trail);
ui->est437->setMaximumHeight( m7traild3 );
ui->est437->setMaxLength(15);
ui->est437->setFrame(globalFrame);

ui->lib441->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "44    ") );
connect( ui->lib441, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib441, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib44, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst44, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib441->installEventFilter(this);
ui->lib441->setMaximumWidth( m6trail);
ui->lib441->setMinimumWidth( m6trail);
ui->lib441->setMaximumHeight( m7traild3 );
ui->lib441->setMaxLength(3);
ui->lib441->setFrame(globalFrame);

ui->lib442->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "44    ") );
connect( ui->lib442, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib442, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib442->installEventFilter(this);
ui->lib442->setMaximumWidth( m26trail);
ui->lib442->setMinimumWidth( m25trail);
ui->lib442->setMaximumHeight( m7traild3 );
ui->lib442->setMaxLength(24);
ui->lib442->setFrame(globalFrame);

ui->lib443->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "44    ") );
connect( ui->lib443, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib443, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib443->installEventFilter(this);
ui->lib443->setAlignment(Qt::AlignCenter);
ui->lib443->setMaximumWidth( m12trail);
ui->lib443->setMinimumWidth( m6trail);
ui->lib443->setMaximumHeight( m7traild3 );
ui->lib443->setMaxLength(11);
ui->lib443->setFrame(globalFrame);

ui->lib444->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "44    ") );
connect( ui->lib444, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib444, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib444->installEventFilter(this);
ui->lib444->setAlignment(Qt::AlignCenter);
ui->lib444->setMaximumWidth( m12trail);
ui->lib444->setMinimumWidth( m6trail);
ui->lib444->setMaximumHeight( m7traild3 );
ui->lib444->setMaxLength(11);
ui->lib444->setFrame(globalFrame);

ui->pushButtonEst44->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "44    ") );
ui->pushButtonEst44->setMaximumWidth( m7traild3 );
ui->pushButtonEst44->setMaximumHeight( m7traild3 );
ui->pushButtonLib44->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "44    ") );
ui->pushButtonLib44->setMaximumWidth( m7traild3 );
ui->pushButtonLib44->setMaximumHeight( m7traild3 );

ui->est441->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "44    ") );
connect( ui->est441, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est441, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est441->installEventFilter(this);
ui->est441->setMaximumWidth( m6trail);
ui->est441->setMinimumWidth( m6trail);
ui->est441->setMaximumHeight( m7traild3 );
ui->est441->setMaxLength(3);
ui->est441->setFrame(globalFrame);

ui->est442->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "44    ") );
connect( ui->est442, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est442, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est442->installEventFilter(this);
ui->est442->setMaximumWidth( m26trail);
ui->est442->setMinimumWidth( m25trail);
ui->est442->setMaximumHeight( m7traild3 );
ui->est442->setMaxLength(24);
ui->est442->setFrame(globalFrame);

ui->est443->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "44    ") );
connect( ui->est443, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est443, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est443->installEventFilter(this);
ui->est443->setAlignment(Qt::AlignCenter);
ui->est443->setMaximumWidth( m11trail);
ui->est443->setMinimumWidth( m6trail);
ui->est443->setMaximumHeight( m7traild3 );
ui->est443->setMaxLength(8);
ui->est443->setFrame(globalFrame);

ui->est444->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "44    ") );
connect( ui->est444, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est444, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est444->installEventFilter(this);
ui->est444->setAlignment(Qt::AlignCenter);
ui->est444->setMaximumWidth( m12trail);
ui->est444->setMinimumWidth( m6trail);
ui->est444->setMaximumHeight( m7traild3 );
ui->est444->setMaxLength(11);
ui->est444->setFrame(globalFrame);

ui->est445->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "44    ") );
connect( ui->est445, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est445, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est445->installEventFilter(this);
ui->est445->setAlignment(Qt::AlignCenter);
ui->est445->setMaximumWidth( m12trail);
ui->est445->setMinimumWidth( m6trail);
ui->est445->setMaximumHeight( m7traild3 );
ui->est445->setMaxLength(11);
ui->est445->setFrame(globalFrame);

ui->est446->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "44    ") );
ui->est446->setReadOnly(true);
ui->est446->setAlignment(Qt::AlignRight);
ui->est446->setMaximumWidth( m14trail);
ui->est446->setMinimumWidth( m9trail);
ui->est446->setMaximumHeight( m7traild3 );
ui->est446->setMaxLength(15);
ui->est446->setFrame(globalFrame);

ui->est447->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "44    ") );
ui->est447->setReadOnly(true);
ui->est447->setAlignment(Qt::AlignRight);
ui->est447->setMaximumWidth( m14trail);
ui->est447->setMinimumWidth( m9trail);
ui->est447->setMaximumHeight( m7traild3 );
ui->est447->setMaxLength(15);
ui->est447->setFrame(globalFrame);

ui->lib451->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "45    ") );
connect( ui->lib451, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib451, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib45, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst45, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib451->installEventFilter(this);
ui->lib451->setMaximumWidth( m6trail);
ui->lib451->setMinimumWidth( m6trail);
ui->lib451->setMaximumHeight( m7traild3 );
ui->lib451->setMaxLength(3);
ui->lib451->setFrame(globalFrame);

ui->lib452->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "45    ") );
connect( ui->lib452, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib452, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib452->installEventFilter(this);
ui->lib452->setMaximumWidth( m26trail);
ui->lib452->setMinimumWidth( m25trail);
ui->lib452->setMaximumHeight( m7traild3 );
ui->lib452->setMaxLength(24);
ui->lib452->setFrame(globalFrame);

ui->lib453->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "45    ") );
connect( ui->lib453, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib453, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib453->installEventFilter(this);
ui->lib453->setAlignment(Qt::AlignCenter);
ui->lib453->setMaximumWidth( m12trail);
ui->lib453->setMinimumWidth( m6trail);
ui->lib453->setMaximumHeight( m7traild3 );
ui->lib453->setMaxLength(11);
ui->lib453->setFrame(globalFrame);

ui->lib454->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "45    ") );
connect( ui->lib454, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib454, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib454->installEventFilter(this);
ui->lib454->setAlignment(Qt::AlignCenter);
ui->lib454->setMaximumWidth( m12trail);
ui->lib454->setMinimumWidth( m6trail);
ui->lib454->setMaximumHeight( m7traild3 );
ui->lib454->setMaxLength(11);
ui->lib454->setFrame(globalFrame);

ui->pushButtonEst45->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "45    ") );
ui->pushButtonEst45->setMaximumWidth( m7traild3 );
ui->pushButtonEst45->setMaximumHeight( m7traild3 );
ui->pushButtonLib45->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "45    ") );
ui->pushButtonLib45->setMaximumWidth( m7traild3 );
ui->pushButtonLib45->setMaximumHeight( m7traild3 );

ui->est451->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "45    ") );
connect( ui->est451, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est451, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est451->installEventFilter(this);
ui->est451->setMaximumWidth( m6trail);
ui->est451->setMinimumWidth( m6trail);
ui->est451->setMaximumHeight( m7traild3 );
ui->est451->setMaxLength(3);
ui->est451->setFrame(globalFrame);

ui->est452->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "45    ") );
connect( ui->est452, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est452, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est452->installEventFilter(this);
ui->est452->setMaximumWidth( m26trail);
ui->est452->setMinimumWidth( m25trail);
ui->est452->setMaximumHeight( m7traild3 );
ui->est452->setMaxLength(24);
ui->est452->setFrame(globalFrame);

ui->est453->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "45    ") );
connect( ui->est453, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est453, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est453->installEventFilter(this);
ui->est453->setAlignment(Qt::AlignCenter);
ui->est453->setMaximumWidth( m11trail);
ui->est453->setMinimumWidth( m6trail);
ui->est453->setMaximumHeight( m7traild3 );
ui->est453->setMaxLength(8);
ui->est453->setFrame(globalFrame);

ui->est454->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "45    ") );
connect( ui->est454, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est454, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est454->installEventFilter(this);
ui->est454->setAlignment(Qt::AlignCenter);
ui->est454->setMaximumWidth( m12trail);
ui->est454->setMinimumWidth( m6trail);
ui->est454->setMaximumHeight( m7traild3 );
ui->est454->setMaxLength(11);
ui->est454->setFrame(globalFrame);

ui->est455->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "45    ") );
connect( ui->est455, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est455, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est455->installEventFilter(this);
ui->est455->setAlignment(Qt::AlignCenter);
ui->est455->setMaximumWidth( m12trail);
ui->est455->setMinimumWidth( m6trail);
ui->est455->setMaximumHeight( m7traild3 );
ui->est455->setMaxLength(11);
ui->est455->setFrame(globalFrame);

ui->est456->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "45    ") );
ui->est456->setReadOnly(true);
ui->est456->setAlignment(Qt::AlignRight);
ui->est456->setMaximumWidth( m14trail);
ui->est456->setMinimumWidth( m9trail);
ui->est456->setMaximumHeight( m7traild3 );
ui->est456->setMaxLength(15);
ui->est456->setFrame(globalFrame);

ui->est457->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "45    ") );
ui->est457->setReadOnly(true);
ui->est457->setAlignment(Qt::AlignRight);
ui->est457->setMaximumWidth( m14trail);
ui->est457->setMinimumWidth( m9trail);
ui->est457->setMaximumHeight( m7traild3 );
ui->est457->setMaxLength(15);
ui->est457->setFrame(globalFrame);

ui->lib461->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "46    ") );
connect( ui->lib461, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib461, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib46, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst46, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib461->installEventFilter(this);
ui->lib461->setMaximumWidth( m6trail);
ui->lib461->setMinimumWidth( m6trail);
ui->lib461->setMaximumHeight( m7traild3 );
ui->lib461->setMaxLength(3);
ui->lib461->setFrame(globalFrame);

ui->lib462->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "46    ") );
connect( ui->lib462, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib462, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib462->installEventFilter(this);
ui->lib462->setMaximumWidth( m26trail);
ui->lib462->setMinimumWidth( m25trail);
ui->lib462->setMaximumHeight( m7traild3 );
ui->lib462->setMaxLength(24);
ui->lib462->setFrame(globalFrame);

ui->lib463->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "46    ") );
connect( ui->lib463, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib463, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib463->installEventFilter(this);
ui->lib463->setAlignment(Qt::AlignCenter);
ui->lib463->setMaximumWidth( m12trail);
ui->lib463->setMinimumWidth( m6trail);
ui->lib463->setMaximumHeight( m7traild3 );
ui->lib463->setMaxLength(11);
ui->lib463->setFrame(globalFrame);

ui->lib464->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "46    ") );
connect( ui->lib464, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib464, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib464->installEventFilter(this);
ui->lib464->setAlignment(Qt::AlignCenter);
ui->lib464->setMaximumWidth( m12trail);
ui->lib464->setMinimumWidth( m6trail);
ui->lib464->setMaximumHeight( m7traild3 );
ui->lib464->setMaxLength(11);
ui->lib464->setFrame(globalFrame);

ui->pushButtonEst46->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "46    ") );
ui->pushButtonEst46->setMaximumWidth( m7traild3 );
ui->pushButtonEst46->setMaximumHeight( m7traild3 );
ui->pushButtonLib46->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "46    ") );
ui->pushButtonLib46->setMaximumWidth( m7traild3 );
ui->pushButtonLib46->setMaximumHeight( m7traild3 );

ui->est461->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "46    ") );
connect( ui->est461, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est461, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est461->installEventFilter(this);
ui->est461->setMaximumWidth( m6trail);
ui->est461->setMinimumWidth( m6trail);
ui->est461->setMaximumHeight( m7traild3 );
ui->est461->setMaxLength(3);
ui->est461->setFrame(globalFrame);

ui->est462->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "46    ") );
connect( ui->est462, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est462, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est462->installEventFilter(this);
ui->est462->setMaximumWidth( m26trail);
ui->est462->setMinimumWidth( m25trail);
ui->est462->setMaximumHeight( m7traild3 );
ui->est462->setMaxLength(24);
ui->est462->setFrame(globalFrame);

ui->est463->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "46    ") );
connect( ui->est463, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est463, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est463->installEventFilter(this);
ui->est463->setAlignment(Qt::AlignCenter);
ui->est463->setMaximumWidth( m11trail);
ui->est463->setMinimumWidth( m6trail);
ui->est463->setMaximumHeight( m7traild3 );
ui->est463->setMaxLength(8);
ui->est463->setFrame(globalFrame);

ui->est464->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "46    ") );
connect( ui->est464, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est464, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est464->installEventFilter(this);
ui->est464->setAlignment(Qt::AlignCenter);
ui->est464->setMaximumWidth( m12trail);
ui->est464->setMinimumWidth( m6trail);
ui->est464->setMaximumHeight( m7traild3 );
ui->est464->setMaxLength(11);
ui->est464->setFrame(globalFrame);

ui->est465->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "46    ") );
connect( ui->est465, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est465, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est465->installEventFilter(this);
ui->est465->setAlignment(Qt::AlignCenter);
ui->est465->setMaximumWidth( m12trail);
ui->est465->setMinimumWidth( m6trail);
ui->est465->setMaximumHeight( m7traild3 );
ui->est465->setMaxLength(11);
ui->est465->setFrame(globalFrame);

ui->est466->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "46    ") );
ui->est466->setReadOnly(true);
ui->est466->setAlignment(Qt::AlignRight);
ui->est466->setMaximumWidth( m14trail);
ui->est466->setMinimumWidth( m9trail);
ui->est466->setMaximumHeight( m7traild3 );
ui->est466->setMaxLength(15);
ui->est466->setFrame(globalFrame);

ui->est467->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "46    ") );
ui->est467->setReadOnly(true);
ui->est467->setAlignment(Qt::AlignRight);
ui->est467->setMaximumWidth( m14trail);
ui->est467->setMinimumWidth( m9trail);
ui->est467->setMaximumHeight( m7traild3 );
ui->est467->setMaxLength(15);
ui->est467->setFrame(globalFrame);

ui->lib471->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "47    ") );
connect( ui->lib471, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib471, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib47, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst47, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib471->installEventFilter(this);
ui->lib471->setMaximumWidth( m6trail);
ui->lib471->setMinimumWidth( m6trail);
ui->lib471->setMaximumHeight( m7traild3 );
ui->lib471->setMaxLength(3);
ui->lib471->setFrame(globalFrame);

ui->lib472->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "47    ") );
connect( ui->lib472, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib472, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib472->installEventFilter(this);
ui->lib472->setMaximumWidth( m26trail);
ui->lib472->setMinimumWidth( m25trail);
ui->lib472->setMaximumHeight( m7traild3 );
ui->lib472->setMaxLength(24);
ui->lib472->setFrame(globalFrame);

ui->lib473->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "47    ") );
connect( ui->lib473, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib473, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib473->installEventFilter(this);
ui->lib473->setAlignment(Qt::AlignCenter);
ui->lib473->setMaximumWidth( m12trail);
ui->lib473->setMinimumWidth( m6trail);
ui->lib473->setMaximumHeight( m7traild3 );
ui->lib473->setMaxLength(11);
ui->lib473->setFrame(globalFrame);

ui->lib474->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "47    ") );
connect( ui->lib474, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib474, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib474->installEventFilter(this);
ui->lib474->setAlignment(Qt::AlignCenter);
ui->lib474->setMaximumWidth( m12trail);
ui->lib474->setMinimumWidth( m6trail);
ui->lib474->setMaximumHeight( m7traild3 );
ui->lib474->setMaxLength(11);
ui->lib474->setFrame(globalFrame);

ui->pushButtonEst47->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "47    ") );
ui->pushButtonEst47->setMaximumWidth( m7traild3 );
ui->pushButtonEst47->setMaximumHeight( m7traild3 );
ui->pushButtonLib47->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "47    ") );
ui->pushButtonLib47->setMaximumWidth( m7traild3 );
ui->pushButtonLib47->setMaximumHeight( m7traild3 );

ui->est471->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "47    ") );
connect( ui->est471, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est471, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est471->installEventFilter(this);
ui->est471->setMaximumWidth( m6trail);
ui->est471->setMinimumWidth( m6trail);
ui->est471->setMaximumHeight( m7traild3 );
ui->est471->setMaxLength(3);
ui->est471->setFrame(globalFrame);

ui->est472->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "47    ") );
connect( ui->est472, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est472, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est472->installEventFilter(this);
ui->est472->setMaximumWidth( m26trail);
ui->est472->setMinimumWidth( m25trail);
ui->est472->setMaximumHeight( m7traild3 );
ui->est472->setMaxLength(24);
ui->est472->setFrame(globalFrame);

ui->est473->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "47    ") );
connect( ui->est473, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est473, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est473->installEventFilter(this);
ui->est473->setAlignment(Qt::AlignCenter);
ui->est473->setMaximumWidth( m11trail);
ui->est473->setMinimumWidth( m6trail);
ui->est473->setMaximumHeight( m7traild3 );
ui->est473->setMaxLength(8);
ui->est473->setFrame(globalFrame);

ui->est474->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "47    ") );
connect( ui->est474, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est474, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est474->installEventFilter(this);
ui->est474->setAlignment(Qt::AlignCenter);
ui->est474->setMaximumWidth( m12trail);
ui->est474->setMinimumWidth( m6trail);
ui->est474->setMaximumHeight( m7traild3 );
ui->est474->setMaxLength(11);
ui->est474->setFrame(globalFrame);

ui->est475->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "47    ") );
connect( ui->est475, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est475, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est475->installEventFilter(this);
ui->est475->setAlignment(Qt::AlignCenter);
ui->est475->setMaximumWidth( m12trail);
ui->est475->setMinimumWidth( m6trail);
ui->est475->setMaximumHeight( m7traild3 );
ui->est475->setMaxLength(11);
ui->est475->setFrame(globalFrame);

ui->est476->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "47    ") );
ui->est476->setReadOnly(true);
ui->est476->setAlignment(Qt::AlignRight);
ui->est476->setMaximumWidth( m14trail);
ui->est476->setMinimumWidth( m9trail);
ui->est476->setMaximumHeight( m7traild3 );
ui->est476->setMaxLength(15);
ui->est476->setFrame(globalFrame);

ui->est477->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "47    ") );
ui->est477->setReadOnly(true);
ui->est477->setAlignment(Qt::AlignRight);
ui->est477->setMaximumWidth( m14trail);
ui->est477->setMinimumWidth( m9trail);
ui->est477->setMaximumHeight( m7traild3 );
ui->est477->setMaxLength(15);
ui->est477->setFrame(globalFrame);

ui->lib481->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "48    ") );
connect( ui->lib481, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib481, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib48, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst48, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib481->installEventFilter(this);
ui->lib481->setMaximumWidth( m6trail);
ui->lib481->setMinimumWidth( m6trail);
ui->lib481->setMaximumHeight( m7traild3 );
ui->lib481->setMaxLength(3);
ui->lib481->setFrame(globalFrame);

ui->lib482->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "48    ") );
connect( ui->lib482, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib482, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib482->installEventFilter(this);
ui->lib482->setMaximumWidth( m26trail);
ui->lib482->setMinimumWidth( m25trail);
ui->lib482->setMaximumHeight( m7traild3 );
ui->lib482->setMaxLength(24);
ui->lib482->setFrame(globalFrame);

ui->lib483->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "48    ") );
connect( ui->lib483, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib483, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib483->installEventFilter(this);
ui->lib483->setAlignment(Qt::AlignCenter);
ui->lib483->setMaximumWidth( m12trail);
ui->lib483->setMinimumWidth( m6trail);
ui->lib483->setMaximumHeight( m7traild3 );
ui->lib483->setMaxLength(11);
ui->lib483->setFrame(globalFrame);

ui->lib484->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "48    ") );
connect( ui->lib484, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib484, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib484->installEventFilter(this);
ui->lib484->setAlignment(Qt::AlignCenter);
ui->lib484->setMaximumWidth( m12trail);
ui->lib484->setMinimumWidth( m6trail);
ui->lib484->setMaximumHeight( m7traild3 );
ui->lib484->setMaxLength(11);
ui->lib484->setFrame(globalFrame);

ui->pushButtonEst48->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "48    ") );
ui->pushButtonEst48->setMaximumWidth( m7traild3 );
ui->pushButtonEst48->setMaximumHeight( m7traild3 );
ui->pushButtonLib48->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "48    ") );
ui->pushButtonLib48->setMaximumWidth( m7traild3 );
ui->pushButtonLib48->setMaximumHeight( m7traild3 );

ui->est481->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "48    ") );
connect( ui->est481, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est481, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est481->installEventFilter(this);
ui->est481->setMaximumWidth( m6trail);
ui->est481->setMinimumWidth( m6trail);
ui->est481->setMaximumHeight( m7traild3 );
ui->est481->setMaxLength(3);
ui->est481->setFrame(globalFrame);

ui->est482->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "48    ") );
connect( ui->est482, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est482, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est482->installEventFilter(this);
ui->est482->setMaximumWidth( m26trail);
ui->est482->setMinimumWidth( m25trail);
ui->est482->setMaximumHeight( m7traild3 );
ui->est482->setMaxLength(24);
ui->est482->setFrame(globalFrame);

ui->est483->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "48    ") );
connect( ui->est483, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est483, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est483->installEventFilter(this);
ui->est483->setAlignment(Qt::AlignCenter);
ui->est483->setMaximumWidth( m11trail);
ui->est483->setMinimumWidth( m6trail);
ui->est483->setMaximumHeight( m7traild3 );
ui->est483->setMaxLength(8);
ui->est483->setFrame(globalFrame);

ui->est484->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "48    ") );
connect( ui->est484, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est484, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est484->installEventFilter(this);
ui->est484->setAlignment(Qt::AlignCenter);
ui->est484->setMaximumWidth( m12trail);
ui->est484->setMinimumWidth( m6trail);
ui->est484->setMaximumHeight( m7traild3 );
ui->est484->setMaxLength(11);
ui->est484->setFrame(globalFrame);

ui->est485->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "48    ") );
connect( ui->est485, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est485, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est485->installEventFilter(this);
ui->est485->setAlignment(Qt::AlignCenter);
ui->est485->setMaximumWidth( m12trail);
ui->est485->setMinimumWidth( m6trail);
ui->est485->setMaximumHeight( m7traild3 );
ui->est485->setMaxLength(11);
ui->est485->setFrame(globalFrame);

ui->est486->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "48    ") );
ui->est486->setReadOnly(true);
ui->est486->setAlignment(Qt::AlignRight);
ui->est486->setMaximumWidth( m14trail);
ui->est486->setMinimumWidth( m9trail);
ui->est486->setMaximumHeight( m7traild3 );
ui->est486->setMaxLength(15);
ui->est486->setFrame(globalFrame);

ui->est487->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "48    ") );
ui->est487->setReadOnly(true);
ui->est487->setAlignment(Qt::AlignRight);
ui->est487->setMaximumWidth( m14trail);
ui->est487->setMinimumWidth( m9trail);
ui->est487->setMaximumHeight( m7traild3 );
ui->est487->setMaxLength(15);
ui->est487->setFrame(globalFrame);

ui->lib491->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "49    ") );
connect( ui->lib491, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib491, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib49, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst49, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib491->installEventFilter(this);
ui->lib491->setMaximumWidth( m6trail);
ui->lib491->setMinimumWidth( m6trail);
ui->lib491->setMaximumHeight( m7traild3 );
ui->lib491->setMaxLength(3);
ui->lib491->setFrame(globalFrame);

ui->lib492->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "49    ") );
connect( ui->lib492, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib492, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib492->installEventFilter(this);
ui->lib492->setMaximumWidth( m26trail);
ui->lib492->setMinimumWidth( m25trail);
ui->lib492->setMaximumHeight( m7traild3 );
ui->lib492->setMaxLength(24);
ui->lib492->setFrame(globalFrame);

ui->lib493->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "49    ") );
connect( ui->lib493, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib493, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib493->installEventFilter(this);
ui->lib493->setAlignment(Qt::AlignCenter);
ui->lib493->setMaximumWidth( m12trail);
ui->lib493->setMinimumWidth( m6trail);
ui->lib493->setMaximumHeight( m7traild3 );
ui->lib493->setMaxLength(11);
ui->lib493->setFrame(globalFrame);

ui->lib494->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "49    ") );
connect( ui->lib494, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib494, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib494->installEventFilter(this);
ui->lib494->setAlignment(Qt::AlignCenter);
ui->lib494->setMaximumWidth( m12trail);
ui->lib494->setMinimumWidth( m6trail);
ui->lib494->setMaximumHeight( m7traild3 );
ui->lib494->setMaxLength(11);
ui->lib494->setFrame(globalFrame);

ui->pushButtonEst49->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "49    ") );
ui->pushButtonEst49->setMaximumWidth( m7traild3 );
ui->pushButtonEst49->setMaximumHeight( m7traild3 );
ui->pushButtonLib49->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "49    ") );
ui->pushButtonLib49->setMaximumWidth( m7traild3 );
ui->pushButtonLib49->setMaximumHeight( m7traild3 );

ui->est491->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "49    ") );
connect( ui->est491, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est491, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est491->installEventFilter(this);
ui->est491->setMaximumWidth( m6trail);
ui->est491->setMinimumWidth( m6trail);
ui->est491->setMaximumHeight( m7traild3 );
ui->est491->setMaxLength(3);
ui->est491->setFrame(globalFrame);

ui->est492->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "49    ") );
connect( ui->est492, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est492, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est492->installEventFilter(this);
ui->est492->setMaximumWidth( m26trail);
ui->est492->setMinimumWidth( m25trail);
ui->est492->setMaximumHeight( m7traild3 );
ui->est492->setMaxLength(24);
ui->est492->setFrame(globalFrame);

ui->est493->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "49    ") );
connect( ui->est493, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est493, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est493->installEventFilter(this);
ui->est493->setAlignment(Qt::AlignCenter);
ui->est493->setMaximumWidth( m11trail);
ui->est493->setMinimumWidth( m6trail);
ui->est493->setMaximumHeight( m7traild3 );
ui->est493->setMaxLength(8);
ui->est493->setFrame(globalFrame);

ui->est494->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "49    ") );
connect( ui->est494, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est494, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est494->installEventFilter(this);
ui->est494->setAlignment(Qt::AlignCenter);
ui->est494->setMaximumWidth( m12trail);
ui->est494->setMinimumWidth( m6trail);
ui->est494->setMaximumHeight( m7traild3 );
ui->est494->setMaxLength(11);
ui->est494->setFrame(globalFrame);

ui->est495->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "49    ") );
connect( ui->est495, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est495, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est495->installEventFilter(this);
ui->est495->setAlignment(Qt::AlignCenter);
ui->est495->setMaximumWidth( m12trail);
ui->est495->setMinimumWidth( m6trail);
ui->est495->setMaximumHeight( m7traild3 );
ui->est495->setMaxLength(11);
ui->est495->setFrame(globalFrame);

ui->est496->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "49    ") );
ui->est496->setReadOnly(true);
ui->est496->setAlignment(Qt::AlignRight);
ui->est496->setMaximumWidth( m14trail);
ui->est496->setMinimumWidth( m9trail);
ui->est496->setMaximumHeight( m7traild3 );
ui->est496->setMaxLength(15);
ui->est496->setFrame(globalFrame);

ui->est497->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "49    ") );
ui->est497->setReadOnly(true);
ui->est497->setAlignment(Qt::AlignRight);
ui->est497->setMaximumWidth( m14trail);
ui->est497->setMinimumWidth( m9trail);
ui->est497->setMaximumHeight( m7traild3 );
ui->est497->setMaxLength(15);
ui->est497->setFrame(globalFrame);

ui->lib501->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "50    ") );
connect( ui->lib501, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib501, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib50, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst50, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib501->installEventFilter(this);
ui->lib501->setMaximumWidth( m6trail);
ui->lib501->setMinimumWidth( m6trail);
ui->lib501->setMaximumHeight( m7traild3 );
ui->lib501->setMaxLength(3);
ui->lib501->setFrame(globalFrame);

ui->lib502->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "50    ") );
connect( ui->lib502, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib502, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib502->installEventFilter(this);
ui->lib502->setMaximumWidth( m26trail);
ui->lib502->setMinimumWidth( m25trail);
ui->lib502->setMaximumHeight( m7traild3 );
ui->lib502->setMaxLength(24);
ui->lib502->setFrame(globalFrame);

ui->lib503->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "50    ") );
connect( ui->lib503, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib503, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib503->installEventFilter(this);
ui->lib503->setAlignment(Qt::AlignCenter);
ui->lib503->setMaximumWidth( m12trail);
ui->lib503->setMinimumWidth( m6trail);
ui->lib503->setMaximumHeight( m7traild3 );
ui->lib503->setMaxLength(11);
ui->lib503->setFrame(globalFrame);

ui->lib504->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "50    ") );
connect( ui->lib504, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib504, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib504->installEventFilter(this);
ui->lib504->setAlignment(Qt::AlignCenter);
ui->lib504->setMaximumWidth( m12trail);
ui->lib504->setMinimumWidth( m6trail);
ui->lib504->setMaximumHeight( m7traild3 );
ui->lib504->setMaxLength(11);
ui->lib504->setFrame(globalFrame);

ui->pushButtonEst50->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "50    ") );
ui->pushButtonEst50->setMaximumWidth( m7traild3 );
ui->pushButtonEst50->setMaximumHeight( m7traild3 );
ui->pushButtonLib50->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "50    ") );
ui->pushButtonLib50->setMaximumWidth( m7traild3 );
ui->pushButtonLib50->setMaximumHeight( m7traild3 );

ui->est501->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "50    ") );
connect( ui->est501, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est501, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est501->installEventFilter(this);
ui->est501->setMaximumWidth( m6trail);
ui->est501->setMinimumWidth( m6trail);
ui->est501->setMaximumHeight( m7traild3 );
ui->est501->setMaxLength(3);
ui->est501->setFrame(globalFrame);

ui->est502->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "50    ") );
connect( ui->est502, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est502, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est502->installEventFilter(this);
ui->est502->setMaximumWidth( m26trail);
ui->est502->setMinimumWidth( m25trail);
ui->est502->setMaximumHeight( m7traild3 );
ui->est502->setMaxLength(24);
ui->est502->setFrame(globalFrame);

ui->est503->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "50    ") );
connect( ui->est503, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est503, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est503->installEventFilter(this);
ui->est503->setAlignment(Qt::AlignCenter);
ui->est503->setMaximumWidth( m11trail);
ui->est503->setMinimumWidth( m6trail);
ui->est503->setMaximumHeight( m7traild3 );
ui->est503->setMaxLength(8);
ui->est503->setFrame(globalFrame);

ui->est504->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "50    ") );
connect( ui->est504, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est504, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est504->installEventFilter(this);
ui->est504->setAlignment(Qt::AlignCenter);
ui->est504->setMaximumWidth( m12trail);
ui->est504->setMinimumWidth( m6trail);
ui->est504->setMaximumHeight( m7traild3 );
ui->est504->setMaxLength(11);
ui->est504->setFrame(globalFrame);

ui->est505->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "50    ") );
connect( ui->est505, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est505, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est505->installEventFilter(this);
ui->est505->setAlignment(Qt::AlignCenter);
ui->est505->setMaximumWidth( m12trail);
ui->est505->setMinimumWidth( m6trail);
ui->est505->setMaximumHeight( m7traild3 );
ui->est505->setMaxLength(11);
ui->est505->setFrame(globalFrame);

ui->est506->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "50    ") );
ui->est506->setReadOnly(true);
ui->est506->setAlignment(Qt::AlignRight);
ui->est506->setMaximumWidth( m14trail);
ui->est506->setMinimumWidth( m9trail);
ui->est506->setMaximumHeight( m7traild3 );
ui->est506->setMaxLength(15);
ui->est506->setFrame(globalFrame);

ui->est507->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "50    ") );
ui->est507->setReadOnly(true);
ui->est507->setAlignment(Qt::AlignRight);
ui->est507->setMaximumWidth( m14trail);
ui->est507->setMinimumWidth( m9trail);
ui->est507->setMaximumHeight( m7traild3 );
ui->est507->setMaxLength(15);
ui->est507->setFrame(globalFrame);

ui->lib511->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "51    ") );
connect( ui->lib511, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib511, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib51, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst51, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib511->installEventFilter(this);
ui->lib511->setMaximumWidth( m6trail);
ui->lib511->setMinimumWidth( m6trail);
ui->lib511->setMaximumHeight( m7traild3 );
ui->lib511->setMaxLength(3);
ui->lib511->setFrame(globalFrame);

ui->lib512->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "51    ") );
connect( ui->lib512, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib512, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib512->installEventFilter(this);
ui->lib512->setMaximumWidth( m26trail);
ui->lib512->setMinimumWidth( m25trail);
ui->lib512->setMaximumHeight( m7traild3 );
ui->lib512->setMaxLength(24);
ui->lib512->setFrame(globalFrame);

ui->lib513->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "51    ") );
connect( ui->lib513, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib513, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib513->installEventFilter(this);
ui->lib513->setAlignment(Qt::AlignCenter);
ui->lib513->setMaximumWidth( m12trail);
ui->lib513->setMinimumWidth( m6trail);
ui->lib513->setMaximumHeight( m7traild3 );
ui->lib513->setMaxLength(11);
ui->lib513->setFrame(globalFrame);

ui->lib514->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "51    ") );
connect( ui->lib514, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib514, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib514->installEventFilter(this);
ui->lib514->setAlignment(Qt::AlignCenter);
ui->lib514->setMaximumWidth( m12trail);
ui->lib514->setMinimumWidth( m6trail);
ui->lib514->setMaximumHeight( m7traild3 );
ui->lib514->setMaxLength(11);
ui->lib514->setFrame(globalFrame);

ui->pushButtonEst51->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "51    ") );
ui->pushButtonEst51->setMaximumWidth( m7traild3 );
ui->pushButtonEst51->setMaximumHeight( m7traild3 );
ui->pushButtonLib51->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "51    ") );
ui->pushButtonLib51->setMaximumWidth( m7traild3 );
ui->pushButtonLib51->setMaximumHeight( m7traild3 );

ui->est511->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "51    ") );
connect( ui->est511, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est511, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est511->installEventFilter(this);
ui->est511->setMaximumWidth( m6trail);
ui->est511->setMinimumWidth( m6trail);
ui->est511->setMaximumHeight( m7traild3 );
ui->est511->setMaxLength(3);
ui->est511->setFrame(globalFrame);

ui->est512->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "51    ") );
connect( ui->est512, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est512, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est512->installEventFilter(this);
ui->est512->setMaximumWidth( m26trail);
ui->est512->setMinimumWidth( m25trail);
ui->est512->setMaximumHeight( m7traild3 );
ui->est512->setMaxLength(24);
ui->est512->setFrame(globalFrame);

ui->est513->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "51    ") );
connect( ui->est513, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est513, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est513->installEventFilter(this);
ui->est513->setAlignment(Qt::AlignCenter);
ui->est513->setMaximumWidth( m11trail);
ui->est513->setMinimumWidth( m6trail);
ui->est513->setMaximumHeight( m7traild3 );
ui->est513->setMaxLength(8);
ui->est513->setFrame(globalFrame);

ui->est514->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "51    ") );
connect( ui->est514, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est514, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est514->installEventFilter(this);
ui->est514->setAlignment(Qt::AlignCenter);
ui->est514->setMaximumWidth( m12trail);
ui->est514->setMinimumWidth( m6trail);
ui->est514->setMaximumHeight( m7traild3 );
ui->est514->setMaxLength(11);
ui->est514->setFrame(globalFrame);

ui->est515->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "51    ") );
connect( ui->est515, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est515, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est515->installEventFilter(this);
ui->est515->setAlignment(Qt::AlignCenter);
ui->est515->setMaximumWidth( m12trail);
ui->est515->setMinimumWidth( m6trail);
ui->est515->setMaximumHeight( m7traild3 );
ui->est515->setMaxLength(11);
ui->est515->setFrame(globalFrame);

ui->est516->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "51    ") );
ui->est516->setReadOnly(true);
ui->est516->setAlignment(Qt::AlignRight);
ui->est516->setMaximumWidth( m14trail);
ui->est516->setMinimumWidth( m9trail);
ui->est516->setMaximumHeight( m7traild3 );
ui->est516->setMaxLength(15);
ui->est516->setFrame(globalFrame);

ui->est517->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "51    ") );
ui->est517->setReadOnly(true);
ui->est517->setAlignment(Qt::AlignRight);
ui->est517->setMaximumWidth( m14trail);
ui->est517->setMinimumWidth( m9trail);
ui->est517->setMaximumHeight( m7traild3 );
ui->est517->setMaxLength(15);
ui->est517->setFrame(globalFrame);

ui->lib521->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "52    ") );
connect( ui->lib521, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib521, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib52, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst52, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib521->installEventFilter(this);
ui->lib521->setMaximumWidth( m6trail);
ui->lib521->setMinimumWidth( m6trail);
ui->lib521->setMaximumHeight( m7traild3 );
ui->lib521->setMaxLength(3);
ui->lib521->setFrame(globalFrame);

ui->lib522->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "52    ") );
connect( ui->lib522, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib522, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib522->installEventFilter(this);
ui->lib522->setMaximumWidth( m26trail);
ui->lib522->setMinimumWidth( m25trail);
ui->lib522->setMaximumHeight( m7traild3 );
ui->lib522->setMaxLength(24);
ui->lib522->setFrame(globalFrame);

ui->lib523->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "52    ") );
connect( ui->lib523, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib523, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib523->installEventFilter(this);
ui->lib523->setAlignment(Qt::AlignCenter);
ui->lib523->setMaximumWidth( m12trail);
ui->lib523->setMinimumWidth( m6trail);
ui->lib523->setMaximumHeight( m7traild3 );
ui->lib523->setMaxLength(11);
ui->lib523->setFrame(globalFrame);

ui->lib524->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "52    ") );
connect( ui->lib524, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib524, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib524->installEventFilter(this);
ui->lib524->setAlignment(Qt::AlignCenter);
ui->lib524->setMaximumWidth( m12trail);
ui->lib524->setMinimumWidth( m6trail);
ui->lib524->setMaximumHeight( m7traild3 );
ui->lib524->setMaxLength(11);
ui->lib524->setFrame(globalFrame);

ui->pushButtonEst52->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "52    ") );
ui->pushButtonEst52->setMaximumWidth( m7traild3 );
ui->pushButtonEst52->setMaximumHeight( m7traild3 );
ui->pushButtonLib52->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "52    ") );
ui->pushButtonLib52->setMaximumWidth( m7traild3 );
ui->pushButtonLib52->setMaximumHeight( m7traild3 );

ui->est521->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "52    ") );
connect( ui->est521, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est521, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est521->installEventFilter(this);
ui->est521->setMaximumWidth( m6trail);
ui->est521->setMinimumWidth( m6trail);
ui->est521->setMaximumHeight( m7traild3 );
ui->est521->setMaxLength(3);
ui->est521->setFrame(globalFrame);

ui->est522->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "52    ") );
connect( ui->est522, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est522, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est522->installEventFilter(this);
ui->est522->setMaximumWidth( m26trail);
ui->est522->setMinimumWidth( m25trail);
ui->est522->setMaximumHeight( m7traild3 );
ui->est522->setMaxLength(24);
ui->est522->setFrame(globalFrame);

ui->est523->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "52    ") );
connect( ui->est523, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est523, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est523->installEventFilter(this);
ui->est523->setAlignment(Qt::AlignCenter);
ui->est523->setMaximumWidth( m11trail);
ui->est523->setMinimumWidth( m6trail);
ui->est523->setMaximumHeight( m7traild3 );
ui->est523->setMaxLength(8);
ui->est523->setFrame(globalFrame);

ui->est524->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "52    ") );
connect( ui->est524, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est524, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est524->installEventFilter(this);
ui->est524->setAlignment(Qt::AlignCenter);
ui->est524->setMaximumWidth( m12trail);
ui->est524->setMinimumWidth( m6trail);
ui->est524->setMaximumHeight( m7traild3 );
ui->est524->setMaxLength(11);
ui->est524->setFrame(globalFrame);

ui->est525->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "52    ") );
connect( ui->est525, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est525, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est525->installEventFilter(this);
ui->est525->setAlignment(Qt::AlignCenter);
ui->est525->setMaximumWidth( m12trail);
ui->est525->setMinimumWidth( m6trail);
ui->est525->setMaximumHeight( m7traild3 );
ui->est525->setMaxLength(11);
ui->est525->setFrame(globalFrame);

ui->est526->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "52    ") );
ui->est526->setReadOnly(true);
ui->est526->setAlignment(Qt::AlignRight);
ui->est526->setMaximumWidth( m14trail);
ui->est526->setMinimumWidth( m9trail);
ui->est526->setMaximumHeight( m7traild3 );
ui->est526->setMaxLength(15);
ui->est526->setFrame(globalFrame);

ui->est527->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "52    ") );
ui->est527->setReadOnly(true);
ui->est527->setAlignment(Qt::AlignRight);
ui->est527->setMaximumWidth( m14trail);
ui->est527->setMinimumWidth( m9trail);
ui->est527->setMaximumHeight( m7traild3 );
ui->est527->setMaxLength(15);
ui->est527->setFrame(globalFrame);

ui->lib531->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "53    ") );
connect( ui->lib531, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib531, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib53, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst53, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib531->installEventFilter(this);
ui->lib531->setMaximumWidth( m6trail);
ui->lib531->setMinimumWidth( m6trail);
ui->lib531->setMaximumHeight( m7traild3 );
ui->lib531->setMaxLength(3);
ui->lib531->setFrame(globalFrame);

ui->lib532->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "53    ") );
connect( ui->lib532, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib532, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib532->installEventFilter(this);
ui->lib532->setMaximumWidth( m26trail);
ui->lib532->setMinimumWidth( m25trail);
ui->lib532->setMaximumHeight( m7traild3 );
ui->lib532->setMaxLength(24);
ui->lib532->setFrame(globalFrame);

ui->lib533->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "53    ") );
connect( ui->lib533, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib533, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib533->installEventFilter(this);
ui->lib533->setAlignment(Qt::AlignCenter);
ui->lib533->setMaximumWidth( m12trail);
ui->lib533->setMinimumWidth( m6trail);
ui->lib533->setMaximumHeight( m7traild3 );
ui->lib533->setMaxLength(11);
ui->lib533->setFrame(globalFrame);

ui->lib534->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "53    ") );
connect( ui->lib534, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib534, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib534->installEventFilter(this);
ui->lib534->setAlignment(Qt::AlignCenter);
ui->lib534->setMaximumWidth( m12trail);
ui->lib534->setMinimumWidth( m6trail);
ui->lib534->setMaximumHeight( m7traild3 );
ui->lib534->setMaxLength(11);
ui->lib534->setFrame(globalFrame);

ui->pushButtonEst53->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "53    ") );
ui->pushButtonEst53->setMaximumWidth( m7traild3 );
ui->pushButtonEst53->setMaximumHeight( m7traild3 );
ui->pushButtonLib53->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "53    ") );
ui->pushButtonLib53->setMaximumWidth( m7traild3 );
ui->pushButtonLib53->setMaximumHeight( m7traild3 );

ui->est531->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "53    ") );
connect( ui->est531, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est531, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est531->installEventFilter(this);
ui->est531->setMaximumWidth( m6trail);
ui->est531->setMinimumWidth( m6trail);
ui->est531->setMaximumHeight( m7traild3 );
ui->est531->setMaxLength(3);
ui->est531->setFrame(globalFrame);

ui->est532->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "53    ") );
connect( ui->est532, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est532, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est532->installEventFilter(this);
ui->est532->setMaximumWidth( m26trail);
ui->est532->setMinimumWidth( m25trail);
ui->est532->setMaximumHeight( m7traild3 );
ui->est532->setMaxLength(24);
ui->est532->setFrame(globalFrame);

ui->est533->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "53    ") );
connect( ui->est533, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est533, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est533->installEventFilter(this);
ui->est533->setAlignment(Qt::AlignCenter);
ui->est533->setMaximumWidth( m11trail);
ui->est533->setMinimumWidth( m6trail);
ui->est533->setMaximumHeight( m7traild3 );
ui->est533->setMaxLength(8);
ui->est533->setFrame(globalFrame);

ui->est534->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "53    ") );
connect( ui->est534, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est534, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est534->installEventFilter(this);
ui->est534->setAlignment(Qt::AlignCenter);
ui->est534->setMaximumWidth( m12trail);
ui->est534->setMinimumWidth( m6trail);
ui->est534->setMaximumHeight( m7traild3 );
ui->est534->setMaxLength(11);
ui->est534->setFrame(globalFrame);

ui->est535->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "53    ") );
connect( ui->est535, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est535, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est535->installEventFilter(this);
ui->est535->setAlignment(Qt::AlignCenter);
ui->est535->setMaximumWidth( m12trail);
ui->est535->setMinimumWidth( m6trail);
ui->est535->setMaximumHeight( m7traild3 );
ui->est535->setMaxLength(11);
ui->est535->setFrame(globalFrame);

ui->est536->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "53    ") );
ui->est536->setReadOnly(true);
ui->est536->setAlignment(Qt::AlignRight);
ui->est536->setMaximumWidth( m14trail);
ui->est536->setMinimumWidth( m9trail);
ui->est536->setMaximumHeight( m7traild3 );
ui->est536->setMaxLength(15);
ui->est536->setFrame(globalFrame);

ui->est537->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "53    ") );
ui->est537->setReadOnly(true);
ui->est537->setAlignment(Qt::AlignRight);
ui->est537->setMaximumWidth( m14trail);
ui->est537->setMinimumWidth( m9trail);
ui->est537->setMaximumHeight( m7traild3 );
ui->est537->setMaxLength(15);
ui->est537->setFrame(globalFrame);

ui->lib541->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "54    ") );
connect( ui->lib541, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib541, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib54, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst54, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib541->installEventFilter(this);
ui->lib541->setMaximumWidth( m6trail);
ui->lib541->setMinimumWidth( m6trail);
ui->lib541->setMaximumHeight( m7traild3 );
ui->lib541->setMaxLength(3);
ui->lib541->setFrame(globalFrame);

ui->lib542->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "54    ") );
connect( ui->lib542, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib542, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib542->installEventFilter(this);
ui->lib542->setMaximumWidth( m26trail);
ui->lib542->setMinimumWidth( m25trail);
ui->lib542->setMaximumHeight( m7traild3 );
ui->lib542->setMaxLength(24);
ui->lib542->setFrame(globalFrame);

ui->lib543->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "54    ") );
connect( ui->lib543, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib543, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib543->installEventFilter(this);
ui->lib543->setAlignment(Qt::AlignCenter);
ui->lib543->setMaximumWidth( m12trail);
ui->lib543->setMinimumWidth( m6trail);
ui->lib543->setMaximumHeight( m7traild3 );
ui->lib543->setMaxLength(11);
ui->lib543->setFrame(globalFrame);

ui->lib544->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "54    ") );
connect( ui->lib544, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib544, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib544->installEventFilter(this);
ui->lib544->setAlignment(Qt::AlignCenter);
ui->lib544->setMaximumWidth( m12trail);
ui->lib544->setMinimumWidth( m6trail);
ui->lib544->setMaximumHeight( m7traild3 );
ui->lib544->setMaxLength(11);
ui->lib544->setFrame(globalFrame);

ui->pushButtonEst54->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "54    ") );
ui->pushButtonEst54->setMaximumWidth( m7traild3 );
ui->pushButtonEst54->setMaximumHeight( m7traild3 );
ui->pushButtonLib54->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "54    ") );
ui->pushButtonLib54->setMaximumWidth( m7traild3 );
ui->pushButtonLib54->setMaximumHeight( m7traild3 );

ui->est541->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "54    ") );
connect( ui->est541, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est541, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est541->installEventFilter(this);
ui->est541->setMaximumWidth( m6trail);
ui->est541->setMinimumWidth( m6trail);
ui->est541->setMaximumHeight( m7traild3 );
ui->est541->setMaxLength(3);
ui->est541->setFrame(globalFrame);

ui->est542->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "54    ") );
connect( ui->est542, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est542, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est542->installEventFilter(this);
ui->est542->setMaximumWidth( m26trail);
ui->est542->setMinimumWidth( m25trail);
ui->est542->setMaximumHeight( m7traild3 );
ui->est542->setMaxLength(24);
ui->est542->setFrame(globalFrame);

ui->est543->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "54    ") );
connect( ui->est543, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est543, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est543->installEventFilter(this);
ui->est543->setAlignment(Qt::AlignCenter);
ui->est543->setMaximumWidth( m11trail);
ui->est543->setMinimumWidth( m6trail);
ui->est543->setMaximumHeight( m7traild3 );
ui->est543->setMaxLength(8);
ui->est543->setFrame(globalFrame);

ui->est544->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "54    ") );
connect( ui->est544, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est544, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est544->installEventFilter(this);
ui->est544->setAlignment(Qt::AlignCenter);
ui->est544->setMaximumWidth( m12trail);
ui->est544->setMinimumWidth( m6trail);
ui->est544->setMaximumHeight( m7traild3 );
ui->est544->setMaxLength(11);
ui->est544->setFrame(globalFrame);

ui->est545->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "54    ") );
connect( ui->est545, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est545, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est545->installEventFilter(this);
ui->est545->setAlignment(Qt::AlignCenter);
ui->est545->setMaximumWidth( m12trail);
ui->est545->setMinimumWidth( m6trail);
ui->est545->setMaximumHeight( m7traild3 );
ui->est545->setMaxLength(11);
ui->est545->setFrame(globalFrame);

ui->est546->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "54    ") );
ui->est546->setReadOnly(true);
ui->est546->setAlignment(Qt::AlignRight);
ui->est546->setMaximumWidth( m14trail);
ui->est546->setMinimumWidth( m9trail);
ui->est546->setMaximumHeight( m7traild3 );
ui->est546->setMaxLength(15);
ui->est546->setFrame(globalFrame);

ui->est547->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "54    ") );
ui->est547->setReadOnly(true);
ui->est547->setAlignment(Qt::AlignRight);
ui->est547->setMaximumWidth( m14trail);
ui->est547->setMinimumWidth( m9trail);
ui->est547->setMaximumHeight( m7traild3 );
ui->est547->setMaxLength(15);
ui->est547->setFrame(globalFrame);

ui->lib551->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "55    ") );
connect( ui->lib551, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib551, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib55, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst55, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib551->installEventFilter(this);
ui->lib551->setMaximumWidth( m6trail);
ui->lib551->setMinimumWidth( m6trail);
ui->lib551->setMaximumHeight( m7traild3 );
ui->lib551->setMaxLength(3);
ui->lib551->setFrame(globalFrame);

ui->lib552->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "55    ") );
connect( ui->lib552, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib552, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib552->installEventFilter(this);
ui->lib552->setMaximumWidth( m26trail);
ui->lib552->setMinimumWidth( m25trail);
ui->lib552->setMaximumHeight( m7traild3 );
ui->lib552->setMaxLength(24);
ui->lib552->setFrame(globalFrame);

ui->lib553->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "55    ") );
connect( ui->lib553, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib553, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib553->installEventFilter(this);
ui->lib553->setAlignment(Qt::AlignCenter);
ui->lib553->setMaximumWidth( m12trail);
ui->lib553->setMinimumWidth( m6trail);
ui->lib553->setMaximumHeight( m7traild3 );
ui->lib553->setMaxLength(11);
ui->lib553->setFrame(globalFrame);

ui->lib554->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "55    ") );
connect( ui->lib554, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib554, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib554->installEventFilter(this);
ui->lib554->setAlignment(Qt::AlignCenter);
ui->lib554->setMaximumWidth( m12trail);
ui->lib554->setMinimumWidth( m6trail);
ui->lib554->setMaximumHeight( m7traild3 );
ui->lib554->setMaxLength(11);
ui->lib554->setFrame(globalFrame);

ui->pushButtonEst55->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "55    ") );
ui->pushButtonEst55->setMaximumWidth( m7traild3 );
ui->pushButtonEst55->setMaximumHeight( m7traild3 );
ui->pushButtonLib55->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "55    ") );
ui->pushButtonLib55->setMaximumWidth( m7traild3 );
ui->pushButtonLib55->setMaximumHeight( m7traild3 );

ui->est551->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "55    ") );
connect( ui->est551, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est551, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est551->installEventFilter(this);
ui->est551->setMaximumWidth( m6trail);
ui->est551->setMinimumWidth( m6trail);
ui->est551->setMaximumHeight( m7traild3 );
ui->est551->setMaxLength(3);
ui->est551->setFrame(globalFrame);

ui->est552->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "55    ") );
connect( ui->est552, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est552, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est552->installEventFilter(this);
ui->est552->setMaximumWidth( m26trail);
ui->est552->setMinimumWidth( m25trail);
ui->est552->setMaximumHeight( m7traild3 );
ui->est552->setMaxLength(24);
ui->est552->setFrame(globalFrame);

ui->est553->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "55    ") );
connect( ui->est553, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est553, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est553->installEventFilter(this);
ui->est553->setAlignment(Qt::AlignCenter);
ui->est553->setMaximumWidth( m11trail);
ui->est553->setMinimumWidth( m6trail);
ui->est553->setMaximumHeight( m7traild3 );
ui->est553->setMaxLength(8);
ui->est553->setFrame(globalFrame);

ui->est554->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "55    ") );
connect( ui->est554, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est554, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est554->installEventFilter(this);
ui->est554->setAlignment(Qt::AlignCenter);
ui->est554->setMaximumWidth( m12trail);
ui->est554->setMinimumWidth( m6trail);
ui->est554->setMaximumHeight( m7traild3 );
ui->est554->setMaxLength(11);
ui->est554->setFrame(globalFrame);

ui->est555->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "55    ") );
connect( ui->est555, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est555, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est555->installEventFilter(this);
ui->est555->setAlignment(Qt::AlignCenter);
ui->est555->setMaximumWidth( m12trail);
ui->est555->setMinimumWidth( m6trail);
ui->est555->setMaximumHeight( m7traild3 );
ui->est555->setMaxLength(11);
ui->est555->setFrame(globalFrame);

ui->est556->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "55    ") );
ui->est556->setReadOnly(true);
ui->est556->setAlignment(Qt::AlignRight);
ui->est556->setMaximumWidth( m14trail);
ui->est556->setMinimumWidth( m9trail);
ui->est556->setMaximumHeight( m7traild3 );
ui->est556->setMaxLength(15);
ui->est556->setFrame(globalFrame);

ui->est557->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "55    ") );
ui->est557->setReadOnly(true);
ui->est557->setAlignment(Qt::AlignRight);
ui->est557->setMaximumWidth( m14trail);
ui->est557->setMinimumWidth( m9trail);
ui->est557->setMaximumHeight( m7traild3 );
ui->est557->setMaxLength(15);
ui->est557->setFrame(globalFrame);

ui->lib561->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "56    ") );
connect( ui->lib561, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib561, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib56, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst56, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib561->installEventFilter(this);
ui->lib561->setMaximumWidth( m6trail);
ui->lib561->setMinimumWidth( m6trail);
ui->lib561->setMaximumHeight( m7traild3 );
ui->lib561->setMaxLength(3);
ui->lib561->setFrame(globalFrame);

ui->lib562->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "56    ") );
connect( ui->lib562, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib562, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib562->installEventFilter(this);
ui->lib562->setMaximumWidth( m26trail);
ui->lib562->setMinimumWidth( m25trail);
ui->lib562->setMaximumHeight( m7traild3 );
ui->lib562->setMaxLength(24);
ui->lib562->setFrame(globalFrame);

ui->lib563->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "56    ") );
connect( ui->lib563, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib563, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib563->installEventFilter(this);
ui->lib563->setAlignment(Qt::AlignCenter);
ui->lib563->setMaximumWidth( m12trail);
ui->lib563->setMinimumWidth( m6trail);
ui->lib563->setMaximumHeight( m7traild3 );
ui->lib563->setMaxLength(11);
ui->lib563->setFrame(globalFrame);

ui->lib564->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "56    ") );
connect( ui->lib564, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib564, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib564->installEventFilter(this);
ui->lib564->setAlignment(Qt::AlignCenter);
ui->lib564->setMaximumWidth( m12trail);
ui->lib564->setMinimumWidth( m6trail);
ui->lib564->setMaximumHeight( m7traild3 );
ui->lib564->setMaxLength(11);
ui->lib564->setFrame(globalFrame);

ui->pushButtonEst56->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "56    ") );
ui->pushButtonEst56->setMaximumWidth( m7traild3 );
ui->pushButtonEst56->setMaximumHeight( m7traild3 );
ui->pushButtonLib56->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "56    ") );
ui->pushButtonLib56->setMaximumWidth( m7traild3 );
ui->pushButtonLib56->setMaximumHeight( m7traild3 );

ui->est561->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "56    ") );
connect( ui->est561, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est561, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est561->installEventFilter(this);
ui->est561->setMaximumWidth( m6trail);
ui->est561->setMinimumWidth( m6trail);
ui->est561->setMaximumHeight( m7traild3 );
ui->est561->setMaxLength(3);
ui->est561->setFrame(globalFrame);

ui->est562->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "56    ") );
connect( ui->est562, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est562, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est562->installEventFilter(this);
ui->est562->setMaximumWidth( m26trail);
ui->est562->setMinimumWidth( m25trail);
ui->est562->setMaximumHeight( m7traild3 );
ui->est562->setMaxLength(24);
ui->est562->setFrame(globalFrame);

ui->est563->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "56    ") );
connect( ui->est563, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est563, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est563->installEventFilter(this);
ui->est563->setAlignment(Qt::AlignCenter);
ui->est563->setMaximumWidth( m11trail);
ui->est563->setMinimumWidth( m6trail);
ui->est563->setMaximumHeight( m7traild3 );
ui->est563->setMaxLength(8);
ui->est563->setFrame(globalFrame);

ui->est564->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "56    ") );
connect( ui->est564, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est564, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est564->installEventFilter(this);
ui->est564->setAlignment(Qt::AlignCenter);
ui->est564->setMaximumWidth( m12trail);
ui->est564->setMinimumWidth( m6trail);
ui->est564->setMaximumHeight( m7traild3 );
ui->est564->setMaxLength(11);
ui->est564->setFrame(globalFrame);

ui->est565->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "56    ") );
connect( ui->est565, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est565, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est565->installEventFilter(this);
ui->est565->setAlignment(Qt::AlignCenter);
ui->est565->setMaximumWidth( m12trail);
ui->est565->setMinimumWidth( m6trail);
ui->est565->setMaximumHeight( m7traild3 );
ui->est565->setMaxLength(11);
ui->est565->setFrame(globalFrame);

ui->est566->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "56    ") );
ui->est566->setReadOnly(true);
ui->est566->setAlignment(Qt::AlignRight);
ui->est566->setMaximumWidth( m14trail);
ui->est566->setMinimumWidth( m9trail);
ui->est566->setMaximumHeight( m7traild3 );
ui->est566->setMaxLength(15);
ui->est566->setFrame(globalFrame);

ui->est567->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "56    ") );
ui->est567->setReadOnly(true);
ui->est567->setAlignment(Qt::AlignRight);
ui->est567->setMaximumWidth( m14trail);
ui->est567->setMinimumWidth( m9trail);
ui->est567->setMaximumHeight( m7traild3 );
ui->est567->setMaxLength(15);
ui->est567->setFrame(globalFrame);

ui->lib571->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "57    ") );
connect( ui->lib571, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib571, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib57, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst57, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib571->installEventFilter(this);
ui->lib571->setMaximumWidth( m6trail);
ui->lib571->setMinimumWidth( m6trail);
ui->lib571->setMaximumHeight( m7traild3 );
ui->lib571->setMaxLength(3);
ui->lib571->setFrame(globalFrame);

ui->lib572->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "57    ") );
connect( ui->lib572, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib572, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib572->installEventFilter(this);
ui->lib572->setMaximumWidth( m26trail);
ui->lib572->setMinimumWidth( m25trail);
ui->lib572->setMaximumHeight( m7traild3 );
ui->lib572->setMaxLength(24);
ui->lib572->setFrame(globalFrame);

ui->lib573->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "57    ") );
connect( ui->lib573, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib573, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib573->installEventFilter(this);
ui->lib573->setAlignment(Qt::AlignCenter);
ui->lib573->setMaximumWidth( m12trail);
ui->lib573->setMinimumWidth( m6trail);
ui->lib573->setMaximumHeight( m7traild3 );
ui->lib573->setMaxLength(11);
ui->lib573->setFrame(globalFrame);

ui->lib574->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "57    ") );
connect( ui->lib574, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib574, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib574->installEventFilter(this);
ui->lib574->setAlignment(Qt::AlignCenter);
ui->lib574->setMaximumWidth( m12trail);
ui->lib574->setMinimumWidth( m6trail);
ui->lib574->setMaximumHeight( m7traild3 );
ui->lib574->setMaxLength(11);
ui->lib574->setFrame(globalFrame);

ui->pushButtonEst57->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "57    ") );
ui->pushButtonEst57->setMaximumWidth( m7traild3 );
ui->pushButtonEst57->setMaximumHeight( m7traild3 );
ui->pushButtonLib57->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "57    ") );
ui->pushButtonLib57->setMaximumWidth( m7traild3 );
ui->pushButtonLib57->setMaximumHeight( m7traild3 );

ui->est571->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "57    ") );
connect( ui->est571, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est571, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est571->installEventFilter(this);
ui->est571->setMaximumWidth( m6trail);
ui->est571->setMinimumWidth( m6trail);
ui->est571->setMaximumHeight( m7traild3 );
ui->est571->setMaxLength(3);
ui->est571->setFrame(globalFrame);

ui->est572->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "57    ") );
connect( ui->est572, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est572, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est572->installEventFilter(this);
ui->est572->setMaximumWidth( m26trail);
ui->est572->setMinimumWidth( m25trail);
ui->est572->setMaximumHeight( m7traild3 );
ui->est572->setMaxLength(24);
ui->est572->setFrame(globalFrame);

ui->est573->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "57    ") );
connect( ui->est573, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est573, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est573->installEventFilter(this);
ui->est573->setAlignment(Qt::AlignCenter);
ui->est573->setMaximumWidth( m11trail);
ui->est573->setMinimumWidth( m6trail);
ui->est573->setMaximumHeight( m7traild3 );
ui->est573->setMaxLength(8);
ui->est573->setFrame(globalFrame);

ui->est574->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "57    ") );
connect( ui->est574, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est574, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est574->installEventFilter(this);
ui->est574->setAlignment(Qt::AlignCenter);
ui->est574->setMaximumWidth( m12trail);
ui->est574->setMinimumWidth( m6trail);
ui->est574->setMaximumHeight( m7traild3 );
ui->est574->setMaxLength(11);
ui->est574->setFrame(globalFrame);

ui->est575->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "57    ") );
connect( ui->est575, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est575, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est575->installEventFilter(this);
ui->est575->setAlignment(Qt::AlignCenter);
ui->est575->setMaximumWidth( m12trail);
ui->est575->setMinimumWidth( m6trail);
ui->est575->setMaximumHeight( m7traild3 );
ui->est575->setMaxLength(11);
ui->est575->setFrame(globalFrame);

ui->est576->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "57    ") );
ui->est576->setReadOnly(true);
ui->est576->setAlignment(Qt::AlignRight);
ui->est576->setMaximumWidth( m14trail);
ui->est576->setMinimumWidth( m9trail);
ui->est576->setMaximumHeight( m7traild3 );
ui->est576->setMaxLength(15);
ui->est576->setFrame(globalFrame);

ui->est577->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "57    ") );
ui->est577->setReadOnly(true);
ui->est577->setAlignment(Qt::AlignRight);
ui->est577->setMaximumWidth( m14trail);
ui->est577->setMinimumWidth( m9trail);
ui->est577->setMaximumHeight( m7traild3 );
ui->est577->setMaxLength(15);
ui->est577->setFrame(globalFrame);

ui->lib581->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "58    ") );
connect( ui->lib581, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib581, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib58, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst58, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib581->installEventFilter(this);
ui->lib581->setMaximumWidth( m6trail);
ui->lib581->setMinimumWidth( m6trail);
ui->lib581->setMaximumHeight( m7traild3 );
ui->lib581->setMaxLength(3);
ui->lib581->setFrame(globalFrame);

ui->lib582->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "58    ") );
connect( ui->lib582, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib582, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib582->installEventFilter(this);
ui->lib582->setMaximumWidth( m26trail);
ui->lib582->setMinimumWidth( m25trail);
ui->lib582->setMaximumHeight( m7traild3 );
ui->lib582->setMaxLength(24);
ui->lib582->setFrame(globalFrame);

ui->lib583->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "58    ") );
connect( ui->lib583, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib583, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib583->installEventFilter(this);
ui->lib583->setAlignment(Qt::AlignCenter);
ui->lib583->setMaximumWidth( m12trail);
ui->lib583->setMinimumWidth( m6trail);
ui->lib583->setMaximumHeight( m7traild3 );
ui->lib583->setMaxLength(11);
ui->lib583->setFrame(globalFrame);

ui->lib584->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "58    ") );
connect( ui->lib584, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib584, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib584->installEventFilter(this);
ui->lib584->setAlignment(Qt::AlignCenter);
ui->lib584->setMaximumWidth( m12trail);
ui->lib584->setMinimumWidth( m6trail);
ui->lib584->setMaximumHeight( m7traild3 );
ui->lib584->setMaxLength(11);
ui->lib584->setFrame(globalFrame);

ui->pushButtonEst58->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "58    ") );
ui->pushButtonEst58->setMaximumWidth( m7traild3 );
ui->pushButtonEst58->setMaximumHeight( m7traild3 );
ui->pushButtonLib58->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "58    ") );
ui->pushButtonLib58->setMaximumWidth( m7traild3 );
ui->pushButtonLib58->setMaximumHeight( m7traild3 );

ui->est581->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "58    ") );
connect( ui->est581, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est581, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est581->installEventFilter(this);
ui->est581->setMaximumWidth( m6trail);
ui->est581->setMinimumWidth( m6trail);
ui->est581->setMaximumHeight( m7traild3 );
ui->est581->setMaxLength(3);
ui->est581->setFrame(globalFrame);

ui->est582->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "58    ") );
connect( ui->est582, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est582, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est582->installEventFilter(this);
ui->est582->setMaximumWidth( m26trail);
ui->est582->setMinimumWidth( m25trail);
ui->est582->setMaximumHeight( m7traild3 );
ui->est582->setMaxLength(24);
ui->est582->setFrame(globalFrame);

ui->est583->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "58    ") );
connect( ui->est583, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est583, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est583->installEventFilter(this);
ui->est583->setAlignment(Qt::AlignCenter);
ui->est583->setMaximumWidth( m11trail);
ui->est583->setMinimumWidth( m6trail);
ui->est583->setMaximumHeight( m7traild3 );
ui->est583->setMaxLength(8);
ui->est583->setFrame(globalFrame);

ui->est584->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "58    ") );
connect( ui->est584, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est584, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est584->installEventFilter(this);
ui->est584->setAlignment(Qt::AlignCenter);
ui->est584->setMaximumWidth( m12trail);
ui->est584->setMinimumWidth( m6trail);
ui->est584->setMaximumHeight( m7traild3 );
ui->est584->setMaxLength(11);
ui->est584->setFrame(globalFrame);

ui->est585->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "58    ") );
connect( ui->est585, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est585, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est585->installEventFilter(this);
ui->est585->setAlignment(Qt::AlignCenter);
ui->est585->setMaximumWidth( m12trail);
ui->est585->setMinimumWidth( m6trail);
ui->est585->setMaximumHeight( m7traild3 );
ui->est585->setMaxLength(11);
ui->est585->setFrame(globalFrame);

ui->est586->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "58    ") );
ui->est586->setReadOnly(true);
ui->est586->setAlignment(Qt::AlignRight);
ui->est586->setMaximumWidth( m14trail);
ui->est586->setMinimumWidth( m9trail);
ui->est586->setMaximumHeight( m7traild3 );
ui->est586->setMaxLength(15);
ui->est586->setFrame(globalFrame);

ui->est587->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "58    ") );
ui->est587->setReadOnly(true);
ui->est587->setAlignment(Qt::AlignRight);
ui->est587->setMaximumWidth( m14trail);
ui->est587->setMinimumWidth( m9trail);
ui->est587->setMaximumHeight( m7traild3 );
ui->est587->setMaxLength(15);
ui->est587->setFrame(globalFrame);

ui->lib591->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "59    ") );
connect( ui->lib591, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib591, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib59, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst59, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib591->installEventFilter(this);
ui->lib591->setMaximumWidth( m6trail);
ui->lib591->setMinimumWidth( m6trail);
ui->lib591->setMaximumHeight( m7traild3 );
ui->lib591->setMaxLength(3);
ui->lib591->setFrame(globalFrame);

ui->lib592->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "59    ") );
connect( ui->lib592, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib592, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib592->installEventFilter(this);
ui->lib592->setMaximumWidth( m26trail);
ui->lib592->setMinimumWidth( m25trail);
ui->lib592->setMaximumHeight( m7traild3 );
ui->lib592->setMaxLength(24);
ui->lib592->setFrame(globalFrame);

ui->lib593->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "59    ") );
connect( ui->lib593, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib593, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib593->installEventFilter(this);
ui->lib593->setAlignment(Qt::AlignCenter);
ui->lib593->setMaximumWidth( m12trail);
ui->lib593->setMinimumWidth( m6trail);
ui->lib593->setMaximumHeight( m7traild3 );
ui->lib593->setMaxLength(11);
ui->lib593->setFrame(globalFrame);

ui->lib594->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "59    ") );
connect( ui->lib594, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib594, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib594->installEventFilter(this);
ui->lib594->setAlignment(Qt::AlignCenter);
ui->lib594->setMaximumWidth( m12trail);
ui->lib594->setMinimumWidth( m6trail);
ui->lib594->setMaximumHeight( m7traild3 );
ui->lib594->setMaxLength(11);
ui->lib594->setFrame(globalFrame);

ui->pushButtonEst59->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "59    ") );
ui->pushButtonEst59->setMaximumWidth( m7traild3 );
ui->pushButtonEst59->setMaximumHeight( m7traild3 );
ui->pushButtonLib59->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "59    ") );
ui->pushButtonLib59->setMaximumWidth( m7traild3 );
ui->pushButtonLib59->setMaximumHeight( m7traild3 );

ui->est591->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "59    ") );
connect( ui->est591, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est591, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est591->installEventFilter(this);
ui->est591->setMaximumWidth( m6trail);
ui->est591->setMinimumWidth( m6trail);
ui->est591->setMaximumHeight( m7traild3 );
ui->est591->setMaxLength(3);
ui->est591->setFrame(globalFrame);

ui->est592->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "59    ") );
connect( ui->est592, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est592, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est592->installEventFilter(this);
ui->est592->setMaximumWidth( m26trail);
ui->est592->setMinimumWidth( m25trail);
ui->est592->setMaximumHeight( m7traild3 );
ui->est592->setMaxLength(24);
ui->est592->setFrame(globalFrame);

ui->est593->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "59    ") );
connect( ui->est593, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est593, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est593->installEventFilter(this);
ui->est593->setAlignment(Qt::AlignCenter);
ui->est593->setMaximumWidth( m11trail);
ui->est593->setMinimumWidth( m6trail);
ui->est593->setMaximumHeight( m7traild3 );
ui->est593->setMaxLength(8);
ui->est593->setFrame(globalFrame);

ui->est594->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "59    ") );
connect( ui->est594, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est594, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est594->installEventFilter(this);
ui->est594->setAlignment(Qt::AlignCenter);
ui->est594->setMaximumWidth( m12trail);
ui->est594->setMinimumWidth( m6trail);
ui->est594->setMaximumHeight( m7traild3 );
ui->est594->setMaxLength(11);
ui->est594->setFrame(globalFrame);

ui->est595->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "59    ") );
connect( ui->est595, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est595, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est595->installEventFilter(this);
ui->est595->setAlignment(Qt::AlignCenter);
ui->est595->setMaximumWidth( m12trail);
ui->est595->setMinimumWidth( m6trail);
ui->est595->setMaximumHeight( m7traild3 );
ui->est595->setMaxLength(11);
ui->est595->setFrame(globalFrame);

ui->est596->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "59    ") );
ui->est596->setReadOnly(true);
ui->est596->setAlignment(Qt::AlignRight);
ui->est596->setMaximumWidth( m14trail);
ui->est596->setMinimumWidth( m9trail);
ui->est596->setMaximumHeight( m7traild3 );
ui->est596->setMaxLength(15);
ui->est596->setFrame(globalFrame);

ui->est597->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "59    ") );
ui->est597->setReadOnly(true);
ui->est597->setAlignment(Qt::AlignRight);
ui->est597->setMaximumWidth( m14trail);
ui->est597->setMinimumWidth( m9trail);
ui->est597->setMaximumHeight( m7traild3 );
ui->est597->setMaxLength(15);
ui->est597->setFrame(globalFrame);

ui->lib601->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "60    ") );
connect( ui->lib601, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib601, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib60, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst60, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib601->installEventFilter(this);
ui->lib601->setMaximumWidth( m6trail);
ui->lib601->setMinimumWidth( m6trail);
ui->lib601->setMaximumHeight( m7traild3 );
ui->lib601->setMaxLength(3);
ui->lib601->setFrame(globalFrame);

ui->lib602->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "60    ") );
connect( ui->lib602, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib602, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib602->installEventFilter(this);
ui->lib602->setMaximumWidth( m26trail);
ui->lib602->setMinimumWidth( m25trail);
ui->lib602->setMaximumHeight( m7traild3 );
ui->lib602->setMaxLength(24);
ui->lib602->setFrame(globalFrame);

ui->lib603->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "60    ") );
connect( ui->lib603, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib603, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib603->installEventFilter(this);
ui->lib603->setAlignment(Qt::AlignCenter);
ui->lib603->setMaximumWidth( m12trail);
ui->lib603->setMinimumWidth( m6trail);
ui->lib603->setMaximumHeight( m7traild3 );
ui->lib603->setMaxLength(11);
ui->lib603->setFrame(globalFrame);

ui->lib604->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "60    ") );
connect( ui->lib604, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib604, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib604->installEventFilter(this);
ui->lib604->setAlignment(Qt::AlignCenter);
ui->lib604->setMaximumWidth( m12trail);
ui->lib604->setMinimumWidth( m6trail);
ui->lib604->setMaximumHeight( m7traild3 );
ui->lib604->setMaxLength(11);
ui->lib604->setFrame(globalFrame);

ui->pushButtonEst60->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "60    ") );
ui->pushButtonEst60->setMaximumWidth( m7traild3 );
ui->pushButtonEst60->setMaximumHeight( m7traild3 );
ui->pushButtonLib60->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "60    ") );
ui->pushButtonLib60->setMaximumWidth( m7traild3 );
ui->pushButtonLib60->setMaximumHeight( m7traild3 );

ui->est601->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "60    ") );
connect( ui->est601, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est601, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est601->installEventFilter(this);
ui->est601->setMaximumWidth( m6trail);
ui->est601->setMinimumWidth( m6trail);
ui->est601->setMaximumHeight( m7traild3 );
ui->est601->setMaxLength(3);
ui->est601->setFrame(globalFrame);

ui->est602->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "60    ") );
connect( ui->est602, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est602, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est602->installEventFilter(this);
ui->est602->setMaximumWidth( m26trail);
ui->est602->setMinimumWidth( m25trail);
ui->est602->setMaximumHeight( m7traild3 );
ui->est602->setMaxLength(24);
ui->est602->setFrame(globalFrame);

ui->est603->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "60    ") );
connect( ui->est603, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est603, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est603->installEventFilter(this);
ui->est603->setAlignment(Qt::AlignCenter);
ui->est603->setMaximumWidth( m11trail);
ui->est603->setMinimumWidth( m6trail);
ui->est603->setMaximumHeight( m7traild3 );
ui->est603->setMaxLength(8);
ui->est603->setFrame(globalFrame);

ui->est604->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "60    ") );
connect( ui->est604, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est604, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est604->installEventFilter(this);
ui->est604->setAlignment(Qt::AlignCenter);
ui->est604->setMaximumWidth( m12trail);
ui->est604->setMinimumWidth( m6trail);
ui->est604->setMaximumHeight( m7traild3 );
ui->est604->setMaxLength(11);
ui->est604->setFrame(globalFrame);

ui->est605->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "60    ") );
connect( ui->est605, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est605, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est605->installEventFilter(this);
ui->est605->setAlignment(Qt::AlignCenter);
ui->est605->setMaximumWidth( m12trail);
ui->est605->setMinimumWidth( m6trail);
ui->est605->setMaximumHeight( m7traild3 );
ui->est605->setMaxLength(11);
ui->est605->setFrame(globalFrame);

ui->est606->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "60    ") );
ui->est606->setReadOnly(true);
ui->est606->setAlignment(Qt::AlignRight);
ui->est606->setMaximumWidth( m14trail);
ui->est606->setMinimumWidth( m9trail);
ui->est606->setMaximumHeight( m7traild3 );
ui->est606->setMaxLength(15);
ui->est606->setFrame(globalFrame);

ui->est607->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "60    ") );
ui->est607->setReadOnly(true);
ui->est607->setAlignment(Qt::AlignRight);
ui->est607->setMaximumWidth( m14trail);
ui->est607->setMinimumWidth( m9trail);
ui->est607->setMaximumHeight( m7traild3 );
ui->est607->setMaxLength(15);
ui->est607->setFrame(globalFrame);

ui->lib611->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "61    ") );
connect( ui->lib611, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib611, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib61, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst61, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib611->installEventFilter(this);
ui->lib611->setMaximumWidth( m6trail);
ui->lib611->setMinimumWidth( m6trail);
ui->lib611->setMaximumHeight( m7traild3 );
ui->lib611->setMaxLength(3);
ui->lib611->setFrame(globalFrame);

ui->lib612->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "61    ") );
connect( ui->lib612, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib612, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib612->installEventFilter(this);
ui->lib612->setMaximumWidth( m26trail);
ui->lib612->setMinimumWidth( m25trail);
ui->lib612->setMaximumHeight( m7traild3 );
ui->lib612->setMaxLength(24);
ui->lib612->setFrame(globalFrame);

ui->lib613->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "61    ") );
connect( ui->lib613, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib613, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib613->installEventFilter(this);
ui->lib613->setAlignment(Qt::AlignCenter);
ui->lib613->setMaximumWidth( m12trail);
ui->lib613->setMinimumWidth( m6trail);
ui->lib613->setMaximumHeight( m7traild3 );
ui->lib613->setMaxLength(11);
ui->lib613->setFrame(globalFrame);

ui->lib614->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "61    ") );
connect( ui->lib614, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib614, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib614->installEventFilter(this);
ui->lib614->setAlignment(Qt::AlignCenter);
ui->lib614->setMaximumWidth( m12trail);
ui->lib614->setMinimumWidth( m6trail);
ui->lib614->setMaximumHeight( m7traild3 );
ui->lib614->setMaxLength(11);
ui->lib614->setFrame(globalFrame);

ui->pushButtonEst61->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "61    ") );
ui->pushButtonEst61->setMaximumWidth( m7traild3 );
ui->pushButtonEst61->setMaximumHeight( m7traild3 );
ui->pushButtonLib61->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "61    ") );
ui->pushButtonLib61->setMaximumWidth( m7traild3 );
ui->pushButtonLib61->setMaximumHeight( m7traild3 );

ui->est611->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "61    ") );
connect( ui->est611, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est611, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est611->installEventFilter(this);
ui->est611->setMaximumWidth( m6trail);
ui->est611->setMinimumWidth( m6trail);
ui->est611->setMaximumHeight( m7traild3 );
ui->est611->setMaxLength(3);
ui->est611->setFrame(globalFrame);

ui->est612->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "61    ") );
connect( ui->est612, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est612, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est612->installEventFilter(this);
ui->est612->setMaximumWidth( m26trail);
ui->est612->setMinimumWidth( m25trail);
ui->est612->setMaximumHeight( m7traild3 );
ui->est612->setMaxLength(24);
ui->est612->setFrame(globalFrame);

ui->est613->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "61    ") );
connect( ui->est613, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est613, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est613->installEventFilter(this);
ui->est613->setAlignment(Qt::AlignCenter);
ui->est613->setMaximumWidth( m11trail);
ui->est613->setMinimumWidth( m6trail);
ui->est613->setMaximumHeight( m7traild3 );
ui->est613->setMaxLength(8);
ui->est613->setFrame(globalFrame);

ui->est614->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "61    ") );
connect( ui->est614, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est614, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est614->installEventFilter(this);
ui->est614->setAlignment(Qt::AlignCenter);
ui->est614->setMaximumWidth( m12trail);
ui->est614->setMinimumWidth( m6trail);
ui->est614->setMaximumHeight( m7traild3 );
ui->est614->setMaxLength(11);
ui->est614->setFrame(globalFrame);

ui->est615->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "61    ") );
connect( ui->est615, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est615, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est615->installEventFilter(this);
ui->est615->setAlignment(Qt::AlignCenter);
ui->est615->setMaximumWidth( m12trail);
ui->est615->setMinimumWidth( m6trail);
ui->est615->setMaximumHeight( m7traild3 );
ui->est615->setMaxLength(11);
ui->est615->setFrame(globalFrame);

ui->est616->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "61    ") );
ui->est616->setReadOnly(true);
ui->est616->setAlignment(Qt::AlignRight);
ui->est616->setMaximumWidth( m14trail);
ui->est616->setMinimumWidth( m9trail);
ui->est616->setMaximumHeight( m7traild3 );
ui->est616->setMaxLength(15);
ui->est616->setFrame(globalFrame);

ui->est617->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "61    ") );
ui->est617->setReadOnly(true);
ui->est617->setAlignment(Qt::AlignRight);
ui->est617->setMaximumWidth( m14trail);
ui->est617->setMinimumWidth( m9trail);
ui->est617->setMaximumHeight( m7traild3 );
ui->est617->setMaxLength(15);
ui->est617->setFrame(globalFrame);

ui->lib621->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "62    ") );
connect( ui->lib621, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib621, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib62, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst62, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib621->installEventFilter(this);
ui->lib621->setMaximumWidth( m6trail);
ui->lib621->setMinimumWidth( m6trail);
ui->lib621->setMaximumHeight( m7traild3 );
ui->lib621->setMaxLength(3);
ui->lib621->setFrame(globalFrame);

ui->lib622->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "62    ") );
connect( ui->lib622, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib622, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib622->installEventFilter(this);
ui->lib622->setMaximumWidth( m26trail);
ui->lib622->setMinimumWidth( m25trail);
ui->lib622->setMaximumHeight( m7traild3 );
ui->lib622->setMaxLength(24);
ui->lib622->setFrame(globalFrame);

ui->lib623->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "62    ") );
connect( ui->lib623, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib623, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib623->installEventFilter(this);
ui->lib623->setAlignment(Qt::AlignCenter);
ui->lib623->setMaximumWidth( m12trail);
ui->lib623->setMinimumWidth( m6trail);
ui->lib623->setMaximumHeight( m7traild3 );
ui->lib623->setMaxLength(11);
ui->lib623->setFrame(globalFrame);

ui->lib624->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "62    ") );
connect( ui->lib624, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib624, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib624->installEventFilter(this);
ui->lib624->setAlignment(Qt::AlignCenter);
ui->lib624->setMaximumWidth( m12trail);
ui->lib624->setMinimumWidth( m6trail);
ui->lib624->setMaximumHeight( m7traild3 );
ui->lib624->setMaxLength(11);
ui->lib624->setFrame(globalFrame);

ui->pushButtonEst62->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "62    ") );
ui->pushButtonEst62->setMaximumWidth( m7traild3 );
ui->pushButtonEst62->setMaximumHeight( m7traild3 );
ui->pushButtonLib62->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "62    ") );
ui->pushButtonLib62->setMaximumWidth( m7traild3 );
ui->pushButtonLib62->setMaximumHeight( m7traild3 );

ui->est621->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "62    ") );
connect( ui->est621, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est621, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est621->installEventFilter(this);
ui->est621->setMaximumWidth( m6trail);
ui->est621->setMinimumWidth( m6trail);
ui->est621->setMaximumHeight( m7traild3 );
ui->est621->setMaxLength(3);
ui->est621->setFrame(globalFrame);

ui->est622->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "62    ") );
connect( ui->est622, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est622, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est622->installEventFilter(this);
ui->est622->setMaximumWidth( m26trail);
ui->est622->setMinimumWidth( m25trail);
ui->est622->setMaximumHeight( m7traild3 );
ui->est622->setMaxLength(24);
ui->est622->setFrame(globalFrame);

ui->est623->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "62    ") );
connect( ui->est623, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est623, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est623->installEventFilter(this);
ui->est623->setAlignment(Qt::AlignCenter);
ui->est623->setMaximumWidth( m11trail);
ui->est623->setMinimumWidth( m6trail);
ui->est623->setMaximumHeight( m7traild3 );
ui->est623->setMaxLength(8);
ui->est623->setFrame(globalFrame);

ui->est624->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "62    ") );
connect( ui->est624, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est624, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est624->installEventFilter(this);
ui->est624->setAlignment(Qt::AlignCenter);
ui->est624->setMaximumWidth( m12trail);
ui->est624->setMinimumWidth( m6trail);
ui->est624->setMaximumHeight( m7traild3 );
ui->est624->setMaxLength(11);
ui->est624->setFrame(globalFrame);

ui->est625->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "62    ") );
connect( ui->est625, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est625, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est625->installEventFilter(this);
ui->est625->setAlignment(Qt::AlignCenter);
ui->est625->setMaximumWidth( m12trail);
ui->est625->setMinimumWidth( m6trail);
ui->est625->setMaximumHeight( m7traild3 );
ui->est625->setMaxLength(11);
ui->est625->setFrame(globalFrame);

ui->est626->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "62    ") );
ui->est626->setReadOnly(true);
ui->est626->setAlignment(Qt::AlignRight);
ui->est626->setMaximumWidth( m14trail);
ui->est626->setMinimumWidth( m9trail);
ui->est626->setMaximumHeight( m7traild3 );
ui->est626->setMaxLength(15);
ui->est626->setFrame(globalFrame);

ui->est627->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "62    ") );
ui->est627->setReadOnly(true);
ui->est627->setAlignment(Qt::AlignRight);
ui->est627->setMaximumWidth( m14trail);
ui->est627->setMinimumWidth( m9trail);
ui->est627->setMaximumHeight( m7traild3 );
ui->est627->setMaxLength(15);
ui->est627->setFrame(globalFrame);

ui->lib631->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "63    ") );
connect( ui->lib631, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib631, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib63, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst63, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib631->installEventFilter(this);
ui->lib631->setMaximumWidth( m6trail);
ui->lib631->setMinimumWidth( m6trail);
ui->lib631->setMaximumHeight( m7traild3 );
ui->lib631->setMaxLength(3);
ui->lib631->setFrame(globalFrame);

ui->lib632->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "63    ") );
connect( ui->lib632, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib632, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib632->installEventFilter(this);
ui->lib632->setMaximumWidth( m26trail);
ui->lib632->setMinimumWidth( m25trail);
ui->lib632->setMaximumHeight( m7traild3 );
ui->lib632->setMaxLength(24);
ui->lib632->setFrame(globalFrame);

ui->lib633->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "63    ") );
connect( ui->lib633, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib633, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib633->installEventFilter(this);
ui->lib633->setAlignment(Qt::AlignCenter);
ui->lib633->setMaximumWidth( m12trail);
ui->lib633->setMinimumWidth( m6trail);
ui->lib633->setMaximumHeight( m7traild3 );
ui->lib633->setMaxLength(11);
ui->lib633->setFrame(globalFrame);

ui->lib634->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "63    ") );
connect( ui->lib634, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib634, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib634->installEventFilter(this);
ui->lib634->setAlignment(Qt::AlignCenter);
ui->lib634->setMaximumWidth( m12trail);
ui->lib634->setMinimumWidth( m6trail);
ui->lib634->setMaximumHeight( m7traild3 );
ui->lib634->setMaxLength(11);
ui->lib634->setFrame(globalFrame);

ui->pushButtonEst63->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "63    ") );
ui->pushButtonEst63->setMaximumWidth( m7traild3 );
ui->pushButtonEst63->setMaximumHeight( m7traild3 );
ui->pushButtonLib63->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "63    ") );
ui->pushButtonLib63->setMaximumWidth( m7traild3 );
ui->pushButtonLib63->setMaximumHeight( m7traild3 );

ui->est631->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "63    ") );
connect( ui->est631, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est631, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est631->installEventFilter(this);
ui->est631->setMaximumWidth( m6trail);
ui->est631->setMinimumWidth( m6trail);
ui->est631->setMaximumHeight( m7traild3 );
ui->est631->setMaxLength(3);
ui->est631->setFrame(globalFrame);

ui->est632->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "63    ") );
connect( ui->est632, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est632, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est632->installEventFilter(this);
ui->est632->setMaximumWidth( m26trail);
ui->est632->setMinimumWidth( m25trail);
ui->est632->setMaximumHeight( m7traild3 );
ui->est632->setMaxLength(24);
ui->est632->setFrame(globalFrame);

ui->est633->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "63    ") );
connect( ui->est633, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est633, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est633->installEventFilter(this);
ui->est633->setAlignment(Qt::AlignCenter);
ui->est633->setMaximumWidth( m11trail);
ui->est633->setMinimumWidth( m6trail);
ui->est633->setMaximumHeight( m7traild3 );
ui->est633->setMaxLength(8);
ui->est633->setFrame(globalFrame);

ui->est634->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "63    ") );
connect( ui->est634, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est634, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est634->installEventFilter(this);
ui->est634->setAlignment(Qt::AlignCenter);
ui->est634->setMaximumWidth( m12trail);
ui->est634->setMinimumWidth( m6trail);
ui->est634->setMaximumHeight( m7traild3 );
ui->est634->setMaxLength(11);
ui->est634->setFrame(globalFrame);

ui->est635->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "63    ") );
connect( ui->est635, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est635, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est635->installEventFilter(this);
ui->est635->setAlignment(Qt::AlignCenter);
ui->est635->setMaximumWidth( m12trail);
ui->est635->setMinimumWidth( m6trail);
ui->est635->setMaximumHeight( m7traild3 );
ui->est635->setMaxLength(11);
ui->est635->setFrame(globalFrame);

ui->est636->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "63    ") );
ui->est636->setReadOnly(true);
ui->est636->setAlignment(Qt::AlignRight);
ui->est636->setMaximumWidth( m14trail);
ui->est636->setMinimumWidth( m9trail);
ui->est636->setMaximumHeight( m7traild3 );
ui->est636->setMaxLength(15);
ui->est636->setFrame(globalFrame);

ui->est637->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "63    ") );
ui->est637->setReadOnly(true);
ui->est637->setAlignment(Qt::AlignRight);
ui->est637->setMaximumWidth( m14trail);
ui->est637->setMinimumWidth( m9trail);
ui->est637->setMaximumHeight( m7traild3 );
ui->est637->setMaxLength(15);
ui->est637->setFrame(globalFrame);

ui->lib641->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "64    ") );
connect( ui->lib641, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib641, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib64, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst64, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib641->installEventFilter(this);
ui->lib641->setMaximumWidth( m6trail);
ui->lib641->setMinimumWidth( m6trail);
ui->lib641->setMaximumHeight( m7traild3 );
ui->lib641->setMaxLength(3);
ui->lib641->setFrame(globalFrame);

ui->lib642->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "64    ") );
connect( ui->lib642, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib642, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib642->installEventFilter(this);
ui->lib642->setMaximumWidth( m26trail);
ui->lib642->setMinimumWidth( m25trail);
ui->lib642->setMaximumHeight( m7traild3 );
ui->lib642->setMaxLength(24);
ui->lib642->setFrame(globalFrame);

ui->lib643->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "64    ") );
connect( ui->lib643, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib643, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib643->installEventFilter(this);
ui->lib643->setAlignment(Qt::AlignCenter);
ui->lib643->setMaximumWidth( m12trail);
ui->lib643->setMinimumWidth( m6trail);
ui->lib643->setMaximumHeight( m7traild3 );
ui->lib643->setMaxLength(11);
ui->lib643->setFrame(globalFrame);

ui->lib644->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "64    ") );
connect( ui->lib644, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib644, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib644->installEventFilter(this);
ui->lib644->setAlignment(Qt::AlignCenter);
ui->lib644->setMaximumWidth( m12trail);
ui->lib644->setMinimumWidth( m6trail);
ui->lib644->setMaximumHeight( m7traild3 );
ui->lib644->setMaxLength(11);
ui->lib644->setFrame(globalFrame);

ui->pushButtonEst64->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "64    ") );
ui->pushButtonEst64->setMaximumWidth( m7traild3 );
ui->pushButtonEst64->setMaximumHeight( m7traild3 );
ui->pushButtonLib64->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "64    ") );
ui->pushButtonLib64->setMaximumWidth( m7traild3 );
ui->pushButtonLib64->setMaximumHeight( m7traild3 );

ui->est641->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "64    ") );
connect( ui->est641, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est641, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est641->installEventFilter(this);
ui->est641->setMaximumWidth( m6trail);
ui->est641->setMinimumWidth( m6trail);
ui->est641->setMaximumHeight( m7traild3 );
ui->est641->setMaxLength(3);
ui->est641->setFrame(globalFrame);

ui->est642->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "64    ") );
connect( ui->est642, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est642, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est642->installEventFilter(this);
ui->est642->setMaximumWidth( m26trail);
ui->est642->setMinimumWidth( m25trail);
ui->est642->setMaximumHeight( m7traild3 );
ui->est642->setMaxLength(24);
ui->est642->setFrame(globalFrame);

ui->est643->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "64    ") );
connect( ui->est643, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est643, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est643->installEventFilter(this);
ui->est643->setAlignment(Qt::AlignCenter);
ui->est643->setMaximumWidth( m11trail);
ui->est643->setMinimumWidth( m6trail);
ui->est643->setMaximumHeight( m7traild3 );
ui->est643->setMaxLength(8);
ui->est643->setFrame(globalFrame);

ui->est644->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "64    ") );
connect( ui->est644, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est644, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est644->installEventFilter(this);
ui->est644->setAlignment(Qt::AlignCenter);
ui->est644->setMaximumWidth( m12trail);
ui->est644->setMinimumWidth( m6trail);
ui->est644->setMaximumHeight( m7traild3 );
ui->est644->setMaxLength(11);
ui->est644->setFrame(globalFrame);

ui->est645->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "64    ") );
connect( ui->est645, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est645, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est645->installEventFilter(this);
ui->est645->setAlignment(Qt::AlignCenter);
ui->est645->setMaximumWidth( m12trail);
ui->est645->setMinimumWidth( m6trail);
ui->est645->setMaximumHeight( m7traild3 );
ui->est645->setMaxLength(11);
ui->est645->setFrame(globalFrame);

ui->est646->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "64    ") );
ui->est646->setReadOnly(true);
ui->est646->setAlignment(Qt::AlignRight);
ui->est646->setMaximumWidth( m14trail);
ui->est646->setMinimumWidth( m9trail);
ui->est646->setMaximumHeight( m7traild3 );
ui->est646->setMaxLength(15);
ui->est646->setFrame(globalFrame);

ui->est647->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "64    ") );
ui->est647->setReadOnly(true);
ui->est647->setAlignment(Qt::AlignRight);
ui->est647->setMaximumWidth( m14trail);
ui->est647->setMinimumWidth( m9trail);
ui->est647->setMaximumHeight( m7traild3 );
ui->est647->setMaxLength(15);
ui->est647->setFrame(globalFrame);

ui->lib651->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "65    ") );
connect( ui->lib651, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib651, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib65, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst65, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib651->installEventFilter(this);
ui->lib651->setMaximumWidth( m6trail);
ui->lib651->setMinimumWidth( m6trail);
ui->lib651->setMaximumHeight( m7traild3 );
ui->lib651->setMaxLength(3);
ui->lib651->setFrame(globalFrame);

ui->lib652->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "65    ") );
connect( ui->lib652, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib652, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib652->installEventFilter(this);
ui->lib652->setMaximumWidth( m26trail);
ui->lib652->setMinimumWidth( m25trail);
ui->lib652->setMaximumHeight( m7traild3 );
ui->lib652->setMaxLength(24);
ui->lib652->setFrame(globalFrame);

ui->lib653->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "65    ") );
connect( ui->lib653, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib653, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib653->installEventFilter(this);
ui->lib653->setAlignment(Qt::AlignCenter);
ui->lib653->setMaximumWidth( m12trail);
ui->lib653->setMinimumWidth( m6trail);
ui->lib653->setMaximumHeight( m7traild3 );
ui->lib653->setMaxLength(11);
ui->lib653->setFrame(globalFrame);

ui->lib654->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "65    ") );
connect( ui->lib654, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib654, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib654->installEventFilter(this);
ui->lib654->setAlignment(Qt::AlignCenter);
ui->lib654->setMaximumWidth( m12trail);
ui->lib654->setMinimumWidth( m6trail);
ui->lib654->setMaximumHeight( m7traild3 );
ui->lib654->setMaxLength(11);
ui->lib654->setFrame(globalFrame);

ui->pushButtonEst65->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "65    ") );
ui->pushButtonEst65->setMaximumWidth( m7traild3 );
ui->pushButtonEst65->setMaximumHeight( m7traild3 );
ui->pushButtonLib65->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "65    ") );
ui->pushButtonLib65->setMaximumWidth( m7traild3 );
ui->pushButtonLib65->setMaximumHeight( m7traild3 );

ui->est651->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "65    ") );
connect( ui->est651, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est651, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est651->installEventFilter(this);
ui->est651->setMaximumWidth( m6trail);
ui->est651->setMinimumWidth( m6trail);
ui->est651->setMaximumHeight( m7traild3 );
ui->est651->setMaxLength(3);
ui->est651->setFrame(globalFrame);

ui->est652->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "65    ") );
connect( ui->est652, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est652, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est652->installEventFilter(this);
ui->est652->setMaximumWidth( m26trail);
ui->est652->setMinimumWidth( m25trail);
ui->est652->setMaximumHeight( m7traild3 );
ui->est652->setMaxLength(24);
ui->est652->setFrame(globalFrame);

ui->est653->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "65    ") );
connect( ui->est653, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est653, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est653->installEventFilter(this);
ui->est653->setAlignment(Qt::AlignCenter);
ui->est653->setMaximumWidth( m11trail);
ui->est653->setMinimumWidth( m6trail);
ui->est653->setMaximumHeight( m7traild3 );
ui->est653->setMaxLength(8);
ui->est653->setFrame(globalFrame);

ui->est654->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "65    ") );
connect( ui->est654, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est654, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est654->installEventFilter(this);
ui->est654->setAlignment(Qt::AlignCenter);
ui->est654->setMaximumWidth( m12trail);
ui->est654->setMinimumWidth( m6trail);
ui->est654->setMaximumHeight( m7traild3 );
ui->est654->setMaxLength(11);
ui->est654->setFrame(globalFrame);

ui->est655->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "65    ") );
connect( ui->est655, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est655, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est655->installEventFilter(this);
ui->est655->setAlignment(Qt::AlignCenter);
ui->est655->setMaximumWidth( m12trail);
ui->est655->setMinimumWidth( m6trail);
ui->est655->setMaximumHeight( m7traild3 );
ui->est655->setMaxLength(11);
ui->est655->setFrame(globalFrame);

ui->est656->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "65    ") );
ui->est656->setReadOnly(true);
ui->est656->setAlignment(Qt::AlignRight);
ui->est656->setMaximumWidth( m14trail);
ui->est656->setMinimumWidth( m9trail);
ui->est656->setMaximumHeight( m7traild3 );
ui->est656->setMaxLength(15);
ui->est656->setFrame(globalFrame);

ui->est657->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "65    ") );
ui->est657->setReadOnly(true);
ui->est657->setAlignment(Qt::AlignRight);
ui->est657->setMaximumWidth( m14trail);
ui->est657->setMinimumWidth( m9trail);
ui->est657->setMaximumHeight( m7traild3 );
ui->est657->setMaxLength(15);
ui->est657->setFrame(globalFrame);

ui->lib661->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "66    ") );
connect( ui->lib661, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib661, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib66, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst66, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib661->installEventFilter(this);
ui->lib661->setMaximumWidth( m6trail);
ui->lib661->setMinimumWidth( m6trail);
ui->lib661->setMaximumHeight( m7traild3 );
ui->lib661->setMaxLength(3);
ui->lib661->setFrame(globalFrame);

ui->lib662->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "66    ") );
connect( ui->lib662, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib662, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib662->installEventFilter(this);
ui->lib662->setMaximumWidth( m26trail);
ui->lib662->setMinimumWidth( m25trail);
ui->lib662->setMaximumHeight( m7traild3 );
ui->lib662->setMaxLength(24);
ui->lib662->setFrame(globalFrame);

ui->lib663->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "66    ") );
connect( ui->lib663, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib663, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib663->installEventFilter(this);
ui->lib663->setAlignment(Qt::AlignCenter);
ui->lib663->setMaximumWidth( m12trail);
ui->lib663->setMinimumWidth( m6trail);
ui->lib663->setMaximumHeight( m7traild3 );
ui->lib663->setMaxLength(11);
ui->lib663->setFrame(globalFrame);

ui->lib664->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "66    ") );
connect( ui->lib664, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib664, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib664->installEventFilter(this);
ui->lib664->setAlignment(Qt::AlignCenter);
ui->lib664->setMaximumWidth( m12trail);
ui->lib664->setMinimumWidth( m6trail);
ui->lib664->setMaximumHeight( m7traild3 );
ui->lib664->setMaxLength(11);
ui->lib664->setFrame(globalFrame);

ui->pushButtonEst66->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "66    ") );
ui->pushButtonEst66->setMaximumWidth( m7traild3 );
ui->pushButtonEst66->setMaximumHeight( m7traild3 );
ui->pushButtonLib66->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "66    ") );
ui->pushButtonLib66->setMaximumWidth( m7traild3 );
ui->pushButtonLib66->setMaximumHeight( m7traild3 );

ui->est661->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "66    ") );
connect( ui->est661, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est661, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est661->installEventFilter(this);
ui->est661->setMaximumWidth( m6trail);
ui->est661->setMinimumWidth( m6trail);
ui->est661->setMaximumHeight( m7traild3 );
ui->est661->setMaxLength(3);
ui->est661->setFrame(globalFrame);

ui->est662->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "66    ") );
connect( ui->est662, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est662, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est662->installEventFilter(this);
ui->est662->setMaximumWidth( m26trail);
ui->est662->setMinimumWidth( m25trail);
ui->est662->setMaximumHeight( m7traild3 );
ui->est662->setMaxLength(24);
ui->est662->setFrame(globalFrame);

ui->est663->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "66    ") );
connect( ui->est663, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est663, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est663->installEventFilter(this);
ui->est663->setAlignment(Qt::AlignCenter);
ui->est663->setMaximumWidth( m11trail);
ui->est663->setMinimumWidth( m6trail);
ui->est663->setMaximumHeight( m7traild3 );
ui->est663->setMaxLength(8);
ui->est663->setFrame(globalFrame);

ui->est664->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "66    ") );
connect( ui->est664, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est664, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est664->installEventFilter(this);
ui->est664->setAlignment(Qt::AlignCenter);
ui->est664->setMaximumWidth( m12trail);
ui->est664->setMinimumWidth( m6trail);
ui->est664->setMaximumHeight( m7traild3 );
ui->est664->setMaxLength(11);
ui->est664->setFrame(globalFrame);

ui->est665->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "66    ") );
connect( ui->est665, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est665, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est665->installEventFilter(this);
ui->est665->setAlignment(Qt::AlignCenter);
ui->est665->setMaximumWidth( m12trail);
ui->est665->setMinimumWidth( m6trail);
ui->est665->setMaximumHeight( m7traild3 );
ui->est665->setMaxLength(11);
ui->est665->setFrame(globalFrame);

ui->est666->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "66    ") );
ui->est666->setReadOnly(true);
ui->est666->setAlignment(Qt::AlignRight);
ui->est666->setMaximumWidth( m14trail);
ui->est666->setMinimumWidth( m9trail);
ui->est666->setMaximumHeight( m7traild3 );
ui->est666->setMaxLength(15);
ui->est666->setFrame(globalFrame);

ui->est667->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "66    ") );
ui->est667->setReadOnly(true);
ui->est667->setAlignment(Qt::AlignRight);
ui->est667->setMaximumWidth( m14trail);
ui->est667->setMinimumWidth( m9trail);
ui->est667->setMaximumHeight( m7traild3 );
ui->est667->setMaxLength(15);
ui->est667->setFrame(globalFrame);

ui->lib671->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "67    ") );
connect( ui->lib671, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib671, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib67, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst67, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib671->installEventFilter(this);
ui->lib671->setMaximumWidth( m6trail);
ui->lib671->setMinimumWidth( m6trail);
ui->lib671->setMaximumHeight( m7traild3 );
ui->lib671->setMaxLength(3);
ui->lib671->setFrame(globalFrame);

ui->lib672->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "67    ") );
connect( ui->lib672, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib672, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib672->installEventFilter(this);
ui->lib672->setMaximumWidth( m26trail);
ui->lib672->setMinimumWidth( m25trail);
ui->lib672->setMaximumHeight( m7traild3 );
ui->lib672->setMaxLength(24);
ui->lib672->setFrame(globalFrame);

ui->lib673->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "67    ") );
connect( ui->lib673, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib673, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib673->installEventFilter(this);
ui->lib673->setAlignment(Qt::AlignCenter);
ui->lib673->setMaximumWidth( m12trail);
ui->lib673->setMinimumWidth( m6trail);
ui->lib673->setMaximumHeight( m7traild3 );
ui->lib673->setMaxLength(11);
ui->lib673->setFrame(globalFrame);

ui->lib674->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "67    ") );
connect( ui->lib674, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib674, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib674->installEventFilter(this);
ui->lib674->setAlignment(Qt::AlignCenter);
ui->lib674->setMaximumWidth( m12trail);
ui->lib674->setMinimumWidth( m6trail);
ui->lib674->setMaximumHeight( m7traild3 );
ui->lib674->setMaxLength(11);
ui->lib674->setFrame(globalFrame);

ui->pushButtonEst67->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "67    ") );
ui->pushButtonEst67->setMaximumWidth( m7traild3 );
ui->pushButtonEst67->setMaximumHeight( m7traild3 );
ui->pushButtonLib67->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "67    ") );
ui->pushButtonLib67->setMaximumWidth( m7traild3 );
ui->pushButtonLib67->setMaximumHeight( m7traild3 );

ui->est671->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "67    ") );
connect( ui->est671, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est671, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est671->installEventFilter(this);
ui->est671->setMaximumWidth( m6trail);
ui->est671->setMinimumWidth( m6trail);
ui->est671->setMaximumHeight( m7traild3 );
ui->est671->setMaxLength(3);
ui->est671->setFrame(globalFrame);

ui->est672->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "67    ") );
connect( ui->est672, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est672, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est672->installEventFilter(this);
ui->est672->setMaximumWidth( m26trail);
ui->est672->setMinimumWidth( m25trail);
ui->est672->setMaximumHeight( m7traild3 );
ui->est672->setMaxLength(24);
ui->est672->setFrame(globalFrame);

ui->est673->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "67    ") );
connect( ui->est673, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est673, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est673->installEventFilter(this);
ui->est673->setAlignment(Qt::AlignCenter);
ui->est673->setMaximumWidth( m11trail);
ui->est673->setMinimumWidth( m6trail);
ui->est673->setMaximumHeight( m7traild3 );
ui->est673->setMaxLength(8);
ui->est673->setFrame(globalFrame);

ui->est674->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "67    ") );
connect( ui->est674, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est674, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est674->installEventFilter(this);
ui->est674->setAlignment(Qt::AlignCenter);
ui->est674->setMaximumWidth( m12trail);
ui->est674->setMinimumWidth( m6trail);
ui->est674->setMaximumHeight( m7traild3 );
ui->est674->setMaxLength(11);
ui->est674->setFrame(globalFrame);

ui->est675->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "67    ") );
connect( ui->est675, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est675, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est675->installEventFilter(this);
ui->est675->setAlignment(Qt::AlignCenter);
ui->est675->setMaximumWidth( m12trail);
ui->est675->setMinimumWidth( m6trail);
ui->est675->setMaximumHeight( m7traild3 );
ui->est675->setMaxLength(11);
ui->est675->setFrame(globalFrame);

ui->est676->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "67    ") );
ui->est676->setReadOnly(true);
ui->est676->setAlignment(Qt::AlignRight);
ui->est676->setMaximumWidth( m14trail);
ui->est676->setMinimumWidth( m9trail);
ui->est676->setMaximumHeight( m7traild3 );
ui->est676->setMaxLength(15);
ui->est676->setFrame(globalFrame);

ui->est677->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "67    ") );
ui->est677->setReadOnly(true);
ui->est677->setAlignment(Qt::AlignRight);
ui->est677->setMaximumWidth( m14trail);
ui->est677->setMinimumWidth( m9trail);
ui->est677->setMaximumHeight( m7traild3 );
ui->est677->setMaxLength(15);
ui->est677->setFrame(globalFrame);

ui->lib681->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "68    ") );
connect( ui->lib681, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib681, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib68, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst68, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib681->installEventFilter(this);
ui->lib681->setMaximumWidth( m6trail);
ui->lib681->setMinimumWidth( m6trail);
ui->lib681->setMaximumHeight( m7traild3 );
ui->lib681->setMaxLength(3);
ui->lib681->setFrame(globalFrame);

ui->lib682->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "68    ") );
connect( ui->lib682, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib682, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib682->installEventFilter(this);
ui->lib682->setMaximumWidth( m26trail);
ui->lib682->setMinimumWidth( m25trail);
ui->lib682->setMaximumHeight( m7traild3 );
ui->lib682->setMaxLength(24);
ui->lib682->setFrame(globalFrame);

ui->lib683->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "68    ") );
connect( ui->lib683, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib683, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib683->installEventFilter(this);
ui->lib683->setAlignment(Qt::AlignCenter);
ui->lib683->setMaximumWidth( m12trail);
ui->lib683->setMinimumWidth( m6trail);
ui->lib683->setMaximumHeight( m7traild3 );
ui->lib683->setMaxLength(11);
ui->lib683->setFrame(globalFrame);

ui->lib684->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "68    ") );
connect( ui->lib684, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib684, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib684->installEventFilter(this);
ui->lib684->setAlignment(Qt::AlignCenter);
ui->lib684->setMaximumWidth( m12trail);
ui->lib684->setMinimumWidth( m6trail);
ui->lib684->setMaximumHeight( m7traild3 );
ui->lib684->setMaxLength(11);
ui->lib684->setFrame(globalFrame);

ui->pushButtonEst68->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "68    ") );
ui->pushButtonEst68->setMaximumWidth( m7traild3 );
ui->pushButtonEst68->setMaximumHeight( m7traild3 );
ui->pushButtonLib68->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "68    ") );
ui->pushButtonLib68->setMaximumWidth( m7traild3 );
ui->pushButtonLib68->setMaximumHeight( m7traild3 );

ui->est681->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "68    ") );
connect( ui->est681, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est681, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est681->installEventFilter(this);
ui->est681->setMaximumWidth( m6trail);
ui->est681->setMinimumWidth( m6trail);
ui->est681->setMaximumHeight( m7traild3 );
ui->est681->setMaxLength(3);
ui->est681->setFrame(globalFrame);

ui->est682->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "68    ") );
connect( ui->est682, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est682, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est682->installEventFilter(this);
ui->est682->setMaximumWidth( m26trail);
ui->est682->setMinimumWidth( m25trail);
ui->est682->setMaximumHeight( m7traild3 );
ui->est682->setMaxLength(24);
ui->est682->setFrame(globalFrame);

ui->est683->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "68    ") );
connect( ui->est683, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est683, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est683->installEventFilter(this);
ui->est683->setAlignment(Qt::AlignCenter);
ui->est683->setMaximumWidth( m11trail);
ui->est683->setMinimumWidth( m6trail);
ui->est683->setMaximumHeight( m7traild3 );
ui->est683->setMaxLength(8);
ui->est683->setFrame(globalFrame);

ui->est684->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "68    ") );
connect( ui->est684, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est684, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est684->installEventFilter(this);
ui->est684->setAlignment(Qt::AlignCenter);
ui->est684->setMaximumWidth( m12trail);
ui->est684->setMinimumWidth( m6trail);
ui->est684->setMaximumHeight( m7traild3 );
ui->est684->setMaxLength(11);
ui->est684->setFrame(globalFrame);

ui->est685->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "68    ") );
connect( ui->est685, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est685, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est685->installEventFilter(this);
ui->est685->setAlignment(Qt::AlignCenter);
ui->est685->setMaximumWidth( m12trail);
ui->est685->setMinimumWidth( m6trail);
ui->est685->setMaximumHeight( m7traild3 );
ui->est685->setMaxLength(11);
ui->est685->setFrame(globalFrame);

ui->est686->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "68    ") );
ui->est686->setReadOnly(true);
ui->est686->setAlignment(Qt::AlignRight);
ui->est686->setMaximumWidth( m14trail);
ui->est686->setMinimumWidth( m9trail);
ui->est686->setMaximumHeight( m7traild3 );
ui->est686->setMaxLength(15);
ui->est686->setFrame(globalFrame);

ui->est687->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "68    ") );
ui->est687->setReadOnly(true);
ui->est687->setAlignment(Qt::AlignRight);
ui->est687->setMaximumWidth( m14trail);
ui->est687->setMinimumWidth( m9trail);
ui->est687->setMaximumHeight( m7traild3 );
ui->est687->setMaxLength(15);
ui->est687->setFrame(globalFrame);

ui->lib691->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "69    ") );
connect( ui->lib691, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib691, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib69, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst69, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib691->installEventFilter(this);
ui->lib691->setMaximumWidth( m6trail);
ui->lib691->setMinimumWidth( m6trail);
ui->lib691->setMaximumHeight( m7traild3 );
ui->lib691->setMaxLength(3);
ui->lib691->setFrame(globalFrame);

ui->lib692->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "69    ") );
connect( ui->lib692, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib692, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib692->installEventFilter(this);
ui->lib692->setMaximumWidth( m26trail);
ui->lib692->setMinimumWidth( m25trail);
ui->lib692->setMaximumHeight( m7traild3 );
ui->lib692->setMaxLength(24);
ui->lib692->setFrame(globalFrame);

ui->lib693->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "69    ") );
connect( ui->lib693, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib693, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib693->installEventFilter(this);
ui->lib693->setAlignment(Qt::AlignCenter);
ui->lib693->setMaximumWidth( m12trail);
ui->lib693->setMinimumWidth( m6trail);
ui->lib693->setMaximumHeight( m7traild3 );
ui->lib693->setMaxLength(11);
ui->lib693->setFrame(globalFrame);

ui->lib694->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "69    ") );
connect( ui->lib694, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib694, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib694->installEventFilter(this);
ui->lib694->setAlignment(Qt::AlignCenter);
ui->lib694->setMaximumWidth( m12trail);
ui->lib694->setMinimumWidth( m6trail);
ui->lib694->setMaximumHeight( m7traild3 );
ui->lib694->setMaxLength(11);
ui->lib694->setFrame(globalFrame);

ui->pushButtonEst69->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "69    ") );
ui->pushButtonEst69->setMaximumWidth( m7traild3 );
ui->pushButtonEst69->setMaximumHeight( m7traild3 );
ui->pushButtonLib69->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "69    ") );
ui->pushButtonLib69->setMaximumWidth( m7traild3 );
ui->pushButtonLib69->setMaximumHeight( m7traild3 );

ui->est691->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "69    ") );
connect( ui->est691, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est691, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est691->installEventFilter(this);
ui->est691->setMaximumWidth( m6trail);
ui->est691->setMinimumWidth( m6trail);
ui->est691->setMaximumHeight( m7traild3 );
ui->est691->setMaxLength(3);
ui->est691->setFrame(globalFrame);

ui->est692->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "69    ") );
connect( ui->est692, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est692, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est692->installEventFilter(this);
ui->est692->setMaximumWidth( m26trail);
ui->est692->setMinimumWidth( m25trail);
ui->est692->setMaximumHeight( m7traild3 );
ui->est692->setMaxLength(24);
ui->est692->setFrame(globalFrame);

ui->est693->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "69    ") );
connect( ui->est693, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est693, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est693->installEventFilter(this);
ui->est693->setAlignment(Qt::AlignCenter);
ui->est693->setMaximumWidth( m11trail);
ui->est693->setMinimumWidth( m6trail);
ui->est693->setMaximumHeight( m7traild3 );
ui->est693->setMaxLength(8);
ui->est693->setFrame(globalFrame);

ui->est694->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "69    ") );
connect( ui->est694, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est694, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est694->installEventFilter(this);
ui->est694->setAlignment(Qt::AlignCenter);
ui->est694->setMaximumWidth( m12trail);
ui->est694->setMinimumWidth( m6trail);
ui->est694->setMaximumHeight( m7traild3 );
ui->est694->setMaxLength(11);
ui->est694->setFrame(globalFrame);

ui->est695->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "69    ") );
connect( ui->est695, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est695, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est695->installEventFilter(this);
ui->est695->setAlignment(Qt::AlignCenter);
ui->est695->setMaximumWidth( m12trail);
ui->est695->setMinimumWidth( m6trail);
ui->est695->setMaximumHeight( m7traild3 );
ui->est695->setMaxLength(11);
ui->est695->setFrame(globalFrame);

ui->est696->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "69    ") );
ui->est696->setReadOnly(true);
ui->est696->setAlignment(Qt::AlignRight);
ui->est696->setMaximumWidth( m14trail);
ui->est696->setMinimumWidth( m9trail);
ui->est696->setMaximumHeight( m7traild3 );
ui->est696->setMaxLength(15);
ui->est696->setFrame(globalFrame);

ui->est697->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "69    ") );
ui->est697->setReadOnly(true);
ui->est697->setAlignment(Qt::AlignRight);
ui->est697->setMaximumWidth( m14trail);
ui->est697->setMinimumWidth( m9trail);
ui->est697->setMaximumHeight( m7traild3 );
ui->est697->setMaxLength(15);
ui->est697->setFrame(globalFrame);

ui->lib701->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "70    ") );
connect( ui->lib701, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib701, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib70, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst70, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib701->installEventFilter(this);
ui->lib701->setMaximumWidth( m6trail);
ui->lib701->setMinimumWidth( m6trail);
ui->lib701->setMaximumHeight( m7traild3 );
ui->lib701->setMaxLength(3);
ui->lib701->setFrame(globalFrame);

ui->lib702->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "70    ") );
connect( ui->lib702, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib702, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib702->installEventFilter(this);
ui->lib702->setMaximumWidth( m26trail);
ui->lib702->setMinimumWidth( m25trail);
ui->lib702->setMaximumHeight( m7traild3 );
ui->lib702->setMaxLength(24);
ui->lib702->setFrame(globalFrame);

ui->lib703->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "70    ") );
connect( ui->lib703, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib703, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib703->installEventFilter(this);
ui->lib703->setAlignment(Qt::AlignCenter);
ui->lib703->setMaximumWidth( m12trail);
ui->lib703->setMinimumWidth( m6trail);
ui->lib703->setMaximumHeight( m7traild3 );
ui->lib703->setMaxLength(11);
ui->lib703->setFrame(globalFrame);

ui->lib704->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "70    ") );
connect( ui->lib704, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib704, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib704->installEventFilter(this);
ui->lib704->setAlignment(Qt::AlignCenter);
ui->lib704->setMaximumWidth( m12trail);
ui->lib704->setMinimumWidth( m6trail);
ui->lib704->setMaximumHeight( m7traild3 );
ui->lib704->setMaxLength(11);
ui->lib704->setFrame(globalFrame);

ui->pushButtonEst70->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "70    ") );
ui->pushButtonEst70->setMaximumWidth( m7traild3 );
ui->pushButtonEst70->setMaximumHeight( m7traild3 );
ui->pushButtonLib70->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "70    ") );
ui->pushButtonLib70->setMaximumWidth( m7traild3 );
ui->pushButtonLib70->setMaximumHeight( m7traild3 );

ui->est701->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "70    ") );
connect( ui->est701, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est701, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est701->installEventFilter(this);
ui->est701->setMaximumWidth( m6trail);
ui->est701->setMinimumWidth( m6trail);
ui->est701->setMaximumHeight( m7traild3 );
ui->est701->setMaxLength(3);
ui->est701->setFrame(globalFrame);

ui->est702->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "70    ") );
connect( ui->est702, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est702, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est702->installEventFilter(this);
ui->est702->setMaximumWidth( m26trail);
ui->est702->setMinimumWidth( m25trail);
ui->est702->setMaximumHeight( m7traild3 );
ui->est702->setMaxLength(24);
ui->est702->setFrame(globalFrame);

ui->est703->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "70    ") );
connect( ui->est703, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est703, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est703->installEventFilter(this);
ui->est703->setAlignment(Qt::AlignCenter);
ui->est703->setMaximumWidth( m11trail);
ui->est703->setMinimumWidth( m6trail);
ui->est703->setMaximumHeight( m7traild3 );
ui->est703->setMaxLength(8);
ui->est703->setFrame(globalFrame);

ui->est704->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "70    ") );
connect( ui->est704, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est704, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est704->installEventFilter(this);
ui->est704->setAlignment(Qt::AlignCenter);
ui->est704->setMaximumWidth( m12trail);
ui->est704->setMinimumWidth( m6trail);
ui->est704->setMaximumHeight( m7traild3 );
ui->est704->setMaxLength(11);
ui->est704->setFrame(globalFrame);

ui->est705->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "70    ") );
connect( ui->est705, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est705, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est705->installEventFilter(this);
ui->est705->setAlignment(Qt::AlignCenter);
ui->est705->setMaximumWidth( m12trail);
ui->est705->setMinimumWidth( m6trail);
ui->est705->setMaximumHeight( m7traild3 );
ui->est705->setMaxLength(11);
ui->est705->setFrame(globalFrame);

ui->est706->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "70    ") );
ui->est706->setReadOnly(true);
ui->est706->setAlignment(Qt::AlignRight);
ui->est706->setMaximumWidth( m14trail);
ui->est706->setMinimumWidth( m9trail);
ui->est706->setMaximumHeight( m7traild3 );
ui->est706->setMaxLength(15);
ui->est706->setFrame(globalFrame);

ui->est707->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "70    ") );
ui->est707->setReadOnly(true);
ui->est707->setAlignment(Qt::AlignRight);
ui->est707->setMaximumWidth( m14trail);
ui->est707->setMinimumWidth( m9trail);
ui->est707->setMaximumHeight( m7traild3 );
ui->est707->setMaxLength(15);
ui->est707->setFrame(globalFrame);

ui->lib711->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "71    ") );
connect( ui->lib711, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib711, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib71, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst71, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib711->installEventFilter(this);
ui->lib711->setMaximumWidth( m6trail);
ui->lib711->setMinimumWidth( m6trail);
ui->lib711->setMaximumHeight( m7traild3 );
ui->lib711->setMaxLength(3);
ui->lib711->setFrame(globalFrame);

ui->lib712->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "71    ") );
connect( ui->lib712, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib712, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib712->installEventFilter(this);
ui->lib712->setMaximumWidth( m26trail);
ui->lib712->setMinimumWidth( m25trail);
ui->lib712->setMaximumHeight( m7traild3 );
ui->lib712->setMaxLength(24);
ui->lib712->setFrame(globalFrame);

ui->lib713->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "71    ") );
connect( ui->lib713, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib713, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib713->installEventFilter(this);
ui->lib713->setAlignment(Qt::AlignCenter);
ui->lib713->setMaximumWidth( m12trail);
ui->lib713->setMinimumWidth( m6trail);
ui->lib713->setMaximumHeight( m7traild3 );
ui->lib713->setMaxLength(11);
ui->lib713->setFrame(globalFrame);

ui->lib714->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "71    ") );
connect( ui->lib714, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib714, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib714->installEventFilter(this);
ui->lib714->setAlignment(Qt::AlignCenter);
ui->lib714->setMaximumWidth( m12trail);
ui->lib714->setMinimumWidth( m6trail);
ui->lib714->setMaximumHeight( m7traild3 );
ui->lib714->setMaxLength(11);
ui->lib714->setFrame(globalFrame);

ui->pushButtonEst71->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "71    ") );
ui->pushButtonEst71->setMaximumWidth( m7traild3 );
ui->pushButtonEst71->setMaximumHeight( m7traild3 );
ui->pushButtonLib71->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "71    ") );
ui->pushButtonLib71->setMaximumWidth( m7traild3 );
ui->pushButtonLib71->setMaximumHeight( m7traild3 );

ui->est711->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "71    ") );
connect( ui->est711, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est711, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est711->installEventFilter(this);
ui->est711->setMaximumWidth( m6trail);
ui->est711->setMinimumWidth( m6trail);
ui->est711->setMaximumHeight( m7traild3 );
ui->est711->setMaxLength(3);
ui->est711->setFrame(globalFrame);

ui->est712->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "71    ") );
connect( ui->est712, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est712, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est712->installEventFilter(this);
ui->est712->setMaximumWidth( m26trail);
ui->est712->setMinimumWidth( m25trail);
ui->est712->setMaximumHeight( m7traild3 );
ui->est712->setMaxLength(24);
ui->est712->setFrame(globalFrame);

ui->est713->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "71    ") );
connect( ui->est713, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est713, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est713->installEventFilter(this);
ui->est713->setAlignment(Qt::AlignCenter);
ui->est713->setMaximumWidth( m11trail);
ui->est713->setMinimumWidth( m6trail);
ui->est713->setMaximumHeight( m7traild3 );
ui->est713->setMaxLength(8);
ui->est713->setFrame(globalFrame);

ui->est714->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "71    ") );
connect( ui->est714, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est714, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est714->installEventFilter(this);
ui->est714->setAlignment(Qt::AlignCenter);
ui->est714->setMaximumWidth( m12trail);
ui->est714->setMinimumWidth( m6trail);
ui->est714->setMaximumHeight( m7traild3 );
ui->est714->setMaxLength(11);
ui->est714->setFrame(globalFrame);

ui->est715->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "71    ") );
connect( ui->est715, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est715, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est715->installEventFilter(this);
ui->est715->setAlignment(Qt::AlignCenter);
ui->est715->setMaximumWidth( m12trail);
ui->est715->setMinimumWidth( m6trail);
ui->est715->setMaximumHeight( m7traild3 );
ui->est715->setMaxLength(11);
ui->est715->setFrame(globalFrame);

ui->est716->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "71    ") );
ui->est716->setReadOnly(true);
ui->est716->setAlignment(Qt::AlignRight);
ui->est716->setMaximumWidth( m14trail);
ui->est716->setMinimumWidth( m9trail);
ui->est716->setMaximumHeight( m7traild3 );
ui->est716->setMaxLength(15);
ui->est716->setFrame(globalFrame);

ui->est717->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "71    ") );
ui->est717->setReadOnly(true);
ui->est717->setAlignment(Qt::AlignRight);
ui->est717->setMaximumWidth( m14trail);
ui->est717->setMinimumWidth( m9trail);
ui->est717->setMaximumHeight( m7traild3 );
ui->est717->setMaxLength(15);
ui->est717->setFrame(globalFrame);

ui->lib721->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "72    ") );
connect( ui->lib721, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib721, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib72, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst72, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib721->installEventFilter(this);
ui->lib721->setMaximumWidth( m6trail);
ui->lib721->setMinimumWidth( m6trail);
ui->lib721->setMaximumHeight( m7traild3 );
ui->lib721->setMaxLength(3);
ui->lib721->setFrame(globalFrame);

ui->lib722->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "72    ") );
connect( ui->lib722, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib722, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib722->installEventFilter(this);
ui->lib722->setMaximumWidth( m26trail);
ui->lib722->setMinimumWidth( m25trail);
ui->lib722->setMaximumHeight( m7traild3 );
ui->lib722->setMaxLength(24);
ui->lib722->setFrame(globalFrame);

ui->lib723->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "72    ") );
connect( ui->lib723, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib723, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib723->installEventFilter(this);
ui->lib723->setAlignment(Qt::AlignCenter);
ui->lib723->setMaximumWidth( m12trail);
ui->lib723->setMinimumWidth( m6trail);
ui->lib723->setMaximumHeight( m7traild3 );
ui->lib723->setMaxLength(11);
ui->lib723->setFrame(globalFrame);

ui->lib724->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "72    ") );
connect( ui->lib724, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib724, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib724->installEventFilter(this);
ui->lib724->setAlignment(Qt::AlignCenter);
ui->lib724->setMaximumWidth( m12trail);
ui->lib724->setMinimumWidth( m6trail);
ui->lib724->setMaximumHeight( m7traild3 );
ui->lib724->setMaxLength(11);
ui->lib724->setFrame(globalFrame);

ui->pushButtonEst72->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "72    ") );
ui->pushButtonEst72->setMaximumWidth( m7traild3 );
ui->pushButtonEst72->setMaximumHeight( m7traild3 );
ui->pushButtonLib72->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "72    ") );
ui->pushButtonLib72->setMaximumWidth( m7traild3 );
ui->pushButtonLib72->setMaximumHeight( m7traild3 );

ui->est721->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "72    ") );
connect( ui->est721, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est721, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est721->installEventFilter(this);
ui->est721->setMaximumWidth( m6trail);
ui->est721->setMinimumWidth( m6trail);
ui->est721->setMaximumHeight( m7traild3 );
ui->est721->setMaxLength(3);
ui->est721->setFrame(globalFrame);

ui->est722->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "72    ") );
connect( ui->est722, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est722, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est722->installEventFilter(this);
ui->est722->setMaximumWidth( m26trail);
ui->est722->setMinimumWidth( m25trail);
ui->est722->setMaximumHeight( m7traild3 );
ui->est722->setMaxLength(24);
ui->est722->setFrame(globalFrame);

ui->est723->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "72    ") );
connect( ui->est723, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est723, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est723->installEventFilter(this);
ui->est723->setAlignment(Qt::AlignCenter);
ui->est723->setMaximumWidth( m11trail);
ui->est723->setMinimumWidth( m6trail);
ui->est723->setMaximumHeight( m7traild3 );
ui->est723->setMaxLength(8);
ui->est723->setFrame(globalFrame);

ui->est724->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "72    ") );
connect( ui->est724, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est724, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est724->installEventFilter(this);
ui->est724->setAlignment(Qt::AlignCenter);
ui->est724->setMaximumWidth( m12trail);
ui->est724->setMinimumWidth( m6trail);
ui->est724->setMaximumHeight( m7traild3 );
ui->est724->setMaxLength(11);
ui->est724->setFrame(globalFrame);

ui->est725->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "72    ") );
connect( ui->est725, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est725, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est725->installEventFilter(this);
ui->est725->setAlignment(Qt::AlignCenter);
ui->est725->setMaximumWidth( m12trail);
ui->est725->setMinimumWidth( m6trail);
ui->est725->setMaximumHeight( m7traild3 );
ui->est725->setMaxLength(11);
ui->est725->setFrame(globalFrame);

ui->est726->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "72    ") );
ui->est726->setReadOnly(true);
ui->est726->setAlignment(Qt::AlignRight);
ui->est726->setMaximumWidth( m14trail);
ui->est726->setMinimumWidth( m9trail);
ui->est726->setMaximumHeight( m7traild3 );
ui->est726->setMaxLength(15);
ui->est726->setFrame(globalFrame);

ui->est727->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "72    ") );
ui->est727->setReadOnly(true);
ui->est727->setAlignment(Qt::AlignRight);
ui->est727->setMaximumWidth( m14trail);
ui->est727->setMinimumWidth( m9trail);
ui->est727->setMaximumHeight( m7traild3 );
ui->est727->setMaxLength(15);
ui->est727->setFrame(globalFrame);

ui->lib731->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "73    ") );
connect( ui->lib731, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib731, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib73, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst73, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib731->installEventFilter(this);
ui->lib731->setMaximumWidth( m6trail);
ui->lib731->setMinimumWidth( m6trail);
ui->lib731->setMaximumHeight( m7traild3 );
ui->lib731->setMaxLength(3);
ui->lib731->setFrame(globalFrame);

ui->lib732->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "73    ") );
connect( ui->lib732, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib732, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib732->installEventFilter(this);
ui->lib732->setMaximumWidth( m26trail);
ui->lib732->setMinimumWidth( m25trail);
ui->lib732->setMaximumHeight( m7traild3 );
ui->lib732->setMaxLength(24);
ui->lib732->setFrame(globalFrame);

ui->lib733->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "73    ") );
connect( ui->lib733, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib733, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib733->installEventFilter(this);
ui->lib733->setAlignment(Qt::AlignCenter);
ui->lib733->setMaximumWidth( m12trail);
ui->lib733->setMinimumWidth( m6trail);
ui->lib733->setMaximumHeight( m7traild3 );
ui->lib733->setMaxLength(11);
ui->lib733->setFrame(globalFrame);

ui->lib734->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "73    ") );
connect( ui->lib734, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib734, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib734->installEventFilter(this);
ui->lib734->setAlignment(Qt::AlignCenter);
ui->lib734->setMaximumWidth( m12trail);
ui->lib734->setMinimumWidth( m6trail);
ui->lib734->setMaximumHeight( m7traild3 );
ui->lib734->setMaxLength(11);
ui->lib734->setFrame(globalFrame);

ui->pushButtonEst73->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "73    ") );
ui->pushButtonEst73->setMaximumWidth( m7traild3 );
ui->pushButtonEst73->setMaximumHeight( m7traild3 );
ui->pushButtonLib73->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "73    ") );
ui->pushButtonLib73->setMaximumWidth( m7traild3 );
ui->pushButtonLib73->setMaximumHeight( m7traild3 );

ui->est731->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "73    ") );
connect( ui->est731, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est731, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est731->installEventFilter(this);
ui->est731->setMaximumWidth( m6trail);
ui->est731->setMinimumWidth( m6trail);
ui->est731->setMaximumHeight( m7traild3 );
ui->est731->setMaxLength(3);
ui->est731->setFrame(globalFrame);

ui->est732->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "73    ") );
connect( ui->est732, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est732, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est732->installEventFilter(this);
ui->est732->setMaximumWidth( m26trail);
ui->est732->setMinimumWidth( m25trail);
ui->est732->setMaximumHeight( m7traild3 );
ui->est732->setMaxLength(24);
ui->est732->setFrame(globalFrame);

ui->est733->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "73    ") );
connect( ui->est733, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est733, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est733->installEventFilter(this);
ui->est733->setAlignment(Qt::AlignCenter);
ui->est733->setMaximumWidth( m11trail);
ui->est733->setMinimumWidth( m6trail);
ui->est733->setMaximumHeight( m7traild3 );
ui->est733->setMaxLength(8);
ui->est733->setFrame(globalFrame);

ui->est734->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "73    ") );
connect( ui->est734, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est734, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est734->installEventFilter(this);
ui->est734->setAlignment(Qt::AlignCenter);
ui->est734->setMaximumWidth( m12trail);
ui->est734->setMinimumWidth( m6trail);
ui->est734->setMaximumHeight( m7traild3 );
ui->est734->setMaxLength(11);
ui->est734->setFrame(globalFrame);

ui->est735->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "73    ") );
connect( ui->est735, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est735, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est735->installEventFilter(this);
ui->est735->setAlignment(Qt::AlignCenter);
ui->est735->setMaximumWidth( m12trail);
ui->est735->setMinimumWidth( m6trail);
ui->est735->setMaximumHeight( m7traild3 );
ui->est735->setMaxLength(11);
ui->est735->setFrame(globalFrame);

ui->est736->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "73    ") );
ui->est736->setReadOnly(true);
ui->est736->setAlignment(Qt::AlignRight);
ui->est736->setMaximumWidth( m14trail);
ui->est736->setMinimumWidth( m9trail);
ui->est736->setMaximumHeight( m7traild3 );
ui->est736->setMaxLength(15);
ui->est736->setFrame(globalFrame);

ui->est737->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "73    ") );
ui->est737->setReadOnly(true);
ui->est737->setAlignment(Qt::AlignRight);
ui->est737->setMaximumWidth( m14trail);
ui->est737->setMinimumWidth( m9trail);
ui->est737->setMaximumHeight( m7traild3 );
ui->est737->setMaxLength(15);
ui->est737->setFrame(globalFrame);

ui->lib741->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "74    ") );
connect( ui->lib741, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib741, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib74, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst74, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib741->installEventFilter(this);
ui->lib741->setMaximumWidth( m6trail);
ui->lib741->setMinimumWidth( m6trail);
ui->lib741->setMaximumHeight( m7traild3 );
ui->lib741->setMaxLength(3);
ui->lib741->setFrame(globalFrame);

ui->lib742->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "74    ") );
connect( ui->lib742, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib742, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib742->installEventFilter(this);
ui->lib742->setMaximumWidth( m26trail);
ui->lib742->setMinimumWidth( m25trail);
ui->lib742->setMaximumHeight( m7traild3 );
ui->lib742->setMaxLength(24);
ui->lib742->setFrame(globalFrame);

ui->lib743->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "74    ") );
connect( ui->lib743, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib743, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib743->installEventFilter(this);
ui->lib743->setAlignment(Qt::AlignCenter);
ui->lib743->setMaximumWidth( m12trail);
ui->lib743->setMinimumWidth( m6trail);
ui->lib743->setMaximumHeight( m7traild3 );
ui->lib743->setMaxLength(11);
ui->lib743->setFrame(globalFrame);

ui->lib744->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "74    ") );
connect( ui->lib744, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib744, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib744->installEventFilter(this);
ui->lib744->setAlignment(Qt::AlignCenter);
ui->lib744->setMaximumWidth( m12trail);
ui->lib744->setMinimumWidth( m6trail);
ui->lib744->setMaximumHeight( m7traild3 );
ui->lib744->setMaxLength(11);
ui->lib744->setFrame(globalFrame);

ui->pushButtonEst74->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "74    ") );
ui->pushButtonEst74->setMaximumWidth( m7traild3 );
ui->pushButtonEst74->setMaximumHeight( m7traild3 );
ui->pushButtonLib74->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "74    ") );
ui->pushButtonLib74->setMaximumWidth( m7traild3 );
ui->pushButtonLib74->setMaximumHeight( m7traild3 );

ui->est741->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "74    ") );
connect( ui->est741, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est741, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est741->installEventFilter(this);
ui->est741->setMaximumWidth( m6trail);
ui->est741->setMinimumWidth( m6trail);
ui->est741->setMaximumHeight( m7traild3 );
ui->est741->setMaxLength(3);
ui->est741->setFrame(globalFrame);

ui->est742->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "74    ") );
connect( ui->est742, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est742, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est742->installEventFilter(this);
ui->est742->setMaximumWidth( m26trail);
ui->est742->setMinimumWidth( m25trail);
ui->est742->setMaximumHeight( m7traild3 );
ui->est742->setMaxLength(24);
ui->est742->setFrame(globalFrame);

ui->est743->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "74    ") );
connect( ui->est743, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est743, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est743->installEventFilter(this);
ui->est743->setAlignment(Qt::AlignCenter);
ui->est743->setMaximumWidth( m11trail);
ui->est743->setMinimumWidth( m6trail);
ui->est743->setMaximumHeight( m7traild3 );
ui->est743->setMaxLength(8);
ui->est743->setFrame(globalFrame);

ui->est744->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "74    ") );
connect( ui->est744, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est744, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est744->installEventFilter(this);
ui->est744->setAlignment(Qt::AlignCenter);
ui->est744->setMaximumWidth( m12trail);
ui->est744->setMinimumWidth( m6trail);
ui->est744->setMaximumHeight( m7traild3 );
ui->est744->setMaxLength(11);
ui->est744->setFrame(globalFrame);

ui->est745->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "74    ") );
connect( ui->est745, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est745, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est745->installEventFilter(this);
ui->est745->setAlignment(Qt::AlignCenter);
ui->est745->setMaximumWidth( m12trail);
ui->est745->setMinimumWidth( m6trail);
ui->est745->setMaximumHeight( m7traild3 );
ui->est745->setMaxLength(11);
ui->est745->setFrame(globalFrame);

ui->est746->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "74    ") );
ui->est746->setReadOnly(true);
ui->est746->setAlignment(Qt::AlignRight);
ui->est746->setMaximumWidth( m14trail);
ui->est746->setMinimumWidth( m9trail);
ui->est746->setMaximumHeight( m7traild3 );
ui->est746->setMaxLength(15);
ui->est746->setFrame(globalFrame);

ui->est747->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "74    ") );
ui->est747->setReadOnly(true);
ui->est747->setAlignment(Qt::AlignRight);
ui->est747->setMaximumWidth( m14trail);
ui->est747->setMinimumWidth( m9trail);
ui->est747->setMaximumHeight( m7traild3 );
ui->est747->setMaxLength(15);
ui->est747->setFrame(globalFrame);

ui->lib751->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "75    ") );
connect( ui->lib751, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib751, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib75, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst75, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib751->installEventFilter(this);
ui->lib751->setMaximumWidth( m6trail);
ui->lib751->setMinimumWidth( m6trail);
ui->lib751->setMaximumHeight( m7traild3 );
ui->lib751->setMaxLength(3);
ui->lib751->setFrame(globalFrame);

ui->lib752->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "75    ") );
connect( ui->lib752, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib752, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib752->installEventFilter(this);
ui->lib752->setMaximumWidth( m26trail);
ui->lib752->setMinimumWidth( m25trail);
ui->lib752->setMaximumHeight( m7traild3 );
ui->lib752->setMaxLength(24);
ui->lib752->setFrame(globalFrame);

ui->lib753->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "75    ") );
connect( ui->lib753, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib753, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib753->installEventFilter(this);
ui->lib753->setAlignment(Qt::AlignCenter);
ui->lib753->setMaximumWidth( m12trail);
ui->lib753->setMinimumWidth( m6trail);
ui->lib753->setMaximumHeight( m7traild3 );
ui->lib753->setMaxLength(11);
ui->lib753->setFrame(globalFrame);

ui->lib754->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "75    ") );
connect( ui->lib754, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib754, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib754->installEventFilter(this);
ui->lib754->setAlignment(Qt::AlignCenter);
ui->lib754->setMaximumWidth( m12trail);
ui->lib754->setMinimumWidth( m6trail);
ui->lib754->setMaximumHeight( m7traild3 );
ui->lib754->setMaxLength(11);
ui->lib754->setFrame(globalFrame);

ui->pushButtonEst75->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "75    ") );
ui->pushButtonEst75->setMaximumWidth( m7traild3 );
ui->pushButtonEst75->setMaximumHeight( m7traild3 );
ui->pushButtonLib75->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "75    ") );
ui->pushButtonLib75->setMaximumWidth( m7traild3 );
ui->pushButtonLib75->setMaximumHeight( m7traild3 );

ui->est751->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "75    ") );
connect( ui->est751, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est751, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est751->installEventFilter(this);
ui->est751->setMaximumWidth( m6trail);
ui->est751->setMinimumWidth( m6trail);
ui->est751->setMaximumHeight( m7traild3 );
ui->est751->setMaxLength(3);
ui->est751->setFrame(globalFrame);

ui->est752->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "75    ") );
connect( ui->est752, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est752, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est752->installEventFilter(this);
ui->est752->setMaximumWidth( m26trail);
ui->est752->setMinimumWidth( m25trail);
ui->est752->setMaximumHeight( m7traild3 );
ui->est752->setMaxLength(24);
ui->est752->setFrame(globalFrame);

ui->est753->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "75    ") );
connect( ui->est753, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est753, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est753->installEventFilter(this);
ui->est753->setAlignment(Qt::AlignCenter);
ui->est753->setMaximumWidth( m11trail);
ui->est753->setMinimumWidth( m6trail);
ui->est753->setMaximumHeight( m7traild3 );
ui->est753->setMaxLength(8);
ui->est753->setFrame(globalFrame);

ui->est754->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "75    ") );
connect( ui->est754, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est754, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est754->installEventFilter(this);
ui->est754->setAlignment(Qt::AlignCenter);
ui->est754->setMaximumWidth( m12trail);
ui->est754->setMinimumWidth( m6trail);
ui->est754->setMaximumHeight( m7traild3 );
ui->est754->setMaxLength(11);
ui->est754->setFrame(globalFrame);

ui->est755->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "75    ") );
connect( ui->est755, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est755, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est755->installEventFilter(this);
ui->est755->setAlignment(Qt::AlignCenter);
ui->est755->setMaximumWidth( m12trail);
ui->est755->setMinimumWidth( m6trail);
ui->est755->setMaximumHeight( m7traild3 );
ui->est755->setMaxLength(11);
ui->est755->setFrame(globalFrame);

ui->est756->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "75    ") );
ui->est756->setReadOnly(true);
ui->est756->setAlignment(Qt::AlignRight);
ui->est756->setMaximumWidth( m14trail);
ui->est756->setMinimumWidth( m9trail);
ui->est756->setMaximumHeight( m7traild3 );
ui->est756->setMaxLength(15);
ui->est756->setFrame(globalFrame);

ui->est757->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "75    ") );
ui->est757->setReadOnly(true);
ui->est757->setAlignment(Qt::AlignRight);
ui->est757->setMaximumWidth( m14trail);
ui->est757->setMinimumWidth( m9trail);
ui->est757->setMaximumHeight( m7traild3 );
ui->est757->setMaxLength(15);
ui->est757->setFrame(globalFrame);

ui->lib761->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "76    ") );
connect( ui->lib761, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib761, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib76, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst76, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib761->installEventFilter(this);
ui->lib761->setMaximumWidth( m6trail);
ui->lib761->setMinimumWidth( m6trail);
ui->lib761->setMaximumHeight( m7traild3 );
ui->lib761->setMaxLength(3);
ui->lib761->setFrame(globalFrame);

ui->lib762->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "76    ") );
connect( ui->lib762, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib762, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib762->installEventFilter(this);
ui->lib762->setMaximumWidth( m26trail);
ui->lib762->setMinimumWidth( m25trail);
ui->lib762->setMaximumHeight( m7traild3 );
ui->lib762->setMaxLength(24);
ui->lib762->setFrame(globalFrame);

ui->lib763->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "76    ") );
connect( ui->lib763, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib763, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib763->installEventFilter(this);
ui->lib763->setAlignment(Qt::AlignCenter);
ui->lib763->setMaximumWidth( m12trail);
ui->lib763->setMinimumWidth( m6trail);
ui->lib763->setMaximumHeight( m7traild3 );
ui->lib763->setMaxLength(11);
ui->lib763->setFrame(globalFrame);

ui->lib764->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "76    ") );
connect( ui->lib764, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib764, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib764->installEventFilter(this);
ui->lib764->setAlignment(Qt::AlignCenter);
ui->lib764->setMaximumWidth( m12trail);
ui->lib764->setMinimumWidth( m6trail);
ui->lib764->setMaximumHeight( m7traild3 );
ui->lib764->setMaxLength(11);
ui->lib764->setFrame(globalFrame);

ui->pushButtonEst76->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "76    ") );
ui->pushButtonEst76->setMaximumWidth( m7traild3 );
ui->pushButtonEst76->setMaximumHeight( m7traild3 );
ui->pushButtonLib76->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "76    ") );
ui->pushButtonLib76->setMaximumWidth( m7traild3 );
ui->pushButtonLib76->setMaximumHeight( m7traild3 );

ui->est761->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "76    ") );
connect( ui->est761, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est761, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est761->installEventFilter(this);
ui->est761->setMaximumWidth( m6trail);
ui->est761->setMinimumWidth( m6trail);
ui->est761->setMaximumHeight( m7traild3 );
ui->est761->setMaxLength(3);
ui->est761->setFrame(globalFrame);

ui->est762->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "76    ") );
connect( ui->est762, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est762, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est762->installEventFilter(this);
ui->est762->setMaximumWidth( m26trail);
ui->est762->setMinimumWidth( m25trail);
ui->est762->setMaximumHeight( m7traild3 );
ui->est762->setMaxLength(24);
ui->est762->setFrame(globalFrame);

ui->est763->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "76    ") );
connect( ui->est763, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est763, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est763->installEventFilter(this);
ui->est763->setAlignment(Qt::AlignCenter);
ui->est763->setMaximumWidth( m11trail);
ui->est763->setMinimumWidth( m6trail);
ui->est763->setMaximumHeight( m7traild3 );
ui->est763->setMaxLength(8);
ui->est763->setFrame(globalFrame);

ui->est764->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "76    ") );
connect( ui->est764, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est764, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est764->installEventFilter(this);
ui->est764->setAlignment(Qt::AlignCenter);
ui->est764->setMaximumWidth( m12trail);
ui->est764->setMinimumWidth( m6trail);
ui->est764->setMaximumHeight( m7traild3 );
ui->est764->setMaxLength(11);
ui->est764->setFrame(globalFrame);

ui->est765->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "76    ") );
connect( ui->est765, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est765, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est765->installEventFilter(this);
ui->est765->setAlignment(Qt::AlignCenter);
ui->est765->setMaximumWidth( m12trail);
ui->est765->setMinimumWidth( m6trail);
ui->est765->setMaximumHeight( m7traild3 );
ui->est765->setMaxLength(11);
ui->est765->setFrame(globalFrame);

ui->est766->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "76    ") );
ui->est766->setReadOnly(true);
ui->est766->setAlignment(Qt::AlignRight);
ui->est766->setMaximumWidth( m14trail);
ui->est766->setMinimumWidth( m9trail);
ui->est766->setMaximumHeight( m7traild3 );
ui->est766->setMaxLength(15);
ui->est766->setFrame(globalFrame);

ui->est767->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "76    ") );
ui->est767->setReadOnly(true);
ui->est767->setAlignment(Qt::AlignRight);
ui->est767->setMaximumWidth( m14trail);
ui->est767->setMinimumWidth( m9trail);
ui->est767->setMaximumHeight( m7traild3 );
ui->est767->setMaxLength(15);
ui->est767->setFrame(globalFrame);

ui->lib771->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "77    ") );
connect( ui->lib771, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib771, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib77, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst77, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib771->installEventFilter(this);
ui->lib771->setMaximumWidth( m6trail);
ui->lib771->setMinimumWidth( m6trail);
ui->lib771->setMaximumHeight( m7traild3 );
ui->lib771->setMaxLength(3);
ui->lib771->setFrame(globalFrame);

ui->lib772->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "77    ") );
connect( ui->lib772, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib772, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib772->installEventFilter(this);
ui->lib772->setMaximumWidth( m26trail);
ui->lib772->setMinimumWidth( m25trail);
ui->lib772->setMaximumHeight( m7traild3 );
ui->lib772->setMaxLength(24);
ui->lib772->setFrame(globalFrame);

ui->lib773->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "77    ") );
connect( ui->lib773, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib773, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib773->installEventFilter(this);
ui->lib773->setAlignment(Qt::AlignCenter);
ui->lib773->setMaximumWidth( m12trail);
ui->lib773->setMinimumWidth( m6trail);
ui->lib773->setMaximumHeight( m7traild3 );
ui->lib773->setMaxLength(11);
ui->lib773->setFrame(globalFrame);

ui->lib774->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "77    ") );
connect( ui->lib774, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib774, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib774->installEventFilter(this);
ui->lib774->setAlignment(Qt::AlignCenter);
ui->lib774->setMaximumWidth( m12trail);
ui->lib774->setMinimumWidth( m6trail);
ui->lib774->setMaximumHeight( m7traild3 );
ui->lib774->setMaxLength(11);
ui->lib774->setFrame(globalFrame);

ui->pushButtonEst77->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "77    ") );
ui->pushButtonEst77->setMaximumWidth( m7traild3 );
ui->pushButtonEst77->setMaximumHeight( m7traild3 );
ui->pushButtonLib77->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "77    ") );
ui->pushButtonLib77->setMaximumWidth( m7traild3 );
ui->pushButtonLib77->setMaximumHeight( m7traild3 );

ui->est771->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "77    ") );
connect( ui->est771, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est771, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est771->installEventFilter(this);
ui->est771->setMaximumWidth( m6trail);
ui->est771->setMinimumWidth( m6trail);
ui->est771->setMaximumHeight( m7traild3 );
ui->est771->setMaxLength(3);
ui->est771->setFrame(globalFrame);

ui->est772->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "77    ") );
connect( ui->est772, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est772, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est772->installEventFilter(this);
ui->est772->setMaximumWidth( m26trail);
ui->est772->setMinimumWidth( m25trail);
ui->est772->setMaximumHeight( m7traild3 );
ui->est772->setMaxLength(24);
ui->est772->setFrame(globalFrame);

ui->est773->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "77    ") );
connect( ui->est773, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est773, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est773->installEventFilter(this);
ui->est773->setAlignment(Qt::AlignCenter);
ui->est773->setMaximumWidth( m11trail);
ui->est773->setMinimumWidth( m6trail);
ui->est773->setMaximumHeight( m7traild3 );
ui->est773->setMaxLength(8);
ui->est773->setFrame(globalFrame);

ui->est774->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "77    ") );
connect( ui->est774, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est774, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est774->installEventFilter(this);
ui->est774->setAlignment(Qt::AlignCenter);
ui->est774->setMaximumWidth( m12trail);
ui->est774->setMinimumWidth( m6trail);
ui->est774->setMaximumHeight( m7traild3 );
ui->est774->setMaxLength(11);
ui->est774->setFrame(globalFrame);

ui->est775->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "77    ") );
connect( ui->est775, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est775, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est775->installEventFilter(this);
ui->est775->setAlignment(Qt::AlignCenter);
ui->est775->setMaximumWidth( m12trail);
ui->est775->setMinimumWidth( m6trail);
ui->est775->setMaximumHeight( m7traild3 );
ui->est775->setMaxLength(11);
ui->est775->setFrame(globalFrame);

ui->est776->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "77    ") );
ui->est776->setReadOnly(true);
ui->est776->setAlignment(Qt::AlignRight);
ui->est776->setMaximumWidth( m14trail);
ui->est776->setMinimumWidth( m9trail);
ui->est776->setMaximumHeight( m7traild3 );
ui->est776->setMaxLength(15);
ui->est776->setFrame(globalFrame);

ui->est777->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "77    ") );
ui->est777->setReadOnly(true);
ui->est777->setAlignment(Qt::AlignRight);
ui->est777->setMaximumWidth( m14trail);
ui->est777->setMinimumWidth( m9trail);
ui->est777->setMaximumHeight( m7traild3 );
ui->est777->setMaxLength(15);
ui->est777->setFrame(globalFrame);

ui->lib781->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "78    ") );
connect( ui->lib781, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib781, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib78, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst78, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib781->installEventFilter(this);
ui->lib781->setMaximumWidth( m6trail);
ui->lib781->setMinimumWidth( m6trail);
ui->lib781->setMaximumHeight( m7traild3 );
ui->lib781->setMaxLength(3);
ui->lib781->setFrame(globalFrame);

ui->lib782->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "78    ") );
connect( ui->lib782, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib782, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib782->installEventFilter(this);
ui->lib782->setMaximumWidth( m26trail);
ui->lib782->setMinimumWidth( m25trail);
ui->lib782->setMaximumHeight( m7traild3 );
ui->lib782->setMaxLength(24);
ui->lib782->setFrame(globalFrame);

ui->lib783->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "78    ") );
connect( ui->lib783, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib783, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib783->installEventFilter(this);
ui->lib783->setAlignment(Qt::AlignCenter);
ui->lib783->setMaximumWidth( m12trail);
ui->lib783->setMinimumWidth( m6trail);
ui->lib783->setMaximumHeight( m7traild3 );
ui->lib783->setMaxLength(11);
ui->lib783->setFrame(globalFrame);

ui->lib784->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "78    ") );
connect( ui->lib784, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib784, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib784->installEventFilter(this);
ui->lib784->setAlignment(Qt::AlignCenter);
ui->lib784->setMaximumWidth( m12trail);
ui->lib784->setMinimumWidth( m6trail);
ui->lib784->setMaximumHeight( m7traild3 );
ui->lib784->setMaxLength(11);
ui->lib784->setFrame(globalFrame);

ui->pushButtonEst78->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "78    ") );
ui->pushButtonEst78->setMaximumWidth( m7traild3 );
ui->pushButtonEst78->setMaximumHeight( m7traild3 );
ui->pushButtonLib78->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "78    ") );
ui->pushButtonLib78->setMaximumWidth( m7traild3 );
ui->pushButtonLib78->setMaximumHeight( m7traild3 );

ui->est781->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "78    ") );
connect( ui->est781, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est781, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est781->installEventFilter(this);
ui->est781->setMaximumWidth( m6trail);
ui->est781->setMinimumWidth( m6trail);
ui->est781->setMaximumHeight( m7traild3 );
ui->est781->setMaxLength(3);
ui->est781->setFrame(globalFrame);

ui->est782->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "78    ") );
connect( ui->est782, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est782, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est782->installEventFilter(this);
ui->est782->setMaximumWidth( m26trail);
ui->est782->setMinimumWidth( m25trail);
ui->est782->setMaximumHeight( m7traild3 );
ui->est782->setMaxLength(24);
ui->est782->setFrame(globalFrame);

ui->est783->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "78    ") );
connect( ui->est783, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est783, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est783->installEventFilter(this);
ui->est783->setAlignment(Qt::AlignCenter);
ui->est783->setMaximumWidth( m11trail);
ui->est783->setMinimumWidth( m6trail);
ui->est783->setMaximumHeight( m7traild3 );
ui->est783->setMaxLength(8);
ui->est783->setFrame(globalFrame);

ui->est784->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "78    ") );
connect( ui->est784, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est784, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est784->installEventFilter(this);
ui->est784->setAlignment(Qt::AlignCenter);
ui->est784->setMaximumWidth( m12trail);
ui->est784->setMinimumWidth( m6trail);
ui->est784->setMaximumHeight( m7traild3 );
ui->est784->setMaxLength(11);
ui->est784->setFrame(globalFrame);

ui->est785->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "78    ") );
connect( ui->est785, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est785, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est785->installEventFilter(this);
ui->est785->setAlignment(Qt::AlignCenter);
ui->est785->setMaximumWidth( m12trail);
ui->est785->setMinimumWidth( m6trail);
ui->est785->setMaximumHeight( m7traild3 );
ui->est785->setMaxLength(11);
ui->est785->setFrame(globalFrame);

ui->est786->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "78    ") );
ui->est786->setReadOnly(true);
ui->est786->setAlignment(Qt::AlignRight);
ui->est786->setMaximumWidth( m14trail);
ui->est786->setMinimumWidth( m9trail);
ui->est786->setMaximumHeight( m7traild3 );
ui->est786->setMaxLength(15);
ui->est786->setFrame(globalFrame);

ui->est787->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "78    ") );
ui->est787->setReadOnly(true);
ui->est787->setAlignment(Qt::AlignRight);
ui->est787->setMaximumWidth( m14trail);
ui->est787->setMinimumWidth( m9trail);
ui->est787->setMaximumHeight( m7traild3 );
ui->est787->setMaxLength(15);
ui->est787->setFrame(globalFrame);

ui->lib791->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "79    ") );
connect( ui->lib791, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib791, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib79, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst79, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib791->installEventFilter(this);
ui->lib791->setMaximumWidth( m6trail);
ui->lib791->setMinimumWidth( m6trail);
ui->lib791->setMaximumHeight( m7traild3 );
ui->lib791->setMaxLength(3);
ui->lib791->setFrame(globalFrame);

ui->lib792->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "79    ") );
connect( ui->lib792, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib792, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib792->installEventFilter(this);
ui->lib792->setMaximumWidth( m26trail);
ui->lib792->setMinimumWidth( m25trail);
ui->lib792->setMaximumHeight( m7traild3 );
ui->lib792->setMaxLength(24);
ui->lib792->setFrame(globalFrame);

ui->lib793->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "79    ") );
connect( ui->lib793, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib793, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib793->installEventFilter(this);
ui->lib793->setAlignment(Qt::AlignCenter);
ui->lib793->setMaximumWidth( m12trail);
ui->lib793->setMinimumWidth( m6trail);
ui->lib793->setMaximumHeight( m7traild3 );
ui->lib793->setMaxLength(11);
ui->lib793->setFrame(globalFrame);

ui->lib794->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "79    ") );
connect( ui->lib794, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib794, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib794->installEventFilter(this);
ui->lib794->setAlignment(Qt::AlignCenter);
ui->lib794->setMaximumWidth( m12trail);
ui->lib794->setMinimumWidth( m6trail);
ui->lib794->setMaximumHeight( m7traild3 );
ui->lib794->setMaxLength(11);
ui->lib794->setFrame(globalFrame);

ui->pushButtonEst79->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "79    ") );
ui->pushButtonEst79->setMaximumWidth( m7traild3 );
ui->pushButtonEst79->setMaximumHeight( m7traild3 );
ui->pushButtonLib79->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "79    ") );
ui->pushButtonLib79->setMaximumWidth( m7traild3 );
ui->pushButtonLib79->setMaximumHeight( m7traild3 );

ui->est791->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "79    ") );
connect( ui->est791, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est791, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est791->installEventFilter(this);
ui->est791->setMaximumWidth( m6trail);
ui->est791->setMinimumWidth( m6trail);
ui->est791->setMaximumHeight( m7traild3 );
ui->est791->setMaxLength(3);
ui->est791->setFrame(globalFrame);

ui->est792->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "79    ") );
connect( ui->est792, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est792, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est792->installEventFilter(this);
ui->est792->setMaximumWidth( m26trail);
ui->est792->setMinimumWidth( m25trail);
ui->est792->setMaximumHeight( m7traild3 );
ui->est792->setMaxLength(24);
ui->est792->setFrame(globalFrame);

ui->est793->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "79    ") );
connect( ui->est793, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est793, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est793->installEventFilter(this);
ui->est793->setAlignment(Qt::AlignCenter);
ui->est793->setMaximumWidth( m11trail);
ui->est793->setMinimumWidth( m6trail);
ui->est793->setMaximumHeight( m7traild3 );
ui->est793->setMaxLength(8);
ui->est793->setFrame(globalFrame);

ui->est794->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "79    ") );
connect( ui->est794, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est794, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est794->installEventFilter(this);
ui->est794->setAlignment(Qt::AlignCenter);
ui->est794->setMaximumWidth( m12trail);
ui->est794->setMinimumWidth( m6trail);
ui->est794->setMaximumHeight( m7traild3 );
ui->est794->setMaxLength(11);
ui->est794->setFrame(globalFrame);

ui->est795->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "79    ") );
connect( ui->est795, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est795, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est795->installEventFilter(this);
ui->est795->setAlignment(Qt::AlignCenter);
ui->est795->setMaximumWidth( m12trail);
ui->est795->setMinimumWidth( m6trail);
ui->est795->setMaximumHeight( m7traild3 );
ui->est795->setMaxLength(11);
ui->est795->setFrame(globalFrame);

ui->est796->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "79    ") );
ui->est796->setReadOnly(true);
ui->est796->setAlignment(Qt::AlignRight);
ui->est796->setMaximumWidth( m14trail);
ui->est796->setMinimumWidth( m9trail);
ui->est796->setMaximumHeight( m7traild3 );
ui->est796->setMaxLength(15);
ui->est796->setFrame(globalFrame);

ui->est797->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "79    ") );
ui->est797->setReadOnly(true);
ui->est797->setAlignment(Qt::AlignRight);
ui->est797->setMaximumWidth( m14trail);
ui->est797->setMinimumWidth( m9trail);
ui->est797->setMaximumHeight( m7traild3 );
ui->est797->setMaxLength(15);
ui->est797->setFrame(globalFrame);

ui->lib801->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "80    ") );
connect( ui->lib801, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib801, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib80, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst80, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib801->installEventFilter(this);
ui->lib801->setMaximumWidth( m6trail);
ui->lib801->setMinimumWidth( m6trail);
ui->lib801->setMaximumHeight( m7traild3 );
ui->lib801->setMaxLength(3);
ui->lib801->setFrame(globalFrame);

ui->lib802->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "80    ") );
connect( ui->lib802, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib802, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib802->installEventFilter(this);
ui->lib802->setMaximumWidth( m26trail);
ui->lib802->setMinimumWidth( m25trail);
ui->lib802->setMaximumHeight( m7traild3 );
ui->lib802->setMaxLength(24);
ui->lib802->setFrame(globalFrame);

ui->lib803->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "80    ") );
connect( ui->lib803, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib803, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib803->installEventFilter(this);
ui->lib803->setAlignment(Qt::AlignCenter);
ui->lib803->setMaximumWidth( m12trail);
ui->lib803->setMinimumWidth( m6trail);
ui->lib803->setMaximumHeight( m7traild3 );
ui->lib803->setMaxLength(11);
ui->lib803->setFrame(globalFrame);

ui->lib804->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "80    ") );
connect( ui->lib804, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib804, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib804->installEventFilter(this);
ui->lib804->setAlignment(Qt::AlignCenter);
ui->lib804->setMaximumWidth( m12trail);
ui->lib804->setMinimumWidth( m6trail);
ui->lib804->setMaximumHeight( m7traild3 );
ui->lib804->setMaxLength(11);
ui->lib804->setFrame(globalFrame);

ui->pushButtonEst80->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "80    ") );
ui->pushButtonEst80->setMaximumWidth( m7traild3 );
ui->pushButtonEst80->setMaximumHeight( m7traild3 );
ui->pushButtonLib80->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "80    ") );
ui->pushButtonLib80->setMaximumWidth( m7traild3 );
ui->pushButtonLib80->setMaximumHeight( m7traild3 );

ui->est801->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "80    ") );
connect( ui->est801, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est801, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est801->installEventFilter(this);
ui->est801->setMaximumWidth( m6trail);
ui->est801->setMinimumWidth( m6trail);
ui->est801->setMaximumHeight( m7traild3 );
ui->est801->setMaxLength(3);
ui->est801->setFrame(globalFrame);

ui->est802->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "80    ") );
connect( ui->est802, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est802, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est802->installEventFilter(this);
ui->est802->setMaximumWidth( m26trail);
ui->est802->setMinimumWidth( m25trail);
ui->est802->setMaximumHeight( m7traild3 );
ui->est802->setMaxLength(24);
ui->est802->setFrame(globalFrame);

ui->est803->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "80    ") );
connect( ui->est803, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est803, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est803->installEventFilter(this);
ui->est803->setAlignment(Qt::AlignCenter);
ui->est803->setMaximumWidth( m11trail);
ui->est803->setMinimumWidth( m6trail);
ui->est803->setMaximumHeight( m7traild3 );
ui->est803->setMaxLength(8);
ui->est803->setFrame(globalFrame);

ui->est804->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "80    ") );
connect( ui->est804, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est804, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est804->installEventFilter(this);
ui->est804->setAlignment(Qt::AlignCenter);
ui->est804->setMaximumWidth( m12trail);
ui->est804->setMinimumWidth( m6trail);
ui->est804->setMaximumHeight( m7traild3 );
ui->est804->setMaxLength(11);
ui->est804->setFrame(globalFrame);

ui->est805->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "80    ") );
connect( ui->est805, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est805, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est805->installEventFilter(this);
ui->est805->setAlignment(Qt::AlignCenter);
ui->est805->setMaximumWidth( m12trail);
ui->est805->setMinimumWidth( m6trail);
ui->est805->setMaximumHeight( m7traild3 );
ui->est805->setMaxLength(11);
ui->est805->setFrame(globalFrame);

ui->est806->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "80    ") );
ui->est806->setReadOnly(true);
ui->est806->setAlignment(Qt::AlignRight);
ui->est806->setMaximumWidth( m14trail);
ui->est806->setMinimumWidth( m9trail);
ui->est806->setMaximumHeight( m7traild3 );
ui->est806->setMaxLength(15);
ui->est806->setFrame(globalFrame);

ui->est807->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "80    ") );
ui->est807->setReadOnly(true);
ui->est807->setAlignment(Qt::AlignRight);
ui->est807->setMaximumWidth( m14trail);
ui->est807->setMinimumWidth( m9trail);
ui->est807->setMaximumHeight( m7traild3 );
ui->est807->setMaxLength(15);
ui->est807->setFrame(globalFrame);

ui->lib811->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "81    ") );
connect( ui->lib811, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib811, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib81, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst81, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib811->installEventFilter(this);
ui->lib811->setMaximumWidth( m6trail);
ui->lib811->setMinimumWidth( m6trail);
ui->lib811->setMaximumHeight( m7traild3 );
ui->lib811->setMaxLength(3);
ui->lib811->setFrame(globalFrame);

ui->lib812->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "81    ") );
connect( ui->lib812, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib812, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib812->installEventFilter(this);
ui->lib812->setMaximumWidth( m26trail);
ui->lib812->setMinimumWidth( m25trail);
ui->lib812->setMaximumHeight( m7traild3 );
ui->lib812->setMaxLength(24);
ui->lib812->setFrame(globalFrame);

ui->lib813->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "81    ") );
connect( ui->lib813, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib813, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib813->installEventFilter(this);
ui->lib813->setAlignment(Qt::AlignCenter);
ui->lib813->setMaximumWidth( m12trail);
ui->lib813->setMinimumWidth( m6trail);
ui->lib813->setMaximumHeight( m7traild3 );
ui->lib813->setMaxLength(11);
ui->lib813->setFrame(globalFrame);

ui->lib814->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "81    ") );
connect( ui->lib814, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib814, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib814->installEventFilter(this);
ui->lib814->setAlignment(Qt::AlignCenter);
ui->lib814->setMaximumWidth( m12trail);
ui->lib814->setMinimumWidth( m6trail);
ui->lib814->setMaximumHeight( m7traild3 );
ui->lib814->setMaxLength(11);
ui->lib814->setFrame(globalFrame);

ui->pushButtonEst81->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "81    ") );
ui->pushButtonEst81->setMaximumWidth( m7traild3 );
ui->pushButtonEst81->setMaximumHeight( m7traild3 );
ui->pushButtonLib81->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "81    ") );
ui->pushButtonLib81->setMaximumWidth( m7traild3 );
ui->pushButtonLib81->setMaximumHeight( m7traild3 );

ui->est811->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "81    ") );
connect( ui->est811, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est811, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est811->installEventFilter(this);
ui->est811->setMaximumWidth( m6trail);
ui->est811->setMinimumWidth( m6trail);
ui->est811->setMaximumHeight( m7traild3 );
ui->est811->setMaxLength(3);
ui->est811->setFrame(globalFrame);

ui->est812->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "81    ") );
connect( ui->est812, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est812, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est812->installEventFilter(this);
ui->est812->setMaximumWidth( m26trail);
ui->est812->setMinimumWidth( m25trail);
ui->est812->setMaximumHeight( m7traild3 );
ui->est812->setMaxLength(24);
ui->est812->setFrame(globalFrame);

ui->est813->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "81    ") );
connect( ui->est813, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est813, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est813->installEventFilter(this);
ui->est813->setAlignment(Qt::AlignCenter);
ui->est813->setMaximumWidth( m11trail);
ui->est813->setMinimumWidth( m6trail);
ui->est813->setMaximumHeight( m7traild3 );
ui->est813->setMaxLength(8);
ui->est813->setFrame(globalFrame);

ui->est814->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "81    ") );
connect( ui->est814, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est814, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est814->installEventFilter(this);
ui->est814->setAlignment(Qt::AlignCenter);
ui->est814->setMaximumWidth( m12trail);
ui->est814->setMinimumWidth( m6trail);
ui->est814->setMaximumHeight( m7traild3 );
ui->est814->setMaxLength(11);
ui->est814->setFrame(globalFrame);

ui->est815->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "81    ") );
connect( ui->est815, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est815, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est815->installEventFilter(this);
ui->est815->setAlignment(Qt::AlignCenter);
ui->est815->setMaximumWidth( m12trail);
ui->est815->setMinimumWidth( m6trail);
ui->est815->setMaximumHeight( m7traild3 );
ui->est815->setMaxLength(11);
ui->est815->setFrame(globalFrame);

ui->est816->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "81    ") );
ui->est816->setReadOnly(true);
ui->est816->setAlignment(Qt::AlignRight);
ui->est816->setMaximumWidth( m14trail);
ui->est816->setMinimumWidth( m9trail);
ui->est816->setMaximumHeight( m7traild3 );
ui->est816->setMaxLength(15);
ui->est816->setFrame(globalFrame);

ui->est817->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "81    ") );
ui->est817->setReadOnly(true);
ui->est817->setAlignment(Qt::AlignRight);
ui->est817->setMaximumWidth( m14trail);
ui->est817->setMinimumWidth( m9trail);
ui->est817->setMaximumHeight( m7traild3 );
ui->est817->setMaxLength(15);
ui->est817->setFrame(globalFrame);

ui->lib821->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "82    ") );
connect( ui->lib821, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib821, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib82, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst82, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib821->installEventFilter(this);
ui->lib821->setMaximumWidth( m6trail);
ui->lib821->setMinimumWidth( m6trail);
ui->lib821->setMaximumHeight( m7traild3 );
ui->lib821->setMaxLength(3);
ui->lib821->setFrame(globalFrame);

ui->lib822->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "82    ") );
connect( ui->lib822, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib822, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib822->installEventFilter(this);
ui->lib822->setMaximumWidth( m26trail);
ui->lib822->setMinimumWidth( m25trail);
ui->lib822->setMaximumHeight( m7traild3 );
ui->lib822->setMaxLength(24);
ui->lib822->setFrame(globalFrame);

ui->lib823->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "82    ") );
connect( ui->lib823, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib823, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib823->installEventFilter(this);
ui->lib823->setAlignment(Qt::AlignCenter);
ui->lib823->setMaximumWidth( m12trail);
ui->lib823->setMinimumWidth( m6trail);
ui->lib823->setMaximumHeight( m7traild3 );
ui->lib823->setMaxLength(11);
ui->lib823->setFrame(globalFrame);

ui->lib824->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "82    ") );
connect( ui->lib824, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib824, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib824->installEventFilter(this);
ui->lib824->setAlignment(Qt::AlignCenter);
ui->lib824->setMaximumWidth( m12trail);
ui->lib824->setMinimumWidth( m6trail);
ui->lib824->setMaximumHeight( m7traild3 );
ui->lib824->setMaxLength(11);
ui->lib824->setFrame(globalFrame);

ui->pushButtonEst82->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "82    ") );
ui->pushButtonEst82->setMaximumWidth( m7traild3 );
ui->pushButtonEst82->setMaximumHeight( m7traild3 );
ui->pushButtonLib82->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "82    ") );
ui->pushButtonLib82->setMaximumWidth( m7traild3 );
ui->pushButtonLib82->setMaximumHeight( m7traild3 );

ui->est821->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "82    ") );
connect( ui->est821, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est821, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est821->installEventFilter(this);
ui->est821->setMaximumWidth( m6trail);
ui->est821->setMinimumWidth( m6trail);
ui->est821->setMaximumHeight( m7traild3 );
ui->est821->setMaxLength(3);
ui->est821->setFrame(globalFrame);

ui->est822->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "82    ") );
connect( ui->est822, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est822, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est822->installEventFilter(this);
ui->est822->setMaximumWidth( m26trail);
ui->est822->setMinimumWidth( m25trail);
ui->est822->setMaximumHeight( m7traild3 );
ui->est822->setMaxLength(24);
ui->est822->setFrame(globalFrame);

ui->est823->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "82    ") );
connect( ui->est823, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est823, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est823->installEventFilter(this);
ui->est823->setAlignment(Qt::AlignCenter);
ui->est823->setMaximumWidth( m11trail);
ui->est823->setMinimumWidth( m6trail);
ui->est823->setMaximumHeight( m7traild3 );
ui->est823->setMaxLength(8);
ui->est823->setFrame(globalFrame);

ui->est824->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "82    ") );
connect( ui->est824, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est824, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est824->installEventFilter(this);
ui->est824->setAlignment(Qt::AlignCenter);
ui->est824->setMaximumWidth( m12trail);
ui->est824->setMinimumWidth( m6trail);
ui->est824->setMaximumHeight( m7traild3 );
ui->est824->setMaxLength(11);
ui->est824->setFrame(globalFrame);

ui->est825->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "82    ") );
connect( ui->est825, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est825, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est825->installEventFilter(this);
ui->est825->setAlignment(Qt::AlignCenter);
ui->est825->setMaximumWidth( m12trail);
ui->est825->setMinimumWidth( m6trail);
ui->est825->setMaximumHeight( m7traild3 );
ui->est825->setMaxLength(11);
ui->est825->setFrame(globalFrame);

ui->est826->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "82    ") );
ui->est826->setReadOnly(true);
ui->est826->setAlignment(Qt::AlignRight);
ui->est826->setMaximumWidth( m14trail);
ui->est826->setMinimumWidth( m9trail);
ui->est826->setMaximumHeight( m7traild3 );
ui->est826->setMaxLength(15);
ui->est826->setFrame(globalFrame);

ui->est827->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "82    ") );
ui->est827->setReadOnly(true);
ui->est827->setAlignment(Qt::AlignRight);
ui->est827->setMaximumWidth( m14trail);
ui->est827->setMinimumWidth( m9trail);
ui->est827->setMaximumHeight( m7traild3 );
ui->est827->setMaxLength(15);
ui->est827->setFrame(globalFrame);

ui->lib831->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "83    ") );
connect( ui->lib831, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib831, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib83, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst83, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib831->installEventFilter(this);
ui->lib831->setMaximumWidth( m6trail);
ui->lib831->setMinimumWidth( m6trail);
ui->lib831->setMaximumHeight( m7traild3 );
ui->lib831->setMaxLength(3);
ui->lib831->setFrame(globalFrame);

ui->lib832->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "83    ") );
connect( ui->lib832, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib832, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib832->installEventFilter(this);
ui->lib832->setMaximumWidth( m26trail);
ui->lib832->setMinimumWidth( m25trail);
ui->lib832->setMaximumHeight( m7traild3 );
ui->lib832->setMaxLength(24);
ui->lib832->setFrame(globalFrame);

ui->lib833->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "83    ") );
connect( ui->lib833, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib833, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib833->installEventFilter(this);
ui->lib833->setAlignment(Qt::AlignCenter);
ui->lib833->setMaximumWidth( m12trail);
ui->lib833->setMinimumWidth( m6trail);
ui->lib833->setMaximumHeight( m7traild3 );
ui->lib833->setMaxLength(11);
ui->lib833->setFrame(globalFrame);

ui->lib834->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "83    ") );
connect( ui->lib834, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib834, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib834->installEventFilter(this);
ui->lib834->setAlignment(Qt::AlignCenter);
ui->lib834->setMaximumWidth( m12trail);
ui->lib834->setMinimumWidth( m6trail);
ui->lib834->setMaximumHeight( m7traild3 );
ui->lib834->setMaxLength(11);
ui->lib834->setFrame(globalFrame);

ui->pushButtonEst83->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "83    ") );
ui->pushButtonEst83->setMaximumWidth( m7traild3 );
ui->pushButtonEst83->setMaximumHeight( m7traild3 );
ui->pushButtonLib83->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "83    ") );
ui->pushButtonLib83->setMaximumWidth( m7traild3 );
ui->pushButtonLib83->setMaximumHeight( m7traild3 );

ui->est831->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "83    ") );
connect( ui->est831, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est831, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est831->installEventFilter(this);
ui->est831->setMaximumWidth( m6trail);
ui->est831->setMinimumWidth( m6trail);
ui->est831->setMaximumHeight( m7traild3 );
ui->est831->setMaxLength(3);
ui->est831->setFrame(globalFrame);

ui->est832->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "83    ") );
connect( ui->est832, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est832, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est832->installEventFilter(this);
ui->est832->setMaximumWidth( m26trail);
ui->est832->setMinimumWidth( m25trail);
ui->est832->setMaximumHeight( m7traild3 );
ui->est832->setMaxLength(24);
ui->est832->setFrame(globalFrame);

ui->est833->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "83    ") );
connect( ui->est833, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est833, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est833->installEventFilter(this);
ui->est833->setAlignment(Qt::AlignCenter);
ui->est833->setMaximumWidth( m11trail);
ui->est833->setMinimumWidth( m6trail);
ui->est833->setMaximumHeight( m7traild3 );
ui->est833->setMaxLength(8);
ui->est833->setFrame(globalFrame);

ui->est834->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "83    ") );
connect( ui->est834, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est834, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est834->installEventFilter(this);
ui->est834->setAlignment(Qt::AlignCenter);
ui->est834->setMaximumWidth( m12trail);
ui->est834->setMinimumWidth( m6trail);
ui->est834->setMaximumHeight( m7traild3 );
ui->est834->setMaxLength(11);
ui->est834->setFrame(globalFrame);

ui->est835->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "83    ") );
connect( ui->est835, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est835, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est835->installEventFilter(this);
ui->est835->setAlignment(Qt::AlignCenter);
ui->est835->setMaximumWidth( m12trail);
ui->est835->setMinimumWidth( m6trail);
ui->est835->setMaximumHeight( m7traild3 );
ui->est835->setMaxLength(11);
ui->est835->setFrame(globalFrame);

ui->est836->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "83    ") );
ui->est836->setReadOnly(true);
ui->est836->setAlignment(Qt::AlignRight);
ui->est836->setMaximumWidth( m14trail);
ui->est836->setMinimumWidth( m9trail);
ui->est836->setMaximumHeight( m7traild3 );
ui->est836->setMaxLength(15);
ui->est836->setFrame(globalFrame);

ui->est837->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "83    ") );
ui->est837->setReadOnly(true);
ui->est837->setAlignment(Qt::AlignRight);
ui->est837->setMaximumWidth( m14trail);
ui->est837->setMinimumWidth( m9trail);
ui->est837->setMaximumHeight( m7traild3 );
ui->est837->setMaxLength(15);
ui->est837->setFrame(globalFrame);

ui->lib841->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "84    ") );
connect( ui->lib841, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib841, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib84, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst84, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib841->installEventFilter(this);
ui->lib841->setMaximumWidth( m6trail);
ui->lib841->setMinimumWidth( m6trail);
ui->lib841->setMaximumHeight( m7traild3 );
ui->lib841->setMaxLength(3);
ui->lib841->setFrame(globalFrame);

ui->lib842->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "84    ") );
connect( ui->lib842, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib842, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib842->installEventFilter(this);
ui->lib842->setMaximumWidth( m26trail);
ui->lib842->setMinimumWidth( m25trail);
ui->lib842->setMaximumHeight( m7traild3 );
ui->lib842->setMaxLength(24);
ui->lib842->setFrame(globalFrame);

ui->lib843->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "84    ") );
connect( ui->lib843, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib843, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib843->installEventFilter(this);
ui->lib843->setAlignment(Qt::AlignCenter);
ui->lib843->setMaximumWidth( m12trail);
ui->lib843->setMinimumWidth( m6trail);
ui->lib843->setMaximumHeight( m7traild3 );
ui->lib843->setMaxLength(11);
ui->lib843->setFrame(globalFrame);

ui->lib844->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "84    ") );
connect( ui->lib844, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib844, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib844->installEventFilter(this);
ui->lib844->setAlignment(Qt::AlignCenter);
ui->lib844->setMaximumWidth( m12trail);
ui->lib844->setMinimumWidth( m6trail);
ui->lib844->setMaximumHeight( m7traild3 );
ui->lib844->setMaxLength(11);
ui->lib844->setFrame(globalFrame);

ui->pushButtonEst84->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "84    ") );
ui->pushButtonEst84->setMaximumWidth( m7traild3 );
ui->pushButtonEst84->setMaximumHeight( m7traild3 );
ui->pushButtonLib84->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "84    ") );
ui->pushButtonLib84->setMaximumWidth( m7traild3 );
ui->pushButtonLib84->setMaximumHeight( m7traild3 );

ui->est841->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "84    ") );
connect( ui->est841, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est841, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est841->installEventFilter(this);
ui->est841->setMaximumWidth( m6trail);
ui->est841->setMinimumWidth( m6trail);
ui->est841->setMaximumHeight( m7traild3 );
ui->est841->setMaxLength(3);
ui->est841->setFrame(globalFrame);

ui->est842->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "84    ") );
connect( ui->est842, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est842, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est842->installEventFilter(this);
ui->est842->setMaximumWidth( m26trail);
ui->est842->setMinimumWidth( m25trail);
ui->est842->setMaximumHeight( m7traild3 );
ui->est842->setMaxLength(24);
ui->est842->setFrame(globalFrame);

ui->est843->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "84    ") );
connect( ui->est843, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est843, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est843->installEventFilter(this);
ui->est843->setAlignment(Qt::AlignCenter);
ui->est843->setMaximumWidth( m11trail);
ui->est843->setMinimumWidth( m6trail);
ui->est843->setMaximumHeight( m7traild3 );
ui->est843->setMaxLength(8);
ui->est843->setFrame(globalFrame);

ui->est844->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "84    ") );
connect( ui->est844, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est844, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est844->installEventFilter(this);
ui->est844->setAlignment(Qt::AlignCenter);
ui->est844->setMaximumWidth( m12trail);
ui->est844->setMinimumWidth( m6trail);
ui->est844->setMaximumHeight( m7traild3 );
ui->est844->setMaxLength(11);
ui->est844->setFrame(globalFrame);

ui->est845->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "84    ") );
connect( ui->est845, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est845, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est845->installEventFilter(this);
ui->est845->setAlignment(Qt::AlignCenter);
ui->est845->setMaximumWidth( m12trail);
ui->est845->setMinimumWidth( m6trail);
ui->est845->setMaximumHeight( m7traild3 );
ui->est845->setMaxLength(11);
ui->est845->setFrame(globalFrame);

ui->est846->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "84    ") );
ui->est846->setReadOnly(true);
ui->est846->setAlignment(Qt::AlignRight);
ui->est846->setMaximumWidth( m14trail);
ui->est846->setMinimumWidth( m9trail);
ui->est846->setMaximumHeight( m7traild3 );
ui->est846->setMaxLength(15);
ui->est846->setFrame(globalFrame);

ui->est847->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "84    ") );
ui->est847->setReadOnly(true);
ui->est847->setAlignment(Qt::AlignRight);
ui->est847->setMaximumWidth( m14trail);
ui->est847->setMinimumWidth( m9trail);
ui->est847->setMaximumHeight( m7traild3 );
ui->est847->setMaxLength(15);
ui->est847->setFrame(globalFrame);

ui->lib851->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "85    ") );
connect( ui->lib851, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib851, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib85, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst85, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib851->installEventFilter(this);
ui->lib851->setMaximumWidth( m6trail);
ui->lib851->setMinimumWidth( m6trail);
ui->lib851->setMaximumHeight( m7traild3 );
ui->lib851->setMaxLength(3);
ui->lib851->setFrame(globalFrame);

ui->lib852->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "85    ") );
connect( ui->lib852, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib852, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib852->installEventFilter(this);
ui->lib852->setMaximumWidth( m26trail);
ui->lib852->setMinimumWidth( m25trail);
ui->lib852->setMaximumHeight( m7traild3 );
ui->lib852->setMaxLength(24);
ui->lib852->setFrame(globalFrame);

ui->lib853->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "85    ") );
connect( ui->lib853, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib853, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib853->installEventFilter(this);
ui->lib853->setAlignment(Qt::AlignCenter);
ui->lib853->setMaximumWidth( m12trail);
ui->lib853->setMinimumWidth( m6trail);
ui->lib853->setMaximumHeight( m7traild3 );
ui->lib853->setMaxLength(11);
ui->lib853->setFrame(globalFrame);

ui->lib854->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "85    ") );
connect( ui->lib854, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib854, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib854->installEventFilter(this);
ui->lib854->setAlignment(Qt::AlignCenter);
ui->lib854->setMaximumWidth( m12trail);
ui->lib854->setMinimumWidth( m6trail);
ui->lib854->setMaximumHeight( m7traild3 );
ui->lib854->setMaxLength(11);
ui->lib854->setFrame(globalFrame);

ui->pushButtonEst85->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "85    ") );
ui->pushButtonEst85->setMaximumWidth( m7traild3 );
ui->pushButtonEst85->setMaximumHeight( m7traild3 );
ui->pushButtonLib85->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "85    ") );
ui->pushButtonLib85->setMaximumWidth( m7traild3 );
ui->pushButtonLib85->setMaximumHeight( m7traild3 );

ui->est851->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "85    ") );
connect( ui->est851, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est851, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est851->installEventFilter(this);
ui->est851->setMaximumWidth( m6trail);
ui->est851->setMinimumWidth( m6trail);
ui->est851->setMaximumHeight( m7traild3 );
ui->est851->setMaxLength(3);
ui->est851->setFrame(globalFrame);

ui->est852->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "85    ") );
connect( ui->est852, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est852, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est852->installEventFilter(this);
ui->est852->setMaximumWidth( m26trail);
ui->est852->setMinimumWidth( m25trail);
ui->est852->setMaximumHeight( m7traild3 );
ui->est852->setMaxLength(24);
ui->est852->setFrame(globalFrame);

ui->est853->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "85    ") );
connect( ui->est853, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est853, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est853->installEventFilter(this);
ui->est853->setAlignment(Qt::AlignCenter);
ui->est853->setMaximumWidth( m11trail);
ui->est853->setMinimumWidth( m6trail);
ui->est853->setMaximumHeight( m7traild3 );
ui->est853->setMaxLength(8);
ui->est853->setFrame(globalFrame);

ui->est854->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "85    ") );
connect( ui->est854, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est854, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est854->installEventFilter(this);
ui->est854->setAlignment(Qt::AlignCenter);
ui->est854->setMaximumWidth( m12trail);
ui->est854->setMinimumWidth( m6trail);
ui->est854->setMaximumHeight( m7traild3 );
ui->est854->setMaxLength(11);
ui->est854->setFrame(globalFrame);

ui->est855->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "85    ") );
connect( ui->est855, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est855, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est855->installEventFilter(this);
ui->est855->setAlignment(Qt::AlignCenter);
ui->est855->setMaximumWidth( m12trail);
ui->est855->setMinimumWidth( m6trail);
ui->est855->setMaximumHeight( m7traild3 );
ui->est855->setMaxLength(11);
ui->est855->setFrame(globalFrame);

ui->est856->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "85    ") );
ui->est856->setReadOnly(true);
ui->est856->setAlignment(Qt::AlignRight);
ui->est856->setMaximumWidth( m14trail);
ui->est856->setMinimumWidth( m9trail);
ui->est856->setMaximumHeight( m7traild3 );
ui->est856->setMaxLength(15);
ui->est856->setFrame(globalFrame);

ui->est857->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "85    ") );
ui->est857->setReadOnly(true);
ui->est857->setAlignment(Qt::AlignRight);
ui->est857->setMaximumWidth( m14trail);
ui->est857->setMinimumWidth( m9trail);
ui->est857->setMaximumHeight( m7traild3 );
ui->est857->setMaxLength(15);
ui->est857->setFrame(globalFrame);

ui->lib861->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "86    ") );
connect( ui->lib861, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib861, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib86, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst86, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib861->installEventFilter(this);
ui->lib861->setMaximumWidth( m6trail);
ui->lib861->setMinimumWidth( m6trail);
ui->lib861->setMaximumHeight( m7traild3 );
ui->lib861->setMaxLength(3);
ui->lib861->setFrame(globalFrame);

ui->lib862->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "86    ") );
connect( ui->lib862, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib862, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib862->installEventFilter(this);
ui->lib862->setMaximumWidth( m26trail);
ui->lib862->setMinimumWidth( m25trail);
ui->lib862->setMaximumHeight( m7traild3 );
ui->lib862->setMaxLength(24);
ui->lib862->setFrame(globalFrame);

ui->lib863->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "86    ") );
connect( ui->lib863, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib863, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib863->installEventFilter(this);
ui->lib863->setAlignment(Qt::AlignCenter);
ui->lib863->setMaximumWidth( m12trail);
ui->lib863->setMinimumWidth( m6trail);
ui->lib863->setMaximumHeight( m7traild3 );
ui->lib863->setMaxLength(11);
ui->lib863->setFrame(globalFrame);

ui->lib864->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "86    ") );
connect( ui->lib864, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib864, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib864->installEventFilter(this);
ui->lib864->setAlignment(Qt::AlignCenter);
ui->lib864->setMaximumWidth( m12trail);
ui->lib864->setMinimumWidth( m6trail);
ui->lib864->setMaximumHeight( m7traild3 );
ui->lib864->setMaxLength(11);
ui->lib864->setFrame(globalFrame);

ui->pushButtonEst86->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "86    ") );
ui->pushButtonEst86->setMaximumWidth( m7traild3 );
ui->pushButtonEst86->setMaximumHeight( m7traild3 );
ui->pushButtonLib86->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "86    ") );
ui->pushButtonLib86->setMaximumWidth( m7traild3 );
ui->pushButtonLib86->setMaximumHeight( m7traild3 );

ui->est861->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "86    ") );
connect( ui->est861, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est861, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est861->installEventFilter(this);
ui->est861->setMaximumWidth( m6trail);
ui->est861->setMinimumWidth( m6trail);
ui->est861->setMaximumHeight( m7traild3 );
ui->est861->setMaxLength(3);
ui->est861->setFrame(globalFrame);

ui->est862->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "86    ") );
connect( ui->est862, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est862, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est862->installEventFilter(this);
ui->est862->setMaximumWidth( m26trail);
ui->est862->setMinimumWidth( m25trail);
ui->est862->setMaximumHeight( m7traild3 );
ui->est862->setMaxLength(24);
ui->est862->setFrame(globalFrame);

ui->est863->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "86    ") );
connect( ui->est863, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est863, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est863->installEventFilter(this);
ui->est863->setAlignment(Qt::AlignCenter);
ui->est863->setMaximumWidth( m11trail);
ui->est863->setMinimumWidth( m6trail);
ui->est863->setMaximumHeight( m7traild3 );
ui->est863->setMaxLength(8);
ui->est863->setFrame(globalFrame);

ui->est864->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "86    ") );
connect( ui->est864, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est864, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est864->installEventFilter(this);
ui->est864->setAlignment(Qt::AlignCenter);
ui->est864->setMaximumWidth( m12trail);
ui->est864->setMinimumWidth( m6trail);
ui->est864->setMaximumHeight( m7traild3 );
ui->est864->setMaxLength(11);
ui->est864->setFrame(globalFrame);

ui->est865->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "86    ") );
connect( ui->est865, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est865, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est865->installEventFilter(this);
ui->est865->setAlignment(Qt::AlignCenter);
ui->est865->setMaximumWidth( m12trail);
ui->est865->setMinimumWidth( m6trail);
ui->est865->setMaximumHeight( m7traild3 );
ui->est865->setMaxLength(11);
ui->est865->setFrame(globalFrame);

ui->est866->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "86    ") );
ui->est866->setReadOnly(true);
ui->est866->setAlignment(Qt::AlignRight);
ui->est866->setMaximumWidth( m14trail);
ui->est866->setMinimumWidth( m9trail);
ui->est866->setMaximumHeight( m7traild3 );
ui->est866->setMaxLength(15);
ui->est866->setFrame(globalFrame);

ui->est867->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "86    ") );
ui->est867->setReadOnly(true);
ui->est867->setAlignment(Qt::AlignRight);
ui->est867->setMaximumWidth( m14trail);
ui->est867->setMinimumWidth( m9trail);
ui->est867->setMaximumHeight( m7traild3 );
ui->est867->setMaxLength(15);
ui->est867->setFrame(globalFrame);

ui->lib871->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "87    ") );
connect( ui->lib871, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib871, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib87, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst87, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib871->installEventFilter(this);
ui->lib871->setMaximumWidth( m6trail);
ui->lib871->setMinimumWidth( m6trail);
ui->lib871->setMaximumHeight( m7traild3 );
ui->lib871->setMaxLength(3);
ui->lib871->setFrame(globalFrame);

ui->lib872->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "87    ") );
connect( ui->lib872, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib872, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib872->installEventFilter(this);
ui->lib872->setMaximumWidth( m26trail);
ui->lib872->setMinimumWidth( m25trail);
ui->lib872->setMaximumHeight( m7traild3 );
ui->lib872->setMaxLength(24);
ui->lib872->setFrame(globalFrame);

ui->lib873->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "87    ") );
connect( ui->lib873, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib873, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib873->installEventFilter(this);
ui->lib873->setAlignment(Qt::AlignCenter);
ui->lib873->setMaximumWidth( m12trail);
ui->lib873->setMinimumWidth( m6trail);
ui->lib873->setMaximumHeight( m7traild3 );
ui->lib873->setMaxLength(11);
ui->lib873->setFrame(globalFrame);

ui->lib874->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "87    ") );
connect( ui->lib874, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib874, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib874->installEventFilter(this);
ui->lib874->setAlignment(Qt::AlignCenter);
ui->lib874->setMaximumWidth( m12trail);
ui->lib874->setMinimumWidth( m6trail);
ui->lib874->setMaximumHeight( m7traild3 );
ui->lib874->setMaxLength(11);
ui->lib874->setFrame(globalFrame);

ui->pushButtonEst87->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "87    ") );
ui->pushButtonEst87->setMaximumWidth( m7traild3 );
ui->pushButtonEst87->setMaximumHeight( m7traild3 );
ui->pushButtonLib87->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "87    ") );
ui->pushButtonLib87->setMaximumWidth( m7traild3 );
ui->pushButtonLib87->setMaximumHeight( m7traild3 );

ui->est871->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "87    ") );
connect( ui->est871, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est871, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est871->installEventFilter(this);
ui->est871->setMaximumWidth( m6trail);
ui->est871->setMinimumWidth( m6trail);
ui->est871->setMaximumHeight( m7traild3 );
ui->est871->setMaxLength(3);
ui->est871->setFrame(globalFrame);

ui->est872->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "87    ") );
connect( ui->est872, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est872, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est872->installEventFilter(this);
ui->est872->setMaximumWidth( m26trail);
ui->est872->setMinimumWidth( m25trail);
ui->est872->setMaximumHeight( m7traild3 );
ui->est872->setMaxLength(24);
ui->est872->setFrame(globalFrame);

ui->est873->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "87    ") );
connect( ui->est873, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est873, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est873->installEventFilter(this);
ui->est873->setAlignment(Qt::AlignCenter);
ui->est873->setMaximumWidth( m11trail);
ui->est873->setMinimumWidth( m6trail);
ui->est873->setMaximumHeight( m7traild3 );
ui->est873->setMaxLength(8);
ui->est873->setFrame(globalFrame);

ui->est874->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "87    ") );
connect( ui->est874, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est874, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est874->installEventFilter(this);
ui->est874->setAlignment(Qt::AlignCenter);
ui->est874->setMaximumWidth( m12trail);
ui->est874->setMinimumWidth( m6trail);
ui->est874->setMaximumHeight( m7traild3 );
ui->est874->setMaxLength(11);
ui->est874->setFrame(globalFrame);

ui->est875->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "87    ") );
connect( ui->est875, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est875, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est875->installEventFilter(this);
ui->est875->setAlignment(Qt::AlignCenter);
ui->est875->setMaximumWidth( m12trail);
ui->est875->setMinimumWidth( m6trail);
ui->est875->setMaximumHeight( m7traild3 );
ui->est875->setMaxLength(11);
ui->est875->setFrame(globalFrame);

ui->est876->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "87    ") );
ui->est876->setReadOnly(true);
ui->est876->setAlignment(Qt::AlignRight);
ui->est876->setMaximumWidth( m14trail);
ui->est876->setMinimumWidth( m9trail);
ui->est876->setMaximumHeight( m7traild3 );
ui->est876->setMaxLength(15);
ui->est876->setFrame(globalFrame);

ui->est877->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "87    ") );
ui->est877->setReadOnly(true);
ui->est877->setAlignment(Qt::AlignRight);
ui->est877->setMaximumWidth( m14trail);
ui->est877->setMinimumWidth( m9trail);
ui->est877->setMaximumHeight( m7traild3 );
ui->est877->setMaxLength(15);
ui->est877->setFrame(globalFrame);

ui->lib881->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "88    ") );
connect( ui->lib881, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib881, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib88, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst88, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib881->installEventFilter(this);
ui->lib881->setMaximumWidth( m6trail);
ui->lib881->setMinimumWidth( m6trail);
ui->lib881->setMaximumHeight( m7traild3 );
ui->lib881->setMaxLength(3);
ui->lib881->setFrame(globalFrame);

ui->lib882->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "88    ") );
connect( ui->lib882, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib882, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib882->installEventFilter(this);
ui->lib882->setMaximumWidth( m26trail);
ui->lib882->setMinimumWidth( m25trail);
ui->lib882->setMaximumHeight( m7traild3 );
ui->lib882->setMaxLength(24);
ui->lib882->setFrame(globalFrame);

ui->lib883->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "88    ") );
connect( ui->lib883, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib883, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib883->installEventFilter(this);
ui->lib883->setAlignment(Qt::AlignCenter);
ui->lib883->setMaximumWidth( m12trail);
ui->lib883->setMinimumWidth( m6trail);
ui->lib883->setMaximumHeight( m7traild3 );
ui->lib883->setMaxLength(11);
ui->lib883->setFrame(globalFrame);

ui->lib884->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "88    ") );
connect( ui->lib884, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib884, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib884->installEventFilter(this);
ui->lib884->setAlignment(Qt::AlignCenter);
ui->lib884->setMaximumWidth( m12trail);
ui->lib884->setMinimumWidth( m6trail);
ui->lib884->setMaximumHeight( m7traild3 );
ui->lib884->setMaxLength(11);
ui->lib884->setFrame(globalFrame);

ui->pushButtonEst88->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "88    ") );
ui->pushButtonEst88->setMaximumWidth( m7traild3 );
ui->pushButtonEst88->setMaximumHeight( m7traild3 );
ui->pushButtonLib88->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "88    ") );
ui->pushButtonLib88->setMaximumWidth( m7traild3 );
ui->pushButtonLib88->setMaximumHeight( m7traild3 );

ui->est881->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "88    ") );
connect( ui->est881, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est881, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est881->installEventFilter(this);
ui->est881->setMaximumWidth( m6trail);
ui->est881->setMinimumWidth( m6trail);
ui->est881->setMaximumHeight( m7traild3 );
ui->est881->setMaxLength(3);
ui->est881->setFrame(globalFrame);

ui->est882->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "88    ") );
connect( ui->est882, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est882, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est882->installEventFilter(this);
ui->est882->setMaximumWidth( m26trail);
ui->est882->setMinimumWidth( m25trail);
ui->est882->setMaximumHeight( m7traild3 );
ui->est882->setMaxLength(24);
ui->est882->setFrame(globalFrame);

ui->est883->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "88    ") );
connect( ui->est883, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est883, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est883->installEventFilter(this);
ui->est883->setAlignment(Qt::AlignCenter);
ui->est883->setMaximumWidth( m11trail);
ui->est883->setMinimumWidth( m6trail);
ui->est883->setMaximumHeight( m7traild3 );
ui->est883->setMaxLength(8);
ui->est883->setFrame(globalFrame);

ui->est884->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "88    ") );
connect( ui->est884, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est884, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est884->installEventFilter(this);
ui->est884->setAlignment(Qt::AlignCenter);
ui->est884->setMaximumWidth( m12trail);
ui->est884->setMinimumWidth( m6trail);
ui->est884->setMaximumHeight( m7traild3 );
ui->est884->setMaxLength(11);
ui->est884->setFrame(globalFrame);

ui->est885->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "88    ") );
connect( ui->est885, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est885, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est885->installEventFilter(this);
ui->est885->setAlignment(Qt::AlignCenter);
ui->est885->setMaximumWidth( m12trail);
ui->est885->setMinimumWidth( m6trail);
ui->est885->setMaximumHeight( m7traild3 );
ui->est885->setMaxLength(11);
ui->est885->setFrame(globalFrame);

ui->est886->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "88    ") );
ui->est886->setReadOnly(true);
ui->est886->setAlignment(Qt::AlignRight);
ui->est886->setMaximumWidth( m14trail);
ui->est886->setMinimumWidth( m9trail);
ui->est886->setMaximumHeight( m7traild3 );
ui->est886->setMaxLength(15);
ui->est886->setFrame(globalFrame);

ui->est887->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "88    ") );
ui->est887->setReadOnly(true);
ui->est887->setAlignment(Qt::AlignRight);
ui->est887->setMaximumWidth( m14trail);
ui->est887->setMinimumWidth( m9trail);
ui->est887->setMaximumHeight( m7traild3 );
ui->est887->setMaxLength(15);
ui->est887->setFrame(globalFrame);

ui->lib891->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "89    ") );
connect( ui->lib891, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib891, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib89, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst89, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib891->installEventFilter(this);
ui->lib891->setMaximumWidth( m6trail);
ui->lib891->setMinimumWidth( m6trail);
ui->lib891->setMaximumHeight( m7traild3 );
ui->lib891->setMaxLength(3);
ui->lib891->setFrame(globalFrame);

ui->lib892->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "89    ") );
connect( ui->lib892, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib892, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib892->installEventFilter(this);
ui->lib892->setMaximumWidth( m26trail);
ui->lib892->setMinimumWidth( m25trail);
ui->lib892->setMaximumHeight( m7traild3 );
ui->lib892->setMaxLength(24);
ui->lib892->setFrame(globalFrame);

ui->lib893->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "89    ") );
connect( ui->lib893, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib893, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib893->installEventFilter(this);
ui->lib893->setAlignment(Qt::AlignCenter);
ui->lib893->setMaximumWidth( m12trail);
ui->lib893->setMinimumWidth( m6trail);
ui->lib893->setMaximumHeight( m7traild3 );
ui->lib893->setMaxLength(11);
ui->lib893->setFrame(globalFrame);

ui->lib894->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "89    ") );
connect( ui->lib894, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib894, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib894->installEventFilter(this);
ui->lib894->setAlignment(Qt::AlignCenter);
ui->lib894->setMaximumWidth( m12trail);
ui->lib894->setMinimumWidth( m6trail);
ui->lib894->setMaximumHeight( m7traild3 );
ui->lib894->setMaxLength(11);
ui->lib894->setFrame(globalFrame);

ui->pushButtonEst89->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "89    ") );
ui->pushButtonEst89->setMaximumWidth( m7traild3 );
ui->pushButtonEst89->setMaximumHeight( m7traild3 );
ui->pushButtonLib89->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "89    ") );
ui->pushButtonLib89->setMaximumWidth( m7traild3 );
ui->pushButtonLib89->setMaximumHeight( m7traild3 );

ui->est891->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "89    ") );
connect( ui->est891, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est891, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est891->installEventFilter(this);
ui->est891->setMaximumWidth( m6trail);
ui->est891->setMinimumWidth( m6trail);
ui->est891->setMaximumHeight( m7traild3 );
ui->est891->setMaxLength(3);
ui->est891->setFrame(globalFrame);

ui->est892->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "89    ") );
connect( ui->est892, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est892, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est892->installEventFilter(this);
ui->est892->setMaximumWidth( m26trail);
ui->est892->setMinimumWidth( m25trail);
ui->est892->setMaximumHeight( m7traild3 );
ui->est892->setMaxLength(24);
ui->est892->setFrame(globalFrame);

ui->est893->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "89    ") );
connect( ui->est893, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est893, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est893->installEventFilter(this);
ui->est893->setAlignment(Qt::AlignCenter);
ui->est893->setMaximumWidth( m11trail);
ui->est893->setMinimumWidth( m6trail);
ui->est893->setMaximumHeight( m7traild3 );
ui->est893->setMaxLength(8);
ui->est893->setFrame(globalFrame);

ui->est894->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "89    ") );
connect( ui->est894, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est894, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est894->installEventFilter(this);
ui->est894->setAlignment(Qt::AlignCenter);
ui->est894->setMaximumWidth( m12trail);
ui->est894->setMinimumWidth( m6trail);
ui->est894->setMaximumHeight( m7traild3 );
ui->est894->setMaxLength(11);
ui->est894->setFrame(globalFrame);

ui->est895->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "89    ") );
connect( ui->est895, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est895, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est895->installEventFilter(this);
ui->est895->setAlignment(Qt::AlignCenter);
ui->est895->setMaximumWidth( m12trail);
ui->est895->setMinimumWidth( m6trail);
ui->est895->setMaximumHeight( m7traild3 );
ui->est895->setMaxLength(11);
ui->est895->setFrame(globalFrame);

ui->est896->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "89    ") );
ui->est896->setReadOnly(true);
ui->est896->setAlignment(Qt::AlignRight);
ui->est896->setMaximumWidth( m14trail);
ui->est896->setMinimumWidth( m9trail);
ui->est896->setMaximumHeight( m7traild3 );
ui->est896->setMaxLength(15);
ui->est896->setFrame(globalFrame);

ui->est897->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "89    ") );
ui->est897->setReadOnly(true);
ui->est897->setAlignment(Qt::AlignRight);
ui->est897->setMaximumWidth( m14trail);
ui->est897->setMinimumWidth( m9trail);
ui->est897->setMaximumHeight( m7traild3 );
ui->est897->setMaxLength(15);
ui->est897->setFrame(globalFrame);

ui->lib901->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "90    ") );
connect( ui->lib901, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib901, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib90, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst90, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib901->installEventFilter(this);
ui->lib901->setMaximumWidth( m6trail);
ui->lib901->setMinimumWidth( m6trail);
ui->lib901->setMaximumHeight( m7traild3 );
ui->lib901->setMaxLength(3);
ui->lib901->setFrame(globalFrame);

ui->lib902->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "90    ") );
connect( ui->lib902, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib902, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib902->installEventFilter(this);
ui->lib902->setMaximumWidth( m26trail);
ui->lib902->setMinimumWidth( m25trail);
ui->lib902->setMaximumHeight( m7traild3 );
ui->lib902->setMaxLength(24);
ui->lib902->setFrame(globalFrame);

ui->lib903->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "90    ") );
connect( ui->lib903, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib903, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib903->installEventFilter(this);
ui->lib903->setAlignment(Qt::AlignCenter);
ui->lib903->setMaximumWidth( m12trail);
ui->lib903->setMinimumWidth( m6trail);
ui->lib903->setMaximumHeight( m7traild3 );
ui->lib903->setMaxLength(11);
ui->lib903->setFrame(globalFrame);

ui->lib904->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "90    ") );
connect( ui->lib904, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib904, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib904->installEventFilter(this);
ui->lib904->setAlignment(Qt::AlignCenter);
ui->lib904->setMaximumWidth( m12trail);
ui->lib904->setMinimumWidth( m6trail);
ui->lib904->setMaximumHeight( m7traild3 );
ui->lib904->setMaxLength(11);
ui->lib904->setFrame(globalFrame);

ui->pushButtonEst90->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "90    ") );
ui->pushButtonEst90->setMaximumWidth( m7traild3 );
ui->pushButtonEst90->setMaximumHeight( m7traild3 );
ui->pushButtonLib90->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "90    ") );
ui->pushButtonLib90->setMaximumWidth( m7traild3 );
ui->pushButtonLib90->setMaximumHeight( m7traild3 );

ui->est901->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "90    ") );
connect( ui->est901, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est901, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est901->installEventFilter(this);
ui->est901->setMaximumWidth( m6trail);
ui->est901->setMinimumWidth( m6trail);
ui->est901->setMaximumHeight( m7traild3 );
ui->est901->setMaxLength(3);
ui->est901->setFrame(globalFrame);

ui->est902->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "90    ") );
connect( ui->est902, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est902, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est902->installEventFilter(this);
ui->est902->setMaximumWidth( m26trail);
ui->est902->setMinimumWidth( m25trail);
ui->est902->setMaximumHeight( m7traild3 );
ui->est902->setMaxLength(24);
ui->est902->setFrame(globalFrame);

ui->est903->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "90    ") );
connect( ui->est903, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est903, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est903->installEventFilter(this);
ui->est903->setAlignment(Qt::AlignCenter);
ui->est903->setMaximumWidth( m11trail);
ui->est903->setMinimumWidth( m6trail);
ui->est903->setMaximumHeight( m7traild3 );
ui->est903->setMaxLength(8);
ui->est903->setFrame(globalFrame);

ui->est904->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "90    ") );
connect( ui->est904, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est904, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est904->installEventFilter(this);
ui->est904->setAlignment(Qt::AlignCenter);
ui->est904->setMaximumWidth( m12trail);
ui->est904->setMinimumWidth( m6trail);
ui->est904->setMaximumHeight( m7traild3 );
ui->est904->setMaxLength(11);
ui->est904->setFrame(globalFrame);

ui->est905->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "90    ") );
connect( ui->est905, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est905, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est905->installEventFilter(this);
ui->est905->setAlignment(Qt::AlignCenter);
ui->est905->setMaximumWidth( m12trail);
ui->est905->setMinimumWidth( m6trail);
ui->est905->setMaximumHeight( m7traild3 );
ui->est905->setMaxLength(11);
ui->est905->setFrame(globalFrame);

ui->est906->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "90    ") );
ui->est906->setReadOnly(true);
ui->est906->setAlignment(Qt::AlignRight);
ui->est906->setMaximumWidth( m14trail);
ui->est906->setMinimumWidth( m9trail);
ui->est906->setMaximumHeight( m7traild3 );
ui->est906->setMaxLength(15);
ui->est906->setFrame(globalFrame);

ui->est907->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "90    ") );
ui->est907->setReadOnly(true);
ui->est907->setAlignment(Qt::AlignRight);
ui->est907->setMaximumWidth( m14trail);
ui->est907->setMinimumWidth( m9trail);
ui->est907->setMaximumHeight( m7traild3 );
ui->est907->setMaxLength(15);
ui->est907->setFrame(globalFrame);

ui->lib911->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "91    ") );
connect( ui->lib911, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib911, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib91, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst91, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib911->installEventFilter(this);
ui->lib911->setMaximumWidth( m6trail);
ui->lib911->setMinimumWidth( m6trail);
ui->lib911->setMaximumHeight( m7traild3 );
ui->lib911->setMaxLength(3);
ui->lib911->setFrame(globalFrame);

ui->lib912->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "91    ") );
connect( ui->lib912, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib912, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib912->installEventFilter(this);
ui->lib912->setMaximumWidth( m26trail);
ui->lib912->setMinimumWidth( m25trail);
ui->lib912->setMaximumHeight( m7traild3 );
ui->lib912->setMaxLength(24);
ui->lib912->setFrame(globalFrame);

ui->lib913->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "91    ") );
connect( ui->lib913, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib913, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib913->installEventFilter(this);
ui->lib913->setAlignment(Qt::AlignCenter);
ui->lib913->setMaximumWidth( m12trail);
ui->lib913->setMinimumWidth( m6trail);
ui->lib913->setMaximumHeight( m7traild3 );
ui->lib913->setMaxLength(11);
ui->lib913->setFrame(globalFrame);

ui->lib914->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "91    ") );
connect( ui->lib914, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib914, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib914->installEventFilter(this);
ui->lib914->setAlignment(Qt::AlignCenter);
ui->lib914->setMaximumWidth( m12trail);
ui->lib914->setMinimumWidth( m6trail);
ui->lib914->setMaximumHeight( m7traild3 );
ui->lib914->setMaxLength(11);
ui->lib914->setFrame(globalFrame);

ui->pushButtonEst91->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "91    ") );
ui->pushButtonEst91->setMaximumWidth( m7traild3 );
ui->pushButtonEst91->setMaximumHeight( m7traild3 );
ui->pushButtonLib91->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "91    ") );
ui->pushButtonLib91->setMaximumWidth( m7traild3 );
ui->pushButtonLib91->setMaximumHeight( m7traild3 );

ui->est911->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "91    ") );
connect( ui->est911, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est911, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est911->installEventFilter(this);
ui->est911->setMaximumWidth( m6trail);
ui->est911->setMinimumWidth( m6trail);
ui->est911->setMaximumHeight( m7traild3 );
ui->est911->setMaxLength(3);
ui->est911->setFrame(globalFrame);

ui->est912->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "91    ") );
connect( ui->est912, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est912, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est912->installEventFilter(this);
ui->est912->setMaximumWidth( m26trail);
ui->est912->setMinimumWidth( m25trail);
ui->est912->setMaximumHeight( m7traild3 );
ui->est912->setMaxLength(24);
ui->est912->setFrame(globalFrame);

ui->est913->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "91    ") );
connect( ui->est913, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est913, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est913->installEventFilter(this);
ui->est913->setAlignment(Qt::AlignCenter);
ui->est913->setMaximumWidth( m11trail);
ui->est913->setMinimumWidth( m6trail);
ui->est913->setMaximumHeight( m7traild3 );
ui->est913->setMaxLength(8);
ui->est913->setFrame(globalFrame);

ui->est914->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "91    ") );
connect( ui->est914, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est914, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est914->installEventFilter(this);
ui->est914->setAlignment(Qt::AlignCenter);
ui->est914->setMaximumWidth( m12trail);
ui->est914->setMinimumWidth( m6trail);
ui->est914->setMaximumHeight( m7traild3 );
ui->est914->setMaxLength(11);
ui->est914->setFrame(globalFrame);

ui->est915->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "91    ") );
connect( ui->est915, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est915, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est915->installEventFilter(this);
ui->est915->setAlignment(Qt::AlignCenter);
ui->est915->setMaximumWidth( m12trail);
ui->est915->setMinimumWidth( m6trail);
ui->est915->setMaximumHeight( m7traild3 );
ui->est915->setMaxLength(11);
ui->est915->setFrame(globalFrame);

ui->est916->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "91    ") );
ui->est916->setReadOnly(true);
ui->est916->setAlignment(Qt::AlignRight);
ui->est916->setMaximumWidth( m14trail);
ui->est916->setMinimumWidth( m9trail);
ui->est916->setMaximumHeight( m7traild3 );
ui->est916->setMaxLength(15);
ui->est916->setFrame(globalFrame);

ui->est917->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "91    ") );
ui->est917->setReadOnly(true);
ui->est917->setAlignment(Qt::AlignRight);
ui->est917->setMaximumWidth( m14trail);
ui->est917->setMinimumWidth( m9trail);
ui->est917->setMaximumHeight( m7traild3 );
ui->est917->setMaxLength(15);
ui->est917->setFrame(globalFrame);

ui->lib921->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "92    ") );
connect( ui->lib921, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib921, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib92, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst92, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib921->installEventFilter(this);
ui->lib921->setMaximumWidth( m6trail);
ui->lib921->setMinimumWidth( m6trail);
ui->lib921->setMaximumHeight( m7traild3 );
ui->lib921->setMaxLength(3);
ui->lib921->setFrame(globalFrame);

ui->lib922->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "92    ") );
connect( ui->lib922, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib922, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib922->installEventFilter(this);
ui->lib922->setMaximumWidth( m26trail);
ui->lib922->setMinimumWidth( m25trail);
ui->lib922->setMaximumHeight( m7traild3 );
ui->lib922->setMaxLength(24);
ui->lib922->setFrame(globalFrame);

ui->lib923->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "92    ") );
connect( ui->lib923, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib923, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib923->installEventFilter(this);
ui->lib923->setAlignment(Qt::AlignCenter);
ui->lib923->setMaximumWidth( m12trail);
ui->lib923->setMinimumWidth( m6trail);
ui->lib923->setMaximumHeight( m7traild3 );
ui->lib923->setMaxLength(11);
ui->lib923->setFrame(globalFrame);

ui->lib924->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "92    ") );
connect( ui->lib924, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib924, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib924->installEventFilter(this);
ui->lib924->setAlignment(Qt::AlignCenter);
ui->lib924->setMaximumWidth( m12trail);
ui->lib924->setMinimumWidth( m6trail);
ui->lib924->setMaximumHeight( m7traild3 );
ui->lib924->setMaxLength(11);
ui->lib924->setFrame(globalFrame);

ui->pushButtonEst92->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "92    ") );
ui->pushButtonEst92->setMaximumWidth( m7traild3 );
ui->pushButtonEst92->setMaximumHeight( m7traild3 );
ui->pushButtonLib92->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "92    ") );
ui->pushButtonLib92->setMaximumWidth( m7traild3 );
ui->pushButtonLib92->setMaximumHeight( m7traild3 );

ui->est921->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "92    ") );
connect( ui->est921, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est921, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est921->installEventFilter(this);
ui->est921->setMaximumWidth( m6trail);
ui->est921->setMinimumWidth( m6trail);
ui->est921->setMaximumHeight( m7traild3 );
ui->est921->setMaxLength(3);
ui->est921->setFrame(globalFrame);

ui->est922->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "92    ") );
connect( ui->est922, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est922, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est922->installEventFilter(this);
ui->est922->setMaximumWidth( m26trail);
ui->est922->setMinimumWidth( m25trail);
ui->est922->setMaximumHeight( m7traild3 );
ui->est922->setMaxLength(24);
ui->est922->setFrame(globalFrame);

ui->est923->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "92    ") );
connect( ui->est923, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est923, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est923->installEventFilter(this);
ui->est923->setAlignment(Qt::AlignCenter);
ui->est923->setMaximumWidth( m11trail);
ui->est923->setMinimumWidth( m6trail);
ui->est923->setMaximumHeight( m7traild3 );
ui->est923->setMaxLength(8);
ui->est923->setFrame(globalFrame);

ui->est924->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "92    ") );
connect( ui->est924, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est924, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est924->installEventFilter(this);
ui->est924->setAlignment(Qt::AlignCenter);
ui->est924->setMaximumWidth( m12trail);
ui->est924->setMinimumWidth( m6trail);
ui->est924->setMaximumHeight( m7traild3 );
ui->est924->setMaxLength(11);
ui->est924->setFrame(globalFrame);

ui->est925->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "92    ") );
connect( ui->est925, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est925, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est925->installEventFilter(this);
ui->est925->setAlignment(Qt::AlignCenter);
ui->est925->setMaximumWidth( m12trail);
ui->est925->setMinimumWidth( m6trail);
ui->est925->setMaximumHeight( m7traild3 );
ui->est925->setMaxLength(11);
ui->est925->setFrame(globalFrame);

ui->est926->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "92    ") );
ui->est926->setReadOnly(true);
ui->est926->setAlignment(Qt::AlignRight);
ui->est926->setMaximumWidth( m14trail);
ui->est926->setMinimumWidth( m9trail);
ui->est926->setMaximumHeight( m7traild3 );
ui->est926->setMaxLength(15);
ui->est926->setFrame(globalFrame);

ui->est927->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "92    ") );
ui->est927->setReadOnly(true);
ui->est927->setAlignment(Qt::AlignRight);
ui->est927->setMaximumWidth( m14trail);
ui->est927->setMinimumWidth( m9trail);
ui->est927->setMaximumHeight( m7traild3 );
ui->est927->setMaxLength(15);
ui->est927->setFrame(globalFrame);

ui->lib931->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "93    ") );
connect( ui->lib931, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib931, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib93, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst93, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib931->installEventFilter(this);
ui->lib931->setMaximumWidth( m6trail);
ui->lib931->setMinimumWidth( m6trail);
ui->lib931->setMaximumHeight( m7traild3 );
ui->lib931->setMaxLength(3);
ui->lib931->setFrame(globalFrame);

ui->lib932->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "93    ") );
connect( ui->lib932, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib932, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib932->installEventFilter(this);
ui->lib932->setMaximumWidth( m26trail);
ui->lib932->setMinimumWidth( m25trail);
ui->lib932->setMaximumHeight( m7traild3 );
ui->lib932->setMaxLength(24);
ui->lib932->setFrame(globalFrame);

ui->lib933->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "93    ") );
connect( ui->lib933, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib933, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib933->installEventFilter(this);
ui->lib933->setAlignment(Qt::AlignCenter);
ui->lib933->setMaximumWidth( m12trail);
ui->lib933->setMinimumWidth( m6trail);
ui->lib933->setMaximumHeight( m7traild3 );
ui->lib933->setMaxLength(11);
ui->lib933->setFrame(globalFrame);

ui->lib934->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "93    ") );
connect( ui->lib934, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib934, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib934->installEventFilter(this);
ui->lib934->setAlignment(Qt::AlignCenter);
ui->lib934->setMaximumWidth( m12trail);
ui->lib934->setMinimumWidth( m6trail);
ui->lib934->setMaximumHeight( m7traild3 );
ui->lib934->setMaxLength(11);
ui->lib934->setFrame(globalFrame);

ui->pushButtonEst93->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "93    ") );
ui->pushButtonEst93->setMaximumWidth( m7traild3 );
ui->pushButtonEst93->setMaximumHeight( m7traild3 );
ui->pushButtonLib93->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "93    ") );
ui->pushButtonLib93->setMaximumWidth( m7traild3 );
ui->pushButtonLib93->setMaximumHeight( m7traild3 );

ui->est931->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "93    ") );
connect( ui->est931, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est931, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est931->installEventFilter(this);
ui->est931->setMaximumWidth( m6trail);
ui->est931->setMinimumWidth( m6trail);
ui->est931->setMaximumHeight( m7traild3 );
ui->est931->setMaxLength(3);
ui->est931->setFrame(globalFrame);

ui->est932->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "93    ") );
connect( ui->est932, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est932, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est932->installEventFilter(this);
ui->est932->setMaximumWidth( m26trail);
ui->est932->setMinimumWidth( m25trail);
ui->est932->setMaximumHeight( m7traild3 );
ui->est932->setMaxLength(24);
ui->est932->setFrame(globalFrame);

ui->est933->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "93    ") );
connect( ui->est933, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est933, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est933->installEventFilter(this);
ui->est933->setAlignment(Qt::AlignCenter);
ui->est933->setMaximumWidth( m11trail);
ui->est933->setMinimumWidth( m6trail);
ui->est933->setMaximumHeight( m7traild3 );
ui->est933->setMaxLength(8);
ui->est933->setFrame(globalFrame);

ui->est934->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "93    ") );
connect( ui->est934, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est934, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est934->installEventFilter(this);
ui->est934->setAlignment(Qt::AlignCenter);
ui->est934->setMaximumWidth( m12trail);
ui->est934->setMinimumWidth( m6trail);
ui->est934->setMaximumHeight( m7traild3 );
ui->est934->setMaxLength(11);
ui->est934->setFrame(globalFrame);

ui->est935->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "93    ") );
connect( ui->est935, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est935, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est935->installEventFilter(this);
ui->est935->setAlignment(Qt::AlignCenter);
ui->est935->setMaximumWidth( m12trail);
ui->est935->setMinimumWidth( m6trail);
ui->est935->setMaximumHeight( m7traild3 );
ui->est935->setMaxLength(11);
ui->est935->setFrame(globalFrame);

ui->est936->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "93    ") );
ui->est936->setReadOnly(true);
ui->est936->setAlignment(Qt::AlignRight);
ui->est936->setMaximumWidth( m14trail);
ui->est936->setMinimumWidth( m9trail);
ui->est936->setMaximumHeight( m7traild3 );
ui->est936->setMaxLength(15);
ui->est936->setFrame(globalFrame);

ui->est937->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "93    ") );
ui->est937->setReadOnly(true);
ui->est937->setAlignment(Qt::AlignRight);
ui->est937->setMaximumWidth( m14trail);
ui->est937->setMinimumWidth( m9trail);
ui->est937->setMaximumHeight( m7traild3 );
ui->est937->setMaxLength(15);
ui->est937->setFrame(globalFrame);

ui->lib941->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "94    ") );
connect( ui->lib941, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib941, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib94, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst94, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib941->installEventFilter(this);
ui->lib941->setMaximumWidth( m6trail);
ui->lib941->setMinimumWidth( m6trail);
ui->lib941->setMaximumHeight( m7traild3 );
ui->lib941->setMaxLength(3);
ui->lib941->setFrame(globalFrame);

ui->lib942->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "94    ") );
connect( ui->lib942, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib942, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib942->installEventFilter(this);
ui->lib942->setMaximumWidth( m26trail);
ui->lib942->setMinimumWidth( m25trail);
ui->lib942->setMaximumHeight( m7traild3 );
ui->lib942->setMaxLength(24);
ui->lib942->setFrame(globalFrame);

ui->lib943->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "94    ") );
connect( ui->lib943, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib943, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib943->installEventFilter(this);
ui->lib943->setAlignment(Qt::AlignCenter);
ui->lib943->setMaximumWidth( m12trail);
ui->lib943->setMinimumWidth( m6trail);
ui->lib943->setMaximumHeight( m7traild3 );
ui->lib943->setMaxLength(11);
ui->lib943->setFrame(globalFrame);

ui->lib944->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "94    ") );
connect( ui->lib944, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib944, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib944->installEventFilter(this);
ui->lib944->setAlignment(Qt::AlignCenter);
ui->lib944->setMaximumWidth( m12trail);
ui->lib944->setMinimumWidth( m6trail);
ui->lib944->setMaximumHeight( m7traild3 );
ui->lib944->setMaxLength(11);
ui->lib944->setFrame(globalFrame);

ui->pushButtonEst94->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "94    ") );
ui->pushButtonEst94->setMaximumWidth( m7traild3 );
ui->pushButtonEst94->setMaximumHeight( m7traild3 );
ui->pushButtonLib94->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "94    ") );
ui->pushButtonLib94->setMaximumWidth( m7traild3 );
ui->pushButtonLib94->setMaximumHeight( m7traild3 );

ui->est941->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "94    ") );
connect( ui->est941, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est941, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est941->installEventFilter(this);
ui->est941->setMaximumWidth( m6trail);
ui->est941->setMinimumWidth( m6trail);
ui->est941->setMaximumHeight( m7traild3 );
ui->est941->setMaxLength(3);
ui->est941->setFrame(globalFrame);

ui->est942->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "94    ") );
connect( ui->est942, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est942, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est942->installEventFilter(this);
ui->est942->setMaximumWidth( m26trail);
ui->est942->setMinimumWidth( m25trail);
ui->est942->setMaximumHeight( m7traild3 );
ui->est942->setMaxLength(24);
ui->est942->setFrame(globalFrame);

ui->est943->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "94    ") );
connect( ui->est943, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est943, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est943->installEventFilter(this);
ui->est943->setAlignment(Qt::AlignCenter);
ui->est943->setMaximumWidth( m11trail);
ui->est943->setMinimumWidth( m6trail);
ui->est943->setMaximumHeight( m7traild3 );
ui->est943->setMaxLength(8);
ui->est943->setFrame(globalFrame);

ui->est944->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "94    ") );
connect( ui->est944, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est944, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est944->installEventFilter(this);
ui->est944->setAlignment(Qt::AlignCenter);
ui->est944->setMaximumWidth( m12trail);
ui->est944->setMinimumWidth( m6trail);
ui->est944->setMaximumHeight( m7traild3 );
ui->est944->setMaxLength(11);
ui->est944->setFrame(globalFrame);

ui->est945->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "94    ") );
connect( ui->est945, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est945, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est945->installEventFilter(this);
ui->est945->setAlignment(Qt::AlignCenter);
ui->est945->setMaximumWidth( m12trail);
ui->est945->setMinimumWidth( m6trail);
ui->est945->setMaximumHeight( m7traild3 );
ui->est945->setMaxLength(11);
ui->est945->setFrame(globalFrame);

ui->est946->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "94    ") );
ui->est946->setReadOnly(true);
ui->est946->setAlignment(Qt::AlignRight);
ui->est946->setMaximumWidth( m14trail);
ui->est946->setMinimumWidth( m9trail);
ui->est946->setMaximumHeight( m7traild3 );
ui->est946->setMaxLength(15);
ui->est946->setFrame(globalFrame);

ui->est947->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "94    ") );
ui->est947->setReadOnly(true);
ui->est947->setAlignment(Qt::AlignRight);
ui->est947->setMaximumWidth( m14trail);
ui->est947->setMinimumWidth( m9trail);
ui->est947->setMaximumHeight( m7traild3 );
ui->est947->setMaxLength(15);
ui->est947->setFrame(globalFrame);

ui->lib951->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "95    ") );
connect( ui->lib951, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib951, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib95, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst95, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib951->installEventFilter(this);
ui->lib951->setMaximumWidth( m6trail);
ui->lib951->setMinimumWidth( m6trail);
ui->lib951->setMaximumHeight( m7traild3 );
ui->lib951->setMaxLength(3);
ui->lib951->setFrame(globalFrame);

ui->lib952->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "95    ") );
connect( ui->lib952, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib952, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib952->installEventFilter(this);
ui->lib952->setMaximumWidth( m26trail);
ui->lib952->setMinimumWidth( m25trail);
ui->lib952->setMaximumHeight( m7traild3 );
ui->lib952->setMaxLength(24);
ui->lib952->setFrame(globalFrame);

ui->lib953->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "95    ") );
connect( ui->lib953, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib953, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib953->installEventFilter(this);
ui->lib953->setAlignment(Qt::AlignCenter);
ui->lib953->setMaximumWidth( m12trail);
ui->lib953->setMinimumWidth( m6trail);
ui->lib953->setMaximumHeight( m7traild3 );
ui->lib953->setMaxLength(11);
ui->lib953->setFrame(globalFrame);

ui->lib954->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "95    ") );
connect( ui->lib954, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib954, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib954->installEventFilter(this);
ui->lib954->setAlignment(Qt::AlignCenter);
ui->lib954->setMaximumWidth( m12trail);
ui->lib954->setMinimumWidth( m6trail);
ui->lib954->setMaximumHeight( m7traild3 );
ui->lib954->setMaxLength(11);
ui->lib954->setFrame(globalFrame);

ui->pushButtonEst95->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "95    ") );
ui->pushButtonEst95->setMaximumWidth( m7traild3 );
ui->pushButtonEst95->setMaximumHeight( m7traild3 );
ui->pushButtonLib95->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "95    ") );
ui->pushButtonLib95->setMaximumWidth( m7traild3 );
ui->pushButtonLib95->setMaximumHeight( m7traild3 );

ui->est951->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "95    ") );
connect( ui->est951, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est951, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est951->installEventFilter(this);
ui->est951->setMaximumWidth( m6trail);
ui->est951->setMinimumWidth( m6trail);
ui->est951->setMaximumHeight( m7traild3 );
ui->est951->setMaxLength(3);
ui->est951->setFrame(globalFrame);

ui->est952->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "95    ") );
connect( ui->est952, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est952, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est952->installEventFilter(this);
ui->est952->setMaximumWidth( m26trail);
ui->est952->setMinimumWidth( m25trail);
ui->est952->setMaximumHeight( m7traild3 );
ui->est952->setMaxLength(24);
ui->est952->setFrame(globalFrame);

ui->est953->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "95    ") );
connect( ui->est953, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est953, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est953->installEventFilter(this);
ui->est953->setAlignment(Qt::AlignCenter);
ui->est953->setMaximumWidth( m11trail);
ui->est953->setMinimumWidth( m6trail);
ui->est953->setMaximumHeight( m7traild3 );
ui->est953->setMaxLength(8);
ui->est953->setFrame(globalFrame);

ui->est954->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "95    ") );
connect( ui->est954, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est954, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est954->installEventFilter(this);
ui->est954->setAlignment(Qt::AlignCenter);
ui->est954->setMaximumWidth( m12trail);
ui->est954->setMinimumWidth( m6trail);
ui->est954->setMaximumHeight( m7traild3 );
ui->est954->setMaxLength(11);
ui->est954->setFrame(globalFrame);

ui->est955->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "95    ") );
connect( ui->est955, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est955, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est955->installEventFilter(this);
ui->est955->setAlignment(Qt::AlignCenter);
ui->est955->setMaximumWidth( m12trail);
ui->est955->setMinimumWidth( m6trail);
ui->est955->setMaximumHeight( m7traild3 );
ui->est955->setMaxLength(11);
ui->est955->setFrame(globalFrame);

ui->est956->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "95    ") );
ui->est956->setReadOnly(true);
ui->est956->setAlignment(Qt::AlignRight);
ui->est956->setMaximumWidth( m14trail);
ui->est956->setMinimumWidth( m9trail);
ui->est956->setMaximumHeight( m7traild3 );
ui->est956->setMaxLength(15);
ui->est956->setFrame(globalFrame);

ui->est957->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "95    ") );
ui->est957->setReadOnly(true);
ui->est957->setAlignment(Qt::AlignRight);
ui->est957->setMaximumWidth( m14trail);
ui->est957->setMinimumWidth( m9trail);
ui->est957->setMaximumHeight( m7traild3 );
ui->est957->setMaxLength(15);
ui->est957->setFrame(globalFrame);

ui->lib961->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "96    ") );
connect( ui->lib961, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib961, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib96, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst96, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib961->installEventFilter(this);
ui->lib961->setMaximumWidth( m6trail);
ui->lib961->setMinimumWidth( m6trail);
ui->lib961->setMaximumHeight( m7traild3 );
ui->lib961->setMaxLength(3);
ui->lib961->setFrame(globalFrame);

ui->lib962->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "96    ") );
connect( ui->lib962, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib962, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib962->installEventFilter(this);
ui->lib962->setMaximumWidth( m26trail);
ui->lib962->setMinimumWidth( m25trail);
ui->lib962->setMaximumHeight( m7traild3 );
ui->lib962->setMaxLength(24);
ui->lib962->setFrame(globalFrame);

ui->lib963->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "96    ") );
connect( ui->lib963, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib963, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib963->installEventFilter(this);
ui->lib963->setAlignment(Qt::AlignCenter);
ui->lib963->setMaximumWidth( m12trail);
ui->lib963->setMinimumWidth( m6trail);
ui->lib963->setMaximumHeight( m7traild3 );
ui->lib963->setMaxLength(11);
ui->lib963->setFrame(globalFrame);

ui->lib964->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "96    ") );
connect( ui->lib964, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib964, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib964->installEventFilter(this);
ui->lib964->setAlignment(Qt::AlignCenter);
ui->lib964->setMaximumWidth( m12trail);
ui->lib964->setMinimumWidth( m6trail);
ui->lib964->setMaximumHeight( m7traild3 );
ui->lib964->setMaxLength(11);
ui->lib964->setFrame(globalFrame);

ui->pushButtonEst96->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "96    ") );
ui->pushButtonEst96->setMaximumWidth( m7traild3 );
ui->pushButtonEst96->setMaximumHeight( m7traild3 );
ui->pushButtonLib96->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "96    ") );
ui->pushButtonLib96->setMaximumWidth( m7traild3 );
ui->pushButtonLib96->setMaximumHeight( m7traild3 );

ui->est961->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "96    ") );
connect( ui->est961, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est961, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est961->installEventFilter(this);
ui->est961->setMaximumWidth( m6trail);
ui->est961->setMinimumWidth( m6trail);
ui->est961->setMaximumHeight( m7traild3 );
ui->est961->setMaxLength(3);
ui->est961->setFrame(globalFrame);

ui->est962->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "96    ") );
connect( ui->est962, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est962, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est962->installEventFilter(this);
ui->est962->setMaximumWidth( m26trail);
ui->est962->setMinimumWidth( m25trail);
ui->est962->setMaximumHeight( m7traild3 );
ui->est962->setMaxLength(24);
ui->est962->setFrame(globalFrame);

ui->est963->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "96    ") );
connect( ui->est963, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est963, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est963->installEventFilter(this);
ui->est963->setAlignment(Qt::AlignCenter);
ui->est963->setMaximumWidth( m11trail);
ui->est963->setMinimumWidth( m6trail);
ui->est963->setMaximumHeight( m7traild3 );
ui->est963->setMaxLength(8);
ui->est963->setFrame(globalFrame);

ui->est964->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "96    ") );
connect( ui->est964, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est964, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est964->installEventFilter(this);
ui->est964->setAlignment(Qt::AlignCenter);
ui->est964->setMaximumWidth( m12trail);
ui->est964->setMinimumWidth( m6trail);
ui->est964->setMaximumHeight( m7traild3 );
ui->est964->setMaxLength(11);
ui->est964->setFrame(globalFrame);

ui->est965->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "96    ") );
connect( ui->est965, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est965, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est965->installEventFilter(this);
ui->est965->setAlignment(Qt::AlignCenter);
ui->est965->setMaximumWidth( m12trail);
ui->est965->setMinimumWidth( m6trail);
ui->est965->setMaximumHeight( m7traild3 );
ui->est965->setMaxLength(11);
ui->est965->setFrame(globalFrame);

ui->est966->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "96    ") );
ui->est966->setReadOnly(true);
ui->est966->setAlignment(Qt::AlignRight);
ui->est966->setMaximumWidth( m14trail);
ui->est966->setMinimumWidth( m9trail);
ui->est966->setMaximumHeight( m7traild3 );
ui->est966->setMaxLength(15);
ui->est966->setFrame(globalFrame);

ui->est967->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "96    ") );
ui->est967->setReadOnly(true);
ui->est967->setAlignment(Qt::AlignRight);
ui->est967->setMaximumWidth( m14trail);
ui->est967->setMinimumWidth( m9trail);
ui->est967->setMaximumHeight( m7traild3 );
ui->est967->setMaxLength(15);
ui->est967->setFrame(globalFrame);

ui->lib971->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "97    ") );
connect( ui->lib971, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib971, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib97, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst97, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib971->installEventFilter(this);
ui->lib971->setMaximumWidth( m6trail);
ui->lib971->setMinimumWidth( m6trail);
ui->lib971->setMaximumHeight( m7traild3 );
ui->lib971->setMaxLength(3);
ui->lib971->setFrame(globalFrame);

ui->lib972->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "97    ") );
connect( ui->lib972, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib972, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib972->installEventFilter(this);
ui->lib972->setMaximumWidth( m26trail);
ui->lib972->setMinimumWidth( m25trail);
ui->lib972->setMaximumHeight( m7traild3 );
ui->lib972->setMaxLength(24);
ui->lib972->setFrame(globalFrame);

ui->lib973->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "97    ") );
connect( ui->lib973, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib973, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib973->installEventFilter(this);
ui->lib973->setAlignment(Qt::AlignCenter);
ui->lib973->setMaximumWidth( m12trail);
ui->lib973->setMinimumWidth( m6trail);
ui->lib973->setMaximumHeight( m7traild3 );
ui->lib973->setMaxLength(11);
ui->lib973->setFrame(globalFrame);

ui->lib974->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "97    ") );
connect( ui->lib974, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib974, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib974->installEventFilter(this);
ui->lib974->setAlignment(Qt::AlignCenter);
ui->lib974->setMaximumWidth( m12trail);
ui->lib974->setMinimumWidth( m6trail);
ui->lib974->setMaximumHeight( m7traild3 );
ui->lib974->setMaxLength(11);
ui->lib974->setFrame(globalFrame);

ui->pushButtonEst97->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "97    ") );
ui->pushButtonEst97->setMaximumWidth( m7traild3 );
ui->pushButtonEst97->setMaximumHeight( m7traild3 );
ui->pushButtonLib97->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "97    ") );
ui->pushButtonLib97->setMaximumWidth( m7traild3 );
ui->pushButtonLib97->setMaximumHeight( m7traild3 );

ui->est971->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "97    ") );
connect( ui->est971, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est971, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est971->installEventFilter(this);
ui->est971->setMaximumWidth( m6trail);
ui->est971->setMinimumWidth( m6trail);
ui->est971->setMaximumHeight( m7traild3 );
ui->est971->setMaxLength(3);
ui->est971->setFrame(globalFrame);

ui->est972->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "97    ") );
connect( ui->est972, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est972, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est972->installEventFilter(this);
ui->est972->setMaximumWidth( m26trail);
ui->est972->setMinimumWidth( m25trail);
ui->est972->setMaximumHeight( m7traild3 );
ui->est972->setMaxLength(24);
ui->est972->setFrame(globalFrame);

ui->est973->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "97    ") );
connect( ui->est973, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est973, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est973->installEventFilter(this);
ui->est973->setAlignment(Qt::AlignCenter);
ui->est973->setMaximumWidth( m11trail);
ui->est973->setMinimumWidth( m6trail);
ui->est973->setMaximumHeight( m7traild3 );
ui->est973->setMaxLength(8);
ui->est973->setFrame(globalFrame);

ui->est974->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "97    ") );
connect( ui->est974, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est974, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est974->installEventFilter(this);
ui->est974->setAlignment(Qt::AlignCenter);
ui->est974->setMaximumWidth( m12trail);
ui->est974->setMinimumWidth( m6trail);
ui->est974->setMaximumHeight( m7traild3 );
ui->est974->setMaxLength(11);
ui->est974->setFrame(globalFrame);

ui->est975->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "97    ") );
connect( ui->est975, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est975, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est975->installEventFilter(this);
ui->est975->setAlignment(Qt::AlignCenter);
ui->est975->setMaximumWidth( m12trail);
ui->est975->setMinimumWidth( m6trail);
ui->est975->setMaximumHeight( m7traild3 );
ui->est975->setMaxLength(11);
ui->est975->setFrame(globalFrame);

ui->est976->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "97    ") );
ui->est976->setReadOnly(true);
ui->est976->setAlignment(Qt::AlignRight);
ui->est976->setMaximumWidth( m14trail);
ui->est976->setMinimumWidth( m9trail);
ui->est976->setMaximumHeight( m7traild3 );
ui->est976->setMaxLength(15);
ui->est976->setFrame(globalFrame);

ui->est977->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "97    ") );
ui->est977->setReadOnly(true);
ui->est977->setAlignment(Qt::AlignRight);
ui->est977->setMaximumWidth( m14trail);
ui->est977->setMinimumWidth( m9trail);
ui->est977->setMaximumHeight( m7traild3 );
ui->est977->setMaxLength(15);
ui->est977->setFrame(globalFrame);

ui->lib981->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "98    ") );
connect( ui->lib981, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib981, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib98, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst98, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib981->installEventFilter(this);
ui->lib981->setMaximumWidth( m6trail);
ui->lib981->setMinimumWidth( m6trail);
ui->lib981->setMaximumHeight( m7traild3 );
ui->lib981->setMaxLength(3);
ui->lib981->setFrame(globalFrame);

ui->lib982->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "98    ") );
connect( ui->lib982, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib982, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib982->installEventFilter(this);
ui->lib982->setMaximumWidth( m26trail);
ui->lib982->setMinimumWidth( m25trail);
ui->lib982->setMaximumHeight( m7traild3 );
ui->lib982->setMaxLength(24);
ui->lib982->setFrame(globalFrame);

ui->lib983->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "98    ") );
connect( ui->lib983, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib983, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib983->installEventFilter(this);
ui->lib983->setAlignment(Qt::AlignCenter);
ui->lib983->setMaximumWidth( m12trail);
ui->lib983->setMinimumWidth( m6trail);
ui->lib983->setMaximumHeight( m7traild3 );
ui->lib983->setMaxLength(11);
ui->lib983->setFrame(globalFrame);

ui->lib984->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "98    ") );
connect( ui->lib984, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib984, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib984->installEventFilter(this);
ui->lib984->setAlignment(Qt::AlignCenter);
ui->lib984->setMaximumWidth( m12trail);
ui->lib984->setMinimumWidth( m6trail);
ui->lib984->setMaximumHeight( m7traild3 );
ui->lib984->setMaxLength(11);
ui->lib984->setFrame(globalFrame);

ui->pushButtonEst98->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "98    ") );
ui->pushButtonEst98->setMaximumWidth( m7traild3 );
ui->pushButtonEst98->setMaximumHeight( m7traild3 );
ui->pushButtonLib98->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "98    ") );
ui->pushButtonLib98->setMaximumWidth( m7traild3 );
ui->pushButtonLib98->setMaximumHeight( m7traild3 );

ui->est981->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "98    ") );
connect( ui->est981, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est981, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est981->installEventFilter(this);
ui->est981->setMaximumWidth( m6trail);
ui->est981->setMinimumWidth( m6trail);
ui->est981->setMaximumHeight( m7traild3 );
ui->est981->setMaxLength(3);
ui->est981->setFrame(globalFrame);

ui->est982->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "98    ") );
connect( ui->est982, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est982, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est982->installEventFilter(this);
ui->est982->setMaximumWidth( m26trail);
ui->est982->setMinimumWidth( m25trail);
ui->est982->setMaximumHeight( m7traild3 );
ui->est982->setMaxLength(24);
ui->est982->setFrame(globalFrame);

ui->est983->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "98    ") );
connect( ui->est983, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est983, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est983->installEventFilter(this);
ui->est983->setAlignment(Qt::AlignCenter);
ui->est983->setMaximumWidth( m11trail);
ui->est983->setMinimumWidth( m6trail);
ui->est983->setMaximumHeight( m7traild3 );
ui->est983->setMaxLength(8);
ui->est983->setFrame(globalFrame);

ui->est984->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "98    ") );
connect( ui->est984, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est984, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est984->installEventFilter(this);
ui->est984->setAlignment(Qt::AlignCenter);
ui->est984->setMaximumWidth( m12trail);
ui->est984->setMinimumWidth( m6trail);
ui->est984->setMaximumHeight( m7traild3 );
ui->est984->setMaxLength(11);
ui->est984->setFrame(globalFrame);

ui->est985->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "98    ") );
connect( ui->est985, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est985, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est985->installEventFilter(this);
ui->est985->setAlignment(Qt::AlignCenter);
ui->est985->setMaximumWidth( m12trail);
ui->est985->setMinimumWidth( m6trail);
ui->est985->setMaximumHeight( m7traild3 );
ui->est985->setMaxLength(11);
ui->est985->setFrame(globalFrame);

ui->est986->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "98    ") );
ui->est986->setReadOnly(true);
ui->est986->setAlignment(Qt::AlignRight);
ui->est986->setMaximumWidth( m14trail);
ui->est986->setMinimumWidth( m9trail);
ui->est986->setMaximumHeight( m7traild3 );
ui->est986->setMaxLength(15);
ui->est986->setFrame(globalFrame);

ui->est987->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "98    ") );
ui->est987->setReadOnly(true);
ui->est987->setAlignment(Qt::AlignRight);
ui->est987->setMaximumWidth( m14trail);
ui->est987->setMinimumWidth( m9trail);
ui->est987->setMaximumHeight( m7traild3 );
ui->est987->setMaxLength(15);
ui->est987->setFrame(globalFrame);

ui->lib991->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "99    ") );
connect( ui->lib991, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib991, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib99, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst99, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib991->installEventFilter(this);
ui->lib991->setMaximumWidth( m6trail);
ui->lib991->setMinimumWidth( m6trail);
ui->lib991->setMaximumHeight( m7traild3 );
ui->lib991->setMaxLength(3);
ui->lib991->setFrame(globalFrame);

ui->lib992->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "99    ") );
connect( ui->lib992, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib992, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib992->installEventFilter(this);
ui->lib992->setMaximumWidth( m26trail);
ui->lib992->setMinimumWidth( m25trail);
ui->lib992->setMaximumHeight( m7traild3 );
ui->lib992->setMaxLength(24);
ui->lib992->setFrame(globalFrame);

ui->lib993->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "99    ") );
connect( ui->lib993, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib993, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib993->installEventFilter(this);
ui->lib993->setAlignment(Qt::AlignCenter);
ui->lib993->setMaximumWidth( m12trail);
ui->lib993->setMinimumWidth( m6trail);
ui->lib993->setMaximumHeight( m7traild3 );
ui->lib993->setMaxLength(11);
ui->lib993->setFrame(globalFrame);

ui->lib994->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "99    ") );
connect( ui->lib994, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib994, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib994->installEventFilter(this);
ui->lib994->setAlignment(Qt::AlignCenter);
ui->lib994->setMaximumWidth( m12trail);
ui->lib994->setMinimumWidth( m6trail);
ui->lib994->setMaximumHeight( m7traild3 );
ui->lib994->setMaxLength(11);
ui->lib994->setFrame(globalFrame);

ui->pushButtonEst99->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "99    ") );
ui->pushButtonEst99->setMaximumWidth( m7traild3 );
ui->pushButtonEst99->setMaximumHeight( m7traild3 );
ui->pushButtonLib99->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "99    ") );
ui->pushButtonLib99->setMaximumWidth( m7traild3 );
ui->pushButtonLib99->setMaximumHeight( m7traild3 );

ui->est991->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "99    ") );
connect( ui->est991, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est991, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est991->installEventFilter(this);
ui->est991->setMaximumWidth( m6trail);
ui->est991->setMinimumWidth( m6trail);
ui->est991->setMaximumHeight( m7traild3 );
ui->est991->setMaxLength(3);
ui->est991->setFrame(globalFrame);

ui->est992->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "99    ") );
connect( ui->est992, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est992, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est992->installEventFilter(this);
ui->est992->setMaximumWidth( m26trail);
ui->est992->setMinimumWidth( m25trail);
ui->est992->setMaximumHeight( m7traild3 );
ui->est992->setMaxLength(24);
ui->est992->setFrame(globalFrame);

ui->est993->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "99    ") );
connect( ui->est993, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est993, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est993->installEventFilter(this);
ui->est993->setAlignment(Qt::AlignCenter);
ui->est993->setMaximumWidth( m11trail);
ui->est993->setMinimumWidth( m6trail);
ui->est993->setMaximumHeight( m7traild3 );
ui->est993->setMaxLength(8);
ui->est993->setFrame(globalFrame);

ui->est994->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "99    ") );
connect( ui->est994, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est994, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est994->installEventFilter(this);
ui->est994->setAlignment(Qt::AlignCenter);
ui->est994->setMaximumWidth( m12trail);
ui->est994->setMinimumWidth( m6trail);
ui->est994->setMaximumHeight( m7traild3 );
ui->est994->setMaxLength(11);
ui->est994->setFrame(globalFrame);

ui->est995->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "99    ") );
connect( ui->est995, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est995, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est995->installEventFilter(this);
ui->est995->setAlignment(Qt::AlignCenter);
ui->est995->setMaximumWidth( m12trail);
ui->est995->setMinimumWidth( m6trail);
ui->est995->setMaximumHeight( m7traild3 );
ui->est995->setMaxLength(11);
ui->est995->setFrame(globalFrame);

ui->est996->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "99    ") );
ui->est996->setReadOnly(true);
ui->est996->setAlignment(Qt::AlignRight);
ui->est996->setMaximumWidth( m14trail);
ui->est996->setMinimumWidth( m9trail);
ui->est996->setMaximumHeight( m7traild3 );
ui->est996->setMaxLength(15);
ui->est996->setFrame(globalFrame);

ui->est997->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "99    ") );
ui->est997->setReadOnly(true);
ui->est997->setAlignment(Qt::AlignRight);
ui->est997->setMaximumWidth( m14trail);
ui->est997->setMinimumWidth( m9trail);
ui->est997->setMaximumHeight( m7traild3 );
ui->est997->setMaxLength(15);
ui->est997->setFrame(globalFrame);

ui->lib1001->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "100   ") );
connect( ui->lib1001, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1001, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib100, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst100, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1001->installEventFilter(this);
ui->lib1001->setMaximumWidth( m6trail);
ui->lib1001->setMinimumWidth( m6trail);
ui->lib1001->setMaximumHeight( m7traild3 );
ui->lib1001->setMaxLength(3);
ui->lib1001->setFrame(globalFrame);

ui->lib1002->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "100   ") );
connect( ui->lib1002, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1002, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1002->installEventFilter(this);
ui->lib1002->setMaximumWidth( m26trail);
ui->lib1002->setMinimumWidth( m25trail);
ui->lib1002->setMaximumHeight( m7traild3 );
ui->lib1002->setMaxLength(24);
ui->lib1002->setFrame(globalFrame);

ui->lib1003->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "100   ") );
connect( ui->lib1003, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1003, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1003->installEventFilter(this);
ui->lib1003->setAlignment(Qt::AlignCenter);
ui->lib1003->setMaximumWidth( m12trail);
ui->lib1003->setMinimumWidth( m6trail);
ui->lib1003->setMaximumHeight( m7traild3 );
ui->lib1003->setMaxLength(11);
ui->lib1003->setFrame(globalFrame);

ui->lib1004->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "100   ") );
connect( ui->lib1004, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1004, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1004->installEventFilter(this);
ui->lib1004->setAlignment(Qt::AlignCenter);
ui->lib1004->setMaximumWidth( m12trail);
ui->lib1004->setMinimumWidth( m6trail);
ui->lib1004->setMaximumHeight( m7traild3 );
ui->lib1004->setMaxLength(11);
ui->lib1004->setFrame(globalFrame);

ui->pushButtonEst100->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "100   ") );
ui->pushButtonEst100->setMaximumWidth( m7traild3 );
ui->pushButtonEst100->setMaximumHeight( m7traild3 );
ui->pushButtonLib100->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "100   ") );
ui->pushButtonLib100->setMaximumWidth( m7traild3 );
ui->pushButtonLib100->setMaximumHeight( m7traild3 );

ui->est1001->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "100   ") );
connect( ui->est1001, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1001, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1001->installEventFilter(this);
ui->est1001->setMaximumWidth( m6trail);
ui->est1001->setMinimumWidth( m6trail);
ui->est1001->setMaximumHeight( m7traild3 );
ui->est1001->setMaxLength(3);
ui->est1001->setFrame(globalFrame);

ui->est1002->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "100   ") );
connect( ui->est1002, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1002, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1002->installEventFilter(this);
ui->est1002->setMaximumWidth( m26trail);
ui->est1002->setMinimumWidth( m25trail);
ui->est1002->setMaximumHeight( m7traild3 );
ui->est1002->setMaxLength(24);
ui->est1002->setFrame(globalFrame);

ui->est1003->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "100   ") );
connect( ui->est1003, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1003, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1003->installEventFilter(this);
ui->est1003->setAlignment(Qt::AlignCenter);
ui->est1003->setMaximumWidth( m11trail);
ui->est1003->setMinimumWidth( m6trail);
ui->est1003->setMaximumHeight( m7traild3 );
ui->est1003->setMaxLength(8);
ui->est1003->setFrame(globalFrame);

ui->est1004->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "100   ") );
connect( ui->est1004, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1004, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1004->installEventFilter(this);
ui->est1004->setAlignment(Qt::AlignCenter);
ui->est1004->setMaximumWidth( m12trail);
ui->est1004->setMinimumWidth( m6trail);
ui->est1004->setMaximumHeight( m7traild3 );
ui->est1004->setMaxLength(11);
ui->est1004->setFrame(globalFrame);

ui->est1005->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "100   ") );
connect( ui->est1005, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1005, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1005->installEventFilter(this);
ui->est1005->setAlignment(Qt::AlignCenter);
ui->est1005->setMaximumWidth( m12trail);
ui->est1005->setMinimumWidth( m6trail);
ui->est1005->setMaximumHeight( m7traild3 );
ui->est1005->setMaxLength(11);
ui->est1005->setFrame(globalFrame);

ui->est1006->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "100   ") );
ui->est1006->setReadOnly(true);
ui->est1006->setAlignment(Qt::AlignRight);
ui->est1006->setMaximumWidth( m14trail);
ui->est1006->setMinimumWidth( m9trail);
ui->est1006->setMaximumHeight( m7traild3 );
ui->est1006->setMaxLength(15);
ui->est1006->setFrame(globalFrame);

ui->est1007->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "100   ") );
ui->est1007->setReadOnly(true);
ui->est1007->setAlignment(Qt::AlignRight);
ui->est1007->setMaximumWidth( m14trail);
ui->est1007->setMinimumWidth( m9trail);
ui->est1007->setMaximumHeight( m7traild3 );
ui->est1007->setMaxLength(15);
ui->est1007->setFrame(globalFrame);

ui->lib1011->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "101   ") );
connect( ui->lib1011, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1011, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib101, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst101, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1011->installEventFilter(this);
ui->lib1011->setMaximumWidth( m6trail);
ui->lib1011->setMinimumWidth( m6trail);
ui->lib1011->setMaximumHeight( m7traild3 );
ui->lib1011->setMaxLength(3);
ui->lib1011->setFrame(globalFrame);

ui->lib1012->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "101   ") );
connect( ui->lib1012, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1012, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1012->installEventFilter(this);
ui->lib1012->setMaximumWidth( m26trail);
ui->lib1012->setMinimumWidth( m25trail);
ui->lib1012->setMaximumHeight( m7traild3 );
ui->lib1012->setMaxLength(24);
ui->lib1012->setFrame(globalFrame);

ui->lib1013->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "101   ") );
connect( ui->lib1013, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1013, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1013->installEventFilter(this);
ui->lib1013->setAlignment(Qt::AlignCenter);
ui->lib1013->setMaximumWidth( m12trail);
ui->lib1013->setMinimumWidth( m6trail);
ui->lib1013->setMaximumHeight( m7traild3 );
ui->lib1013->setMaxLength(11);
ui->lib1013->setFrame(globalFrame);

ui->lib1014->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "101   ") );
connect( ui->lib1014, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1014, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1014->installEventFilter(this);
ui->lib1014->setAlignment(Qt::AlignCenter);
ui->lib1014->setMaximumWidth( m12trail);
ui->lib1014->setMinimumWidth( m6trail);
ui->lib1014->setMaximumHeight( m7traild3 );
ui->lib1014->setMaxLength(11);
ui->lib1014->setFrame(globalFrame);

ui->pushButtonEst101->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "101   ") );
ui->pushButtonEst101->setMaximumWidth( m7traild3 );
ui->pushButtonEst101->setMaximumHeight( m7traild3 );
ui->pushButtonLib101->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "101   ") );
ui->pushButtonLib101->setMaximumWidth( m7traild3 );
ui->pushButtonLib101->setMaximumHeight( m7traild3 );

ui->est1011->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "101   ") );
connect( ui->est1011, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1011, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1011->installEventFilter(this);
ui->est1011->setMaximumWidth( m6trail);
ui->est1011->setMinimumWidth( m6trail);
ui->est1011->setMaximumHeight( m7traild3 );
ui->est1011->setMaxLength(3);
ui->est1011->setFrame(globalFrame);

ui->est1012->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "101   ") );
connect( ui->est1012, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1012, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1012->installEventFilter(this);
ui->est1012->setMaximumWidth( m26trail);
ui->est1012->setMinimumWidth( m25trail);
ui->est1012->setMaximumHeight( m7traild3 );
ui->est1012->setMaxLength(24);
ui->est1012->setFrame(globalFrame);

ui->est1013->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "101   ") );
connect( ui->est1013, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1013, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1013->installEventFilter(this);
ui->est1013->setAlignment(Qt::AlignCenter);
ui->est1013->setMaximumWidth( m11trail);
ui->est1013->setMinimumWidth( m6trail);
ui->est1013->setMaximumHeight( m7traild3 );
ui->est1013->setMaxLength(8);
ui->est1013->setFrame(globalFrame);

ui->est1014->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "101   ") );
connect( ui->est1014, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1014, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1014->installEventFilter(this);
ui->est1014->setAlignment(Qt::AlignCenter);
ui->est1014->setMaximumWidth( m12trail);
ui->est1014->setMinimumWidth( m6trail);
ui->est1014->setMaximumHeight( m7traild3 );
ui->est1014->setMaxLength(11);
ui->est1014->setFrame(globalFrame);

ui->est1015->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "101   ") );
connect( ui->est1015, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1015, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1015->installEventFilter(this);
ui->est1015->setAlignment(Qt::AlignCenter);
ui->est1015->setMaximumWidth( m12trail);
ui->est1015->setMinimumWidth( m6trail);
ui->est1015->setMaximumHeight( m7traild3 );
ui->est1015->setMaxLength(11);
ui->est1015->setFrame(globalFrame);

ui->est1016->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "101   ") );
ui->est1016->setReadOnly(true);
ui->est1016->setAlignment(Qt::AlignRight);
ui->est1016->setMaximumWidth( m14trail);
ui->est1016->setMinimumWidth( m9trail);
ui->est1016->setMaximumHeight( m7traild3 );
ui->est1016->setMaxLength(15);
ui->est1016->setFrame(globalFrame);

ui->est1017->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "101   ") );
ui->est1017->setReadOnly(true);
ui->est1017->setAlignment(Qt::AlignRight);
ui->est1017->setMaximumWidth( m14trail);
ui->est1017->setMinimumWidth( m9trail);
ui->est1017->setMaximumHeight( m7traild3 );
ui->est1017->setMaxLength(15);
ui->est1017->setFrame(globalFrame);

ui->lib1021->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "102   ") );
connect( ui->lib1021, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1021, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib102, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst102, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1021->installEventFilter(this);
ui->lib1021->setMaximumWidth( m6trail);
ui->lib1021->setMinimumWidth( m6trail);
ui->lib1021->setMaximumHeight( m7traild3 );
ui->lib1021->setMaxLength(3);
ui->lib1021->setFrame(globalFrame);

ui->lib1022->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "102   ") );
connect( ui->lib1022, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1022, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1022->installEventFilter(this);
ui->lib1022->setMaximumWidth( m26trail);
ui->lib1022->setMinimumWidth( m25trail);
ui->lib1022->setMaximumHeight( m7traild3 );
ui->lib1022->setMaxLength(24);
ui->lib1022->setFrame(globalFrame);

ui->lib1023->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "102   ") );
connect( ui->lib1023, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1023, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1023->installEventFilter(this);
ui->lib1023->setAlignment(Qt::AlignCenter);
ui->lib1023->setMaximumWidth( m12trail);
ui->lib1023->setMinimumWidth( m6trail);
ui->lib1023->setMaximumHeight( m7traild3 );
ui->lib1023->setMaxLength(11);
ui->lib1023->setFrame(globalFrame);

ui->lib1024->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "102   ") );
connect( ui->lib1024, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1024, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1024->installEventFilter(this);
ui->lib1024->setAlignment(Qt::AlignCenter);
ui->lib1024->setMaximumWidth( m12trail);
ui->lib1024->setMinimumWidth( m6trail);
ui->lib1024->setMaximumHeight( m7traild3 );
ui->lib1024->setMaxLength(11);
ui->lib1024->setFrame(globalFrame);

ui->pushButtonEst102->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "102   ") );
ui->pushButtonEst102->setMaximumWidth( m7traild3 );
ui->pushButtonEst102->setMaximumHeight( m7traild3 );
ui->pushButtonLib102->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "102   ") );
ui->pushButtonLib102->setMaximumWidth( m7traild3 );
ui->pushButtonLib102->setMaximumHeight( m7traild3 );

ui->est1021->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "102   ") );
connect( ui->est1021, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1021, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1021->installEventFilter(this);
ui->est1021->setMaximumWidth( m6trail);
ui->est1021->setMinimumWidth( m6trail);
ui->est1021->setMaximumHeight( m7traild3 );
ui->est1021->setMaxLength(3);
ui->est1021->setFrame(globalFrame);

ui->est1022->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "102   ") );
connect( ui->est1022, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1022, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1022->installEventFilter(this);
ui->est1022->setMaximumWidth( m26trail);
ui->est1022->setMinimumWidth( m25trail);
ui->est1022->setMaximumHeight( m7traild3 );
ui->est1022->setMaxLength(24);
ui->est1022->setFrame(globalFrame);

ui->est1023->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "102   ") );
connect( ui->est1023, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1023, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1023->installEventFilter(this);
ui->est1023->setAlignment(Qt::AlignCenter);
ui->est1023->setMaximumWidth( m11trail);
ui->est1023->setMinimumWidth( m6trail);
ui->est1023->setMaximumHeight( m7traild3 );
ui->est1023->setMaxLength(8);
ui->est1023->setFrame(globalFrame);

ui->est1024->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "102   ") );
connect( ui->est1024, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1024, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1024->installEventFilter(this);
ui->est1024->setAlignment(Qt::AlignCenter);
ui->est1024->setMaximumWidth( m12trail);
ui->est1024->setMinimumWidth( m6trail);
ui->est1024->setMaximumHeight( m7traild3 );
ui->est1024->setMaxLength(11);
ui->est1024->setFrame(globalFrame);

ui->est1025->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "102   ") );
connect( ui->est1025, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1025, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1025->installEventFilter(this);
ui->est1025->setAlignment(Qt::AlignCenter);
ui->est1025->setMaximumWidth( m12trail);
ui->est1025->setMinimumWidth( m6trail);
ui->est1025->setMaximumHeight( m7traild3 );
ui->est1025->setMaxLength(11);
ui->est1025->setFrame(globalFrame);

ui->est1026->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "102   ") );
ui->est1026->setReadOnly(true);
ui->est1026->setAlignment(Qt::AlignRight);
ui->est1026->setMaximumWidth( m14trail);
ui->est1026->setMinimumWidth( m9trail);
ui->est1026->setMaximumHeight( m7traild3 );
ui->est1026->setMaxLength(15);
ui->est1026->setFrame(globalFrame);

ui->est1027->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "102   ") );
ui->est1027->setReadOnly(true);
ui->est1027->setAlignment(Qt::AlignRight);
ui->est1027->setMaximumWidth( m14trail);
ui->est1027->setMinimumWidth( m9trail);
ui->est1027->setMaximumHeight( m7traild3 );
ui->est1027->setMaxLength(15);
ui->est1027->setFrame(globalFrame);

ui->lib1031->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "103   ") );
connect( ui->lib1031, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1031, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib103, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst103, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1031->installEventFilter(this);
ui->lib1031->setMaximumWidth( m6trail);
ui->lib1031->setMinimumWidth( m6trail);
ui->lib1031->setMaximumHeight( m7traild3 );
ui->lib1031->setMaxLength(3);
ui->lib1031->setFrame(globalFrame);

ui->lib1032->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "103   ") );
connect( ui->lib1032, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1032, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1032->installEventFilter(this);
ui->lib1032->setMaximumWidth( m26trail);
ui->lib1032->setMinimumWidth( m25trail);
ui->lib1032->setMaximumHeight( m7traild3 );
ui->lib1032->setMaxLength(24);
ui->lib1032->setFrame(globalFrame);

ui->lib1033->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "103   ") );
connect( ui->lib1033, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1033, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1033->installEventFilter(this);
ui->lib1033->setAlignment(Qt::AlignCenter);
ui->lib1033->setMaximumWidth( m12trail);
ui->lib1033->setMinimumWidth( m6trail);
ui->lib1033->setMaximumHeight( m7traild3 );
ui->lib1033->setMaxLength(11);
ui->lib1033->setFrame(globalFrame);

ui->lib1034->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "103   ") );
connect( ui->lib1034, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1034, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1034->installEventFilter(this);
ui->lib1034->setAlignment(Qt::AlignCenter);
ui->lib1034->setMaximumWidth( m12trail);
ui->lib1034->setMinimumWidth( m6trail);
ui->lib1034->setMaximumHeight( m7traild3 );
ui->lib1034->setMaxLength(11);
ui->lib1034->setFrame(globalFrame);

ui->pushButtonEst103->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "103   ") );
ui->pushButtonEst103->setMaximumWidth( m7traild3 );
ui->pushButtonEst103->setMaximumHeight( m7traild3 );
ui->pushButtonLib103->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "103   ") );
ui->pushButtonLib103->setMaximumWidth( m7traild3 );
ui->pushButtonLib103->setMaximumHeight( m7traild3 );

ui->est1031->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "103   ") );
connect( ui->est1031, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1031, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1031->installEventFilter(this);
ui->est1031->setMaximumWidth( m6trail);
ui->est1031->setMinimumWidth( m6trail);
ui->est1031->setMaximumHeight( m7traild3 );
ui->est1031->setMaxLength(3);
ui->est1031->setFrame(globalFrame);

ui->est1032->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "103   ") );
connect( ui->est1032, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1032, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1032->installEventFilter(this);
ui->est1032->setMaximumWidth( m26trail);
ui->est1032->setMinimumWidth( m25trail);
ui->est1032->setMaximumHeight( m7traild3 );
ui->est1032->setMaxLength(24);
ui->est1032->setFrame(globalFrame);

ui->est1033->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "103   ") );
connect( ui->est1033, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1033, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1033->installEventFilter(this);
ui->est1033->setAlignment(Qt::AlignCenter);
ui->est1033->setMaximumWidth( m11trail);
ui->est1033->setMinimumWidth( m6trail);
ui->est1033->setMaximumHeight( m7traild3 );
ui->est1033->setMaxLength(8);
ui->est1033->setFrame(globalFrame);

ui->est1034->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "103   ") );
connect( ui->est1034, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1034, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1034->installEventFilter(this);
ui->est1034->setAlignment(Qt::AlignCenter);
ui->est1034->setMaximumWidth( m12trail);
ui->est1034->setMinimumWidth( m6trail);
ui->est1034->setMaximumHeight( m7traild3 );
ui->est1034->setMaxLength(11);
ui->est1034->setFrame(globalFrame);

ui->est1035->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "103   ") );
connect( ui->est1035, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1035, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1035->installEventFilter(this);
ui->est1035->setAlignment(Qt::AlignCenter);
ui->est1035->setMaximumWidth( m12trail);
ui->est1035->setMinimumWidth( m6trail);
ui->est1035->setMaximumHeight( m7traild3 );
ui->est1035->setMaxLength(11);
ui->est1035->setFrame(globalFrame);

ui->est1036->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "103   ") );
ui->est1036->setReadOnly(true);
ui->est1036->setAlignment(Qt::AlignRight);
ui->est1036->setMaximumWidth( m14trail);
ui->est1036->setMinimumWidth( m9trail);
ui->est1036->setMaximumHeight( m7traild3 );
ui->est1036->setMaxLength(15);
ui->est1036->setFrame(globalFrame);

ui->est1037->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "103   ") );
ui->est1037->setReadOnly(true);
ui->est1037->setAlignment(Qt::AlignRight);
ui->est1037->setMaximumWidth( m14trail);
ui->est1037->setMinimumWidth( m9trail);
ui->est1037->setMaximumHeight( m7traild3 );
ui->est1037->setMaxLength(15);
ui->est1037->setFrame(globalFrame);

ui->lib1041->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "104   ") );
connect( ui->lib1041, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1041, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib104, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst104, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1041->installEventFilter(this);
ui->lib1041->setMaximumWidth( m6trail);
ui->lib1041->setMinimumWidth( m6trail);
ui->lib1041->setMaximumHeight( m7traild3 );
ui->lib1041->setMaxLength(3);
ui->lib1041->setFrame(globalFrame);

ui->lib1042->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "104   ") );
connect( ui->lib1042, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1042, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1042->installEventFilter(this);
ui->lib1042->setMaximumWidth( m26trail);
ui->lib1042->setMinimumWidth( m25trail);
ui->lib1042->setMaximumHeight( m7traild3 );
ui->lib1042->setMaxLength(24);
ui->lib1042->setFrame(globalFrame);

ui->lib1043->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "104   ") );
connect( ui->lib1043, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1043, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1043->installEventFilter(this);
ui->lib1043->setAlignment(Qt::AlignCenter);
ui->lib1043->setMaximumWidth( m12trail);
ui->lib1043->setMinimumWidth( m6trail);
ui->lib1043->setMaximumHeight( m7traild3 );
ui->lib1043->setMaxLength(11);
ui->lib1043->setFrame(globalFrame);

ui->lib1044->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "104   ") );
connect( ui->lib1044, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1044, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1044->installEventFilter(this);
ui->lib1044->setAlignment(Qt::AlignCenter);
ui->lib1044->setMaximumWidth( m12trail);
ui->lib1044->setMinimumWidth( m6trail);
ui->lib1044->setMaximumHeight( m7traild3 );
ui->lib1044->setMaxLength(11);
ui->lib1044->setFrame(globalFrame);

ui->pushButtonEst104->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "104   ") );
ui->pushButtonEst104->setMaximumWidth( m7traild3 );
ui->pushButtonEst104->setMaximumHeight( m7traild3 );
ui->pushButtonLib104->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "104   ") );
ui->pushButtonLib104->setMaximumWidth( m7traild3 );
ui->pushButtonLib104->setMaximumHeight( m7traild3 );

ui->est1041->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "104   ") );
connect( ui->est1041, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1041, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1041->installEventFilter(this);
ui->est1041->setMaximumWidth( m6trail);
ui->est1041->setMinimumWidth( m6trail);
ui->est1041->setMaximumHeight( m7traild3 );
ui->est1041->setMaxLength(3);
ui->est1041->setFrame(globalFrame);

ui->est1042->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "104   ") );
connect( ui->est1042, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1042, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1042->installEventFilter(this);
ui->est1042->setMaximumWidth( m26trail);
ui->est1042->setMinimumWidth( m25trail);
ui->est1042->setMaximumHeight( m7traild3 );
ui->est1042->setMaxLength(24);
ui->est1042->setFrame(globalFrame);

ui->est1043->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "104   ") );
connect( ui->est1043, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1043, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1043->installEventFilter(this);
ui->est1043->setAlignment(Qt::AlignCenter);
ui->est1043->setMaximumWidth( m11trail);
ui->est1043->setMinimumWidth( m6trail);
ui->est1043->setMaximumHeight( m7traild3 );
ui->est1043->setMaxLength(8);
ui->est1043->setFrame(globalFrame);

ui->est1044->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "104   ") );
connect( ui->est1044, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1044, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1044->installEventFilter(this);
ui->est1044->setAlignment(Qt::AlignCenter);
ui->est1044->setMaximumWidth( m12trail);
ui->est1044->setMinimumWidth( m6trail);
ui->est1044->setMaximumHeight( m7traild3 );
ui->est1044->setMaxLength(11);
ui->est1044->setFrame(globalFrame);

ui->est1045->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "104   ") );
connect( ui->est1045, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1045, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1045->installEventFilter(this);
ui->est1045->setAlignment(Qt::AlignCenter);
ui->est1045->setMaximumWidth( m12trail);
ui->est1045->setMinimumWidth( m6trail);
ui->est1045->setMaximumHeight( m7traild3 );
ui->est1045->setMaxLength(11);
ui->est1045->setFrame(globalFrame);

ui->est1046->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "104   ") );
ui->est1046->setReadOnly(true);
ui->est1046->setAlignment(Qt::AlignRight);
ui->est1046->setMaximumWidth( m14trail);
ui->est1046->setMinimumWidth( m9trail);
ui->est1046->setMaximumHeight( m7traild3 );
ui->est1046->setMaxLength(15);
ui->est1046->setFrame(globalFrame);

ui->est1047->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "104   ") );
ui->est1047->setReadOnly(true);
ui->est1047->setAlignment(Qt::AlignRight);
ui->est1047->setMaximumWidth( m14trail);
ui->est1047->setMinimumWidth( m9trail);
ui->est1047->setMaximumHeight( m7traild3 );
ui->est1047->setMaxLength(15);
ui->est1047->setFrame(globalFrame);

ui->lib1051->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "105   ") );
connect( ui->lib1051, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1051, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib105, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst105, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1051->installEventFilter(this);
ui->lib1051->setMaximumWidth( m6trail);
ui->lib1051->setMinimumWidth( m6trail);
ui->lib1051->setMaximumHeight( m7traild3 );
ui->lib1051->setMaxLength(3);
ui->lib1051->setFrame(globalFrame);

ui->lib1052->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "105   ") );
connect( ui->lib1052, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1052, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1052->installEventFilter(this);
ui->lib1052->setMaximumWidth( m26trail);
ui->lib1052->setMinimumWidth( m25trail);
ui->lib1052->setMaximumHeight( m7traild3 );
ui->lib1052->setMaxLength(24);
ui->lib1052->setFrame(globalFrame);

ui->lib1053->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "105   ") );
connect( ui->lib1053, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1053, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1053->installEventFilter(this);
ui->lib1053->setAlignment(Qt::AlignCenter);
ui->lib1053->setMaximumWidth( m12trail);
ui->lib1053->setMinimumWidth( m6trail);
ui->lib1053->setMaximumHeight( m7traild3 );
ui->lib1053->setMaxLength(11);
ui->lib1053->setFrame(globalFrame);

ui->lib1054->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "105   ") );
connect( ui->lib1054, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1054, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1054->installEventFilter(this);
ui->lib1054->setAlignment(Qt::AlignCenter);
ui->lib1054->setMaximumWidth( m12trail);
ui->lib1054->setMinimumWidth( m6trail);
ui->lib1054->setMaximumHeight( m7traild3 );
ui->lib1054->setMaxLength(11);
ui->lib1054->setFrame(globalFrame);

ui->pushButtonEst105->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "105   ") );
ui->pushButtonEst105->setMaximumWidth( m7traild3 );
ui->pushButtonEst105->setMaximumHeight( m7traild3 );
ui->pushButtonLib105->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "105   ") );
ui->pushButtonLib105->setMaximumWidth( m7traild3 );
ui->pushButtonLib105->setMaximumHeight( m7traild3 );

ui->est1051->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "105   ") );
connect( ui->est1051, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1051, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1051->installEventFilter(this);
ui->est1051->setMaximumWidth( m6trail);
ui->est1051->setMinimumWidth( m6trail);
ui->est1051->setMaximumHeight( m7traild3 );
ui->est1051->setMaxLength(3);
ui->est1051->setFrame(globalFrame);

ui->est1052->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "105   ") );
connect( ui->est1052, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1052, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1052->installEventFilter(this);
ui->est1052->setMaximumWidth( m26trail);
ui->est1052->setMinimumWidth( m25trail);
ui->est1052->setMaximumHeight( m7traild3 );
ui->est1052->setMaxLength(24);
ui->est1052->setFrame(globalFrame);

ui->est1053->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "105   ") );
connect( ui->est1053, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1053, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1053->installEventFilter(this);
ui->est1053->setAlignment(Qt::AlignCenter);
ui->est1053->setMaximumWidth( m11trail);
ui->est1053->setMinimumWidth( m6trail);
ui->est1053->setMaximumHeight( m7traild3 );
ui->est1053->setMaxLength(8);
ui->est1053->setFrame(globalFrame);

ui->est1054->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "105   ") );
connect( ui->est1054, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1054, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1054->installEventFilter(this);
ui->est1054->setAlignment(Qt::AlignCenter);
ui->est1054->setMaximumWidth( m12trail);
ui->est1054->setMinimumWidth( m6trail);
ui->est1054->setMaximumHeight( m7traild3 );
ui->est1054->setMaxLength(11);
ui->est1054->setFrame(globalFrame);

ui->est1055->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "105   ") );
connect( ui->est1055, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1055, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1055->installEventFilter(this);
ui->est1055->setAlignment(Qt::AlignCenter);
ui->est1055->setMaximumWidth( m12trail);
ui->est1055->setMinimumWidth( m6trail);
ui->est1055->setMaximumHeight( m7traild3 );
ui->est1055->setMaxLength(11);
ui->est1055->setFrame(globalFrame);

ui->est1056->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "105   ") );
ui->est1056->setReadOnly(true);
ui->est1056->setAlignment(Qt::AlignRight);
ui->est1056->setMaximumWidth( m14trail);
ui->est1056->setMinimumWidth( m9trail);
ui->est1056->setMaximumHeight( m7traild3 );
ui->est1056->setMaxLength(15);
ui->est1056->setFrame(globalFrame);

ui->est1057->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "105   ") );
ui->est1057->setReadOnly(true);
ui->est1057->setAlignment(Qt::AlignRight);
ui->est1057->setMaximumWidth( m14trail);
ui->est1057->setMinimumWidth( m9trail);
ui->est1057->setMaximumHeight( m7traild3 );
ui->est1057->setMaxLength(15);
ui->est1057->setFrame(globalFrame);

ui->lib1061->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "106   ") );
connect( ui->lib1061, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1061, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib106, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst106, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1061->installEventFilter(this);
ui->lib1061->setMaximumWidth( m6trail);
ui->lib1061->setMinimumWidth( m6trail);
ui->lib1061->setMaximumHeight( m7traild3 );
ui->lib1061->setMaxLength(3);
ui->lib1061->setFrame(globalFrame);

ui->lib1062->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "106   ") );
connect( ui->lib1062, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1062, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1062->installEventFilter(this);
ui->lib1062->setMaximumWidth( m26trail);
ui->lib1062->setMinimumWidth( m25trail);
ui->lib1062->setMaximumHeight( m7traild3 );
ui->lib1062->setMaxLength(24);
ui->lib1062->setFrame(globalFrame);

ui->lib1063->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "106   ") );
connect( ui->lib1063, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1063, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1063->installEventFilter(this);
ui->lib1063->setAlignment(Qt::AlignCenter);
ui->lib1063->setMaximumWidth( m12trail);
ui->lib1063->setMinimumWidth( m6trail);
ui->lib1063->setMaximumHeight( m7traild3 );
ui->lib1063->setMaxLength(11);
ui->lib1063->setFrame(globalFrame);

ui->lib1064->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "106   ") );
connect( ui->lib1064, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1064, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1064->installEventFilter(this);
ui->lib1064->setAlignment(Qt::AlignCenter);
ui->lib1064->setMaximumWidth( m12trail);
ui->lib1064->setMinimumWidth( m6trail);
ui->lib1064->setMaximumHeight( m7traild3 );
ui->lib1064->setMaxLength(11);
ui->lib1064->setFrame(globalFrame);

ui->pushButtonEst106->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "106   ") );
ui->pushButtonEst106->setMaximumWidth( m7traild3 );
ui->pushButtonEst106->setMaximumHeight( m7traild3 );
ui->pushButtonLib106->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "106   ") );
ui->pushButtonLib106->setMaximumWidth( m7traild3 );
ui->pushButtonLib106->setMaximumHeight( m7traild3 );

ui->est1061->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "106   ") );
connect( ui->est1061, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1061, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1061->installEventFilter(this);
ui->est1061->setMaximumWidth( m6trail);
ui->est1061->setMinimumWidth( m6trail);
ui->est1061->setMaximumHeight( m7traild3 );
ui->est1061->setMaxLength(3);
ui->est1061->setFrame(globalFrame);

ui->est1062->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "106   ") );
connect( ui->est1062, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1062, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1062->installEventFilter(this);
ui->est1062->setMaximumWidth( m26trail);
ui->est1062->setMinimumWidth( m25trail);
ui->est1062->setMaximumHeight( m7traild3 );
ui->est1062->setMaxLength(24);
ui->est1062->setFrame(globalFrame);

ui->est1063->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "106   ") );
connect( ui->est1063, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1063, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1063->installEventFilter(this);
ui->est1063->setAlignment(Qt::AlignCenter);
ui->est1063->setMaximumWidth( m11trail);
ui->est1063->setMinimumWidth( m6trail);
ui->est1063->setMaximumHeight( m7traild3 );
ui->est1063->setMaxLength(8);
ui->est1063->setFrame(globalFrame);

ui->est1064->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "106   ") );
connect( ui->est1064, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1064, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1064->installEventFilter(this);
ui->est1064->setAlignment(Qt::AlignCenter);
ui->est1064->setMaximumWidth( m12trail);
ui->est1064->setMinimumWidth( m6trail);
ui->est1064->setMaximumHeight( m7traild3 );
ui->est1064->setMaxLength(11);
ui->est1064->setFrame(globalFrame);

ui->est1065->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "106   ") );
connect( ui->est1065, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1065, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1065->installEventFilter(this);
ui->est1065->setAlignment(Qt::AlignCenter);
ui->est1065->setMaximumWidth( m12trail);
ui->est1065->setMinimumWidth( m6trail);
ui->est1065->setMaximumHeight( m7traild3 );
ui->est1065->setMaxLength(11);
ui->est1065->setFrame(globalFrame);

ui->est1066->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "106   ") );
ui->est1066->setReadOnly(true);
ui->est1066->setAlignment(Qt::AlignRight);
ui->est1066->setMaximumWidth( m14trail);
ui->est1066->setMinimumWidth( m9trail);
ui->est1066->setMaximumHeight( m7traild3 );
ui->est1066->setMaxLength(15);
ui->est1066->setFrame(globalFrame);

ui->est1067->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "106   ") );
ui->est1067->setReadOnly(true);
ui->est1067->setAlignment(Qt::AlignRight);
ui->est1067->setMaximumWidth( m14trail);
ui->est1067->setMinimumWidth( m9trail);
ui->est1067->setMaximumHeight( m7traild3 );
ui->est1067->setMaxLength(15);
ui->est1067->setFrame(globalFrame);

ui->lib1071->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "107   ") );
connect( ui->lib1071, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1071, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib107, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst107, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1071->installEventFilter(this);
ui->lib1071->setMaximumWidth( m6trail);
ui->lib1071->setMinimumWidth( m6trail);
ui->lib1071->setMaximumHeight( m7traild3 );
ui->lib1071->setMaxLength(3);
ui->lib1071->setFrame(globalFrame);

ui->lib1072->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "107   ") );
connect( ui->lib1072, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1072, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1072->installEventFilter(this);
ui->lib1072->setMaximumWidth( m26trail);
ui->lib1072->setMinimumWidth( m25trail);
ui->lib1072->setMaximumHeight( m7traild3 );
ui->lib1072->setMaxLength(24);
ui->lib1072->setFrame(globalFrame);

ui->lib1073->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "107   ") );
connect( ui->lib1073, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1073, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1073->installEventFilter(this);
ui->lib1073->setAlignment(Qt::AlignCenter);
ui->lib1073->setMaximumWidth( m12trail);
ui->lib1073->setMinimumWidth( m6trail);
ui->lib1073->setMaximumHeight( m7traild3 );
ui->lib1073->setMaxLength(11);
ui->lib1073->setFrame(globalFrame);

ui->lib1074->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "107   ") );
connect( ui->lib1074, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1074, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1074->installEventFilter(this);
ui->lib1074->setAlignment(Qt::AlignCenter);
ui->lib1074->setMaximumWidth( m12trail);
ui->lib1074->setMinimumWidth( m6trail);
ui->lib1074->setMaximumHeight( m7traild3 );
ui->lib1074->setMaxLength(11);
ui->lib1074->setFrame(globalFrame);

ui->pushButtonEst107->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "107   ") );
ui->pushButtonEst107->setMaximumWidth( m7traild3 );
ui->pushButtonEst107->setMaximumHeight( m7traild3 );
ui->pushButtonLib107->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "107   ") );
ui->pushButtonLib107->setMaximumWidth( m7traild3 );
ui->pushButtonLib107->setMaximumHeight( m7traild3 );

ui->est1071->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "107   ") );
connect( ui->est1071, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1071, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1071->installEventFilter(this);
ui->est1071->setMaximumWidth( m6trail);
ui->est1071->setMinimumWidth( m6trail);
ui->est1071->setMaximumHeight( m7traild3 );
ui->est1071->setMaxLength(3);
ui->est1071->setFrame(globalFrame);

ui->est1072->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "107   ") );
connect( ui->est1072, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1072, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1072->installEventFilter(this);
ui->est1072->setMaximumWidth( m26trail);
ui->est1072->setMinimumWidth( m25trail);
ui->est1072->setMaximumHeight( m7traild3 );
ui->est1072->setMaxLength(24);
ui->est1072->setFrame(globalFrame);

ui->est1073->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "107   ") );
connect( ui->est1073, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1073, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1073->installEventFilter(this);
ui->est1073->setAlignment(Qt::AlignCenter);
ui->est1073->setMaximumWidth( m11trail);
ui->est1073->setMinimumWidth( m6trail);
ui->est1073->setMaximumHeight( m7traild3 );
ui->est1073->setMaxLength(8);
ui->est1073->setFrame(globalFrame);

ui->est1074->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "107   ") );
connect( ui->est1074, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1074, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1074->installEventFilter(this);
ui->est1074->setAlignment(Qt::AlignCenter);
ui->est1074->setMaximumWidth( m12trail);
ui->est1074->setMinimumWidth( m6trail);
ui->est1074->setMaximumHeight( m7traild3 );
ui->est1074->setMaxLength(11);
ui->est1074->setFrame(globalFrame);

ui->est1075->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "107   ") );
connect( ui->est1075, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1075, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1075->installEventFilter(this);
ui->est1075->setAlignment(Qt::AlignCenter);
ui->est1075->setMaximumWidth( m12trail);
ui->est1075->setMinimumWidth( m6trail);
ui->est1075->setMaximumHeight( m7traild3 );
ui->est1075->setMaxLength(11);
ui->est1075->setFrame(globalFrame);

ui->est1076->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "107   ") );
ui->est1076->setReadOnly(true);
ui->est1076->setAlignment(Qt::AlignRight);
ui->est1076->setMaximumWidth( m14trail);
ui->est1076->setMinimumWidth( m9trail);
ui->est1076->setMaximumHeight( m7traild3 );
ui->est1076->setMaxLength(15);
ui->est1076->setFrame(globalFrame);

ui->est1077->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "107   ") );
ui->est1077->setReadOnly(true);
ui->est1077->setAlignment(Qt::AlignRight);
ui->est1077->setMaximumWidth( m14trail);
ui->est1077->setMinimumWidth( m9trail);
ui->est1077->setMaximumHeight( m7traild3 );
ui->est1077->setMaxLength(15);
ui->est1077->setFrame(globalFrame);

ui->lib1081->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "108   ") );
connect( ui->lib1081, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1081, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib108, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst108, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1081->installEventFilter(this);
ui->lib1081->setMaximumWidth( m6trail);
ui->lib1081->setMinimumWidth( m6trail);
ui->lib1081->setMaximumHeight( m7traild3 );
ui->lib1081->setMaxLength(3);
ui->lib1081->setFrame(globalFrame);

ui->lib1082->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "108   ") );
connect( ui->lib1082, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1082, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1082->installEventFilter(this);
ui->lib1082->setMaximumWidth( m26trail);
ui->lib1082->setMinimumWidth( m25trail);
ui->lib1082->setMaximumHeight( m7traild3 );
ui->lib1082->setMaxLength(24);
ui->lib1082->setFrame(globalFrame);

ui->lib1083->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "108   ") );
connect( ui->lib1083, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1083, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1083->installEventFilter(this);
ui->lib1083->setAlignment(Qt::AlignCenter);
ui->lib1083->setMaximumWidth( m12trail);
ui->lib1083->setMinimumWidth( m6trail);
ui->lib1083->setMaximumHeight( m7traild3 );
ui->lib1083->setMaxLength(11);
ui->lib1083->setFrame(globalFrame);

ui->lib1084->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "108   ") );
connect( ui->lib1084, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1084, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1084->installEventFilter(this);
ui->lib1084->setAlignment(Qt::AlignCenter);
ui->lib1084->setMaximumWidth( m12trail);
ui->lib1084->setMinimumWidth( m6trail);
ui->lib1084->setMaximumHeight( m7traild3 );
ui->lib1084->setMaxLength(11);
ui->lib1084->setFrame(globalFrame);

ui->pushButtonEst108->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "108   ") );
ui->pushButtonEst108->setMaximumWidth( m7traild3 );
ui->pushButtonEst108->setMaximumHeight( m7traild3 );
ui->pushButtonLib108->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "108   ") );
ui->pushButtonLib108->setMaximumWidth( m7traild3 );
ui->pushButtonLib108->setMaximumHeight( m7traild3 );

ui->est1081->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "108   ") );
connect( ui->est1081, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1081, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1081->installEventFilter(this);
ui->est1081->setMaximumWidth( m6trail);
ui->est1081->setMinimumWidth( m6trail);
ui->est1081->setMaximumHeight( m7traild3 );
ui->est1081->setMaxLength(3);
ui->est1081->setFrame(globalFrame);

ui->est1082->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "108   ") );
connect( ui->est1082, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1082, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1082->installEventFilter(this);
ui->est1082->setMaximumWidth( m26trail);
ui->est1082->setMinimumWidth( m25trail);
ui->est1082->setMaximumHeight( m7traild3 );
ui->est1082->setMaxLength(24);
ui->est1082->setFrame(globalFrame);

ui->est1083->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "108   ") );
connect( ui->est1083, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1083, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1083->installEventFilter(this);
ui->est1083->setAlignment(Qt::AlignCenter);
ui->est1083->setMaximumWidth( m11trail);
ui->est1083->setMinimumWidth( m6trail);
ui->est1083->setMaximumHeight( m7traild3 );
ui->est1083->setMaxLength(8);
ui->est1083->setFrame(globalFrame);

ui->est1084->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "108   ") );
connect( ui->est1084, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1084, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1084->installEventFilter(this);
ui->est1084->setAlignment(Qt::AlignCenter);
ui->est1084->setMaximumWidth( m12trail);
ui->est1084->setMinimumWidth( m6trail);
ui->est1084->setMaximumHeight( m7traild3 );
ui->est1084->setMaxLength(11);
ui->est1084->setFrame(globalFrame);

ui->est1085->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "108   ") );
connect( ui->est1085, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1085, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1085->installEventFilter(this);
ui->est1085->setAlignment(Qt::AlignCenter);
ui->est1085->setMaximumWidth( m12trail);
ui->est1085->setMinimumWidth( m6trail);
ui->est1085->setMaximumHeight( m7traild3 );
ui->est1085->setMaxLength(11);
ui->est1085->setFrame(globalFrame);

ui->est1086->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "108   ") );
ui->est1086->setReadOnly(true);
ui->est1086->setAlignment(Qt::AlignRight);
ui->est1086->setMaximumWidth( m14trail);
ui->est1086->setMinimumWidth( m9trail);
ui->est1086->setMaximumHeight( m7traild3 );
ui->est1086->setMaxLength(15);
ui->est1086->setFrame(globalFrame);

ui->est1087->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "108   ") );
ui->est1087->setReadOnly(true);
ui->est1087->setAlignment(Qt::AlignRight);
ui->est1087->setMaximumWidth( m14trail);
ui->est1087->setMinimumWidth( m9trail);
ui->est1087->setMaximumHeight( m7traild3 );
ui->est1087->setMaxLength(15);
ui->est1087->setFrame(globalFrame);

ui->lib1091->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "109   ") );
connect( ui->lib1091, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1091, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib109, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst109, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1091->installEventFilter(this);
ui->lib1091->setMaximumWidth( m6trail);
ui->lib1091->setMinimumWidth( m6trail);
ui->lib1091->setMaximumHeight( m7traild3 );
ui->lib1091->setMaxLength(3);
ui->lib1091->setFrame(globalFrame);

ui->lib1092->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "109   ") );
connect( ui->lib1092, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1092, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1092->installEventFilter(this);
ui->lib1092->setMaximumWidth( m26trail);
ui->lib1092->setMinimumWidth( m25trail);
ui->lib1092->setMaximumHeight( m7traild3 );
ui->lib1092->setMaxLength(24);
ui->lib1092->setFrame(globalFrame);

ui->lib1093->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "109   ") );
connect( ui->lib1093, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1093, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1093->installEventFilter(this);
ui->lib1093->setAlignment(Qt::AlignCenter);
ui->lib1093->setMaximumWidth( m12trail);
ui->lib1093->setMinimumWidth( m6trail);
ui->lib1093->setMaximumHeight( m7traild3 );
ui->lib1093->setMaxLength(11);
ui->lib1093->setFrame(globalFrame);

ui->lib1094->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "109   ") );
connect( ui->lib1094, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1094, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1094->installEventFilter(this);
ui->lib1094->setAlignment(Qt::AlignCenter);
ui->lib1094->setMaximumWidth( m12trail);
ui->lib1094->setMinimumWidth( m6trail);
ui->lib1094->setMaximumHeight( m7traild3 );
ui->lib1094->setMaxLength(11);
ui->lib1094->setFrame(globalFrame);

ui->pushButtonEst109->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "109   ") );
ui->pushButtonEst109->setMaximumWidth( m7traild3 );
ui->pushButtonEst109->setMaximumHeight( m7traild3 );
ui->pushButtonLib109->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "109   ") );
ui->pushButtonLib109->setMaximumWidth( m7traild3 );
ui->pushButtonLib109->setMaximumHeight( m7traild3 );

ui->est1091->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "109   ") );
connect( ui->est1091, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1091, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1091->installEventFilter(this);
ui->est1091->setMaximumWidth( m6trail);
ui->est1091->setMinimumWidth( m6trail);
ui->est1091->setMaximumHeight( m7traild3 );
ui->est1091->setMaxLength(3);
ui->est1091->setFrame(globalFrame);

ui->est1092->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "109   ") );
connect( ui->est1092, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1092, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1092->installEventFilter(this);
ui->est1092->setMaximumWidth( m26trail);
ui->est1092->setMinimumWidth( m25trail);
ui->est1092->setMaximumHeight( m7traild3 );
ui->est1092->setMaxLength(24);
ui->est1092->setFrame(globalFrame);

ui->est1093->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "109   ") );
connect( ui->est1093, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1093, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1093->installEventFilter(this);
ui->est1093->setAlignment(Qt::AlignCenter);
ui->est1093->setMaximumWidth( m11trail);
ui->est1093->setMinimumWidth( m6trail);
ui->est1093->setMaximumHeight( m7traild3 );
ui->est1093->setMaxLength(8);
ui->est1093->setFrame(globalFrame);

ui->est1094->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "109   ") );
connect( ui->est1094, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1094, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1094->installEventFilter(this);
ui->est1094->setAlignment(Qt::AlignCenter);
ui->est1094->setMaximumWidth( m12trail);
ui->est1094->setMinimumWidth( m6trail);
ui->est1094->setMaximumHeight( m7traild3 );
ui->est1094->setMaxLength(11);
ui->est1094->setFrame(globalFrame);

ui->est1095->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "109   ") );
connect( ui->est1095, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1095, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1095->installEventFilter(this);
ui->est1095->setAlignment(Qt::AlignCenter);
ui->est1095->setMaximumWidth( m12trail);
ui->est1095->setMinimumWidth( m6trail);
ui->est1095->setMaximumHeight( m7traild3 );
ui->est1095->setMaxLength(11);
ui->est1095->setFrame(globalFrame);

ui->est1096->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "109   ") );
ui->est1096->setReadOnly(true);
ui->est1096->setAlignment(Qt::AlignRight);
ui->est1096->setMaximumWidth( m14trail);
ui->est1096->setMinimumWidth( m9trail);
ui->est1096->setMaximumHeight( m7traild3 );
ui->est1096->setMaxLength(15);
ui->est1096->setFrame(globalFrame);

ui->est1097->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "109   ") );
ui->est1097->setReadOnly(true);
ui->est1097->setAlignment(Qt::AlignRight);
ui->est1097->setMaximumWidth( m14trail);
ui->est1097->setMinimumWidth( m9trail);
ui->est1097->setMaximumHeight( m7traild3 );
ui->est1097->setMaxLength(15);
ui->est1097->setFrame(globalFrame);

ui->lib1101->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "110   ") );
connect( ui->lib1101, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1101, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib110, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst110, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1101->installEventFilter(this);
ui->lib1101->setMaximumWidth( m6trail);
ui->lib1101->setMinimumWidth( m6trail);
ui->lib1101->setMaximumHeight( m7traild3 );
ui->lib1101->setMaxLength(3);
ui->lib1101->setFrame(globalFrame);

ui->lib1102->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "110   ") );
connect( ui->lib1102, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1102, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1102->installEventFilter(this);
ui->lib1102->setMaximumWidth( m26trail);
ui->lib1102->setMinimumWidth( m25trail);
ui->lib1102->setMaximumHeight( m7traild3 );
ui->lib1102->setMaxLength(24);
ui->lib1102->setFrame(globalFrame);

ui->lib1103->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "110   ") );
connect( ui->lib1103, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1103, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1103->installEventFilter(this);
ui->lib1103->setAlignment(Qt::AlignCenter);
ui->lib1103->setMaximumWidth( m12trail);
ui->lib1103->setMinimumWidth( m6trail);
ui->lib1103->setMaximumHeight( m7traild3 );
ui->lib1103->setMaxLength(11);
ui->lib1103->setFrame(globalFrame);

ui->lib1104->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "110   ") );
connect( ui->lib1104, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1104, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1104->installEventFilter(this);
ui->lib1104->setAlignment(Qt::AlignCenter);
ui->lib1104->setMaximumWidth( m12trail);
ui->lib1104->setMinimumWidth( m6trail);
ui->lib1104->setMaximumHeight( m7traild3 );
ui->lib1104->setMaxLength(11);
ui->lib1104->setFrame(globalFrame);

ui->pushButtonEst110->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "110   ") );
ui->pushButtonEst110->setMaximumWidth( m7traild3 );
ui->pushButtonEst110->setMaximumHeight( m7traild3 );
ui->pushButtonLib110->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "110   ") );
ui->pushButtonLib110->setMaximumWidth( m7traild3 );
ui->pushButtonLib110->setMaximumHeight( m7traild3 );

ui->est1101->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "110   ") );
connect( ui->est1101, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1101, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1101->installEventFilter(this);
ui->est1101->setMaximumWidth( m6trail);
ui->est1101->setMinimumWidth( m6trail);
ui->est1101->setMaximumHeight( m7traild3 );
ui->est1101->setMaxLength(3);
ui->est1101->setFrame(globalFrame);

ui->est1102->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "110   ") );
connect( ui->est1102, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1102, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1102->installEventFilter(this);
ui->est1102->setMaximumWidth( m26trail);
ui->est1102->setMinimumWidth( m25trail);
ui->est1102->setMaximumHeight( m7traild3 );
ui->est1102->setMaxLength(24);
ui->est1102->setFrame(globalFrame);

ui->est1103->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "110   ") );
connect( ui->est1103, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1103, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1103->installEventFilter(this);
ui->est1103->setAlignment(Qt::AlignCenter);
ui->est1103->setMaximumWidth( m11trail);
ui->est1103->setMinimumWidth( m6trail);
ui->est1103->setMaximumHeight( m7traild3 );
ui->est1103->setMaxLength(8);
ui->est1103->setFrame(globalFrame);

ui->est1104->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "110   ") );
connect( ui->est1104, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1104, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1104->installEventFilter(this);
ui->est1104->setAlignment(Qt::AlignCenter);
ui->est1104->setMaximumWidth( m12trail);
ui->est1104->setMinimumWidth( m6trail);
ui->est1104->setMaximumHeight( m7traild3 );
ui->est1104->setMaxLength(11);
ui->est1104->setFrame(globalFrame);

ui->est1105->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "110   ") );
connect( ui->est1105, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1105, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1105->installEventFilter(this);
ui->est1105->setAlignment(Qt::AlignCenter);
ui->est1105->setMaximumWidth( m12trail);
ui->est1105->setMinimumWidth( m6trail);
ui->est1105->setMaximumHeight( m7traild3 );
ui->est1105->setMaxLength(11);
ui->est1105->setFrame(globalFrame);

ui->est1106->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "110   ") );
ui->est1106->setReadOnly(true);
ui->est1106->setAlignment(Qt::AlignRight);
ui->est1106->setMaximumWidth( m14trail);
ui->est1106->setMinimumWidth( m9trail);
ui->est1106->setMaximumHeight( m7traild3 );
ui->est1106->setMaxLength(15);
ui->est1106->setFrame(globalFrame);

ui->est1107->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "110   ") );
ui->est1107->setReadOnly(true);
ui->est1107->setAlignment(Qt::AlignRight);
ui->est1107->setMaximumWidth( m14trail);
ui->est1107->setMinimumWidth( m9trail);
ui->est1107->setMaximumHeight( m7traild3 );
ui->est1107->setMaxLength(15);
ui->est1107->setFrame(globalFrame);

ui->lib1111->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "111   ") );
connect( ui->lib1111, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1111, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib111, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst111, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1111->installEventFilter(this);
ui->lib1111->setMaximumWidth( m6trail);
ui->lib1111->setMinimumWidth( m6trail);
ui->lib1111->setMaximumHeight( m7traild3 );
ui->lib1111->setMaxLength(3);
ui->lib1111->setFrame(globalFrame);

ui->lib1112->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "111   ") );
connect( ui->lib1112, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1112, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1112->installEventFilter(this);
ui->lib1112->setMaximumWidth( m26trail);
ui->lib1112->setMinimumWidth( m25trail);
ui->lib1112->setMaximumHeight( m7traild3 );
ui->lib1112->setMaxLength(24);
ui->lib1112->setFrame(globalFrame);

ui->lib1113->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "111   ") );
connect( ui->lib1113, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1113, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1113->installEventFilter(this);
ui->lib1113->setAlignment(Qt::AlignCenter);
ui->lib1113->setMaximumWidth( m12trail);
ui->lib1113->setMinimumWidth( m6trail);
ui->lib1113->setMaximumHeight( m7traild3 );
ui->lib1113->setMaxLength(11);
ui->lib1113->setFrame(globalFrame);

ui->lib1114->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "111   ") );
connect( ui->lib1114, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1114, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1114->installEventFilter(this);
ui->lib1114->setAlignment(Qt::AlignCenter);
ui->lib1114->setMaximumWidth( m12trail);
ui->lib1114->setMinimumWidth( m6trail);
ui->lib1114->setMaximumHeight( m7traild3 );
ui->lib1114->setMaxLength(11);
ui->lib1114->setFrame(globalFrame);

ui->pushButtonEst111->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "111   ") );
ui->pushButtonEst111->setMaximumWidth( m7traild3 );
ui->pushButtonEst111->setMaximumHeight( m7traild3 );
ui->pushButtonLib111->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "111   ") );
ui->pushButtonLib111->setMaximumWidth( m7traild3 );
ui->pushButtonLib111->setMaximumHeight( m7traild3 );

ui->est1111->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "111   ") );
connect( ui->est1111, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1111, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1111->installEventFilter(this);
ui->est1111->setMaximumWidth( m6trail);
ui->est1111->setMinimumWidth( m6trail);
ui->est1111->setMaximumHeight( m7traild3 );
ui->est1111->setMaxLength(3);
ui->est1111->setFrame(globalFrame);

ui->est1112->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "111   ") );
connect( ui->est1112, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1112, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1112->installEventFilter(this);
ui->est1112->setMaximumWidth( m26trail);
ui->est1112->setMinimumWidth( m25trail);
ui->est1112->setMaximumHeight( m7traild3 );
ui->est1112->setMaxLength(24);
ui->est1112->setFrame(globalFrame);

ui->est1113->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "111   ") );
connect( ui->est1113, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1113, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1113->installEventFilter(this);
ui->est1113->setAlignment(Qt::AlignCenter);
ui->est1113->setMaximumWidth( m11trail);
ui->est1113->setMinimumWidth( m6trail);
ui->est1113->setMaximumHeight( m7traild3 );
ui->est1113->setMaxLength(8);
ui->est1113->setFrame(globalFrame);

ui->est1114->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "111   ") );
connect( ui->est1114, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1114, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1114->installEventFilter(this);
ui->est1114->setAlignment(Qt::AlignCenter);
ui->est1114->setMaximumWidth( m12trail);
ui->est1114->setMinimumWidth( m6trail);
ui->est1114->setMaximumHeight( m7traild3 );
ui->est1114->setMaxLength(11);
ui->est1114->setFrame(globalFrame);

ui->est1115->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "111   ") );
connect( ui->est1115, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1115, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1115->installEventFilter(this);
ui->est1115->setAlignment(Qt::AlignCenter);
ui->est1115->setMaximumWidth( m12trail);
ui->est1115->setMinimumWidth( m6trail);
ui->est1115->setMaximumHeight( m7traild3 );
ui->est1115->setMaxLength(11);
ui->est1115->setFrame(globalFrame);

ui->est1116->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "111   ") );
ui->est1116->setReadOnly(true);
ui->est1116->setAlignment(Qt::AlignRight);
ui->est1116->setMaximumWidth( m14trail);
ui->est1116->setMinimumWidth( m9trail);
ui->est1116->setMaximumHeight( m7traild3 );
ui->est1116->setMaxLength(15);
ui->est1116->setFrame(globalFrame);

ui->est1117->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "111   ") );
ui->est1117->setReadOnly(true);
ui->est1117->setAlignment(Qt::AlignRight);
ui->est1117->setMaximumWidth( m14trail);
ui->est1117->setMinimumWidth( m9trail);
ui->est1117->setMaximumHeight( m7traild3 );
ui->est1117->setMaxLength(15);
ui->est1117->setFrame(globalFrame);

ui->lib1121->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "112   ") );
connect( ui->lib1121, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1121, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib112, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst112, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1121->installEventFilter(this);
ui->lib1121->setMaximumWidth( m6trail);
ui->lib1121->setMinimumWidth( m6trail);
ui->lib1121->setMaximumHeight( m7traild3 );
ui->lib1121->setMaxLength(3);
ui->lib1121->setFrame(globalFrame);

ui->lib1122->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "112   ") );
connect( ui->lib1122, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1122, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1122->installEventFilter(this);
ui->lib1122->setMaximumWidth( m26trail);
ui->lib1122->setMinimumWidth( m25trail);
ui->lib1122->setMaximumHeight( m7traild3 );
ui->lib1122->setMaxLength(24);
ui->lib1122->setFrame(globalFrame);

ui->lib1123->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "112   ") );
connect( ui->lib1123, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1123, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1123->installEventFilter(this);
ui->lib1123->setAlignment(Qt::AlignCenter);
ui->lib1123->setMaximumWidth( m12trail);
ui->lib1123->setMinimumWidth( m6trail);
ui->lib1123->setMaximumHeight( m7traild3 );
ui->lib1123->setMaxLength(11);
ui->lib1123->setFrame(globalFrame);

ui->lib1124->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "112   ") );
connect( ui->lib1124, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1124, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1124->installEventFilter(this);
ui->lib1124->setAlignment(Qt::AlignCenter);
ui->lib1124->setMaximumWidth( m12trail);
ui->lib1124->setMinimumWidth( m6trail);
ui->lib1124->setMaximumHeight( m7traild3 );
ui->lib1124->setMaxLength(11);
ui->lib1124->setFrame(globalFrame);

ui->pushButtonEst112->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "112   ") );
ui->pushButtonEst112->setMaximumWidth( m7traild3 );
ui->pushButtonEst112->setMaximumHeight( m7traild3 );
ui->pushButtonLib112->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "112   ") );
ui->pushButtonLib112->setMaximumWidth( m7traild3 );
ui->pushButtonLib112->setMaximumHeight( m7traild3 );

ui->est1121->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "112   ") );
connect( ui->est1121, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1121, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1121->installEventFilter(this);
ui->est1121->setMaximumWidth( m6trail);
ui->est1121->setMinimumWidth( m6trail);
ui->est1121->setMaximumHeight( m7traild3 );
ui->est1121->setMaxLength(3);
ui->est1121->setFrame(globalFrame);

ui->est1122->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "112   ") );
connect( ui->est1122, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1122, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1122->installEventFilter(this);
ui->est1122->setMaximumWidth( m26trail);
ui->est1122->setMinimumWidth( m25trail);
ui->est1122->setMaximumHeight( m7traild3 );
ui->est1122->setMaxLength(24);
ui->est1122->setFrame(globalFrame);

ui->est1123->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "112   ") );
connect( ui->est1123, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1123, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1123->installEventFilter(this);
ui->est1123->setAlignment(Qt::AlignCenter);
ui->est1123->setMaximumWidth( m11trail);
ui->est1123->setMinimumWidth( m6trail);
ui->est1123->setMaximumHeight( m7traild3 );
ui->est1123->setMaxLength(8);
ui->est1123->setFrame(globalFrame);

ui->est1124->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "112   ") );
connect( ui->est1124, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1124, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1124->installEventFilter(this);
ui->est1124->setAlignment(Qt::AlignCenter);
ui->est1124->setMaximumWidth( m12trail);
ui->est1124->setMinimumWidth( m6trail);
ui->est1124->setMaximumHeight( m7traild3 );
ui->est1124->setMaxLength(11);
ui->est1124->setFrame(globalFrame);

ui->est1125->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "112   ") );
connect( ui->est1125, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1125, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1125->installEventFilter(this);
ui->est1125->setAlignment(Qt::AlignCenter);
ui->est1125->setMaximumWidth( m12trail);
ui->est1125->setMinimumWidth( m6trail);
ui->est1125->setMaximumHeight( m7traild3 );
ui->est1125->setMaxLength(11);
ui->est1125->setFrame(globalFrame);

ui->est1126->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "112   ") );
ui->est1126->setReadOnly(true);
ui->est1126->setAlignment(Qt::AlignRight);
ui->est1126->setMaximumWidth( m14trail);
ui->est1126->setMinimumWidth( m9trail);
ui->est1126->setMaximumHeight( m7traild3 );
ui->est1126->setMaxLength(15);
ui->est1126->setFrame(globalFrame);

ui->est1127->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "112   ") );
ui->est1127->setReadOnly(true);
ui->est1127->setAlignment(Qt::AlignRight);
ui->est1127->setMaximumWidth( m14trail);
ui->est1127->setMinimumWidth( m9trail);
ui->est1127->setMaximumHeight( m7traild3 );
ui->est1127->setMaxLength(15);
ui->est1127->setFrame(globalFrame);

ui->lib1131->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "113   ") );
connect( ui->lib1131, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1131, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib113, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst113, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1131->installEventFilter(this);
ui->lib1131->setMaximumWidth( m6trail);
ui->lib1131->setMinimumWidth( m6trail);
ui->lib1131->setMaximumHeight( m7traild3 );
ui->lib1131->setMaxLength(3);
ui->lib1131->setFrame(globalFrame);

ui->lib1132->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "113   ") );
connect( ui->lib1132, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1132, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1132->installEventFilter(this);
ui->lib1132->setMaximumWidth( m26trail);
ui->lib1132->setMinimumWidth( m25trail);
ui->lib1132->setMaximumHeight( m7traild3 );
ui->lib1132->setMaxLength(24);
ui->lib1132->setFrame(globalFrame);

ui->lib1133->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "113   ") );
connect( ui->lib1133, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1133, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1133->installEventFilter(this);
ui->lib1133->setAlignment(Qt::AlignCenter);
ui->lib1133->setMaximumWidth( m12trail);
ui->lib1133->setMinimumWidth( m6trail);
ui->lib1133->setMaximumHeight( m7traild3 );
ui->lib1133->setMaxLength(11);
ui->lib1133->setFrame(globalFrame);

ui->lib1134->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "113   ") );
connect( ui->lib1134, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1134, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1134->installEventFilter(this);
ui->lib1134->setAlignment(Qt::AlignCenter);
ui->lib1134->setMaximumWidth( m12trail);
ui->lib1134->setMinimumWidth( m6trail);
ui->lib1134->setMaximumHeight( m7traild3 );
ui->lib1134->setMaxLength(11);
ui->lib1134->setFrame(globalFrame);

ui->pushButtonEst113->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "113   ") );
ui->pushButtonEst113->setMaximumWidth( m7traild3 );
ui->pushButtonEst113->setMaximumHeight( m7traild3 );
ui->pushButtonLib113->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "113   ") );
ui->pushButtonLib113->setMaximumWidth( m7traild3 );
ui->pushButtonLib113->setMaximumHeight( m7traild3 );

ui->est1131->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "113   ") );
connect( ui->est1131, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1131, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1131->installEventFilter(this);
ui->est1131->setMaximumWidth( m6trail);
ui->est1131->setMinimumWidth( m6trail);
ui->est1131->setMaximumHeight( m7traild3 );
ui->est1131->setMaxLength(3);
ui->est1131->setFrame(globalFrame);

ui->est1132->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "113   ") );
connect( ui->est1132, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1132, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1132->installEventFilter(this);
ui->est1132->setMaximumWidth( m26trail);
ui->est1132->setMinimumWidth( m25trail);
ui->est1132->setMaximumHeight( m7traild3 );
ui->est1132->setMaxLength(24);
ui->est1132->setFrame(globalFrame);

ui->est1133->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "113   ") );
connect( ui->est1133, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1133, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1133->installEventFilter(this);
ui->est1133->setAlignment(Qt::AlignCenter);
ui->est1133->setMaximumWidth( m11trail);
ui->est1133->setMinimumWidth( m6trail);
ui->est1133->setMaximumHeight( m7traild3 );
ui->est1133->setMaxLength(8);
ui->est1133->setFrame(globalFrame);

ui->est1134->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "113   ") );
connect( ui->est1134, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1134, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1134->installEventFilter(this);
ui->est1134->setAlignment(Qt::AlignCenter);
ui->est1134->setMaximumWidth( m12trail);
ui->est1134->setMinimumWidth( m6trail);
ui->est1134->setMaximumHeight( m7traild3 );
ui->est1134->setMaxLength(11);
ui->est1134->setFrame(globalFrame);

ui->est1135->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "113   ") );
connect( ui->est1135, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1135, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1135->installEventFilter(this);
ui->est1135->setAlignment(Qt::AlignCenter);
ui->est1135->setMaximumWidth( m12trail);
ui->est1135->setMinimumWidth( m6trail);
ui->est1135->setMaximumHeight( m7traild3 );
ui->est1135->setMaxLength(11);
ui->est1135->setFrame(globalFrame);

ui->est1136->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "113   ") );
ui->est1136->setReadOnly(true);
ui->est1136->setAlignment(Qt::AlignRight);
ui->est1136->setMaximumWidth( m14trail);
ui->est1136->setMinimumWidth( m9trail);
ui->est1136->setMaximumHeight( m7traild3 );
ui->est1136->setMaxLength(15);
ui->est1136->setFrame(globalFrame);

ui->est1137->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "113   ") );
ui->est1137->setReadOnly(true);
ui->est1137->setAlignment(Qt::AlignRight);
ui->est1137->setMaximumWidth( m14trail);
ui->est1137->setMinimumWidth( m9trail);
ui->est1137->setMaximumHeight( m7traild3 );
ui->est1137->setMaxLength(15);
ui->est1137->setFrame(globalFrame);

ui->lib1141->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "114   ") );
connect( ui->lib1141, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1141, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib114, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst114, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1141->installEventFilter(this);
ui->lib1141->setMaximumWidth( m6trail);
ui->lib1141->setMinimumWidth( m6trail);
ui->lib1141->setMaximumHeight( m7traild3 );
ui->lib1141->setMaxLength(3);
ui->lib1141->setFrame(globalFrame);

ui->lib1142->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "114   ") );
connect( ui->lib1142, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1142, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1142->installEventFilter(this);
ui->lib1142->setMaximumWidth( m26trail);
ui->lib1142->setMinimumWidth( m25trail);
ui->lib1142->setMaximumHeight( m7traild3 );
ui->lib1142->setMaxLength(24);
ui->lib1142->setFrame(globalFrame);

ui->lib1143->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "114   ") );
connect( ui->lib1143, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1143, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1143->installEventFilter(this);
ui->lib1143->setAlignment(Qt::AlignCenter);
ui->lib1143->setMaximumWidth( m12trail);
ui->lib1143->setMinimumWidth( m6trail);
ui->lib1143->setMaximumHeight( m7traild3 );
ui->lib1143->setMaxLength(11);
ui->lib1143->setFrame(globalFrame);

ui->lib1144->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "114   ") );
connect( ui->lib1144, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1144, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1144->installEventFilter(this);
ui->lib1144->setAlignment(Qt::AlignCenter);
ui->lib1144->setMaximumWidth( m12trail);
ui->lib1144->setMinimumWidth( m6trail);
ui->lib1144->setMaximumHeight( m7traild3 );
ui->lib1144->setMaxLength(11);
ui->lib1144->setFrame(globalFrame);

ui->pushButtonEst114->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "114   ") );
ui->pushButtonEst114->setMaximumWidth( m7traild3 );
ui->pushButtonEst114->setMaximumHeight( m7traild3 );
ui->pushButtonLib114->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "114   ") );
ui->pushButtonLib114->setMaximumWidth( m7traild3 );
ui->pushButtonLib114->setMaximumHeight( m7traild3 );

ui->est1141->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "114   ") );
connect( ui->est1141, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1141, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1141->installEventFilter(this);
ui->est1141->setMaximumWidth( m6trail);
ui->est1141->setMinimumWidth( m6trail);
ui->est1141->setMaximumHeight( m7traild3 );
ui->est1141->setMaxLength(3);
ui->est1141->setFrame(globalFrame);

ui->est1142->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "114   ") );
connect( ui->est1142, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1142, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1142->installEventFilter(this);
ui->est1142->setMaximumWidth( m26trail);
ui->est1142->setMinimumWidth( m25trail);
ui->est1142->setMaximumHeight( m7traild3 );
ui->est1142->setMaxLength(24);
ui->est1142->setFrame(globalFrame);

ui->est1143->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "114   ") );
connect( ui->est1143, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1143, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1143->installEventFilter(this);
ui->est1143->setAlignment(Qt::AlignCenter);
ui->est1143->setMaximumWidth( m11trail);
ui->est1143->setMinimumWidth( m6trail);
ui->est1143->setMaximumHeight( m7traild3 );
ui->est1143->setMaxLength(8);
ui->est1143->setFrame(globalFrame);

ui->est1144->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "114   ") );
connect( ui->est1144, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1144, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1144->installEventFilter(this);
ui->est1144->setAlignment(Qt::AlignCenter);
ui->est1144->setMaximumWidth( m12trail);
ui->est1144->setMinimumWidth( m6trail);
ui->est1144->setMaximumHeight( m7traild3 );
ui->est1144->setMaxLength(11);
ui->est1144->setFrame(globalFrame);

ui->est1145->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "114   ") );
connect( ui->est1145, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1145, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1145->installEventFilter(this);
ui->est1145->setAlignment(Qt::AlignCenter);
ui->est1145->setMaximumWidth( m12trail);
ui->est1145->setMinimumWidth( m6trail);
ui->est1145->setMaximumHeight( m7traild3 );
ui->est1145->setMaxLength(11);
ui->est1145->setFrame(globalFrame);

ui->est1146->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "114   ") );
ui->est1146->setReadOnly(true);
ui->est1146->setAlignment(Qt::AlignRight);
ui->est1146->setMaximumWidth( m14trail);
ui->est1146->setMinimumWidth( m9trail);
ui->est1146->setMaximumHeight( m7traild3 );
ui->est1146->setMaxLength(15);
ui->est1146->setFrame(globalFrame);

ui->est1147->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "114   ") );
ui->est1147->setReadOnly(true);
ui->est1147->setAlignment(Qt::AlignRight);
ui->est1147->setMaximumWidth( m14trail);
ui->est1147->setMinimumWidth( m9trail);
ui->est1147->setMaximumHeight( m7traild3 );
ui->est1147->setMaxLength(15);
ui->est1147->setFrame(globalFrame);

ui->lib1151->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "115   ") );
connect( ui->lib1151, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1151, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib115, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst115, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1151->installEventFilter(this);
ui->lib1151->setMaximumWidth( m6trail);
ui->lib1151->setMinimumWidth( m6trail);
ui->lib1151->setMaximumHeight( m7traild3 );
ui->lib1151->setMaxLength(3);
ui->lib1151->setFrame(globalFrame);

ui->lib1152->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "115   ") );
connect( ui->lib1152, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1152, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1152->installEventFilter(this);
ui->lib1152->setMaximumWidth( m26trail);
ui->lib1152->setMinimumWidth( m25trail);
ui->lib1152->setMaximumHeight( m7traild3 );
ui->lib1152->setMaxLength(24);
ui->lib1152->setFrame(globalFrame);

ui->lib1153->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "115   ") );
connect( ui->lib1153, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1153, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1153->installEventFilter(this);
ui->lib1153->setAlignment(Qt::AlignCenter);
ui->lib1153->setMaximumWidth( m12trail);
ui->lib1153->setMinimumWidth( m6trail);
ui->lib1153->setMaximumHeight( m7traild3 );
ui->lib1153->setMaxLength(11);
ui->lib1153->setFrame(globalFrame);

ui->lib1154->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "115   ") );
connect( ui->lib1154, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1154, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1154->installEventFilter(this);
ui->lib1154->setAlignment(Qt::AlignCenter);
ui->lib1154->setMaximumWidth( m12trail);
ui->lib1154->setMinimumWidth( m6trail);
ui->lib1154->setMaximumHeight( m7traild3 );
ui->lib1154->setMaxLength(11);
ui->lib1154->setFrame(globalFrame);

ui->pushButtonEst115->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "115   ") );
ui->pushButtonEst115->setMaximumWidth( m7traild3 );
ui->pushButtonEst115->setMaximumHeight( m7traild3 );
ui->pushButtonLib115->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "115   ") );
ui->pushButtonLib115->setMaximumWidth( m7traild3 );
ui->pushButtonLib115->setMaximumHeight( m7traild3 );

ui->est1151->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "115   ") );
connect( ui->est1151, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1151, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1151->installEventFilter(this);
ui->est1151->setMaximumWidth( m6trail);
ui->est1151->setMinimumWidth( m6trail);
ui->est1151->setMaximumHeight( m7traild3 );
ui->est1151->setMaxLength(3);
ui->est1151->setFrame(globalFrame);

ui->est1152->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "115   ") );
connect( ui->est1152, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1152, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1152->installEventFilter(this);
ui->est1152->setMaximumWidth( m26trail);
ui->est1152->setMinimumWidth( m25trail);
ui->est1152->setMaximumHeight( m7traild3 );
ui->est1152->setMaxLength(24);
ui->est1152->setFrame(globalFrame);

ui->est1153->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "115   ") );
connect( ui->est1153, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1153, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1153->installEventFilter(this);
ui->est1153->setAlignment(Qt::AlignCenter);
ui->est1153->setMaximumWidth( m11trail);
ui->est1153->setMinimumWidth( m6trail);
ui->est1153->setMaximumHeight( m7traild3 );
ui->est1153->setMaxLength(8);
ui->est1153->setFrame(globalFrame);

ui->est1154->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "115   ") );
connect( ui->est1154, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1154, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1154->installEventFilter(this);
ui->est1154->setAlignment(Qt::AlignCenter);
ui->est1154->setMaximumWidth( m12trail);
ui->est1154->setMinimumWidth( m6trail);
ui->est1154->setMaximumHeight( m7traild3 );
ui->est1154->setMaxLength(11);
ui->est1154->setFrame(globalFrame);

ui->est1155->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "115   ") );
connect( ui->est1155, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1155, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1155->installEventFilter(this);
ui->est1155->setAlignment(Qt::AlignCenter);
ui->est1155->setMaximumWidth( m12trail);
ui->est1155->setMinimumWidth( m6trail);
ui->est1155->setMaximumHeight( m7traild3 );
ui->est1155->setMaxLength(11);
ui->est1155->setFrame(globalFrame);

ui->est1156->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "115   ") );
ui->est1156->setReadOnly(true);
ui->est1156->setAlignment(Qt::AlignRight);
ui->est1156->setMaximumWidth( m14trail);
ui->est1156->setMinimumWidth( m9trail);
ui->est1156->setMaximumHeight( m7traild3 );
ui->est1156->setMaxLength(15);
ui->est1156->setFrame(globalFrame);

ui->est1157->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "115   ") );
ui->est1157->setReadOnly(true);
ui->est1157->setAlignment(Qt::AlignRight);
ui->est1157->setMaximumWidth( m14trail);
ui->est1157->setMinimumWidth( m9trail);
ui->est1157->setMaximumHeight( m7traild3 );
ui->est1157->setMaxLength(15);
ui->est1157->setFrame(globalFrame);

ui->lib1161->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "116   ") );
connect( ui->lib1161, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1161, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib116, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst116, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1161->installEventFilter(this);
ui->lib1161->setMaximumWidth( m6trail);
ui->lib1161->setMinimumWidth( m6trail);
ui->lib1161->setMaximumHeight( m7traild3 );
ui->lib1161->setMaxLength(3);
ui->lib1161->setFrame(globalFrame);

ui->lib1162->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "116   ") );
connect( ui->lib1162, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1162, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1162->installEventFilter(this);
ui->lib1162->setMaximumWidth( m26trail);
ui->lib1162->setMinimumWidth( m25trail);
ui->lib1162->setMaximumHeight( m7traild3 );
ui->lib1162->setMaxLength(24);
ui->lib1162->setFrame(globalFrame);

ui->lib1163->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "116   ") );
connect( ui->lib1163, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1163, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1163->installEventFilter(this);
ui->lib1163->setAlignment(Qt::AlignCenter);
ui->lib1163->setMaximumWidth( m12trail);
ui->lib1163->setMinimumWidth( m6trail);
ui->lib1163->setMaximumHeight( m7traild3 );
ui->lib1163->setMaxLength(11);
ui->lib1163->setFrame(globalFrame);

ui->lib1164->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "116   ") );
connect( ui->lib1164, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1164, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1164->installEventFilter(this);
ui->lib1164->setAlignment(Qt::AlignCenter);
ui->lib1164->setMaximumWidth( m12trail);
ui->lib1164->setMinimumWidth( m6trail);
ui->lib1164->setMaximumHeight( m7traild3 );
ui->lib1164->setMaxLength(11);
ui->lib1164->setFrame(globalFrame);

ui->pushButtonEst116->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "116   ") );
ui->pushButtonEst116->setMaximumWidth( m7traild3 );
ui->pushButtonEst116->setMaximumHeight( m7traild3 );
ui->pushButtonLib116->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "116   ") );
ui->pushButtonLib116->setMaximumWidth( m7traild3 );
ui->pushButtonLib116->setMaximumHeight( m7traild3 );

ui->est1161->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "116   ") );
connect( ui->est1161, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1161, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1161->installEventFilter(this);
ui->est1161->setMaximumWidth( m6trail);
ui->est1161->setMinimumWidth( m6trail);
ui->est1161->setMaximumHeight( m7traild3 );
ui->est1161->setMaxLength(3);
ui->est1161->setFrame(globalFrame);

ui->est1162->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "116   ") );
connect( ui->est1162, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1162, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1162->installEventFilter(this);
ui->est1162->setMaximumWidth( m26trail);
ui->est1162->setMinimumWidth( m25trail);
ui->est1162->setMaximumHeight( m7traild3 );
ui->est1162->setMaxLength(24);
ui->est1162->setFrame(globalFrame);

ui->est1163->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "116   ") );
connect( ui->est1163, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1163, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1163->installEventFilter(this);
ui->est1163->setAlignment(Qt::AlignCenter);
ui->est1163->setMaximumWidth( m11trail);
ui->est1163->setMinimumWidth( m6trail);
ui->est1163->setMaximumHeight( m7traild3 );
ui->est1163->setMaxLength(8);
ui->est1163->setFrame(globalFrame);

ui->est1164->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "116   ") );
connect( ui->est1164, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1164, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1164->installEventFilter(this);
ui->est1164->setAlignment(Qt::AlignCenter);
ui->est1164->setMaximumWidth( m12trail);
ui->est1164->setMinimumWidth( m6trail);
ui->est1164->setMaximumHeight( m7traild3 );
ui->est1164->setMaxLength(11);
ui->est1164->setFrame(globalFrame);

ui->est1165->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "116   ") );
connect( ui->est1165, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1165, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1165->installEventFilter(this);
ui->est1165->setAlignment(Qt::AlignCenter);
ui->est1165->setMaximumWidth( m12trail);
ui->est1165->setMinimumWidth( m6trail);
ui->est1165->setMaximumHeight( m7traild3 );
ui->est1165->setMaxLength(11);
ui->est1165->setFrame(globalFrame);

ui->est1166->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "116   ") );
ui->est1166->setReadOnly(true);
ui->est1166->setAlignment(Qt::AlignRight);
ui->est1166->setMaximumWidth( m14trail);
ui->est1166->setMinimumWidth( m9trail);
ui->est1166->setMaximumHeight( m7traild3 );
ui->est1166->setMaxLength(15);
ui->est1166->setFrame(globalFrame);

ui->est1167->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "116   ") );
ui->est1167->setReadOnly(true);
ui->est1167->setAlignment(Qt::AlignRight);
ui->est1167->setMaximumWidth( m14trail);
ui->est1167->setMinimumWidth( m9trail);
ui->est1167->setMaximumHeight( m7traild3 );
ui->est1167->setMaxLength(15);
ui->est1167->setFrame(globalFrame);

ui->lib1171->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "117   ") );
connect( ui->lib1171, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1171, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib117, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst117, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1171->installEventFilter(this);
ui->lib1171->setMaximumWidth( m6trail);
ui->lib1171->setMinimumWidth( m6trail);
ui->lib1171->setMaximumHeight( m7traild3 );
ui->lib1171->setMaxLength(3);
ui->lib1171->setFrame(globalFrame);

ui->lib1172->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "117   ") );
connect( ui->lib1172, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1172, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1172->installEventFilter(this);
ui->lib1172->setMaximumWidth( m26trail);
ui->lib1172->setMinimumWidth( m25trail);
ui->lib1172->setMaximumHeight( m7traild3 );
ui->lib1172->setMaxLength(24);
ui->lib1172->setFrame(globalFrame);

ui->lib1173->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "117   ") );
connect( ui->lib1173, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1173, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1173->installEventFilter(this);
ui->lib1173->setAlignment(Qt::AlignCenter);
ui->lib1173->setMaximumWidth( m12trail);
ui->lib1173->setMinimumWidth( m6trail);
ui->lib1173->setMaximumHeight( m7traild3 );
ui->lib1173->setMaxLength(11);
ui->lib1173->setFrame(globalFrame);

ui->lib1174->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "117   ") );
connect( ui->lib1174, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1174, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1174->installEventFilter(this);
ui->lib1174->setAlignment(Qt::AlignCenter);
ui->lib1174->setMaximumWidth( m12trail);
ui->lib1174->setMinimumWidth( m6trail);
ui->lib1174->setMaximumHeight( m7traild3 );
ui->lib1174->setMaxLength(11);
ui->lib1174->setFrame(globalFrame);

ui->pushButtonEst117->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "117   ") );
ui->pushButtonEst117->setMaximumWidth( m7traild3 );
ui->pushButtonEst117->setMaximumHeight( m7traild3 );
ui->pushButtonLib117->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "117   ") );
ui->pushButtonLib117->setMaximumWidth( m7traild3 );
ui->pushButtonLib117->setMaximumHeight( m7traild3 );

ui->est1171->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "117   ") );
connect( ui->est1171, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1171, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1171->installEventFilter(this);
ui->est1171->setMaximumWidth( m6trail);
ui->est1171->setMinimumWidth( m6trail);
ui->est1171->setMaximumHeight( m7traild3 );
ui->est1171->setMaxLength(3);
ui->est1171->setFrame(globalFrame);

ui->est1172->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "117   ") );
connect( ui->est1172, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1172, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1172->installEventFilter(this);
ui->est1172->setMaximumWidth( m26trail);
ui->est1172->setMinimumWidth( m25trail);
ui->est1172->setMaximumHeight( m7traild3 );
ui->est1172->setMaxLength(24);
ui->est1172->setFrame(globalFrame);

ui->est1173->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "117   ") );
connect( ui->est1173, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1173, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1173->installEventFilter(this);
ui->est1173->setAlignment(Qt::AlignCenter);
ui->est1173->setMaximumWidth( m11trail);
ui->est1173->setMinimumWidth( m6trail);
ui->est1173->setMaximumHeight( m7traild3 );
ui->est1173->setMaxLength(8);
ui->est1173->setFrame(globalFrame);

ui->est1174->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "117   ") );
connect( ui->est1174, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1174, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1174->installEventFilter(this);
ui->est1174->setAlignment(Qt::AlignCenter);
ui->est1174->setMaximumWidth( m12trail);
ui->est1174->setMinimumWidth( m6trail);
ui->est1174->setMaximumHeight( m7traild3 );
ui->est1174->setMaxLength(11);
ui->est1174->setFrame(globalFrame);

ui->est1175->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "117   ") );
connect( ui->est1175, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1175, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1175->installEventFilter(this);
ui->est1175->setAlignment(Qt::AlignCenter);
ui->est1175->setMaximumWidth( m12trail);
ui->est1175->setMinimumWidth( m6trail);
ui->est1175->setMaximumHeight( m7traild3 );
ui->est1175->setMaxLength(11);
ui->est1175->setFrame(globalFrame);

ui->est1176->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "117   ") );
ui->est1176->setReadOnly(true);
ui->est1176->setAlignment(Qt::AlignRight);
ui->est1176->setMaximumWidth( m14trail);
ui->est1176->setMinimumWidth( m9trail);
ui->est1176->setMaximumHeight( m7traild3 );
ui->est1176->setMaxLength(15);
ui->est1176->setFrame(globalFrame);

ui->est1177->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "117   ") );
ui->est1177->setReadOnly(true);
ui->est1177->setAlignment(Qt::AlignRight);
ui->est1177->setMaximumWidth( m14trail);
ui->est1177->setMinimumWidth( m9trail);
ui->est1177->setMaximumHeight( m7traild3 );
ui->est1177->setMaxLength(15);
ui->est1177->setFrame(globalFrame);

ui->lib1181->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "118   ") );
connect( ui->lib1181, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1181, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib118, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst118, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1181->installEventFilter(this);
ui->lib1181->setMaximumWidth( m6trail);
ui->lib1181->setMinimumWidth( m6trail);
ui->lib1181->setMaximumHeight( m7traild3 );
ui->lib1181->setMaxLength(3);
ui->lib1181->setFrame(globalFrame);

ui->lib1182->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "118   ") );
connect( ui->lib1182, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1182, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1182->installEventFilter(this);
ui->lib1182->setMaximumWidth( m26trail);
ui->lib1182->setMinimumWidth( m25trail);
ui->lib1182->setMaximumHeight( m7traild3 );
ui->lib1182->setMaxLength(24);
ui->lib1182->setFrame(globalFrame);

ui->lib1183->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "118   ") );
connect( ui->lib1183, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1183, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1183->installEventFilter(this);
ui->lib1183->setAlignment(Qt::AlignCenter);
ui->lib1183->setMaximumWidth( m12trail);
ui->lib1183->setMinimumWidth( m6trail);
ui->lib1183->setMaximumHeight( m7traild3 );
ui->lib1183->setMaxLength(11);
ui->lib1183->setFrame(globalFrame);

ui->lib1184->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "118   ") );
connect( ui->lib1184, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1184, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1184->installEventFilter(this);
ui->lib1184->setAlignment(Qt::AlignCenter);
ui->lib1184->setMaximumWidth( m12trail);
ui->lib1184->setMinimumWidth( m6trail);
ui->lib1184->setMaximumHeight( m7traild3 );
ui->lib1184->setMaxLength(11);
ui->lib1184->setFrame(globalFrame);

ui->pushButtonEst118->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "118   ") );
ui->pushButtonEst118->setMaximumWidth( m7traild3 );
ui->pushButtonEst118->setMaximumHeight( m7traild3 );
ui->pushButtonLib118->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "118   ") );
ui->pushButtonLib118->setMaximumWidth( m7traild3 );
ui->pushButtonLib118->setMaximumHeight( m7traild3 );

ui->est1181->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "118   ") );
connect( ui->est1181, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1181, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1181->installEventFilter(this);
ui->est1181->setMaximumWidth( m6trail);
ui->est1181->setMinimumWidth( m6trail);
ui->est1181->setMaximumHeight( m7traild3 );
ui->est1181->setMaxLength(3);
ui->est1181->setFrame(globalFrame);

ui->est1182->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "118   ") );
connect( ui->est1182, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1182, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1182->installEventFilter(this);
ui->est1182->setMaximumWidth( m26trail);
ui->est1182->setMinimumWidth( m25trail);
ui->est1182->setMaximumHeight( m7traild3 );
ui->est1182->setMaxLength(24);
ui->est1182->setFrame(globalFrame);

ui->est1183->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "118   ") );
connect( ui->est1183, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1183, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1183->installEventFilter(this);
ui->est1183->setAlignment(Qt::AlignCenter);
ui->est1183->setMaximumWidth( m11trail);
ui->est1183->setMinimumWidth( m6trail);
ui->est1183->setMaximumHeight( m7traild3 );
ui->est1183->setMaxLength(8);
ui->est1183->setFrame(globalFrame);

ui->est1184->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "118   ") );
connect( ui->est1184, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1184, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1184->installEventFilter(this);
ui->est1184->setAlignment(Qt::AlignCenter);
ui->est1184->setMaximumWidth( m12trail);
ui->est1184->setMinimumWidth( m6trail);
ui->est1184->setMaximumHeight( m7traild3 );
ui->est1184->setMaxLength(11);
ui->est1184->setFrame(globalFrame);

ui->est1185->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "118   ") );
connect( ui->est1185, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1185, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1185->installEventFilter(this);
ui->est1185->setAlignment(Qt::AlignCenter);
ui->est1185->setMaximumWidth( m12trail);
ui->est1185->setMinimumWidth( m6trail);
ui->est1185->setMaximumHeight( m7traild3 );
ui->est1185->setMaxLength(11);
ui->est1185->setFrame(globalFrame);

ui->est1186->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "118   ") );
ui->est1186->setReadOnly(true);
ui->est1186->setAlignment(Qt::AlignRight);
ui->est1186->setMaximumWidth( m14trail);
ui->est1186->setMinimumWidth( m9trail);
ui->est1186->setMaximumHeight( m7traild3 );
ui->est1186->setMaxLength(15);
ui->est1186->setFrame(globalFrame);

ui->est1187->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "118   ") );
ui->est1187->setReadOnly(true);
ui->est1187->setAlignment(Qt::AlignRight);
ui->est1187->setMaximumWidth( m14trail);
ui->est1187->setMinimumWidth( m9trail);
ui->est1187->setMaximumHeight( m7traild3 );
ui->est1187->setMaxLength(15);
ui->est1187->setFrame(globalFrame);

ui->lib1191->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "119   ") );
connect( ui->lib1191, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1191, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib119, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst119, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1191->installEventFilter(this);
ui->lib1191->setMaximumWidth( m6trail);
ui->lib1191->setMinimumWidth( m6trail);
ui->lib1191->setMaximumHeight( m7traild3 );
ui->lib1191->setMaxLength(3);
ui->lib1191->setFrame(globalFrame);

ui->lib1192->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "119   ") );
connect( ui->lib1192, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1192, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1192->installEventFilter(this);
ui->lib1192->setMaximumWidth( m26trail);
ui->lib1192->setMinimumWidth( m25trail);
ui->lib1192->setMaximumHeight( m7traild3 );
ui->lib1192->setMaxLength(24);
ui->lib1192->setFrame(globalFrame);

ui->lib1193->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "119   ") );
connect( ui->lib1193, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1193, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1193->installEventFilter(this);
ui->lib1193->setAlignment(Qt::AlignCenter);
ui->lib1193->setMaximumWidth( m12trail);
ui->lib1193->setMinimumWidth( m6trail);
ui->lib1193->setMaximumHeight( m7traild3 );
ui->lib1193->setMaxLength(11);
ui->lib1193->setFrame(globalFrame);

ui->lib1194->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "119   ") );
connect( ui->lib1194, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1194, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1194->installEventFilter(this);
ui->lib1194->setAlignment(Qt::AlignCenter);
ui->lib1194->setMaximumWidth( m12trail);
ui->lib1194->setMinimumWidth( m6trail);
ui->lib1194->setMaximumHeight( m7traild3 );
ui->lib1194->setMaxLength(11);
ui->lib1194->setFrame(globalFrame);

ui->pushButtonEst119->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "119   ") );
ui->pushButtonEst119->setMaximumWidth( m7traild3 );
ui->pushButtonEst119->setMaximumHeight( m7traild3 );
ui->pushButtonLib119->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "119   ") );
ui->pushButtonLib119->setMaximumWidth( m7traild3 );
ui->pushButtonLib119->setMaximumHeight( m7traild3 );

ui->est1191->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "119   ") );
connect( ui->est1191, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1191, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1191->installEventFilter(this);
ui->est1191->setMaximumWidth( m6trail);
ui->est1191->setMinimumWidth( m6trail);
ui->est1191->setMaximumHeight( m7traild3 );
ui->est1191->setMaxLength(3);
ui->est1191->setFrame(globalFrame);

ui->est1192->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "119   ") );
connect( ui->est1192, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1192, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1192->installEventFilter(this);
ui->est1192->setMaximumWidth( m26trail);
ui->est1192->setMinimumWidth( m25trail);
ui->est1192->setMaximumHeight( m7traild3 );
ui->est1192->setMaxLength(24);
ui->est1192->setFrame(globalFrame);

ui->est1193->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "119   ") );
connect( ui->est1193, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1193, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1193->installEventFilter(this);
ui->est1193->setAlignment(Qt::AlignCenter);
ui->est1193->setMaximumWidth( m11trail);
ui->est1193->setMinimumWidth( m6trail);
ui->est1193->setMaximumHeight( m7traild3 );
ui->est1193->setMaxLength(8);
ui->est1193->setFrame(globalFrame);

ui->est1194->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "119   ") );
connect( ui->est1194, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1194, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1194->installEventFilter(this);
ui->est1194->setAlignment(Qt::AlignCenter);
ui->est1194->setMaximumWidth( m12trail);
ui->est1194->setMinimumWidth( m6trail);
ui->est1194->setMaximumHeight( m7traild3 );
ui->est1194->setMaxLength(11);
ui->est1194->setFrame(globalFrame);

ui->est1195->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "119   ") );
connect( ui->est1195, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1195, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1195->installEventFilter(this);
ui->est1195->setAlignment(Qt::AlignCenter);
ui->est1195->setMaximumWidth( m12trail);
ui->est1195->setMinimumWidth( m6trail);
ui->est1195->setMaximumHeight( m7traild3 );
ui->est1195->setMaxLength(11);
ui->est1195->setFrame(globalFrame);

ui->est1196->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "119   ") );
ui->est1196->setReadOnly(true);
ui->est1196->setAlignment(Qt::AlignRight);
ui->est1196->setMaximumWidth( m14trail);
ui->est1196->setMinimumWidth( m9trail);
ui->est1196->setMaximumHeight( m7traild3 );
ui->est1196->setMaxLength(15);
ui->est1196->setFrame(globalFrame);

ui->est1197->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "119   ") );
ui->est1197->setReadOnly(true);
ui->est1197->setAlignment(Qt::AlignRight);
ui->est1197->setMaximumWidth( m14trail);
ui->est1197->setMinimumWidth( m9trail);
ui->est1197->setMaximumHeight( m7traild3 );
ui->est1197->setMaxLength(15);
ui->est1197->setFrame(globalFrame);

ui->lib1201->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "120   ") );
connect( ui->lib1201, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1201, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib120, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst120, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1201->installEventFilter(this);
ui->lib1201->setMaximumWidth( m6trail);
ui->lib1201->setMinimumWidth( m6trail);
ui->lib1201->setMaximumHeight( m7traild3 );
ui->lib1201->setMaxLength(3);
ui->lib1201->setFrame(globalFrame);

ui->lib1202->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "120   ") );
connect( ui->lib1202, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1202, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1202->installEventFilter(this);
ui->lib1202->setMaximumWidth( m26trail);
ui->lib1202->setMinimumWidth( m25trail);
ui->lib1202->setMaximumHeight( m7traild3 );
ui->lib1202->setMaxLength(24);
ui->lib1202->setFrame(globalFrame);

ui->lib1203->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "120   ") );
connect( ui->lib1203, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1203, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1203->installEventFilter(this);
ui->lib1203->setAlignment(Qt::AlignCenter);
ui->lib1203->setMaximumWidth( m12trail);
ui->lib1203->setMinimumWidth( m6trail);
ui->lib1203->setMaximumHeight( m7traild3 );
ui->lib1203->setMaxLength(11);
ui->lib1203->setFrame(globalFrame);

ui->lib1204->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "120   ") );
connect( ui->lib1204, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1204, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1204->installEventFilter(this);
ui->lib1204->setAlignment(Qt::AlignCenter);
ui->lib1204->setMaximumWidth( m12trail);
ui->lib1204->setMinimumWidth( m6trail);
ui->lib1204->setMaximumHeight( m7traild3 );
ui->lib1204->setMaxLength(11);
ui->lib1204->setFrame(globalFrame);

ui->pushButtonEst120->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "120   ") );
ui->pushButtonEst120->setMaximumWidth( m7traild3 );
ui->pushButtonEst120->setMaximumHeight( m7traild3 );
ui->pushButtonLib120->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "120   ") );
ui->pushButtonLib120->setMaximumWidth( m7traild3 );
ui->pushButtonLib120->setMaximumHeight( m7traild3 );

ui->est1201->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "120   ") );
connect( ui->est1201, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1201, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1201->installEventFilter(this);
ui->est1201->setMaximumWidth( m6trail);
ui->est1201->setMinimumWidth( m6trail);
ui->est1201->setMaximumHeight( m7traild3 );
ui->est1201->setMaxLength(3);
ui->est1201->setFrame(globalFrame);

ui->est1202->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "120   ") );
connect( ui->est1202, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1202, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1202->installEventFilter(this);
ui->est1202->setMaximumWidth( m26trail);
ui->est1202->setMinimumWidth( m25trail);
ui->est1202->setMaximumHeight( m7traild3 );
ui->est1202->setMaxLength(24);
ui->est1202->setFrame(globalFrame);

ui->est1203->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "120   ") );
connect( ui->est1203, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1203, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1203->installEventFilter(this);
ui->est1203->setAlignment(Qt::AlignCenter);
ui->est1203->setMaximumWidth( m11trail);
ui->est1203->setMinimumWidth( m6trail);
ui->est1203->setMaximumHeight( m7traild3 );
ui->est1203->setMaxLength(8);
ui->est1203->setFrame(globalFrame);

ui->est1204->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "120   ") );
connect( ui->est1204, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1204, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1204->installEventFilter(this);
ui->est1204->setAlignment(Qt::AlignCenter);
ui->est1204->setMaximumWidth( m12trail);
ui->est1204->setMinimumWidth( m6trail);
ui->est1204->setMaximumHeight( m7traild3 );
ui->est1204->setMaxLength(11);
ui->est1204->setFrame(globalFrame);

ui->est1205->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "120   ") );
connect( ui->est1205, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1205, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1205->installEventFilter(this);
ui->est1205->setAlignment(Qt::AlignCenter);
ui->est1205->setMaximumWidth( m12trail);
ui->est1205->setMinimumWidth( m6trail);
ui->est1205->setMaximumHeight( m7traild3 );
ui->est1205->setMaxLength(11);
ui->est1205->setFrame(globalFrame);

ui->est1206->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "120   ") );
ui->est1206->setReadOnly(true);
ui->est1206->setAlignment(Qt::AlignRight);
ui->est1206->setMaximumWidth( m14trail);
ui->est1206->setMinimumWidth( m9trail);
ui->est1206->setMaximumHeight( m7traild3 );
ui->est1206->setMaxLength(15);
ui->est1206->setFrame(globalFrame);

ui->est1207->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "120   ") );
ui->est1207->setReadOnly(true);
ui->est1207->setAlignment(Qt::AlignRight);
ui->est1207->setMaximumWidth( m14trail);
ui->est1207->setMinimumWidth( m9trail);
ui->est1207->setMaximumHeight( m7traild3 );
ui->est1207->setMaxLength(15);
ui->est1207->setFrame(globalFrame);

ui->lib1211->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "121   ") );
connect( ui->lib1211, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1211, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib121, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst121, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1211->installEventFilter(this);
ui->lib1211->setMaximumWidth( m6trail);
ui->lib1211->setMinimumWidth( m6trail);
ui->lib1211->setMaximumHeight( m7traild3 );
ui->lib1211->setMaxLength(3);
ui->lib1211->setFrame(globalFrame);

ui->lib1212->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "121   ") );
connect( ui->lib1212, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1212, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1212->installEventFilter(this);
ui->lib1212->setMaximumWidth( m26trail);
ui->lib1212->setMinimumWidth( m25trail);
ui->lib1212->setMaximumHeight( m7traild3 );
ui->lib1212->setMaxLength(24);
ui->lib1212->setFrame(globalFrame);

ui->lib1213->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "121   ") );
connect( ui->lib1213, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1213, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1213->installEventFilter(this);
ui->lib1213->setAlignment(Qt::AlignCenter);
ui->lib1213->setMaximumWidth( m12trail);
ui->lib1213->setMinimumWidth( m6trail);
ui->lib1213->setMaximumHeight( m7traild3 );
ui->lib1213->setMaxLength(11);
ui->lib1213->setFrame(globalFrame);

ui->lib1214->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "121   ") );
connect( ui->lib1214, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1214, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1214->installEventFilter(this);
ui->lib1214->setAlignment(Qt::AlignCenter);
ui->lib1214->setMaximumWidth( m12trail);
ui->lib1214->setMinimumWidth( m6trail);
ui->lib1214->setMaximumHeight( m7traild3 );
ui->lib1214->setMaxLength(11);
ui->lib1214->setFrame(globalFrame);

ui->pushButtonEst121->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "121   ") );
ui->pushButtonEst121->setMaximumWidth( m7traild3 );
ui->pushButtonEst121->setMaximumHeight( m7traild3 );
ui->pushButtonLib121->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "121   ") );
ui->pushButtonLib121->setMaximumWidth( m7traild3 );
ui->pushButtonLib121->setMaximumHeight( m7traild3 );

ui->est1211->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "121   ") );
connect( ui->est1211, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1211, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1211->installEventFilter(this);
ui->est1211->setMaximumWidth( m6trail);
ui->est1211->setMinimumWidth( m6trail);
ui->est1211->setMaximumHeight( m7traild3 );
ui->est1211->setMaxLength(3);
ui->est1211->setFrame(globalFrame);

ui->est1212->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "121   ") );
connect( ui->est1212, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1212, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1212->installEventFilter(this);
ui->est1212->setMaximumWidth( m26trail);
ui->est1212->setMinimumWidth( m25trail);
ui->est1212->setMaximumHeight( m7traild3 );
ui->est1212->setMaxLength(24);
ui->est1212->setFrame(globalFrame);

ui->est1213->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "121   ") );
connect( ui->est1213, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1213, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1213->installEventFilter(this);
ui->est1213->setAlignment(Qt::AlignCenter);
ui->est1213->setMaximumWidth( m11trail);
ui->est1213->setMinimumWidth( m6trail);
ui->est1213->setMaximumHeight( m7traild3 );
ui->est1213->setMaxLength(8);
ui->est1213->setFrame(globalFrame);

ui->est1214->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "121   ") );
connect( ui->est1214, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1214, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1214->installEventFilter(this);
ui->est1214->setAlignment(Qt::AlignCenter);
ui->est1214->setMaximumWidth( m12trail);
ui->est1214->setMinimumWidth( m6trail);
ui->est1214->setMaximumHeight( m7traild3 );
ui->est1214->setMaxLength(11);
ui->est1214->setFrame(globalFrame);

ui->est1215->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "121   ") );
connect( ui->est1215, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1215, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1215->installEventFilter(this);
ui->est1215->setAlignment(Qt::AlignCenter);
ui->est1215->setMaximumWidth( m12trail);
ui->est1215->setMinimumWidth( m6trail);
ui->est1215->setMaximumHeight( m7traild3 );
ui->est1215->setMaxLength(11);
ui->est1215->setFrame(globalFrame);

ui->est1216->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "121   ") );
ui->est1216->setReadOnly(true);
ui->est1216->setAlignment(Qt::AlignRight);
ui->est1216->setMaximumWidth( m14trail);
ui->est1216->setMinimumWidth( m9trail);
ui->est1216->setMaximumHeight( m7traild3 );
ui->est1216->setMaxLength(15);
ui->est1216->setFrame(globalFrame);

ui->est1217->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "121   ") );
ui->est1217->setReadOnly(true);
ui->est1217->setAlignment(Qt::AlignRight);
ui->est1217->setMaximumWidth( m14trail);
ui->est1217->setMinimumWidth( m9trail);
ui->est1217->setMaximumHeight( m7traild3 );
ui->est1217->setMaxLength(15);
ui->est1217->setFrame(globalFrame);

ui->lib1221->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "122   ") );
connect( ui->lib1221, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1221, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib122, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst122, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1221->installEventFilter(this);
ui->lib1221->setMaximumWidth( m6trail);
ui->lib1221->setMinimumWidth( m6trail);
ui->lib1221->setMaximumHeight( m7traild3 );
ui->lib1221->setMaxLength(3);
ui->lib1221->setFrame(globalFrame);

ui->lib1222->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "122   ") );
connect( ui->lib1222, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1222, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1222->installEventFilter(this);
ui->lib1222->setMaximumWidth( m26trail);
ui->lib1222->setMinimumWidth( m25trail);
ui->lib1222->setMaximumHeight( m7traild3 );
ui->lib1222->setMaxLength(24);
ui->lib1222->setFrame(globalFrame);

ui->lib1223->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "122   ") );
connect( ui->lib1223, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1223, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1223->installEventFilter(this);
ui->lib1223->setAlignment(Qt::AlignCenter);
ui->lib1223->setMaximumWidth( m12trail);
ui->lib1223->setMinimumWidth( m6trail);
ui->lib1223->setMaximumHeight( m7traild3 );
ui->lib1223->setMaxLength(11);
ui->lib1223->setFrame(globalFrame);

ui->lib1224->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "122   ") );
connect( ui->lib1224, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1224, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1224->installEventFilter(this);
ui->lib1224->setAlignment(Qt::AlignCenter);
ui->lib1224->setMaximumWidth( m12trail);
ui->lib1224->setMinimumWidth( m6trail);
ui->lib1224->setMaximumHeight( m7traild3 );
ui->lib1224->setMaxLength(11);
ui->lib1224->setFrame(globalFrame);

ui->pushButtonEst122->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "122   ") );
ui->pushButtonEst122->setMaximumWidth( m7traild3 );
ui->pushButtonEst122->setMaximumHeight( m7traild3 );
ui->pushButtonLib122->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "122   ") );
ui->pushButtonLib122->setMaximumWidth( m7traild3 );
ui->pushButtonLib122->setMaximumHeight( m7traild3 );

ui->est1221->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "122   ") );
connect( ui->est1221, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1221, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1221->installEventFilter(this);
ui->est1221->setMaximumWidth( m6trail);
ui->est1221->setMinimumWidth( m6trail);
ui->est1221->setMaximumHeight( m7traild3 );
ui->est1221->setMaxLength(3);
ui->est1221->setFrame(globalFrame);

ui->est1222->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "122   ") );
connect( ui->est1222, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1222, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1222->installEventFilter(this);
ui->est1222->setMaximumWidth( m26trail);
ui->est1222->setMinimumWidth( m25trail);
ui->est1222->setMaximumHeight( m7traild3 );
ui->est1222->setMaxLength(24);
ui->est1222->setFrame(globalFrame);

ui->est1223->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "122   ") );
connect( ui->est1223, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1223, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1223->installEventFilter(this);
ui->est1223->setAlignment(Qt::AlignCenter);
ui->est1223->setMaximumWidth( m11trail);
ui->est1223->setMinimumWidth( m6trail);
ui->est1223->setMaximumHeight( m7traild3 );
ui->est1223->setMaxLength(8);
ui->est1223->setFrame(globalFrame);

ui->est1224->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "122   ") );
connect( ui->est1224, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1224, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1224->installEventFilter(this);
ui->est1224->setAlignment(Qt::AlignCenter);
ui->est1224->setMaximumWidth( m12trail);
ui->est1224->setMinimumWidth( m6trail);
ui->est1224->setMaximumHeight( m7traild3 );
ui->est1224->setMaxLength(11);
ui->est1224->setFrame(globalFrame);

ui->est1225->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "122   ") );
connect( ui->est1225, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1225, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1225->installEventFilter(this);
ui->est1225->setAlignment(Qt::AlignCenter);
ui->est1225->setMaximumWidth( m12trail);
ui->est1225->setMinimumWidth( m6trail);
ui->est1225->setMaximumHeight( m7traild3 );
ui->est1225->setMaxLength(11);
ui->est1225->setFrame(globalFrame);

ui->est1226->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "122   ") );
ui->est1226->setReadOnly(true);
ui->est1226->setAlignment(Qt::AlignRight);
ui->est1226->setMaximumWidth( m14trail);
ui->est1226->setMinimumWidth( m9trail);
ui->est1226->setMaximumHeight( m7traild3 );
ui->est1226->setMaxLength(15);
ui->est1226->setFrame(globalFrame);

ui->est1227->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "122   ") );
ui->est1227->setReadOnly(true);
ui->est1227->setAlignment(Qt::AlignRight);
ui->est1227->setMaximumWidth( m14trail);
ui->est1227->setMinimumWidth( m9trail);
ui->est1227->setMaximumHeight( m7traild3 );
ui->est1227->setMaxLength(15);
ui->est1227->setFrame(globalFrame);

ui->lib1231->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "123   ") );
connect( ui->lib1231, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1231, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib123, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst123, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1231->installEventFilter(this);
ui->lib1231->setMaximumWidth( m6trail);
ui->lib1231->setMinimumWidth( m6trail);
ui->lib1231->setMaximumHeight( m7traild3 );
ui->lib1231->setMaxLength(3);
ui->lib1231->setFrame(globalFrame);

ui->lib1232->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "123   ") );
connect( ui->lib1232, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1232, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1232->installEventFilter(this);
ui->lib1232->setMaximumWidth( m26trail);
ui->lib1232->setMinimumWidth( m25trail);
ui->lib1232->setMaximumHeight( m7traild3 );
ui->lib1232->setMaxLength(24);
ui->lib1232->setFrame(globalFrame);

ui->lib1233->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "123   ") );
connect( ui->lib1233, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1233, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1233->installEventFilter(this);
ui->lib1233->setAlignment(Qt::AlignCenter);
ui->lib1233->setMaximumWidth( m12trail);
ui->lib1233->setMinimumWidth( m6trail);
ui->lib1233->setMaximumHeight( m7traild3 );
ui->lib1233->setMaxLength(11);
ui->lib1233->setFrame(globalFrame);

ui->lib1234->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "123   ") );
connect( ui->lib1234, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1234, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1234->installEventFilter(this);
ui->lib1234->setAlignment(Qt::AlignCenter);
ui->lib1234->setMaximumWidth( m12trail);
ui->lib1234->setMinimumWidth( m6trail);
ui->lib1234->setMaximumHeight( m7traild3 );
ui->lib1234->setMaxLength(11);
ui->lib1234->setFrame(globalFrame);

ui->pushButtonEst123->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "123   ") );
ui->pushButtonEst123->setMaximumWidth( m7traild3 );
ui->pushButtonEst123->setMaximumHeight( m7traild3 );
ui->pushButtonLib123->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "123   ") );
ui->pushButtonLib123->setMaximumWidth( m7traild3 );
ui->pushButtonLib123->setMaximumHeight( m7traild3 );

ui->est1231->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "123   ") );
connect( ui->est1231, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1231, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1231->installEventFilter(this);
ui->est1231->setMaximumWidth( m6trail);
ui->est1231->setMinimumWidth( m6trail);
ui->est1231->setMaximumHeight( m7traild3 );
ui->est1231->setMaxLength(3);
ui->est1231->setFrame(globalFrame);

ui->est1232->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "123   ") );
connect( ui->est1232, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1232, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1232->installEventFilter(this);
ui->est1232->setMaximumWidth( m26trail);
ui->est1232->setMinimumWidth( m25trail);
ui->est1232->setMaximumHeight( m7traild3 );
ui->est1232->setMaxLength(24);
ui->est1232->setFrame(globalFrame);

ui->est1233->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "123   ") );
connect( ui->est1233, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1233, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1233->installEventFilter(this);
ui->est1233->setAlignment(Qt::AlignCenter);
ui->est1233->setMaximumWidth( m11trail);
ui->est1233->setMinimumWidth( m6trail);
ui->est1233->setMaximumHeight( m7traild3 );
ui->est1233->setMaxLength(8);
ui->est1233->setFrame(globalFrame);

ui->est1234->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "123   ") );
connect( ui->est1234, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1234, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1234->installEventFilter(this);
ui->est1234->setAlignment(Qt::AlignCenter);
ui->est1234->setMaximumWidth( m12trail);
ui->est1234->setMinimumWidth( m6trail);
ui->est1234->setMaximumHeight( m7traild3 );
ui->est1234->setMaxLength(11);
ui->est1234->setFrame(globalFrame);

ui->est1235->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "123   ") );
connect( ui->est1235, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1235, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1235->installEventFilter(this);
ui->est1235->setAlignment(Qt::AlignCenter);
ui->est1235->setMaximumWidth( m12trail);
ui->est1235->setMinimumWidth( m6trail);
ui->est1235->setMaximumHeight( m7traild3 );
ui->est1235->setMaxLength(11);
ui->est1235->setFrame(globalFrame);

ui->est1236->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "123   ") );
ui->est1236->setReadOnly(true);
ui->est1236->setAlignment(Qt::AlignRight);
ui->est1236->setMaximumWidth( m14trail);
ui->est1236->setMinimumWidth( m9trail);
ui->est1236->setMaximumHeight( m7traild3 );
ui->est1236->setMaxLength(15);
ui->est1236->setFrame(globalFrame);

ui->est1237->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "123   ") );
ui->est1237->setReadOnly(true);
ui->est1237->setAlignment(Qt::AlignRight);
ui->est1237->setMaximumWidth( m14trail);
ui->est1237->setMinimumWidth( m9trail);
ui->est1237->setMaximumHeight( m7traild3 );
ui->est1237->setMaxLength(15);
ui->est1237->setFrame(globalFrame);

ui->lib1241->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "124   ") );
connect( ui->lib1241, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1241, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib124, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst124, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1241->installEventFilter(this);
ui->lib1241->setMaximumWidth( m6trail);
ui->lib1241->setMinimumWidth( m6trail);
ui->lib1241->setMaximumHeight( m7traild3 );
ui->lib1241->setMaxLength(3);
ui->lib1241->setFrame(globalFrame);

ui->lib1242->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "124   ") );
connect( ui->lib1242, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1242, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1242->installEventFilter(this);
ui->lib1242->setMaximumWidth( m26trail);
ui->lib1242->setMinimumWidth( m25trail);
ui->lib1242->setMaximumHeight( m7traild3 );
ui->lib1242->setMaxLength(24);
ui->lib1242->setFrame(globalFrame);

ui->lib1243->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "124   ") );
connect( ui->lib1243, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1243, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1243->installEventFilter(this);
ui->lib1243->setAlignment(Qt::AlignCenter);
ui->lib1243->setMaximumWidth( m12trail);
ui->lib1243->setMinimumWidth( m6trail);
ui->lib1243->setMaximumHeight( m7traild3 );
ui->lib1243->setMaxLength(11);
ui->lib1243->setFrame(globalFrame);

ui->lib1244->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "124   ") );
connect( ui->lib1244, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1244, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1244->installEventFilter(this);
ui->lib1244->setAlignment(Qt::AlignCenter);
ui->lib1244->setMaximumWidth( m12trail);
ui->lib1244->setMinimumWidth( m6trail);
ui->lib1244->setMaximumHeight( m7traild3 );
ui->lib1244->setMaxLength(11);
ui->lib1244->setFrame(globalFrame);

ui->pushButtonEst124->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "124   ") );
ui->pushButtonEst124->setMaximumWidth( m7traild3 );
ui->pushButtonEst124->setMaximumHeight( m7traild3 );
ui->pushButtonLib124->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "124   ") );
ui->pushButtonLib124->setMaximumWidth( m7traild3 );
ui->pushButtonLib124->setMaximumHeight( m7traild3 );

ui->est1241->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "124   ") );
connect( ui->est1241, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1241, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1241->installEventFilter(this);
ui->est1241->setMaximumWidth( m6trail);
ui->est1241->setMinimumWidth( m6trail);
ui->est1241->setMaximumHeight( m7traild3 );
ui->est1241->setMaxLength(3);
ui->est1241->setFrame(globalFrame);

ui->est1242->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "124   ") );
connect( ui->est1242, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1242, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1242->installEventFilter(this);
ui->est1242->setMaximumWidth( m26trail);
ui->est1242->setMinimumWidth( m25trail);
ui->est1242->setMaximumHeight( m7traild3 );
ui->est1242->setMaxLength(24);
ui->est1242->setFrame(globalFrame);

ui->est1243->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "124   ") );
connect( ui->est1243, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1243, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1243->installEventFilter(this);
ui->est1243->setAlignment(Qt::AlignCenter);
ui->est1243->setMaximumWidth( m11trail);
ui->est1243->setMinimumWidth( m6trail);
ui->est1243->setMaximumHeight( m7traild3 );
ui->est1243->setMaxLength(8);
ui->est1243->setFrame(globalFrame);

ui->est1244->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "124   ") );
connect( ui->est1244, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1244, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1244->installEventFilter(this);
ui->est1244->setAlignment(Qt::AlignCenter);
ui->est1244->setMaximumWidth( m12trail);
ui->est1244->setMinimumWidth( m6trail);
ui->est1244->setMaximumHeight( m7traild3 );
ui->est1244->setMaxLength(11);
ui->est1244->setFrame(globalFrame);

ui->est1245->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "124   ") );
connect( ui->est1245, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1245, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1245->installEventFilter(this);
ui->est1245->setAlignment(Qt::AlignCenter);
ui->est1245->setMaximumWidth( m12trail);
ui->est1245->setMinimumWidth( m6trail);
ui->est1245->setMaximumHeight( m7traild3 );
ui->est1245->setMaxLength(11);
ui->est1245->setFrame(globalFrame);

ui->est1246->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "124   ") );
ui->est1246->setReadOnly(true);
ui->est1246->setAlignment(Qt::AlignRight);
ui->est1246->setMaximumWidth( m14trail);
ui->est1246->setMinimumWidth( m9trail);
ui->est1246->setMaximumHeight( m7traild3 );
ui->est1246->setMaxLength(15);
ui->est1246->setFrame(globalFrame);

ui->est1247->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "124   ") );
ui->est1247->setReadOnly(true);
ui->est1247->setAlignment(Qt::AlignRight);
ui->est1247->setMaximumWidth( m14trail);
ui->est1247->setMinimumWidth( m9trail);
ui->est1247->setMaximumHeight( m7traild3 );
ui->est1247->setMaxLength(15);
ui->est1247->setFrame(globalFrame);

ui->lib1251->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "125   ") );
connect( ui->lib1251, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1251, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib125, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst125, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1251->installEventFilter(this);
ui->lib1251->setMaximumWidth( m6trail);
ui->lib1251->setMinimumWidth( m6trail);
ui->lib1251->setMaximumHeight( m7traild3 );
ui->lib1251->setMaxLength(3);
ui->lib1251->setFrame(globalFrame);

ui->lib1252->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "125   ") );
connect( ui->lib1252, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1252, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1252->installEventFilter(this);
ui->lib1252->setMaximumWidth( m26trail);
ui->lib1252->setMinimumWidth( m25trail);
ui->lib1252->setMaximumHeight( m7traild3 );
ui->lib1252->setMaxLength(24);
ui->lib1252->setFrame(globalFrame);

ui->lib1253->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "125   ") );
connect( ui->lib1253, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1253, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1253->installEventFilter(this);
ui->lib1253->setAlignment(Qt::AlignCenter);
ui->lib1253->setMaximumWidth( m12trail);
ui->lib1253->setMinimumWidth( m6trail);
ui->lib1253->setMaximumHeight( m7traild3 );
ui->lib1253->setMaxLength(11);
ui->lib1253->setFrame(globalFrame);

ui->lib1254->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "125   ") );
connect( ui->lib1254, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1254, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1254->installEventFilter(this);
ui->lib1254->setAlignment(Qt::AlignCenter);
ui->lib1254->setMaximumWidth( m12trail);
ui->lib1254->setMinimumWidth( m6trail);
ui->lib1254->setMaximumHeight( m7traild3 );
ui->lib1254->setMaxLength(11);
ui->lib1254->setFrame(globalFrame);

ui->pushButtonEst125->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "125   ") );
ui->pushButtonEst125->setMaximumWidth( m7traild3 );
ui->pushButtonEst125->setMaximumHeight( m7traild3 );
ui->pushButtonLib125->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "125   ") );
ui->pushButtonLib125->setMaximumWidth( m7traild3 );
ui->pushButtonLib125->setMaximumHeight( m7traild3 );

ui->est1251->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "125   ") );
connect( ui->est1251, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1251, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1251->installEventFilter(this);
ui->est1251->setMaximumWidth( m6trail);
ui->est1251->setMinimumWidth( m6trail);
ui->est1251->setMaximumHeight( m7traild3 );
ui->est1251->setMaxLength(3);
ui->est1251->setFrame(globalFrame);

ui->est1252->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "125   ") );
connect( ui->est1252, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1252, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1252->installEventFilter(this);
ui->est1252->setMaximumWidth( m26trail);
ui->est1252->setMinimumWidth( m25trail);
ui->est1252->setMaximumHeight( m7traild3 );
ui->est1252->setMaxLength(24);
ui->est1252->setFrame(globalFrame);

ui->est1253->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "125   ") );
connect( ui->est1253, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1253, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1253->installEventFilter(this);
ui->est1253->setAlignment(Qt::AlignCenter);
ui->est1253->setMaximumWidth( m11trail);
ui->est1253->setMinimumWidth( m6trail);
ui->est1253->setMaximumHeight( m7traild3 );
ui->est1253->setMaxLength(8);
ui->est1253->setFrame(globalFrame);

ui->est1254->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "125   ") );
connect( ui->est1254, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1254, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1254->installEventFilter(this);
ui->est1254->setAlignment(Qt::AlignCenter);
ui->est1254->setMaximumWidth( m12trail);
ui->est1254->setMinimumWidth( m6trail);
ui->est1254->setMaximumHeight( m7traild3 );
ui->est1254->setMaxLength(11);
ui->est1254->setFrame(globalFrame);

ui->est1255->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "125   ") );
connect( ui->est1255, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1255, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1255->installEventFilter(this);
ui->est1255->setAlignment(Qt::AlignCenter);
ui->est1255->setMaximumWidth( m12trail);
ui->est1255->setMinimumWidth( m6trail);
ui->est1255->setMaximumHeight( m7traild3 );
ui->est1255->setMaxLength(11);
ui->est1255->setFrame(globalFrame);

ui->est1256->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "125   ") );
ui->est1256->setReadOnly(true);
ui->est1256->setAlignment(Qt::AlignRight);
ui->est1256->setMaximumWidth( m14trail);
ui->est1256->setMinimumWidth( m9trail);
ui->est1256->setMaximumHeight( m7traild3 );
ui->est1256->setMaxLength(15);
ui->est1256->setFrame(globalFrame);

ui->est1257->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "125   ") );
ui->est1257->setReadOnly(true);
ui->est1257->setAlignment(Qt::AlignRight);
ui->est1257->setMaximumWidth( m14trail);
ui->est1257->setMinimumWidth( m9trail);
ui->est1257->setMaximumHeight( m7traild3 );
ui->est1257->setMaxLength(15);
ui->est1257->setFrame(globalFrame);

ui->lib1261->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "126   ") );
connect( ui->lib1261, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1261, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib126, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst126, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1261->installEventFilter(this);
ui->lib1261->setMaximumWidth( m6trail);
ui->lib1261->setMinimumWidth( m6trail);
ui->lib1261->setMaximumHeight( m7traild3 );
ui->lib1261->setMaxLength(3);
ui->lib1261->setFrame(globalFrame);

ui->lib1262->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "126   ") );
connect( ui->lib1262, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1262, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1262->installEventFilter(this);
ui->lib1262->setMaximumWidth( m26trail);
ui->lib1262->setMinimumWidth( m25trail);
ui->lib1262->setMaximumHeight( m7traild3 );
ui->lib1262->setMaxLength(24);
ui->lib1262->setFrame(globalFrame);

ui->lib1263->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "126   ") );
connect( ui->lib1263, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1263, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1263->installEventFilter(this);
ui->lib1263->setAlignment(Qt::AlignCenter);
ui->lib1263->setMaximumWidth( m12trail);
ui->lib1263->setMinimumWidth( m6trail);
ui->lib1263->setMaximumHeight( m7traild3 );
ui->lib1263->setMaxLength(11);
ui->lib1263->setFrame(globalFrame);

ui->lib1264->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "126   ") );
connect( ui->lib1264, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1264, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1264->installEventFilter(this);
ui->lib1264->setAlignment(Qt::AlignCenter);
ui->lib1264->setMaximumWidth( m12trail);
ui->lib1264->setMinimumWidth( m6trail);
ui->lib1264->setMaximumHeight( m7traild3 );
ui->lib1264->setMaxLength(11);
ui->lib1264->setFrame(globalFrame);

ui->pushButtonEst126->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "126   ") );
ui->pushButtonEst126->setMaximumWidth( m7traild3 );
ui->pushButtonEst126->setMaximumHeight( m7traild3 );
ui->pushButtonLib126->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "126   ") );
ui->pushButtonLib126->setMaximumWidth( m7traild3 );
ui->pushButtonLib126->setMaximumHeight( m7traild3 );

ui->est1261->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "126   ") );
connect( ui->est1261, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1261, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1261->installEventFilter(this);
ui->est1261->setMaximumWidth( m6trail);
ui->est1261->setMinimumWidth( m6trail);
ui->est1261->setMaximumHeight( m7traild3 );
ui->est1261->setMaxLength(3);
ui->est1261->setFrame(globalFrame);

ui->est1262->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "126   ") );
connect( ui->est1262, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1262, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1262->installEventFilter(this);
ui->est1262->setMaximumWidth( m26trail);
ui->est1262->setMinimumWidth( m25trail);
ui->est1262->setMaximumHeight( m7traild3 );
ui->est1262->setMaxLength(24);
ui->est1262->setFrame(globalFrame);

ui->est1263->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "126   ") );
connect( ui->est1263, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1263, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1263->installEventFilter(this);
ui->est1263->setAlignment(Qt::AlignCenter);
ui->est1263->setMaximumWidth( m11trail);
ui->est1263->setMinimumWidth( m6trail);
ui->est1263->setMaximumHeight( m7traild3 );
ui->est1263->setMaxLength(8);
ui->est1263->setFrame(globalFrame);

ui->est1264->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "126   ") );
connect( ui->est1264, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1264, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1264->installEventFilter(this);
ui->est1264->setAlignment(Qt::AlignCenter);
ui->est1264->setMaximumWidth( m12trail);
ui->est1264->setMinimumWidth( m6trail);
ui->est1264->setMaximumHeight( m7traild3 );
ui->est1264->setMaxLength(11);
ui->est1264->setFrame(globalFrame);

ui->est1265->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "126   ") );
connect( ui->est1265, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1265, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1265->installEventFilter(this);
ui->est1265->setAlignment(Qt::AlignCenter);
ui->est1265->setMaximumWidth( m12trail);
ui->est1265->setMinimumWidth( m6trail);
ui->est1265->setMaximumHeight( m7traild3 );
ui->est1265->setMaxLength(11);
ui->est1265->setFrame(globalFrame);

ui->est1266->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "126   ") );
ui->est1266->setReadOnly(true);
ui->est1266->setAlignment(Qt::AlignRight);
ui->est1266->setMaximumWidth( m14trail);
ui->est1266->setMinimumWidth( m9trail);
ui->est1266->setMaximumHeight( m7traild3 );
ui->est1266->setMaxLength(15);
ui->est1266->setFrame(globalFrame);

ui->est1267->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "126   ") );
ui->est1267->setReadOnly(true);
ui->est1267->setAlignment(Qt::AlignRight);
ui->est1267->setMaximumWidth( m14trail);
ui->est1267->setMinimumWidth( m9trail);
ui->est1267->setMaximumHeight( m7traild3 );
ui->est1267->setMaxLength(15);
ui->est1267->setFrame(globalFrame);

ui->lib1271->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "127   ") );
connect( ui->lib1271, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1271, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib127, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst127, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1271->installEventFilter(this);
ui->lib1271->setMaximumWidth( m6trail);
ui->lib1271->setMinimumWidth( m6trail);
ui->lib1271->setMaximumHeight( m7traild3 );
ui->lib1271->setMaxLength(3);
ui->lib1271->setFrame(globalFrame);

ui->lib1272->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "127   ") );
connect( ui->lib1272, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1272, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1272->installEventFilter(this);
ui->lib1272->setMaximumWidth( m26trail);
ui->lib1272->setMinimumWidth( m25trail);
ui->lib1272->setMaximumHeight( m7traild3 );
ui->lib1272->setMaxLength(24);
ui->lib1272->setFrame(globalFrame);

ui->lib1273->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "127   ") );
connect( ui->lib1273, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1273, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1273->installEventFilter(this);
ui->lib1273->setAlignment(Qt::AlignCenter);
ui->lib1273->setMaximumWidth( m12trail);
ui->lib1273->setMinimumWidth( m6trail);
ui->lib1273->setMaximumHeight( m7traild3 );
ui->lib1273->setMaxLength(11);
ui->lib1273->setFrame(globalFrame);

ui->lib1274->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "127   ") );
connect( ui->lib1274, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1274, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1274->installEventFilter(this);
ui->lib1274->setAlignment(Qt::AlignCenter);
ui->lib1274->setMaximumWidth( m12trail);
ui->lib1274->setMinimumWidth( m6trail);
ui->lib1274->setMaximumHeight( m7traild3 );
ui->lib1274->setMaxLength(11);
ui->lib1274->setFrame(globalFrame);

ui->pushButtonEst127->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "127   ") );
ui->pushButtonEst127->setMaximumWidth( m7traild3 );
ui->pushButtonEst127->setMaximumHeight( m7traild3 );
ui->pushButtonLib127->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "127   ") );
ui->pushButtonLib127->setMaximumWidth( m7traild3 );
ui->pushButtonLib127->setMaximumHeight( m7traild3 );

ui->est1271->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "127   ") );
connect( ui->est1271, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1271, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1271->installEventFilter(this);
ui->est1271->setMaximumWidth( m6trail);
ui->est1271->setMinimumWidth( m6trail);
ui->est1271->setMaximumHeight( m7traild3 );
ui->est1271->setMaxLength(3);
ui->est1271->setFrame(globalFrame);

ui->est1272->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "127   ") );
connect( ui->est1272, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1272, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1272->installEventFilter(this);
ui->est1272->setMaximumWidth( m26trail);
ui->est1272->setMinimumWidth( m25trail);
ui->est1272->setMaximumHeight( m7traild3 );
ui->est1272->setMaxLength(24);
ui->est1272->setFrame(globalFrame);

ui->est1273->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "127   ") );
connect( ui->est1273, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1273, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1273->installEventFilter(this);
ui->est1273->setAlignment(Qt::AlignCenter);
ui->est1273->setMaximumWidth( m11trail);
ui->est1273->setMinimumWidth( m6trail);
ui->est1273->setMaximumHeight( m7traild3 );
ui->est1273->setMaxLength(8);
ui->est1273->setFrame(globalFrame);

ui->est1274->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "127   ") );
connect( ui->est1274, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1274, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1274->installEventFilter(this);
ui->est1274->setAlignment(Qt::AlignCenter);
ui->est1274->setMaximumWidth( m12trail);
ui->est1274->setMinimumWidth( m6trail);
ui->est1274->setMaximumHeight( m7traild3 );
ui->est1274->setMaxLength(11);
ui->est1274->setFrame(globalFrame);

ui->est1275->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "127   ") );
connect( ui->est1275, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1275, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1275->installEventFilter(this);
ui->est1275->setAlignment(Qt::AlignCenter);
ui->est1275->setMaximumWidth( m12trail);
ui->est1275->setMinimumWidth( m6trail);
ui->est1275->setMaximumHeight( m7traild3 );
ui->est1275->setMaxLength(11);
ui->est1275->setFrame(globalFrame);

ui->est1276->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "127   ") );
ui->est1276->setReadOnly(true);
ui->est1276->setAlignment(Qt::AlignRight);
ui->est1276->setMaximumWidth( m14trail);
ui->est1276->setMinimumWidth( m9trail);
ui->est1276->setMaximumHeight( m7traild3 );
ui->est1276->setMaxLength(15);
ui->est1276->setFrame(globalFrame);

ui->est1277->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "127   ") );
ui->est1277->setReadOnly(true);
ui->est1277->setAlignment(Qt::AlignRight);
ui->est1277->setMaximumWidth( m14trail);
ui->est1277->setMinimumWidth( m9trail);
ui->est1277->setMaximumHeight( m7traild3 );
ui->est1277->setMaxLength(15);
ui->est1277->setFrame(globalFrame);

ui->lib1281->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "128   ") );
connect( ui->lib1281, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1281, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib128, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst128, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1281->installEventFilter(this);
ui->lib1281->setMaximumWidth( m6trail);
ui->lib1281->setMinimumWidth( m6trail);
ui->lib1281->setMaximumHeight( m7traild3 );
ui->lib1281->setMaxLength(3);
ui->lib1281->setFrame(globalFrame);

ui->lib1282->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "128   ") );
connect( ui->lib1282, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1282, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1282->installEventFilter(this);
ui->lib1282->setMaximumWidth( m26trail);
ui->lib1282->setMinimumWidth( m25trail);
ui->lib1282->setMaximumHeight( m7traild3 );
ui->lib1282->setMaxLength(24);
ui->lib1282->setFrame(globalFrame);

ui->lib1283->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "128   ") );
connect( ui->lib1283, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1283, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1283->installEventFilter(this);
ui->lib1283->setAlignment(Qt::AlignCenter);
ui->lib1283->setMaximumWidth( m12trail);
ui->lib1283->setMinimumWidth( m6trail);
ui->lib1283->setMaximumHeight( m7traild3 );
ui->lib1283->setMaxLength(11);
ui->lib1283->setFrame(globalFrame);

ui->lib1284->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "128   ") );
connect( ui->lib1284, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1284, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1284->installEventFilter(this);
ui->lib1284->setAlignment(Qt::AlignCenter);
ui->lib1284->setMaximumWidth( m12trail);
ui->lib1284->setMinimumWidth( m6trail);
ui->lib1284->setMaximumHeight( m7traild3 );
ui->lib1284->setMaxLength(11);
ui->lib1284->setFrame(globalFrame);

ui->pushButtonEst128->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "128   ") );
ui->pushButtonEst128->setMaximumWidth( m7traild3 );
ui->pushButtonEst128->setMaximumHeight( m7traild3 );
ui->pushButtonLib128->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "128   ") );
ui->pushButtonLib128->setMaximumWidth( m7traild3 );
ui->pushButtonLib128->setMaximumHeight( m7traild3 );

ui->est1281->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "128   ") );
connect( ui->est1281, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1281, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1281->installEventFilter(this);
ui->est1281->setMaximumWidth( m6trail);
ui->est1281->setMinimumWidth( m6trail);
ui->est1281->setMaximumHeight( m7traild3 );
ui->est1281->setMaxLength(3);
ui->est1281->setFrame(globalFrame);

ui->est1282->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "128   ") );
connect( ui->est1282, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1282, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1282->installEventFilter(this);
ui->est1282->setMaximumWidth( m26trail);
ui->est1282->setMinimumWidth( m25trail);
ui->est1282->setMaximumHeight( m7traild3 );
ui->est1282->setMaxLength(24);
ui->est1282->setFrame(globalFrame);

ui->est1283->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "128   ") );
connect( ui->est1283, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1283, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1283->installEventFilter(this);
ui->est1283->setAlignment(Qt::AlignCenter);
ui->est1283->setMaximumWidth( m11trail);
ui->est1283->setMinimumWidth( m6trail);
ui->est1283->setMaximumHeight( m7traild3 );
ui->est1283->setMaxLength(8);
ui->est1283->setFrame(globalFrame);

ui->est1284->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "128   ") );
connect( ui->est1284, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1284, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1284->installEventFilter(this);
ui->est1284->setAlignment(Qt::AlignCenter);
ui->est1284->setMaximumWidth( m12trail);
ui->est1284->setMinimumWidth( m6trail);
ui->est1284->setMaximumHeight( m7traild3 );
ui->est1284->setMaxLength(11);
ui->est1284->setFrame(globalFrame);

ui->est1285->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "128   ") );
connect( ui->est1285, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1285, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1285->installEventFilter(this);
ui->est1285->setAlignment(Qt::AlignCenter);
ui->est1285->setMaximumWidth( m12trail);
ui->est1285->setMinimumWidth( m6trail);
ui->est1285->setMaximumHeight( m7traild3 );
ui->est1285->setMaxLength(11);
ui->est1285->setFrame(globalFrame);

ui->est1286->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "128   ") );
ui->est1286->setReadOnly(true);
ui->est1286->setAlignment(Qt::AlignRight);
ui->est1286->setMaximumWidth( m14trail);
ui->est1286->setMinimumWidth( m9trail);
ui->est1286->setMaximumHeight( m7traild3 );
ui->est1286->setMaxLength(15);
ui->est1286->setFrame(globalFrame);

ui->est1287->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "128   ") );
ui->est1287->setReadOnly(true);
ui->est1287->setAlignment(Qt::AlignRight);
ui->est1287->setMaximumWidth( m14trail);
ui->est1287->setMinimumWidth( m9trail);
ui->est1287->setMaximumHeight( m7traild3 );
ui->est1287->setMaxLength(15);
ui->est1287->setFrame(globalFrame);

ui->lib1291->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "129   ") );
connect( ui->lib1291, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1291, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib129, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst129, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1291->installEventFilter(this);
ui->lib1291->setMaximumWidth( m6trail);
ui->lib1291->setMinimumWidth( m6trail);
ui->lib1291->setMaximumHeight( m7traild3 );
ui->lib1291->setMaxLength(3);
ui->lib1291->setFrame(globalFrame);

ui->lib1292->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "129   ") );
connect( ui->lib1292, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1292, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1292->installEventFilter(this);
ui->lib1292->setMaximumWidth( m26trail);
ui->lib1292->setMinimumWidth( m25trail);
ui->lib1292->setMaximumHeight( m7traild3 );
ui->lib1292->setMaxLength(24);
ui->lib1292->setFrame(globalFrame);

ui->lib1293->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "129   ") );
connect( ui->lib1293, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1293, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1293->installEventFilter(this);
ui->lib1293->setAlignment(Qt::AlignCenter);
ui->lib1293->setMaximumWidth( m12trail);
ui->lib1293->setMinimumWidth( m6trail);
ui->lib1293->setMaximumHeight( m7traild3 );
ui->lib1293->setMaxLength(11);
ui->lib1293->setFrame(globalFrame);

ui->lib1294->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "129   ") );
connect( ui->lib1294, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1294, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1294->installEventFilter(this);
ui->lib1294->setAlignment(Qt::AlignCenter);
ui->lib1294->setMaximumWidth( m12trail);
ui->lib1294->setMinimumWidth( m6trail);
ui->lib1294->setMaximumHeight( m7traild3 );
ui->lib1294->setMaxLength(11);
ui->lib1294->setFrame(globalFrame);

ui->pushButtonEst129->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "129   ") );
ui->pushButtonEst129->setMaximumWidth( m7traild3 );
ui->pushButtonEst129->setMaximumHeight( m7traild3 );
ui->pushButtonLib129->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "129   ") );
ui->pushButtonLib129->setMaximumWidth( m7traild3 );
ui->pushButtonLib129->setMaximumHeight( m7traild3 );

ui->est1291->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "129   ") );
connect( ui->est1291, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1291, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1291->installEventFilter(this);
ui->est1291->setMaximumWidth( m6trail);
ui->est1291->setMinimumWidth( m6trail);
ui->est1291->setMaximumHeight( m7traild3 );
ui->est1291->setMaxLength(3);
ui->est1291->setFrame(globalFrame);

ui->est1292->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "129   ") );
connect( ui->est1292, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1292, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1292->installEventFilter(this);
ui->est1292->setMaximumWidth( m26trail);
ui->est1292->setMinimumWidth( m25trail);
ui->est1292->setMaximumHeight( m7traild3 );
ui->est1292->setMaxLength(24);
ui->est1292->setFrame(globalFrame);

ui->est1293->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "129   ") );
connect( ui->est1293, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1293, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1293->installEventFilter(this);
ui->est1293->setAlignment(Qt::AlignCenter);
ui->est1293->setMaximumWidth( m11trail);
ui->est1293->setMinimumWidth( m6trail);
ui->est1293->setMaximumHeight( m7traild3 );
ui->est1293->setMaxLength(8);
ui->est1293->setFrame(globalFrame);

ui->est1294->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "129   ") );
connect( ui->est1294, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1294, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1294->installEventFilter(this);
ui->est1294->setAlignment(Qt::AlignCenter);
ui->est1294->setMaximumWidth( m12trail);
ui->est1294->setMinimumWidth( m6trail);
ui->est1294->setMaximumHeight( m7traild3 );
ui->est1294->setMaxLength(11);
ui->est1294->setFrame(globalFrame);

ui->est1295->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "129   ") );
connect( ui->est1295, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1295, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1295->installEventFilter(this);
ui->est1295->setAlignment(Qt::AlignCenter);
ui->est1295->setMaximumWidth( m12trail);
ui->est1295->setMinimumWidth( m6trail);
ui->est1295->setMaximumHeight( m7traild3 );
ui->est1295->setMaxLength(11);
ui->est1295->setFrame(globalFrame);

ui->est1296->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "129   ") );
ui->est1296->setReadOnly(true);
ui->est1296->setAlignment(Qt::AlignRight);
ui->est1296->setMaximumWidth( m14trail);
ui->est1296->setMinimumWidth( m9trail);
ui->est1296->setMaximumHeight( m7traild3 );
ui->est1296->setMaxLength(15);
ui->est1296->setFrame(globalFrame);

ui->est1297->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "129   ") );
ui->est1297->setReadOnly(true);
ui->est1297->setAlignment(Qt::AlignRight);
ui->est1297->setMaximumWidth( m14trail);
ui->est1297->setMinimumWidth( m9trail);
ui->est1297->setMaximumHeight( m7traild3 );
ui->est1297->setMaxLength(15);
ui->est1297->setFrame(globalFrame);

ui->lib1301->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "130   ") );
connect( ui->lib1301, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1301, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib130, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst130, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1301->installEventFilter(this);
ui->lib1301->setMaximumWidth( m6trail);
ui->lib1301->setMinimumWidth( m6trail);
ui->lib1301->setMaximumHeight( m7traild3 );
ui->lib1301->setMaxLength(3);
ui->lib1301->setFrame(globalFrame);

ui->lib1302->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "130   ") );
connect( ui->lib1302, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1302, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1302->installEventFilter(this);
ui->lib1302->setMaximumWidth( m26trail);
ui->lib1302->setMinimumWidth( m25trail);
ui->lib1302->setMaximumHeight( m7traild3 );
ui->lib1302->setMaxLength(24);
ui->lib1302->setFrame(globalFrame);

ui->lib1303->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "130   ") );
connect( ui->lib1303, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1303, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1303->installEventFilter(this);
ui->lib1303->setAlignment(Qt::AlignCenter);
ui->lib1303->setMaximumWidth( m12trail);
ui->lib1303->setMinimumWidth( m6trail);
ui->lib1303->setMaximumHeight( m7traild3 );
ui->lib1303->setMaxLength(11);
ui->lib1303->setFrame(globalFrame);

ui->lib1304->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "130   ") );
connect( ui->lib1304, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1304, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1304->installEventFilter(this);
ui->lib1304->setAlignment(Qt::AlignCenter);
ui->lib1304->setMaximumWidth( m12trail);
ui->lib1304->setMinimumWidth( m6trail);
ui->lib1304->setMaximumHeight( m7traild3 );
ui->lib1304->setMaxLength(11);
ui->lib1304->setFrame(globalFrame);

ui->pushButtonEst130->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "130   ") );
ui->pushButtonEst130->setMaximumWidth( m7traild3 );
ui->pushButtonEst130->setMaximumHeight( m7traild3 );
ui->pushButtonLib130->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "130   ") );
ui->pushButtonLib130->setMaximumWidth( m7traild3 );
ui->pushButtonLib130->setMaximumHeight( m7traild3 );

ui->est1301->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "130   ") );
connect( ui->est1301, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1301, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1301->installEventFilter(this);
ui->est1301->setMaximumWidth( m6trail);
ui->est1301->setMinimumWidth( m6trail);
ui->est1301->setMaximumHeight( m7traild3 );
ui->est1301->setMaxLength(3);
ui->est1301->setFrame(globalFrame);

ui->est1302->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "130   ") );
connect( ui->est1302, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1302, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1302->installEventFilter(this);
ui->est1302->setMaximumWidth( m26trail);
ui->est1302->setMinimumWidth( m25trail);
ui->est1302->setMaximumHeight( m7traild3 );
ui->est1302->setMaxLength(24);
ui->est1302->setFrame(globalFrame);

ui->est1303->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "130   ") );
connect( ui->est1303, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1303, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1303->installEventFilter(this);
ui->est1303->setAlignment(Qt::AlignCenter);
ui->est1303->setMaximumWidth( m11trail);
ui->est1303->setMinimumWidth( m6trail);
ui->est1303->setMaximumHeight( m7traild3 );
ui->est1303->setMaxLength(8);
ui->est1303->setFrame(globalFrame);

ui->est1304->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "130   ") );
connect( ui->est1304, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1304, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1304->installEventFilter(this);
ui->est1304->setAlignment(Qt::AlignCenter);
ui->est1304->setMaximumWidth( m12trail);
ui->est1304->setMinimumWidth( m6trail);
ui->est1304->setMaximumHeight( m7traild3 );
ui->est1304->setMaxLength(11);
ui->est1304->setFrame(globalFrame);

ui->est1305->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "130   ") );
connect( ui->est1305, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1305, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1305->installEventFilter(this);
ui->est1305->setAlignment(Qt::AlignCenter);
ui->est1305->setMaximumWidth( m12trail);
ui->est1305->setMinimumWidth( m6trail);
ui->est1305->setMaximumHeight( m7traild3 );
ui->est1305->setMaxLength(11);
ui->est1305->setFrame(globalFrame);

ui->est1306->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "130   ") );
ui->est1306->setReadOnly(true);
ui->est1306->setAlignment(Qt::AlignRight);
ui->est1306->setMaximumWidth( m14trail);
ui->est1306->setMinimumWidth( m9trail);
ui->est1306->setMaximumHeight( m7traild3 );
ui->est1306->setMaxLength(15);
ui->est1306->setFrame(globalFrame);

ui->est1307->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "130   ") );
ui->est1307->setReadOnly(true);
ui->est1307->setAlignment(Qt::AlignRight);
ui->est1307->setMaximumWidth( m14trail);
ui->est1307->setMinimumWidth( m9trail);
ui->est1307->setMaximumHeight( m7traild3 );
ui->est1307->setMaxLength(15);
ui->est1307->setFrame(globalFrame);

ui->lib1311->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "131   ") );
connect( ui->lib1311, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1311, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib131, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst131, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1311->installEventFilter(this);
ui->lib1311->setMaximumWidth( m6trail);
ui->lib1311->setMinimumWidth( m6trail);
ui->lib1311->setMaximumHeight( m7traild3 );
ui->lib1311->setMaxLength(3);
ui->lib1311->setFrame(globalFrame);

ui->lib1312->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "131   ") );
connect( ui->lib1312, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1312, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1312->installEventFilter(this);
ui->lib1312->setMaximumWidth( m26trail);
ui->lib1312->setMinimumWidth( m25trail);
ui->lib1312->setMaximumHeight( m7traild3 );
ui->lib1312->setMaxLength(24);
ui->lib1312->setFrame(globalFrame);

ui->lib1313->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "131   ") );
connect( ui->lib1313, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1313, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1313->installEventFilter(this);
ui->lib1313->setAlignment(Qt::AlignCenter);
ui->lib1313->setMaximumWidth( m12trail);
ui->lib1313->setMinimumWidth( m6trail);
ui->lib1313->setMaximumHeight( m7traild3 );
ui->lib1313->setMaxLength(11);
ui->lib1313->setFrame(globalFrame);

ui->lib1314->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "131   ") );
connect( ui->lib1314, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1314, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1314->installEventFilter(this);
ui->lib1314->setAlignment(Qt::AlignCenter);
ui->lib1314->setMaximumWidth( m12trail);
ui->lib1314->setMinimumWidth( m6trail);
ui->lib1314->setMaximumHeight( m7traild3 );
ui->lib1314->setMaxLength(11);
ui->lib1314->setFrame(globalFrame);

ui->pushButtonEst131->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "131   ") );
ui->pushButtonEst131->setMaximumWidth( m7traild3 );
ui->pushButtonEst131->setMaximumHeight( m7traild3 );
ui->pushButtonLib131->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "131   ") );
ui->pushButtonLib131->setMaximumWidth( m7traild3 );
ui->pushButtonLib131->setMaximumHeight( m7traild3 );

ui->est1311->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "131   ") );
connect( ui->est1311, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1311, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1311->installEventFilter(this);
ui->est1311->setMaximumWidth( m6trail);
ui->est1311->setMinimumWidth( m6trail);
ui->est1311->setMaximumHeight( m7traild3 );
ui->est1311->setMaxLength(3);
ui->est1311->setFrame(globalFrame);

ui->est1312->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "131   ") );
connect( ui->est1312, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1312, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1312->installEventFilter(this);
ui->est1312->setMaximumWidth( m26trail);
ui->est1312->setMinimumWidth( m25trail);
ui->est1312->setMaximumHeight( m7traild3 );
ui->est1312->setMaxLength(24);
ui->est1312->setFrame(globalFrame);

ui->est1313->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "131   ") );
connect( ui->est1313, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1313, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1313->installEventFilter(this);
ui->est1313->setAlignment(Qt::AlignCenter);
ui->est1313->setMaximumWidth( m11trail);
ui->est1313->setMinimumWidth( m6trail);
ui->est1313->setMaximumHeight( m7traild3 );
ui->est1313->setMaxLength(8);
ui->est1313->setFrame(globalFrame);

ui->est1314->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "131   ") );
connect( ui->est1314, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1314, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1314->installEventFilter(this);
ui->est1314->setAlignment(Qt::AlignCenter);
ui->est1314->setMaximumWidth( m12trail);
ui->est1314->setMinimumWidth( m6trail);
ui->est1314->setMaximumHeight( m7traild3 );
ui->est1314->setMaxLength(11);
ui->est1314->setFrame(globalFrame);

ui->est1315->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "131   ") );
connect( ui->est1315, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1315, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1315->installEventFilter(this);
ui->est1315->setAlignment(Qt::AlignCenter);
ui->est1315->setMaximumWidth( m12trail);
ui->est1315->setMinimumWidth( m6trail);
ui->est1315->setMaximumHeight( m7traild3 );
ui->est1315->setMaxLength(11);
ui->est1315->setFrame(globalFrame);

ui->est1316->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "131   ") );
ui->est1316->setReadOnly(true);
ui->est1316->setAlignment(Qt::AlignRight);
ui->est1316->setMaximumWidth( m14trail);
ui->est1316->setMinimumWidth( m9trail);
ui->est1316->setMaximumHeight( m7traild3 );
ui->est1316->setMaxLength(15);
ui->est1316->setFrame(globalFrame);

ui->est1317->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "131   ") );
ui->est1317->setReadOnly(true);
ui->est1317->setAlignment(Qt::AlignRight);
ui->est1317->setMaximumWidth( m14trail);
ui->est1317->setMinimumWidth( m9trail);
ui->est1317->setMaximumHeight( m7traild3 );
ui->est1317->setMaxLength(15);
ui->est1317->setFrame(globalFrame);

ui->lib1321->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "132   ") );
connect( ui->lib1321, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1321, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib132, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst132, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1321->installEventFilter(this);
ui->lib1321->setMaximumWidth( m6trail);
ui->lib1321->setMinimumWidth( m6trail);
ui->lib1321->setMaximumHeight( m7traild3 );
ui->lib1321->setMaxLength(3);
ui->lib1321->setFrame(globalFrame);

ui->lib1322->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "132   ") );
connect( ui->lib1322, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1322, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1322->installEventFilter(this);
ui->lib1322->setMaximumWidth( m26trail);
ui->lib1322->setMinimumWidth( m25trail);
ui->lib1322->setMaximumHeight( m7traild3 );
ui->lib1322->setMaxLength(24);
ui->lib1322->setFrame(globalFrame);

ui->lib1323->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "132   ") );
connect( ui->lib1323, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1323, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1323->installEventFilter(this);
ui->lib1323->setAlignment(Qt::AlignCenter);
ui->lib1323->setMaximumWidth( m12trail);
ui->lib1323->setMinimumWidth( m6trail);
ui->lib1323->setMaximumHeight( m7traild3 );
ui->lib1323->setMaxLength(11);
ui->lib1323->setFrame(globalFrame);

ui->lib1324->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "132   ") );
connect( ui->lib1324, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1324, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1324->installEventFilter(this);
ui->lib1324->setAlignment(Qt::AlignCenter);
ui->lib1324->setMaximumWidth( m12trail);
ui->lib1324->setMinimumWidth( m6trail);
ui->lib1324->setMaximumHeight( m7traild3 );
ui->lib1324->setMaxLength(11);
ui->lib1324->setFrame(globalFrame);

ui->pushButtonEst132->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "132   ") );
ui->pushButtonEst132->setMaximumWidth( m7traild3 );
ui->pushButtonEst132->setMaximumHeight( m7traild3 );
ui->pushButtonLib132->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "132   ") );
ui->pushButtonLib132->setMaximumWidth( m7traild3 );
ui->pushButtonLib132->setMaximumHeight( m7traild3 );

ui->est1321->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "132   ") );
connect( ui->est1321, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1321, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1321->installEventFilter(this);
ui->est1321->setMaximumWidth( m6trail);
ui->est1321->setMinimumWidth( m6trail);
ui->est1321->setMaximumHeight( m7traild3 );
ui->est1321->setMaxLength(3);
ui->est1321->setFrame(globalFrame);

ui->est1322->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "132   ") );
connect( ui->est1322, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1322, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1322->installEventFilter(this);
ui->est1322->setMaximumWidth( m26trail);
ui->est1322->setMinimumWidth( m25trail);
ui->est1322->setMaximumHeight( m7traild3 );
ui->est1322->setMaxLength(24);
ui->est1322->setFrame(globalFrame);

ui->est1323->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "132   ") );
connect( ui->est1323, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1323, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1323->installEventFilter(this);
ui->est1323->setAlignment(Qt::AlignCenter);
ui->est1323->setMaximumWidth( m11trail);
ui->est1323->setMinimumWidth( m6trail);
ui->est1323->setMaximumHeight( m7traild3 );
ui->est1323->setMaxLength(8);
ui->est1323->setFrame(globalFrame);

ui->est1324->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "132   ") );
connect( ui->est1324, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1324, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1324->installEventFilter(this);
ui->est1324->setAlignment(Qt::AlignCenter);
ui->est1324->setMaximumWidth( m12trail);
ui->est1324->setMinimumWidth( m6trail);
ui->est1324->setMaximumHeight( m7traild3 );
ui->est1324->setMaxLength(11);
ui->est1324->setFrame(globalFrame);

ui->est1325->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "132   ") );
connect( ui->est1325, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1325, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1325->installEventFilter(this);
ui->est1325->setAlignment(Qt::AlignCenter);
ui->est1325->setMaximumWidth( m12trail);
ui->est1325->setMinimumWidth( m6trail);
ui->est1325->setMaximumHeight( m7traild3 );
ui->est1325->setMaxLength(11);
ui->est1325->setFrame(globalFrame);

ui->est1326->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "132   ") );
ui->est1326->setReadOnly(true);
ui->est1326->setAlignment(Qt::AlignRight);
ui->est1326->setMaximumWidth( m14trail);
ui->est1326->setMinimumWidth( m9trail);
ui->est1326->setMaximumHeight( m7traild3 );
ui->est1326->setMaxLength(15);
ui->est1326->setFrame(globalFrame);

ui->est1327->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "132   ") );
ui->est1327->setReadOnly(true);
ui->est1327->setAlignment(Qt::AlignRight);
ui->est1327->setMaximumWidth( m14trail);
ui->est1327->setMinimumWidth( m9trail);
ui->est1327->setMaximumHeight( m7traild3 );
ui->est1327->setMaxLength(15);
ui->est1327->setFrame(globalFrame);

ui->lib1331->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "133   ") );
connect( ui->lib1331, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1331, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib133, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst133, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1331->installEventFilter(this);
ui->lib1331->setMaximumWidth( m6trail);
ui->lib1331->setMinimumWidth( m6trail);
ui->lib1331->setMaximumHeight( m7traild3 );
ui->lib1331->setMaxLength(3);
ui->lib1331->setFrame(globalFrame);

ui->lib1332->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "133   ") );
connect( ui->lib1332, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1332, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1332->installEventFilter(this);
ui->lib1332->setMaximumWidth( m26trail);
ui->lib1332->setMinimumWidth( m25trail);
ui->lib1332->setMaximumHeight( m7traild3 );
ui->lib1332->setMaxLength(24);
ui->lib1332->setFrame(globalFrame);

ui->lib1333->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "133   ") );
connect( ui->lib1333, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1333, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1333->installEventFilter(this);
ui->lib1333->setAlignment(Qt::AlignCenter);
ui->lib1333->setMaximumWidth( m12trail);
ui->lib1333->setMinimumWidth( m6trail);
ui->lib1333->setMaximumHeight( m7traild3 );
ui->lib1333->setMaxLength(11);
ui->lib1333->setFrame(globalFrame);

ui->lib1334->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "133   ") );
connect( ui->lib1334, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1334, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1334->installEventFilter(this);
ui->lib1334->setAlignment(Qt::AlignCenter);
ui->lib1334->setMaximumWidth( m12trail);
ui->lib1334->setMinimumWidth( m6trail);
ui->lib1334->setMaximumHeight( m7traild3 );
ui->lib1334->setMaxLength(11);
ui->lib1334->setFrame(globalFrame);

ui->pushButtonEst133->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "133   ") );
ui->pushButtonEst133->setMaximumWidth( m7traild3 );
ui->pushButtonEst133->setMaximumHeight( m7traild3 );
ui->pushButtonLib133->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "133   ") );
ui->pushButtonLib133->setMaximumWidth( m7traild3 );
ui->pushButtonLib133->setMaximumHeight( m7traild3 );

ui->est1331->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "133   ") );
connect( ui->est1331, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1331, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1331->installEventFilter(this);
ui->est1331->setMaximumWidth( m6trail);
ui->est1331->setMinimumWidth( m6trail);
ui->est1331->setMaximumHeight( m7traild3 );
ui->est1331->setMaxLength(3);
ui->est1331->setFrame(globalFrame);

ui->est1332->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "133   ") );
connect( ui->est1332, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1332, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1332->installEventFilter(this);
ui->est1332->setMaximumWidth( m26trail);
ui->est1332->setMinimumWidth( m25trail);
ui->est1332->setMaximumHeight( m7traild3 );
ui->est1332->setMaxLength(24);
ui->est1332->setFrame(globalFrame);

ui->est1333->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "133   ") );
connect( ui->est1333, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1333, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1333->installEventFilter(this);
ui->est1333->setAlignment(Qt::AlignCenter);
ui->est1333->setMaximumWidth( m11trail);
ui->est1333->setMinimumWidth( m6trail);
ui->est1333->setMaximumHeight( m7traild3 );
ui->est1333->setMaxLength(8);
ui->est1333->setFrame(globalFrame);

ui->est1334->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "133   ") );
connect( ui->est1334, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1334, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1334->installEventFilter(this);
ui->est1334->setAlignment(Qt::AlignCenter);
ui->est1334->setMaximumWidth( m12trail);
ui->est1334->setMinimumWidth( m6trail);
ui->est1334->setMaximumHeight( m7traild3 );
ui->est1334->setMaxLength(11);
ui->est1334->setFrame(globalFrame);

ui->est1335->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "133   ") );
connect( ui->est1335, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1335, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1335->installEventFilter(this);
ui->est1335->setAlignment(Qt::AlignCenter);
ui->est1335->setMaximumWidth( m12trail);
ui->est1335->setMinimumWidth( m6trail);
ui->est1335->setMaximumHeight( m7traild3 );
ui->est1335->setMaxLength(11);
ui->est1335->setFrame(globalFrame);

ui->est1336->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "133   ") );
ui->est1336->setReadOnly(true);
ui->est1336->setAlignment(Qt::AlignRight);
ui->est1336->setMaximumWidth( m14trail);
ui->est1336->setMinimumWidth( m9trail);
ui->est1336->setMaximumHeight( m7traild3 );
ui->est1336->setMaxLength(15);
ui->est1336->setFrame(globalFrame);

ui->est1337->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "133   ") );
ui->est1337->setReadOnly(true);
ui->est1337->setAlignment(Qt::AlignRight);
ui->est1337->setMaximumWidth( m14trail);
ui->est1337->setMinimumWidth( m9trail);
ui->est1337->setMaximumHeight( m7traild3 );
ui->est1337->setMaxLength(15);
ui->est1337->setFrame(globalFrame);

ui->lib1341->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "134   ") );
connect( ui->lib1341, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1341, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib134, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst134, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1341->installEventFilter(this);
ui->lib1341->setMaximumWidth( m6trail);
ui->lib1341->setMinimumWidth( m6trail);
ui->lib1341->setMaximumHeight( m7traild3 );
ui->lib1341->setMaxLength(3);
ui->lib1341->setFrame(globalFrame);

ui->lib1342->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "134   ") );
connect( ui->lib1342, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1342, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1342->installEventFilter(this);
ui->lib1342->setMaximumWidth( m26trail);
ui->lib1342->setMinimumWidth( m25trail);
ui->lib1342->setMaximumHeight( m7traild3 );
ui->lib1342->setMaxLength(24);
ui->lib1342->setFrame(globalFrame);

ui->lib1343->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "134   ") );
connect( ui->lib1343, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1343, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1343->installEventFilter(this);
ui->lib1343->setAlignment(Qt::AlignCenter);
ui->lib1343->setMaximumWidth( m12trail);
ui->lib1343->setMinimumWidth( m6trail);
ui->lib1343->setMaximumHeight( m7traild3 );
ui->lib1343->setMaxLength(11);
ui->lib1343->setFrame(globalFrame);

ui->lib1344->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "134   ") );
connect( ui->lib1344, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1344, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1344->installEventFilter(this);
ui->lib1344->setAlignment(Qt::AlignCenter);
ui->lib1344->setMaximumWidth( m12trail);
ui->lib1344->setMinimumWidth( m6trail);
ui->lib1344->setMaximumHeight( m7traild3 );
ui->lib1344->setMaxLength(11);
ui->lib1344->setFrame(globalFrame);

ui->pushButtonEst134->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "134   ") );
ui->pushButtonEst134->setMaximumWidth( m7traild3 );
ui->pushButtonEst134->setMaximumHeight( m7traild3 );
ui->pushButtonLib134->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "134   ") );
ui->pushButtonLib134->setMaximumWidth( m7traild3 );
ui->pushButtonLib134->setMaximumHeight( m7traild3 );

ui->est1341->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "134   ") );
connect( ui->est1341, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1341, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1341->installEventFilter(this);
ui->est1341->setMaximumWidth( m6trail);
ui->est1341->setMinimumWidth( m6trail);
ui->est1341->setMaximumHeight( m7traild3 );
ui->est1341->setMaxLength(3);
ui->est1341->setFrame(globalFrame);

ui->est1342->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "134   ") );
connect( ui->est1342, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1342, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1342->installEventFilter(this);
ui->est1342->setMaximumWidth( m26trail);
ui->est1342->setMinimumWidth( m25trail);
ui->est1342->setMaximumHeight( m7traild3 );
ui->est1342->setMaxLength(24);
ui->est1342->setFrame(globalFrame);

ui->est1343->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "134   ") );
connect( ui->est1343, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1343, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1343->installEventFilter(this);
ui->est1343->setAlignment(Qt::AlignCenter);
ui->est1343->setMaximumWidth( m11trail);
ui->est1343->setMinimumWidth( m6trail);
ui->est1343->setMaximumHeight( m7traild3 );
ui->est1343->setMaxLength(8);
ui->est1343->setFrame(globalFrame);

ui->est1344->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "134   ") );
connect( ui->est1344, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1344, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1344->installEventFilter(this);
ui->est1344->setAlignment(Qt::AlignCenter);
ui->est1344->setMaximumWidth( m12trail);
ui->est1344->setMinimumWidth( m6trail);
ui->est1344->setMaximumHeight( m7traild3 );
ui->est1344->setMaxLength(11);
ui->est1344->setFrame(globalFrame);

ui->est1345->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "134   ") );
connect( ui->est1345, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1345, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1345->installEventFilter(this);
ui->est1345->setAlignment(Qt::AlignCenter);
ui->est1345->setMaximumWidth( m12trail);
ui->est1345->setMinimumWidth( m6trail);
ui->est1345->setMaximumHeight( m7traild3 );
ui->est1345->setMaxLength(11);
ui->est1345->setFrame(globalFrame);

ui->est1346->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "134   ") );
ui->est1346->setReadOnly(true);
ui->est1346->setAlignment(Qt::AlignRight);
ui->est1346->setMaximumWidth( m14trail);
ui->est1346->setMinimumWidth( m9trail);
ui->est1346->setMaximumHeight( m7traild3 );
ui->est1346->setMaxLength(15);
ui->est1346->setFrame(globalFrame);

ui->est1347->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "134   ") );
ui->est1347->setReadOnly(true);
ui->est1347->setAlignment(Qt::AlignRight);
ui->est1347->setMaximumWidth( m14trail);
ui->est1347->setMinimumWidth( m9trail);
ui->est1347->setMaximumHeight( m7traild3 );
ui->est1347->setMaxLength(15);
ui->est1347->setFrame(globalFrame);

ui->lib1351->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "135   ") );
connect( ui->lib1351, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1351, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib135, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst135, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1351->installEventFilter(this);
ui->lib1351->setMaximumWidth( m6trail);
ui->lib1351->setMinimumWidth( m6trail);
ui->lib1351->setMaximumHeight( m7traild3 );
ui->lib1351->setMaxLength(3);
ui->lib1351->setFrame(globalFrame);

ui->lib1352->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "135   ") );
connect( ui->lib1352, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1352, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1352->installEventFilter(this);
ui->lib1352->setMaximumWidth( m26trail);
ui->lib1352->setMinimumWidth( m25trail);
ui->lib1352->setMaximumHeight( m7traild3 );
ui->lib1352->setMaxLength(24);
ui->lib1352->setFrame(globalFrame);

ui->lib1353->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "135   ") );
connect( ui->lib1353, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1353, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1353->installEventFilter(this);
ui->lib1353->setAlignment(Qt::AlignCenter);
ui->lib1353->setMaximumWidth( m12trail);
ui->lib1353->setMinimumWidth( m6trail);
ui->lib1353->setMaximumHeight( m7traild3 );
ui->lib1353->setMaxLength(11);
ui->lib1353->setFrame(globalFrame);

ui->lib1354->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "135   ") );
connect( ui->lib1354, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1354, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1354->installEventFilter(this);
ui->lib1354->setAlignment(Qt::AlignCenter);
ui->lib1354->setMaximumWidth( m12trail);
ui->lib1354->setMinimumWidth( m6trail);
ui->lib1354->setMaximumHeight( m7traild3 );
ui->lib1354->setMaxLength(11);
ui->lib1354->setFrame(globalFrame);

ui->pushButtonEst135->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "135   ") );
ui->pushButtonEst135->setMaximumWidth( m7traild3 );
ui->pushButtonEst135->setMaximumHeight( m7traild3 );
ui->pushButtonLib135->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "135   ") );
ui->pushButtonLib135->setMaximumWidth( m7traild3 );
ui->pushButtonLib135->setMaximumHeight( m7traild3 );

ui->est1351->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "135   ") );
connect( ui->est1351, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1351, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1351->installEventFilter(this);
ui->est1351->setMaximumWidth( m6trail);
ui->est1351->setMinimumWidth( m6trail);
ui->est1351->setMaximumHeight( m7traild3 );
ui->est1351->setMaxLength(3);
ui->est1351->setFrame(globalFrame);

ui->est1352->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "135   ") );
connect( ui->est1352, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1352, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1352->installEventFilter(this);
ui->est1352->setMaximumWidth( m26trail);
ui->est1352->setMinimumWidth( m25trail);
ui->est1352->setMaximumHeight( m7traild3 );
ui->est1352->setMaxLength(24);
ui->est1352->setFrame(globalFrame);

ui->est1353->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "135   ") );
connect( ui->est1353, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1353, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1353->installEventFilter(this);
ui->est1353->setAlignment(Qt::AlignCenter);
ui->est1353->setMaximumWidth( m11trail);
ui->est1353->setMinimumWidth( m6trail);
ui->est1353->setMaximumHeight( m7traild3 );
ui->est1353->setMaxLength(8);
ui->est1353->setFrame(globalFrame);

ui->est1354->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "135   ") );
connect( ui->est1354, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1354, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1354->installEventFilter(this);
ui->est1354->setAlignment(Qt::AlignCenter);
ui->est1354->setMaximumWidth( m12trail);
ui->est1354->setMinimumWidth( m6trail);
ui->est1354->setMaximumHeight( m7traild3 );
ui->est1354->setMaxLength(11);
ui->est1354->setFrame(globalFrame);

ui->est1355->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "135   ") );
connect( ui->est1355, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1355, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1355->installEventFilter(this);
ui->est1355->setAlignment(Qt::AlignCenter);
ui->est1355->setMaximumWidth( m12trail);
ui->est1355->setMinimumWidth( m6trail);
ui->est1355->setMaximumHeight( m7traild3 );
ui->est1355->setMaxLength(11);
ui->est1355->setFrame(globalFrame);

ui->est1356->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "135   ") );
ui->est1356->setReadOnly(true);
ui->est1356->setAlignment(Qt::AlignRight);
ui->est1356->setMaximumWidth( m14trail);
ui->est1356->setMinimumWidth( m9trail);
ui->est1356->setMaximumHeight( m7traild3 );
ui->est1356->setMaxLength(15);
ui->est1356->setFrame(globalFrame);

ui->est1357->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "135   ") );
ui->est1357->setReadOnly(true);
ui->est1357->setAlignment(Qt::AlignRight);
ui->est1357->setMaximumWidth( m14trail);
ui->est1357->setMinimumWidth( m9trail);
ui->est1357->setMaximumHeight( m7traild3 );
ui->est1357->setMaxLength(15);
ui->est1357->setFrame(globalFrame);

ui->lib1361->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "136   ") );
connect( ui->lib1361, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1361, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib136, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst136, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1361->installEventFilter(this);
ui->lib1361->setMaximumWidth( m6trail);
ui->lib1361->setMinimumWidth( m6trail);
ui->lib1361->setMaximumHeight( m7traild3 );
ui->lib1361->setMaxLength(3);
ui->lib1361->setFrame(globalFrame);

ui->lib1362->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "136   ") );
connect( ui->lib1362, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1362, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1362->installEventFilter(this);
ui->lib1362->setMaximumWidth( m26trail);
ui->lib1362->setMinimumWidth( m25trail);
ui->lib1362->setMaximumHeight( m7traild3 );
ui->lib1362->setMaxLength(24);
ui->lib1362->setFrame(globalFrame);

ui->lib1363->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "136   ") );
connect( ui->lib1363, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1363, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1363->installEventFilter(this);
ui->lib1363->setAlignment(Qt::AlignCenter);
ui->lib1363->setMaximumWidth( m12trail);
ui->lib1363->setMinimumWidth( m6trail);
ui->lib1363->setMaximumHeight( m7traild3 );
ui->lib1363->setMaxLength(11);
ui->lib1363->setFrame(globalFrame);

ui->lib1364->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "136   ") );
connect( ui->lib1364, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1364, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1364->installEventFilter(this);
ui->lib1364->setAlignment(Qt::AlignCenter);
ui->lib1364->setMaximumWidth( m12trail);
ui->lib1364->setMinimumWidth( m6trail);
ui->lib1364->setMaximumHeight( m7traild3 );
ui->lib1364->setMaxLength(11);
ui->lib1364->setFrame(globalFrame);

ui->pushButtonEst136->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "136   ") );
ui->pushButtonEst136->setMaximumWidth( m7traild3 );
ui->pushButtonEst136->setMaximumHeight( m7traild3 );
ui->pushButtonLib136->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "136   ") );
ui->pushButtonLib136->setMaximumWidth( m7traild3 );
ui->pushButtonLib136->setMaximumHeight( m7traild3 );

ui->est1361->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "136   ") );
connect( ui->est1361, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1361, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1361->installEventFilter(this);
ui->est1361->setMaximumWidth( m6trail);
ui->est1361->setMinimumWidth( m6trail);
ui->est1361->setMaximumHeight( m7traild3 );
ui->est1361->setMaxLength(3);
ui->est1361->setFrame(globalFrame);

ui->est1362->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "136   ") );
connect( ui->est1362, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1362, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1362->installEventFilter(this);
ui->est1362->setMaximumWidth( m26trail);
ui->est1362->setMinimumWidth( m25trail);
ui->est1362->setMaximumHeight( m7traild3 );
ui->est1362->setMaxLength(24);
ui->est1362->setFrame(globalFrame);

ui->est1363->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "136   ") );
connect( ui->est1363, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1363, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1363->installEventFilter(this);
ui->est1363->setAlignment(Qt::AlignCenter);
ui->est1363->setMaximumWidth( m11trail);
ui->est1363->setMinimumWidth( m6trail);
ui->est1363->setMaximumHeight( m7traild3 );
ui->est1363->setMaxLength(8);
ui->est1363->setFrame(globalFrame);

ui->est1364->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "136   ") );
connect( ui->est1364, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1364, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1364->installEventFilter(this);
ui->est1364->setAlignment(Qt::AlignCenter);
ui->est1364->setMaximumWidth( m12trail);
ui->est1364->setMinimumWidth( m6trail);
ui->est1364->setMaximumHeight( m7traild3 );
ui->est1364->setMaxLength(11);
ui->est1364->setFrame(globalFrame);

ui->est1365->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "136   ") );
connect( ui->est1365, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1365, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1365->installEventFilter(this);
ui->est1365->setAlignment(Qt::AlignCenter);
ui->est1365->setMaximumWidth( m12trail);
ui->est1365->setMinimumWidth( m6trail);
ui->est1365->setMaximumHeight( m7traild3 );
ui->est1365->setMaxLength(11);
ui->est1365->setFrame(globalFrame);

ui->est1366->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "136   ") );
ui->est1366->setReadOnly(true);
ui->est1366->setAlignment(Qt::AlignRight);
ui->est1366->setMaximumWidth( m14trail);
ui->est1366->setMinimumWidth( m9trail);
ui->est1366->setMaximumHeight( m7traild3 );
ui->est1366->setMaxLength(15);
ui->est1366->setFrame(globalFrame);

ui->est1367->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "136   ") );
ui->est1367->setReadOnly(true);
ui->est1367->setAlignment(Qt::AlignRight);
ui->est1367->setMaximumWidth( m14trail);
ui->est1367->setMinimumWidth( m9trail);
ui->est1367->setMaximumHeight( m7traild3 );
ui->est1367->setMaxLength(15);
ui->est1367->setFrame(globalFrame);

ui->lib1371->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "137   ") );
connect( ui->lib1371, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1371, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib137, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst137, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1371->installEventFilter(this);
ui->lib1371->setMaximumWidth( m6trail);
ui->lib1371->setMinimumWidth( m6trail);
ui->lib1371->setMaximumHeight( m7traild3 );
ui->lib1371->setMaxLength(3);
ui->lib1371->setFrame(globalFrame);

ui->lib1372->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "137   ") );
connect( ui->lib1372, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1372, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1372->installEventFilter(this);
ui->lib1372->setMaximumWidth( m26trail);
ui->lib1372->setMinimumWidth( m25trail);
ui->lib1372->setMaximumHeight( m7traild3 );
ui->lib1372->setMaxLength(24);
ui->lib1372->setFrame(globalFrame);

ui->lib1373->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "137   ") );
connect( ui->lib1373, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1373, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1373->installEventFilter(this);
ui->lib1373->setAlignment(Qt::AlignCenter);
ui->lib1373->setMaximumWidth( m12trail);
ui->lib1373->setMinimumWidth( m6trail);
ui->lib1373->setMaximumHeight( m7traild3 );
ui->lib1373->setMaxLength(11);
ui->lib1373->setFrame(globalFrame);

ui->lib1374->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "137   ") );
connect( ui->lib1374, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1374, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1374->installEventFilter(this);
ui->lib1374->setAlignment(Qt::AlignCenter);
ui->lib1374->setMaximumWidth( m12trail);
ui->lib1374->setMinimumWidth( m6trail);
ui->lib1374->setMaximumHeight( m7traild3 );
ui->lib1374->setMaxLength(11);
ui->lib1374->setFrame(globalFrame);

ui->pushButtonEst137->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "137   ") );
ui->pushButtonEst137->setMaximumWidth( m7traild3 );
ui->pushButtonEst137->setMaximumHeight( m7traild3 );
ui->pushButtonLib137->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "137   ") );
ui->pushButtonLib137->setMaximumWidth( m7traild3 );
ui->pushButtonLib137->setMaximumHeight( m7traild3 );

ui->est1371->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "137   ") );
connect( ui->est1371, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1371, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1371->installEventFilter(this);
ui->est1371->setMaximumWidth( m6trail);
ui->est1371->setMinimumWidth( m6trail);
ui->est1371->setMaximumHeight( m7traild3 );
ui->est1371->setMaxLength(3);
ui->est1371->setFrame(globalFrame);

ui->est1372->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "137   ") );
connect( ui->est1372, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1372, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1372->installEventFilter(this);
ui->est1372->setMaximumWidth( m26trail);
ui->est1372->setMinimumWidth( m25trail);
ui->est1372->setMaximumHeight( m7traild3 );
ui->est1372->setMaxLength(24);
ui->est1372->setFrame(globalFrame);

ui->est1373->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "137   ") );
connect( ui->est1373, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1373, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1373->installEventFilter(this);
ui->est1373->setAlignment(Qt::AlignCenter);
ui->est1373->setMaximumWidth( m11trail);
ui->est1373->setMinimumWidth( m6trail);
ui->est1373->setMaximumHeight( m7traild3 );
ui->est1373->setMaxLength(8);
ui->est1373->setFrame(globalFrame);

ui->est1374->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "137   ") );
connect( ui->est1374, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1374, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1374->installEventFilter(this);
ui->est1374->setAlignment(Qt::AlignCenter);
ui->est1374->setMaximumWidth( m12trail);
ui->est1374->setMinimumWidth( m6trail);
ui->est1374->setMaximumHeight( m7traild3 );
ui->est1374->setMaxLength(11);
ui->est1374->setFrame(globalFrame);

ui->est1375->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "137   ") );
connect( ui->est1375, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1375, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1375->installEventFilter(this);
ui->est1375->setAlignment(Qt::AlignCenter);
ui->est1375->setMaximumWidth( m12trail);
ui->est1375->setMinimumWidth( m6trail);
ui->est1375->setMaximumHeight( m7traild3 );
ui->est1375->setMaxLength(11);
ui->est1375->setFrame(globalFrame);

ui->est1376->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "137   ") );
ui->est1376->setReadOnly(true);
ui->est1376->setAlignment(Qt::AlignRight);
ui->est1376->setMaximumWidth( m14trail);
ui->est1376->setMinimumWidth( m9trail);
ui->est1376->setMaximumHeight( m7traild3 );
ui->est1376->setMaxLength(15);
ui->est1376->setFrame(globalFrame);

ui->est1377->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "137   ") );
ui->est1377->setReadOnly(true);
ui->est1377->setAlignment(Qt::AlignRight);
ui->est1377->setMaximumWidth( m14trail);
ui->est1377->setMinimumWidth( m9trail);
ui->est1377->setMaximumHeight( m7traild3 );
ui->est1377->setMaxLength(15);
ui->est1377->setFrame(globalFrame);

ui->lib1381->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "138   ") );
connect( ui->lib1381, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1381, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib138, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst138, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1381->installEventFilter(this);
ui->lib1381->setMaximumWidth( m6trail);
ui->lib1381->setMinimumWidth( m6trail);
ui->lib1381->setMaximumHeight( m7traild3 );
ui->lib1381->setMaxLength(3);
ui->lib1381->setFrame(globalFrame);

ui->lib1382->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "138   ") );
connect( ui->lib1382, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1382, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1382->installEventFilter(this);
ui->lib1382->setMaximumWidth( m26trail);
ui->lib1382->setMinimumWidth( m25trail);
ui->lib1382->setMaximumHeight( m7traild3 );
ui->lib1382->setMaxLength(24);
ui->lib1382->setFrame(globalFrame);

ui->lib1383->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "138   ") );
connect( ui->lib1383, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1383, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1383->installEventFilter(this);
ui->lib1383->setAlignment(Qt::AlignCenter);
ui->lib1383->setMaximumWidth( m12trail);
ui->lib1383->setMinimumWidth( m6trail);
ui->lib1383->setMaximumHeight( m7traild3 );
ui->lib1383->setMaxLength(11);
ui->lib1383->setFrame(globalFrame);

ui->lib1384->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "138   ") );
connect( ui->lib1384, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1384, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1384->installEventFilter(this);
ui->lib1384->setAlignment(Qt::AlignCenter);
ui->lib1384->setMaximumWidth( m12trail);
ui->lib1384->setMinimumWidth( m6trail);
ui->lib1384->setMaximumHeight( m7traild3 );
ui->lib1384->setMaxLength(11);
ui->lib1384->setFrame(globalFrame);

ui->pushButtonEst138->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "138   ") );
ui->pushButtonEst138->setMaximumWidth( m7traild3 );
ui->pushButtonEst138->setMaximumHeight( m7traild3 );
ui->pushButtonLib138->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "138   ") );
ui->pushButtonLib138->setMaximumWidth( m7traild3 );
ui->pushButtonLib138->setMaximumHeight( m7traild3 );

ui->est1381->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "138   ") );
connect( ui->est1381, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1381, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1381->installEventFilter(this);
ui->est1381->setMaximumWidth( m6trail);
ui->est1381->setMinimumWidth( m6trail);
ui->est1381->setMaximumHeight( m7traild3 );
ui->est1381->setMaxLength(3);
ui->est1381->setFrame(globalFrame);

ui->est1382->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "138   ") );
connect( ui->est1382, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1382, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1382->installEventFilter(this);
ui->est1382->setMaximumWidth( m26trail);
ui->est1382->setMinimumWidth( m25trail);
ui->est1382->setMaximumHeight( m7traild3 );
ui->est1382->setMaxLength(24);
ui->est1382->setFrame(globalFrame);

ui->est1383->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "138   ") );
connect( ui->est1383, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1383, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1383->installEventFilter(this);
ui->est1383->setAlignment(Qt::AlignCenter);
ui->est1383->setMaximumWidth( m11trail);
ui->est1383->setMinimumWidth( m6trail);
ui->est1383->setMaximumHeight( m7traild3 );
ui->est1383->setMaxLength(8);
ui->est1383->setFrame(globalFrame);

ui->est1384->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "138   ") );
connect( ui->est1384, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1384, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1384->installEventFilter(this);
ui->est1384->setAlignment(Qt::AlignCenter);
ui->est1384->setMaximumWidth( m12trail);
ui->est1384->setMinimumWidth( m6trail);
ui->est1384->setMaximumHeight( m7traild3 );
ui->est1384->setMaxLength(11);
ui->est1384->setFrame(globalFrame);

ui->est1385->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "138   ") );
connect( ui->est1385, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1385, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1385->installEventFilter(this);
ui->est1385->setAlignment(Qt::AlignCenter);
ui->est1385->setMaximumWidth( m12trail);
ui->est1385->setMinimumWidth( m6trail);
ui->est1385->setMaximumHeight( m7traild3 );
ui->est1385->setMaxLength(11);
ui->est1385->setFrame(globalFrame);

ui->est1386->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "138   ") );
ui->est1386->setReadOnly(true);
ui->est1386->setAlignment(Qt::AlignRight);
ui->est1386->setMaximumWidth( m14trail);
ui->est1386->setMinimumWidth( m9trail);
ui->est1386->setMaximumHeight( m7traild3 );
ui->est1386->setMaxLength(15);
ui->est1386->setFrame(globalFrame);

ui->est1387->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "138   ") );
ui->est1387->setReadOnly(true);
ui->est1387->setAlignment(Qt::AlignRight);
ui->est1387->setMaximumWidth( m14trail);
ui->est1387->setMinimumWidth( m9trail);
ui->est1387->setMaximumHeight( m7traild3 );
ui->est1387->setMaxLength(15);
ui->est1387->setFrame(globalFrame);

ui->lib1391->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "139   ") );
connect( ui->lib1391, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1391, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib139, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst139, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1391->installEventFilter(this);
ui->lib1391->setMaximumWidth( m6trail);
ui->lib1391->setMinimumWidth( m6trail);
ui->lib1391->setMaximumHeight( m7traild3 );
ui->lib1391->setMaxLength(3);
ui->lib1391->setFrame(globalFrame);

ui->lib1392->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "139   ") );
connect( ui->lib1392, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1392, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1392->installEventFilter(this);
ui->lib1392->setMaximumWidth( m26trail);
ui->lib1392->setMinimumWidth( m25trail);
ui->lib1392->setMaximumHeight( m7traild3 );
ui->lib1392->setMaxLength(24);
ui->lib1392->setFrame(globalFrame);

ui->lib1393->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "139   ") );
connect( ui->lib1393, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1393, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1393->installEventFilter(this);
ui->lib1393->setAlignment(Qt::AlignCenter);
ui->lib1393->setMaximumWidth( m12trail);
ui->lib1393->setMinimumWidth( m6trail);
ui->lib1393->setMaximumHeight( m7traild3 );
ui->lib1393->setMaxLength(11);
ui->lib1393->setFrame(globalFrame);

ui->lib1394->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "139   ") );
connect( ui->lib1394, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1394, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1394->installEventFilter(this);
ui->lib1394->setAlignment(Qt::AlignCenter);
ui->lib1394->setMaximumWidth( m12trail);
ui->lib1394->setMinimumWidth( m6trail);
ui->lib1394->setMaximumHeight( m7traild3 );
ui->lib1394->setMaxLength(11);
ui->lib1394->setFrame(globalFrame);

ui->pushButtonEst139->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "139   ") );
ui->pushButtonEst139->setMaximumWidth( m7traild3 );
ui->pushButtonEst139->setMaximumHeight( m7traild3 );
ui->pushButtonLib139->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "139   ") );
ui->pushButtonLib139->setMaximumWidth( m7traild3 );
ui->pushButtonLib139->setMaximumHeight( m7traild3 );

ui->est1391->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "139   ") );
connect( ui->est1391, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1391, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1391->installEventFilter(this);
ui->est1391->setMaximumWidth( m6trail);
ui->est1391->setMinimumWidth( m6trail);
ui->est1391->setMaximumHeight( m7traild3 );
ui->est1391->setMaxLength(3);
ui->est1391->setFrame(globalFrame);

ui->est1392->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "139   ") );
connect( ui->est1392, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1392, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1392->installEventFilter(this);
ui->est1392->setMaximumWidth( m26trail);
ui->est1392->setMinimumWidth( m25trail);
ui->est1392->setMaximumHeight( m7traild3 );
ui->est1392->setMaxLength(24);
ui->est1392->setFrame(globalFrame);

ui->est1393->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "139   ") );
connect( ui->est1393, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1393, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1393->installEventFilter(this);
ui->est1393->setAlignment(Qt::AlignCenter);
ui->est1393->setMaximumWidth( m11trail);
ui->est1393->setMinimumWidth( m6trail);
ui->est1393->setMaximumHeight( m7traild3 );
ui->est1393->setMaxLength(8);
ui->est1393->setFrame(globalFrame);

ui->est1394->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "139   ") );
connect( ui->est1394, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1394, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1394->installEventFilter(this);
ui->est1394->setAlignment(Qt::AlignCenter);
ui->est1394->setMaximumWidth( m12trail);
ui->est1394->setMinimumWidth( m6trail);
ui->est1394->setMaximumHeight( m7traild3 );
ui->est1394->setMaxLength(11);
ui->est1394->setFrame(globalFrame);

ui->est1395->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "139   ") );
connect( ui->est1395, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1395, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1395->installEventFilter(this);
ui->est1395->setAlignment(Qt::AlignCenter);
ui->est1395->setMaximumWidth( m12trail);
ui->est1395->setMinimumWidth( m6trail);
ui->est1395->setMaximumHeight( m7traild3 );
ui->est1395->setMaxLength(11);
ui->est1395->setFrame(globalFrame);

ui->est1396->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "139   ") );
ui->est1396->setReadOnly(true);
ui->est1396->setAlignment(Qt::AlignRight);
ui->est1396->setMaximumWidth( m14trail);
ui->est1396->setMinimumWidth( m9trail);
ui->est1396->setMaximumHeight( m7traild3 );
ui->est1396->setMaxLength(15);
ui->est1396->setFrame(globalFrame);

ui->est1397->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "139   ") );
ui->est1397->setReadOnly(true);
ui->est1397->setAlignment(Qt::AlignRight);
ui->est1397->setMaximumWidth( m14trail);
ui->est1397->setMinimumWidth( m9trail);
ui->est1397->setMaximumHeight( m7traild3 );
ui->est1397->setMaxLength(15);
ui->est1397->setFrame(globalFrame);

ui->lib1401->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "140   ") );
connect( ui->lib1401, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1401, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib140, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst140, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1401->installEventFilter(this);
ui->lib1401->setMaximumWidth( m6trail);
ui->lib1401->setMinimumWidth( m6trail);
ui->lib1401->setMaximumHeight( m7traild3 );
ui->lib1401->setMaxLength(3);
ui->lib1401->setFrame(globalFrame);

ui->lib1402->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "140   ") );
connect( ui->lib1402, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1402, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1402->installEventFilter(this);
ui->lib1402->setMaximumWidth( m26trail);
ui->lib1402->setMinimumWidth( m25trail);
ui->lib1402->setMaximumHeight( m7traild3 );
ui->lib1402->setMaxLength(24);
ui->lib1402->setFrame(globalFrame);

ui->lib1403->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "140   ") );
connect( ui->lib1403, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1403, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1403->installEventFilter(this);
ui->lib1403->setAlignment(Qt::AlignCenter);
ui->lib1403->setMaximumWidth( m12trail);
ui->lib1403->setMinimumWidth( m6trail);
ui->lib1403->setMaximumHeight( m7traild3 );
ui->lib1403->setMaxLength(11);
ui->lib1403->setFrame(globalFrame);

ui->lib1404->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "140   ") );
connect( ui->lib1404, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1404, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1404->installEventFilter(this);
ui->lib1404->setAlignment(Qt::AlignCenter);
ui->lib1404->setMaximumWidth( m12trail);
ui->lib1404->setMinimumWidth( m6trail);
ui->lib1404->setMaximumHeight( m7traild3 );
ui->lib1404->setMaxLength(11);
ui->lib1404->setFrame(globalFrame);

ui->pushButtonEst140->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "140   ") );
ui->pushButtonEst140->setMaximumWidth( m7traild3 );
ui->pushButtonEst140->setMaximumHeight( m7traild3 );
ui->pushButtonLib140->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "140   ") );
ui->pushButtonLib140->setMaximumWidth( m7traild3 );
ui->pushButtonLib140->setMaximumHeight( m7traild3 );

ui->est1401->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "140   ") );
connect( ui->est1401, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1401, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1401->installEventFilter(this);
ui->est1401->setMaximumWidth( m6trail);
ui->est1401->setMinimumWidth( m6trail);
ui->est1401->setMaximumHeight( m7traild3 );
ui->est1401->setMaxLength(3);
ui->est1401->setFrame(globalFrame);

ui->est1402->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "140   ") );
connect( ui->est1402, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1402, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1402->installEventFilter(this);
ui->est1402->setMaximumWidth( m26trail);
ui->est1402->setMinimumWidth( m25trail);
ui->est1402->setMaximumHeight( m7traild3 );
ui->est1402->setMaxLength(24);
ui->est1402->setFrame(globalFrame);

ui->est1403->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "140   ") );
connect( ui->est1403, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1403, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1403->installEventFilter(this);
ui->est1403->setAlignment(Qt::AlignCenter);
ui->est1403->setMaximumWidth( m11trail);
ui->est1403->setMinimumWidth( m6trail);
ui->est1403->setMaximumHeight( m7traild3 );
ui->est1403->setMaxLength(8);
ui->est1403->setFrame(globalFrame);

ui->est1404->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "140   ") );
connect( ui->est1404, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1404, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1404->installEventFilter(this);
ui->est1404->setAlignment(Qt::AlignCenter);
ui->est1404->setMaximumWidth( m12trail);
ui->est1404->setMinimumWidth( m6trail);
ui->est1404->setMaximumHeight( m7traild3 );
ui->est1404->setMaxLength(11);
ui->est1404->setFrame(globalFrame);

ui->est1405->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "140   ") );
connect( ui->est1405, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1405, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1405->installEventFilter(this);
ui->est1405->setAlignment(Qt::AlignCenter);
ui->est1405->setMaximumWidth( m12trail);
ui->est1405->setMinimumWidth( m6trail);
ui->est1405->setMaximumHeight( m7traild3 );
ui->est1405->setMaxLength(11);
ui->est1405->setFrame(globalFrame);

ui->est1406->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "140   ") );
ui->est1406->setReadOnly(true);
ui->est1406->setAlignment(Qt::AlignRight);
ui->est1406->setMaximumWidth( m14trail);
ui->est1406->setMinimumWidth( m9trail);
ui->est1406->setMaximumHeight( m7traild3 );
ui->est1406->setMaxLength(15);
ui->est1406->setFrame(globalFrame);

ui->est1407->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "140   ") );
ui->est1407->setReadOnly(true);
ui->est1407->setAlignment(Qt::AlignRight);
ui->est1407->setMaximumWidth( m14trail);
ui->est1407->setMinimumWidth( m9trail);
ui->est1407->setMaximumHeight( m7traild3 );
ui->est1407->setMaxLength(15);
ui->est1407->setFrame(globalFrame);

ui->lib1411->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "141   ") );
connect( ui->lib1411, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1411, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib141, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst141, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1411->installEventFilter(this);
ui->lib1411->setMaximumWidth( m6trail);
ui->lib1411->setMinimumWidth( m6trail);
ui->lib1411->setMaximumHeight( m7traild3 );
ui->lib1411->setMaxLength(3);
ui->lib1411->setFrame(globalFrame);

ui->lib1412->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "141   ") );
connect( ui->lib1412, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1412, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1412->installEventFilter(this);
ui->lib1412->setMaximumWidth( m26trail);
ui->lib1412->setMinimumWidth( m25trail);
ui->lib1412->setMaximumHeight( m7traild3 );
ui->lib1412->setMaxLength(24);
ui->lib1412->setFrame(globalFrame);

ui->lib1413->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "141   ") );
connect( ui->lib1413, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1413, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1413->installEventFilter(this);
ui->lib1413->setAlignment(Qt::AlignCenter);
ui->lib1413->setMaximumWidth( m12trail);
ui->lib1413->setMinimumWidth( m6trail);
ui->lib1413->setMaximumHeight( m7traild3 );
ui->lib1413->setMaxLength(11);
ui->lib1413->setFrame(globalFrame);

ui->lib1414->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "141   ") );
connect( ui->lib1414, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1414, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1414->installEventFilter(this);
ui->lib1414->setAlignment(Qt::AlignCenter);
ui->lib1414->setMaximumWidth( m12trail);
ui->lib1414->setMinimumWidth( m6trail);
ui->lib1414->setMaximumHeight( m7traild3 );
ui->lib1414->setMaxLength(11);
ui->lib1414->setFrame(globalFrame);

ui->pushButtonEst141->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "141   ") );
ui->pushButtonEst141->setMaximumWidth( m7traild3 );
ui->pushButtonEst141->setMaximumHeight( m7traild3 );
ui->pushButtonLib141->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "141   ") );
ui->pushButtonLib141->setMaximumWidth( m7traild3 );
ui->pushButtonLib141->setMaximumHeight( m7traild3 );

ui->est1411->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "141   ") );
connect( ui->est1411, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1411, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1411->installEventFilter(this);
ui->est1411->setMaximumWidth( m6trail);
ui->est1411->setMinimumWidth( m6trail);
ui->est1411->setMaximumHeight( m7traild3 );
ui->est1411->setMaxLength(3);
ui->est1411->setFrame(globalFrame);

ui->est1412->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "141   ") );
connect( ui->est1412, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1412, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1412->installEventFilter(this);
ui->est1412->setMaximumWidth( m26trail);
ui->est1412->setMinimumWidth( m25trail);
ui->est1412->setMaximumHeight( m7traild3 );
ui->est1412->setMaxLength(24);
ui->est1412->setFrame(globalFrame);

ui->est1413->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "141   ") );
connect( ui->est1413, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1413, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1413->installEventFilter(this);
ui->est1413->setAlignment(Qt::AlignCenter);
ui->est1413->setMaximumWidth( m11trail);
ui->est1413->setMinimumWidth( m6trail);
ui->est1413->setMaximumHeight( m7traild3 );
ui->est1413->setMaxLength(8);
ui->est1413->setFrame(globalFrame);

ui->est1414->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "141   ") );
connect( ui->est1414, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1414, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1414->installEventFilter(this);
ui->est1414->setAlignment(Qt::AlignCenter);
ui->est1414->setMaximumWidth( m12trail);
ui->est1414->setMinimumWidth( m6trail);
ui->est1414->setMaximumHeight( m7traild3 );
ui->est1414->setMaxLength(11);
ui->est1414->setFrame(globalFrame);

ui->est1415->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "141   ") );
connect( ui->est1415, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1415, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1415->installEventFilter(this);
ui->est1415->setAlignment(Qt::AlignCenter);
ui->est1415->setMaximumWidth( m12trail);
ui->est1415->setMinimumWidth( m6trail);
ui->est1415->setMaximumHeight( m7traild3 );
ui->est1415->setMaxLength(11);
ui->est1415->setFrame(globalFrame);

ui->est1416->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "141   ") );
ui->est1416->setReadOnly(true);
ui->est1416->setAlignment(Qt::AlignRight);
ui->est1416->setMaximumWidth( m14trail);
ui->est1416->setMinimumWidth( m9trail);
ui->est1416->setMaximumHeight( m7traild3 );
ui->est1416->setMaxLength(15);
ui->est1416->setFrame(globalFrame);

ui->est1417->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "141   ") );
ui->est1417->setReadOnly(true);
ui->est1417->setAlignment(Qt::AlignRight);
ui->est1417->setMaximumWidth( m14trail);
ui->est1417->setMinimumWidth( m9trail);
ui->est1417->setMaximumHeight( m7traild3 );
ui->est1417->setMaxLength(15);
ui->est1417->setFrame(globalFrame);

ui->lib1421->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "142   ") );
connect( ui->lib1421, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1421, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib142, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst142, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1421->installEventFilter(this);
ui->lib1421->setMaximumWidth( m6trail);
ui->lib1421->setMinimumWidth( m6trail);
ui->lib1421->setMaximumHeight( m7traild3 );
ui->lib1421->setMaxLength(3);
ui->lib1421->setFrame(globalFrame);

ui->lib1422->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "142   ") );
connect( ui->lib1422, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1422, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1422->installEventFilter(this);
ui->lib1422->setMaximumWidth( m26trail);
ui->lib1422->setMinimumWidth( m25trail);
ui->lib1422->setMaximumHeight( m7traild3 );
ui->lib1422->setMaxLength(24);
ui->lib1422->setFrame(globalFrame);

ui->lib1423->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "142   ") );
connect( ui->lib1423, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1423, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1423->installEventFilter(this);
ui->lib1423->setAlignment(Qt::AlignCenter);
ui->lib1423->setMaximumWidth( m12trail);
ui->lib1423->setMinimumWidth( m6trail);
ui->lib1423->setMaximumHeight( m7traild3 );
ui->lib1423->setMaxLength(11);
ui->lib1423->setFrame(globalFrame);

ui->lib1424->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "142   ") );
connect( ui->lib1424, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1424, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1424->installEventFilter(this);
ui->lib1424->setAlignment(Qt::AlignCenter);
ui->lib1424->setMaximumWidth( m12trail);
ui->lib1424->setMinimumWidth( m6trail);
ui->lib1424->setMaximumHeight( m7traild3 );
ui->lib1424->setMaxLength(11);
ui->lib1424->setFrame(globalFrame);

ui->pushButtonEst142->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "142   ") );
ui->pushButtonEst142->setMaximumWidth( m7traild3 );
ui->pushButtonEst142->setMaximumHeight( m7traild3 );
ui->pushButtonLib142->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "142   ") );
ui->pushButtonLib142->setMaximumWidth( m7traild3 );
ui->pushButtonLib142->setMaximumHeight( m7traild3 );

ui->est1421->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "142   ") );
connect( ui->est1421, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1421, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1421->installEventFilter(this);
ui->est1421->setMaximumWidth( m6trail);
ui->est1421->setMinimumWidth( m6trail);
ui->est1421->setMaximumHeight( m7traild3 );
ui->est1421->setMaxLength(3);
ui->est1421->setFrame(globalFrame);

ui->est1422->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "142   ") );
connect( ui->est1422, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1422, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1422->installEventFilter(this);
ui->est1422->setMaximumWidth( m26trail);
ui->est1422->setMinimumWidth( m25trail);
ui->est1422->setMaximumHeight( m7traild3 );
ui->est1422->setMaxLength(24);
ui->est1422->setFrame(globalFrame);

ui->est1423->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "142   ") );
connect( ui->est1423, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1423, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1423->installEventFilter(this);
ui->est1423->setAlignment(Qt::AlignCenter);
ui->est1423->setMaximumWidth( m11trail);
ui->est1423->setMinimumWidth( m6trail);
ui->est1423->setMaximumHeight( m7traild3 );
ui->est1423->setMaxLength(8);
ui->est1423->setFrame(globalFrame);

ui->est1424->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "142   ") );
connect( ui->est1424, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1424, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1424->installEventFilter(this);
ui->est1424->setAlignment(Qt::AlignCenter);
ui->est1424->setMaximumWidth( m12trail);
ui->est1424->setMinimumWidth( m6trail);
ui->est1424->setMaximumHeight( m7traild3 );
ui->est1424->setMaxLength(11);
ui->est1424->setFrame(globalFrame);

ui->est1425->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "142   ") );
connect( ui->est1425, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1425, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1425->installEventFilter(this);
ui->est1425->setAlignment(Qt::AlignCenter);
ui->est1425->setMaximumWidth( m12trail);
ui->est1425->setMinimumWidth( m6trail);
ui->est1425->setMaximumHeight( m7traild3 );
ui->est1425->setMaxLength(11);
ui->est1425->setFrame(globalFrame);

ui->est1426->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "142   ") );
ui->est1426->setReadOnly(true);
ui->est1426->setAlignment(Qt::AlignRight);
ui->est1426->setMaximumWidth( m14trail);
ui->est1426->setMinimumWidth( m9trail);
ui->est1426->setMaximumHeight( m7traild3 );
ui->est1426->setMaxLength(15);
ui->est1426->setFrame(globalFrame);

ui->est1427->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "142   ") );
ui->est1427->setReadOnly(true);
ui->est1427->setAlignment(Qt::AlignRight);
ui->est1427->setMaximumWidth( m14trail);
ui->est1427->setMinimumWidth( m9trail);
ui->est1427->setMaximumHeight( m7traild3 );
ui->est1427->setMaxLength(15);
ui->est1427->setFrame(globalFrame);

ui->lib1431->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "143   ") );
connect( ui->lib1431, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1431, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib143, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst143, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1431->installEventFilter(this);
ui->lib1431->setMaximumWidth( m6trail);
ui->lib1431->setMinimumWidth( m6trail);
ui->lib1431->setMaximumHeight( m7traild3 );
ui->lib1431->setMaxLength(3);
ui->lib1431->setFrame(globalFrame);

ui->lib1432->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "143   ") );
connect( ui->lib1432, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1432, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1432->installEventFilter(this);
ui->lib1432->setMaximumWidth( m26trail);
ui->lib1432->setMinimumWidth( m25trail);
ui->lib1432->setMaximumHeight( m7traild3 );
ui->lib1432->setMaxLength(24);
ui->lib1432->setFrame(globalFrame);

ui->lib1433->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "143   ") );
connect( ui->lib1433, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1433, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1433->installEventFilter(this);
ui->lib1433->setAlignment(Qt::AlignCenter);
ui->lib1433->setMaximumWidth( m12trail);
ui->lib1433->setMinimumWidth( m6trail);
ui->lib1433->setMaximumHeight( m7traild3 );
ui->lib1433->setMaxLength(11);
ui->lib1433->setFrame(globalFrame);

ui->lib1434->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "143   ") );
connect( ui->lib1434, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1434, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1434->installEventFilter(this);
ui->lib1434->setAlignment(Qt::AlignCenter);
ui->lib1434->setMaximumWidth( m12trail);
ui->lib1434->setMinimumWidth( m6trail);
ui->lib1434->setMaximumHeight( m7traild3 );
ui->lib1434->setMaxLength(11);
ui->lib1434->setFrame(globalFrame);

ui->pushButtonEst143->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "143   ") );
ui->pushButtonEst143->setMaximumWidth( m7traild3 );
ui->pushButtonEst143->setMaximumHeight( m7traild3 );
ui->pushButtonLib143->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "143   ") );
ui->pushButtonLib143->setMaximumWidth( m7traild3 );
ui->pushButtonLib143->setMaximumHeight( m7traild3 );

ui->est1431->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "143   ") );
connect( ui->est1431, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1431, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1431->installEventFilter(this);
ui->est1431->setMaximumWidth( m6trail);
ui->est1431->setMinimumWidth( m6trail);
ui->est1431->setMaximumHeight( m7traild3 );
ui->est1431->setMaxLength(3);
ui->est1431->setFrame(globalFrame);

ui->est1432->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "143   ") );
connect( ui->est1432, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1432, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1432->installEventFilter(this);
ui->est1432->setMaximumWidth( m26trail);
ui->est1432->setMinimumWidth( m25trail);
ui->est1432->setMaximumHeight( m7traild3 );
ui->est1432->setMaxLength(24);
ui->est1432->setFrame(globalFrame);

ui->est1433->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "143   ") );
connect( ui->est1433, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1433, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1433->installEventFilter(this);
ui->est1433->setAlignment(Qt::AlignCenter);
ui->est1433->setMaximumWidth( m11trail);
ui->est1433->setMinimumWidth( m6trail);
ui->est1433->setMaximumHeight( m7traild3 );
ui->est1433->setMaxLength(8);
ui->est1433->setFrame(globalFrame);

ui->est1434->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "143   ") );
connect( ui->est1434, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1434, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1434->installEventFilter(this);
ui->est1434->setAlignment(Qt::AlignCenter);
ui->est1434->setMaximumWidth( m12trail);
ui->est1434->setMinimumWidth( m6trail);
ui->est1434->setMaximumHeight( m7traild3 );
ui->est1434->setMaxLength(11);
ui->est1434->setFrame(globalFrame);

ui->est1435->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "143   ") );
connect( ui->est1435, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1435, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1435->installEventFilter(this);
ui->est1435->setAlignment(Qt::AlignCenter);
ui->est1435->setMaximumWidth( m12trail);
ui->est1435->setMinimumWidth( m6trail);
ui->est1435->setMaximumHeight( m7traild3 );
ui->est1435->setMaxLength(11);
ui->est1435->setFrame(globalFrame);

ui->est1436->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "143   ") );
ui->est1436->setReadOnly(true);
ui->est1436->setAlignment(Qt::AlignRight);
ui->est1436->setMaximumWidth( m14trail);
ui->est1436->setMinimumWidth( m9trail);
ui->est1436->setMaximumHeight( m7traild3 );
ui->est1436->setMaxLength(15);
ui->est1436->setFrame(globalFrame);

ui->est1437->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "143   ") );
ui->est1437->setReadOnly(true);
ui->est1437->setAlignment(Qt::AlignRight);
ui->est1437->setMaximumWidth( m14trail);
ui->est1437->setMinimumWidth( m9trail);
ui->est1437->setMaximumHeight( m7traild3 );
ui->est1437->setMaxLength(15);
ui->est1437->setFrame(globalFrame);

ui->lib1441->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "144   ") );
connect( ui->lib1441, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1441, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib144, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst144, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1441->installEventFilter(this);
ui->lib1441->setMaximumWidth( m6trail);
ui->lib1441->setMinimumWidth( m6trail);
ui->lib1441->setMaximumHeight( m7traild3 );
ui->lib1441->setMaxLength(3);
ui->lib1441->setFrame(globalFrame);

ui->lib1442->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "144   ") );
connect( ui->lib1442, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1442, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1442->installEventFilter(this);
ui->lib1442->setMaximumWidth( m26trail);
ui->lib1442->setMinimumWidth( m25trail);
ui->lib1442->setMaximumHeight( m7traild3 );
ui->lib1442->setMaxLength(24);
ui->lib1442->setFrame(globalFrame);

ui->lib1443->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "144   ") );
connect( ui->lib1443, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1443, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1443->installEventFilter(this);
ui->lib1443->setAlignment(Qt::AlignCenter);
ui->lib1443->setMaximumWidth( m12trail);
ui->lib1443->setMinimumWidth( m6trail);
ui->lib1443->setMaximumHeight( m7traild3 );
ui->lib1443->setMaxLength(11);
ui->lib1443->setFrame(globalFrame);

ui->lib1444->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "144   ") );
connect( ui->lib1444, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1444, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1444->installEventFilter(this);
ui->lib1444->setAlignment(Qt::AlignCenter);
ui->lib1444->setMaximumWidth( m12trail);
ui->lib1444->setMinimumWidth( m6trail);
ui->lib1444->setMaximumHeight( m7traild3 );
ui->lib1444->setMaxLength(11);
ui->lib1444->setFrame(globalFrame);

ui->pushButtonEst144->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "144   ") );
ui->pushButtonEst144->setMaximumWidth( m7traild3 );
ui->pushButtonEst144->setMaximumHeight( m7traild3 );
ui->pushButtonLib144->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "144   ") );
ui->pushButtonLib144->setMaximumWidth( m7traild3 );
ui->pushButtonLib144->setMaximumHeight( m7traild3 );

ui->est1441->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "144   ") );
connect( ui->est1441, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1441, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1441->installEventFilter(this);
ui->est1441->setMaximumWidth( m6trail);
ui->est1441->setMinimumWidth( m6trail);
ui->est1441->setMaximumHeight( m7traild3 );
ui->est1441->setMaxLength(3);
ui->est1441->setFrame(globalFrame);

ui->est1442->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "144   ") );
connect( ui->est1442, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1442, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1442->installEventFilter(this);
ui->est1442->setMaximumWidth( m26trail);
ui->est1442->setMinimumWidth( m25trail);
ui->est1442->setMaximumHeight( m7traild3 );
ui->est1442->setMaxLength(24);
ui->est1442->setFrame(globalFrame);

ui->est1443->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "144   ") );
connect( ui->est1443, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1443, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1443->installEventFilter(this);
ui->est1443->setAlignment(Qt::AlignCenter);
ui->est1443->setMaximumWidth( m11trail);
ui->est1443->setMinimumWidth( m6trail);
ui->est1443->setMaximumHeight( m7traild3 );
ui->est1443->setMaxLength(8);
ui->est1443->setFrame(globalFrame);

ui->est1444->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "144   ") );
connect( ui->est1444, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1444, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1444->installEventFilter(this);
ui->est1444->setAlignment(Qt::AlignCenter);
ui->est1444->setMaximumWidth( m12trail);
ui->est1444->setMinimumWidth( m6trail);
ui->est1444->setMaximumHeight( m7traild3 );
ui->est1444->setMaxLength(11);
ui->est1444->setFrame(globalFrame);

ui->est1445->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "144   ") );
connect( ui->est1445, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1445, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1445->installEventFilter(this);
ui->est1445->setAlignment(Qt::AlignCenter);
ui->est1445->setMaximumWidth( m12trail);
ui->est1445->setMinimumWidth( m6trail);
ui->est1445->setMaximumHeight( m7traild3 );
ui->est1445->setMaxLength(11);
ui->est1445->setFrame(globalFrame);

ui->est1446->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "144   ") );
ui->est1446->setReadOnly(true);
ui->est1446->setAlignment(Qt::AlignRight);
ui->est1446->setMaximumWidth( m14trail);
ui->est1446->setMinimumWidth( m9trail);
ui->est1446->setMaximumHeight( m7traild3 );
ui->est1446->setMaxLength(15);
ui->est1446->setFrame(globalFrame);

ui->est1447->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "144   ") );
ui->est1447->setReadOnly(true);
ui->est1447->setAlignment(Qt::AlignRight);
ui->est1447->setMaximumWidth( m14trail);
ui->est1447->setMinimumWidth( m9trail);
ui->est1447->setMaximumHeight( m7traild3 );
ui->est1447->setMaxLength(15);
ui->est1447->setFrame(globalFrame);

ui->lib1451->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "145   ") );
connect( ui->lib1451, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1451, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib145, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst145, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1451->installEventFilter(this);
ui->lib1451->setMaximumWidth( m6trail);
ui->lib1451->setMinimumWidth( m6trail);
ui->lib1451->setMaximumHeight( m7traild3 );
ui->lib1451->setMaxLength(3);
ui->lib1451->setFrame(globalFrame);

ui->lib1452->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "145   ") );
connect( ui->lib1452, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1452, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1452->installEventFilter(this);
ui->lib1452->setMaximumWidth( m26trail);
ui->lib1452->setMinimumWidth( m25trail);
ui->lib1452->setMaximumHeight( m7traild3 );
ui->lib1452->setMaxLength(24);
ui->lib1452->setFrame(globalFrame);

ui->lib1453->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "145   ") );
connect( ui->lib1453, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1453, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1453->installEventFilter(this);
ui->lib1453->setAlignment(Qt::AlignCenter);
ui->lib1453->setMaximumWidth( m12trail);
ui->lib1453->setMinimumWidth( m6trail);
ui->lib1453->setMaximumHeight( m7traild3 );
ui->lib1453->setMaxLength(11);
ui->lib1453->setFrame(globalFrame);

ui->lib1454->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "145   ") );
connect( ui->lib1454, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1454, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1454->installEventFilter(this);
ui->lib1454->setAlignment(Qt::AlignCenter);
ui->lib1454->setMaximumWidth( m12trail);
ui->lib1454->setMinimumWidth( m6trail);
ui->lib1454->setMaximumHeight( m7traild3 );
ui->lib1454->setMaxLength(11);
ui->lib1454->setFrame(globalFrame);

ui->pushButtonEst145->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "145   ") );
ui->pushButtonEst145->setMaximumWidth( m7traild3 );
ui->pushButtonEst145->setMaximumHeight( m7traild3 );
ui->pushButtonLib145->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "145   ") );
ui->pushButtonLib145->setMaximumWidth( m7traild3 );
ui->pushButtonLib145->setMaximumHeight( m7traild3 );

ui->est1451->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "145   ") );
connect( ui->est1451, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1451, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1451->installEventFilter(this);
ui->est1451->setMaximumWidth( m6trail);
ui->est1451->setMinimumWidth( m6trail);
ui->est1451->setMaximumHeight( m7traild3 );
ui->est1451->setMaxLength(3);
ui->est1451->setFrame(globalFrame);

ui->est1452->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "145   ") );
connect( ui->est1452, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1452, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1452->installEventFilter(this);
ui->est1452->setMaximumWidth( m26trail);
ui->est1452->setMinimumWidth( m25trail);
ui->est1452->setMaximumHeight( m7traild3 );
ui->est1452->setMaxLength(24);
ui->est1452->setFrame(globalFrame);

ui->est1453->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "145   ") );
connect( ui->est1453, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1453, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1453->installEventFilter(this);
ui->est1453->setAlignment(Qt::AlignCenter);
ui->est1453->setMaximumWidth( m11trail);
ui->est1453->setMinimumWidth( m6trail);
ui->est1453->setMaximumHeight( m7traild3 );
ui->est1453->setMaxLength(8);
ui->est1453->setFrame(globalFrame);

ui->est1454->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "145   ") );
connect( ui->est1454, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1454, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1454->installEventFilter(this);
ui->est1454->setAlignment(Qt::AlignCenter);
ui->est1454->setMaximumWidth( m12trail);
ui->est1454->setMinimumWidth( m6trail);
ui->est1454->setMaximumHeight( m7traild3 );
ui->est1454->setMaxLength(11);
ui->est1454->setFrame(globalFrame);

ui->est1455->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "145   ") );
connect( ui->est1455, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1455, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1455->installEventFilter(this);
ui->est1455->setAlignment(Qt::AlignCenter);
ui->est1455->setMaximumWidth( m12trail);
ui->est1455->setMinimumWidth( m6trail);
ui->est1455->setMaximumHeight( m7traild3 );
ui->est1455->setMaxLength(11);
ui->est1455->setFrame(globalFrame);

ui->est1456->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "145   ") );
ui->est1456->setReadOnly(true);
ui->est1456->setAlignment(Qt::AlignRight);
ui->est1456->setMaximumWidth( m14trail);
ui->est1456->setMinimumWidth( m9trail);
ui->est1456->setMaximumHeight( m7traild3 );
ui->est1456->setMaxLength(15);
ui->est1456->setFrame(globalFrame);

ui->est1457->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "145   ") );
ui->est1457->setReadOnly(true);
ui->est1457->setAlignment(Qt::AlignRight);
ui->est1457->setMaximumWidth( m14trail);
ui->est1457->setMinimumWidth( m9trail);
ui->est1457->setMaximumHeight( m7traild3 );
ui->est1457->setMaxLength(15);
ui->est1457->setFrame(globalFrame);

ui->lib1461->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "146   ") );
connect( ui->lib1461, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1461, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib146, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst146, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1461->installEventFilter(this);
ui->lib1461->setMaximumWidth( m6trail);
ui->lib1461->setMinimumWidth( m6trail);
ui->lib1461->setMaximumHeight( m7traild3 );
ui->lib1461->setMaxLength(3);
ui->lib1461->setFrame(globalFrame);

ui->lib1462->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "146   ") );
connect( ui->lib1462, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1462, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1462->installEventFilter(this);
ui->lib1462->setMaximumWidth( m26trail);
ui->lib1462->setMinimumWidth( m25trail);
ui->lib1462->setMaximumHeight( m7traild3 );
ui->lib1462->setMaxLength(24);
ui->lib1462->setFrame(globalFrame);

ui->lib1463->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "146   ") );
connect( ui->lib1463, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1463, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1463->installEventFilter(this);
ui->lib1463->setAlignment(Qt::AlignCenter);
ui->lib1463->setMaximumWidth( m12trail);
ui->lib1463->setMinimumWidth( m6trail);
ui->lib1463->setMaximumHeight( m7traild3 );
ui->lib1463->setMaxLength(11);
ui->lib1463->setFrame(globalFrame);

ui->lib1464->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "146   ") );
connect( ui->lib1464, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1464, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1464->installEventFilter(this);
ui->lib1464->setAlignment(Qt::AlignCenter);
ui->lib1464->setMaximumWidth( m12trail);
ui->lib1464->setMinimumWidth( m6trail);
ui->lib1464->setMaximumHeight( m7traild3 );
ui->lib1464->setMaxLength(11);
ui->lib1464->setFrame(globalFrame);

ui->pushButtonEst146->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "146   ") );
ui->pushButtonEst146->setMaximumWidth( m7traild3 );
ui->pushButtonEst146->setMaximumHeight( m7traild3 );
ui->pushButtonLib146->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "146   ") );
ui->pushButtonLib146->setMaximumWidth( m7traild3 );
ui->pushButtonLib146->setMaximumHeight( m7traild3 );

ui->est1461->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "146   ") );
connect( ui->est1461, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1461, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1461->installEventFilter(this);
ui->est1461->setMaximumWidth( m6trail);
ui->est1461->setMinimumWidth( m6trail);
ui->est1461->setMaximumHeight( m7traild3 );
ui->est1461->setMaxLength(3);
ui->est1461->setFrame(globalFrame);

ui->est1462->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "146   ") );
connect( ui->est1462, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1462, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1462->installEventFilter(this);
ui->est1462->setMaximumWidth( m26trail);
ui->est1462->setMinimumWidth( m25trail);
ui->est1462->setMaximumHeight( m7traild3 );
ui->est1462->setMaxLength(24);
ui->est1462->setFrame(globalFrame);

ui->est1463->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "146   ") );
connect( ui->est1463, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1463, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1463->installEventFilter(this);
ui->est1463->setAlignment(Qt::AlignCenter);
ui->est1463->setMaximumWidth( m11trail);
ui->est1463->setMinimumWidth( m6trail);
ui->est1463->setMaximumHeight( m7traild3 );
ui->est1463->setMaxLength(8);
ui->est1463->setFrame(globalFrame);

ui->est1464->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "146   ") );
connect( ui->est1464, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1464, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1464->installEventFilter(this);
ui->est1464->setAlignment(Qt::AlignCenter);
ui->est1464->setMaximumWidth( m12trail);
ui->est1464->setMinimumWidth( m6trail);
ui->est1464->setMaximumHeight( m7traild3 );
ui->est1464->setMaxLength(11);
ui->est1464->setFrame(globalFrame);

ui->est1465->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "146   ") );
connect( ui->est1465, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1465, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1465->installEventFilter(this);
ui->est1465->setAlignment(Qt::AlignCenter);
ui->est1465->setMaximumWidth( m12trail);
ui->est1465->setMinimumWidth( m6trail);
ui->est1465->setMaximumHeight( m7traild3 );
ui->est1465->setMaxLength(11);
ui->est1465->setFrame(globalFrame);

ui->est1466->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "146   ") );
ui->est1466->setReadOnly(true);
ui->est1466->setAlignment(Qt::AlignRight);
ui->est1466->setMaximumWidth( m14trail);
ui->est1466->setMinimumWidth( m9trail);
ui->est1466->setMaximumHeight( m7traild3 );
ui->est1466->setMaxLength(15);
ui->est1466->setFrame(globalFrame);

ui->est1467->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "146   ") );
ui->est1467->setReadOnly(true);
ui->est1467->setAlignment(Qt::AlignRight);
ui->est1467->setMaximumWidth( m14trail);
ui->est1467->setMinimumWidth( m9trail);
ui->est1467->setMaximumHeight( m7traild3 );
ui->est1467->setMaxLength(15);
ui->est1467->setFrame(globalFrame);

ui->lib1471->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "147   ") );
connect( ui->lib1471, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1471, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib147, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst147, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1471->installEventFilter(this);
ui->lib1471->setMaximumWidth( m6trail);
ui->lib1471->setMinimumWidth( m6trail);
ui->lib1471->setMaximumHeight( m7traild3 );
ui->lib1471->setMaxLength(3);
ui->lib1471->setFrame(globalFrame);

ui->lib1472->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "147   ") );
connect( ui->lib1472, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1472, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1472->installEventFilter(this);
ui->lib1472->setMaximumWidth( m26trail);
ui->lib1472->setMinimumWidth( m25trail);
ui->lib1472->setMaximumHeight( m7traild3 );
ui->lib1472->setMaxLength(24);
ui->lib1472->setFrame(globalFrame);

ui->lib1473->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "147   ") );
connect( ui->lib1473, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1473, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1473->installEventFilter(this);
ui->lib1473->setAlignment(Qt::AlignCenter);
ui->lib1473->setMaximumWidth( m12trail);
ui->lib1473->setMinimumWidth( m6trail);
ui->lib1473->setMaximumHeight( m7traild3 );
ui->lib1473->setMaxLength(11);
ui->lib1473->setFrame(globalFrame);

ui->lib1474->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "147   ") );
connect( ui->lib1474, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1474, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1474->installEventFilter(this);
ui->lib1474->setAlignment(Qt::AlignCenter);
ui->lib1474->setMaximumWidth( m12trail);
ui->lib1474->setMinimumWidth( m6trail);
ui->lib1474->setMaximumHeight( m7traild3 );
ui->lib1474->setMaxLength(11);
ui->lib1474->setFrame(globalFrame);

ui->pushButtonEst147->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "147   ") );
ui->pushButtonEst147->setMaximumWidth( m7traild3 );
ui->pushButtonEst147->setMaximumHeight( m7traild3 );
ui->pushButtonLib147->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "147   ") );
ui->pushButtonLib147->setMaximumWidth( m7traild3 );
ui->pushButtonLib147->setMaximumHeight( m7traild3 );

ui->est1471->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "147   ") );
connect( ui->est1471, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1471, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1471->installEventFilter(this);
ui->est1471->setMaximumWidth( m6trail);
ui->est1471->setMinimumWidth( m6trail);
ui->est1471->setMaximumHeight( m7traild3 );
ui->est1471->setMaxLength(3);
ui->est1471->setFrame(globalFrame);

ui->est1472->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "147   ") );
connect( ui->est1472, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1472, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1472->installEventFilter(this);
ui->est1472->setMaximumWidth( m26trail);
ui->est1472->setMinimumWidth( m25trail);
ui->est1472->setMaximumHeight( m7traild3 );
ui->est1472->setMaxLength(24);
ui->est1472->setFrame(globalFrame);

ui->est1473->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "147   ") );
connect( ui->est1473, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1473, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1473->installEventFilter(this);
ui->est1473->setAlignment(Qt::AlignCenter);
ui->est1473->setMaximumWidth( m11trail);
ui->est1473->setMinimumWidth( m6trail);
ui->est1473->setMaximumHeight( m7traild3 );
ui->est1473->setMaxLength(8);
ui->est1473->setFrame(globalFrame);

ui->est1474->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "147   ") );
connect( ui->est1474, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1474, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1474->installEventFilter(this);
ui->est1474->setAlignment(Qt::AlignCenter);
ui->est1474->setMaximumWidth( m12trail);
ui->est1474->setMinimumWidth( m6trail);
ui->est1474->setMaximumHeight( m7traild3 );
ui->est1474->setMaxLength(11);
ui->est1474->setFrame(globalFrame);

ui->est1475->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "147   ") );
connect( ui->est1475, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1475, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1475->installEventFilter(this);
ui->est1475->setAlignment(Qt::AlignCenter);
ui->est1475->setMaximumWidth( m12trail);
ui->est1475->setMinimumWidth( m6trail);
ui->est1475->setMaximumHeight( m7traild3 );
ui->est1475->setMaxLength(11);
ui->est1475->setFrame(globalFrame);

ui->est1476->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "147   ") );
ui->est1476->setReadOnly(true);
ui->est1476->setAlignment(Qt::AlignRight);
ui->est1476->setMaximumWidth( m14trail);
ui->est1476->setMinimumWidth( m9trail);
ui->est1476->setMaximumHeight( m7traild3 );
ui->est1476->setMaxLength(15);
ui->est1476->setFrame(globalFrame);

ui->est1477->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "147   ") );
ui->est1477->setReadOnly(true);
ui->est1477->setAlignment(Qt::AlignRight);
ui->est1477->setMaximumWidth( m14trail);
ui->est1477->setMinimumWidth( m9trail);
ui->est1477->setMaximumHeight( m7traild3 );
ui->est1477->setMaxLength(15);
ui->est1477->setFrame(globalFrame);

ui->lib1481->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "148   ") );
connect( ui->lib1481, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1481, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib148, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst148, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1481->installEventFilter(this);
ui->lib1481->setMaximumWidth( m6trail);
ui->lib1481->setMinimumWidth( m6trail);
ui->lib1481->setMaximumHeight( m7traild3 );
ui->lib1481->setMaxLength(3);
ui->lib1481->setFrame(globalFrame);

ui->lib1482->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "148   ") );
connect( ui->lib1482, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1482, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1482->installEventFilter(this);
ui->lib1482->setMaximumWidth( m26trail);
ui->lib1482->setMinimumWidth( m25trail);
ui->lib1482->setMaximumHeight( m7traild3 );
ui->lib1482->setMaxLength(24);
ui->lib1482->setFrame(globalFrame);

ui->lib1483->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "148   ") );
connect( ui->lib1483, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1483, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1483->installEventFilter(this);
ui->lib1483->setAlignment(Qt::AlignCenter);
ui->lib1483->setMaximumWidth( m12trail);
ui->lib1483->setMinimumWidth( m6trail);
ui->lib1483->setMaximumHeight( m7traild3 );
ui->lib1483->setMaxLength(11);
ui->lib1483->setFrame(globalFrame);

ui->lib1484->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "148   ") );
connect( ui->lib1484, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1484, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1484->installEventFilter(this);
ui->lib1484->setAlignment(Qt::AlignCenter);
ui->lib1484->setMaximumWidth( m12trail);
ui->lib1484->setMinimumWidth( m6trail);
ui->lib1484->setMaximumHeight( m7traild3 );
ui->lib1484->setMaxLength(11);
ui->lib1484->setFrame(globalFrame);

ui->pushButtonEst148->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "148   ") );
ui->pushButtonEst148->setMaximumWidth( m7traild3 );
ui->pushButtonEst148->setMaximumHeight( m7traild3 );
ui->pushButtonLib148->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "148   ") );
ui->pushButtonLib148->setMaximumWidth( m7traild3 );
ui->pushButtonLib148->setMaximumHeight( m7traild3 );

ui->est1481->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "148   ") );
connect( ui->est1481, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1481, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1481->installEventFilter(this);
ui->est1481->setMaximumWidth( m6trail);
ui->est1481->setMinimumWidth( m6trail);
ui->est1481->setMaximumHeight( m7traild3 );
ui->est1481->setMaxLength(3);
ui->est1481->setFrame(globalFrame);

ui->est1482->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "148   ") );
connect( ui->est1482, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1482, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1482->installEventFilter(this);
ui->est1482->setMaximumWidth( m26trail);
ui->est1482->setMinimumWidth( m25trail);
ui->est1482->setMaximumHeight( m7traild3 );
ui->est1482->setMaxLength(24);
ui->est1482->setFrame(globalFrame);

ui->est1483->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "148   ") );
connect( ui->est1483, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1483, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1483->installEventFilter(this);
ui->est1483->setAlignment(Qt::AlignCenter);
ui->est1483->setMaximumWidth( m11trail);
ui->est1483->setMinimumWidth( m6trail);
ui->est1483->setMaximumHeight( m7traild3 );
ui->est1483->setMaxLength(8);
ui->est1483->setFrame(globalFrame);

ui->est1484->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "148   ") );
connect( ui->est1484, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1484, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1484->installEventFilter(this);
ui->est1484->setAlignment(Qt::AlignCenter);
ui->est1484->setMaximumWidth( m12trail);
ui->est1484->setMinimumWidth( m6trail);
ui->est1484->setMaximumHeight( m7traild3 );
ui->est1484->setMaxLength(11);
ui->est1484->setFrame(globalFrame);

ui->est1485->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "148   ") );
connect( ui->est1485, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1485, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1485->installEventFilter(this);
ui->est1485->setAlignment(Qt::AlignCenter);
ui->est1485->setMaximumWidth( m12trail);
ui->est1485->setMinimumWidth( m6trail);
ui->est1485->setMaximumHeight( m7traild3 );
ui->est1485->setMaxLength(11);
ui->est1485->setFrame(globalFrame);

ui->est1486->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "148   ") );
ui->est1486->setReadOnly(true);
ui->est1486->setAlignment(Qt::AlignRight);
ui->est1486->setMaximumWidth( m14trail);
ui->est1486->setMinimumWidth( m9trail);
ui->est1486->setMaximumHeight( m7traild3 );
ui->est1486->setMaxLength(15);
ui->est1486->setFrame(globalFrame);

ui->est1487->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "148   ") );
ui->est1487->setReadOnly(true);
ui->est1487->setAlignment(Qt::AlignRight);
ui->est1487->setMaximumWidth( m14trail);
ui->est1487->setMinimumWidth( m9trail);
ui->est1487->setMaximumHeight( m7traild3 );
ui->est1487->setMaxLength(15);
ui->est1487->setFrame(globalFrame);

ui->lib1491->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "149   ") );
connect( ui->lib1491, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1491, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib149, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst149, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1491->installEventFilter(this);
ui->lib1491->setMaximumWidth( m6trail);
ui->lib1491->setMinimumWidth( m6trail);
ui->lib1491->setMaximumHeight( m7traild3 );
ui->lib1491->setMaxLength(3);
ui->lib1491->setFrame(globalFrame);

ui->lib1492->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "149   ") );
connect( ui->lib1492, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1492, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1492->installEventFilter(this);
ui->lib1492->setMaximumWidth( m26trail);
ui->lib1492->setMinimumWidth( m25trail);
ui->lib1492->setMaximumHeight( m7traild3 );
ui->lib1492->setMaxLength(24);
ui->lib1492->setFrame(globalFrame);

ui->lib1493->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "149   ") );
connect( ui->lib1493, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1493, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1493->installEventFilter(this);
ui->lib1493->setAlignment(Qt::AlignCenter);
ui->lib1493->setMaximumWidth( m12trail);
ui->lib1493->setMinimumWidth( m6trail);
ui->lib1493->setMaximumHeight( m7traild3 );
ui->lib1493->setMaxLength(11);
ui->lib1493->setFrame(globalFrame);

ui->lib1494->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "149   ") );
connect( ui->lib1494, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1494, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1494->installEventFilter(this);
ui->lib1494->setAlignment(Qt::AlignCenter);
ui->lib1494->setMaximumWidth( m12trail);
ui->lib1494->setMinimumWidth( m6trail);
ui->lib1494->setMaximumHeight( m7traild3 );
ui->lib1494->setMaxLength(11);
ui->lib1494->setFrame(globalFrame);

ui->pushButtonEst149->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "149   ") );
ui->pushButtonEst149->setMaximumWidth( m7traild3 );
ui->pushButtonEst149->setMaximumHeight( m7traild3 );
ui->pushButtonLib149->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "149   ") );
ui->pushButtonLib149->setMaximumWidth( m7traild3 );
ui->pushButtonLib149->setMaximumHeight( m7traild3 );

ui->est1491->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "149   ") );
connect( ui->est1491, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1491, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1491->installEventFilter(this);
ui->est1491->setMaximumWidth( m6trail);
ui->est1491->setMinimumWidth( m6trail);
ui->est1491->setMaximumHeight( m7traild3 );
ui->est1491->setMaxLength(3);
ui->est1491->setFrame(globalFrame);

ui->est1492->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "149   ") );
connect( ui->est1492, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1492, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1492->installEventFilter(this);
ui->est1492->setMaximumWidth( m26trail);
ui->est1492->setMinimumWidth( m25trail);
ui->est1492->setMaximumHeight( m7traild3 );
ui->est1492->setMaxLength(24);
ui->est1492->setFrame(globalFrame);

ui->est1493->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "149   ") );
connect( ui->est1493, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1493, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1493->installEventFilter(this);
ui->est1493->setAlignment(Qt::AlignCenter);
ui->est1493->setMaximumWidth( m11trail);
ui->est1493->setMinimumWidth( m6trail);
ui->est1493->setMaximumHeight( m7traild3 );
ui->est1493->setMaxLength(8);
ui->est1493->setFrame(globalFrame);

ui->est1494->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "149   ") );
connect( ui->est1494, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1494, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1494->installEventFilter(this);
ui->est1494->setAlignment(Qt::AlignCenter);
ui->est1494->setMaximumWidth( m12trail);
ui->est1494->setMinimumWidth( m6trail);
ui->est1494->setMaximumHeight( m7traild3 );
ui->est1494->setMaxLength(11);
ui->est1494->setFrame(globalFrame);

ui->est1495->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "149   ") );
connect( ui->est1495, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1495, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1495->installEventFilter(this);
ui->est1495->setAlignment(Qt::AlignCenter);
ui->est1495->setMaximumWidth( m12trail);
ui->est1495->setMinimumWidth( m6trail);
ui->est1495->setMaximumHeight( m7traild3 );
ui->est1495->setMaxLength(11);
ui->est1495->setFrame(globalFrame);

ui->est1496->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "149   ") );
ui->est1496->setReadOnly(true);
ui->est1496->setAlignment(Qt::AlignRight);
ui->est1496->setMaximumWidth( m14trail);
ui->est1496->setMinimumWidth( m9trail);
ui->est1496->setMaximumHeight( m7traild3 );
ui->est1496->setMaxLength(15);
ui->est1496->setFrame(globalFrame);

ui->est1497->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "149   ") );
ui->est1497->setReadOnly(true);
ui->est1497->setAlignment(Qt::AlignRight);
ui->est1497->setMaximumWidth( m14trail);
ui->est1497->setMinimumWidth( m9trail);
ui->est1497->setMaximumHeight( m7traild3 );
ui->est1497->setMaxLength(15);
ui->est1497->setFrame(globalFrame);

ui->lib1501->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "150   ") );
connect( ui->lib1501, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1501, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib150, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst150, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1501->installEventFilter(this);
ui->lib1501->setMaximumWidth( m6trail);
ui->lib1501->setMinimumWidth( m6trail);
ui->lib1501->setMaximumHeight( m7traild3 );
ui->lib1501->setMaxLength(3);
ui->lib1501->setFrame(globalFrame);

ui->lib1502->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "150   ") );
connect( ui->lib1502, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1502, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1502->installEventFilter(this);
ui->lib1502->setMaximumWidth( m26trail);
ui->lib1502->setMinimumWidth( m25trail);
ui->lib1502->setMaximumHeight( m7traild3 );
ui->lib1502->setMaxLength(24);
ui->lib1502->setFrame(globalFrame);

ui->lib1503->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "150   ") );
connect( ui->lib1503, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1503, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1503->installEventFilter(this);
ui->lib1503->setAlignment(Qt::AlignCenter);
ui->lib1503->setMaximumWidth( m12trail);
ui->lib1503->setMinimumWidth( m6trail);
ui->lib1503->setMaximumHeight( m7traild3 );
ui->lib1503->setMaxLength(11);
ui->lib1503->setFrame(globalFrame);

ui->lib1504->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "150   ") );
connect( ui->lib1504, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1504, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1504->installEventFilter(this);
ui->lib1504->setAlignment(Qt::AlignCenter);
ui->lib1504->setMaximumWidth( m12trail);
ui->lib1504->setMinimumWidth( m6trail);
ui->lib1504->setMaximumHeight( m7traild3 );
ui->lib1504->setMaxLength(11);
ui->lib1504->setFrame(globalFrame);

ui->pushButtonEst150->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "150   ") );
ui->pushButtonEst150->setMaximumWidth( m7traild3 );
ui->pushButtonEst150->setMaximumHeight( m7traild3 );
ui->pushButtonLib150->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "150   ") );
ui->pushButtonLib150->setMaximumWidth( m7traild3 );
ui->pushButtonLib150->setMaximumHeight( m7traild3 );

ui->est1501->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "150   ") );
connect( ui->est1501, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1501, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1501->installEventFilter(this);
ui->est1501->setMaximumWidth( m6trail);
ui->est1501->setMinimumWidth( m6trail);
ui->est1501->setMaximumHeight( m7traild3 );
ui->est1501->setMaxLength(3);
ui->est1501->setFrame(globalFrame);

ui->est1502->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "150   ") );
connect( ui->est1502, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1502, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1502->installEventFilter(this);
ui->est1502->setMaximumWidth( m26trail);
ui->est1502->setMinimumWidth( m25trail);
ui->est1502->setMaximumHeight( m7traild3 );
ui->est1502->setMaxLength(24);
ui->est1502->setFrame(globalFrame);

ui->est1503->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "150   ") );
connect( ui->est1503, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1503, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1503->installEventFilter(this);
ui->est1503->setAlignment(Qt::AlignCenter);
ui->est1503->setMaximumWidth( m11trail);
ui->est1503->setMinimumWidth( m6trail);
ui->est1503->setMaximumHeight( m7traild3 );
ui->est1503->setMaxLength(8);
ui->est1503->setFrame(globalFrame);

ui->est1504->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "150   ") );
connect( ui->est1504, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1504, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1504->installEventFilter(this);
ui->est1504->setAlignment(Qt::AlignCenter);
ui->est1504->setMaximumWidth( m12trail);
ui->est1504->setMinimumWidth( m6trail);
ui->est1504->setMaximumHeight( m7traild3 );
ui->est1504->setMaxLength(11);
ui->est1504->setFrame(globalFrame);

ui->est1505->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "150   ") );
connect( ui->est1505, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1505, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1505->installEventFilter(this);
ui->est1505->setAlignment(Qt::AlignCenter);
ui->est1505->setMaximumWidth( m12trail);
ui->est1505->setMinimumWidth( m6trail);
ui->est1505->setMaximumHeight( m7traild3 );
ui->est1505->setMaxLength(11);
ui->est1505->setFrame(globalFrame);

ui->est1506->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "150   ") );
ui->est1506->setReadOnly(true);
ui->est1506->setAlignment(Qt::AlignRight);
ui->est1506->setMaximumWidth( m14trail);
ui->est1506->setMinimumWidth( m9trail);
ui->est1506->setMaximumHeight( m7traild3 );
ui->est1506->setMaxLength(15);
ui->est1506->setFrame(globalFrame);

ui->est1507->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "150   ") );
ui->est1507->setReadOnly(true);
ui->est1507->setAlignment(Qt::AlignRight);
ui->est1507->setMaximumWidth( m14trail);
ui->est1507->setMinimumWidth( m9trail);
ui->est1507->setMaximumHeight( m7traild3 );
ui->est1507->setMaxLength(15);
ui->est1507->setFrame(globalFrame);

ui->lib1511->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "151   ") );
connect( ui->lib1511, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1511, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib151, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst151, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1511->installEventFilter(this);
ui->lib1511->setMaximumWidth( m6trail);
ui->lib1511->setMinimumWidth( m6trail);
ui->lib1511->setMaximumHeight( m7traild3 );
ui->lib1511->setMaxLength(3);
ui->lib1511->setFrame(globalFrame);

ui->lib1512->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "151   ") );
connect( ui->lib1512, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1512, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1512->installEventFilter(this);
ui->lib1512->setMaximumWidth( m26trail);
ui->lib1512->setMinimumWidth( m25trail);
ui->lib1512->setMaximumHeight( m7traild3 );
ui->lib1512->setMaxLength(24);
ui->lib1512->setFrame(globalFrame);

ui->lib1513->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "151   ") );
connect( ui->lib1513, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1513, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1513->installEventFilter(this);
ui->lib1513->setAlignment(Qt::AlignCenter);
ui->lib1513->setMaximumWidth( m12trail);
ui->lib1513->setMinimumWidth( m6trail);
ui->lib1513->setMaximumHeight( m7traild3 );
ui->lib1513->setMaxLength(11);
ui->lib1513->setFrame(globalFrame);

ui->lib1514->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "151   ") );
connect( ui->lib1514, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1514, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1514->installEventFilter(this);
ui->lib1514->setAlignment(Qt::AlignCenter);
ui->lib1514->setMaximumWidth( m12trail);
ui->lib1514->setMinimumWidth( m6trail);
ui->lib1514->setMaximumHeight( m7traild3 );
ui->lib1514->setMaxLength(11);
ui->lib1514->setFrame(globalFrame);

ui->pushButtonEst151->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "151   ") );
ui->pushButtonEst151->setMaximumWidth( m7traild3 );
ui->pushButtonEst151->setMaximumHeight( m7traild3 );
ui->pushButtonLib151->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "151   ") );
ui->pushButtonLib151->setMaximumWidth( m7traild3 );
ui->pushButtonLib151->setMaximumHeight( m7traild3 );

ui->est1511->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "151   ") );
connect( ui->est1511, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1511, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1511->installEventFilter(this);
ui->est1511->setMaximumWidth( m6trail);
ui->est1511->setMinimumWidth( m6trail);
ui->est1511->setMaximumHeight( m7traild3 );
ui->est1511->setMaxLength(3);
ui->est1511->setFrame(globalFrame);

ui->est1512->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "151   ") );
connect( ui->est1512, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1512, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1512->installEventFilter(this);
ui->est1512->setMaximumWidth( m26trail);
ui->est1512->setMinimumWidth( m25trail);
ui->est1512->setMaximumHeight( m7traild3 );
ui->est1512->setMaxLength(24);
ui->est1512->setFrame(globalFrame);

ui->est1513->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "151   ") );
connect( ui->est1513, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1513, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1513->installEventFilter(this);
ui->est1513->setAlignment(Qt::AlignCenter);
ui->est1513->setMaximumWidth( m11trail);
ui->est1513->setMinimumWidth( m6trail);
ui->est1513->setMaximumHeight( m7traild3 );
ui->est1513->setMaxLength(8);
ui->est1513->setFrame(globalFrame);

ui->est1514->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "151   ") );
connect( ui->est1514, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1514, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1514->installEventFilter(this);
ui->est1514->setAlignment(Qt::AlignCenter);
ui->est1514->setMaximumWidth( m12trail);
ui->est1514->setMinimumWidth( m6trail);
ui->est1514->setMaximumHeight( m7traild3 );
ui->est1514->setMaxLength(11);
ui->est1514->setFrame(globalFrame);

ui->est1515->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "151   ") );
connect( ui->est1515, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1515, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1515->installEventFilter(this);
ui->est1515->setAlignment(Qt::AlignCenter);
ui->est1515->setMaximumWidth( m12trail);
ui->est1515->setMinimumWidth( m6trail);
ui->est1515->setMaximumHeight( m7traild3 );
ui->est1515->setMaxLength(11);
ui->est1515->setFrame(globalFrame);

ui->est1516->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "151   ") );
ui->est1516->setReadOnly(true);
ui->est1516->setAlignment(Qt::AlignRight);
ui->est1516->setMaximumWidth( m14trail);
ui->est1516->setMinimumWidth( m9trail);
ui->est1516->setMaximumHeight( m7traild3 );
ui->est1516->setMaxLength(15);
ui->est1516->setFrame(globalFrame);

ui->est1517->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "151   ") );
ui->est1517->setReadOnly(true);
ui->est1517->setAlignment(Qt::AlignRight);
ui->est1517->setMaximumWidth( m14trail);
ui->est1517->setMinimumWidth( m9trail);
ui->est1517->setMaximumHeight( m7traild3 );
ui->est1517->setMaxLength(15);
ui->est1517->setFrame(globalFrame);

ui->lib1521->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "152   ") );
connect( ui->lib1521, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1521, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib152, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst152, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1521->installEventFilter(this);
ui->lib1521->setMaximumWidth( m6trail);
ui->lib1521->setMinimumWidth( m6trail);
ui->lib1521->setMaximumHeight( m7traild3 );
ui->lib1521->setMaxLength(3);
ui->lib1521->setFrame(globalFrame);

ui->lib1522->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "152   ") );
connect( ui->lib1522, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1522, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1522->installEventFilter(this);
ui->lib1522->setMaximumWidth( m26trail);
ui->lib1522->setMinimumWidth( m25trail);
ui->lib1522->setMaximumHeight( m7traild3 );
ui->lib1522->setMaxLength(24);
ui->lib1522->setFrame(globalFrame);

ui->lib1523->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "152   ") );
connect( ui->lib1523, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1523, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1523->installEventFilter(this);
ui->lib1523->setAlignment(Qt::AlignCenter);
ui->lib1523->setMaximumWidth( m12trail);
ui->lib1523->setMinimumWidth( m6trail);
ui->lib1523->setMaximumHeight( m7traild3 );
ui->lib1523->setMaxLength(11);
ui->lib1523->setFrame(globalFrame);

ui->lib1524->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "152   ") );
connect( ui->lib1524, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1524, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1524->installEventFilter(this);
ui->lib1524->setAlignment(Qt::AlignCenter);
ui->lib1524->setMaximumWidth( m12trail);
ui->lib1524->setMinimumWidth( m6trail);
ui->lib1524->setMaximumHeight( m7traild3 );
ui->lib1524->setMaxLength(11);
ui->lib1524->setFrame(globalFrame);

ui->pushButtonEst152->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "152   ") );
ui->pushButtonEst152->setMaximumWidth( m7traild3 );
ui->pushButtonEst152->setMaximumHeight( m7traild3 );
ui->pushButtonLib152->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "152   ") );
ui->pushButtonLib152->setMaximumWidth( m7traild3 );
ui->pushButtonLib152->setMaximumHeight( m7traild3 );

ui->est1521->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "152   ") );
connect( ui->est1521, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1521, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1521->installEventFilter(this);
ui->est1521->setMaximumWidth( m6trail);
ui->est1521->setMinimumWidth( m6trail);
ui->est1521->setMaximumHeight( m7traild3 );
ui->est1521->setMaxLength(3);
ui->est1521->setFrame(globalFrame);

ui->est1522->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "152   ") );
connect( ui->est1522, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1522, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1522->installEventFilter(this);
ui->est1522->setMaximumWidth( m26trail);
ui->est1522->setMinimumWidth( m25trail);
ui->est1522->setMaximumHeight( m7traild3 );
ui->est1522->setMaxLength(24);
ui->est1522->setFrame(globalFrame);

ui->est1523->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "152   ") );
connect( ui->est1523, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1523, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1523->installEventFilter(this);
ui->est1523->setAlignment(Qt::AlignCenter);
ui->est1523->setMaximumWidth( m11trail);
ui->est1523->setMinimumWidth( m6trail);
ui->est1523->setMaximumHeight( m7traild3 );
ui->est1523->setMaxLength(8);
ui->est1523->setFrame(globalFrame);

ui->est1524->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "152   ") );
connect( ui->est1524, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1524, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1524->installEventFilter(this);
ui->est1524->setAlignment(Qt::AlignCenter);
ui->est1524->setMaximumWidth( m12trail);
ui->est1524->setMinimumWidth( m6trail);
ui->est1524->setMaximumHeight( m7traild3 );
ui->est1524->setMaxLength(11);
ui->est1524->setFrame(globalFrame);

ui->est1525->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "152   ") );
connect( ui->est1525, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1525, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1525->installEventFilter(this);
ui->est1525->setAlignment(Qt::AlignCenter);
ui->est1525->setMaximumWidth( m12trail);
ui->est1525->setMinimumWidth( m6trail);
ui->est1525->setMaximumHeight( m7traild3 );
ui->est1525->setMaxLength(11);
ui->est1525->setFrame(globalFrame);

ui->est1526->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "152   ") );
ui->est1526->setReadOnly(true);
ui->est1526->setAlignment(Qt::AlignRight);
ui->est1526->setMaximumWidth( m14trail);
ui->est1526->setMinimumWidth( m9trail);
ui->est1526->setMaximumHeight( m7traild3 );
ui->est1526->setMaxLength(15);
ui->est1526->setFrame(globalFrame);

ui->est1527->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "152   ") );
ui->est1527->setReadOnly(true);
ui->est1527->setAlignment(Qt::AlignRight);
ui->est1527->setMaximumWidth( m14trail);
ui->est1527->setMinimumWidth( m9trail);
ui->est1527->setMaximumHeight( m7traild3 );
ui->est1527->setMaxLength(15);
ui->est1527->setFrame(globalFrame);

ui->lib1531->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "153   ") );
connect( ui->lib1531, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1531, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib153, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst153, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1531->installEventFilter(this);
ui->lib1531->setMaximumWidth( m6trail);
ui->lib1531->setMinimumWidth( m6trail);
ui->lib1531->setMaximumHeight( m7traild3 );
ui->lib1531->setMaxLength(3);
ui->lib1531->setFrame(globalFrame);

ui->lib1532->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "153   ") );
connect( ui->lib1532, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1532, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1532->installEventFilter(this);
ui->lib1532->setMaximumWidth( m26trail);
ui->lib1532->setMinimumWidth( m25trail);
ui->lib1532->setMaximumHeight( m7traild3 );
ui->lib1532->setMaxLength(24);
ui->lib1532->setFrame(globalFrame);

ui->lib1533->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "153   ") );
connect( ui->lib1533, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1533, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1533->installEventFilter(this);
ui->lib1533->setAlignment(Qt::AlignCenter);
ui->lib1533->setMaximumWidth( m12trail);
ui->lib1533->setMinimumWidth( m6trail);
ui->lib1533->setMaximumHeight( m7traild3 );
ui->lib1533->setMaxLength(11);
ui->lib1533->setFrame(globalFrame);

ui->lib1534->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "153   ") );
connect( ui->lib1534, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1534, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1534->installEventFilter(this);
ui->lib1534->setAlignment(Qt::AlignCenter);
ui->lib1534->setMaximumWidth( m12trail);
ui->lib1534->setMinimumWidth( m6trail);
ui->lib1534->setMaximumHeight( m7traild3 );
ui->lib1534->setMaxLength(11);
ui->lib1534->setFrame(globalFrame);

ui->pushButtonEst153->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "153   ") );
ui->pushButtonEst153->setMaximumWidth( m7traild3 );
ui->pushButtonEst153->setMaximumHeight( m7traild3 );
ui->pushButtonLib153->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "153   ") );
ui->pushButtonLib153->setMaximumWidth( m7traild3 );
ui->pushButtonLib153->setMaximumHeight( m7traild3 );

ui->est1531->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "153   ") );
connect( ui->est1531, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1531, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1531->installEventFilter(this);
ui->est1531->setMaximumWidth( m6trail);
ui->est1531->setMinimumWidth( m6trail);
ui->est1531->setMaximumHeight( m7traild3 );
ui->est1531->setMaxLength(3);
ui->est1531->setFrame(globalFrame);

ui->est1532->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "153   ") );
connect( ui->est1532, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1532, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1532->installEventFilter(this);
ui->est1532->setMaximumWidth( m26trail);
ui->est1532->setMinimumWidth( m25trail);
ui->est1532->setMaximumHeight( m7traild3 );
ui->est1532->setMaxLength(24);
ui->est1532->setFrame(globalFrame);

ui->est1533->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "153   ") );
connect( ui->est1533, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1533, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1533->installEventFilter(this);
ui->est1533->setAlignment(Qt::AlignCenter);
ui->est1533->setMaximumWidth( m11trail);
ui->est1533->setMinimumWidth( m6trail);
ui->est1533->setMaximumHeight( m7traild3 );
ui->est1533->setMaxLength(8);
ui->est1533->setFrame(globalFrame);

ui->est1534->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "153   ") );
connect( ui->est1534, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1534, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1534->installEventFilter(this);
ui->est1534->setAlignment(Qt::AlignCenter);
ui->est1534->setMaximumWidth( m12trail);
ui->est1534->setMinimumWidth( m6trail);
ui->est1534->setMaximumHeight( m7traild3 );
ui->est1534->setMaxLength(11);
ui->est1534->setFrame(globalFrame);

ui->est1535->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "153   ") );
connect( ui->est1535, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1535, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1535->installEventFilter(this);
ui->est1535->setAlignment(Qt::AlignCenter);
ui->est1535->setMaximumWidth( m12trail);
ui->est1535->setMinimumWidth( m6trail);
ui->est1535->setMaximumHeight( m7traild3 );
ui->est1535->setMaxLength(11);
ui->est1535->setFrame(globalFrame);

ui->est1536->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "153   ") );
ui->est1536->setReadOnly(true);
ui->est1536->setAlignment(Qt::AlignRight);
ui->est1536->setMaximumWidth( m14trail);
ui->est1536->setMinimumWidth( m9trail);
ui->est1536->setMaximumHeight( m7traild3 );
ui->est1536->setMaxLength(15);
ui->est1536->setFrame(globalFrame);

ui->est1537->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "153   ") );
ui->est1537->setReadOnly(true);
ui->est1537->setAlignment(Qt::AlignRight);
ui->est1537->setMaximumWidth( m14trail);
ui->est1537->setMinimumWidth( m9trail);
ui->est1537->setMaximumHeight( m7traild3 );
ui->est1537->setMaxLength(15);
ui->est1537->setFrame(globalFrame);

ui->lib1541->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "154   ") );
connect( ui->lib1541, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1541, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib154, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst154, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1541->installEventFilter(this);
ui->lib1541->setMaximumWidth( m6trail);
ui->lib1541->setMinimumWidth( m6trail);
ui->lib1541->setMaximumHeight( m7traild3 );
ui->lib1541->setMaxLength(3);
ui->lib1541->setFrame(globalFrame);

ui->lib1542->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "154   ") );
connect( ui->lib1542, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1542, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1542->installEventFilter(this);
ui->lib1542->setMaximumWidth( m26trail);
ui->lib1542->setMinimumWidth( m25trail);
ui->lib1542->setMaximumHeight( m7traild3 );
ui->lib1542->setMaxLength(24);
ui->lib1542->setFrame(globalFrame);

ui->lib1543->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "154   ") );
connect( ui->lib1543, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1543, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1543->installEventFilter(this);
ui->lib1543->setAlignment(Qt::AlignCenter);
ui->lib1543->setMaximumWidth( m12trail);
ui->lib1543->setMinimumWidth( m6trail);
ui->lib1543->setMaximumHeight( m7traild3 );
ui->lib1543->setMaxLength(11);
ui->lib1543->setFrame(globalFrame);

ui->lib1544->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "154   ") );
connect( ui->lib1544, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1544, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1544->installEventFilter(this);
ui->lib1544->setAlignment(Qt::AlignCenter);
ui->lib1544->setMaximumWidth( m12trail);
ui->lib1544->setMinimumWidth( m6trail);
ui->lib1544->setMaximumHeight( m7traild3 );
ui->lib1544->setMaxLength(11);
ui->lib1544->setFrame(globalFrame);

ui->pushButtonEst154->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "154   ") );
ui->pushButtonEst154->setMaximumWidth( m7traild3 );
ui->pushButtonEst154->setMaximumHeight( m7traild3 );
ui->pushButtonLib154->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "154   ") );
ui->pushButtonLib154->setMaximumWidth( m7traild3 );
ui->pushButtonLib154->setMaximumHeight( m7traild3 );

ui->est1541->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "154   ") );
connect( ui->est1541, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1541, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1541->installEventFilter(this);
ui->est1541->setMaximumWidth( m6trail);
ui->est1541->setMinimumWidth( m6trail);
ui->est1541->setMaximumHeight( m7traild3 );
ui->est1541->setMaxLength(3);
ui->est1541->setFrame(globalFrame);

ui->est1542->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "154   ") );
connect( ui->est1542, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1542, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1542->installEventFilter(this);
ui->est1542->setMaximumWidth( m26trail);
ui->est1542->setMinimumWidth( m25trail);
ui->est1542->setMaximumHeight( m7traild3 );
ui->est1542->setMaxLength(24);
ui->est1542->setFrame(globalFrame);

ui->est1543->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "154   ") );
connect( ui->est1543, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1543, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1543->installEventFilter(this);
ui->est1543->setAlignment(Qt::AlignCenter);
ui->est1543->setMaximumWidth( m11trail);
ui->est1543->setMinimumWidth( m6trail);
ui->est1543->setMaximumHeight( m7traild3 );
ui->est1543->setMaxLength(8);
ui->est1543->setFrame(globalFrame);

ui->est1544->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "154   ") );
connect( ui->est1544, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1544, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1544->installEventFilter(this);
ui->est1544->setAlignment(Qt::AlignCenter);
ui->est1544->setMaximumWidth( m12trail);
ui->est1544->setMinimumWidth( m6trail);
ui->est1544->setMaximumHeight( m7traild3 );
ui->est1544->setMaxLength(11);
ui->est1544->setFrame(globalFrame);

ui->est1545->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "154   ") );
connect( ui->est1545, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1545, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1545->installEventFilter(this);
ui->est1545->setAlignment(Qt::AlignCenter);
ui->est1545->setMaximumWidth( m12trail);
ui->est1545->setMinimumWidth( m6trail);
ui->est1545->setMaximumHeight( m7traild3 );
ui->est1545->setMaxLength(11);
ui->est1545->setFrame(globalFrame);

ui->est1546->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "154   ") );
ui->est1546->setReadOnly(true);
ui->est1546->setAlignment(Qt::AlignRight);
ui->est1546->setMaximumWidth( m14trail);
ui->est1546->setMinimumWidth( m9trail);
ui->est1546->setMaximumHeight( m7traild3 );
ui->est1546->setMaxLength(15);
ui->est1546->setFrame(globalFrame);

ui->est1547->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "154   ") );
ui->est1547->setReadOnly(true);
ui->est1547->setAlignment(Qt::AlignRight);
ui->est1547->setMaximumWidth( m14trail);
ui->est1547->setMinimumWidth( m9trail);
ui->est1547->setMaximumHeight( m7traild3 );
ui->est1547->setMaxLength(15);
ui->est1547->setFrame(globalFrame);

ui->lib1551->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "155   ") );
connect( ui->lib1551, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1551, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib155, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst155, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1551->installEventFilter(this);
ui->lib1551->setMaximumWidth( m6trail);
ui->lib1551->setMinimumWidth( m6trail);
ui->lib1551->setMaximumHeight( m7traild3 );
ui->lib1551->setMaxLength(3);
ui->lib1551->setFrame(globalFrame);

ui->lib1552->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "155   ") );
connect( ui->lib1552, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1552, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1552->installEventFilter(this);
ui->lib1552->setMaximumWidth( m26trail);
ui->lib1552->setMinimumWidth( m25trail);
ui->lib1552->setMaximumHeight( m7traild3 );
ui->lib1552->setMaxLength(24);
ui->lib1552->setFrame(globalFrame);

ui->lib1553->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "155   ") );
connect( ui->lib1553, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1553, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1553->installEventFilter(this);
ui->lib1553->setAlignment(Qt::AlignCenter);
ui->lib1553->setMaximumWidth( m12trail);
ui->lib1553->setMinimumWidth( m6trail);
ui->lib1553->setMaximumHeight( m7traild3 );
ui->lib1553->setMaxLength(11);
ui->lib1553->setFrame(globalFrame);

ui->lib1554->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "155   ") );
connect( ui->lib1554, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1554, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1554->installEventFilter(this);
ui->lib1554->setAlignment(Qt::AlignCenter);
ui->lib1554->setMaximumWidth( m12trail);
ui->lib1554->setMinimumWidth( m6trail);
ui->lib1554->setMaximumHeight( m7traild3 );
ui->lib1554->setMaxLength(11);
ui->lib1554->setFrame(globalFrame);

ui->pushButtonEst155->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "155   ") );
ui->pushButtonEst155->setMaximumWidth( m7traild3 );
ui->pushButtonEst155->setMaximumHeight( m7traild3 );
ui->pushButtonLib155->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "155   ") );
ui->pushButtonLib155->setMaximumWidth( m7traild3 );
ui->pushButtonLib155->setMaximumHeight( m7traild3 );

ui->est1551->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "155   ") );
connect( ui->est1551, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1551, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1551->installEventFilter(this);
ui->est1551->setMaximumWidth( m6trail);
ui->est1551->setMinimumWidth( m6trail);
ui->est1551->setMaximumHeight( m7traild3 );
ui->est1551->setMaxLength(3);
ui->est1551->setFrame(globalFrame);

ui->est1552->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "155   ") );
connect( ui->est1552, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1552, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1552->installEventFilter(this);
ui->est1552->setMaximumWidth( m26trail);
ui->est1552->setMinimumWidth( m25trail);
ui->est1552->setMaximumHeight( m7traild3 );
ui->est1552->setMaxLength(24);
ui->est1552->setFrame(globalFrame);

ui->est1553->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "155   ") );
connect( ui->est1553, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1553, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1553->installEventFilter(this);
ui->est1553->setAlignment(Qt::AlignCenter);
ui->est1553->setMaximumWidth( m11trail);
ui->est1553->setMinimumWidth( m6trail);
ui->est1553->setMaximumHeight( m7traild3 );
ui->est1553->setMaxLength(8);
ui->est1553->setFrame(globalFrame);

ui->est1554->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "155   ") );
connect( ui->est1554, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1554, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1554->installEventFilter(this);
ui->est1554->setAlignment(Qt::AlignCenter);
ui->est1554->setMaximumWidth( m12trail);
ui->est1554->setMinimumWidth( m6trail);
ui->est1554->setMaximumHeight( m7traild3 );
ui->est1554->setMaxLength(11);
ui->est1554->setFrame(globalFrame);

ui->est1555->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "155   ") );
connect( ui->est1555, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1555, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1555->installEventFilter(this);
ui->est1555->setAlignment(Qt::AlignCenter);
ui->est1555->setMaximumWidth( m12trail);
ui->est1555->setMinimumWidth( m6trail);
ui->est1555->setMaximumHeight( m7traild3 );
ui->est1555->setMaxLength(11);
ui->est1555->setFrame(globalFrame);

ui->est1556->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "155   ") );
ui->est1556->setReadOnly(true);
ui->est1556->setAlignment(Qt::AlignRight);
ui->est1556->setMaximumWidth( m14trail);
ui->est1556->setMinimumWidth( m9trail);
ui->est1556->setMaximumHeight( m7traild3 );
ui->est1556->setMaxLength(15);
ui->est1556->setFrame(globalFrame);

ui->est1557->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "155   ") );
ui->est1557->setReadOnly(true);
ui->est1557->setAlignment(Qt::AlignRight);
ui->est1557->setMaximumWidth( m14trail);
ui->est1557->setMinimumWidth( m9trail);
ui->est1557->setMaximumHeight( m7traild3 );
ui->est1557->setMaxLength(15);
ui->est1557->setFrame(globalFrame);

ui->lib1561->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "156   ") );
connect( ui->lib1561, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1561, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib156, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst156, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1561->installEventFilter(this);
ui->lib1561->setMaximumWidth( m6trail);
ui->lib1561->setMinimumWidth( m6trail);
ui->lib1561->setMaximumHeight( m7traild3 );
ui->lib1561->setMaxLength(3);
ui->lib1561->setFrame(globalFrame);

ui->lib1562->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "156   ") );
connect( ui->lib1562, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1562, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1562->installEventFilter(this);
ui->lib1562->setMaximumWidth( m26trail);
ui->lib1562->setMinimumWidth( m25trail);
ui->lib1562->setMaximumHeight( m7traild3 );
ui->lib1562->setMaxLength(24);
ui->lib1562->setFrame(globalFrame);

ui->lib1563->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "156   ") );
connect( ui->lib1563, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1563, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1563->installEventFilter(this);
ui->lib1563->setAlignment(Qt::AlignCenter);
ui->lib1563->setMaximumWidth( m12trail);
ui->lib1563->setMinimumWidth( m6trail);
ui->lib1563->setMaximumHeight( m7traild3 );
ui->lib1563->setMaxLength(11);
ui->lib1563->setFrame(globalFrame);

ui->lib1564->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "156   ") );
connect( ui->lib1564, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1564, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1564->installEventFilter(this);
ui->lib1564->setAlignment(Qt::AlignCenter);
ui->lib1564->setMaximumWidth( m12trail);
ui->lib1564->setMinimumWidth( m6trail);
ui->lib1564->setMaximumHeight( m7traild3 );
ui->lib1564->setMaxLength(11);
ui->lib1564->setFrame(globalFrame);

ui->pushButtonEst156->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "156   ") );
ui->pushButtonEst156->setMaximumWidth( m7traild3 );
ui->pushButtonEst156->setMaximumHeight( m7traild3 );
ui->pushButtonLib156->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "156   ") );
ui->pushButtonLib156->setMaximumWidth( m7traild3 );
ui->pushButtonLib156->setMaximumHeight( m7traild3 );

ui->est1561->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "156   ") );
connect( ui->est1561, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1561, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1561->installEventFilter(this);
ui->est1561->setMaximumWidth( m6trail);
ui->est1561->setMinimumWidth( m6trail);
ui->est1561->setMaximumHeight( m7traild3 );
ui->est1561->setMaxLength(3);
ui->est1561->setFrame(globalFrame);

ui->est1562->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "156   ") );
connect( ui->est1562, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1562, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1562->installEventFilter(this);
ui->est1562->setMaximumWidth( m26trail);
ui->est1562->setMinimumWidth( m25trail);
ui->est1562->setMaximumHeight( m7traild3 );
ui->est1562->setMaxLength(24);
ui->est1562->setFrame(globalFrame);

ui->est1563->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "156   ") );
connect( ui->est1563, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1563, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1563->installEventFilter(this);
ui->est1563->setAlignment(Qt::AlignCenter);
ui->est1563->setMaximumWidth( m11trail);
ui->est1563->setMinimumWidth( m6trail);
ui->est1563->setMaximumHeight( m7traild3 );
ui->est1563->setMaxLength(8);
ui->est1563->setFrame(globalFrame);

ui->est1564->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "156   ") );
connect( ui->est1564, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1564, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1564->installEventFilter(this);
ui->est1564->setAlignment(Qt::AlignCenter);
ui->est1564->setMaximumWidth( m12trail);
ui->est1564->setMinimumWidth( m6trail);
ui->est1564->setMaximumHeight( m7traild3 );
ui->est1564->setMaxLength(11);
ui->est1564->setFrame(globalFrame);

ui->est1565->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "156   ") );
connect( ui->est1565, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1565, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1565->installEventFilter(this);
ui->est1565->setAlignment(Qt::AlignCenter);
ui->est1565->setMaximumWidth( m12trail);
ui->est1565->setMinimumWidth( m6trail);
ui->est1565->setMaximumHeight( m7traild3 );
ui->est1565->setMaxLength(11);
ui->est1565->setFrame(globalFrame);

ui->est1566->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "156   ") );
ui->est1566->setReadOnly(true);
ui->est1566->setAlignment(Qt::AlignRight);
ui->est1566->setMaximumWidth( m14trail);
ui->est1566->setMinimumWidth( m9trail);
ui->est1566->setMaximumHeight( m7traild3 );
ui->est1566->setMaxLength(15);
ui->est1566->setFrame(globalFrame);

ui->est1567->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "156   ") );
ui->est1567->setReadOnly(true);
ui->est1567->setAlignment(Qt::AlignRight);
ui->est1567->setMaximumWidth( m14trail);
ui->est1567->setMinimumWidth( m9trail);
ui->est1567->setMaximumHeight( m7traild3 );
ui->est1567->setMaxLength(15);
ui->est1567->setFrame(globalFrame);

ui->lib1571->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "157   ") );
connect( ui->lib1571, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1571, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib157, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst157, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1571->installEventFilter(this);
ui->lib1571->setMaximumWidth( m6trail);
ui->lib1571->setMinimumWidth( m6trail);
ui->lib1571->setMaximumHeight( m7traild3 );
ui->lib1571->setMaxLength(3);
ui->lib1571->setFrame(globalFrame);

ui->lib1572->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "157   ") );
connect( ui->lib1572, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1572, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1572->installEventFilter(this);
ui->lib1572->setMaximumWidth( m26trail);
ui->lib1572->setMinimumWidth( m25trail);
ui->lib1572->setMaximumHeight( m7traild3 );
ui->lib1572->setMaxLength(24);
ui->lib1572->setFrame(globalFrame);

ui->lib1573->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "157   ") );
connect( ui->lib1573, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1573, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1573->installEventFilter(this);
ui->lib1573->setAlignment(Qt::AlignCenter);
ui->lib1573->setMaximumWidth( m12trail);
ui->lib1573->setMinimumWidth( m6trail);
ui->lib1573->setMaximumHeight( m7traild3 );
ui->lib1573->setMaxLength(11);
ui->lib1573->setFrame(globalFrame);

ui->lib1574->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "157   ") );
connect( ui->lib1574, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1574, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1574->installEventFilter(this);
ui->lib1574->setAlignment(Qt::AlignCenter);
ui->lib1574->setMaximumWidth( m12trail);
ui->lib1574->setMinimumWidth( m6trail);
ui->lib1574->setMaximumHeight( m7traild3 );
ui->lib1574->setMaxLength(11);
ui->lib1574->setFrame(globalFrame);

ui->pushButtonEst157->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "157   ") );
ui->pushButtonEst157->setMaximumWidth( m7traild3 );
ui->pushButtonEst157->setMaximumHeight( m7traild3 );
ui->pushButtonLib157->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "157   ") );
ui->pushButtonLib157->setMaximumWidth( m7traild3 );
ui->pushButtonLib157->setMaximumHeight( m7traild3 );

ui->est1571->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "157   ") );
connect( ui->est1571, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1571, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1571->installEventFilter(this);
ui->est1571->setMaximumWidth( m6trail);
ui->est1571->setMinimumWidth( m6trail);
ui->est1571->setMaximumHeight( m7traild3 );
ui->est1571->setMaxLength(3);
ui->est1571->setFrame(globalFrame);

ui->est1572->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "157   ") );
connect( ui->est1572, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1572, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1572->installEventFilter(this);
ui->est1572->setMaximumWidth( m26trail);
ui->est1572->setMinimumWidth( m25trail);
ui->est1572->setMaximumHeight( m7traild3 );
ui->est1572->setMaxLength(24);
ui->est1572->setFrame(globalFrame);

ui->est1573->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "157   ") );
connect( ui->est1573, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1573, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1573->installEventFilter(this);
ui->est1573->setAlignment(Qt::AlignCenter);
ui->est1573->setMaximumWidth( m11trail);
ui->est1573->setMinimumWidth( m6trail);
ui->est1573->setMaximumHeight( m7traild3 );
ui->est1573->setMaxLength(8);
ui->est1573->setFrame(globalFrame);

ui->est1574->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "157   ") );
connect( ui->est1574, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1574, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1574->installEventFilter(this);
ui->est1574->setAlignment(Qt::AlignCenter);
ui->est1574->setMaximumWidth( m12trail);
ui->est1574->setMinimumWidth( m6trail);
ui->est1574->setMaximumHeight( m7traild3 );
ui->est1574->setMaxLength(11);
ui->est1574->setFrame(globalFrame);

ui->est1575->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "157   ") );
connect( ui->est1575, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1575, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1575->installEventFilter(this);
ui->est1575->setAlignment(Qt::AlignCenter);
ui->est1575->setMaximumWidth( m12trail);
ui->est1575->setMinimumWidth( m6trail);
ui->est1575->setMaximumHeight( m7traild3 );
ui->est1575->setMaxLength(11);
ui->est1575->setFrame(globalFrame);

ui->est1576->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "157   ") );
ui->est1576->setReadOnly(true);
ui->est1576->setAlignment(Qt::AlignRight);
ui->est1576->setMaximumWidth( m14trail);
ui->est1576->setMinimumWidth( m9trail);
ui->est1576->setMaximumHeight( m7traild3 );
ui->est1576->setMaxLength(15);
ui->est1576->setFrame(globalFrame);

ui->est1577->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "157   ") );
ui->est1577->setReadOnly(true);
ui->est1577->setAlignment(Qt::AlignRight);
ui->est1577->setMaximumWidth( m14trail);
ui->est1577->setMinimumWidth( m9trail);
ui->est1577->setMaximumHeight( m7traild3 );
ui->est1577->setMaxLength(15);
ui->est1577->setFrame(globalFrame);

ui->lib1581->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "158   ") );
connect( ui->lib1581, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1581, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib158, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst158, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1581->installEventFilter(this);
ui->lib1581->setMaximumWidth( m6trail);
ui->lib1581->setMinimumWidth( m6trail);
ui->lib1581->setMaximumHeight( m7traild3 );
ui->lib1581->setMaxLength(3);
ui->lib1581->setFrame(globalFrame);

ui->lib1582->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "158   ") );
connect( ui->lib1582, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1582, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1582->installEventFilter(this);
ui->lib1582->setMaximumWidth( m26trail);
ui->lib1582->setMinimumWidth( m25trail);
ui->lib1582->setMaximumHeight( m7traild3 );
ui->lib1582->setMaxLength(24);
ui->lib1582->setFrame(globalFrame);

ui->lib1583->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "158   ") );
connect( ui->lib1583, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1583, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1583->installEventFilter(this);
ui->lib1583->setAlignment(Qt::AlignCenter);
ui->lib1583->setMaximumWidth( m12trail);
ui->lib1583->setMinimumWidth( m6trail);
ui->lib1583->setMaximumHeight( m7traild3 );
ui->lib1583->setMaxLength(11);
ui->lib1583->setFrame(globalFrame);

ui->lib1584->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "158   ") );
connect( ui->lib1584, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1584, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1584->installEventFilter(this);
ui->lib1584->setAlignment(Qt::AlignCenter);
ui->lib1584->setMaximumWidth( m12trail);
ui->lib1584->setMinimumWidth( m6trail);
ui->lib1584->setMaximumHeight( m7traild3 );
ui->lib1584->setMaxLength(11);
ui->lib1584->setFrame(globalFrame);

ui->pushButtonEst158->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "158   ") );
ui->pushButtonEst158->setMaximumWidth( m7traild3 );
ui->pushButtonEst158->setMaximumHeight( m7traild3 );
ui->pushButtonLib158->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "158   ") );
ui->pushButtonLib158->setMaximumWidth( m7traild3 );
ui->pushButtonLib158->setMaximumHeight( m7traild3 );

ui->est1581->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "158   ") );
connect( ui->est1581, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1581, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1581->installEventFilter(this);
ui->est1581->setMaximumWidth( m6trail);
ui->est1581->setMinimumWidth( m6trail);
ui->est1581->setMaximumHeight( m7traild3 );
ui->est1581->setMaxLength(3);
ui->est1581->setFrame(globalFrame);

ui->est1582->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "158   ") );
connect( ui->est1582, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1582, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1582->installEventFilter(this);
ui->est1582->setMaximumWidth( m26trail);
ui->est1582->setMinimumWidth( m25trail);
ui->est1582->setMaximumHeight( m7traild3 );
ui->est1582->setMaxLength(24);
ui->est1582->setFrame(globalFrame);

ui->est1583->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "158   ") );
connect( ui->est1583, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1583, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1583->installEventFilter(this);
ui->est1583->setAlignment(Qt::AlignCenter);
ui->est1583->setMaximumWidth( m11trail);
ui->est1583->setMinimumWidth( m6trail);
ui->est1583->setMaximumHeight( m7traild3 );
ui->est1583->setMaxLength(8);
ui->est1583->setFrame(globalFrame);

ui->est1584->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "158   ") );
connect( ui->est1584, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1584, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1584->installEventFilter(this);
ui->est1584->setAlignment(Qt::AlignCenter);
ui->est1584->setMaximumWidth( m12trail);
ui->est1584->setMinimumWidth( m6trail);
ui->est1584->setMaximumHeight( m7traild3 );
ui->est1584->setMaxLength(11);
ui->est1584->setFrame(globalFrame);

ui->est1585->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "158   ") );
connect( ui->est1585, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1585, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1585->installEventFilter(this);
ui->est1585->setAlignment(Qt::AlignCenter);
ui->est1585->setMaximumWidth( m12trail);
ui->est1585->setMinimumWidth( m6trail);
ui->est1585->setMaximumHeight( m7traild3 );
ui->est1585->setMaxLength(11);
ui->est1585->setFrame(globalFrame);

ui->est1586->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "158   ") );
ui->est1586->setReadOnly(true);
ui->est1586->setAlignment(Qt::AlignRight);
ui->est1586->setMaximumWidth( m14trail);
ui->est1586->setMinimumWidth( m9trail);
ui->est1586->setMaximumHeight( m7traild3 );
ui->est1586->setMaxLength(15);
ui->est1586->setFrame(globalFrame);

ui->est1587->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "158   ") );
ui->est1587->setReadOnly(true);
ui->est1587->setAlignment(Qt::AlignRight);
ui->est1587->setMaximumWidth( m14trail);
ui->est1587->setMinimumWidth( m9trail);
ui->est1587->setMaximumHeight( m7traild3 );
ui->est1587->setMaxLength(15);
ui->est1587->setFrame(globalFrame);

ui->lib1591->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "159   ") );
connect( ui->lib1591, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1591, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib159, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst159, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1591->installEventFilter(this);
ui->lib1591->setMaximumWidth( m6trail);
ui->lib1591->setMinimumWidth( m6trail);
ui->lib1591->setMaximumHeight( m7traild3 );
ui->lib1591->setMaxLength(3);
ui->lib1591->setFrame(globalFrame);

ui->lib1592->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "159   ") );
connect( ui->lib1592, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1592, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1592->installEventFilter(this);
ui->lib1592->setMaximumWidth( m26trail);
ui->lib1592->setMinimumWidth( m25trail);
ui->lib1592->setMaximumHeight( m7traild3 );
ui->lib1592->setMaxLength(24);
ui->lib1592->setFrame(globalFrame);

ui->lib1593->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "159   ") );
connect( ui->lib1593, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1593, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1593->installEventFilter(this);
ui->lib1593->setAlignment(Qt::AlignCenter);
ui->lib1593->setMaximumWidth( m12trail);
ui->lib1593->setMinimumWidth( m6trail);
ui->lib1593->setMaximumHeight( m7traild3 );
ui->lib1593->setMaxLength(11);
ui->lib1593->setFrame(globalFrame);

ui->lib1594->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "159   ") );
connect( ui->lib1594, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1594, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1594->installEventFilter(this);
ui->lib1594->setAlignment(Qt::AlignCenter);
ui->lib1594->setMaximumWidth( m12trail);
ui->lib1594->setMinimumWidth( m6trail);
ui->lib1594->setMaximumHeight( m7traild3 );
ui->lib1594->setMaxLength(11);
ui->lib1594->setFrame(globalFrame);

ui->pushButtonEst159->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "159   ") );
ui->pushButtonEst159->setMaximumWidth( m7traild3 );
ui->pushButtonEst159->setMaximumHeight( m7traild3 );
ui->pushButtonLib159->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "159   ") );
ui->pushButtonLib159->setMaximumWidth( m7traild3 );
ui->pushButtonLib159->setMaximumHeight( m7traild3 );

ui->est1591->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "159   ") );
connect( ui->est1591, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1591, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1591->installEventFilter(this);
ui->est1591->setMaximumWidth( m6trail);
ui->est1591->setMinimumWidth( m6trail);
ui->est1591->setMaximumHeight( m7traild3 );
ui->est1591->setMaxLength(3);
ui->est1591->setFrame(globalFrame);

ui->est1592->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "159   ") );
connect( ui->est1592, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1592, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1592->installEventFilter(this);
ui->est1592->setMaximumWidth( m26trail);
ui->est1592->setMinimumWidth( m25trail);
ui->est1592->setMaximumHeight( m7traild3 );
ui->est1592->setMaxLength(24);
ui->est1592->setFrame(globalFrame);

ui->est1593->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "159   ") );
connect( ui->est1593, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1593, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1593->installEventFilter(this);
ui->est1593->setAlignment(Qt::AlignCenter);
ui->est1593->setMaximumWidth( m11trail);
ui->est1593->setMinimumWidth( m6trail);
ui->est1593->setMaximumHeight( m7traild3 );
ui->est1593->setMaxLength(8);
ui->est1593->setFrame(globalFrame);

ui->est1594->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "159   ") );
connect( ui->est1594, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1594, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1594->installEventFilter(this);
ui->est1594->setAlignment(Qt::AlignCenter);
ui->est1594->setMaximumWidth( m12trail);
ui->est1594->setMinimumWidth( m6trail);
ui->est1594->setMaximumHeight( m7traild3 );
ui->est1594->setMaxLength(11);
ui->est1594->setFrame(globalFrame);

ui->est1595->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "159   ") );
connect( ui->est1595, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1595, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1595->installEventFilter(this);
ui->est1595->setAlignment(Qt::AlignCenter);
ui->est1595->setMaximumWidth( m12trail);
ui->est1595->setMinimumWidth( m6trail);
ui->est1595->setMaximumHeight( m7traild3 );
ui->est1595->setMaxLength(11);
ui->est1595->setFrame(globalFrame);

ui->est1596->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "159   ") );
ui->est1596->setReadOnly(true);
ui->est1596->setAlignment(Qt::AlignRight);
ui->est1596->setMaximumWidth( m14trail);
ui->est1596->setMinimumWidth( m9trail);
ui->est1596->setMaximumHeight( m7traild3 );
ui->est1596->setMaxLength(15);
ui->est1596->setFrame(globalFrame);

ui->est1597->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "159   ") );
ui->est1597->setReadOnly(true);
ui->est1597->setAlignment(Qt::AlignRight);
ui->est1597->setMaximumWidth( m14trail);
ui->est1597->setMinimumWidth( m9trail);
ui->est1597->setMaximumHeight( m7traild3 );
ui->est1597->setMaxLength(15);
ui->est1597->setFrame(globalFrame);

ui->lib1601->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "160   ") );
connect( ui->lib1601, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1601, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib160, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst160, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1601->installEventFilter(this);
ui->lib1601->setMaximumWidth( m6trail);
ui->lib1601->setMinimumWidth( m6trail);
ui->lib1601->setMaximumHeight( m7traild3 );
ui->lib1601->setMaxLength(3);
ui->lib1601->setFrame(globalFrame);

ui->lib1602->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "160   ") );
connect( ui->lib1602, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1602, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1602->installEventFilter(this);
ui->lib1602->setMaximumWidth( m26trail);
ui->lib1602->setMinimumWidth( m25trail);
ui->lib1602->setMaximumHeight( m7traild3 );
ui->lib1602->setMaxLength(24);
ui->lib1602->setFrame(globalFrame);

ui->lib1603->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "160   ") );
connect( ui->lib1603, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1603, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1603->installEventFilter(this);
ui->lib1603->setAlignment(Qt::AlignCenter);
ui->lib1603->setMaximumWidth( m12trail);
ui->lib1603->setMinimumWidth( m6trail);
ui->lib1603->setMaximumHeight( m7traild3 );
ui->lib1603->setMaxLength(11);
ui->lib1603->setFrame(globalFrame);

ui->lib1604->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "160   ") );
connect( ui->lib1604, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1604, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1604->installEventFilter(this);
ui->lib1604->setAlignment(Qt::AlignCenter);
ui->lib1604->setMaximumWidth( m12trail);
ui->lib1604->setMinimumWidth( m6trail);
ui->lib1604->setMaximumHeight( m7traild3 );
ui->lib1604->setMaxLength(11);
ui->lib1604->setFrame(globalFrame);

ui->pushButtonEst160->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "160   ") );
ui->pushButtonEst160->setMaximumWidth( m7traild3 );
ui->pushButtonEst160->setMaximumHeight( m7traild3 );
ui->pushButtonLib160->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "160   ") );
ui->pushButtonLib160->setMaximumWidth( m7traild3 );
ui->pushButtonLib160->setMaximumHeight( m7traild3 );

ui->est1601->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "160   ") );
connect( ui->est1601, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1601, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1601->installEventFilter(this);
ui->est1601->setMaximumWidth( m6trail);
ui->est1601->setMinimumWidth( m6trail);
ui->est1601->setMaximumHeight( m7traild3 );
ui->est1601->setMaxLength(3);
ui->est1601->setFrame(globalFrame);

ui->est1602->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "160   ") );
connect( ui->est1602, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1602, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1602->installEventFilter(this);
ui->est1602->setMaximumWidth( m26trail);
ui->est1602->setMinimumWidth( m25trail);
ui->est1602->setMaximumHeight( m7traild3 );
ui->est1602->setMaxLength(24);
ui->est1602->setFrame(globalFrame);

ui->est1603->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "160   ") );
connect( ui->est1603, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1603, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1603->installEventFilter(this);
ui->est1603->setAlignment(Qt::AlignCenter);
ui->est1603->setMaximumWidth( m11trail);
ui->est1603->setMinimumWidth( m6trail);
ui->est1603->setMaximumHeight( m7traild3 );
ui->est1603->setMaxLength(8);
ui->est1603->setFrame(globalFrame);

ui->est1604->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "160   ") );
connect( ui->est1604, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1604, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1604->installEventFilter(this);
ui->est1604->setAlignment(Qt::AlignCenter);
ui->est1604->setMaximumWidth( m12trail);
ui->est1604->setMinimumWidth( m6trail);
ui->est1604->setMaximumHeight( m7traild3 );
ui->est1604->setMaxLength(11);
ui->est1604->setFrame(globalFrame);

ui->est1605->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "160   ") );
connect( ui->est1605, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1605, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1605->installEventFilter(this);
ui->est1605->setAlignment(Qt::AlignCenter);
ui->est1605->setMaximumWidth( m12trail);
ui->est1605->setMinimumWidth( m6trail);
ui->est1605->setMaximumHeight( m7traild3 );
ui->est1605->setMaxLength(11);
ui->est1605->setFrame(globalFrame);

ui->est1606->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "160   ") );
ui->est1606->setReadOnly(true);
ui->est1606->setAlignment(Qt::AlignRight);
ui->est1606->setMaximumWidth( m14trail);
ui->est1606->setMinimumWidth( m9trail);
ui->est1606->setMaximumHeight( m7traild3 );
ui->est1606->setMaxLength(15);
ui->est1606->setFrame(globalFrame);

ui->est1607->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "160   ") );
ui->est1607->setReadOnly(true);
ui->est1607->setAlignment(Qt::AlignRight);
ui->est1607->setMaximumWidth( m14trail);
ui->est1607->setMinimumWidth( m9trail);
ui->est1607->setMaximumHeight( m7traild3 );
ui->est1607->setMaxLength(15);
ui->est1607->setFrame(globalFrame);

ui->lib1611->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "161   ") );
connect( ui->lib1611, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1611, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib161, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst161, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1611->installEventFilter(this);
ui->lib1611->setMaximumWidth( m6trail);
ui->lib1611->setMinimumWidth( m6trail);
ui->lib1611->setMaximumHeight( m7traild3 );
ui->lib1611->setMaxLength(3);
ui->lib1611->setFrame(globalFrame);

ui->lib1612->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "161   ") );
connect( ui->lib1612, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1612, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1612->installEventFilter(this);
ui->lib1612->setMaximumWidth( m26trail);
ui->lib1612->setMinimumWidth( m25trail);
ui->lib1612->setMaximumHeight( m7traild3 );
ui->lib1612->setMaxLength(24);
ui->lib1612->setFrame(globalFrame);

ui->lib1613->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "161   ") );
connect( ui->lib1613, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1613, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1613->installEventFilter(this);
ui->lib1613->setAlignment(Qt::AlignCenter);
ui->lib1613->setMaximumWidth( m12trail);
ui->lib1613->setMinimumWidth( m6trail);
ui->lib1613->setMaximumHeight( m7traild3 );
ui->lib1613->setMaxLength(11);
ui->lib1613->setFrame(globalFrame);

ui->lib1614->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "161   ") );
connect( ui->lib1614, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1614, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1614->installEventFilter(this);
ui->lib1614->setAlignment(Qt::AlignCenter);
ui->lib1614->setMaximumWidth( m12trail);
ui->lib1614->setMinimumWidth( m6trail);
ui->lib1614->setMaximumHeight( m7traild3 );
ui->lib1614->setMaxLength(11);
ui->lib1614->setFrame(globalFrame);

ui->pushButtonEst161->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "161   ") );
ui->pushButtonEst161->setMaximumWidth( m7traild3 );
ui->pushButtonEst161->setMaximumHeight( m7traild3 );
ui->pushButtonLib161->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "161   ") );
ui->pushButtonLib161->setMaximumWidth( m7traild3 );
ui->pushButtonLib161->setMaximumHeight( m7traild3 );

ui->est1611->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "161   ") );
connect( ui->est1611, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1611, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1611->installEventFilter(this);
ui->est1611->setMaximumWidth( m6trail);
ui->est1611->setMinimumWidth( m6trail);
ui->est1611->setMaximumHeight( m7traild3 );
ui->est1611->setMaxLength(3);
ui->est1611->setFrame(globalFrame);

ui->est1612->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "161   ") );
connect( ui->est1612, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1612, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1612->installEventFilter(this);
ui->est1612->setMaximumWidth( m26trail);
ui->est1612->setMinimumWidth( m25trail);
ui->est1612->setMaximumHeight( m7traild3 );
ui->est1612->setMaxLength(24);
ui->est1612->setFrame(globalFrame);

ui->est1613->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "161   ") );
connect( ui->est1613, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1613, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1613->installEventFilter(this);
ui->est1613->setAlignment(Qt::AlignCenter);
ui->est1613->setMaximumWidth( m11trail);
ui->est1613->setMinimumWidth( m6trail);
ui->est1613->setMaximumHeight( m7traild3 );
ui->est1613->setMaxLength(8);
ui->est1613->setFrame(globalFrame);

ui->est1614->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "161   ") );
connect( ui->est1614, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1614, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1614->installEventFilter(this);
ui->est1614->setAlignment(Qt::AlignCenter);
ui->est1614->setMaximumWidth( m12trail);
ui->est1614->setMinimumWidth( m6trail);
ui->est1614->setMaximumHeight( m7traild3 );
ui->est1614->setMaxLength(11);
ui->est1614->setFrame(globalFrame);

ui->est1615->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "161   ") );
connect( ui->est1615, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1615, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1615->installEventFilter(this);
ui->est1615->setAlignment(Qt::AlignCenter);
ui->est1615->setMaximumWidth( m12trail);
ui->est1615->setMinimumWidth( m6trail);
ui->est1615->setMaximumHeight( m7traild3 );
ui->est1615->setMaxLength(11);
ui->est1615->setFrame(globalFrame);

ui->est1616->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "161   ") );
ui->est1616->setReadOnly(true);
ui->est1616->setAlignment(Qt::AlignRight);
ui->est1616->setMaximumWidth( m14trail);
ui->est1616->setMinimumWidth( m9trail);
ui->est1616->setMaximumHeight( m7traild3 );
ui->est1616->setMaxLength(15);
ui->est1616->setFrame(globalFrame);

ui->est1617->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "161   ") );
ui->est1617->setReadOnly(true);
ui->est1617->setAlignment(Qt::AlignRight);
ui->est1617->setMaximumWidth( m14trail);
ui->est1617->setMinimumWidth( m9trail);
ui->est1617->setMaximumHeight( m7traild3 );
ui->est1617->setMaxLength(15);
ui->est1617->setFrame(globalFrame);

ui->lib1621->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "162   ") );
connect( ui->lib1621, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1621, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib162, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst162, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1621->installEventFilter(this);
ui->lib1621->setMaximumWidth( m6trail);
ui->lib1621->setMinimumWidth( m6trail);
ui->lib1621->setMaximumHeight( m7traild3 );
ui->lib1621->setMaxLength(3);
ui->lib1621->setFrame(globalFrame);

ui->lib1622->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "162   ") );
connect( ui->lib1622, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1622, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1622->installEventFilter(this);
ui->lib1622->setMaximumWidth( m26trail);
ui->lib1622->setMinimumWidth( m25trail);
ui->lib1622->setMaximumHeight( m7traild3 );
ui->lib1622->setMaxLength(24);
ui->lib1622->setFrame(globalFrame);

ui->lib1623->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "162   ") );
connect( ui->lib1623, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1623, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1623->installEventFilter(this);
ui->lib1623->setAlignment(Qt::AlignCenter);
ui->lib1623->setMaximumWidth( m12trail);
ui->lib1623->setMinimumWidth( m6trail);
ui->lib1623->setMaximumHeight( m7traild3 );
ui->lib1623->setMaxLength(11);
ui->lib1623->setFrame(globalFrame);

ui->lib1624->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "162   ") );
connect( ui->lib1624, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1624, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1624->installEventFilter(this);
ui->lib1624->setAlignment(Qt::AlignCenter);
ui->lib1624->setMaximumWidth( m12trail);
ui->lib1624->setMinimumWidth( m6trail);
ui->lib1624->setMaximumHeight( m7traild3 );
ui->lib1624->setMaxLength(11);
ui->lib1624->setFrame(globalFrame);

ui->pushButtonEst162->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "162   ") );
ui->pushButtonEst162->setMaximumWidth( m7traild3 );
ui->pushButtonEst162->setMaximumHeight( m7traild3 );
ui->pushButtonLib162->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "162   ") );
ui->pushButtonLib162->setMaximumWidth( m7traild3 );
ui->pushButtonLib162->setMaximumHeight( m7traild3 );

ui->est1621->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "162   ") );
connect( ui->est1621, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1621, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1621->installEventFilter(this);
ui->est1621->setMaximumWidth( m6trail);
ui->est1621->setMinimumWidth( m6trail);
ui->est1621->setMaximumHeight( m7traild3 );
ui->est1621->setMaxLength(3);
ui->est1621->setFrame(globalFrame);

ui->est1622->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "162   ") );
connect( ui->est1622, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1622, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1622->installEventFilter(this);
ui->est1622->setMaximumWidth( m26trail);
ui->est1622->setMinimumWidth( m25trail);
ui->est1622->setMaximumHeight( m7traild3 );
ui->est1622->setMaxLength(24);
ui->est1622->setFrame(globalFrame);

ui->est1623->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "162   ") );
connect( ui->est1623, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1623, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1623->installEventFilter(this);
ui->est1623->setAlignment(Qt::AlignCenter);
ui->est1623->setMaximumWidth( m11trail);
ui->est1623->setMinimumWidth( m6trail);
ui->est1623->setMaximumHeight( m7traild3 );
ui->est1623->setMaxLength(8);
ui->est1623->setFrame(globalFrame);

ui->est1624->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "162   ") );
connect( ui->est1624, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1624, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1624->installEventFilter(this);
ui->est1624->setAlignment(Qt::AlignCenter);
ui->est1624->setMaximumWidth( m12trail);
ui->est1624->setMinimumWidth( m6trail);
ui->est1624->setMaximumHeight( m7traild3 );
ui->est1624->setMaxLength(11);
ui->est1624->setFrame(globalFrame);

ui->est1625->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "162   ") );
connect( ui->est1625, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1625, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1625->installEventFilter(this);
ui->est1625->setAlignment(Qt::AlignCenter);
ui->est1625->setMaximumWidth( m12trail);
ui->est1625->setMinimumWidth( m6trail);
ui->est1625->setMaximumHeight( m7traild3 );
ui->est1625->setMaxLength(11);
ui->est1625->setFrame(globalFrame);

ui->est1626->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "162   ") );
ui->est1626->setReadOnly(true);
ui->est1626->setAlignment(Qt::AlignRight);
ui->est1626->setMaximumWidth( m14trail);
ui->est1626->setMinimumWidth( m9trail);
ui->est1626->setMaximumHeight( m7traild3 );
ui->est1626->setMaxLength(15);
ui->est1626->setFrame(globalFrame);

ui->est1627->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "162   ") );
ui->est1627->setReadOnly(true);
ui->est1627->setAlignment(Qt::AlignRight);
ui->est1627->setMaximumWidth( m14trail);
ui->est1627->setMinimumWidth( m9trail);
ui->est1627->setMaximumHeight( m7traild3 );
ui->est1627->setMaxLength(15);
ui->est1627->setFrame(globalFrame);

ui->lib1631->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "163   ") );
connect( ui->lib1631, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1631, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib163, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst163, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1631->installEventFilter(this);
ui->lib1631->setMaximumWidth( m6trail);
ui->lib1631->setMinimumWidth( m6trail);
ui->lib1631->setMaximumHeight( m7traild3 );
ui->lib1631->setMaxLength(3);
ui->lib1631->setFrame(globalFrame);

ui->lib1632->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "163   ") );
connect( ui->lib1632, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1632, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1632->installEventFilter(this);
ui->lib1632->setMaximumWidth( m26trail);
ui->lib1632->setMinimumWidth( m25trail);
ui->lib1632->setMaximumHeight( m7traild3 );
ui->lib1632->setMaxLength(24);
ui->lib1632->setFrame(globalFrame);

ui->lib1633->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "163   ") );
connect( ui->lib1633, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1633, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1633->installEventFilter(this);
ui->lib1633->setAlignment(Qt::AlignCenter);
ui->lib1633->setMaximumWidth( m12trail);
ui->lib1633->setMinimumWidth( m6trail);
ui->lib1633->setMaximumHeight( m7traild3 );
ui->lib1633->setMaxLength(11);
ui->lib1633->setFrame(globalFrame);

ui->lib1634->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "163   ") );
connect( ui->lib1634, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1634, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1634->installEventFilter(this);
ui->lib1634->setAlignment(Qt::AlignCenter);
ui->lib1634->setMaximumWidth( m12trail);
ui->lib1634->setMinimumWidth( m6trail);
ui->lib1634->setMaximumHeight( m7traild3 );
ui->lib1634->setMaxLength(11);
ui->lib1634->setFrame(globalFrame);

ui->pushButtonEst163->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "163   ") );
ui->pushButtonEst163->setMaximumWidth( m7traild3 );
ui->pushButtonEst163->setMaximumHeight( m7traild3 );
ui->pushButtonLib163->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "163   ") );
ui->pushButtonLib163->setMaximumWidth( m7traild3 );
ui->pushButtonLib163->setMaximumHeight( m7traild3 );

ui->est1631->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "163   ") );
connect( ui->est1631, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1631, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1631->installEventFilter(this);
ui->est1631->setMaximumWidth( m6trail);
ui->est1631->setMinimumWidth( m6trail);
ui->est1631->setMaximumHeight( m7traild3 );
ui->est1631->setMaxLength(3);
ui->est1631->setFrame(globalFrame);

ui->est1632->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "163   ") );
connect( ui->est1632, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1632, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1632->installEventFilter(this);
ui->est1632->setMaximumWidth( m26trail);
ui->est1632->setMinimumWidth( m25trail);
ui->est1632->setMaximumHeight( m7traild3 );
ui->est1632->setMaxLength(24);
ui->est1632->setFrame(globalFrame);

ui->est1633->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "163   ") );
connect( ui->est1633, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1633, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1633->installEventFilter(this);
ui->est1633->setAlignment(Qt::AlignCenter);
ui->est1633->setMaximumWidth( m11trail);
ui->est1633->setMinimumWidth( m6trail);
ui->est1633->setMaximumHeight( m7traild3 );
ui->est1633->setMaxLength(8);
ui->est1633->setFrame(globalFrame);

ui->est1634->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "163   ") );
connect( ui->est1634, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1634, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1634->installEventFilter(this);
ui->est1634->setAlignment(Qt::AlignCenter);
ui->est1634->setMaximumWidth( m12trail);
ui->est1634->setMinimumWidth( m6trail);
ui->est1634->setMaximumHeight( m7traild3 );
ui->est1634->setMaxLength(11);
ui->est1634->setFrame(globalFrame);

ui->est1635->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "163   ") );
connect( ui->est1635, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1635, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1635->installEventFilter(this);
ui->est1635->setAlignment(Qt::AlignCenter);
ui->est1635->setMaximumWidth( m12trail);
ui->est1635->setMinimumWidth( m6trail);
ui->est1635->setMaximumHeight( m7traild3 );
ui->est1635->setMaxLength(11);
ui->est1635->setFrame(globalFrame);

ui->est1636->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "163   ") );
ui->est1636->setReadOnly(true);
ui->est1636->setAlignment(Qt::AlignRight);
ui->est1636->setMaximumWidth( m14trail);
ui->est1636->setMinimumWidth( m9trail);
ui->est1636->setMaximumHeight( m7traild3 );
ui->est1636->setMaxLength(15);
ui->est1636->setFrame(globalFrame);

ui->est1637->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "163   ") );
ui->est1637->setReadOnly(true);
ui->est1637->setAlignment(Qt::AlignRight);
ui->est1637->setMaximumWidth( m14trail);
ui->est1637->setMinimumWidth( m9trail);
ui->est1637->setMaximumHeight( m7traild3 );
ui->est1637->setMaxLength(15);
ui->est1637->setFrame(globalFrame);

ui->lib1641->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "164   ") );
connect( ui->lib1641, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1641, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib164, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst164, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1641->installEventFilter(this);
ui->lib1641->setMaximumWidth( m6trail);
ui->lib1641->setMinimumWidth( m6trail);
ui->lib1641->setMaximumHeight( m7traild3 );
ui->lib1641->setMaxLength(3);
ui->lib1641->setFrame(globalFrame);

ui->lib1642->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "164   ") );
connect( ui->lib1642, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1642, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1642->installEventFilter(this);
ui->lib1642->setMaximumWidth( m26trail);
ui->lib1642->setMinimumWidth( m25trail);
ui->lib1642->setMaximumHeight( m7traild3 );
ui->lib1642->setMaxLength(24);
ui->lib1642->setFrame(globalFrame);

ui->lib1643->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "164   ") );
connect( ui->lib1643, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1643, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1643->installEventFilter(this);
ui->lib1643->setAlignment(Qt::AlignCenter);
ui->lib1643->setMaximumWidth( m12trail);
ui->lib1643->setMinimumWidth( m6trail);
ui->lib1643->setMaximumHeight( m7traild3 );
ui->lib1643->setMaxLength(11);
ui->lib1643->setFrame(globalFrame);

ui->lib1644->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "164   ") );
connect( ui->lib1644, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1644, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1644->installEventFilter(this);
ui->lib1644->setAlignment(Qt::AlignCenter);
ui->lib1644->setMaximumWidth( m12trail);
ui->lib1644->setMinimumWidth( m6trail);
ui->lib1644->setMaximumHeight( m7traild3 );
ui->lib1644->setMaxLength(11);
ui->lib1644->setFrame(globalFrame);

ui->pushButtonEst164->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "164   ") );
ui->pushButtonEst164->setMaximumWidth( m7traild3 );
ui->pushButtonEst164->setMaximumHeight( m7traild3 );
ui->pushButtonLib164->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "164   ") );
ui->pushButtonLib164->setMaximumWidth( m7traild3 );
ui->pushButtonLib164->setMaximumHeight( m7traild3 );

ui->est1641->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "164   ") );
connect( ui->est1641, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1641, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1641->installEventFilter(this);
ui->est1641->setMaximumWidth( m6trail);
ui->est1641->setMinimumWidth( m6trail);
ui->est1641->setMaximumHeight( m7traild3 );
ui->est1641->setMaxLength(3);
ui->est1641->setFrame(globalFrame);

ui->est1642->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "164   ") );
connect( ui->est1642, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1642, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1642->installEventFilter(this);
ui->est1642->setMaximumWidth( m26trail);
ui->est1642->setMinimumWidth( m25trail);
ui->est1642->setMaximumHeight( m7traild3 );
ui->est1642->setMaxLength(24);
ui->est1642->setFrame(globalFrame);

ui->est1643->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "164   ") );
connect( ui->est1643, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1643, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1643->installEventFilter(this);
ui->est1643->setAlignment(Qt::AlignCenter);
ui->est1643->setMaximumWidth( m11trail);
ui->est1643->setMinimumWidth( m6trail);
ui->est1643->setMaximumHeight( m7traild3 );
ui->est1643->setMaxLength(8);
ui->est1643->setFrame(globalFrame);

ui->est1644->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "164   ") );
connect( ui->est1644, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1644, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1644->installEventFilter(this);
ui->est1644->setAlignment(Qt::AlignCenter);
ui->est1644->setMaximumWidth( m12trail);
ui->est1644->setMinimumWidth( m6trail);
ui->est1644->setMaximumHeight( m7traild3 );
ui->est1644->setMaxLength(11);
ui->est1644->setFrame(globalFrame);

ui->est1645->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "164   ") );
connect( ui->est1645, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1645, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1645->installEventFilter(this);
ui->est1645->setAlignment(Qt::AlignCenter);
ui->est1645->setMaximumWidth( m12trail);
ui->est1645->setMinimumWidth( m6trail);
ui->est1645->setMaximumHeight( m7traild3 );
ui->est1645->setMaxLength(11);
ui->est1645->setFrame(globalFrame);

ui->est1646->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "164   ") );
ui->est1646->setReadOnly(true);
ui->est1646->setAlignment(Qt::AlignRight);
ui->est1646->setMaximumWidth( m14trail);
ui->est1646->setMinimumWidth( m9trail);
ui->est1646->setMaximumHeight( m7traild3 );
ui->est1646->setMaxLength(15);
ui->est1646->setFrame(globalFrame);

ui->est1647->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "164   ") );
ui->est1647->setReadOnly(true);
ui->est1647->setAlignment(Qt::AlignRight);
ui->est1647->setMaximumWidth( m14trail);
ui->est1647->setMinimumWidth( m9trail);
ui->est1647->setMaximumHeight( m7traild3 );
ui->est1647->setMaxLength(15);
ui->est1647->setFrame(globalFrame);

ui->lib1651->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "165   ") );
connect( ui->lib1651, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1651, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib165, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst165, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1651->installEventFilter(this);
ui->lib1651->setMaximumWidth( m6trail);
ui->lib1651->setMinimumWidth( m6trail);
ui->lib1651->setMaximumHeight( m7traild3 );
ui->lib1651->setMaxLength(3);
ui->lib1651->setFrame(globalFrame);

ui->lib1652->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "165   ") );
connect( ui->lib1652, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1652, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1652->installEventFilter(this);
ui->lib1652->setMaximumWidth( m26trail);
ui->lib1652->setMinimumWidth( m25trail);
ui->lib1652->setMaximumHeight( m7traild3 );
ui->lib1652->setMaxLength(24);
ui->lib1652->setFrame(globalFrame);

ui->lib1653->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "165   ") );
connect( ui->lib1653, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1653, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1653->installEventFilter(this);
ui->lib1653->setAlignment(Qt::AlignCenter);
ui->lib1653->setMaximumWidth( m12trail);
ui->lib1653->setMinimumWidth( m6trail);
ui->lib1653->setMaximumHeight( m7traild3 );
ui->lib1653->setMaxLength(11);
ui->lib1653->setFrame(globalFrame);

ui->lib1654->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "165   ") );
connect( ui->lib1654, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1654, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1654->installEventFilter(this);
ui->lib1654->setAlignment(Qt::AlignCenter);
ui->lib1654->setMaximumWidth( m12trail);
ui->lib1654->setMinimumWidth( m6trail);
ui->lib1654->setMaximumHeight( m7traild3 );
ui->lib1654->setMaxLength(11);
ui->lib1654->setFrame(globalFrame);

ui->pushButtonEst165->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "165   ") );
ui->pushButtonEst165->setMaximumWidth( m7traild3 );
ui->pushButtonEst165->setMaximumHeight( m7traild3 );
ui->pushButtonLib165->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "165   ") );
ui->pushButtonLib165->setMaximumWidth( m7traild3 );
ui->pushButtonLib165->setMaximumHeight( m7traild3 );

ui->est1651->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "165   ") );
connect( ui->est1651, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1651, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1651->installEventFilter(this);
ui->est1651->setMaximumWidth( m6trail);
ui->est1651->setMinimumWidth( m6trail);
ui->est1651->setMaximumHeight( m7traild3 );
ui->est1651->setMaxLength(3);
ui->est1651->setFrame(globalFrame);

ui->est1652->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "165   ") );
connect( ui->est1652, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1652, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1652->installEventFilter(this);
ui->est1652->setMaximumWidth( m26trail);
ui->est1652->setMinimumWidth( m25trail);
ui->est1652->setMaximumHeight( m7traild3 );
ui->est1652->setMaxLength(24);
ui->est1652->setFrame(globalFrame);

ui->est1653->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "165   ") );
connect( ui->est1653, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1653, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1653->installEventFilter(this);
ui->est1653->setAlignment(Qt::AlignCenter);
ui->est1653->setMaximumWidth( m11trail);
ui->est1653->setMinimumWidth( m6trail);
ui->est1653->setMaximumHeight( m7traild3 );
ui->est1653->setMaxLength(8);
ui->est1653->setFrame(globalFrame);

ui->est1654->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "165   ") );
connect( ui->est1654, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1654, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1654->installEventFilter(this);
ui->est1654->setAlignment(Qt::AlignCenter);
ui->est1654->setMaximumWidth( m12trail);
ui->est1654->setMinimumWidth( m6trail);
ui->est1654->setMaximumHeight( m7traild3 );
ui->est1654->setMaxLength(11);
ui->est1654->setFrame(globalFrame);

ui->est1655->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "165   ") );
connect( ui->est1655, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1655, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1655->installEventFilter(this);
ui->est1655->setAlignment(Qt::AlignCenter);
ui->est1655->setMaximumWidth( m12trail);
ui->est1655->setMinimumWidth( m6trail);
ui->est1655->setMaximumHeight( m7traild3 );
ui->est1655->setMaxLength(11);
ui->est1655->setFrame(globalFrame);

ui->est1656->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "165   ") );
ui->est1656->setReadOnly(true);
ui->est1656->setAlignment(Qt::AlignRight);
ui->est1656->setMaximumWidth( m14trail);
ui->est1656->setMinimumWidth( m9trail);
ui->est1656->setMaximumHeight( m7traild3 );
ui->est1656->setMaxLength(15);
ui->est1656->setFrame(globalFrame);

ui->est1657->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "165   ") );
ui->est1657->setReadOnly(true);
ui->est1657->setAlignment(Qt::AlignRight);
ui->est1657->setMaximumWidth( m14trail);
ui->est1657->setMinimumWidth( m9trail);
ui->est1657->setMaximumHeight( m7traild3 );
ui->est1657->setMaxLength(15);
ui->est1657->setFrame(globalFrame);

ui->lib1661->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "166   ") );
connect( ui->lib1661, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1661, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib166, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst166, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1661->installEventFilter(this);
ui->lib1661->setMaximumWidth( m6trail);
ui->lib1661->setMinimumWidth( m6trail);
ui->lib1661->setMaximumHeight( m7traild3 );
ui->lib1661->setMaxLength(3);
ui->lib1661->setFrame(globalFrame);

ui->lib1662->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "166   ") );
connect( ui->lib1662, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1662, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1662->installEventFilter(this);
ui->lib1662->setMaximumWidth( m26trail);
ui->lib1662->setMinimumWidth( m25trail);
ui->lib1662->setMaximumHeight( m7traild3 );
ui->lib1662->setMaxLength(24);
ui->lib1662->setFrame(globalFrame);

ui->lib1663->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "166   ") );
connect( ui->lib1663, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1663, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1663->installEventFilter(this);
ui->lib1663->setAlignment(Qt::AlignCenter);
ui->lib1663->setMaximumWidth( m12trail);
ui->lib1663->setMinimumWidth( m6trail);
ui->lib1663->setMaximumHeight( m7traild3 );
ui->lib1663->setMaxLength(11);
ui->lib1663->setFrame(globalFrame);

ui->lib1664->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "166   ") );
connect( ui->lib1664, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1664, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1664->installEventFilter(this);
ui->lib1664->setAlignment(Qt::AlignCenter);
ui->lib1664->setMaximumWidth( m12trail);
ui->lib1664->setMinimumWidth( m6trail);
ui->lib1664->setMaximumHeight( m7traild3 );
ui->lib1664->setMaxLength(11);
ui->lib1664->setFrame(globalFrame);

ui->pushButtonEst166->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "166   ") );
ui->pushButtonEst166->setMaximumWidth( m7traild3 );
ui->pushButtonEst166->setMaximumHeight( m7traild3 );
ui->pushButtonLib166->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "166   ") );
ui->pushButtonLib166->setMaximumWidth( m7traild3 );
ui->pushButtonLib166->setMaximumHeight( m7traild3 );

ui->est1661->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "166   ") );
connect( ui->est1661, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1661, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1661->installEventFilter(this);
ui->est1661->setMaximumWidth( m6trail);
ui->est1661->setMinimumWidth( m6trail);
ui->est1661->setMaximumHeight( m7traild3 );
ui->est1661->setMaxLength(3);
ui->est1661->setFrame(globalFrame);

ui->est1662->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "166   ") );
connect( ui->est1662, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1662, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1662->installEventFilter(this);
ui->est1662->setMaximumWidth( m26trail);
ui->est1662->setMinimumWidth( m25trail);
ui->est1662->setMaximumHeight( m7traild3 );
ui->est1662->setMaxLength(24);
ui->est1662->setFrame(globalFrame);

ui->est1663->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "166   ") );
connect( ui->est1663, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1663, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1663->installEventFilter(this);
ui->est1663->setAlignment(Qt::AlignCenter);
ui->est1663->setMaximumWidth( m11trail);
ui->est1663->setMinimumWidth( m6trail);
ui->est1663->setMaximumHeight( m7traild3 );
ui->est1663->setMaxLength(8);
ui->est1663->setFrame(globalFrame);

ui->est1664->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "166   ") );
connect( ui->est1664, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1664, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1664->installEventFilter(this);
ui->est1664->setAlignment(Qt::AlignCenter);
ui->est1664->setMaximumWidth( m12trail);
ui->est1664->setMinimumWidth( m6trail);
ui->est1664->setMaximumHeight( m7traild3 );
ui->est1664->setMaxLength(11);
ui->est1664->setFrame(globalFrame);

ui->est1665->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "166   ") );
connect( ui->est1665, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1665, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1665->installEventFilter(this);
ui->est1665->setAlignment(Qt::AlignCenter);
ui->est1665->setMaximumWidth( m12trail);
ui->est1665->setMinimumWidth( m6trail);
ui->est1665->setMaximumHeight( m7traild3 );
ui->est1665->setMaxLength(11);
ui->est1665->setFrame(globalFrame);

ui->est1666->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "166   ") );
ui->est1666->setReadOnly(true);
ui->est1666->setAlignment(Qt::AlignRight);
ui->est1666->setMaximumWidth( m14trail);
ui->est1666->setMinimumWidth( m9trail);
ui->est1666->setMaximumHeight( m7traild3 );
ui->est1666->setMaxLength(15);
ui->est1666->setFrame(globalFrame);

ui->est1667->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "166   ") );
ui->est1667->setReadOnly(true);
ui->est1667->setAlignment(Qt::AlignRight);
ui->est1667->setMaximumWidth( m14trail);
ui->est1667->setMinimumWidth( m9trail);
ui->est1667->setMaximumHeight( m7traild3 );
ui->est1667->setMaxLength(15);
ui->est1667->setFrame(globalFrame);

ui->lib1671->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "167   ") );
connect( ui->lib1671, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1671, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib167, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst167, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1671->installEventFilter(this);
ui->lib1671->setMaximumWidth( m6trail);
ui->lib1671->setMinimumWidth( m6trail);
ui->lib1671->setMaximumHeight( m7traild3 );
ui->lib1671->setMaxLength(3);
ui->lib1671->setFrame(globalFrame);

ui->lib1672->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "167   ") );
connect( ui->lib1672, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1672, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1672->installEventFilter(this);
ui->lib1672->setMaximumWidth( m26trail);
ui->lib1672->setMinimumWidth( m25trail);
ui->lib1672->setMaximumHeight( m7traild3 );
ui->lib1672->setMaxLength(24);
ui->lib1672->setFrame(globalFrame);

ui->lib1673->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "167   ") );
connect( ui->lib1673, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1673, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1673->installEventFilter(this);
ui->lib1673->setAlignment(Qt::AlignCenter);
ui->lib1673->setMaximumWidth( m12trail);
ui->lib1673->setMinimumWidth( m6trail);
ui->lib1673->setMaximumHeight( m7traild3 );
ui->lib1673->setMaxLength(11);
ui->lib1673->setFrame(globalFrame);

ui->lib1674->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "167   ") );
connect( ui->lib1674, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1674, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1674->installEventFilter(this);
ui->lib1674->setAlignment(Qt::AlignCenter);
ui->lib1674->setMaximumWidth( m12trail);
ui->lib1674->setMinimumWidth( m6trail);
ui->lib1674->setMaximumHeight( m7traild3 );
ui->lib1674->setMaxLength(11);
ui->lib1674->setFrame(globalFrame);

ui->pushButtonEst167->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "167   ") );
ui->pushButtonEst167->setMaximumWidth( m7traild3 );
ui->pushButtonEst167->setMaximumHeight( m7traild3 );
ui->pushButtonLib167->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "167   ") );
ui->pushButtonLib167->setMaximumWidth( m7traild3 );
ui->pushButtonLib167->setMaximumHeight( m7traild3 );

ui->est1671->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "167   ") );
connect( ui->est1671, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1671, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1671->installEventFilter(this);
ui->est1671->setMaximumWidth( m6trail);
ui->est1671->setMinimumWidth( m6trail);
ui->est1671->setMaximumHeight( m7traild3 );
ui->est1671->setMaxLength(3);
ui->est1671->setFrame(globalFrame);

ui->est1672->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "167   ") );
connect( ui->est1672, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1672, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1672->installEventFilter(this);
ui->est1672->setMaximumWidth( m26trail);
ui->est1672->setMinimumWidth( m25trail);
ui->est1672->setMaximumHeight( m7traild3 );
ui->est1672->setMaxLength(24);
ui->est1672->setFrame(globalFrame);

ui->est1673->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "167   ") );
connect( ui->est1673, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1673, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1673->installEventFilter(this);
ui->est1673->setAlignment(Qt::AlignCenter);
ui->est1673->setMaximumWidth( m11trail);
ui->est1673->setMinimumWidth( m6trail);
ui->est1673->setMaximumHeight( m7traild3 );
ui->est1673->setMaxLength(8);
ui->est1673->setFrame(globalFrame);

ui->est1674->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "167   ") );
connect( ui->est1674, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1674, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1674->installEventFilter(this);
ui->est1674->setAlignment(Qt::AlignCenter);
ui->est1674->setMaximumWidth( m12trail);
ui->est1674->setMinimumWidth( m6trail);
ui->est1674->setMaximumHeight( m7traild3 );
ui->est1674->setMaxLength(11);
ui->est1674->setFrame(globalFrame);

ui->est1675->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "167   ") );
connect( ui->est1675, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1675, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1675->installEventFilter(this);
ui->est1675->setAlignment(Qt::AlignCenter);
ui->est1675->setMaximumWidth( m12trail);
ui->est1675->setMinimumWidth( m6trail);
ui->est1675->setMaximumHeight( m7traild3 );
ui->est1675->setMaxLength(11);
ui->est1675->setFrame(globalFrame);

ui->est1676->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "167   ") );
ui->est1676->setReadOnly(true);
ui->est1676->setAlignment(Qt::AlignRight);
ui->est1676->setMaximumWidth( m14trail);
ui->est1676->setMinimumWidth( m9trail);
ui->est1676->setMaximumHeight( m7traild3 );
ui->est1676->setMaxLength(15);
ui->est1676->setFrame(globalFrame);

ui->est1677->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "167   ") );
ui->est1677->setReadOnly(true);
ui->est1677->setAlignment(Qt::AlignRight);
ui->est1677->setMaximumWidth( m14trail);
ui->est1677->setMinimumWidth( m9trail);
ui->est1677->setMaximumHeight( m7traild3 );
ui->est1677->setMaxLength(15);
ui->est1677->setFrame(globalFrame);

ui->lib1681->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "168   ") );
connect( ui->lib1681, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1681, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib168, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst168, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1681->installEventFilter(this);
ui->lib1681->setMaximumWidth( m6trail);
ui->lib1681->setMinimumWidth( m6trail);
ui->lib1681->setMaximumHeight( m7traild3 );
ui->lib1681->setMaxLength(3);
ui->lib1681->setFrame(globalFrame);

ui->lib1682->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "168   ") );
connect( ui->lib1682, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1682, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1682->installEventFilter(this);
ui->lib1682->setMaximumWidth( m26trail);
ui->lib1682->setMinimumWidth( m25trail);
ui->lib1682->setMaximumHeight( m7traild3 );
ui->lib1682->setMaxLength(24);
ui->lib1682->setFrame(globalFrame);

ui->lib1683->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "168   ") );
connect( ui->lib1683, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1683, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1683->installEventFilter(this);
ui->lib1683->setAlignment(Qt::AlignCenter);
ui->lib1683->setMaximumWidth( m12trail);
ui->lib1683->setMinimumWidth( m6trail);
ui->lib1683->setMaximumHeight( m7traild3 );
ui->lib1683->setMaxLength(11);
ui->lib1683->setFrame(globalFrame);

ui->lib1684->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "168   ") );
connect( ui->lib1684, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1684, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1684->installEventFilter(this);
ui->lib1684->setAlignment(Qt::AlignCenter);
ui->lib1684->setMaximumWidth( m12trail);
ui->lib1684->setMinimumWidth( m6trail);
ui->lib1684->setMaximumHeight( m7traild3 );
ui->lib1684->setMaxLength(11);
ui->lib1684->setFrame(globalFrame);

ui->pushButtonEst168->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "168   ") );
ui->pushButtonEst168->setMaximumWidth( m7traild3 );
ui->pushButtonEst168->setMaximumHeight( m7traild3 );
ui->pushButtonLib168->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "168   ") );
ui->pushButtonLib168->setMaximumWidth( m7traild3 );
ui->pushButtonLib168->setMaximumHeight( m7traild3 );

ui->est1681->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "168   ") );
connect( ui->est1681, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1681, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1681->installEventFilter(this);
ui->est1681->setMaximumWidth( m6trail);
ui->est1681->setMinimumWidth( m6trail);
ui->est1681->setMaximumHeight( m7traild3 );
ui->est1681->setMaxLength(3);
ui->est1681->setFrame(globalFrame);

ui->est1682->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "168   ") );
connect( ui->est1682, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1682, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1682->installEventFilter(this);
ui->est1682->setMaximumWidth( m26trail);
ui->est1682->setMinimumWidth( m25trail);
ui->est1682->setMaximumHeight( m7traild3 );
ui->est1682->setMaxLength(24);
ui->est1682->setFrame(globalFrame);

ui->est1683->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "168   ") );
connect( ui->est1683, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1683, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1683->installEventFilter(this);
ui->est1683->setAlignment(Qt::AlignCenter);
ui->est1683->setMaximumWidth( m11trail);
ui->est1683->setMinimumWidth( m6trail);
ui->est1683->setMaximumHeight( m7traild3 );
ui->est1683->setMaxLength(8);
ui->est1683->setFrame(globalFrame);

ui->est1684->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "168   ") );
connect( ui->est1684, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1684, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1684->installEventFilter(this);
ui->est1684->setAlignment(Qt::AlignCenter);
ui->est1684->setMaximumWidth( m12trail);
ui->est1684->setMinimumWidth( m6trail);
ui->est1684->setMaximumHeight( m7traild3 );
ui->est1684->setMaxLength(11);
ui->est1684->setFrame(globalFrame);

ui->est1685->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "168   ") );
connect( ui->est1685, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1685, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1685->installEventFilter(this);
ui->est1685->setAlignment(Qt::AlignCenter);
ui->est1685->setMaximumWidth( m12trail);
ui->est1685->setMinimumWidth( m6trail);
ui->est1685->setMaximumHeight( m7traild3 );
ui->est1685->setMaxLength(11);
ui->est1685->setFrame(globalFrame);

ui->est1686->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "168   ") );
ui->est1686->setReadOnly(true);
ui->est1686->setAlignment(Qt::AlignRight);
ui->est1686->setMaximumWidth( m14trail);
ui->est1686->setMinimumWidth( m9trail);
ui->est1686->setMaximumHeight( m7traild3 );
ui->est1686->setMaxLength(15);
ui->est1686->setFrame(globalFrame);

ui->est1687->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "168   ") );
ui->est1687->setReadOnly(true);
ui->est1687->setAlignment(Qt::AlignRight);
ui->est1687->setMaximumWidth( m14trail);
ui->est1687->setMinimumWidth( m9trail);
ui->est1687->setMaximumHeight( m7traild3 );
ui->est1687->setMaxLength(15);
ui->est1687->setFrame(globalFrame);

ui->lib1691->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "169   ") );
connect( ui->lib1691, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1691, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib169, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst169, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1691->installEventFilter(this);
ui->lib1691->setMaximumWidth( m6trail);
ui->lib1691->setMinimumWidth( m6trail);
ui->lib1691->setMaximumHeight( m7traild3 );
ui->lib1691->setMaxLength(3);
ui->lib1691->setFrame(globalFrame);

ui->lib1692->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "169   ") );
connect( ui->lib1692, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1692, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1692->installEventFilter(this);
ui->lib1692->setMaximumWidth( m26trail);
ui->lib1692->setMinimumWidth( m25trail);
ui->lib1692->setMaximumHeight( m7traild3 );
ui->lib1692->setMaxLength(24);
ui->lib1692->setFrame(globalFrame);

ui->lib1693->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "169   ") );
connect( ui->lib1693, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1693, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1693->installEventFilter(this);
ui->lib1693->setAlignment(Qt::AlignCenter);
ui->lib1693->setMaximumWidth( m12trail);
ui->lib1693->setMinimumWidth( m6trail);
ui->lib1693->setMaximumHeight( m7traild3 );
ui->lib1693->setMaxLength(11);
ui->lib1693->setFrame(globalFrame);

ui->lib1694->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "169   ") );
connect( ui->lib1694, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1694, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1694->installEventFilter(this);
ui->lib1694->setAlignment(Qt::AlignCenter);
ui->lib1694->setMaximumWidth( m12trail);
ui->lib1694->setMinimumWidth( m6trail);
ui->lib1694->setMaximumHeight( m7traild3 );
ui->lib1694->setMaxLength(11);
ui->lib1694->setFrame(globalFrame);

ui->pushButtonEst169->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "169   ") );
ui->pushButtonEst169->setMaximumWidth( m7traild3 );
ui->pushButtonEst169->setMaximumHeight( m7traild3 );
ui->pushButtonLib169->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "169   ") );
ui->pushButtonLib169->setMaximumWidth( m7traild3 );
ui->pushButtonLib169->setMaximumHeight( m7traild3 );

ui->est1691->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "169   ") );
connect( ui->est1691, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1691, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1691->installEventFilter(this);
ui->est1691->setMaximumWidth( m6trail);
ui->est1691->setMinimumWidth( m6trail);
ui->est1691->setMaximumHeight( m7traild3 );
ui->est1691->setMaxLength(3);
ui->est1691->setFrame(globalFrame);

ui->est1692->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "169   ") );
connect( ui->est1692, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1692, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1692->installEventFilter(this);
ui->est1692->setMaximumWidth( m26trail);
ui->est1692->setMinimumWidth( m25trail);
ui->est1692->setMaximumHeight( m7traild3 );
ui->est1692->setMaxLength(24);
ui->est1692->setFrame(globalFrame);

ui->est1693->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "169   ") );
connect( ui->est1693, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1693, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1693->installEventFilter(this);
ui->est1693->setAlignment(Qt::AlignCenter);
ui->est1693->setMaximumWidth( m11trail);
ui->est1693->setMinimumWidth( m6trail);
ui->est1693->setMaximumHeight( m7traild3 );
ui->est1693->setMaxLength(8);
ui->est1693->setFrame(globalFrame);

ui->est1694->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "169   ") );
connect( ui->est1694, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1694, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1694->installEventFilter(this);
ui->est1694->setAlignment(Qt::AlignCenter);
ui->est1694->setMaximumWidth( m12trail);
ui->est1694->setMinimumWidth( m6trail);
ui->est1694->setMaximumHeight( m7traild3 );
ui->est1694->setMaxLength(11);
ui->est1694->setFrame(globalFrame);

ui->est1695->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "169   ") );
connect( ui->est1695, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1695, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1695->installEventFilter(this);
ui->est1695->setAlignment(Qt::AlignCenter);
ui->est1695->setMaximumWidth( m12trail);
ui->est1695->setMinimumWidth( m6trail);
ui->est1695->setMaximumHeight( m7traild3 );
ui->est1695->setMaxLength(11);
ui->est1695->setFrame(globalFrame);

ui->est1696->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "169   ") );
ui->est1696->setReadOnly(true);
ui->est1696->setAlignment(Qt::AlignRight);
ui->est1696->setMaximumWidth( m14trail);
ui->est1696->setMinimumWidth( m9trail);
ui->est1696->setMaximumHeight( m7traild3 );
ui->est1696->setMaxLength(15);
ui->est1696->setFrame(globalFrame);

ui->est1697->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "169   ") );
ui->est1697->setReadOnly(true);
ui->est1697->setAlignment(Qt::AlignRight);
ui->est1697->setMaximumWidth( m14trail);
ui->est1697->setMinimumWidth( m9trail);
ui->est1697->setMaximumHeight( m7traild3 );
ui->est1697->setMaxLength(15);
ui->est1697->setFrame(globalFrame);

ui->lib1701->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "170   ") );
connect( ui->lib1701, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1701, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib170, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst170, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1701->installEventFilter(this);
ui->lib1701->setMaximumWidth( m6trail);
ui->lib1701->setMinimumWidth( m6trail);
ui->lib1701->setMaximumHeight( m7traild3 );
ui->lib1701->setMaxLength(3);
ui->lib1701->setFrame(globalFrame);

ui->lib1702->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "170   ") );
connect( ui->lib1702, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1702, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1702->installEventFilter(this);
ui->lib1702->setMaximumWidth( m26trail);
ui->lib1702->setMinimumWidth( m25trail);
ui->lib1702->setMaximumHeight( m7traild3 );
ui->lib1702->setMaxLength(24);
ui->lib1702->setFrame(globalFrame);

ui->lib1703->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "170   ") );
connect( ui->lib1703, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1703, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1703->installEventFilter(this);
ui->lib1703->setAlignment(Qt::AlignCenter);
ui->lib1703->setMaximumWidth( m12trail);
ui->lib1703->setMinimumWidth( m6trail);
ui->lib1703->setMaximumHeight( m7traild3 );
ui->lib1703->setMaxLength(11);
ui->lib1703->setFrame(globalFrame);

ui->lib1704->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "170   ") );
connect( ui->lib1704, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1704, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1704->installEventFilter(this);
ui->lib1704->setAlignment(Qt::AlignCenter);
ui->lib1704->setMaximumWidth( m12trail);
ui->lib1704->setMinimumWidth( m6trail);
ui->lib1704->setMaximumHeight( m7traild3 );
ui->lib1704->setMaxLength(11);
ui->lib1704->setFrame(globalFrame);

ui->pushButtonEst170->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "170   ") );
ui->pushButtonEst170->setMaximumWidth( m7traild3 );
ui->pushButtonEst170->setMaximumHeight( m7traild3 );
ui->pushButtonLib170->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "170   ") );
ui->pushButtonLib170->setMaximumWidth( m7traild3 );
ui->pushButtonLib170->setMaximumHeight( m7traild3 );

ui->est1701->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "170   ") );
connect( ui->est1701, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1701, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1701->installEventFilter(this);
ui->est1701->setMaximumWidth( m6trail);
ui->est1701->setMinimumWidth( m6trail);
ui->est1701->setMaximumHeight( m7traild3 );
ui->est1701->setMaxLength(3);
ui->est1701->setFrame(globalFrame);

ui->est1702->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "170   ") );
connect( ui->est1702, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1702, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1702->installEventFilter(this);
ui->est1702->setMaximumWidth( m26trail);
ui->est1702->setMinimumWidth( m25trail);
ui->est1702->setMaximumHeight( m7traild3 );
ui->est1702->setMaxLength(24);
ui->est1702->setFrame(globalFrame);

ui->est1703->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "170   ") );
connect( ui->est1703, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1703, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1703->installEventFilter(this);
ui->est1703->setAlignment(Qt::AlignCenter);
ui->est1703->setMaximumWidth( m11trail);
ui->est1703->setMinimumWidth( m6trail);
ui->est1703->setMaximumHeight( m7traild3 );
ui->est1703->setMaxLength(8);
ui->est1703->setFrame(globalFrame);

ui->est1704->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "170   ") );
connect( ui->est1704, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1704, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1704->installEventFilter(this);
ui->est1704->setAlignment(Qt::AlignCenter);
ui->est1704->setMaximumWidth( m12trail);
ui->est1704->setMinimumWidth( m6trail);
ui->est1704->setMaximumHeight( m7traild3 );
ui->est1704->setMaxLength(11);
ui->est1704->setFrame(globalFrame);

ui->est1705->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "170   ") );
connect( ui->est1705, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1705, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1705->installEventFilter(this);
ui->est1705->setAlignment(Qt::AlignCenter);
ui->est1705->setMaximumWidth( m12trail);
ui->est1705->setMinimumWidth( m6trail);
ui->est1705->setMaximumHeight( m7traild3 );
ui->est1705->setMaxLength(11);
ui->est1705->setFrame(globalFrame);

ui->est1706->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "170   ") );
ui->est1706->setReadOnly(true);
ui->est1706->setAlignment(Qt::AlignRight);
ui->est1706->setMaximumWidth( m14trail);
ui->est1706->setMinimumWidth( m9trail);
ui->est1706->setMaximumHeight( m7traild3 );
ui->est1706->setMaxLength(15);
ui->est1706->setFrame(globalFrame);

ui->est1707->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "170   ") );
ui->est1707->setReadOnly(true);
ui->est1707->setAlignment(Qt::AlignRight);
ui->est1707->setMaximumWidth( m14trail);
ui->est1707->setMinimumWidth( m9trail);
ui->est1707->setMaximumHeight( m7traild3 );
ui->est1707->setMaxLength(15);
ui->est1707->setFrame(globalFrame);

ui->lib1711->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "171   ") );
connect( ui->lib1711, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1711, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib171, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst171, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1711->installEventFilter(this);
ui->lib1711->setMaximumWidth( m6trail);
ui->lib1711->setMinimumWidth( m6trail);
ui->lib1711->setMaximumHeight( m7traild3 );
ui->lib1711->setMaxLength(3);
ui->lib1711->setFrame(globalFrame);

ui->lib1712->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "171   ") );
connect( ui->lib1712, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1712, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1712->installEventFilter(this);
ui->lib1712->setMaximumWidth( m26trail);
ui->lib1712->setMinimumWidth( m25trail);
ui->lib1712->setMaximumHeight( m7traild3 );
ui->lib1712->setMaxLength(24);
ui->lib1712->setFrame(globalFrame);

ui->lib1713->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "171   ") );
connect( ui->lib1713, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1713, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1713->installEventFilter(this);
ui->lib1713->setAlignment(Qt::AlignCenter);
ui->lib1713->setMaximumWidth( m12trail);
ui->lib1713->setMinimumWidth( m6trail);
ui->lib1713->setMaximumHeight( m7traild3 );
ui->lib1713->setMaxLength(11);
ui->lib1713->setFrame(globalFrame);

ui->lib1714->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "171   ") );
connect( ui->lib1714, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1714, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1714->installEventFilter(this);
ui->lib1714->setAlignment(Qt::AlignCenter);
ui->lib1714->setMaximumWidth( m12trail);
ui->lib1714->setMinimumWidth( m6trail);
ui->lib1714->setMaximumHeight( m7traild3 );
ui->lib1714->setMaxLength(11);
ui->lib1714->setFrame(globalFrame);

ui->pushButtonEst171->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "171   ") );
ui->pushButtonEst171->setMaximumWidth( m7traild3 );
ui->pushButtonEst171->setMaximumHeight( m7traild3 );
ui->pushButtonLib171->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "171   ") );
ui->pushButtonLib171->setMaximumWidth( m7traild3 );
ui->pushButtonLib171->setMaximumHeight( m7traild3 );

ui->est1711->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "171   ") );
connect( ui->est1711, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1711, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1711->installEventFilter(this);
ui->est1711->setMaximumWidth( m6trail);
ui->est1711->setMinimumWidth( m6trail);
ui->est1711->setMaximumHeight( m7traild3 );
ui->est1711->setMaxLength(3);
ui->est1711->setFrame(globalFrame);

ui->est1712->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "171   ") );
connect( ui->est1712, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1712, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1712->installEventFilter(this);
ui->est1712->setMaximumWidth( m26trail);
ui->est1712->setMinimumWidth( m25trail);
ui->est1712->setMaximumHeight( m7traild3 );
ui->est1712->setMaxLength(24);
ui->est1712->setFrame(globalFrame);

ui->est1713->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "171   ") );
connect( ui->est1713, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1713, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1713->installEventFilter(this);
ui->est1713->setAlignment(Qt::AlignCenter);
ui->est1713->setMaximumWidth( m11trail);
ui->est1713->setMinimumWidth( m6trail);
ui->est1713->setMaximumHeight( m7traild3 );
ui->est1713->setMaxLength(8);
ui->est1713->setFrame(globalFrame);

ui->est1714->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "171   ") );
connect( ui->est1714, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1714, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1714->installEventFilter(this);
ui->est1714->setAlignment(Qt::AlignCenter);
ui->est1714->setMaximumWidth( m12trail);
ui->est1714->setMinimumWidth( m6trail);
ui->est1714->setMaximumHeight( m7traild3 );
ui->est1714->setMaxLength(11);
ui->est1714->setFrame(globalFrame);

ui->est1715->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "171   ") );
connect( ui->est1715, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1715, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1715->installEventFilter(this);
ui->est1715->setAlignment(Qt::AlignCenter);
ui->est1715->setMaximumWidth( m12trail);
ui->est1715->setMinimumWidth( m6trail);
ui->est1715->setMaximumHeight( m7traild3 );
ui->est1715->setMaxLength(11);
ui->est1715->setFrame(globalFrame);

ui->est1716->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "171   ") );
ui->est1716->setReadOnly(true);
ui->est1716->setAlignment(Qt::AlignRight);
ui->est1716->setMaximumWidth( m14trail);
ui->est1716->setMinimumWidth( m9trail);
ui->est1716->setMaximumHeight( m7traild3 );
ui->est1716->setMaxLength(15);
ui->est1716->setFrame(globalFrame);

ui->est1717->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "171   ") );
ui->est1717->setReadOnly(true);
ui->est1717->setAlignment(Qt::AlignRight);
ui->est1717->setMaximumWidth( m14trail);
ui->est1717->setMinimumWidth( m9trail);
ui->est1717->setMaximumHeight( m7traild3 );
ui->est1717->setMaxLength(15);
ui->est1717->setFrame(globalFrame);

ui->lib1721->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "172   ") );
connect( ui->lib1721, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1721, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib172, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst172, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1721->installEventFilter(this);
ui->lib1721->setMaximumWidth( m6trail);
ui->lib1721->setMinimumWidth( m6trail);
ui->lib1721->setMaximumHeight( m7traild3 );
ui->lib1721->setMaxLength(3);
ui->lib1721->setFrame(globalFrame);

ui->lib1722->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "172   ") );
connect( ui->lib1722, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1722, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1722->installEventFilter(this);
ui->lib1722->setMaximumWidth( m26trail);
ui->lib1722->setMinimumWidth( m25trail);
ui->lib1722->setMaximumHeight( m7traild3 );
ui->lib1722->setMaxLength(24);
ui->lib1722->setFrame(globalFrame);

ui->lib1723->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "172   ") );
connect( ui->lib1723, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1723, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1723->installEventFilter(this);
ui->lib1723->setAlignment(Qt::AlignCenter);
ui->lib1723->setMaximumWidth( m12trail);
ui->lib1723->setMinimumWidth( m6trail);
ui->lib1723->setMaximumHeight( m7traild3 );
ui->lib1723->setMaxLength(11);
ui->lib1723->setFrame(globalFrame);

ui->lib1724->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "172   ") );
connect( ui->lib1724, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1724, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1724->installEventFilter(this);
ui->lib1724->setAlignment(Qt::AlignCenter);
ui->lib1724->setMaximumWidth( m12trail);
ui->lib1724->setMinimumWidth( m6trail);
ui->lib1724->setMaximumHeight( m7traild3 );
ui->lib1724->setMaxLength(11);
ui->lib1724->setFrame(globalFrame);

ui->pushButtonEst172->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "172   ") );
ui->pushButtonEst172->setMaximumWidth( m7traild3 );
ui->pushButtonEst172->setMaximumHeight( m7traild3 );
ui->pushButtonLib172->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "172   ") );
ui->pushButtonLib172->setMaximumWidth( m7traild3 );
ui->pushButtonLib172->setMaximumHeight( m7traild3 );

ui->est1721->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "172   ") );
connect( ui->est1721, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1721, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1721->installEventFilter(this);
ui->est1721->setMaximumWidth( m6trail);
ui->est1721->setMinimumWidth( m6trail);
ui->est1721->setMaximumHeight( m7traild3 );
ui->est1721->setMaxLength(3);
ui->est1721->setFrame(globalFrame);

ui->est1722->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "172   ") );
connect( ui->est1722, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1722, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1722->installEventFilter(this);
ui->est1722->setMaximumWidth( m26trail);
ui->est1722->setMinimumWidth( m25trail);
ui->est1722->setMaximumHeight( m7traild3 );
ui->est1722->setMaxLength(24);
ui->est1722->setFrame(globalFrame);

ui->est1723->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "172   ") );
connect( ui->est1723, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1723, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1723->installEventFilter(this);
ui->est1723->setAlignment(Qt::AlignCenter);
ui->est1723->setMaximumWidth( m11trail);
ui->est1723->setMinimumWidth( m6trail);
ui->est1723->setMaximumHeight( m7traild3 );
ui->est1723->setMaxLength(8);
ui->est1723->setFrame(globalFrame);

ui->est1724->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "172   ") );
connect( ui->est1724, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1724, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1724->installEventFilter(this);
ui->est1724->setAlignment(Qt::AlignCenter);
ui->est1724->setMaximumWidth( m12trail);
ui->est1724->setMinimumWidth( m6trail);
ui->est1724->setMaximumHeight( m7traild3 );
ui->est1724->setMaxLength(11);
ui->est1724->setFrame(globalFrame);

ui->est1725->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "172   ") );
connect( ui->est1725, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1725, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1725->installEventFilter(this);
ui->est1725->setAlignment(Qt::AlignCenter);
ui->est1725->setMaximumWidth( m12trail);
ui->est1725->setMinimumWidth( m6trail);
ui->est1725->setMaximumHeight( m7traild3 );
ui->est1725->setMaxLength(11);
ui->est1725->setFrame(globalFrame);

ui->est1726->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "172   ") );
ui->est1726->setReadOnly(true);
ui->est1726->setAlignment(Qt::AlignRight);
ui->est1726->setMaximumWidth( m14trail);
ui->est1726->setMinimumWidth( m9trail);
ui->est1726->setMaximumHeight( m7traild3 );
ui->est1726->setMaxLength(15);
ui->est1726->setFrame(globalFrame);

ui->est1727->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "172   ") );
ui->est1727->setReadOnly(true);
ui->est1727->setAlignment(Qt::AlignRight);
ui->est1727->setMaximumWidth( m14trail);
ui->est1727->setMinimumWidth( m9trail);
ui->est1727->setMaximumHeight( m7traild3 );
ui->est1727->setMaxLength(15);
ui->est1727->setFrame(globalFrame);

ui->lib1731->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "173   ") );
connect( ui->lib1731, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1731, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib173, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst173, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1731->installEventFilter(this);
ui->lib1731->setMaximumWidth( m6trail);
ui->lib1731->setMinimumWidth( m6trail);
ui->lib1731->setMaximumHeight( m7traild3 );
ui->lib1731->setMaxLength(3);
ui->lib1731->setFrame(globalFrame);

ui->lib1732->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "173   ") );
connect( ui->lib1732, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1732, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1732->installEventFilter(this);
ui->lib1732->setMaximumWidth( m26trail);
ui->lib1732->setMinimumWidth( m25trail);
ui->lib1732->setMaximumHeight( m7traild3 );
ui->lib1732->setMaxLength(24);
ui->lib1732->setFrame(globalFrame);

ui->lib1733->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "173   ") );
connect( ui->lib1733, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1733, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1733->installEventFilter(this);
ui->lib1733->setAlignment(Qt::AlignCenter);
ui->lib1733->setMaximumWidth( m12trail);
ui->lib1733->setMinimumWidth( m6trail);
ui->lib1733->setMaximumHeight( m7traild3 );
ui->lib1733->setMaxLength(11);
ui->lib1733->setFrame(globalFrame);

ui->lib1734->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "173   ") );
connect( ui->lib1734, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1734, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1734->installEventFilter(this);
ui->lib1734->setAlignment(Qt::AlignCenter);
ui->lib1734->setMaximumWidth( m12trail);
ui->lib1734->setMinimumWidth( m6trail);
ui->lib1734->setMaximumHeight( m7traild3 );
ui->lib1734->setMaxLength(11);
ui->lib1734->setFrame(globalFrame);

ui->pushButtonEst173->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "173   ") );
ui->pushButtonEst173->setMaximumWidth( m7traild3 );
ui->pushButtonEst173->setMaximumHeight( m7traild3 );
ui->pushButtonLib173->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "173   ") );
ui->pushButtonLib173->setMaximumWidth( m7traild3 );
ui->pushButtonLib173->setMaximumHeight( m7traild3 );

ui->est1731->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "173   ") );
connect( ui->est1731, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1731, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1731->installEventFilter(this);
ui->est1731->setMaximumWidth( m6trail);
ui->est1731->setMinimumWidth( m6trail);
ui->est1731->setMaximumHeight( m7traild3 );
ui->est1731->setMaxLength(3);
ui->est1731->setFrame(globalFrame);

ui->est1732->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "173   ") );
connect( ui->est1732, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1732, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1732->installEventFilter(this);
ui->est1732->setMaximumWidth( m26trail);
ui->est1732->setMinimumWidth( m25trail);
ui->est1732->setMaximumHeight( m7traild3 );
ui->est1732->setMaxLength(24);
ui->est1732->setFrame(globalFrame);

ui->est1733->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "173   ") );
connect( ui->est1733, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1733, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1733->installEventFilter(this);
ui->est1733->setAlignment(Qt::AlignCenter);
ui->est1733->setMaximumWidth( m11trail);
ui->est1733->setMinimumWidth( m6trail);
ui->est1733->setMaximumHeight( m7traild3 );
ui->est1733->setMaxLength(8);
ui->est1733->setFrame(globalFrame);

ui->est1734->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "173   ") );
connect( ui->est1734, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1734, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1734->installEventFilter(this);
ui->est1734->setAlignment(Qt::AlignCenter);
ui->est1734->setMaximumWidth( m12trail);
ui->est1734->setMinimumWidth( m6trail);
ui->est1734->setMaximumHeight( m7traild3 );
ui->est1734->setMaxLength(11);
ui->est1734->setFrame(globalFrame);

ui->est1735->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "173   ") );
connect( ui->est1735, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1735, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1735->installEventFilter(this);
ui->est1735->setAlignment(Qt::AlignCenter);
ui->est1735->setMaximumWidth( m12trail);
ui->est1735->setMinimumWidth( m6trail);
ui->est1735->setMaximumHeight( m7traild3 );
ui->est1735->setMaxLength(11);
ui->est1735->setFrame(globalFrame);

ui->est1736->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "173   ") );
ui->est1736->setReadOnly(true);
ui->est1736->setAlignment(Qt::AlignRight);
ui->est1736->setMaximumWidth( m14trail);
ui->est1736->setMinimumWidth( m9trail);
ui->est1736->setMaximumHeight( m7traild3 );
ui->est1736->setMaxLength(15);
ui->est1736->setFrame(globalFrame);

ui->est1737->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "173   ") );
ui->est1737->setReadOnly(true);
ui->est1737->setAlignment(Qt::AlignRight);
ui->est1737->setMaximumWidth( m14trail);
ui->est1737->setMinimumWidth( m9trail);
ui->est1737->setMaximumHeight( m7traild3 );
ui->est1737->setMaxLength(15);
ui->est1737->setFrame(globalFrame);

ui->lib1741->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "174   ") );
connect( ui->lib1741, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1741, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib174, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst174, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1741->installEventFilter(this);
ui->lib1741->setMaximumWidth( m6trail);
ui->lib1741->setMinimumWidth( m6trail);
ui->lib1741->setMaximumHeight( m7traild3 );
ui->lib1741->setMaxLength(3);
ui->lib1741->setFrame(globalFrame);

ui->lib1742->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "174   ") );
connect( ui->lib1742, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1742, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1742->installEventFilter(this);
ui->lib1742->setMaximumWidth( m26trail);
ui->lib1742->setMinimumWidth( m25trail);
ui->lib1742->setMaximumHeight( m7traild3 );
ui->lib1742->setMaxLength(24);
ui->lib1742->setFrame(globalFrame);

ui->lib1743->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "174   ") );
connect( ui->lib1743, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1743, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1743->installEventFilter(this);
ui->lib1743->setAlignment(Qt::AlignCenter);
ui->lib1743->setMaximumWidth( m12trail);
ui->lib1743->setMinimumWidth( m6trail);
ui->lib1743->setMaximumHeight( m7traild3 );
ui->lib1743->setMaxLength(11);
ui->lib1743->setFrame(globalFrame);

ui->lib1744->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "174   ") );
connect( ui->lib1744, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1744, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1744->installEventFilter(this);
ui->lib1744->setAlignment(Qt::AlignCenter);
ui->lib1744->setMaximumWidth( m12trail);
ui->lib1744->setMinimumWidth( m6trail);
ui->lib1744->setMaximumHeight( m7traild3 );
ui->lib1744->setMaxLength(11);
ui->lib1744->setFrame(globalFrame);

ui->pushButtonEst174->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "174   ") );
ui->pushButtonEst174->setMaximumWidth( m7traild3 );
ui->pushButtonEst174->setMaximumHeight( m7traild3 );
ui->pushButtonLib174->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "174   ") );
ui->pushButtonLib174->setMaximumWidth( m7traild3 );
ui->pushButtonLib174->setMaximumHeight( m7traild3 );

ui->est1741->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "174   ") );
connect( ui->est1741, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1741, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1741->installEventFilter(this);
ui->est1741->setMaximumWidth( m6trail);
ui->est1741->setMinimumWidth( m6trail);
ui->est1741->setMaximumHeight( m7traild3 );
ui->est1741->setMaxLength(3);
ui->est1741->setFrame(globalFrame);

ui->est1742->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "174   ") );
connect( ui->est1742, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1742, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1742->installEventFilter(this);
ui->est1742->setMaximumWidth( m26trail);
ui->est1742->setMinimumWidth( m25trail);
ui->est1742->setMaximumHeight( m7traild3 );
ui->est1742->setMaxLength(24);
ui->est1742->setFrame(globalFrame);

ui->est1743->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "174   ") );
connect( ui->est1743, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1743, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1743->installEventFilter(this);
ui->est1743->setAlignment(Qt::AlignCenter);
ui->est1743->setMaximumWidth( m11trail);
ui->est1743->setMinimumWidth( m6trail);
ui->est1743->setMaximumHeight( m7traild3 );
ui->est1743->setMaxLength(8);
ui->est1743->setFrame(globalFrame);

ui->est1744->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "174   ") );
connect( ui->est1744, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1744, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1744->installEventFilter(this);
ui->est1744->setAlignment(Qt::AlignCenter);
ui->est1744->setMaximumWidth( m12trail);
ui->est1744->setMinimumWidth( m6trail);
ui->est1744->setMaximumHeight( m7traild3 );
ui->est1744->setMaxLength(11);
ui->est1744->setFrame(globalFrame);

ui->est1745->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "174   ") );
connect( ui->est1745, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1745, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1745->installEventFilter(this);
ui->est1745->setAlignment(Qt::AlignCenter);
ui->est1745->setMaximumWidth( m12trail);
ui->est1745->setMinimumWidth( m6trail);
ui->est1745->setMaximumHeight( m7traild3 );
ui->est1745->setMaxLength(11);
ui->est1745->setFrame(globalFrame);

ui->est1746->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "174   ") );
ui->est1746->setReadOnly(true);
ui->est1746->setAlignment(Qt::AlignRight);
ui->est1746->setMaximumWidth( m14trail);
ui->est1746->setMinimumWidth( m9trail);
ui->est1746->setMaximumHeight( m7traild3 );
ui->est1746->setMaxLength(15);
ui->est1746->setFrame(globalFrame);

ui->est1747->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "174   ") );
ui->est1747->setReadOnly(true);
ui->est1747->setAlignment(Qt::AlignRight);
ui->est1747->setMaximumWidth( m14trail);
ui->est1747->setMinimumWidth( m9trail);
ui->est1747->setMaximumHeight( m7traild3 );
ui->est1747->setMaxLength(15);
ui->est1747->setFrame(globalFrame);

ui->lib1751->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "175   ") );
connect( ui->lib1751, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1751, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib175, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst175, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1751->installEventFilter(this);
ui->lib1751->setMaximumWidth( m6trail);
ui->lib1751->setMinimumWidth( m6trail);
ui->lib1751->setMaximumHeight( m7traild3 );
ui->lib1751->setMaxLength(3);
ui->lib1751->setFrame(globalFrame);

ui->lib1752->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "175   ") );
connect( ui->lib1752, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1752, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1752->installEventFilter(this);
ui->lib1752->setMaximumWidth( m26trail);
ui->lib1752->setMinimumWidth( m25trail);
ui->lib1752->setMaximumHeight( m7traild3 );
ui->lib1752->setMaxLength(24);
ui->lib1752->setFrame(globalFrame);

ui->lib1753->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "175   ") );
connect( ui->lib1753, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1753, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1753->installEventFilter(this);
ui->lib1753->setAlignment(Qt::AlignCenter);
ui->lib1753->setMaximumWidth( m12trail);
ui->lib1753->setMinimumWidth( m6trail);
ui->lib1753->setMaximumHeight( m7traild3 );
ui->lib1753->setMaxLength(11);
ui->lib1753->setFrame(globalFrame);

ui->lib1754->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "175   ") );
connect( ui->lib1754, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1754, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1754->installEventFilter(this);
ui->lib1754->setAlignment(Qt::AlignCenter);
ui->lib1754->setMaximumWidth( m12trail);
ui->lib1754->setMinimumWidth( m6trail);
ui->lib1754->setMaximumHeight( m7traild3 );
ui->lib1754->setMaxLength(11);
ui->lib1754->setFrame(globalFrame);

ui->pushButtonEst175->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "175   ") );
ui->pushButtonEst175->setMaximumWidth( m7traild3 );
ui->pushButtonEst175->setMaximumHeight( m7traild3 );
ui->pushButtonLib175->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "175   ") );
ui->pushButtonLib175->setMaximumWidth( m7traild3 );
ui->pushButtonLib175->setMaximumHeight( m7traild3 );

ui->est1751->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "175   ") );
connect( ui->est1751, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1751, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1751->installEventFilter(this);
ui->est1751->setMaximumWidth( m6trail);
ui->est1751->setMinimumWidth( m6trail);
ui->est1751->setMaximumHeight( m7traild3 );
ui->est1751->setMaxLength(3);
ui->est1751->setFrame(globalFrame);

ui->est1752->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "175   ") );
connect( ui->est1752, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1752, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1752->installEventFilter(this);
ui->est1752->setMaximumWidth( m26trail);
ui->est1752->setMinimumWidth( m25trail);
ui->est1752->setMaximumHeight( m7traild3 );
ui->est1752->setMaxLength(24);
ui->est1752->setFrame(globalFrame);

ui->est1753->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "175   ") );
connect( ui->est1753, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1753, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1753->installEventFilter(this);
ui->est1753->setAlignment(Qt::AlignCenter);
ui->est1753->setMaximumWidth( m11trail);
ui->est1753->setMinimumWidth( m6trail);
ui->est1753->setMaximumHeight( m7traild3 );
ui->est1753->setMaxLength(8);
ui->est1753->setFrame(globalFrame);

ui->est1754->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "175   ") );
connect( ui->est1754, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1754, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1754->installEventFilter(this);
ui->est1754->setAlignment(Qt::AlignCenter);
ui->est1754->setMaximumWidth( m12trail);
ui->est1754->setMinimumWidth( m6trail);
ui->est1754->setMaximumHeight( m7traild3 );
ui->est1754->setMaxLength(11);
ui->est1754->setFrame(globalFrame);

ui->est1755->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "175   ") );
connect( ui->est1755, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1755, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1755->installEventFilter(this);
ui->est1755->setAlignment(Qt::AlignCenter);
ui->est1755->setMaximumWidth( m12trail);
ui->est1755->setMinimumWidth( m6trail);
ui->est1755->setMaximumHeight( m7traild3 );
ui->est1755->setMaxLength(11);
ui->est1755->setFrame(globalFrame);

ui->est1756->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "175   ") );
ui->est1756->setReadOnly(true);
ui->est1756->setAlignment(Qt::AlignRight);
ui->est1756->setMaximumWidth( m14trail);
ui->est1756->setMinimumWidth( m9trail);
ui->est1756->setMaximumHeight( m7traild3 );
ui->est1756->setMaxLength(15);
ui->est1756->setFrame(globalFrame);

ui->est1757->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "175   ") );
ui->est1757->setReadOnly(true);
ui->est1757->setAlignment(Qt::AlignRight);
ui->est1757->setMaximumWidth( m14trail);
ui->est1757->setMinimumWidth( m9trail);
ui->est1757->setMaximumHeight( m7traild3 );
ui->est1757->setMaxLength(15);
ui->est1757->setFrame(globalFrame);

ui->lib1761->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "176   ") );
connect( ui->lib1761, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1761, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib176, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst176, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1761->installEventFilter(this);
ui->lib1761->setMaximumWidth( m6trail);
ui->lib1761->setMinimumWidth( m6trail);
ui->lib1761->setMaximumHeight( m7traild3 );
ui->lib1761->setMaxLength(3);
ui->lib1761->setFrame(globalFrame);

ui->lib1762->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "176   ") );
connect( ui->lib1762, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1762, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1762->installEventFilter(this);
ui->lib1762->setMaximumWidth( m26trail);
ui->lib1762->setMinimumWidth( m25trail);
ui->lib1762->setMaximumHeight( m7traild3 );
ui->lib1762->setMaxLength(24);
ui->lib1762->setFrame(globalFrame);

ui->lib1763->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "176   ") );
connect( ui->lib1763, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1763, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1763->installEventFilter(this);
ui->lib1763->setAlignment(Qt::AlignCenter);
ui->lib1763->setMaximumWidth( m12trail);
ui->lib1763->setMinimumWidth( m6trail);
ui->lib1763->setMaximumHeight( m7traild3 );
ui->lib1763->setMaxLength(11);
ui->lib1763->setFrame(globalFrame);

ui->lib1764->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "176   ") );
connect( ui->lib1764, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1764, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1764->installEventFilter(this);
ui->lib1764->setAlignment(Qt::AlignCenter);
ui->lib1764->setMaximumWidth( m12trail);
ui->lib1764->setMinimumWidth( m6trail);
ui->lib1764->setMaximumHeight( m7traild3 );
ui->lib1764->setMaxLength(11);
ui->lib1764->setFrame(globalFrame);

ui->pushButtonEst176->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "176   ") );
ui->pushButtonEst176->setMaximumWidth( m7traild3 );
ui->pushButtonEst176->setMaximumHeight( m7traild3 );
ui->pushButtonLib176->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "176   ") );
ui->pushButtonLib176->setMaximumWidth( m7traild3 );
ui->pushButtonLib176->setMaximumHeight( m7traild3 );

ui->est1761->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "176   ") );
connect( ui->est1761, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1761, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1761->installEventFilter(this);
ui->est1761->setMaximumWidth( m6trail);
ui->est1761->setMinimumWidth( m6trail);
ui->est1761->setMaximumHeight( m7traild3 );
ui->est1761->setMaxLength(3);
ui->est1761->setFrame(globalFrame);

ui->est1762->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "176   ") );
connect( ui->est1762, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1762, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1762->installEventFilter(this);
ui->est1762->setMaximumWidth( m26trail);
ui->est1762->setMinimumWidth( m25trail);
ui->est1762->setMaximumHeight( m7traild3 );
ui->est1762->setMaxLength(24);
ui->est1762->setFrame(globalFrame);

ui->est1763->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "176   ") );
connect( ui->est1763, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1763, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1763->installEventFilter(this);
ui->est1763->setAlignment(Qt::AlignCenter);
ui->est1763->setMaximumWidth( m11trail);
ui->est1763->setMinimumWidth( m6trail);
ui->est1763->setMaximumHeight( m7traild3 );
ui->est1763->setMaxLength(8);
ui->est1763->setFrame(globalFrame);

ui->est1764->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "176   ") );
connect( ui->est1764, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1764, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1764->installEventFilter(this);
ui->est1764->setAlignment(Qt::AlignCenter);
ui->est1764->setMaximumWidth( m12trail);
ui->est1764->setMinimumWidth( m6trail);
ui->est1764->setMaximumHeight( m7traild3 );
ui->est1764->setMaxLength(11);
ui->est1764->setFrame(globalFrame);

ui->est1765->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "176   ") );
connect( ui->est1765, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1765, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1765->installEventFilter(this);
ui->est1765->setAlignment(Qt::AlignCenter);
ui->est1765->setMaximumWidth( m12trail);
ui->est1765->setMinimumWidth( m6trail);
ui->est1765->setMaximumHeight( m7traild3 );
ui->est1765->setMaxLength(11);
ui->est1765->setFrame(globalFrame);

ui->est1766->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "176   ") );
ui->est1766->setReadOnly(true);
ui->est1766->setAlignment(Qt::AlignRight);
ui->est1766->setMaximumWidth( m14trail);
ui->est1766->setMinimumWidth( m9trail);
ui->est1766->setMaximumHeight( m7traild3 );
ui->est1766->setMaxLength(15);
ui->est1766->setFrame(globalFrame);

ui->est1767->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "176   ") );
ui->est1767->setReadOnly(true);
ui->est1767->setAlignment(Qt::AlignRight);
ui->est1767->setMaximumWidth( m14trail);
ui->est1767->setMinimumWidth( m9trail);
ui->est1767->setMaximumHeight( m7traild3 );
ui->est1767->setMaxLength(15);
ui->est1767->setFrame(globalFrame);

ui->lib1771->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "177   ") );
connect( ui->lib1771, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1771, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib177, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst177, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1771->installEventFilter(this);
ui->lib1771->setMaximumWidth( m6trail);
ui->lib1771->setMinimumWidth( m6trail);
ui->lib1771->setMaximumHeight( m7traild3 );
ui->lib1771->setMaxLength(3);
ui->lib1771->setFrame(globalFrame);

ui->lib1772->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "177   ") );
connect( ui->lib1772, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1772, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1772->installEventFilter(this);
ui->lib1772->setMaximumWidth( m26trail);
ui->lib1772->setMinimumWidth( m25trail);
ui->lib1772->setMaximumHeight( m7traild3 );
ui->lib1772->setMaxLength(24);
ui->lib1772->setFrame(globalFrame);

ui->lib1773->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "177   ") );
connect( ui->lib1773, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1773, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1773->installEventFilter(this);
ui->lib1773->setAlignment(Qt::AlignCenter);
ui->lib1773->setMaximumWidth( m12trail);
ui->lib1773->setMinimumWidth( m6trail);
ui->lib1773->setMaximumHeight( m7traild3 );
ui->lib1773->setMaxLength(11);
ui->lib1773->setFrame(globalFrame);

ui->lib1774->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "177   ") );
connect( ui->lib1774, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1774, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1774->installEventFilter(this);
ui->lib1774->setAlignment(Qt::AlignCenter);
ui->lib1774->setMaximumWidth( m12trail);
ui->lib1774->setMinimumWidth( m6trail);
ui->lib1774->setMaximumHeight( m7traild3 );
ui->lib1774->setMaxLength(11);
ui->lib1774->setFrame(globalFrame);

ui->pushButtonEst177->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "177   ") );
ui->pushButtonEst177->setMaximumWidth( m7traild3 );
ui->pushButtonEst177->setMaximumHeight( m7traild3 );
ui->pushButtonLib177->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "177   ") );
ui->pushButtonLib177->setMaximumWidth( m7traild3 );
ui->pushButtonLib177->setMaximumHeight( m7traild3 );

ui->est1771->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "177   ") );
connect( ui->est1771, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1771, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1771->installEventFilter(this);
ui->est1771->setMaximumWidth( m6trail);
ui->est1771->setMinimumWidth( m6trail);
ui->est1771->setMaximumHeight( m7traild3 );
ui->est1771->setMaxLength(3);
ui->est1771->setFrame(globalFrame);

ui->est1772->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "177   ") );
connect( ui->est1772, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1772, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1772->installEventFilter(this);
ui->est1772->setMaximumWidth( m26trail);
ui->est1772->setMinimumWidth( m25trail);
ui->est1772->setMaximumHeight( m7traild3 );
ui->est1772->setMaxLength(24);
ui->est1772->setFrame(globalFrame);

ui->est1773->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "177   ") );
connect( ui->est1773, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1773, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1773->installEventFilter(this);
ui->est1773->setAlignment(Qt::AlignCenter);
ui->est1773->setMaximumWidth( m11trail);
ui->est1773->setMinimumWidth( m6trail);
ui->est1773->setMaximumHeight( m7traild3 );
ui->est1773->setMaxLength(8);
ui->est1773->setFrame(globalFrame);

ui->est1774->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "177   ") );
connect( ui->est1774, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1774, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1774->installEventFilter(this);
ui->est1774->setAlignment(Qt::AlignCenter);
ui->est1774->setMaximumWidth( m12trail);
ui->est1774->setMinimumWidth( m6trail);
ui->est1774->setMaximumHeight( m7traild3 );
ui->est1774->setMaxLength(11);
ui->est1774->setFrame(globalFrame);

ui->est1775->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "177   ") );
connect( ui->est1775, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1775, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1775->installEventFilter(this);
ui->est1775->setAlignment(Qt::AlignCenter);
ui->est1775->setMaximumWidth( m12trail);
ui->est1775->setMinimumWidth( m6trail);
ui->est1775->setMaximumHeight( m7traild3 );
ui->est1775->setMaxLength(11);
ui->est1775->setFrame(globalFrame);

ui->est1776->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "177   ") );
ui->est1776->setReadOnly(true);
ui->est1776->setAlignment(Qt::AlignRight);
ui->est1776->setMaximumWidth( m14trail);
ui->est1776->setMinimumWidth( m9trail);
ui->est1776->setMaximumHeight( m7traild3 );
ui->est1776->setMaxLength(15);
ui->est1776->setFrame(globalFrame);

ui->est1777->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "177   ") );
ui->est1777->setReadOnly(true);
ui->est1777->setAlignment(Qt::AlignRight);
ui->est1777->setMaximumWidth( m14trail);
ui->est1777->setMinimumWidth( m9trail);
ui->est1777->setMaximumHeight( m7traild3 );
ui->est1777->setMaxLength(15);
ui->est1777->setFrame(globalFrame);

ui->lib1781->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "178   ") );
connect( ui->lib1781, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1781, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib178, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst178, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1781->installEventFilter(this);
ui->lib1781->setMaximumWidth( m6trail);
ui->lib1781->setMinimumWidth( m6trail);
ui->lib1781->setMaximumHeight( m7traild3 );
ui->lib1781->setMaxLength(3);
ui->lib1781->setFrame(globalFrame);

ui->lib1782->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "178   ") );
connect( ui->lib1782, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1782, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1782->installEventFilter(this);
ui->lib1782->setMaximumWidth( m26trail);
ui->lib1782->setMinimumWidth( m25trail);
ui->lib1782->setMaximumHeight( m7traild3 );
ui->lib1782->setMaxLength(24);
ui->lib1782->setFrame(globalFrame);

ui->lib1783->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "178   ") );
connect( ui->lib1783, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1783, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1783->installEventFilter(this);
ui->lib1783->setAlignment(Qt::AlignCenter);
ui->lib1783->setMaximumWidth( m12trail);
ui->lib1783->setMinimumWidth( m6trail);
ui->lib1783->setMaximumHeight( m7traild3 );
ui->lib1783->setMaxLength(11);
ui->lib1783->setFrame(globalFrame);

ui->lib1784->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "178   ") );
connect( ui->lib1784, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1784, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1784->installEventFilter(this);
ui->lib1784->setAlignment(Qt::AlignCenter);
ui->lib1784->setMaximumWidth( m12trail);
ui->lib1784->setMinimumWidth( m6trail);
ui->lib1784->setMaximumHeight( m7traild3 );
ui->lib1784->setMaxLength(11);
ui->lib1784->setFrame(globalFrame);

ui->pushButtonEst178->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "178   ") );
ui->pushButtonEst178->setMaximumWidth( m7traild3 );
ui->pushButtonEst178->setMaximumHeight( m7traild3 );
ui->pushButtonLib178->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "178   ") );
ui->pushButtonLib178->setMaximumWidth( m7traild3 );
ui->pushButtonLib178->setMaximumHeight( m7traild3 );

ui->est1781->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "178   ") );
connect( ui->est1781, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1781, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1781->installEventFilter(this);
ui->est1781->setMaximumWidth( m6trail);
ui->est1781->setMinimumWidth( m6trail);
ui->est1781->setMaximumHeight( m7traild3 );
ui->est1781->setMaxLength(3);
ui->est1781->setFrame(globalFrame);

ui->est1782->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "178   ") );
connect( ui->est1782, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1782, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1782->installEventFilter(this);
ui->est1782->setMaximumWidth( m26trail);
ui->est1782->setMinimumWidth( m25trail);
ui->est1782->setMaximumHeight( m7traild3 );
ui->est1782->setMaxLength(24);
ui->est1782->setFrame(globalFrame);

ui->est1783->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "178   ") );
connect( ui->est1783, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1783, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1783->installEventFilter(this);
ui->est1783->setAlignment(Qt::AlignCenter);
ui->est1783->setMaximumWidth( m11trail);
ui->est1783->setMinimumWidth( m6trail);
ui->est1783->setMaximumHeight( m7traild3 );
ui->est1783->setMaxLength(8);
ui->est1783->setFrame(globalFrame);

ui->est1784->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "178   ") );
connect( ui->est1784, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1784, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1784->installEventFilter(this);
ui->est1784->setAlignment(Qt::AlignCenter);
ui->est1784->setMaximumWidth( m12trail);
ui->est1784->setMinimumWidth( m6trail);
ui->est1784->setMaximumHeight( m7traild3 );
ui->est1784->setMaxLength(11);
ui->est1784->setFrame(globalFrame);

ui->est1785->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "178   ") );
connect( ui->est1785, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1785, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1785->installEventFilter(this);
ui->est1785->setAlignment(Qt::AlignCenter);
ui->est1785->setMaximumWidth( m12trail);
ui->est1785->setMinimumWidth( m6trail);
ui->est1785->setMaximumHeight( m7traild3 );
ui->est1785->setMaxLength(11);
ui->est1785->setFrame(globalFrame);

ui->est1786->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "178   ") );
ui->est1786->setReadOnly(true);
ui->est1786->setAlignment(Qt::AlignRight);
ui->est1786->setMaximumWidth( m14trail);
ui->est1786->setMinimumWidth( m9trail);
ui->est1786->setMaximumHeight( m7traild3 );
ui->est1786->setMaxLength(15);
ui->est1786->setFrame(globalFrame);

ui->est1787->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "178   ") );
ui->est1787->setReadOnly(true);
ui->est1787->setAlignment(Qt::AlignRight);
ui->est1787->setMaximumWidth( m14trail);
ui->est1787->setMinimumWidth( m9trail);
ui->est1787->setMaximumHeight( m7traild3 );
ui->est1787->setMaxLength(15);
ui->est1787->setFrame(globalFrame);

ui->lib1791->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "179   ") );
connect( ui->lib1791, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1791, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib179, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst179, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1791->installEventFilter(this);
ui->lib1791->setMaximumWidth( m6trail);
ui->lib1791->setMinimumWidth( m6trail);
ui->lib1791->setMaximumHeight( m7traild3 );
ui->lib1791->setMaxLength(3);
ui->lib1791->setFrame(globalFrame);

ui->lib1792->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "179   ") );
connect( ui->lib1792, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1792, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1792->installEventFilter(this);
ui->lib1792->setMaximumWidth( m26trail);
ui->lib1792->setMinimumWidth( m25trail);
ui->lib1792->setMaximumHeight( m7traild3 );
ui->lib1792->setMaxLength(24);
ui->lib1792->setFrame(globalFrame);

ui->lib1793->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "179   ") );
connect( ui->lib1793, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1793, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1793->installEventFilter(this);
ui->lib1793->setAlignment(Qt::AlignCenter);
ui->lib1793->setMaximumWidth( m12trail);
ui->lib1793->setMinimumWidth( m6trail);
ui->lib1793->setMaximumHeight( m7traild3 );
ui->lib1793->setMaxLength(11);
ui->lib1793->setFrame(globalFrame);

ui->lib1794->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "179   ") );
connect( ui->lib1794, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1794, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1794->installEventFilter(this);
ui->lib1794->setAlignment(Qt::AlignCenter);
ui->lib1794->setMaximumWidth( m12trail);
ui->lib1794->setMinimumWidth( m6trail);
ui->lib1794->setMaximumHeight( m7traild3 );
ui->lib1794->setMaxLength(11);
ui->lib1794->setFrame(globalFrame);

ui->pushButtonEst179->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "179   ") );
ui->pushButtonEst179->setMaximumWidth( m7traild3 );
ui->pushButtonEst179->setMaximumHeight( m7traild3 );
ui->pushButtonLib179->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "179   ") );
ui->pushButtonLib179->setMaximumWidth( m7traild3 );
ui->pushButtonLib179->setMaximumHeight( m7traild3 );

ui->est1791->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "179   ") );
connect( ui->est1791, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1791, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1791->installEventFilter(this);
ui->est1791->setMaximumWidth( m6trail);
ui->est1791->setMinimumWidth( m6trail);
ui->est1791->setMaximumHeight( m7traild3 );
ui->est1791->setMaxLength(3);
ui->est1791->setFrame(globalFrame);

ui->est1792->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "179   ") );
connect( ui->est1792, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1792, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1792->installEventFilter(this);
ui->est1792->setMaximumWidth( m26trail);
ui->est1792->setMinimumWidth( m25trail);
ui->est1792->setMaximumHeight( m7traild3 );
ui->est1792->setMaxLength(24);
ui->est1792->setFrame(globalFrame);

ui->est1793->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "179   ") );
connect( ui->est1793, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1793, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1793->installEventFilter(this);
ui->est1793->setAlignment(Qt::AlignCenter);
ui->est1793->setMaximumWidth( m11trail);
ui->est1793->setMinimumWidth( m6trail);
ui->est1793->setMaximumHeight( m7traild3 );
ui->est1793->setMaxLength(8);
ui->est1793->setFrame(globalFrame);

ui->est1794->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "179   ") );
connect( ui->est1794, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1794, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1794->installEventFilter(this);
ui->est1794->setAlignment(Qt::AlignCenter);
ui->est1794->setMaximumWidth( m12trail);
ui->est1794->setMinimumWidth( m6trail);
ui->est1794->setMaximumHeight( m7traild3 );
ui->est1794->setMaxLength(11);
ui->est1794->setFrame(globalFrame);

ui->est1795->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "179   ") );
connect( ui->est1795, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1795, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1795->installEventFilter(this);
ui->est1795->setAlignment(Qt::AlignCenter);
ui->est1795->setMaximumWidth( m12trail);
ui->est1795->setMinimumWidth( m6trail);
ui->est1795->setMaximumHeight( m7traild3 );
ui->est1795->setMaxLength(11);
ui->est1795->setFrame(globalFrame);

ui->est1796->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "179   ") );
ui->est1796->setReadOnly(true);
ui->est1796->setAlignment(Qt::AlignRight);
ui->est1796->setMaximumWidth( m14trail);
ui->est1796->setMinimumWidth( m9trail);
ui->est1796->setMaximumHeight( m7traild3 );
ui->est1796->setMaxLength(15);
ui->est1796->setFrame(globalFrame);

ui->est1797->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "179   ") );
ui->est1797->setReadOnly(true);
ui->est1797->setAlignment(Qt::AlignRight);
ui->est1797->setMaximumWidth( m14trail);
ui->est1797->setMinimumWidth( m9trail);
ui->est1797->setMaximumHeight( m7traild3 );
ui->est1797->setMaxLength(15);
ui->est1797->setFrame(globalFrame);

ui->lib1801->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "180   ") );
connect( ui->lib1801, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1801, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib180, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst180, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1801->installEventFilter(this);
ui->lib1801->setMaximumWidth( m6trail);
ui->lib1801->setMinimumWidth( m6trail);
ui->lib1801->setMaximumHeight( m7traild3 );
ui->lib1801->setMaxLength(3);
ui->lib1801->setFrame(globalFrame);

ui->lib1802->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "180   ") );
connect( ui->lib1802, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1802, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1802->installEventFilter(this);
ui->lib1802->setMaximumWidth( m26trail);
ui->lib1802->setMinimumWidth( m25trail);
ui->lib1802->setMaximumHeight( m7traild3 );
ui->lib1802->setMaxLength(24);
ui->lib1802->setFrame(globalFrame);

ui->lib1803->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "180   ") );
connect( ui->lib1803, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1803, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1803->installEventFilter(this);
ui->lib1803->setAlignment(Qt::AlignCenter);
ui->lib1803->setMaximumWidth( m12trail);
ui->lib1803->setMinimumWidth( m6trail);
ui->lib1803->setMaximumHeight( m7traild3 );
ui->lib1803->setMaxLength(11);
ui->lib1803->setFrame(globalFrame);

ui->lib1804->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "180   ") );
connect( ui->lib1804, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1804, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1804->installEventFilter(this);
ui->lib1804->setAlignment(Qt::AlignCenter);
ui->lib1804->setMaximumWidth( m12trail);
ui->lib1804->setMinimumWidth( m6trail);
ui->lib1804->setMaximumHeight( m7traild3 );
ui->lib1804->setMaxLength(11);
ui->lib1804->setFrame(globalFrame);

ui->pushButtonEst180->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "180   ") );
ui->pushButtonEst180->setMaximumWidth( m7traild3 );
ui->pushButtonEst180->setMaximumHeight( m7traild3 );
ui->pushButtonLib180->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "180   ") );
ui->pushButtonLib180->setMaximumWidth( m7traild3 );
ui->pushButtonLib180->setMaximumHeight( m7traild3 );

ui->est1801->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "180   ") );
connect( ui->est1801, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1801, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1801->installEventFilter(this);
ui->est1801->setMaximumWidth( m6trail);
ui->est1801->setMinimumWidth( m6trail);
ui->est1801->setMaximumHeight( m7traild3 );
ui->est1801->setMaxLength(3);
ui->est1801->setFrame(globalFrame);

ui->est1802->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "180   ") );
connect( ui->est1802, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1802, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1802->installEventFilter(this);
ui->est1802->setMaximumWidth( m26trail);
ui->est1802->setMinimumWidth( m25trail);
ui->est1802->setMaximumHeight( m7traild3 );
ui->est1802->setMaxLength(24);
ui->est1802->setFrame(globalFrame);

ui->est1803->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "180   ") );
connect( ui->est1803, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1803, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1803->installEventFilter(this);
ui->est1803->setAlignment(Qt::AlignCenter);
ui->est1803->setMaximumWidth( m11trail);
ui->est1803->setMinimumWidth( m6trail);
ui->est1803->setMaximumHeight( m7traild3 );
ui->est1803->setMaxLength(8);
ui->est1803->setFrame(globalFrame);

ui->est1804->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "180   ") );
connect( ui->est1804, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1804, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1804->installEventFilter(this);
ui->est1804->setAlignment(Qt::AlignCenter);
ui->est1804->setMaximumWidth( m12trail);
ui->est1804->setMinimumWidth( m6trail);
ui->est1804->setMaximumHeight( m7traild3 );
ui->est1804->setMaxLength(11);
ui->est1804->setFrame(globalFrame);

ui->est1805->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "180   ") );
connect( ui->est1805, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1805, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1805->installEventFilter(this);
ui->est1805->setAlignment(Qt::AlignCenter);
ui->est1805->setMaximumWidth( m12trail);
ui->est1805->setMinimumWidth( m6trail);
ui->est1805->setMaximumHeight( m7traild3 );
ui->est1805->setMaxLength(11);
ui->est1805->setFrame(globalFrame);

ui->est1806->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "180   ") );
ui->est1806->setReadOnly(true);
ui->est1806->setAlignment(Qt::AlignRight);
ui->est1806->setMaximumWidth( m14trail);
ui->est1806->setMinimumWidth( m9trail);
ui->est1806->setMaximumHeight( m7traild3 );
ui->est1806->setMaxLength(15);
ui->est1806->setFrame(globalFrame);

ui->est1807->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "180   ") );
ui->est1807->setReadOnly(true);
ui->est1807->setAlignment(Qt::AlignRight);
ui->est1807->setMaximumWidth( m14trail);
ui->est1807->setMinimumWidth( m9trail);
ui->est1807->setMaximumHeight( m7traild3 );
ui->est1807->setMaxLength(15);
ui->est1807->setFrame(globalFrame);

ui->lib1811->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "181   ") );
connect( ui->lib1811, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1811, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib181, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst181, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1811->installEventFilter(this);
ui->lib1811->setMaximumWidth( m6trail);
ui->lib1811->setMinimumWidth( m6trail);
ui->lib1811->setMaximumHeight( m7traild3 );
ui->lib1811->setMaxLength(3);
ui->lib1811->setFrame(globalFrame);

ui->lib1812->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "181   ") );
connect( ui->lib1812, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1812, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1812->installEventFilter(this);
ui->lib1812->setMaximumWidth( m26trail);
ui->lib1812->setMinimumWidth( m25trail);
ui->lib1812->setMaximumHeight( m7traild3 );
ui->lib1812->setMaxLength(24);
ui->lib1812->setFrame(globalFrame);

ui->lib1813->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "181   ") );
connect( ui->lib1813, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1813, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1813->installEventFilter(this);
ui->lib1813->setAlignment(Qt::AlignCenter);
ui->lib1813->setMaximumWidth( m12trail);
ui->lib1813->setMinimumWidth( m6trail);
ui->lib1813->setMaximumHeight( m7traild3 );
ui->lib1813->setMaxLength(11);
ui->lib1813->setFrame(globalFrame);

ui->lib1814->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "181   ") );
connect( ui->lib1814, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1814, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1814->installEventFilter(this);
ui->lib1814->setAlignment(Qt::AlignCenter);
ui->lib1814->setMaximumWidth( m12trail);
ui->lib1814->setMinimumWidth( m6trail);
ui->lib1814->setMaximumHeight( m7traild3 );
ui->lib1814->setMaxLength(11);
ui->lib1814->setFrame(globalFrame);

ui->pushButtonEst181->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "181   ") );
ui->pushButtonEst181->setMaximumWidth( m7traild3 );
ui->pushButtonEst181->setMaximumHeight( m7traild3 );
ui->pushButtonLib181->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "181   ") );
ui->pushButtonLib181->setMaximumWidth( m7traild3 );
ui->pushButtonLib181->setMaximumHeight( m7traild3 );

ui->est1811->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "181   ") );
connect( ui->est1811, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1811, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1811->installEventFilter(this);
ui->est1811->setMaximumWidth( m6trail);
ui->est1811->setMinimumWidth( m6trail);
ui->est1811->setMaximumHeight( m7traild3 );
ui->est1811->setMaxLength(3);
ui->est1811->setFrame(globalFrame);

ui->est1812->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "181   ") );
connect( ui->est1812, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1812, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1812->installEventFilter(this);
ui->est1812->setMaximumWidth( m26trail);
ui->est1812->setMinimumWidth( m25trail);
ui->est1812->setMaximumHeight( m7traild3 );
ui->est1812->setMaxLength(24);
ui->est1812->setFrame(globalFrame);

ui->est1813->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "181   ") );
connect( ui->est1813, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1813, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1813->installEventFilter(this);
ui->est1813->setAlignment(Qt::AlignCenter);
ui->est1813->setMaximumWidth( m11trail);
ui->est1813->setMinimumWidth( m6trail);
ui->est1813->setMaximumHeight( m7traild3 );
ui->est1813->setMaxLength(8);
ui->est1813->setFrame(globalFrame);

ui->est1814->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "181   ") );
connect( ui->est1814, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1814, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1814->installEventFilter(this);
ui->est1814->setAlignment(Qt::AlignCenter);
ui->est1814->setMaximumWidth( m12trail);
ui->est1814->setMinimumWidth( m6trail);
ui->est1814->setMaximumHeight( m7traild3 );
ui->est1814->setMaxLength(11);
ui->est1814->setFrame(globalFrame);

ui->est1815->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "181   ") );
connect( ui->est1815, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1815, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1815->installEventFilter(this);
ui->est1815->setAlignment(Qt::AlignCenter);
ui->est1815->setMaximumWidth( m12trail);
ui->est1815->setMinimumWidth( m6trail);
ui->est1815->setMaximumHeight( m7traild3 );
ui->est1815->setMaxLength(11);
ui->est1815->setFrame(globalFrame);

ui->est1816->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "181   ") );
ui->est1816->setReadOnly(true);
ui->est1816->setAlignment(Qt::AlignRight);
ui->est1816->setMaximumWidth( m14trail);
ui->est1816->setMinimumWidth( m9trail);
ui->est1816->setMaximumHeight( m7traild3 );
ui->est1816->setMaxLength(15);
ui->est1816->setFrame(globalFrame);

ui->est1817->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "181   ") );
ui->est1817->setReadOnly(true);
ui->est1817->setAlignment(Qt::AlignRight);
ui->est1817->setMaximumWidth( m14trail);
ui->est1817->setMinimumWidth( m9trail);
ui->est1817->setMaximumHeight( m7traild3 );
ui->est1817->setMaxLength(15);
ui->est1817->setFrame(globalFrame);

ui->lib1821->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "182   ") );
connect( ui->lib1821, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1821, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib182, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst182, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1821->installEventFilter(this);
ui->lib1821->setMaximumWidth( m6trail);
ui->lib1821->setMinimumWidth( m6trail);
ui->lib1821->setMaximumHeight( m7traild3 );
ui->lib1821->setMaxLength(3);
ui->lib1821->setFrame(globalFrame);

ui->lib1822->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "182   ") );
connect( ui->lib1822, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1822, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1822->installEventFilter(this);
ui->lib1822->setMaximumWidth( m26trail);
ui->lib1822->setMinimumWidth( m25trail);
ui->lib1822->setMaximumHeight( m7traild3 );
ui->lib1822->setMaxLength(24);
ui->lib1822->setFrame(globalFrame);

ui->lib1823->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "182   ") );
connect( ui->lib1823, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1823, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1823->installEventFilter(this);
ui->lib1823->setAlignment(Qt::AlignCenter);
ui->lib1823->setMaximumWidth( m12trail);
ui->lib1823->setMinimumWidth( m6trail);
ui->lib1823->setMaximumHeight( m7traild3 );
ui->lib1823->setMaxLength(11);
ui->lib1823->setFrame(globalFrame);

ui->lib1824->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "182   ") );
connect( ui->lib1824, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1824, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1824->installEventFilter(this);
ui->lib1824->setAlignment(Qt::AlignCenter);
ui->lib1824->setMaximumWidth( m12trail);
ui->lib1824->setMinimumWidth( m6trail);
ui->lib1824->setMaximumHeight( m7traild3 );
ui->lib1824->setMaxLength(11);
ui->lib1824->setFrame(globalFrame);

ui->pushButtonEst182->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "182   ") );
ui->pushButtonEst182->setMaximumWidth( m7traild3 );
ui->pushButtonEst182->setMaximumHeight( m7traild3 );
ui->pushButtonLib182->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "182   ") );
ui->pushButtonLib182->setMaximumWidth( m7traild3 );
ui->pushButtonLib182->setMaximumHeight( m7traild3 );

ui->est1821->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "182   ") );
connect( ui->est1821, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1821, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1821->installEventFilter(this);
ui->est1821->setMaximumWidth( m6trail);
ui->est1821->setMinimumWidth( m6trail);
ui->est1821->setMaximumHeight( m7traild3 );
ui->est1821->setMaxLength(3);
ui->est1821->setFrame(globalFrame);

ui->est1822->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "182   ") );
connect( ui->est1822, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1822, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1822->installEventFilter(this);
ui->est1822->setMaximumWidth( m26trail);
ui->est1822->setMinimumWidth( m25trail);
ui->est1822->setMaximumHeight( m7traild3 );
ui->est1822->setMaxLength(24);
ui->est1822->setFrame(globalFrame);

ui->est1823->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "182   ") );
connect( ui->est1823, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1823, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1823->installEventFilter(this);
ui->est1823->setAlignment(Qt::AlignCenter);
ui->est1823->setMaximumWidth( m11trail);
ui->est1823->setMinimumWidth( m6trail);
ui->est1823->setMaximumHeight( m7traild3 );
ui->est1823->setMaxLength(8);
ui->est1823->setFrame(globalFrame);

ui->est1824->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "182   ") );
connect( ui->est1824, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1824, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1824->installEventFilter(this);
ui->est1824->setAlignment(Qt::AlignCenter);
ui->est1824->setMaximumWidth( m12trail);
ui->est1824->setMinimumWidth( m6trail);
ui->est1824->setMaximumHeight( m7traild3 );
ui->est1824->setMaxLength(11);
ui->est1824->setFrame(globalFrame);

ui->est1825->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "182   ") );
connect( ui->est1825, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1825, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1825->installEventFilter(this);
ui->est1825->setAlignment(Qt::AlignCenter);
ui->est1825->setMaximumWidth( m12trail);
ui->est1825->setMinimumWidth( m6trail);
ui->est1825->setMaximumHeight( m7traild3 );
ui->est1825->setMaxLength(11);
ui->est1825->setFrame(globalFrame);

ui->est1826->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "182   ") );
ui->est1826->setReadOnly(true);
ui->est1826->setAlignment(Qt::AlignRight);
ui->est1826->setMaximumWidth( m14trail);
ui->est1826->setMinimumWidth( m9trail);
ui->est1826->setMaximumHeight( m7traild3 );
ui->est1826->setMaxLength(15);
ui->est1826->setFrame(globalFrame);

ui->est1827->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "182   ") );
ui->est1827->setReadOnly(true);
ui->est1827->setAlignment(Qt::AlignRight);
ui->est1827->setMaximumWidth( m14trail);
ui->est1827->setMinimumWidth( m9trail);
ui->est1827->setMaximumHeight( m7traild3 );
ui->est1827->setMaxLength(15);
ui->est1827->setFrame(globalFrame);

ui->lib1831->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "183   ") );
connect( ui->lib1831, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1831, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib183, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst183, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1831->installEventFilter(this);
ui->lib1831->setMaximumWidth( m6trail);
ui->lib1831->setMinimumWidth( m6trail);
ui->lib1831->setMaximumHeight( m7traild3 );
ui->lib1831->setMaxLength(3);
ui->lib1831->setFrame(globalFrame);

ui->lib1832->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "183   ") );
connect( ui->lib1832, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1832, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1832->installEventFilter(this);
ui->lib1832->setMaximumWidth( m26trail);
ui->lib1832->setMinimumWidth( m25trail);
ui->lib1832->setMaximumHeight( m7traild3 );
ui->lib1832->setMaxLength(24);
ui->lib1832->setFrame(globalFrame);

ui->lib1833->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "183   ") );
connect( ui->lib1833, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1833, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1833->installEventFilter(this);
ui->lib1833->setAlignment(Qt::AlignCenter);
ui->lib1833->setMaximumWidth( m12trail);
ui->lib1833->setMinimumWidth( m6trail);
ui->lib1833->setMaximumHeight( m7traild3 );
ui->lib1833->setMaxLength(11);
ui->lib1833->setFrame(globalFrame);

ui->lib1834->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "183   ") );
connect( ui->lib1834, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1834, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1834->installEventFilter(this);
ui->lib1834->setAlignment(Qt::AlignCenter);
ui->lib1834->setMaximumWidth( m12trail);
ui->lib1834->setMinimumWidth( m6trail);
ui->lib1834->setMaximumHeight( m7traild3 );
ui->lib1834->setMaxLength(11);
ui->lib1834->setFrame(globalFrame);

ui->pushButtonEst183->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "183   ") );
ui->pushButtonEst183->setMaximumWidth( m7traild3 );
ui->pushButtonEst183->setMaximumHeight( m7traild3 );
ui->pushButtonLib183->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "183   ") );
ui->pushButtonLib183->setMaximumWidth( m7traild3 );
ui->pushButtonLib183->setMaximumHeight( m7traild3 );

ui->est1831->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "183   ") );
connect( ui->est1831, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1831, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1831->installEventFilter(this);
ui->est1831->setMaximumWidth( m6trail);
ui->est1831->setMinimumWidth( m6trail);
ui->est1831->setMaximumHeight( m7traild3 );
ui->est1831->setMaxLength(3);
ui->est1831->setFrame(globalFrame);

ui->est1832->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "183   ") );
connect( ui->est1832, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1832, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1832->installEventFilter(this);
ui->est1832->setMaximumWidth( m26trail);
ui->est1832->setMinimumWidth( m25trail);
ui->est1832->setMaximumHeight( m7traild3 );
ui->est1832->setMaxLength(24);
ui->est1832->setFrame(globalFrame);

ui->est1833->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "183   ") );
connect( ui->est1833, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1833, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1833->installEventFilter(this);
ui->est1833->setAlignment(Qt::AlignCenter);
ui->est1833->setMaximumWidth( m11trail);
ui->est1833->setMinimumWidth( m6trail);
ui->est1833->setMaximumHeight( m7traild3 );
ui->est1833->setMaxLength(8);
ui->est1833->setFrame(globalFrame);

ui->est1834->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "183   ") );
connect( ui->est1834, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1834, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1834->installEventFilter(this);
ui->est1834->setAlignment(Qt::AlignCenter);
ui->est1834->setMaximumWidth( m12trail);
ui->est1834->setMinimumWidth( m6trail);
ui->est1834->setMaximumHeight( m7traild3 );
ui->est1834->setMaxLength(11);
ui->est1834->setFrame(globalFrame);

ui->est1835->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "183   ") );
connect( ui->est1835, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1835, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1835->installEventFilter(this);
ui->est1835->setAlignment(Qt::AlignCenter);
ui->est1835->setMaximumWidth( m12trail);
ui->est1835->setMinimumWidth( m6trail);
ui->est1835->setMaximumHeight( m7traild3 );
ui->est1835->setMaxLength(11);
ui->est1835->setFrame(globalFrame);

ui->est1836->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "183   ") );
ui->est1836->setReadOnly(true);
ui->est1836->setAlignment(Qt::AlignRight);
ui->est1836->setMaximumWidth( m14trail);
ui->est1836->setMinimumWidth( m9trail);
ui->est1836->setMaximumHeight( m7traild3 );
ui->est1836->setMaxLength(15);
ui->est1836->setFrame(globalFrame);

ui->est1837->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "183   ") );
ui->est1837->setReadOnly(true);
ui->est1837->setAlignment(Qt::AlignRight);
ui->est1837->setMaximumWidth( m14trail);
ui->est1837->setMinimumWidth( m9trail);
ui->est1837->setMaximumHeight( m7traild3 );
ui->est1837->setMaxLength(15);
ui->est1837->setFrame(globalFrame);

ui->lib1841->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "184   ") );
connect( ui->lib1841, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1841, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib184, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst184, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1841->installEventFilter(this);
ui->lib1841->setMaximumWidth( m6trail);
ui->lib1841->setMinimumWidth( m6trail);
ui->lib1841->setMaximumHeight( m7traild3 );
ui->lib1841->setMaxLength(3);
ui->lib1841->setFrame(globalFrame);

ui->lib1842->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "184   ") );
connect( ui->lib1842, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1842, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1842->installEventFilter(this);
ui->lib1842->setMaximumWidth( m26trail);
ui->lib1842->setMinimumWidth( m25trail);
ui->lib1842->setMaximumHeight( m7traild3 );
ui->lib1842->setMaxLength(24);
ui->lib1842->setFrame(globalFrame);

ui->lib1843->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "184   ") );
connect( ui->lib1843, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1843, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1843->installEventFilter(this);
ui->lib1843->setAlignment(Qt::AlignCenter);
ui->lib1843->setMaximumWidth( m12trail);
ui->lib1843->setMinimumWidth( m6trail);
ui->lib1843->setMaximumHeight( m7traild3 );
ui->lib1843->setMaxLength(11);
ui->lib1843->setFrame(globalFrame);

ui->lib1844->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "184   ") );
connect( ui->lib1844, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1844, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1844->installEventFilter(this);
ui->lib1844->setAlignment(Qt::AlignCenter);
ui->lib1844->setMaximumWidth( m12trail);
ui->lib1844->setMinimumWidth( m6trail);
ui->lib1844->setMaximumHeight( m7traild3 );
ui->lib1844->setMaxLength(11);
ui->lib1844->setFrame(globalFrame);

ui->pushButtonEst184->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "184   ") );
ui->pushButtonEst184->setMaximumWidth( m7traild3 );
ui->pushButtonEst184->setMaximumHeight( m7traild3 );
ui->pushButtonLib184->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "184   ") );
ui->pushButtonLib184->setMaximumWidth( m7traild3 );
ui->pushButtonLib184->setMaximumHeight( m7traild3 );

ui->est1841->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "184   ") );
connect( ui->est1841, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1841, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1841->installEventFilter(this);
ui->est1841->setMaximumWidth( m6trail);
ui->est1841->setMinimumWidth( m6trail);
ui->est1841->setMaximumHeight( m7traild3 );
ui->est1841->setMaxLength(3);
ui->est1841->setFrame(globalFrame);

ui->est1842->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "184   ") );
connect( ui->est1842, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1842, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1842->installEventFilter(this);
ui->est1842->setMaximumWidth( m26trail);
ui->est1842->setMinimumWidth( m25trail);
ui->est1842->setMaximumHeight( m7traild3 );
ui->est1842->setMaxLength(24);
ui->est1842->setFrame(globalFrame);

ui->est1843->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "184   ") );
connect( ui->est1843, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1843, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1843->installEventFilter(this);
ui->est1843->setAlignment(Qt::AlignCenter);
ui->est1843->setMaximumWidth( m11trail);
ui->est1843->setMinimumWidth( m6trail);
ui->est1843->setMaximumHeight( m7traild3 );
ui->est1843->setMaxLength(8);
ui->est1843->setFrame(globalFrame);

ui->est1844->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "184   ") );
connect( ui->est1844, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1844, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1844->installEventFilter(this);
ui->est1844->setAlignment(Qt::AlignCenter);
ui->est1844->setMaximumWidth( m12trail);
ui->est1844->setMinimumWidth( m6trail);
ui->est1844->setMaximumHeight( m7traild3 );
ui->est1844->setMaxLength(11);
ui->est1844->setFrame(globalFrame);

ui->est1845->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "184   ") );
connect( ui->est1845, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1845, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1845->installEventFilter(this);
ui->est1845->setAlignment(Qt::AlignCenter);
ui->est1845->setMaximumWidth( m12trail);
ui->est1845->setMinimumWidth( m6trail);
ui->est1845->setMaximumHeight( m7traild3 );
ui->est1845->setMaxLength(11);
ui->est1845->setFrame(globalFrame);

ui->est1846->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "184   ") );
ui->est1846->setReadOnly(true);
ui->est1846->setAlignment(Qt::AlignRight);
ui->est1846->setMaximumWidth( m14trail);
ui->est1846->setMinimumWidth( m9trail);
ui->est1846->setMaximumHeight( m7traild3 );
ui->est1846->setMaxLength(15);
ui->est1846->setFrame(globalFrame);

ui->est1847->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "184   ") );
ui->est1847->setReadOnly(true);
ui->est1847->setAlignment(Qt::AlignRight);
ui->est1847->setMaximumWidth( m14trail);
ui->est1847->setMinimumWidth( m9trail);
ui->est1847->setMaximumHeight( m7traild3 );
ui->est1847->setMaxLength(15);
ui->est1847->setFrame(globalFrame);

ui->lib1851->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "185   ") );
connect( ui->lib1851, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1851, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib185, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst185, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1851->installEventFilter(this);
ui->lib1851->setMaximumWidth( m6trail);
ui->lib1851->setMinimumWidth( m6trail);
ui->lib1851->setMaximumHeight( m7traild3 );
ui->lib1851->setMaxLength(3);
ui->lib1851->setFrame(globalFrame);

ui->lib1852->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "185   ") );
connect( ui->lib1852, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1852, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1852->installEventFilter(this);
ui->lib1852->setMaximumWidth( m26trail);
ui->lib1852->setMinimumWidth( m25trail);
ui->lib1852->setMaximumHeight( m7traild3 );
ui->lib1852->setMaxLength(24);
ui->lib1852->setFrame(globalFrame);

ui->lib1853->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "185   ") );
connect( ui->lib1853, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1853, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1853->installEventFilter(this);
ui->lib1853->setAlignment(Qt::AlignCenter);
ui->lib1853->setMaximumWidth( m12trail);
ui->lib1853->setMinimumWidth( m6trail);
ui->lib1853->setMaximumHeight( m7traild3 );
ui->lib1853->setMaxLength(11);
ui->lib1853->setFrame(globalFrame);

ui->lib1854->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "185   ") );
connect( ui->lib1854, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1854, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1854->installEventFilter(this);
ui->lib1854->setAlignment(Qt::AlignCenter);
ui->lib1854->setMaximumWidth( m12trail);
ui->lib1854->setMinimumWidth( m6trail);
ui->lib1854->setMaximumHeight( m7traild3 );
ui->lib1854->setMaxLength(11);
ui->lib1854->setFrame(globalFrame);

ui->pushButtonEst185->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "185   ") );
ui->pushButtonEst185->setMaximumWidth( m7traild3 );
ui->pushButtonEst185->setMaximumHeight( m7traild3 );
ui->pushButtonLib185->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "185   ") );
ui->pushButtonLib185->setMaximumWidth( m7traild3 );
ui->pushButtonLib185->setMaximumHeight( m7traild3 );

ui->est1851->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "185   ") );
connect( ui->est1851, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1851, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1851->installEventFilter(this);
ui->est1851->setMaximumWidth( m6trail);
ui->est1851->setMinimumWidth( m6trail);
ui->est1851->setMaximumHeight( m7traild3 );
ui->est1851->setMaxLength(3);
ui->est1851->setFrame(globalFrame);

ui->est1852->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "185   ") );
connect( ui->est1852, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1852, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1852->installEventFilter(this);
ui->est1852->setMaximumWidth( m26trail);
ui->est1852->setMinimumWidth( m25trail);
ui->est1852->setMaximumHeight( m7traild3 );
ui->est1852->setMaxLength(24);
ui->est1852->setFrame(globalFrame);

ui->est1853->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "185   ") );
connect( ui->est1853, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1853, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1853->installEventFilter(this);
ui->est1853->setAlignment(Qt::AlignCenter);
ui->est1853->setMaximumWidth( m11trail);
ui->est1853->setMinimumWidth( m6trail);
ui->est1853->setMaximumHeight( m7traild3 );
ui->est1853->setMaxLength(8);
ui->est1853->setFrame(globalFrame);

ui->est1854->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "185   ") );
connect( ui->est1854, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1854, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1854->installEventFilter(this);
ui->est1854->setAlignment(Qt::AlignCenter);
ui->est1854->setMaximumWidth( m12trail);
ui->est1854->setMinimumWidth( m6trail);
ui->est1854->setMaximumHeight( m7traild3 );
ui->est1854->setMaxLength(11);
ui->est1854->setFrame(globalFrame);

ui->est1855->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "185   ") );
connect( ui->est1855, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1855, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1855->installEventFilter(this);
ui->est1855->setAlignment(Qt::AlignCenter);
ui->est1855->setMaximumWidth( m12trail);
ui->est1855->setMinimumWidth( m6trail);
ui->est1855->setMaximumHeight( m7traild3 );
ui->est1855->setMaxLength(11);
ui->est1855->setFrame(globalFrame);

ui->est1856->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "185   ") );
ui->est1856->setReadOnly(true);
ui->est1856->setAlignment(Qt::AlignRight);
ui->est1856->setMaximumWidth( m14trail);
ui->est1856->setMinimumWidth( m9trail);
ui->est1856->setMaximumHeight( m7traild3 );
ui->est1856->setMaxLength(15);
ui->est1856->setFrame(globalFrame);

ui->est1857->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "185   ") );
ui->est1857->setReadOnly(true);
ui->est1857->setAlignment(Qt::AlignRight);
ui->est1857->setMaximumWidth( m14trail);
ui->est1857->setMinimumWidth( m9trail);
ui->est1857->setMaximumHeight( m7traild3 );
ui->est1857->setMaxLength(15);
ui->est1857->setFrame(globalFrame);

ui->lib1861->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "186   ") );
connect( ui->lib1861, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1861, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib186, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst186, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1861->installEventFilter(this);
ui->lib1861->setMaximumWidth( m6trail);
ui->lib1861->setMinimumWidth( m6trail);
ui->lib1861->setMaximumHeight( m7traild3 );
ui->lib1861->setMaxLength(3);
ui->lib1861->setFrame(globalFrame);

ui->lib1862->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "186   ") );
connect( ui->lib1862, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1862, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1862->installEventFilter(this);
ui->lib1862->setMaximumWidth( m26trail);
ui->lib1862->setMinimumWidth( m25trail);
ui->lib1862->setMaximumHeight( m7traild3 );
ui->lib1862->setMaxLength(24);
ui->lib1862->setFrame(globalFrame);

ui->lib1863->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "186   ") );
connect( ui->lib1863, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1863, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1863->installEventFilter(this);
ui->lib1863->setAlignment(Qt::AlignCenter);
ui->lib1863->setMaximumWidth( m12trail);
ui->lib1863->setMinimumWidth( m6trail);
ui->lib1863->setMaximumHeight( m7traild3 );
ui->lib1863->setMaxLength(11);
ui->lib1863->setFrame(globalFrame);

ui->lib1864->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "186   ") );
connect( ui->lib1864, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1864, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1864->installEventFilter(this);
ui->lib1864->setAlignment(Qt::AlignCenter);
ui->lib1864->setMaximumWidth( m12trail);
ui->lib1864->setMinimumWidth( m6trail);
ui->lib1864->setMaximumHeight( m7traild3 );
ui->lib1864->setMaxLength(11);
ui->lib1864->setFrame(globalFrame);

ui->pushButtonEst186->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "186   ") );
ui->pushButtonEst186->setMaximumWidth( m7traild3 );
ui->pushButtonEst186->setMaximumHeight( m7traild3 );
ui->pushButtonLib186->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "186   ") );
ui->pushButtonLib186->setMaximumWidth( m7traild3 );
ui->pushButtonLib186->setMaximumHeight( m7traild3 );

ui->est1861->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "186   ") );
connect( ui->est1861, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1861, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1861->installEventFilter(this);
ui->est1861->setMaximumWidth( m6trail);
ui->est1861->setMinimumWidth( m6trail);
ui->est1861->setMaximumHeight( m7traild3 );
ui->est1861->setMaxLength(3);
ui->est1861->setFrame(globalFrame);

ui->est1862->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "186   ") );
connect( ui->est1862, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1862, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1862->installEventFilter(this);
ui->est1862->setMaximumWidth( m26trail);
ui->est1862->setMinimumWidth( m25trail);
ui->est1862->setMaximumHeight( m7traild3 );
ui->est1862->setMaxLength(24);
ui->est1862->setFrame(globalFrame);

ui->est1863->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "186   ") );
connect( ui->est1863, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1863, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1863->installEventFilter(this);
ui->est1863->setAlignment(Qt::AlignCenter);
ui->est1863->setMaximumWidth( m11trail);
ui->est1863->setMinimumWidth( m6trail);
ui->est1863->setMaximumHeight( m7traild3 );
ui->est1863->setMaxLength(8);
ui->est1863->setFrame(globalFrame);

ui->est1864->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "186   ") );
connect( ui->est1864, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1864, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1864->installEventFilter(this);
ui->est1864->setAlignment(Qt::AlignCenter);
ui->est1864->setMaximumWidth( m12trail);
ui->est1864->setMinimumWidth( m6trail);
ui->est1864->setMaximumHeight( m7traild3 );
ui->est1864->setMaxLength(11);
ui->est1864->setFrame(globalFrame);

ui->est1865->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "186   ") );
connect( ui->est1865, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1865, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1865->installEventFilter(this);
ui->est1865->setAlignment(Qt::AlignCenter);
ui->est1865->setMaximumWidth( m12trail);
ui->est1865->setMinimumWidth( m6trail);
ui->est1865->setMaximumHeight( m7traild3 );
ui->est1865->setMaxLength(11);
ui->est1865->setFrame(globalFrame);

ui->est1866->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "186   ") );
ui->est1866->setReadOnly(true);
ui->est1866->setAlignment(Qt::AlignRight);
ui->est1866->setMaximumWidth( m14trail);
ui->est1866->setMinimumWidth( m9trail);
ui->est1866->setMaximumHeight( m7traild3 );
ui->est1866->setMaxLength(15);
ui->est1866->setFrame(globalFrame);

ui->est1867->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "186   ") );
ui->est1867->setReadOnly(true);
ui->est1867->setAlignment(Qt::AlignRight);
ui->est1867->setMaximumWidth( m14trail);
ui->est1867->setMinimumWidth( m9trail);
ui->est1867->setMaximumHeight( m7traild3 );
ui->est1867->setMaxLength(15);
ui->est1867->setFrame(globalFrame);

ui->lib1871->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "187   ") );
connect( ui->lib1871, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1871, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib187, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst187, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1871->installEventFilter(this);
ui->lib1871->setMaximumWidth( m6trail);
ui->lib1871->setMinimumWidth( m6trail);
ui->lib1871->setMaximumHeight( m7traild3 );
ui->lib1871->setMaxLength(3);
ui->lib1871->setFrame(globalFrame);

ui->lib1872->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "187   ") );
connect( ui->lib1872, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1872, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1872->installEventFilter(this);
ui->lib1872->setMaximumWidth( m26trail);
ui->lib1872->setMinimumWidth( m25trail);
ui->lib1872->setMaximumHeight( m7traild3 );
ui->lib1872->setMaxLength(24);
ui->lib1872->setFrame(globalFrame);

ui->lib1873->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "187   ") );
connect( ui->lib1873, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1873, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1873->installEventFilter(this);
ui->lib1873->setAlignment(Qt::AlignCenter);
ui->lib1873->setMaximumWidth( m12trail);
ui->lib1873->setMinimumWidth( m6trail);
ui->lib1873->setMaximumHeight( m7traild3 );
ui->lib1873->setMaxLength(11);
ui->lib1873->setFrame(globalFrame);

ui->lib1874->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "187   ") );
connect( ui->lib1874, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1874, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1874->installEventFilter(this);
ui->lib1874->setAlignment(Qt::AlignCenter);
ui->lib1874->setMaximumWidth( m12trail);
ui->lib1874->setMinimumWidth( m6trail);
ui->lib1874->setMaximumHeight( m7traild3 );
ui->lib1874->setMaxLength(11);
ui->lib1874->setFrame(globalFrame);

ui->pushButtonEst187->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "187   ") );
ui->pushButtonEst187->setMaximumWidth( m7traild3 );
ui->pushButtonEst187->setMaximumHeight( m7traild3 );
ui->pushButtonLib187->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "187   ") );
ui->pushButtonLib187->setMaximumWidth( m7traild3 );
ui->pushButtonLib187->setMaximumHeight( m7traild3 );

ui->est1871->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "187   ") );
connect( ui->est1871, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1871, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1871->installEventFilter(this);
ui->est1871->setMaximumWidth( m6trail);
ui->est1871->setMinimumWidth( m6trail);
ui->est1871->setMaximumHeight( m7traild3 );
ui->est1871->setMaxLength(3);
ui->est1871->setFrame(globalFrame);

ui->est1872->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "187   ") );
connect( ui->est1872, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1872, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1872->installEventFilter(this);
ui->est1872->setMaximumWidth( m26trail);
ui->est1872->setMinimumWidth( m25trail);
ui->est1872->setMaximumHeight( m7traild3 );
ui->est1872->setMaxLength(24);
ui->est1872->setFrame(globalFrame);

ui->est1873->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "187   ") );
connect( ui->est1873, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1873, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1873->installEventFilter(this);
ui->est1873->setAlignment(Qt::AlignCenter);
ui->est1873->setMaximumWidth( m11trail);
ui->est1873->setMinimumWidth( m6trail);
ui->est1873->setMaximumHeight( m7traild3 );
ui->est1873->setMaxLength(8);
ui->est1873->setFrame(globalFrame);

ui->est1874->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "187   ") );
connect( ui->est1874, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1874, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1874->installEventFilter(this);
ui->est1874->setAlignment(Qt::AlignCenter);
ui->est1874->setMaximumWidth( m12trail);
ui->est1874->setMinimumWidth( m6trail);
ui->est1874->setMaximumHeight( m7traild3 );
ui->est1874->setMaxLength(11);
ui->est1874->setFrame(globalFrame);

ui->est1875->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "187   ") );
connect( ui->est1875, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1875, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1875->installEventFilter(this);
ui->est1875->setAlignment(Qt::AlignCenter);
ui->est1875->setMaximumWidth( m12trail);
ui->est1875->setMinimumWidth( m6trail);
ui->est1875->setMaximumHeight( m7traild3 );
ui->est1875->setMaxLength(11);
ui->est1875->setFrame(globalFrame);

ui->est1876->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "187   ") );
ui->est1876->setReadOnly(true);
ui->est1876->setAlignment(Qt::AlignRight);
ui->est1876->setMaximumWidth( m14trail);
ui->est1876->setMinimumWidth( m9trail);
ui->est1876->setMaximumHeight( m7traild3 );
ui->est1876->setMaxLength(15);
ui->est1876->setFrame(globalFrame);

ui->est1877->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "187   ") );
ui->est1877->setReadOnly(true);
ui->est1877->setAlignment(Qt::AlignRight);
ui->est1877->setMaximumWidth( m14trail);
ui->est1877->setMinimumWidth( m9trail);
ui->est1877->setMaximumHeight( m7traild3 );
ui->est1877->setMaxLength(15);
ui->est1877->setFrame(globalFrame);

ui->lib1881->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "188   ") );
connect( ui->lib1881, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1881, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib188, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst188, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1881->installEventFilter(this);
ui->lib1881->setMaximumWidth( m6trail);
ui->lib1881->setMinimumWidth( m6trail);
ui->lib1881->setMaximumHeight( m7traild3 );
ui->lib1881->setMaxLength(3);
ui->lib1881->setFrame(globalFrame);

ui->lib1882->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "188   ") );
connect( ui->lib1882, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1882, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1882->installEventFilter(this);
ui->lib1882->setMaximumWidth( m26trail);
ui->lib1882->setMinimumWidth( m25trail);
ui->lib1882->setMaximumHeight( m7traild3 );
ui->lib1882->setMaxLength(24);
ui->lib1882->setFrame(globalFrame);

ui->lib1883->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "188   ") );
connect( ui->lib1883, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1883, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1883->installEventFilter(this);
ui->lib1883->setAlignment(Qt::AlignCenter);
ui->lib1883->setMaximumWidth( m12trail);
ui->lib1883->setMinimumWidth( m6trail);
ui->lib1883->setMaximumHeight( m7traild3 );
ui->lib1883->setMaxLength(11);
ui->lib1883->setFrame(globalFrame);

ui->lib1884->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "188   ") );
connect( ui->lib1884, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1884, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1884->installEventFilter(this);
ui->lib1884->setAlignment(Qt::AlignCenter);
ui->lib1884->setMaximumWidth( m12trail);
ui->lib1884->setMinimumWidth( m6trail);
ui->lib1884->setMaximumHeight( m7traild3 );
ui->lib1884->setMaxLength(11);
ui->lib1884->setFrame(globalFrame);

ui->pushButtonEst188->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "188   ") );
ui->pushButtonEst188->setMaximumWidth( m7traild3 );
ui->pushButtonEst188->setMaximumHeight( m7traild3 );
ui->pushButtonLib188->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "188   ") );
ui->pushButtonLib188->setMaximumWidth( m7traild3 );
ui->pushButtonLib188->setMaximumHeight( m7traild3 );

ui->est1881->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "188   ") );
connect( ui->est1881, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1881, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1881->installEventFilter(this);
ui->est1881->setMaximumWidth( m6trail);
ui->est1881->setMinimumWidth( m6trail);
ui->est1881->setMaximumHeight( m7traild3 );
ui->est1881->setMaxLength(3);
ui->est1881->setFrame(globalFrame);

ui->est1882->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "188   ") );
connect( ui->est1882, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1882, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1882->installEventFilter(this);
ui->est1882->setMaximumWidth( m26trail);
ui->est1882->setMinimumWidth( m25trail);
ui->est1882->setMaximumHeight( m7traild3 );
ui->est1882->setMaxLength(24);
ui->est1882->setFrame(globalFrame);

ui->est1883->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "188   ") );
connect( ui->est1883, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1883, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1883->installEventFilter(this);
ui->est1883->setAlignment(Qt::AlignCenter);
ui->est1883->setMaximumWidth( m11trail);
ui->est1883->setMinimumWidth( m6trail);
ui->est1883->setMaximumHeight( m7traild3 );
ui->est1883->setMaxLength(8);
ui->est1883->setFrame(globalFrame);

ui->est1884->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "188   ") );
connect( ui->est1884, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1884, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1884->installEventFilter(this);
ui->est1884->setAlignment(Qt::AlignCenter);
ui->est1884->setMaximumWidth( m12trail);
ui->est1884->setMinimumWidth( m6trail);
ui->est1884->setMaximumHeight( m7traild3 );
ui->est1884->setMaxLength(11);
ui->est1884->setFrame(globalFrame);

ui->est1885->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "188   ") );
connect( ui->est1885, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1885, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1885->installEventFilter(this);
ui->est1885->setAlignment(Qt::AlignCenter);
ui->est1885->setMaximumWidth( m12trail);
ui->est1885->setMinimumWidth( m6trail);
ui->est1885->setMaximumHeight( m7traild3 );
ui->est1885->setMaxLength(11);
ui->est1885->setFrame(globalFrame);

ui->est1886->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "188   ") );
ui->est1886->setReadOnly(true);
ui->est1886->setAlignment(Qt::AlignRight);
ui->est1886->setMaximumWidth( m14trail);
ui->est1886->setMinimumWidth( m9trail);
ui->est1886->setMaximumHeight( m7traild3 );
ui->est1886->setMaxLength(15);
ui->est1886->setFrame(globalFrame);

ui->est1887->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "188   ") );
ui->est1887->setReadOnly(true);
ui->est1887->setAlignment(Qt::AlignRight);
ui->est1887->setMaximumWidth( m14trail);
ui->est1887->setMinimumWidth( m9trail);
ui->est1887->setMaximumHeight( m7traild3 );
ui->est1887->setMaxLength(15);
ui->est1887->setFrame(globalFrame);

ui->lib1891->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "189   ") );
connect( ui->lib1891, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1891, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib189, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst189, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1891->installEventFilter(this);
ui->lib1891->setMaximumWidth( m6trail);
ui->lib1891->setMinimumWidth( m6trail);
ui->lib1891->setMaximumHeight( m7traild3 );
ui->lib1891->setMaxLength(3);
ui->lib1891->setFrame(globalFrame);

ui->lib1892->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "189   ") );
connect( ui->lib1892, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1892, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1892->installEventFilter(this);
ui->lib1892->setMaximumWidth( m26trail);
ui->lib1892->setMinimumWidth( m25trail);
ui->lib1892->setMaximumHeight( m7traild3 );
ui->lib1892->setMaxLength(24);
ui->lib1892->setFrame(globalFrame);

ui->lib1893->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "189   ") );
connect( ui->lib1893, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1893, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1893->installEventFilter(this);
ui->lib1893->setAlignment(Qt::AlignCenter);
ui->lib1893->setMaximumWidth( m12trail);
ui->lib1893->setMinimumWidth( m6trail);
ui->lib1893->setMaximumHeight( m7traild3 );
ui->lib1893->setMaxLength(11);
ui->lib1893->setFrame(globalFrame);

ui->lib1894->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "189   ") );
connect( ui->lib1894, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1894, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1894->installEventFilter(this);
ui->lib1894->setAlignment(Qt::AlignCenter);
ui->lib1894->setMaximumWidth( m12trail);
ui->lib1894->setMinimumWidth( m6trail);
ui->lib1894->setMaximumHeight( m7traild3 );
ui->lib1894->setMaxLength(11);
ui->lib1894->setFrame(globalFrame);

ui->pushButtonEst189->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "189   ") );
ui->pushButtonEst189->setMaximumWidth( m7traild3 );
ui->pushButtonEst189->setMaximumHeight( m7traild3 );
ui->pushButtonLib189->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "189   ") );
ui->pushButtonLib189->setMaximumWidth( m7traild3 );
ui->pushButtonLib189->setMaximumHeight( m7traild3 );

ui->est1891->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "189   ") );
connect( ui->est1891, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1891, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1891->installEventFilter(this);
ui->est1891->setMaximumWidth( m6trail);
ui->est1891->setMinimumWidth( m6trail);
ui->est1891->setMaximumHeight( m7traild3 );
ui->est1891->setMaxLength(3);
ui->est1891->setFrame(globalFrame);

ui->est1892->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "189   ") );
connect( ui->est1892, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1892, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1892->installEventFilter(this);
ui->est1892->setMaximumWidth( m26trail);
ui->est1892->setMinimumWidth( m25trail);
ui->est1892->setMaximumHeight( m7traild3 );
ui->est1892->setMaxLength(24);
ui->est1892->setFrame(globalFrame);

ui->est1893->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "189   ") );
connect( ui->est1893, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1893, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1893->installEventFilter(this);
ui->est1893->setAlignment(Qt::AlignCenter);
ui->est1893->setMaximumWidth( m11trail);
ui->est1893->setMinimumWidth( m6trail);
ui->est1893->setMaximumHeight( m7traild3 );
ui->est1893->setMaxLength(8);
ui->est1893->setFrame(globalFrame);

ui->est1894->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "189   ") );
connect( ui->est1894, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1894, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1894->installEventFilter(this);
ui->est1894->setAlignment(Qt::AlignCenter);
ui->est1894->setMaximumWidth( m12trail);
ui->est1894->setMinimumWidth( m6trail);
ui->est1894->setMaximumHeight( m7traild3 );
ui->est1894->setMaxLength(11);
ui->est1894->setFrame(globalFrame);

ui->est1895->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "189   ") );
connect( ui->est1895, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1895, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1895->installEventFilter(this);
ui->est1895->setAlignment(Qt::AlignCenter);
ui->est1895->setMaximumWidth( m12trail);
ui->est1895->setMinimumWidth( m6trail);
ui->est1895->setMaximumHeight( m7traild3 );
ui->est1895->setMaxLength(11);
ui->est1895->setFrame(globalFrame);

ui->est1896->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "189   ") );
ui->est1896->setReadOnly(true);
ui->est1896->setAlignment(Qt::AlignRight);
ui->est1896->setMaximumWidth( m14trail);
ui->est1896->setMinimumWidth( m9trail);
ui->est1896->setMaximumHeight( m7traild3 );
ui->est1896->setMaxLength(15);
ui->est1896->setFrame(globalFrame);

ui->est1897->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "189   ") );
ui->est1897->setReadOnly(true);
ui->est1897->setAlignment(Qt::AlignRight);
ui->est1897->setMaximumWidth( m14trail);
ui->est1897->setMinimumWidth( m9trail);
ui->est1897->setMaximumHeight( m7traild3 );
ui->est1897->setMaxLength(15);
ui->est1897->setFrame(globalFrame);

ui->lib1901->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "190   ") );
connect( ui->lib1901, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1901, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib190, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst190, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1901->installEventFilter(this);
ui->lib1901->setMaximumWidth( m6trail);
ui->lib1901->setMinimumWidth( m6trail);
ui->lib1901->setMaximumHeight( m7traild3 );
ui->lib1901->setMaxLength(3);
ui->lib1901->setFrame(globalFrame);

ui->lib1902->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "190   ") );
connect( ui->lib1902, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1902, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1902->installEventFilter(this);
ui->lib1902->setMaximumWidth( m26trail);
ui->lib1902->setMinimumWidth( m25trail);
ui->lib1902->setMaximumHeight( m7traild3 );
ui->lib1902->setMaxLength(24);
ui->lib1902->setFrame(globalFrame);

ui->lib1903->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "190   ") );
connect( ui->lib1903, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1903, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1903->installEventFilter(this);
ui->lib1903->setAlignment(Qt::AlignCenter);
ui->lib1903->setMaximumWidth( m12trail);
ui->lib1903->setMinimumWidth( m6trail);
ui->lib1903->setMaximumHeight( m7traild3 );
ui->lib1903->setMaxLength(11);
ui->lib1903->setFrame(globalFrame);

ui->lib1904->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "190   ") );
connect( ui->lib1904, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1904, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1904->installEventFilter(this);
ui->lib1904->setAlignment(Qt::AlignCenter);
ui->lib1904->setMaximumWidth( m12trail);
ui->lib1904->setMinimumWidth( m6trail);
ui->lib1904->setMaximumHeight( m7traild3 );
ui->lib1904->setMaxLength(11);
ui->lib1904->setFrame(globalFrame);

ui->pushButtonEst190->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "190   ") );
ui->pushButtonEst190->setMaximumWidth( m7traild3 );
ui->pushButtonEst190->setMaximumHeight( m7traild3 );
ui->pushButtonLib190->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "190   ") );
ui->pushButtonLib190->setMaximumWidth( m7traild3 );
ui->pushButtonLib190->setMaximumHeight( m7traild3 );

ui->est1901->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "190   ") );
connect( ui->est1901, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1901, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1901->installEventFilter(this);
ui->est1901->setMaximumWidth( m6trail);
ui->est1901->setMinimumWidth( m6trail);
ui->est1901->setMaximumHeight( m7traild3 );
ui->est1901->setMaxLength(3);
ui->est1901->setFrame(globalFrame);

ui->est1902->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "190   ") );
connect( ui->est1902, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1902, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1902->installEventFilter(this);
ui->est1902->setMaximumWidth( m26trail);
ui->est1902->setMinimumWidth( m25trail);
ui->est1902->setMaximumHeight( m7traild3 );
ui->est1902->setMaxLength(24);
ui->est1902->setFrame(globalFrame);

ui->est1903->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "190   ") );
connect( ui->est1903, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1903, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1903->installEventFilter(this);
ui->est1903->setAlignment(Qt::AlignCenter);
ui->est1903->setMaximumWidth( m11trail);
ui->est1903->setMinimumWidth( m6trail);
ui->est1903->setMaximumHeight( m7traild3 );
ui->est1903->setMaxLength(8);
ui->est1903->setFrame(globalFrame);

ui->est1904->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "190   ") );
connect( ui->est1904, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1904, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1904->installEventFilter(this);
ui->est1904->setAlignment(Qt::AlignCenter);
ui->est1904->setMaximumWidth( m12trail);
ui->est1904->setMinimumWidth( m6trail);
ui->est1904->setMaximumHeight( m7traild3 );
ui->est1904->setMaxLength(11);
ui->est1904->setFrame(globalFrame);

ui->est1905->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "190   ") );
connect( ui->est1905, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1905, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1905->installEventFilter(this);
ui->est1905->setAlignment(Qt::AlignCenter);
ui->est1905->setMaximumWidth( m12trail);
ui->est1905->setMinimumWidth( m6trail);
ui->est1905->setMaximumHeight( m7traild3 );
ui->est1905->setMaxLength(11);
ui->est1905->setFrame(globalFrame);

ui->est1906->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "190   ") );
ui->est1906->setReadOnly(true);
ui->est1906->setAlignment(Qt::AlignRight);
ui->est1906->setMaximumWidth( m14trail);
ui->est1906->setMinimumWidth( m9trail);
ui->est1906->setMaximumHeight( m7traild3 );
ui->est1906->setMaxLength(15);
ui->est1906->setFrame(globalFrame);

ui->est1907->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "190   ") );
ui->est1907->setReadOnly(true);
ui->est1907->setAlignment(Qt::AlignRight);
ui->est1907->setMaximumWidth( m14trail);
ui->est1907->setMinimumWidth( m9trail);
ui->est1907->setMaximumHeight( m7traild3 );
ui->est1907->setMaxLength(15);
ui->est1907->setFrame(globalFrame);

ui->lib1911->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "191   ") );
connect( ui->lib1911, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1911, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib191, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst191, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1911->installEventFilter(this);
ui->lib1911->setMaximumWidth( m6trail);
ui->lib1911->setMinimumWidth( m6trail);
ui->lib1911->setMaximumHeight( m7traild3 );
ui->lib1911->setMaxLength(3);
ui->lib1911->setFrame(globalFrame);

ui->lib1912->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "191   ") );
connect( ui->lib1912, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1912, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1912->installEventFilter(this);
ui->lib1912->setMaximumWidth( m26trail);
ui->lib1912->setMinimumWidth( m25trail);
ui->lib1912->setMaximumHeight( m7traild3 );
ui->lib1912->setMaxLength(24);
ui->lib1912->setFrame(globalFrame);

ui->lib1913->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "191   ") );
connect( ui->lib1913, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1913, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1913->installEventFilter(this);
ui->lib1913->setAlignment(Qt::AlignCenter);
ui->lib1913->setMaximumWidth( m12trail);
ui->lib1913->setMinimumWidth( m6trail);
ui->lib1913->setMaximumHeight( m7traild3 );
ui->lib1913->setMaxLength(11);
ui->lib1913->setFrame(globalFrame);

ui->lib1914->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "191   ") );
connect( ui->lib1914, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1914, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1914->installEventFilter(this);
ui->lib1914->setAlignment(Qt::AlignCenter);
ui->lib1914->setMaximumWidth( m12trail);
ui->lib1914->setMinimumWidth( m6trail);
ui->lib1914->setMaximumHeight( m7traild3 );
ui->lib1914->setMaxLength(11);
ui->lib1914->setFrame(globalFrame);

ui->pushButtonEst191->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "191   ") );
ui->pushButtonEst191->setMaximumWidth( m7traild3 );
ui->pushButtonEst191->setMaximumHeight( m7traild3 );
ui->pushButtonLib191->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "191   ") );
ui->pushButtonLib191->setMaximumWidth( m7traild3 );
ui->pushButtonLib191->setMaximumHeight( m7traild3 );

ui->est1911->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "191   ") );
connect( ui->est1911, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1911, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1911->installEventFilter(this);
ui->est1911->setMaximumWidth( m6trail);
ui->est1911->setMinimumWidth( m6trail);
ui->est1911->setMaximumHeight( m7traild3 );
ui->est1911->setMaxLength(3);
ui->est1911->setFrame(globalFrame);

ui->est1912->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "191   ") );
connect( ui->est1912, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1912, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1912->installEventFilter(this);
ui->est1912->setMaximumWidth( m26trail);
ui->est1912->setMinimumWidth( m25trail);
ui->est1912->setMaximumHeight( m7traild3 );
ui->est1912->setMaxLength(24);
ui->est1912->setFrame(globalFrame);

ui->est1913->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "191   ") );
connect( ui->est1913, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1913, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1913->installEventFilter(this);
ui->est1913->setAlignment(Qt::AlignCenter);
ui->est1913->setMaximumWidth( m11trail);
ui->est1913->setMinimumWidth( m6trail);
ui->est1913->setMaximumHeight( m7traild3 );
ui->est1913->setMaxLength(8);
ui->est1913->setFrame(globalFrame);

ui->est1914->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "191   ") );
connect( ui->est1914, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1914, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1914->installEventFilter(this);
ui->est1914->setAlignment(Qt::AlignCenter);
ui->est1914->setMaximumWidth( m12trail);
ui->est1914->setMinimumWidth( m6trail);
ui->est1914->setMaximumHeight( m7traild3 );
ui->est1914->setMaxLength(11);
ui->est1914->setFrame(globalFrame);

ui->est1915->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "191   ") );
connect( ui->est1915, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1915, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1915->installEventFilter(this);
ui->est1915->setAlignment(Qt::AlignCenter);
ui->est1915->setMaximumWidth( m12trail);
ui->est1915->setMinimumWidth( m6trail);
ui->est1915->setMaximumHeight( m7traild3 );
ui->est1915->setMaxLength(11);
ui->est1915->setFrame(globalFrame);

ui->est1916->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "191   ") );
ui->est1916->setReadOnly(true);
ui->est1916->setAlignment(Qt::AlignRight);
ui->est1916->setMaximumWidth( m14trail);
ui->est1916->setMinimumWidth( m9trail);
ui->est1916->setMaximumHeight( m7traild3 );
ui->est1916->setMaxLength(15);
ui->est1916->setFrame(globalFrame);

ui->est1917->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "191   ") );
ui->est1917->setReadOnly(true);
ui->est1917->setAlignment(Qt::AlignRight);
ui->est1917->setMaximumWidth( m14trail);
ui->est1917->setMinimumWidth( m9trail);
ui->est1917->setMaximumHeight( m7traild3 );
ui->est1917->setMaxLength(15);
ui->est1917->setFrame(globalFrame);

ui->lib1921->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "192   ") );
connect( ui->lib1921, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1921, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib192, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst192, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1921->installEventFilter(this);
ui->lib1921->setMaximumWidth( m6trail);
ui->lib1921->setMinimumWidth( m6trail);
ui->lib1921->setMaximumHeight( m7traild3 );
ui->lib1921->setMaxLength(3);
ui->lib1921->setFrame(globalFrame);

ui->lib1922->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "192   ") );
connect( ui->lib1922, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1922, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1922->installEventFilter(this);
ui->lib1922->setMaximumWidth( m26trail);
ui->lib1922->setMinimumWidth( m25trail);
ui->lib1922->setMaximumHeight( m7traild3 );
ui->lib1922->setMaxLength(24);
ui->lib1922->setFrame(globalFrame);

ui->lib1923->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "192   ") );
connect( ui->lib1923, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1923, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1923->installEventFilter(this);
ui->lib1923->setAlignment(Qt::AlignCenter);
ui->lib1923->setMaximumWidth( m12trail);
ui->lib1923->setMinimumWidth( m6trail);
ui->lib1923->setMaximumHeight( m7traild3 );
ui->lib1923->setMaxLength(11);
ui->lib1923->setFrame(globalFrame);

ui->lib1924->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "192   ") );
connect( ui->lib1924, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1924, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1924->installEventFilter(this);
ui->lib1924->setAlignment(Qt::AlignCenter);
ui->lib1924->setMaximumWidth( m12trail);
ui->lib1924->setMinimumWidth( m6trail);
ui->lib1924->setMaximumHeight( m7traild3 );
ui->lib1924->setMaxLength(11);
ui->lib1924->setFrame(globalFrame);

ui->pushButtonEst192->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "192   ") );
ui->pushButtonEst192->setMaximumWidth( m7traild3 );
ui->pushButtonEst192->setMaximumHeight( m7traild3 );
ui->pushButtonLib192->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "192   ") );
ui->pushButtonLib192->setMaximumWidth( m7traild3 );
ui->pushButtonLib192->setMaximumHeight( m7traild3 );

ui->est1921->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "192   ") );
connect( ui->est1921, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1921, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1921->installEventFilter(this);
ui->est1921->setMaximumWidth( m6trail);
ui->est1921->setMinimumWidth( m6trail);
ui->est1921->setMaximumHeight( m7traild3 );
ui->est1921->setMaxLength(3);
ui->est1921->setFrame(globalFrame);

ui->est1922->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "192   ") );
connect( ui->est1922, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1922, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1922->installEventFilter(this);
ui->est1922->setMaximumWidth( m26trail);
ui->est1922->setMinimumWidth( m25trail);
ui->est1922->setMaximumHeight( m7traild3 );
ui->est1922->setMaxLength(24);
ui->est1922->setFrame(globalFrame);

ui->est1923->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "192   ") );
connect( ui->est1923, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1923, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1923->installEventFilter(this);
ui->est1923->setAlignment(Qt::AlignCenter);
ui->est1923->setMaximumWidth( m11trail);
ui->est1923->setMinimumWidth( m6trail);
ui->est1923->setMaximumHeight( m7traild3 );
ui->est1923->setMaxLength(8);
ui->est1923->setFrame(globalFrame);

ui->est1924->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "192   ") );
connect( ui->est1924, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1924, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1924->installEventFilter(this);
ui->est1924->setAlignment(Qt::AlignCenter);
ui->est1924->setMaximumWidth( m12trail);
ui->est1924->setMinimumWidth( m6trail);
ui->est1924->setMaximumHeight( m7traild3 );
ui->est1924->setMaxLength(11);
ui->est1924->setFrame(globalFrame);

ui->est1925->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "192   ") );
connect( ui->est1925, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1925, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1925->installEventFilter(this);
ui->est1925->setAlignment(Qt::AlignCenter);
ui->est1925->setMaximumWidth( m12trail);
ui->est1925->setMinimumWidth( m6trail);
ui->est1925->setMaximumHeight( m7traild3 );
ui->est1925->setMaxLength(11);
ui->est1925->setFrame(globalFrame);

ui->est1926->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "192   ") );
ui->est1926->setReadOnly(true);
ui->est1926->setAlignment(Qt::AlignRight);
ui->est1926->setMaximumWidth( m14trail);
ui->est1926->setMinimumWidth( m9trail);
ui->est1926->setMaximumHeight( m7traild3 );
ui->est1926->setMaxLength(15);
ui->est1926->setFrame(globalFrame);

ui->est1927->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "192   ") );
ui->est1927->setReadOnly(true);
ui->est1927->setAlignment(Qt::AlignRight);
ui->est1927->setMaximumWidth( m14trail);
ui->est1927->setMinimumWidth( m9trail);
ui->est1927->setMaximumHeight( m7traild3 );
ui->est1927->setMaxLength(15);
ui->est1927->setFrame(globalFrame);

ui->lib1931->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "193   ") );
connect( ui->lib1931, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1931, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib193, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst193, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1931->installEventFilter(this);
ui->lib1931->setMaximumWidth( m6trail);
ui->lib1931->setMinimumWidth( m6trail);
ui->lib1931->setMaximumHeight( m7traild3 );
ui->lib1931->setMaxLength(3);
ui->lib1931->setFrame(globalFrame);

ui->lib1932->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "193   ") );
connect( ui->lib1932, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1932, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1932->installEventFilter(this);
ui->lib1932->setMaximumWidth( m26trail);
ui->lib1932->setMinimumWidth( m25trail);
ui->lib1932->setMaximumHeight( m7traild3 );
ui->lib1932->setMaxLength(24);
ui->lib1932->setFrame(globalFrame);

ui->lib1933->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "193   ") );
connect( ui->lib1933, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1933, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1933->installEventFilter(this);
ui->lib1933->setAlignment(Qt::AlignCenter);
ui->lib1933->setMaximumWidth( m12trail);
ui->lib1933->setMinimumWidth( m6trail);
ui->lib1933->setMaximumHeight( m7traild3 );
ui->lib1933->setMaxLength(11);
ui->lib1933->setFrame(globalFrame);

ui->lib1934->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "193   ") );
connect( ui->lib1934, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1934, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1934->installEventFilter(this);
ui->lib1934->setAlignment(Qt::AlignCenter);
ui->lib1934->setMaximumWidth( m12trail);
ui->lib1934->setMinimumWidth( m6trail);
ui->lib1934->setMaximumHeight( m7traild3 );
ui->lib1934->setMaxLength(11);
ui->lib1934->setFrame(globalFrame);

ui->pushButtonEst193->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "193   ") );
ui->pushButtonEst193->setMaximumWidth( m7traild3 );
ui->pushButtonEst193->setMaximumHeight( m7traild3 );
ui->pushButtonLib193->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "193   ") );
ui->pushButtonLib193->setMaximumWidth( m7traild3 );
ui->pushButtonLib193->setMaximumHeight( m7traild3 );

ui->est1931->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "193   ") );
connect( ui->est1931, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1931, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1931->installEventFilter(this);
ui->est1931->setMaximumWidth( m6trail);
ui->est1931->setMinimumWidth( m6trail);
ui->est1931->setMaximumHeight( m7traild3 );
ui->est1931->setMaxLength(3);
ui->est1931->setFrame(globalFrame);

ui->est1932->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "193   ") );
connect( ui->est1932, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1932, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1932->installEventFilter(this);
ui->est1932->setMaximumWidth( m26trail);
ui->est1932->setMinimumWidth( m25trail);
ui->est1932->setMaximumHeight( m7traild3 );
ui->est1932->setMaxLength(24);
ui->est1932->setFrame(globalFrame);

ui->est1933->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "193   ") );
connect( ui->est1933, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1933, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1933->installEventFilter(this);
ui->est1933->setAlignment(Qt::AlignCenter);
ui->est1933->setMaximumWidth( m11trail);
ui->est1933->setMinimumWidth( m6trail);
ui->est1933->setMaximumHeight( m7traild3 );
ui->est1933->setMaxLength(8);
ui->est1933->setFrame(globalFrame);

ui->est1934->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "193   ") );
connect( ui->est1934, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1934, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1934->installEventFilter(this);
ui->est1934->setAlignment(Qt::AlignCenter);
ui->est1934->setMaximumWidth( m12trail);
ui->est1934->setMinimumWidth( m6trail);
ui->est1934->setMaximumHeight( m7traild3 );
ui->est1934->setMaxLength(11);
ui->est1934->setFrame(globalFrame);

ui->est1935->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "193   ") );
connect( ui->est1935, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1935, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1935->installEventFilter(this);
ui->est1935->setAlignment(Qt::AlignCenter);
ui->est1935->setMaximumWidth( m12trail);
ui->est1935->setMinimumWidth( m6trail);
ui->est1935->setMaximumHeight( m7traild3 );
ui->est1935->setMaxLength(11);
ui->est1935->setFrame(globalFrame);

ui->est1936->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "193   ") );
ui->est1936->setReadOnly(true);
ui->est1936->setAlignment(Qt::AlignRight);
ui->est1936->setMaximumWidth( m14trail);
ui->est1936->setMinimumWidth( m9trail);
ui->est1936->setMaximumHeight( m7traild3 );
ui->est1936->setMaxLength(15);
ui->est1936->setFrame(globalFrame);

ui->est1937->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "193   ") );
ui->est1937->setReadOnly(true);
ui->est1937->setAlignment(Qt::AlignRight);
ui->est1937->setMaximumWidth( m14trail);
ui->est1937->setMinimumWidth( m9trail);
ui->est1937->setMaximumHeight( m7traild3 );
ui->est1937->setMaxLength(15);
ui->est1937->setFrame(globalFrame);

ui->lib1941->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "194   ") );
connect( ui->lib1941, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1941, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib194, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst194, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1941->installEventFilter(this);
ui->lib1941->setMaximumWidth( m6trail);
ui->lib1941->setMinimumWidth( m6trail);
ui->lib1941->setMaximumHeight( m7traild3 );
ui->lib1941->setMaxLength(3);
ui->lib1941->setFrame(globalFrame);

ui->lib1942->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "194   ") );
connect( ui->lib1942, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1942, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1942->installEventFilter(this);
ui->lib1942->setMaximumWidth( m26trail);
ui->lib1942->setMinimumWidth( m25trail);
ui->lib1942->setMaximumHeight( m7traild3 );
ui->lib1942->setMaxLength(24);
ui->lib1942->setFrame(globalFrame);

ui->lib1943->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "194   ") );
connect( ui->lib1943, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1943, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1943->installEventFilter(this);
ui->lib1943->setAlignment(Qt::AlignCenter);
ui->lib1943->setMaximumWidth( m12trail);
ui->lib1943->setMinimumWidth( m6trail);
ui->lib1943->setMaximumHeight( m7traild3 );
ui->lib1943->setMaxLength(11);
ui->lib1943->setFrame(globalFrame);

ui->lib1944->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "194   ") );
connect( ui->lib1944, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1944, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1944->installEventFilter(this);
ui->lib1944->setAlignment(Qt::AlignCenter);
ui->lib1944->setMaximumWidth( m12trail);
ui->lib1944->setMinimumWidth( m6trail);
ui->lib1944->setMaximumHeight( m7traild3 );
ui->lib1944->setMaxLength(11);
ui->lib1944->setFrame(globalFrame);

ui->pushButtonEst194->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "194   ") );
ui->pushButtonEst194->setMaximumWidth( m7traild3 );
ui->pushButtonEst194->setMaximumHeight( m7traild3 );
ui->pushButtonLib194->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "194   ") );
ui->pushButtonLib194->setMaximumWidth( m7traild3 );
ui->pushButtonLib194->setMaximumHeight( m7traild3 );

ui->est1941->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "194   ") );
connect( ui->est1941, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1941, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1941->installEventFilter(this);
ui->est1941->setMaximumWidth( m6trail);
ui->est1941->setMinimumWidth( m6trail);
ui->est1941->setMaximumHeight( m7traild3 );
ui->est1941->setMaxLength(3);
ui->est1941->setFrame(globalFrame);

ui->est1942->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "194   ") );
connect( ui->est1942, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1942, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1942->installEventFilter(this);
ui->est1942->setMaximumWidth( m26trail);
ui->est1942->setMinimumWidth( m25trail);
ui->est1942->setMaximumHeight( m7traild3 );
ui->est1942->setMaxLength(24);
ui->est1942->setFrame(globalFrame);

ui->est1943->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "194   ") );
connect( ui->est1943, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1943, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1943->installEventFilter(this);
ui->est1943->setAlignment(Qt::AlignCenter);
ui->est1943->setMaximumWidth( m11trail);
ui->est1943->setMinimumWidth( m6trail);
ui->est1943->setMaximumHeight( m7traild3 );
ui->est1943->setMaxLength(8);
ui->est1943->setFrame(globalFrame);

ui->est1944->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "194   ") );
connect( ui->est1944, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1944, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1944->installEventFilter(this);
ui->est1944->setAlignment(Qt::AlignCenter);
ui->est1944->setMaximumWidth( m12trail);
ui->est1944->setMinimumWidth( m6trail);
ui->est1944->setMaximumHeight( m7traild3 );
ui->est1944->setMaxLength(11);
ui->est1944->setFrame(globalFrame);

ui->est1945->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "194   ") );
connect( ui->est1945, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1945, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1945->installEventFilter(this);
ui->est1945->setAlignment(Qt::AlignCenter);
ui->est1945->setMaximumWidth( m12trail);
ui->est1945->setMinimumWidth( m6trail);
ui->est1945->setMaximumHeight( m7traild3 );
ui->est1945->setMaxLength(11);
ui->est1945->setFrame(globalFrame);

ui->est1946->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "194   ") );
ui->est1946->setReadOnly(true);
ui->est1946->setAlignment(Qt::AlignRight);
ui->est1946->setMaximumWidth( m14trail);
ui->est1946->setMinimumWidth( m9trail);
ui->est1946->setMaximumHeight( m7traild3 );
ui->est1946->setMaxLength(15);
ui->est1946->setFrame(globalFrame);

ui->est1947->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "194   ") );
ui->est1947->setReadOnly(true);
ui->est1947->setAlignment(Qt::AlignRight);
ui->est1947->setMaximumWidth( m14trail);
ui->est1947->setMinimumWidth( m9trail);
ui->est1947->setMaximumHeight( m7traild3 );
ui->est1947->setMaxLength(15);
ui->est1947->setFrame(globalFrame);

ui->lib1951->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "195   ") );
connect( ui->lib1951, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1951, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib195, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst195, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1951->installEventFilter(this);
ui->lib1951->setMaximumWidth( m6trail);
ui->lib1951->setMinimumWidth( m6trail);
ui->lib1951->setMaximumHeight( m7traild3 );
ui->lib1951->setMaxLength(3);
ui->lib1951->setFrame(globalFrame);

ui->lib1952->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "195   ") );
connect( ui->lib1952, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1952, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1952->installEventFilter(this);
ui->lib1952->setMaximumWidth( m26trail);
ui->lib1952->setMinimumWidth( m25trail);
ui->lib1952->setMaximumHeight( m7traild3 );
ui->lib1952->setMaxLength(24);
ui->lib1952->setFrame(globalFrame);

ui->lib1953->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "195   ") );
connect( ui->lib1953, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1953, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1953->installEventFilter(this);
ui->lib1953->setAlignment(Qt::AlignCenter);
ui->lib1953->setMaximumWidth( m12trail);
ui->lib1953->setMinimumWidth( m6trail);
ui->lib1953->setMaximumHeight( m7traild3 );
ui->lib1953->setMaxLength(11);
ui->lib1953->setFrame(globalFrame);

ui->lib1954->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "195   ") );
connect( ui->lib1954, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1954, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1954->installEventFilter(this);
ui->lib1954->setAlignment(Qt::AlignCenter);
ui->lib1954->setMaximumWidth( m12trail);
ui->lib1954->setMinimumWidth( m6trail);
ui->lib1954->setMaximumHeight( m7traild3 );
ui->lib1954->setMaxLength(11);
ui->lib1954->setFrame(globalFrame);

ui->pushButtonEst195->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "195   ") );
ui->pushButtonEst195->setMaximumWidth( m7traild3 );
ui->pushButtonEst195->setMaximumHeight( m7traild3 );
ui->pushButtonLib195->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "195   ") );
ui->pushButtonLib195->setMaximumWidth( m7traild3 );
ui->pushButtonLib195->setMaximumHeight( m7traild3 );

ui->est1951->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "195   ") );
connect( ui->est1951, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1951, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1951->installEventFilter(this);
ui->est1951->setMaximumWidth( m6trail);
ui->est1951->setMinimumWidth( m6trail);
ui->est1951->setMaximumHeight( m7traild3 );
ui->est1951->setMaxLength(3);
ui->est1951->setFrame(globalFrame);

ui->est1952->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "195   ") );
connect( ui->est1952, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1952, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1952->installEventFilter(this);
ui->est1952->setMaximumWidth( m26trail);
ui->est1952->setMinimumWidth( m25trail);
ui->est1952->setMaximumHeight( m7traild3 );
ui->est1952->setMaxLength(24);
ui->est1952->setFrame(globalFrame);

ui->est1953->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "195   ") );
connect( ui->est1953, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1953, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1953->installEventFilter(this);
ui->est1953->setAlignment(Qt::AlignCenter);
ui->est1953->setMaximumWidth( m11trail);
ui->est1953->setMinimumWidth( m6trail);
ui->est1953->setMaximumHeight( m7traild3 );
ui->est1953->setMaxLength(8);
ui->est1953->setFrame(globalFrame);

ui->est1954->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "195   ") );
connect( ui->est1954, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1954, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1954->installEventFilter(this);
ui->est1954->setAlignment(Qt::AlignCenter);
ui->est1954->setMaximumWidth( m12trail);
ui->est1954->setMinimumWidth( m6trail);
ui->est1954->setMaximumHeight( m7traild3 );
ui->est1954->setMaxLength(11);
ui->est1954->setFrame(globalFrame);

ui->est1955->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "195   ") );
connect( ui->est1955, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1955, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1955->installEventFilter(this);
ui->est1955->setAlignment(Qt::AlignCenter);
ui->est1955->setMaximumWidth( m12trail);
ui->est1955->setMinimumWidth( m6trail);
ui->est1955->setMaximumHeight( m7traild3 );
ui->est1955->setMaxLength(11);
ui->est1955->setFrame(globalFrame);

ui->est1956->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "195   ") );
ui->est1956->setReadOnly(true);
ui->est1956->setAlignment(Qt::AlignRight);
ui->est1956->setMaximumWidth( m14trail);
ui->est1956->setMinimumWidth( m9trail);
ui->est1956->setMaximumHeight( m7traild3 );
ui->est1956->setMaxLength(15);
ui->est1956->setFrame(globalFrame);

ui->est1957->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "195   ") );
ui->est1957->setReadOnly(true);
ui->est1957->setAlignment(Qt::AlignRight);
ui->est1957->setMaximumWidth( m14trail);
ui->est1957->setMinimumWidth( m9trail);
ui->est1957->setMaximumHeight( m7traild3 );
ui->est1957->setMaxLength(15);
ui->est1957->setFrame(globalFrame);

ui->lib1961->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "196   ") );
connect( ui->lib1961, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1961, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib196, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst196, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1961->installEventFilter(this);
ui->lib1961->setMaximumWidth( m6trail);
ui->lib1961->setMinimumWidth( m6trail);
ui->lib1961->setMaximumHeight( m7traild3 );
ui->lib1961->setMaxLength(3);
ui->lib1961->setFrame(globalFrame);

ui->lib1962->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "196   ") );
connect( ui->lib1962, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1962, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1962->installEventFilter(this);
ui->lib1962->setMaximumWidth( m26trail);
ui->lib1962->setMinimumWidth( m25trail);
ui->lib1962->setMaximumHeight( m7traild3 );
ui->lib1962->setMaxLength(24);
ui->lib1962->setFrame(globalFrame);

ui->lib1963->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "196   ") );
connect( ui->lib1963, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1963, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1963->installEventFilter(this);
ui->lib1963->setAlignment(Qt::AlignCenter);
ui->lib1963->setMaximumWidth( m12trail);
ui->lib1963->setMinimumWidth( m6trail);
ui->lib1963->setMaximumHeight( m7traild3 );
ui->lib1963->setMaxLength(11);
ui->lib1963->setFrame(globalFrame);

ui->lib1964->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "196   ") );
connect( ui->lib1964, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1964, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1964->installEventFilter(this);
ui->lib1964->setAlignment(Qt::AlignCenter);
ui->lib1964->setMaximumWidth( m12trail);
ui->lib1964->setMinimumWidth( m6trail);
ui->lib1964->setMaximumHeight( m7traild3 );
ui->lib1964->setMaxLength(11);
ui->lib1964->setFrame(globalFrame);

ui->pushButtonEst196->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "196   ") );
ui->pushButtonEst196->setMaximumWidth( m7traild3 );
ui->pushButtonEst196->setMaximumHeight( m7traild3 );
ui->pushButtonLib196->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "196   ") );
ui->pushButtonLib196->setMaximumWidth( m7traild3 );
ui->pushButtonLib196->setMaximumHeight( m7traild3 );

ui->est1961->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "196   ") );
connect( ui->est1961, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1961, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1961->installEventFilter(this);
ui->est1961->setMaximumWidth( m6trail);
ui->est1961->setMinimumWidth( m6trail);
ui->est1961->setMaximumHeight( m7traild3 );
ui->est1961->setMaxLength(3);
ui->est1961->setFrame(globalFrame);

ui->est1962->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "196   ") );
connect( ui->est1962, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1962, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1962->installEventFilter(this);
ui->est1962->setMaximumWidth( m26trail);
ui->est1962->setMinimumWidth( m25trail);
ui->est1962->setMaximumHeight( m7traild3 );
ui->est1962->setMaxLength(24);
ui->est1962->setFrame(globalFrame);

ui->est1963->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "196   ") );
connect( ui->est1963, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1963, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1963->installEventFilter(this);
ui->est1963->setAlignment(Qt::AlignCenter);
ui->est1963->setMaximumWidth( m11trail);
ui->est1963->setMinimumWidth( m6trail);
ui->est1963->setMaximumHeight( m7traild3 );
ui->est1963->setMaxLength(8);
ui->est1963->setFrame(globalFrame);

ui->est1964->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "196   ") );
connect( ui->est1964, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1964, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1964->installEventFilter(this);
ui->est1964->setAlignment(Qt::AlignCenter);
ui->est1964->setMaximumWidth( m12trail);
ui->est1964->setMinimumWidth( m6trail);
ui->est1964->setMaximumHeight( m7traild3 );
ui->est1964->setMaxLength(11);
ui->est1964->setFrame(globalFrame);

ui->est1965->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "196   ") );
connect( ui->est1965, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1965, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1965->installEventFilter(this);
ui->est1965->setAlignment(Qt::AlignCenter);
ui->est1965->setMaximumWidth( m12trail);
ui->est1965->setMinimumWidth( m6trail);
ui->est1965->setMaximumHeight( m7traild3 );
ui->est1965->setMaxLength(11);
ui->est1965->setFrame(globalFrame);

ui->est1966->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "196   ") );
ui->est1966->setReadOnly(true);
ui->est1966->setAlignment(Qt::AlignRight);
ui->est1966->setMaximumWidth( m14trail);
ui->est1966->setMinimumWidth( m9trail);
ui->est1966->setMaximumHeight( m7traild3 );
ui->est1966->setMaxLength(15);
ui->est1966->setFrame(globalFrame);

ui->est1967->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "196   ") );
ui->est1967->setReadOnly(true);
ui->est1967->setAlignment(Qt::AlignRight);
ui->est1967->setMaximumWidth( m14trail);
ui->est1967->setMinimumWidth( m9trail);
ui->est1967->setMaximumHeight( m7traild3 );
ui->est1967->setMaxLength(15);
ui->est1967->setFrame(globalFrame);

ui->lib1971->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "197   ") );
connect( ui->lib1971, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1971, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib197, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst197, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1971->installEventFilter(this);
ui->lib1971->setMaximumWidth( m6trail);
ui->lib1971->setMinimumWidth( m6trail);
ui->lib1971->setMaximumHeight( m7traild3 );
ui->lib1971->setMaxLength(3);
ui->lib1971->setFrame(globalFrame);

ui->lib1972->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "197   ") );
connect( ui->lib1972, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1972, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1972->installEventFilter(this);
ui->lib1972->setMaximumWidth( m26trail);
ui->lib1972->setMinimumWidth( m25trail);
ui->lib1972->setMaximumHeight( m7traild3 );
ui->lib1972->setMaxLength(24);
ui->lib1972->setFrame(globalFrame);

ui->lib1973->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "197   ") );
connect( ui->lib1973, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1973, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1973->installEventFilter(this);
ui->lib1973->setAlignment(Qt::AlignCenter);
ui->lib1973->setMaximumWidth( m12trail);
ui->lib1973->setMinimumWidth( m6trail);
ui->lib1973->setMaximumHeight( m7traild3 );
ui->lib1973->setMaxLength(11);
ui->lib1973->setFrame(globalFrame);

ui->lib1974->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "197   ") );
connect( ui->lib1974, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1974, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1974->installEventFilter(this);
ui->lib1974->setAlignment(Qt::AlignCenter);
ui->lib1974->setMaximumWidth( m12trail);
ui->lib1974->setMinimumWidth( m6trail);
ui->lib1974->setMaximumHeight( m7traild3 );
ui->lib1974->setMaxLength(11);
ui->lib1974->setFrame(globalFrame);

ui->pushButtonEst197->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "197   ") );
ui->pushButtonEst197->setMaximumWidth( m7traild3 );
ui->pushButtonEst197->setMaximumHeight( m7traild3 );
ui->pushButtonLib197->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "197   ") );
ui->pushButtonLib197->setMaximumWidth( m7traild3 );
ui->pushButtonLib197->setMaximumHeight( m7traild3 );

ui->est1971->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "197   ") );
connect( ui->est1971, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1971, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1971->installEventFilter(this);
ui->est1971->setMaximumWidth( m6trail);
ui->est1971->setMinimumWidth( m6trail);
ui->est1971->setMaximumHeight( m7traild3 );
ui->est1971->setMaxLength(3);
ui->est1971->setFrame(globalFrame);

ui->est1972->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "197   ") );
connect( ui->est1972, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1972, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1972->installEventFilter(this);
ui->est1972->setMaximumWidth( m26trail);
ui->est1972->setMinimumWidth( m25trail);
ui->est1972->setMaximumHeight( m7traild3 );
ui->est1972->setMaxLength(24);
ui->est1972->setFrame(globalFrame);

ui->est1973->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "197   ") );
connect( ui->est1973, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1973, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1973->installEventFilter(this);
ui->est1973->setAlignment(Qt::AlignCenter);
ui->est1973->setMaximumWidth( m11trail);
ui->est1973->setMinimumWidth( m6trail);
ui->est1973->setMaximumHeight( m7traild3 );
ui->est1973->setMaxLength(8);
ui->est1973->setFrame(globalFrame);

ui->est1974->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "197   ") );
connect( ui->est1974, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1974, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1974->installEventFilter(this);
ui->est1974->setAlignment(Qt::AlignCenter);
ui->est1974->setMaximumWidth( m12trail);
ui->est1974->setMinimumWidth( m6trail);
ui->est1974->setMaximumHeight( m7traild3 );
ui->est1974->setMaxLength(11);
ui->est1974->setFrame(globalFrame);

ui->est1975->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "197   ") );
connect( ui->est1975, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1975, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1975->installEventFilter(this);
ui->est1975->setAlignment(Qt::AlignCenter);
ui->est1975->setMaximumWidth( m12trail);
ui->est1975->setMinimumWidth( m6trail);
ui->est1975->setMaximumHeight( m7traild3 );
ui->est1975->setMaxLength(11);
ui->est1975->setFrame(globalFrame);

ui->est1976->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "197   ") );
ui->est1976->setReadOnly(true);
ui->est1976->setAlignment(Qt::AlignRight);
ui->est1976->setMaximumWidth( m14trail);
ui->est1976->setMinimumWidth( m9trail);
ui->est1976->setMaximumHeight( m7traild3 );
ui->est1976->setMaxLength(15);
ui->est1976->setFrame(globalFrame);

ui->est1977->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "197   ") );
ui->est1977->setReadOnly(true);
ui->est1977->setAlignment(Qt::AlignRight);
ui->est1977->setMaximumWidth( m14trail);
ui->est1977->setMinimumWidth( m9trail);
ui->est1977->setMaximumHeight( m7traild3 );
ui->est1977->setMaxLength(15);
ui->est1977->setFrame(globalFrame);

ui->lib1981->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "198   ") );
connect( ui->lib1981, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1981, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib198, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst198, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1981->installEventFilter(this);
ui->lib1981->setMaximumWidth( m6trail);
ui->lib1981->setMinimumWidth( m6trail);
ui->lib1981->setMaximumHeight( m7traild3 );
ui->lib1981->setMaxLength(3);
ui->lib1981->setFrame(globalFrame);

ui->lib1982->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "198   ") );
connect( ui->lib1982, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1982, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1982->installEventFilter(this);
ui->lib1982->setMaximumWidth( m26trail);
ui->lib1982->setMinimumWidth( m25trail);
ui->lib1982->setMaximumHeight( m7traild3 );
ui->lib1982->setMaxLength(24);
ui->lib1982->setFrame(globalFrame);

ui->lib1983->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "198   ") );
connect( ui->lib1983, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1983, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1983->installEventFilter(this);
ui->lib1983->setAlignment(Qt::AlignCenter);
ui->lib1983->setMaximumWidth( m12trail);
ui->lib1983->setMinimumWidth( m6trail);
ui->lib1983->setMaximumHeight( m7traild3 );
ui->lib1983->setMaxLength(11);
ui->lib1983->setFrame(globalFrame);

ui->lib1984->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "198   ") );
connect( ui->lib1984, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1984, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1984->installEventFilter(this);
ui->lib1984->setAlignment(Qt::AlignCenter);
ui->lib1984->setMaximumWidth( m12trail);
ui->lib1984->setMinimumWidth( m6trail);
ui->lib1984->setMaximumHeight( m7traild3 );
ui->lib1984->setMaxLength(11);
ui->lib1984->setFrame(globalFrame);

ui->pushButtonEst198->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "198   ") );
ui->pushButtonEst198->setMaximumWidth( m7traild3 );
ui->pushButtonEst198->setMaximumHeight( m7traild3 );
ui->pushButtonLib198->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "198   ") );
ui->pushButtonLib198->setMaximumWidth( m7traild3 );
ui->pushButtonLib198->setMaximumHeight( m7traild3 );

ui->est1981->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "198   ") );
connect( ui->est1981, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1981, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1981->installEventFilter(this);
ui->est1981->setMaximumWidth( m6trail);
ui->est1981->setMinimumWidth( m6trail);
ui->est1981->setMaximumHeight( m7traild3 );
ui->est1981->setMaxLength(3);
ui->est1981->setFrame(globalFrame);

ui->est1982->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "198   ") );
connect( ui->est1982, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1982, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1982->installEventFilter(this);
ui->est1982->setMaximumWidth( m26trail);
ui->est1982->setMinimumWidth( m25trail);
ui->est1982->setMaximumHeight( m7traild3 );
ui->est1982->setMaxLength(24);
ui->est1982->setFrame(globalFrame);

ui->est1983->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "198   ") );
connect( ui->est1983, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1983, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1983->installEventFilter(this);
ui->est1983->setAlignment(Qt::AlignCenter);
ui->est1983->setMaximumWidth( m11trail);
ui->est1983->setMinimumWidth( m6trail);
ui->est1983->setMaximumHeight( m7traild3 );
ui->est1983->setMaxLength(8);
ui->est1983->setFrame(globalFrame);

ui->est1984->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "198   ") );
connect( ui->est1984, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1984, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1984->installEventFilter(this);
ui->est1984->setAlignment(Qt::AlignCenter);
ui->est1984->setMaximumWidth( m12trail);
ui->est1984->setMinimumWidth( m6trail);
ui->est1984->setMaximumHeight( m7traild3 );
ui->est1984->setMaxLength(11);
ui->est1984->setFrame(globalFrame);

ui->est1985->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "198   ") );
connect( ui->est1985, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1985, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1985->installEventFilter(this);
ui->est1985->setAlignment(Qt::AlignCenter);
ui->est1985->setMaximumWidth( m12trail);
ui->est1985->setMinimumWidth( m6trail);
ui->est1985->setMaximumHeight( m7traild3 );
ui->est1985->setMaxLength(11);
ui->est1985->setFrame(globalFrame);

ui->est1986->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "198   ") );
ui->est1986->setReadOnly(true);
ui->est1986->setAlignment(Qt::AlignRight);
ui->est1986->setMaximumWidth( m14trail);
ui->est1986->setMinimumWidth( m9trail);
ui->est1986->setMaximumHeight( m7traild3 );
ui->est1986->setMaxLength(15);
ui->est1986->setFrame(globalFrame);

ui->est1987->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "198   ") );
ui->est1987->setReadOnly(true);
ui->est1987->setAlignment(Qt::AlignRight);
ui->est1987->setMaximumWidth( m14trail);
ui->est1987->setMinimumWidth( m9trail);
ui->est1987->setMaximumHeight( m7traild3 );
ui->est1987->setMaxLength(15);
ui->est1987->setFrame(globalFrame);

ui->lib1991->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "199   ") );
connect( ui->lib1991, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1991, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib199, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst199, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib1991->installEventFilter(this);
ui->lib1991->setMaximumWidth( m6trail);
ui->lib1991->setMinimumWidth( m6trail);
ui->lib1991->setMaximumHeight( m7traild3 );
ui->lib1991->setMaxLength(3);
ui->lib1991->setFrame(globalFrame);

ui->lib1992->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "199   ") );
connect( ui->lib1992, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1992, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1992->installEventFilter(this);
ui->lib1992->setMaximumWidth( m26trail);
ui->lib1992->setMinimumWidth( m25trail);
ui->lib1992->setMaximumHeight( m7traild3 );
ui->lib1992->setMaxLength(24);
ui->lib1992->setFrame(globalFrame);

ui->lib1993->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "199   ") );
connect( ui->lib1993, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1993, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1993->installEventFilter(this);
ui->lib1993->setAlignment(Qt::AlignCenter);
ui->lib1993->setMaximumWidth( m12trail);
ui->lib1993->setMinimumWidth( m6trail);
ui->lib1993->setMaximumHeight( m7traild3 );
ui->lib1993->setMaxLength(11);
ui->lib1993->setFrame(globalFrame);

ui->lib1994->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "199   ") );
connect( ui->lib1994, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib1994, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib1994->installEventFilter(this);
ui->lib1994->setAlignment(Qt::AlignCenter);
ui->lib1994->setMaximumWidth( m12trail);
ui->lib1994->setMinimumWidth( m6trail);
ui->lib1994->setMaximumHeight( m7traild3 );
ui->lib1994->setMaxLength(11);
ui->lib1994->setFrame(globalFrame);

ui->pushButtonEst199->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "199   ") );
ui->pushButtonEst199->setMaximumWidth( m7traild3 );
ui->pushButtonEst199->setMaximumHeight( m7traild3 );
ui->pushButtonLib199->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "199   ") );
ui->pushButtonLib199->setMaximumWidth( m7traild3 );
ui->pushButtonLib199->setMaximumHeight( m7traild3 );

ui->est1991->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "199   ") );
connect( ui->est1991, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1991, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1991->installEventFilter(this);
ui->est1991->setMaximumWidth( m6trail);
ui->est1991->setMinimumWidth( m6trail);
ui->est1991->setMaximumHeight( m7traild3 );
ui->est1991->setMaxLength(3);
ui->est1991->setFrame(globalFrame);

ui->est1992->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "199   ") );
connect( ui->est1992, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1992, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1992->installEventFilter(this);
ui->est1992->setMaximumWidth( m26trail);
ui->est1992->setMinimumWidth( m25trail);
ui->est1992->setMaximumHeight( m7traild3 );
ui->est1992->setMaxLength(24);
ui->est1992->setFrame(globalFrame);

ui->est1993->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "199   ") );
connect( ui->est1993, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1993, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1993->installEventFilter(this);
ui->est1993->setAlignment(Qt::AlignCenter);
ui->est1993->setMaximumWidth( m11trail);
ui->est1993->setMinimumWidth( m6trail);
ui->est1993->setMaximumHeight( m7traild3 );
ui->est1993->setMaxLength(8);
ui->est1993->setFrame(globalFrame);

ui->est1994->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "199   ") );
connect( ui->est1994, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1994, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1994->installEventFilter(this);
ui->est1994->setAlignment(Qt::AlignCenter);
ui->est1994->setMaximumWidth( m12trail);
ui->est1994->setMinimumWidth( m6trail);
ui->est1994->setMaximumHeight( m7traild3 );
ui->est1994->setMaxLength(11);
ui->est1994->setFrame(globalFrame);

ui->est1995->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "199   ") );
connect( ui->est1995, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est1995, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est1995->installEventFilter(this);
ui->est1995->setAlignment(Qt::AlignCenter);
ui->est1995->setMaximumWidth( m12trail);
ui->est1995->setMinimumWidth( m6trail);
ui->est1995->setMaximumHeight( m7traild3 );
ui->est1995->setMaxLength(11);
ui->est1995->setFrame(globalFrame);

ui->est1996->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "199   ") );
ui->est1996->setReadOnly(true);
ui->est1996->setAlignment(Qt::AlignRight);
ui->est1996->setMaximumWidth( m14trail);
ui->est1996->setMinimumWidth( m9trail);
ui->est1996->setMaximumHeight( m7traild3 );
ui->est1996->setMaxLength(15);
ui->est1996->setFrame(globalFrame);

ui->est1997->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "199   ") );
ui->est1997->setReadOnly(true);
ui->est1997->setAlignment(Qt::AlignRight);
ui->est1997->setMaximumWidth( m14trail);
ui->est1997->setMinimumWidth( m9trail);
ui->est1997->setMaximumHeight( m7traild3 );
ui->est1997->setMaxLength(15);
ui->est1997->setFrame(globalFrame);

ui->lib2001->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "200   ") );
connect( ui->lib2001, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2001, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib200, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst200, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib2001->installEventFilter(this);
ui->lib2001->setMaximumWidth( m6trail);
ui->lib2001->setMinimumWidth( m6trail);
ui->lib2001->setMaximumHeight( m7traild3 );
ui->lib2001->setMaxLength(3);
ui->lib2001->setFrame(globalFrame);

ui->lib2002->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "200   ") );
connect( ui->lib2002, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2002, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2002->installEventFilter(this);
ui->lib2002->setMaximumWidth( m26trail);
ui->lib2002->setMinimumWidth( m25trail);
ui->lib2002->setMaximumHeight( m7traild3 );
ui->lib2002->setMaxLength(24);
ui->lib2002->setFrame(globalFrame);

ui->lib2003->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "200   ") );
connect( ui->lib2003, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2003, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2003->installEventFilter(this);
ui->lib2003->setAlignment(Qt::AlignCenter);
ui->lib2003->setMaximumWidth( m12trail);
ui->lib2003->setMinimumWidth( m6trail);
ui->lib2003->setMaximumHeight( m7traild3 );
ui->lib2003->setMaxLength(11);
ui->lib2003->setFrame(globalFrame);

ui->lib2004->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "200   ") );
connect( ui->lib2004, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2004, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2004->installEventFilter(this);
ui->lib2004->setAlignment(Qt::AlignCenter);
ui->lib2004->setMaximumWidth( m12trail);
ui->lib2004->setMinimumWidth( m6trail);
ui->lib2004->setMaximumHeight( m7traild3 );
ui->lib2004->setMaxLength(11);
ui->lib2004->setFrame(globalFrame);

ui->pushButtonEst200->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "200   ") );
ui->pushButtonEst200->setMaximumWidth( m7traild3 );
ui->pushButtonEst200->setMaximumHeight( m7traild3 );
ui->pushButtonLib200->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "200   ") );
ui->pushButtonLib200->setMaximumWidth( m7traild3 );
ui->pushButtonLib200->setMaximumHeight( m7traild3 );

ui->est2001->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "200   ") );
connect( ui->est2001, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2001, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2001->installEventFilter(this);
ui->est2001->setMaximumWidth( m6trail);
ui->est2001->setMinimumWidth( m6trail);
ui->est2001->setMaximumHeight( m7traild3 );
ui->est2001->setMaxLength(3);
ui->est2001->setFrame(globalFrame);

ui->est2002->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "200   ") );
connect( ui->est2002, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2002, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2002->installEventFilter(this);
ui->est2002->setMaximumWidth( m26trail);
ui->est2002->setMinimumWidth( m25trail);
ui->est2002->setMaximumHeight( m7traild3 );
ui->est2002->setMaxLength(24);
ui->est2002->setFrame(globalFrame);

ui->est2003->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "200   ") );
connect( ui->est2003, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2003, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2003->installEventFilter(this);
ui->est2003->setAlignment(Qt::AlignCenter);
ui->est2003->setMaximumWidth( m11trail);
ui->est2003->setMinimumWidth( m6trail);
ui->est2003->setMaximumHeight( m7traild3 );
ui->est2003->setMaxLength(8);
ui->est2003->setFrame(globalFrame);

ui->est2004->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "200   ") );
connect( ui->est2004, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2004, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2004->installEventFilter(this);
ui->est2004->setAlignment(Qt::AlignCenter);
ui->est2004->setMaximumWidth( m12trail);
ui->est2004->setMinimumWidth( m6trail);
ui->est2004->setMaximumHeight( m7traild3 );
ui->est2004->setMaxLength(11);
ui->est2004->setFrame(globalFrame);

ui->est2005->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "200   ") );
connect( ui->est2005, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2005, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2005->installEventFilter(this);
ui->est2005->setAlignment(Qt::AlignCenter);
ui->est2005->setMaximumWidth( m12trail);
ui->est2005->setMinimumWidth( m6trail);
ui->est2005->setMaximumHeight( m7traild3 );
ui->est2005->setMaxLength(11);
ui->est2005->setFrame(globalFrame);

ui->est2006->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "200   ") );
ui->est2006->setReadOnly(true);
ui->est2006->setAlignment(Qt::AlignRight);
ui->est2006->setMaximumWidth( m14trail);
ui->est2006->setMinimumWidth( m9trail);
ui->est2006->setMaximumHeight( m7traild3 );
ui->est2006->setMaxLength(15);
ui->est2006->setFrame(globalFrame);

ui->est2007->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "200   ") );
ui->est2007->setReadOnly(true);
ui->est2007->setAlignment(Qt::AlignRight);
ui->est2007->setMaximumWidth( m14trail);
ui->est2007->setMinimumWidth( m9trail);
ui->est2007->setMaximumHeight( m7traild3 );
ui->est2007->setMaxLength(15);
ui->est2007->setFrame(globalFrame);

ui->lib2011->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "201   ") );
connect( ui->lib2011, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2011, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib201, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst201, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib2011->installEventFilter(this);
ui->lib2011->setMaximumWidth( m6trail);
ui->lib2011->setMinimumWidth( m6trail);
ui->lib2011->setMaximumHeight( m7traild3 );
ui->lib2011->setMaxLength(3);
ui->lib2011->setFrame(globalFrame);

ui->lib2012->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "201   ") );
connect( ui->lib2012, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2012, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2012->installEventFilter(this);
ui->lib2012->setMaximumWidth( m26trail);
ui->lib2012->setMinimumWidth( m25trail);
ui->lib2012->setMaximumHeight( m7traild3 );
ui->lib2012->setMaxLength(24);
ui->lib2012->setFrame(globalFrame);

ui->lib2013->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "201   ") );
connect( ui->lib2013, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2013, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2013->installEventFilter(this);
ui->lib2013->setAlignment(Qt::AlignCenter);
ui->lib2013->setMaximumWidth( m12trail);
ui->lib2013->setMinimumWidth( m6trail);
ui->lib2013->setMaximumHeight( m7traild3 );
ui->lib2013->setMaxLength(11);
ui->lib2013->setFrame(globalFrame);

ui->lib2014->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "201   ") );
connect( ui->lib2014, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2014, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2014->installEventFilter(this);
ui->lib2014->setAlignment(Qt::AlignCenter);
ui->lib2014->setMaximumWidth( m12trail);
ui->lib2014->setMinimumWidth( m6trail);
ui->lib2014->setMaximumHeight( m7traild3 );
ui->lib2014->setMaxLength(11);
ui->lib2014->setFrame(globalFrame);

ui->pushButtonEst201->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "201   ") );
ui->pushButtonEst201->setMaximumWidth( m7traild3 );
ui->pushButtonEst201->setMaximumHeight( m7traild3 );
ui->pushButtonLib201->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "201   ") );
ui->pushButtonLib201->setMaximumWidth( m7traild3 );
ui->pushButtonLib201->setMaximumHeight( m7traild3 );

ui->est2011->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "201   ") );
connect( ui->est2011, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2011, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2011->installEventFilter(this);
ui->est2011->setMaximumWidth( m6trail);
ui->est2011->setMinimumWidth( m6trail);
ui->est2011->setMaximumHeight( m7traild3 );
ui->est2011->setMaxLength(3);
ui->est2011->setFrame(globalFrame);

ui->est2012->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "201   ") );
connect( ui->est2012, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2012, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2012->installEventFilter(this);
ui->est2012->setMaximumWidth( m26trail);
ui->est2012->setMinimumWidth( m25trail);
ui->est2012->setMaximumHeight( m7traild3 );
ui->est2012->setMaxLength(24);
ui->est2012->setFrame(globalFrame);

ui->est2013->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "201   ") );
connect( ui->est2013, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2013, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2013->installEventFilter(this);
ui->est2013->setAlignment(Qt::AlignCenter);
ui->est2013->setMaximumWidth( m11trail);
ui->est2013->setMinimumWidth( m6trail);
ui->est2013->setMaximumHeight( m7traild3 );
ui->est2013->setMaxLength(8);
ui->est2013->setFrame(globalFrame);

ui->est2014->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "201   ") );
connect( ui->est2014, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2014, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2014->installEventFilter(this);
ui->est2014->setAlignment(Qt::AlignCenter);
ui->est2014->setMaximumWidth( m12trail);
ui->est2014->setMinimumWidth( m6trail);
ui->est2014->setMaximumHeight( m7traild3 );
ui->est2014->setMaxLength(11);
ui->est2014->setFrame(globalFrame);

ui->est2015->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "201   ") );
connect( ui->est2015, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2015, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2015->installEventFilter(this);
ui->est2015->setAlignment(Qt::AlignCenter);
ui->est2015->setMaximumWidth( m12trail);
ui->est2015->setMinimumWidth( m6trail);
ui->est2015->setMaximumHeight( m7traild3 );
ui->est2015->setMaxLength(11);
ui->est2015->setFrame(globalFrame);

ui->est2016->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "201   ") );
ui->est2016->setReadOnly(true);
ui->est2016->setAlignment(Qt::AlignRight);
ui->est2016->setMaximumWidth( m14trail);
ui->est2016->setMinimumWidth( m9trail);
ui->est2016->setMaximumHeight( m7traild3 );
ui->est2016->setMaxLength(15);
ui->est2016->setFrame(globalFrame);

ui->est2017->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "201   ") );
ui->est2017->setReadOnly(true);
ui->est2017->setAlignment(Qt::AlignRight);
ui->est2017->setMaximumWidth( m14trail);
ui->est2017->setMinimumWidth( m9trail);
ui->est2017->setMaximumHeight( m7traild3 );
ui->est2017->setMaxLength(15);
ui->est2017->setFrame(globalFrame);

ui->lib2021->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "202   ") );
connect( ui->lib2021, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2021, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib202, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst202, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib2021->installEventFilter(this);
ui->lib2021->setMaximumWidth( m6trail);
ui->lib2021->setMinimumWidth( m6trail);
ui->lib2021->setMaximumHeight( m7traild3 );
ui->lib2021->setMaxLength(3);
ui->lib2021->setFrame(globalFrame);

ui->lib2022->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "202   ") );
connect( ui->lib2022, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2022, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2022->installEventFilter(this);
ui->lib2022->setMaximumWidth( m26trail);
ui->lib2022->setMinimumWidth( m25trail);
ui->lib2022->setMaximumHeight( m7traild3 );
ui->lib2022->setMaxLength(24);
ui->lib2022->setFrame(globalFrame);

ui->lib2023->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "202   ") );
connect( ui->lib2023, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2023, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2023->installEventFilter(this);
ui->lib2023->setAlignment(Qt::AlignCenter);
ui->lib2023->setMaximumWidth( m12trail);
ui->lib2023->setMinimumWidth( m6trail);
ui->lib2023->setMaximumHeight( m7traild3 );
ui->lib2023->setMaxLength(11);
ui->lib2023->setFrame(globalFrame);

ui->lib2024->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "202   ") );
connect( ui->lib2024, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2024, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2024->installEventFilter(this);
ui->lib2024->setAlignment(Qt::AlignCenter);
ui->lib2024->setMaximumWidth( m12trail);
ui->lib2024->setMinimumWidth( m6trail);
ui->lib2024->setMaximumHeight( m7traild3 );
ui->lib2024->setMaxLength(11);
ui->lib2024->setFrame(globalFrame);

ui->pushButtonEst202->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "202   ") );
ui->pushButtonEst202->setMaximumWidth( m7traild3 );
ui->pushButtonEst202->setMaximumHeight( m7traild3 );
ui->pushButtonLib202->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "202   ") );
ui->pushButtonLib202->setMaximumWidth( m7traild3 );
ui->pushButtonLib202->setMaximumHeight( m7traild3 );

ui->est2021->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "202   ") );
connect( ui->est2021, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2021, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2021->installEventFilter(this);
ui->est2021->setMaximumWidth( m6trail);
ui->est2021->setMinimumWidth( m6trail);
ui->est2021->setMaximumHeight( m7traild3 );
ui->est2021->setMaxLength(3);
ui->est2021->setFrame(globalFrame);

ui->est2022->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "202   ") );
connect( ui->est2022, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2022, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2022->installEventFilter(this);
ui->est2022->setMaximumWidth( m26trail);
ui->est2022->setMinimumWidth( m25trail);
ui->est2022->setMaximumHeight( m7traild3 );
ui->est2022->setMaxLength(24);
ui->est2022->setFrame(globalFrame);

ui->est2023->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "202   ") );
connect( ui->est2023, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2023, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2023->installEventFilter(this);
ui->est2023->setAlignment(Qt::AlignCenter);
ui->est2023->setMaximumWidth( m11trail);
ui->est2023->setMinimumWidth( m6trail);
ui->est2023->setMaximumHeight( m7traild3 );
ui->est2023->setMaxLength(8);
ui->est2023->setFrame(globalFrame);

ui->est2024->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "202   ") );
connect( ui->est2024, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2024, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2024->installEventFilter(this);
ui->est2024->setAlignment(Qt::AlignCenter);
ui->est2024->setMaximumWidth( m12trail);
ui->est2024->setMinimumWidth( m6trail);
ui->est2024->setMaximumHeight( m7traild3 );
ui->est2024->setMaxLength(11);
ui->est2024->setFrame(globalFrame);

ui->est2025->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "202   ") );
connect( ui->est2025, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2025, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2025->installEventFilter(this);
ui->est2025->setAlignment(Qt::AlignCenter);
ui->est2025->setMaximumWidth( m12trail);
ui->est2025->setMinimumWidth( m6trail);
ui->est2025->setMaximumHeight( m7traild3 );
ui->est2025->setMaxLength(11);
ui->est2025->setFrame(globalFrame);

ui->est2026->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "202   ") );
ui->est2026->setReadOnly(true);
ui->est2026->setAlignment(Qt::AlignRight);
ui->est2026->setMaximumWidth( m14trail);
ui->est2026->setMinimumWidth( m9trail);
ui->est2026->setMaximumHeight( m7traild3 );
ui->est2026->setMaxLength(15);
ui->est2026->setFrame(globalFrame);

ui->est2027->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "202   ") );
ui->est2027->setReadOnly(true);
ui->est2027->setAlignment(Qt::AlignRight);
ui->est2027->setMaximumWidth( m14trail);
ui->est2027->setMinimumWidth( m9trail);
ui->est2027->setMaximumHeight( m7traild3 );
ui->est2027->setMaxLength(15);
ui->est2027->setFrame(globalFrame);

ui->lib2031->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "203   ") );
connect( ui->lib2031, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2031, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib203, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst203, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib2031->installEventFilter(this);
ui->lib2031->setMaximumWidth( m6trail);
ui->lib2031->setMinimumWidth( m6trail);
ui->lib2031->setMaximumHeight( m7traild3 );
ui->lib2031->setMaxLength(3);
ui->lib2031->setFrame(globalFrame);

ui->lib2032->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "203   ") );
connect( ui->lib2032, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2032, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2032->installEventFilter(this);
ui->lib2032->setMaximumWidth( m26trail);
ui->lib2032->setMinimumWidth( m25trail);
ui->lib2032->setMaximumHeight( m7traild3 );
ui->lib2032->setMaxLength(24);
ui->lib2032->setFrame(globalFrame);

ui->lib2033->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "203   ") );
connect( ui->lib2033, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2033, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2033->installEventFilter(this);
ui->lib2033->setAlignment(Qt::AlignCenter);
ui->lib2033->setMaximumWidth( m12trail);
ui->lib2033->setMinimumWidth( m6trail);
ui->lib2033->setMaximumHeight( m7traild3 );
ui->lib2033->setMaxLength(11);
ui->lib2033->setFrame(globalFrame);

ui->lib2034->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "203   ") );
connect( ui->lib2034, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2034, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2034->installEventFilter(this);
ui->lib2034->setAlignment(Qt::AlignCenter);
ui->lib2034->setMaximumWidth( m12trail);
ui->lib2034->setMinimumWidth( m6trail);
ui->lib2034->setMaximumHeight( m7traild3 );
ui->lib2034->setMaxLength(11);
ui->lib2034->setFrame(globalFrame);

ui->pushButtonEst203->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "203   ") );
ui->pushButtonEst203->setMaximumWidth( m7traild3 );
ui->pushButtonEst203->setMaximumHeight( m7traild3 );
ui->pushButtonLib203->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "203   ") );
ui->pushButtonLib203->setMaximumWidth( m7traild3 );
ui->pushButtonLib203->setMaximumHeight( m7traild3 );

ui->est2031->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "203   ") );
connect( ui->est2031, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2031, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2031->installEventFilter(this);
ui->est2031->setMaximumWidth( m6trail);
ui->est2031->setMinimumWidth( m6trail);
ui->est2031->setMaximumHeight( m7traild3 );
ui->est2031->setMaxLength(3);
ui->est2031->setFrame(globalFrame);

ui->est2032->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "203   ") );
connect( ui->est2032, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2032, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2032->installEventFilter(this);
ui->est2032->setMaximumWidth( m26trail);
ui->est2032->setMinimumWidth( m25trail);
ui->est2032->setMaximumHeight( m7traild3 );
ui->est2032->setMaxLength(24);
ui->est2032->setFrame(globalFrame);

ui->est2033->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "203   ") );
connect( ui->est2033, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2033, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2033->installEventFilter(this);
ui->est2033->setAlignment(Qt::AlignCenter);
ui->est2033->setMaximumWidth( m11trail);
ui->est2033->setMinimumWidth( m6trail);
ui->est2033->setMaximumHeight( m7traild3 );
ui->est2033->setMaxLength(8);
ui->est2033->setFrame(globalFrame);

ui->est2034->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "203   ") );
connect( ui->est2034, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2034, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2034->installEventFilter(this);
ui->est2034->setAlignment(Qt::AlignCenter);
ui->est2034->setMaximumWidth( m12trail);
ui->est2034->setMinimumWidth( m6trail);
ui->est2034->setMaximumHeight( m7traild3 );
ui->est2034->setMaxLength(11);
ui->est2034->setFrame(globalFrame);

ui->est2035->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "203   ") );
connect( ui->est2035, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2035, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2035->installEventFilter(this);
ui->est2035->setAlignment(Qt::AlignCenter);
ui->est2035->setMaximumWidth( m12trail);
ui->est2035->setMinimumWidth( m6trail);
ui->est2035->setMaximumHeight( m7traild3 );
ui->est2035->setMaxLength(11);
ui->est2035->setFrame(globalFrame);

ui->est2036->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "203   ") );
ui->est2036->setReadOnly(true);
ui->est2036->setAlignment(Qt::AlignRight);
ui->est2036->setMaximumWidth( m14trail);
ui->est2036->setMinimumWidth( m9trail);
ui->est2036->setMaximumHeight( m7traild3 );
ui->est2036->setMaxLength(15);
ui->est2036->setFrame(globalFrame);

ui->est2037->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "203   ") );
ui->est2037->setReadOnly(true);
ui->est2037->setAlignment(Qt::AlignRight);
ui->est2037->setMaximumWidth( m14trail);
ui->est2037->setMinimumWidth( m9trail);
ui->est2037->setMaximumHeight( m7traild3 );
ui->est2037->setMaxLength(15);
ui->est2037->setFrame(globalFrame);

ui->lib2041->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "204   ") );
connect( ui->lib2041, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2041, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib204, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst204, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib2041->installEventFilter(this);
ui->lib2041->setMaximumWidth( m6trail);
ui->lib2041->setMinimumWidth( m6trail);
ui->lib2041->setMaximumHeight( m7traild3 );
ui->lib2041->setMaxLength(3);
ui->lib2041->setFrame(globalFrame);

ui->lib2042->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "204   ") );
connect( ui->lib2042, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2042, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2042->installEventFilter(this);
ui->lib2042->setMaximumWidth( m26trail);
ui->lib2042->setMinimumWidth( m25trail);
ui->lib2042->setMaximumHeight( m7traild3 );
ui->lib2042->setMaxLength(24);
ui->lib2042->setFrame(globalFrame);

ui->lib2043->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "204   ") );
connect( ui->lib2043, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2043, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2043->installEventFilter(this);
ui->lib2043->setAlignment(Qt::AlignCenter);
ui->lib2043->setMaximumWidth( m12trail);
ui->lib2043->setMinimumWidth( m6trail);
ui->lib2043->setMaximumHeight( m7traild3 );
ui->lib2043->setMaxLength(11);
ui->lib2043->setFrame(globalFrame);

ui->lib2044->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "204   ") );
connect( ui->lib2044, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2044, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2044->installEventFilter(this);
ui->lib2044->setAlignment(Qt::AlignCenter);
ui->lib2044->setMaximumWidth( m12trail);
ui->lib2044->setMinimumWidth( m6trail);
ui->lib2044->setMaximumHeight( m7traild3 );
ui->lib2044->setMaxLength(11);
ui->lib2044->setFrame(globalFrame);

ui->pushButtonEst204->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "204   ") );
ui->pushButtonEst204->setMaximumWidth( m7traild3 );
ui->pushButtonEst204->setMaximumHeight( m7traild3 );
ui->pushButtonLib204->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "204   ") );
ui->pushButtonLib204->setMaximumWidth( m7traild3 );
ui->pushButtonLib204->setMaximumHeight( m7traild3 );

ui->est2041->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "204   ") );
connect( ui->est2041, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2041, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2041->installEventFilter(this);
ui->est2041->setMaximumWidth( m6trail);
ui->est2041->setMinimumWidth( m6trail);
ui->est2041->setMaximumHeight( m7traild3 );
ui->est2041->setMaxLength(3);
ui->est2041->setFrame(globalFrame);

ui->est2042->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "204   ") );
connect( ui->est2042, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2042, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2042->installEventFilter(this);
ui->est2042->setMaximumWidth( m26trail);
ui->est2042->setMinimumWidth( m25trail);
ui->est2042->setMaximumHeight( m7traild3 );
ui->est2042->setMaxLength(24);
ui->est2042->setFrame(globalFrame);

ui->est2043->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "204   ") );
connect( ui->est2043, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2043, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2043->installEventFilter(this);
ui->est2043->setAlignment(Qt::AlignCenter);
ui->est2043->setMaximumWidth( m11trail);
ui->est2043->setMinimumWidth( m6trail);
ui->est2043->setMaximumHeight( m7traild3 );
ui->est2043->setMaxLength(8);
ui->est2043->setFrame(globalFrame);

ui->est2044->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "204   ") );
connect( ui->est2044, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2044, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2044->installEventFilter(this);
ui->est2044->setAlignment(Qt::AlignCenter);
ui->est2044->setMaximumWidth( m12trail);
ui->est2044->setMinimumWidth( m6trail);
ui->est2044->setMaximumHeight( m7traild3 );
ui->est2044->setMaxLength(11);
ui->est2044->setFrame(globalFrame);

ui->est2045->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "204   ") );
connect( ui->est2045, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2045, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2045->installEventFilter(this);
ui->est2045->setAlignment(Qt::AlignCenter);
ui->est2045->setMaximumWidth( m12trail);
ui->est2045->setMinimumWidth( m6trail);
ui->est2045->setMaximumHeight( m7traild3 );
ui->est2045->setMaxLength(11);
ui->est2045->setFrame(globalFrame);

ui->est2046->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "204   ") );
ui->est2046->setReadOnly(true);
ui->est2046->setAlignment(Qt::AlignRight);
ui->est2046->setMaximumWidth( m14trail);
ui->est2046->setMinimumWidth( m9trail);
ui->est2046->setMaximumHeight( m7traild3 );
ui->est2046->setMaxLength(15);
ui->est2046->setFrame(globalFrame);

ui->est2047->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "204   ") );
ui->est2047->setReadOnly(true);
ui->est2047->setAlignment(Qt::AlignRight);
ui->est2047->setMaximumWidth( m14trail);
ui->est2047->setMinimumWidth( m9trail);
ui->est2047->setMaximumHeight( m7traild3 );
ui->est2047->setMaxLength(15);
ui->est2047->setFrame(globalFrame);

ui->lib2051->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "205   ") );
connect( ui->lib2051, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2051, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib205, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst205, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib2051->installEventFilter(this);
ui->lib2051->setMaximumWidth( m6trail);
ui->lib2051->setMinimumWidth( m6trail);
ui->lib2051->setMaximumHeight( m7traild3 );
ui->lib2051->setMaxLength(3);
ui->lib2051->setFrame(globalFrame);

ui->lib2052->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "205   ") );
connect( ui->lib2052, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2052, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2052->installEventFilter(this);
ui->lib2052->setMaximumWidth( m26trail);
ui->lib2052->setMinimumWidth( m25trail);
ui->lib2052->setMaximumHeight( m7traild3 );
ui->lib2052->setMaxLength(24);
ui->lib2052->setFrame(globalFrame);

ui->lib2053->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "205   ") );
connect( ui->lib2053, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2053, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2053->installEventFilter(this);
ui->lib2053->setAlignment(Qt::AlignCenter);
ui->lib2053->setMaximumWidth( m12trail);
ui->lib2053->setMinimumWidth( m6trail);
ui->lib2053->setMaximumHeight( m7traild3 );
ui->lib2053->setMaxLength(11);
ui->lib2053->setFrame(globalFrame);

ui->lib2054->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "205   ") );
connect( ui->lib2054, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2054, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2054->installEventFilter(this);
ui->lib2054->setAlignment(Qt::AlignCenter);
ui->lib2054->setMaximumWidth( m12trail);
ui->lib2054->setMinimumWidth( m6trail);
ui->lib2054->setMaximumHeight( m7traild3 );
ui->lib2054->setMaxLength(11);
ui->lib2054->setFrame(globalFrame);

ui->pushButtonEst205->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "205   ") );
ui->pushButtonEst205->setMaximumWidth( m7traild3 );
ui->pushButtonEst205->setMaximumHeight( m7traild3 );
ui->pushButtonLib205->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "205   ") );
ui->pushButtonLib205->setMaximumWidth( m7traild3 );
ui->pushButtonLib205->setMaximumHeight( m7traild3 );

ui->est2051->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "205   ") );
connect( ui->est2051, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2051, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2051->installEventFilter(this);
ui->est2051->setMaximumWidth( m6trail);
ui->est2051->setMinimumWidth( m6trail);
ui->est2051->setMaximumHeight( m7traild3 );
ui->est2051->setMaxLength(3);
ui->est2051->setFrame(globalFrame);

ui->est2052->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "205   ") );
connect( ui->est2052, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2052, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2052->installEventFilter(this);
ui->est2052->setMaximumWidth( m26trail);
ui->est2052->setMinimumWidth( m25trail);
ui->est2052->setMaximumHeight( m7traild3 );
ui->est2052->setMaxLength(24);
ui->est2052->setFrame(globalFrame);

ui->est2053->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "205   ") );
connect( ui->est2053, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2053, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2053->installEventFilter(this);
ui->est2053->setAlignment(Qt::AlignCenter);
ui->est2053->setMaximumWidth( m11trail);
ui->est2053->setMinimumWidth( m6trail);
ui->est2053->setMaximumHeight( m7traild3 );
ui->est2053->setMaxLength(8);
ui->est2053->setFrame(globalFrame);

ui->est2054->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "205   ") );
connect( ui->est2054, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2054, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2054->installEventFilter(this);
ui->est2054->setAlignment(Qt::AlignCenter);
ui->est2054->setMaximumWidth( m12trail);
ui->est2054->setMinimumWidth( m6trail);
ui->est2054->setMaximumHeight( m7traild3 );
ui->est2054->setMaxLength(11);
ui->est2054->setFrame(globalFrame);

ui->est2055->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "205   ") );
connect( ui->est2055, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2055, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2055->installEventFilter(this);
ui->est2055->setAlignment(Qt::AlignCenter);
ui->est2055->setMaximumWidth( m12trail);
ui->est2055->setMinimumWidth( m6trail);
ui->est2055->setMaximumHeight( m7traild3 );
ui->est2055->setMaxLength(11);
ui->est2055->setFrame(globalFrame);

ui->est2056->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "205   ") );
ui->est2056->setReadOnly(true);
ui->est2056->setAlignment(Qt::AlignRight);
ui->est2056->setMaximumWidth( m14trail);
ui->est2056->setMinimumWidth( m9trail);
ui->est2056->setMaximumHeight( m7traild3 );
ui->est2056->setMaxLength(15);
ui->est2056->setFrame(globalFrame);

ui->est2057->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "205   ") );
ui->est2057->setReadOnly(true);
ui->est2057->setAlignment(Qt::AlignRight);
ui->est2057->setMaximumWidth( m14trail);
ui->est2057->setMinimumWidth( m9trail);
ui->est2057->setMaximumHeight( m7traild3 );
ui->est2057->setMaxLength(15);
ui->est2057->setFrame(globalFrame);

ui->lib2061->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "206   ") );
connect( ui->lib2061, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2061, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib206, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst206, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib2061->installEventFilter(this);
ui->lib2061->setMaximumWidth( m6trail);
ui->lib2061->setMinimumWidth( m6trail);
ui->lib2061->setMaximumHeight( m7traild3 );
ui->lib2061->setMaxLength(3);
ui->lib2061->setFrame(globalFrame);

ui->lib2062->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "206   ") );
connect( ui->lib2062, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2062, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2062->installEventFilter(this);
ui->lib2062->setMaximumWidth( m26trail);
ui->lib2062->setMinimumWidth( m25trail);
ui->lib2062->setMaximumHeight( m7traild3 );
ui->lib2062->setMaxLength(24);
ui->lib2062->setFrame(globalFrame);

ui->lib2063->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "206   ") );
connect( ui->lib2063, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2063, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2063->installEventFilter(this);
ui->lib2063->setAlignment(Qt::AlignCenter);
ui->lib2063->setMaximumWidth( m12trail);
ui->lib2063->setMinimumWidth( m6trail);
ui->lib2063->setMaximumHeight( m7traild3 );
ui->lib2063->setMaxLength(11);
ui->lib2063->setFrame(globalFrame);

ui->lib2064->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "206   ") );
connect( ui->lib2064, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2064, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2064->installEventFilter(this);
ui->lib2064->setAlignment(Qt::AlignCenter);
ui->lib2064->setMaximumWidth( m12trail);
ui->lib2064->setMinimumWidth( m6trail);
ui->lib2064->setMaximumHeight( m7traild3 );
ui->lib2064->setMaxLength(11);
ui->lib2064->setFrame(globalFrame);

ui->pushButtonEst206->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "206   ") );
ui->pushButtonEst206->setMaximumWidth( m7traild3 );
ui->pushButtonEst206->setMaximumHeight( m7traild3 );
ui->pushButtonLib206->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "206   ") );
ui->pushButtonLib206->setMaximumWidth( m7traild3 );
ui->pushButtonLib206->setMaximumHeight( m7traild3 );

ui->est2061->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "206   ") );
connect( ui->est2061, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2061, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2061->installEventFilter(this);
ui->est2061->setMaximumWidth( m6trail);
ui->est2061->setMinimumWidth( m6trail);
ui->est2061->setMaximumHeight( m7traild3 );
ui->est2061->setMaxLength(3);
ui->est2061->setFrame(globalFrame);

ui->est2062->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "206   ") );
connect( ui->est2062, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2062, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2062->installEventFilter(this);
ui->est2062->setMaximumWidth( m26trail);
ui->est2062->setMinimumWidth( m25trail);
ui->est2062->setMaximumHeight( m7traild3 );
ui->est2062->setMaxLength(24);
ui->est2062->setFrame(globalFrame);

ui->est2063->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "206   ") );
connect( ui->est2063, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2063, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2063->installEventFilter(this);
ui->est2063->setAlignment(Qt::AlignCenter);
ui->est2063->setMaximumWidth( m11trail);
ui->est2063->setMinimumWidth( m6trail);
ui->est2063->setMaximumHeight( m7traild3 );
ui->est2063->setMaxLength(8);
ui->est2063->setFrame(globalFrame);

ui->est2064->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "206   ") );
connect( ui->est2064, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2064, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2064->installEventFilter(this);
ui->est2064->setAlignment(Qt::AlignCenter);
ui->est2064->setMaximumWidth( m12trail);
ui->est2064->setMinimumWidth( m6trail);
ui->est2064->setMaximumHeight( m7traild3 );
ui->est2064->setMaxLength(11);
ui->est2064->setFrame(globalFrame);

ui->est2065->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "206   ") );
connect( ui->est2065, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2065, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2065->installEventFilter(this);
ui->est2065->setAlignment(Qt::AlignCenter);
ui->est2065->setMaximumWidth( m12trail);
ui->est2065->setMinimumWidth( m6trail);
ui->est2065->setMaximumHeight( m7traild3 );
ui->est2065->setMaxLength(11);
ui->est2065->setFrame(globalFrame);

ui->est2066->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "206   ") );
ui->est2066->setReadOnly(true);
ui->est2066->setAlignment(Qt::AlignRight);
ui->est2066->setMaximumWidth( m14trail);
ui->est2066->setMinimumWidth( m9trail);
ui->est2066->setMaximumHeight( m7traild3 );
ui->est2066->setMaxLength(15);
ui->est2066->setFrame(globalFrame);

ui->est2067->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "206   ") );
ui->est2067->setReadOnly(true);
ui->est2067->setAlignment(Qt::AlignRight);
ui->est2067->setMaximumWidth( m14trail);
ui->est2067->setMinimumWidth( m9trail);
ui->est2067->setMaximumHeight( m7traild3 );
ui->est2067->setMaxLength(15);
ui->est2067->setFrame(globalFrame);

ui->lib2071->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "207   ") );
connect( ui->lib2071, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2071, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib207, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst207, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib2071->installEventFilter(this);
ui->lib2071->setMaximumWidth( m6trail);
ui->lib2071->setMinimumWidth( m6trail);
ui->lib2071->setMaximumHeight( m7traild3 );
ui->lib2071->setMaxLength(3);
ui->lib2071->setFrame(globalFrame);

ui->lib2072->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "207   ") );
connect( ui->lib2072, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2072, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2072->installEventFilter(this);
ui->lib2072->setMaximumWidth( m26trail);
ui->lib2072->setMinimumWidth( m25trail);
ui->lib2072->setMaximumHeight( m7traild3 );
ui->lib2072->setMaxLength(24);
ui->lib2072->setFrame(globalFrame);

ui->lib2073->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "207   ") );
connect( ui->lib2073, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2073, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2073->installEventFilter(this);
ui->lib2073->setAlignment(Qt::AlignCenter);
ui->lib2073->setMaximumWidth( m12trail);
ui->lib2073->setMinimumWidth( m6trail);
ui->lib2073->setMaximumHeight( m7traild3 );
ui->lib2073->setMaxLength(11);
ui->lib2073->setFrame(globalFrame);

ui->lib2074->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "207   ") );
connect( ui->lib2074, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2074, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2074->installEventFilter(this);
ui->lib2074->setAlignment(Qt::AlignCenter);
ui->lib2074->setMaximumWidth( m12trail);
ui->lib2074->setMinimumWidth( m6trail);
ui->lib2074->setMaximumHeight( m7traild3 );
ui->lib2074->setMaxLength(11);
ui->lib2074->setFrame(globalFrame);

ui->pushButtonEst207->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "207   ") );
ui->pushButtonEst207->setMaximumWidth( m7traild3 );
ui->pushButtonEst207->setMaximumHeight( m7traild3 );
ui->pushButtonLib207->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "207   ") );
ui->pushButtonLib207->setMaximumWidth( m7traild3 );
ui->pushButtonLib207->setMaximumHeight( m7traild3 );

ui->est2071->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "207   ") );
connect( ui->est2071, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2071, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2071->installEventFilter(this);
ui->est2071->setMaximumWidth( m6trail);
ui->est2071->setMinimumWidth( m6trail);
ui->est2071->setMaximumHeight( m7traild3 );
ui->est2071->setMaxLength(3);
ui->est2071->setFrame(globalFrame);

ui->est2072->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "207   ") );
connect( ui->est2072, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2072, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2072->installEventFilter(this);
ui->est2072->setMaximumWidth( m26trail);
ui->est2072->setMinimumWidth( m25trail);
ui->est2072->setMaximumHeight( m7traild3 );
ui->est2072->setMaxLength(24);
ui->est2072->setFrame(globalFrame);

ui->est2073->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "207   ") );
connect( ui->est2073, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2073, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2073->installEventFilter(this);
ui->est2073->setAlignment(Qt::AlignCenter);
ui->est2073->setMaximumWidth( m11trail);
ui->est2073->setMinimumWidth( m6trail);
ui->est2073->setMaximumHeight( m7traild3 );
ui->est2073->setMaxLength(8);
ui->est2073->setFrame(globalFrame);

ui->est2074->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "207   ") );
connect( ui->est2074, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2074, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2074->installEventFilter(this);
ui->est2074->setAlignment(Qt::AlignCenter);
ui->est2074->setMaximumWidth( m12trail);
ui->est2074->setMinimumWidth( m6trail);
ui->est2074->setMaximumHeight( m7traild3 );
ui->est2074->setMaxLength(11);
ui->est2074->setFrame(globalFrame);

ui->est2075->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "207   ") );
connect( ui->est2075, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2075, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2075->installEventFilter(this);
ui->est2075->setAlignment(Qt::AlignCenter);
ui->est2075->setMaximumWidth( m12trail);
ui->est2075->setMinimumWidth( m6trail);
ui->est2075->setMaximumHeight( m7traild3 );
ui->est2075->setMaxLength(11);
ui->est2075->setFrame(globalFrame);

ui->est2076->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "207   ") );
ui->est2076->setReadOnly(true);
ui->est2076->setAlignment(Qt::AlignRight);
ui->est2076->setMaximumWidth( m14trail);
ui->est2076->setMinimumWidth( m9trail);
ui->est2076->setMaximumHeight( m7traild3 );
ui->est2076->setMaxLength(15);
ui->est2076->setFrame(globalFrame);

ui->est2077->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "207   ") );
ui->est2077->setReadOnly(true);
ui->est2077->setAlignment(Qt::AlignRight);
ui->est2077->setMaximumWidth( m14trail);
ui->est2077->setMinimumWidth( m9trail);
ui->est2077->setMaximumHeight( m7traild3 );
ui->est2077->setMaxLength(15);
ui->est2077->setFrame(globalFrame);

ui->lib2081->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "208   ") );
connect( ui->lib2081, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2081, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib208, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst208, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib2081->installEventFilter(this);
ui->lib2081->setMaximumWidth( m6trail);
ui->lib2081->setMinimumWidth( m6trail);
ui->lib2081->setMaximumHeight( m7traild3 );
ui->lib2081->setMaxLength(3);
ui->lib2081->setFrame(globalFrame);

ui->lib2082->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "208   ") );
connect( ui->lib2082, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2082, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2082->installEventFilter(this);
ui->lib2082->setMaximumWidth( m26trail);
ui->lib2082->setMinimumWidth( m25trail);
ui->lib2082->setMaximumHeight( m7traild3 );
ui->lib2082->setMaxLength(24);
ui->lib2082->setFrame(globalFrame);

ui->lib2083->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "208   ") );
connect( ui->lib2083, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2083, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2083->installEventFilter(this);
ui->lib2083->setAlignment(Qt::AlignCenter);
ui->lib2083->setMaximumWidth( m12trail);
ui->lib2083->setMinimumWidth( m6trail);
ui->lib2083->setMaximumHeight( m7traild3 );
ui->lib2083->setMaxLength(11);
ui->lib2083->setFrame(globalFrame);

ui->lib2084->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "208   ") );
connect( ui->lib2084, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2084, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2084->installEventFilter(this);
ui->lib2084->setAlignment(Qt::AlignCenter);
ui->lib2084->setMaximumWidth( m12trail);
ui->lib2084->setMinimumWidth( m6trail);
ui->lib2084->setMaximumHeight( m7traild3 );
ui->lib2084->setMaxLength(11);
ui->lib2084->setFrame(globalFrame);

ui->pushButtonEst208->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "208   ") );
ui->pushButtonEst208->setMaximumWidth( m7traild3 );
ui->pushButtonEst208->setMaximumHeight( m7traild3 );
ui->pushButtonLib208->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "208   ") );
ui->pushButtonLib208->setMaximumWidth( m7traild3 );
ui->pushButtonLib208->setMaximumHeight( m7traild3 );

ui->est2081->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "208   ") );
connect( ui->est2081, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2081, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2081->installEventFilter(this);
ui->est2081->setMaximumWidth( m6trail);
ui->est2081->setMinimumWidth( m6trail);
ui->est2081->setMaximumHeight( m7traild3 );
ui->est2081->setMaxLength(3);
ui->est2081->setFrame(globalFrame);

ui->est2082->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "208   ") );
connect( ui->est2082, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2082, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2082->installEventFilter(this);
ui->est2082->setMaximumWidth( m26trail);
ui->est2082->setMinimumWidth( m25trail);
ui->est2082->setMaximumHeight( m7traild3 );
ui->est2082->setMaxLength(24);
ui->est2082->setFrame(globalFrame);

ui->est2083->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "208   ") );
connect( ui->est2083, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2083, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2083->installEventFilter(this);
ui->est2083->setAlignment(Qt::AlignCenter);
ui->est2083->setMaximumWidth( m11trail);
ui->est2083->setMinimumWidth( m6trail);
ui->est2083->setMaximumHeight( m7traild3 );
ui->est2083->setMaxLength(8);
ui->est2083->setFrame(globalFrame);

ui->est2084->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "208   ") );
connect( ui->est2084, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2084, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2084->installEventFilter(this);
ui->est2084->setAlignment(Qt::AlignCenter);
ui->est2084->setMaximumWidth( m12trail);
ui->est2084->setMinimumWidth( m6trail);
ui->est2084->setMaximumHeight( m7traild3 );
ui->est2084->setMaxLength(11);
ui->est2084->setFrame(globalFrame);

ui->est2085->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "208   ") );
connect( ui->est2085, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2085, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2085->installEventFilter(this);
ui->est2085->setAlignment(Qt::AlignCenter);
ui->est2085->setMaximumWidth( m12trail);
ui->est2085->setMinimumWidth( m6trail);
ui->est2085->setMaximumHeight( m7traild3 );
ui->est2085->setMaxLength(11);
ui->est2085->setFrame(globalFrame);

ui->est2086->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "208   ") );
ui->est2086->setReadOnly(true);
ui->est2086->setAlignment(Qt::AlignRight);
ui->est2086->setMaximumWidth( m14trail);
ui->est2086->setMinimumWidth( m9trail);
ui->est2086->setMaximumHeight( m7traild3 );
ui->est2086->setMaxLength(15);
ui->est2086->setFrame(globalFrame);

ui->est2087->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "208   ") );
ui->est2087->setReadOnly(true);
ui->est2087->setAlignment(Qt::AlignRight);
ui->est2087->setMaximumWidth( m14trail);
ui->est2087->setMinimumWidth( m9trail);
ui->est2087->setMaximumHeight( m7traild3 );
ui->est2087->setMaxLength(15);
ui->est2087->setFrame(globalFrame);

ui->lib2091->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "209   ") );
connect( ui->lib2091, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2091, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib209, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst209, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib2091->installEventFilter(this);
ui->lib2091->setMaximumWidth( m6trail);
ui->lib2091->setMinimumWidth( m6trail);
ui->lib2091->setMaximumHeight( m7traild3 );
ui->lib2091->setMaxLength(3);
ui->lib2091->setFrame(globalFrame);

ui->lib2092->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "209   ") );
connect( ui->lib2092, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2092, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2092->installEventFilter(this);
ui->lib2092->setMaximumWidth( m26trail);
ui->lib2092->setMinimumWidth( m25trail);
ui->lib2092->setMaximumHeight( m7traild3 );
ui->lib2092->setMaxLength(24);
ui->lib2092->setFrame(globalFrame);

ui->lib2093->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "209   ") );
connect( ui->lib2093, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2093, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2093->installEventFilter(this);
ui->lib2093->setAlignment(Qt::AlignCenter);
ui->lib2093->setMaximumWidth( m12trail);
ui->lib2093->setMinimumWidth( m6trail);
ui->lib2093->setMaximumHeight( m7traild3 );
ui->lib2093->setMaxLength(11);
ui->lib2093->setFrame(globalFrame);

ui->lib2094->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "209   ") );
connect( ui->lib2094, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2094, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2094->installEventFilter(this);
ui->lib2094->setAlignment(Qt::AlignCenter);
ui->lib2094->setMaximumWidth( m12trail);
ui->lib2094->setMinimumWidth( m6trail);
ui->lib2094->setMaximumHeight( m7traild3 );
ui->lib2094->setMaxLength(11);
ui->lib2094->setFrame(globalFrame);

ui->pushButtonEst209->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "209   ") );
ui->pushButtonEst209->setMaximumWidth( m7traild3 );
ui->pushButtonEst209->setMaximumHeight( m7traild3 );
ui->pushButtonLib209->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "209   ") );
ui->pushButtonLib209->setMaximumWidth( m7traild3 );
ui->pushButtonLib209->setMaximumHeight( m7traild3 );

ui->est2091->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "209   ") );
connect( ui->est2091, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2091, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2091->installEventFilter(this);
ui->est2091->setMaximumWidth( m6trail);
ui->est2091->setMinimumWidth( m6trail);
ui->est2091->setMaximumHeight( m7traild3 );
ui->est2091->setMaxLength(3);
ui->est2091->setFrame(globalFrame);

ui->est2092->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "209   ") );
connect( ui->est2092, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2092, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2092->installEventFilter(this);
ui->est2092->setMaximumWidth( m26trail);
ui->est2092->setMinimumWidth( m25trail);
ui->est2092->setMaximumHeight( m7traild3 );
ui->est2092->setMaxLength(24);
ui->est2092->setFrame(globalFrame);

ui->est2093->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "209   ") );
connect( ui->est2093, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2093, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2093->installEventFilter(this);
ui->est2093->setAlignment(Qt::AlignCenter);
ui->est2093->setMaximumWidth( m11trail);
ui->est2093->setMinimumWidth( m6trail);
ui->est2093->setMaximumHeight( m7traild3 );
ui->est2093->setMaxLength(8);
ui->est2093->setFrame(globalFrame);

ui->est2094->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "209   ") );
connect( ui->est2094, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2094, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2094->installEventFilter(this);
ui->est2094->setAlignment(Qt::AlignCenter);
ui->est2094->setMaximumWidth( m12trail);
ui->est2094->setMinimumWidth( m6trail);
ui->est2094->setMaximumHeight( m7traild3 );
ui->est2094->setMaxLength(11);
ui->est2094->setFrame(globalFrame);

ui->est2095->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "209   ") );
connect( ui->est2095, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2095, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2095->installEventFilter(this);
ui->est2095->setAlignment(Qt::AlignCenter);
ui->est2095->setMaximumWidth( m12trail);
ui->est2095->setMinimumWidth( m6trail);
ui->est2095->setMaximumHeight( m7traild3 );
ui->est2095->setMaxLength(11);
ui->est2095->setFrame(globalFrame);

ui->est2096->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "209   ") );
ui->est2096->setReadOnly(true);
ui->est2096->setAlignment(Qt::AlignRight);
ui->est2096->setMaximumWidth( m14trail);
ui->est2096->setMinimumWidth( m9trail);
ui->est2096->setMaximumHeight( m7traild3 );
ui->est2096->setMaxLength(15);
ui->est2096->setFrame(globalFrame);

ui->est2097->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "209   ") );
ui->est2097->setReadOnly(true);
ui->est2097->setAlignment(Qt::AlignRight);
ui->est2097->setMaximumWidth( m14trail);
ui->est2097->setMinimumWidth( m9trail);
ui->est2097->setMaximumHeight( m7traild3 );
ui->est2097->setMaxLength(15);
ui->est2097->setFrame(globalFrame);

ui->lib2101->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "210   ") );
connect( ui->lib2101, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2101, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib210, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst210, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib2101->installEventFilter(this);
ui->lib2101->setMaximumWidth( m6trail);
ui->lib2101->setMinimumWidth( m6trail);
ui->lib2101->setMaximumHeight( m7traild3 );
ui->lib2101->setMaxLength(3);
ui->lib2101->setFrame(globalFrame);

ui->lib2102->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "210   ") );
connect( ui->lib2102, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2102, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2102->installEventFilter(this);
ui->lib2102->setMaximumWidth( m26trail);
ui->lib2102->setMinimumWidth( m25trail);
ui->lib2102->setMaximumHeight( m7traild3 );
ui->lib2102->setMaxLength(24);
ui->lib2102->setFrame(globalFrame);

ui->lib2103->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "210   ") );
connect( ui->lib2103, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2103, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2103->installEventFilter(this);
ui->lib2103->setAlignment(Qt::AlignCenter);
ui->lib2103->setMaximumWidth( m12trail);
ui->lib2103->setMinimumWidth( m6trail);
ui->lib2103->setMaximumHeight( m7traild3 );
ui->lib2103->setMaxLength(11);
ui->lib2103->setFrame(globalFrame);

ui->lib2104->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "210   ") );
connect( ui->lib2104, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2104, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2104->installEventFilter(this);
ui->lib2104->setAlignment(Qt::AlignCenter);
ui->lib2104->setMaximumWidth( m12trail);
ui->lib2104->setMinimumWidth( m6trail);
ui->lib2104->setMaximumHeight( m7traild3 );
ui->lib2104->setMaxLength(11);
ui->lib2104->setFrame(globalFrame);

ui->pushButtonEst210->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "210   ") );
ui->pushButtonEst210->setMaximumWidth( m7traild3 );
ui->pushButtonEst210->setMaximumHeight( m7traild3 );
ui->pushButtonLib210->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "210   ") );
ui->pushButtonLib210->setMaximumWidth( m7traild3 );
ui->pushButtonLib210->setMaximumHeight( m7traild3 );

ui->est2101->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "210   ") );
connect( ui->est2101, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2101, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2101->installEventFilter(this);
ui->est2101->setMaximumWidth( m6trail);
ui->est2101->setMinimumWidth( m6trail);
ui->est2101->setMaximumHeight( m7traild3 );
ui->est2101->setMaxLength(3);
ui->est2101->setFrame(globalFrame);

ui->est2102->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "210   ") );
connect( ui->est2102, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2102, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2102->installEventFilter(this);
ui->est2102->setMaximumWidth( m26trail);
ui->est2102->setMinimumWidth( m25trail);
ui->est2102->setMaximumHeight( m7traild3 );
ui->est2102->setMaxLength(24);
ui->est2102->setFrame(globalFrame);

ui->est2103->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "210   ") );
connect( ui->est2103, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2103, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2103->installEventFilter(this);
ui->est2103->setAlignment(Qt::AlignCenter);
ui->est2103->setMaximumWidth( m11trail);
ui->est2103->setMinimumWidth( m6trail);
ui->est2103->setMaximumHeight( m7traild3 );
ui->est2103->setMaxLength(8);
ui->est2103->setFrame(globalFrame);

ui->est2104->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "210   ") );
connect( ui->est2104, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2104, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2104->installEventFilter(this);
ui->est2104->setAlignment(Qt::AlignCenter);
ui->est2104->setMaximumWidth( m12trail);
ui->est2104->setMinimumWidth( m6trail);
ui->est2104->setMaximumHeight( m7traild3 );
ui->est2104->setMaxLength(11);
ui->est2104->setFrame(globalFrame);

ui->est2105->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "210   ") );
connect( ui->est2105, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2105, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2105->installEventFilter(this);
ui->est2105->setAlignment(Qt::AlignCenter);
ui->est2105->setMaximumWidth( m12trail);
ui->est2105->setMinimumWidth( m6trail);
ui->est2105->setMaximumHeight( m7traild3 );
ui->est2105->setMaxLength(11);
ui->est2105->setFrame(globalFrame);

ui->est2106->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "210   ") );
ui->est2106->setReadOnly(true);
ui->est2106->setAlignment(Qt::AlignRight);
ui->est2106->setMaximumWidth( m14trail);
ui->est2106->setMinimumWidth( m9trail);
ui->est2106->setMaximumHeight( m7traild3 );
ui->est2106->setMaxLength(15);
ui->est2106->setFrame(globalFrame);

ui->est2107->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "210   ") );
ui->est2107->setReadOnly(true);
ui->est2107->setAlignment(Qt::AlignRight);
ui->est2107->setMaximumWidth( m14trail);
ui->est2107->setMinimumWidth( m9trail);
ui->est2107->setMaximumHeight( m7traild3 );
ui->est2107->setMaxLength(15);
ui->est2107->setFrame(globalFrame);

ui->lib2111->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "211   ") );
connect( ui->lib2111, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2111, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib211, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst211, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib2111->installEventFilter(this);
ui->lib2111->setMaximumWidth( m6trail);
ui->lib2111->setMinimumWidth( m6trail);
ui->lib2111->setMaximumHeight( m7traild3 );
ui->lib2111->setMaxLength(3);
ui->lib2111->setFrame(globalFrame);

ui->lib2112->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "211   ") );
connect( ui->lib2112, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2112, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2112->installEventFilter(this);
ui->lib2112->setMaximumWidth( m26trail);
ui->lib2112->setMinimumWidth( m25trail);
ui->lib2112->setMaximumHeight( m7traild3 );
ui->lib2112->setMaxLength(24);
ui->lib2112->setFrame(globalFrame);

ui->lib2113->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "211   ") );
connect( ui->lib2113, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2113, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2113->installEventFilter(this);
ui->lib2113->setAlignment(Qt::AlignCenter);
ui->lib2113->setMaximumWidth( m12trail);
ui->lib2113->setMinimumWidth( m6trail);
ui->lib2113->setMaximumHeight( m7traild3 );
ui->lib2113->setMaxLength(11);
ui->lib2113->setFrame(globalFrame);

ui->lib2114->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "211   ") );
connect( ui->lib2114, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2114, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2114->installEventFilter(this);
ui->lib2114->setAlignment(Qt::AlignCenter);
ui->lib2114->setMaximumWidth( m12trail);
ui->lib2114->setMinimumWidth( m6trail);
ui->lib2114->setMaximumHeight( m7traild3 );
ui->lib2114->setMaxLength(11);
ui->lib2114->setFrame(globalFrame);

ui->pushButtonEst211->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "211   ") );
ui->pushButtonEst211->setMaximumWidth( m7traild3 );
ui->pushButtonEst211->setMaximumHeight( m7traild3 );
ui->pushButtonLib211->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "211   ") );
ui->pushButtonLib211->setMaximumWidth( m7traild3 );
ui->pushButtonLib211->setMaximumHeight( m7traild3 );

ui->est2111->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "211   ") );
connect( ui->est2111, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2111, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2111->installEventFilter(this);
ui->est2111->setMaximumWidth( m6trail);
ui->est2111->setMinimumWidth( m6trail);
ui->est2111->setMaximumHeight( m7traild3 );
ui->est2111->setMaxLength(3);
ui->est2111->setFrame(globalFrame);

ui->est2112->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "211   ") );
connect( ui->est2112, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2112, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2112->installEventFilter(this);
ui->est2112->setMaximumWidth( m26trail);
ui->est2112->setMinimumWidth( m25trail);
ui->est2112->setMaximumHeight( m7traild3 );
ui->est2112->setMaxLength(24);
ui->est2112->setFrame(globalFrame);

ui->est2113->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "211   ") );
connect( ui->est2113, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2113, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2113->installEventFilter(this);
ui->est2113->setAlignment(Qt::AlignCenter);
ui->est2113->setMaximumWidth( m11trail);
ui->est2113->setMinimumWidth( m6trail);
ui->est2113->setMaximumHeight( m7traild3 );
ui->est2113->setMaxLength(8);
ui->est2113->setFrame(globalFrame);

ui->est2114->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "211   ") );
connect( ui->est2114, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2114, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2114->installEventFilter(this);
ui->est2114->setAlignment(Qt::AlignCenter);
ui->est2114->setMaximumWidth( m12trail);
ui->est2114->setMinimumWidth( m6trail);
ui->est2114->setMaximumHeight( m7traild3 );
ui->est2114->setMaxLength(11);
ui->est2114->setFrame(globalFrame);

ui->est2115->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "211   ") );
connect( ui->est2115, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2115, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2115->installEventFilter(this);
ui->est2115->setAlignment(Qt::AlignCenter);
ui->est2115->setMaximumWidth( m12trail);
ui->est2115->setMinimumWidth( m6trail);
ui->est2115->setMaximumHeight( m7traild3 );
ui->est2115->setMaxLength(11);
ui->est2115->setFrame(globalFrame);

ui->est2116->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "211   ") );
ui->est2116->setReadOnly(true);
ui->est2116->setAlignment(Qt::AlignRight);
ui->est2116->setMaximumWidth( m14trail);
ui->est2116->setMinimumWidth( m9trail);
ui->est2116->setMaximumHeight( m7traild3 );
ui->est2116->setMaxLength(15);
ui->est2116->setFrame(globalFrame);

ui->est2117->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "211   ") );
ui->est2117->setReadOnly(true);
ui->est2117->setAlignment(Qt::AlignRight);
ui->est2117->setMaximumWidth( m14trail);
ui->est2117->setMinimumWidth( m9trail);
ui->est2117->setMaximumHeight( m7traild3 );
ui->est2117->setMaxLength(15);
ui->est2117->setFrame(globalFrame);

ui->lib2121->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "212   ") );
connect( ui->lib2121, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2121, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib212, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst212, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib2121->installEventFilter(this);
ui->lib2121->setMaximumWidth( m6trail);
ui->lib2121->setMinimumWidth( m6trail);
ui->lib2121->setMaximumHeight( m7traild3 );
ui->lib2121->setMaxLength(3);
ui->lib2121->setFrame(globalFrame);

ui->lib2122->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "212   ") );
connect( ui->lib2122, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2122, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2122->installEventFilter(this);
ui->lib2122->setMaximumWidth( m26trail);
ui->lib2122->setMinimumWidth( m25trail);
ui->lib2122->setMaximumHeight( m7traild3 );
ui->lib2122->setMaxLength(24);
ui->lib2122->setFrame(globalFrame);

ui->lib2123->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "212   ") );
connect( ui->lib2123, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2123, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2123->installEventFilter(this);
ui->lib2123->setAlignment(Qt::AlignCenter);
ui->lib2123->setMaximumWidth( m12trail);
ui->lib2123->setMinimumWidth( m6trail);
ui->lib2123->setMaximumHeight( m7traild3 );
ui->lib2123->setMaxLength(11);
ui->lib2123->setFrame(globalFrame);

ui->lib2124->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "212   ") );
connect( ui->lib2124, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2124, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2124->installEventFilter(this);
ui->lib2124->setAlignment(Qt::AlignCenter);
ui->lib2124->setMaximumWidth( m12trail);
ui->lib2124->setMinimumWidth( m6trail);
ui->lib2124->setMaximumHeight( m7traild3 );
ui->lib2124->setMaxLength(11);
ui->lib2124->setFrame(globalFrame);

ui->pushButtonEst212->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "212   ") );
ui->pushButtonEst212->setMaximumWidth( m7traild3 );
ui->pushButtonEst212->setMaximumHeight( m7traild3 );
ui->pushButtonLib212->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "212   ") );
ui->pushButtonLib212->setMaximumWidth( m7traild3 );
ui->pushButtonLib212->setMaximumHeight( m7traild3 );

ui->est2121->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "212   ") );
connect( ui->est2121, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2121, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2121->installEventFilter(this);
ui->est2121->setMaximumWidth( m6trail);
ui->est2121->setMinimumWidth( m6trail);
ui->est2121->setMaximumHeight( m7traild3 );
ui->est2121->setMaxLength(3);
ui->est2121->setFrame(globalFrame);

ui->est2122->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "212   ") );
connect( ui->est2122, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2122, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2122->installEventFilter(this);
ui->est2122->setMaximumWidth( m26trail);
ui->est2122->setMinimumWidth( m25trail);
ui->est2122->setMaximumHeight( m7traild3 );
ui->est2122->setMaxLength(24);
ui->est2122->setFrame(globalFrame);

ui->est2123->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "212   ") );
connect( ui->est2123, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2123, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2123->installEventFilter(this);
ui->est2123->setAlignment(Qt::AlignCenter);
ui->est2123->setMaximumWidth( m11trail);
ui->est2123->setMinimumWidth( m6trail);
ui->est2123->setMaximumHeight( m7traild3 );
ui->est2123->setMaxLength(8);
ui->est2123->setFrame(globalFrame);

ui->est2124->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "212   ") );
connect( ui->est2124, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2124, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2124->installEventFilter(this);
ui->est2124->setAlignment(Qt::AlignCenter);
ui->est2124->setMaximumWidth( m12trail);
ui->est2124->setMinimumWidth( m6trail);
ui->est2124->setMaximumHeight( m7traild3 );
ui->est2124->setMaxLength(11);
ui->est2124->setFrame(globalFrame);

ui->est2125->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "212   ") );
connect( ui->est2125, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2125, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2125->installEventFilter(this);
ui->est2125->setAlignment(Qt::AlignCenter);
ui->est2125->setMaximumWidth( m12trail);
ui->est2125->setMinimumWidth( m6trail);
ui->est2125->setMaximumHeight( m7traild3 );
ui->est2125->setMaxLength(11);
ui->est2125->setFrame(globalFrame);

ui->est2126->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "212   ") );
ui->est2126->setReadOnly(true);
ui->est2126->setAlignment(Qt::AlignRight);
ui->est2126->setMaximumWidth( m14trail);
ui->est2126->setMinimumWidth( m9trail);
ui->est2126->setMaximumHeight( m7traild3 );
ui->est2126->setMaxLength(15);
ui->est2126->setFrame(globalFrame);

ui->est2127->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "212   ") );
ui->est2127->setReadOnly(true);
ui->est2127->setAlignment(Qt::AlignRight);
ui->est2127->setMaximumWidth( m14trail);
ui->est2127->setMinimumWidth( m9trail);
ui->est2127->setMaximumHeight( m7traild3 );
ui->est2127->setMaxLength(15);
ui->est2127->setFrame(globalFrame);

ui->lib2131->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "213   ") );
connect( ui->lib2131, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2131, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib213, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst213, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib2131->installEventFilter(this);
ui->lib2131->setMaximumWidth( m6trail);
ui->lib2131->setMinimumWidth( m6trail);
ui->lib2131->setMaximumHeight( m7traild3 );
ui->lib2131->setMaxLength(3);
ui->lib2131->setFrame(globalFrame);

ui->lib2132->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "213   ") );
connect( ui->lib2132, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2132, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2132->installEventFilter(this);
ui->lib2132->setMaximumWidth( m26trail);
ui->lib2132->setMinimumWidth( m25trail);
ui->lib2132->setMaximumHeight( m7traild3 );
ui->lib2132->setMaxLength(24);
ui->lib2132->setFrame(globalFrame);

ui->lib2133->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "213   ") );
connect( ui->lib2133, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2133, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2133->installEventFilter(this);
ui->lib2133->setAlignment(Qt::AlignCenter);
ui->lib2133->setMaximumWidth( m12trail);
ui->lib2133->setMinimumWidth( m6trail);
ui->lib2133->setMaximumHeight( m7traild3 );
ui->lib2133->setMaxLength(11);
ui->lib2133->setFrame(globalFrame);

ui->lib2134->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "213   ") );
connect( ui->lib2134, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2134, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2134->installEventFilter(this);
ui->lib2134->setAlignment(Qt::AlignCenter);
ui->lib2134->setMaximumWidth( m12trail);
ui->lib2134->setMinimumWidth( m6trail);
ui->lib2134->setMaximumHeight( m7traild3 );
ui->lib2134->setMaxLength(11);
ui->lib2134->setFrame(globalFrame);

ui->pushButtonEst213->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "213   ") );
ui->pushButtonEst213->setMaximumWidth( m7traild3 );
ui->pushButtonEst213->setMaximumHeight( m7traild3 );
ui->pushButtonLib213->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "213   ") );
ui->pushButtonLib213->setMaximumWidth( m7traild3 );
ui->pushButtonLib213->setMaximumHeight( m7traild3 );

ui->est2131->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "213   ") );
connect( ui->est2131, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2131, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2131->installEventFilter(this);
ui->est2131->setMaximumWidth( m6trail);
ui->est2131->setMinimumWidth( m6trail);
ui->est2131->setMaximumHeight( m7traild3 );
ui->est2131->setMaxLength(3);
ui->est2131->setFrame(globalFrame);

ui->est2132->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "213   ") );
connect( ui->est2132, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2132, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2132->installEventFilter(this);
ui->est2132->setMaximumWidth( m26trail);
ui->est2132->setMinimumWidth( m25trail);
ui->est2132->setMaximumHeight( m7traild3 );
ui->est2132->setMaxLength(24);
ui->est2132->setFrame(globalFrame);

ui->est2133->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "213   ") );
connect( ui->est2133, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2133, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2133->installEventFilter(this);
ui->est2133->setAlignment(Qt::AlignCenter);
ui->est2133->setMaximumWidth( m11trail);
ui->est2133->setMinimumWidth( m6trail);
ui->est2133->setMaximumHeight( m7traild3 );
ui->est2133->setMaxLength(8);
ui->est2133->setFrame(globalFrame);

ui->est2134->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "213   ") );
connect( ui->est2134, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2134, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2134->installEventFilter(this);
ui->est2134->setAlignment(Qt::AlignCenter);
ui->est2134->setMaximumWidth( m12trail);
ui->est2134->setMinimumWidth( m6trail);
ui->est2134->setMaximumHeight( m7traild3 );
ui->est2134->setMaxLength(11);
ui->est2134->setFrame(globalFrame);

ui->est2135->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "213   ") );
connect( ui->est2135, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2135, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2135->installEventFilter(this);
ui->est2135->setAlignment(Qt::AlignCenter);
ui->est2135->setMaximumWidth( m12trail);
ui->est2135->setMinimumWidth( m6trail);
ui->est2135->setMaximumHeight( m7traild3 );
ui->est2135->setMaxLength(11);
ui->est2135->setFrame(globalFrame);

ui->est2136->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "213   ") );
ui->est2136->setReadOnly(true);
ui->est2136->setAlignment(Qt::AlignRight);
ui->est2136->setMaximumWidth( m14trail);
ui->est2136->setMinimumWidth( m9trail);
ui->est2136->setMaximumHeight( m7traild3 );
ui->est2136->setMaxLength(15);
ui->est2136->setFrame(globalFrame);

ui->est2137->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "213   ") );
ui->est2137->setReadOnly(true);
ui->est2137->setAlignment(Qt::AlignRight);
ui->est2137->setMaximumWidth( m14trail);
ui->est2137->setMinimumWidth( m9trail);
ui->est2137->setMaximumHeight( m7traild3 );
ui->est2137->setMaxLength(15);
ui->est2137->setFrame(globalFrame);

ui->lib2141->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "214   ") );
connect( ui->lib2141, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2141, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib214, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst214, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib2141->installEventFilter(this);
ui->lib2141->setMaximumWidth( m6trail);
ui->lib2141->setMinimumWidth( m6trail);
ui->lib2141->setMaximumHeight( m7traild3 );
ui->lib2141->setMaxLength(3);
ui->lib2141->setFrame(globalFrame);

ui->lib2142->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "214   ") );
connect( ui->lib2142, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2142, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2142->installEventFilter(this);
ui->lib2142->setMaximumWidth( m26trail);
ui->lib2142->setMinimumWidth( m25trail);
ui->lib2142->setMaximumHeight( m7traild3 );
ui->lib2142->setMaxLength(24);
ui->lib2142->setFrame(globalFrame);

ui->lib2143->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "214   ") );
connect( ui->lib2143, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2143, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2143->installEventFilter(this);
ui->lib2143->setAlignment(Qt::AlignCenter);
ui->lib2143->setMaximumWidth( m12trail);
ui->lib2143->setMinimumWidth( m6trail);
ui->lib2143->setMaximumHeight( m7traild3 );
ui->lib2143->setMaxLength(11);
ui->lib2143->setFrame(globalFrame);

ui->lib2144->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "214   ") );
connect( ui->lib2144, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2144, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2144->installEventFilter(this);
ui->lib2144->setAlignment(Qt::AlignCenter);
ui->lib2144->setMaximumWidth( m12trail);
ui->lib2144->setMinimumWidth( m6trail);
ui->lib2144->setMaximumHeight( m7traild3 );
ui->lib2144->setMaxLength(11);
ui->lib2144->setFrame(globalFrame);

ui->pushButtonEst214->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "214   ") );
ui->pushButtonEst214->setMaximumWidth( m7traild3 );
ui->pushButtonEst214->setMaximumHeight( m7traild3 );
ui->pushButtonLib214->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "214   ") );
ui->pushButtonLib214->setMaximumWidth( m7traild3 );
ui->pushButtonLib214->setMaximumHeight( m7traild3 );

ui->est2141->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "214   ") );
connect( ui->est2141, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2141, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2141->installEventFilter(this);
ui->est2141->setMaximumWidth( m6trail);
ui->est2141->setMinimumWidth( m6trail);
ui->est2141->setMaximumHeight( m7traild3 );
ui->est2141->setMaxLength(3);
ui->est2141->setFrame(globalFrame);

ui->est2142->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "214   ") );
connect( ui->est2142, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2142, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2142->installEventFilter(this);
ui->est2142->setMaximumWidth( m26trail);
ui->est2142->setMinimumWidth( m25trail);
ui->est2142->setMaximumHeight( m7traild3 );
ui->est2142->setMaxLength(24);
ui->est2142->setFrame(globalFrame);

ui->est2143->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "214   ") );
connect( ui->est2143, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2143, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2143->installEventFilter(this);
ui->est2143->setAlignment(Qt::AlignCenter);
ui->est2143->setMaximumWidth( m11trail);
ui->est2143->setMinimumWidth( m6trail);
ui->est2143->setMaximumHeight( m7traild3 );
ui->est2143->setMaxLength(8);
ui->est2143->setFrame(globalFrame);

ui->est2144->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "214   ") );
connect( ui->est2144, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2144, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2144->installEventFilter(this);
ui->est2144->setAlignment(Qt::AlignCenter);
ui->est2144->setMaximumWidth( m12trail);
ui->est2144->setMinimumWidth( m6trail);
ui->est2144->setMaximumHeight( m7traild3 );
ui->est2144->setMaxLength(11);
ui->est2144->setFrame(globalFrame);

ui->est2145->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "214   ") );
connect( ui->est2145, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2145, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2145->installEventFilter(this);
ui->est2145->setAlignment(Qt::AlignCenter);
ui->est2145->setMaximumWidth( m12trail);
ui->est2145->setMinimumWidth( m6trail);
ui->est2145->setMaximumHeight( m7traild3 );
ui->est2145->setMaxLength(11);
ui->est2145->setFrame(globalFrame);

ui->est2146->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "214   ") );
ui->est2146->setReadOnly(true);
ui->est2146->setAlignment(Qt::AlignRight);
ui->est2146->setMaximumWidth( m14trail);
ui->est2146->setMinimumWidth( m9trail);
ui->est2146->setMaximumHeight( m7traild3 );
ui->est2146->setMaxLength(15);
ui->est2146->setFrame(globalFrame);

ui->est2147->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "214   ") );
ui->est2147->setReadOnly(true);
ui->est2147->setAlignment(Qt::AlignRight);
ui->est2147->setMaximumWidth( m14trail);
ui->est2147->setMinimumWidth( m9trail);
ui->est2147->setMaximumHeight( m7traild3 );
ui->est2147->setMaxLength(15);
ui->est2147->setFrame(globalFrame);

ui->lib2151->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "215   ") );
connect( ui->lib2151, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2151, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib215, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst215, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib2151->installEventFilter(this);
ui->lib2151->setMaximumWidth( m6trail);
ui->lib2151->setMinimumWidth( m6trail);
ui->lib2151->setMaximumHeight( m7traild3 );
ui->lib2151->setMaxLength(3);
ui->lib2151->setFrame(globalFrame);

ui->lib2152->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "215   ") );
connect( ui->lib2152, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2152, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2152->installEventFilter(this);
ui->lib2152->setMaximumWidth( m26trail);
ui->lib2152->setMinimumWidth( m25trail);
ui->lib2152->setMaximumHeight( m7traild3 );
ui->lib2152->setMaxLength(24);
ui->lib2152->setFrame(globalFrame);

ui->lib2153->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "215   ") );
connect( ui->lib2153, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2153, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2153->installEventFilter(this);
ui->lib2153->setAlignment(Qt::AlignCenter);
ui->lib2153->setMaximumWidth( m12trail);
ui->lib2153->setMinimumWidth( m6trail);
ui->lib2153->setMaximumHeight( m7traild3 );
ui->lib2153->setMaxLength(11);
ui->lib2153->setFrame(globalFrame);

ui->lib2154->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "215   ") );
connect( ui->lib2154, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2154, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2154->installEventFilter(this);
ui->lib2154->setAlignment(Qt::AlignCenter);
ui->lib2154->setMaximumWidth( m12trail);
ui->lib2154->setMinimumWidth( m6trail);
ui->lib2154->setMaximumHeight( m7traild3 );
ui->lib2154->setMaxLength(11);
ui->lib2154->setFrame(globalFrame);

ui->pushButtonEst215->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "215   ") );
ui->pushButtonEst215->setMaximumWidth( m7traild3 );
ui->pushButtonEst215->setMaximumHeight( m7traild3 );
ui->pushButtonLib215->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "215   ") );
ui->pushButtonLib215->setMaximumWidth( m7traild3 );
ui->pushButtonLib215->setMaximumHeight( m7traild3 );

ui->est2151->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "215   ") );
connect( ui->est2151, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2151, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2151->installEventFilter(this);
ui->est2151->setMaximumWidth( m6trail);
ui->est2151->setMinimumWidth( m6trail);
ui->est2151->setMaximumHeight( m7traild3 );
ui->est2151->setMaxLength(3);
ui->est2151->setFrame(globalFrame);

ui->est2152->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "215   ") );
connect( ui->est2152, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2152, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2152->installEventFilter(this);
ui->est2152->setMaximumWidth( m26trail);
ui->est2152->setMinimumWidth( m25trail);
ui->est2152->setMaximumHeight( m7traild3 );
ui->est2152->setMaxLength(24);
ui->est2152->setFrame(globalFrame);

ui->est2153->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "215   ") );
connect( ui->est2153, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2153, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2153->installEventFilter(this);
ui->est2153->setAlignment(Qt::AlignCenter);
ui->est2153->setMaximumWidth( m11trail);
ui->est2153->setMinimumWidth( m6trail);
ui->est2153->setMaximumHeight( m7traild3 );
ui->est2153->setMaxLength(8);
ui->est2153->setFrame(globalFrame);

ui->est2154->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "215   ") );
connect( ui->est2154, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2154, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2154->installEventFilter(this);
ui->est2154->setAlignment(Qt::AlignCenter);
ui->est2154->setMaximumWidth( m12trail);
ui->est2154->setMinimumWidth( m6trail);
ui->est2154->setMaximumHeight( m7traild3 );
ui->est2154->setMaxLength(11);
ui->est2154->setFrame(globalFrame);

ui->est2155->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "215   ") );
connect( ui->est2155, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2155, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2155->installEventFilter(this);
ui->est2155->setAlignment(Qt::AlignCenter);
ui->est2155->setMaximumWidth( m12trail);
ui->est2155->setMinimumWidth( m6trail);
ui->est2155->setMaximumHeight( m7traild3 );
ui->est2155->setMaxLength(11);
ui->est2155->setFrame(globalFrame);

ui->est2156->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "215   ") );
ui->est2156->setReadOnly(true);
ui->est2156->setAlignment(Qt::AlignRight);
ui->est2156->setMaximumWidth( m14trail);
ui->est2156->setMinimumWidth( m9trail);
ui->est2156->setMaximumHeight( m7traild3 );
ui->est2156->setMaxLength(15);
ui->est2156->setFrame(globalFrame);

ui->est2157->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "215   ") );
ui->est2157->setReadOnly(true);
ui->est2157->setAlignment(Qt::AlignRight);
ui->est2157->setMaximumWidth( m14trail);
ui->est2157->setMinimumWidth( m9trail);
ui->est2157->setMaximumHeight( m7traild3 );
ui->est2157->setMaxLength(15);
ui->est2157->setFrame(globalFrame);

ui->lib2161->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "216   ") );
connect( ui->lib2161, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2161, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib216, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst216, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib2161->installEventFilter(this);
ui->lib2161->setMaximumWidth( m6trail);
ui->lib2161->setMinimumWidth( m6trail);
ui->lib2161->setMaximumHeight( m7traild3 );
ui->lib2161->setMaxLength(3);
ui->lib2161->setFrame(globalFrame);

ui->lib2162->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "216   ") );
connect( ui->lib2162, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2162, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2162->installEventFilter(this);
ui->lib2162->setMaximumWidth( m26trail);
ui->lib2162->setMinimumWidth( m25trail);
ui->lib2162->setMaximumHeight( m7traild3 );
ui->lib2162->setMaxLength(24);
ui->lib2162->setFrame(globalFrame);

ui->lib2163->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "216   ") );
connect( ui->lib2163, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2163, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2163->installEventFilter(this);
ui->lib2163->setAlignment(Qt::AlignCenter);
ui->lib2163->setMaximumWidth( m12trail);
ui->lib2163->setMinimumWidth( m6trail);
ui->lib2163->setMaximumHeight( m7traild3 );
ui->lib2163->setMaxLength(11);
ui->lib2163->setFrame(globalFrame);

ui->lib2164->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "216   ") );
connect( ui->lib2164, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2164, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2164->installEventFilter(this);
ui->lib2164->setAlignment(Qt::AlignCenter);
ui->lib2164->setMaximumWidth( m12trail);
ui->lib2164->setMinimumWidth( m6trail);
ui->lib2164->setMaximumHeight( m7traild3 );
ui->lib2164->setMaxLength(11);
ui->lib2164->setFrame(globalFrame);

ui->pushButtonEst216->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "216   ") );
ui->pushButtonEst216->setMaximumWidth( m7traild3 );
ui->pushButtonEst216->setMaximumHeight( m7traild3 );
ui->pushButtonLib216->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "216   ") );
ui->pushButtonLib216->setMaximumWidth( m7traild3 );
ui->pushButtonLib216->setMaximumHeight( m7traild3 );

ui->est2161->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "216   ") );
connect( ui->est2161, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2161, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2161->installEventFilter(this);
ui->est2161->setMaximumWidth( m6trail);
ui->est2161->setMinimumWidth( m6trail);
ui->est2161->setMaximumHeight( m7traild3 );
ui->est2161->setMaxLength(3);
ui->est2161->setFrame(globalFrame);

ui->est2162->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "216   ") );
connect( ui->est2162, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2162, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2162->installEventFilter(this);
ui->est2162->setMaximumWidth( m26trail);
ui->est2162->setMinimumWidth( m25trail);
ui->est2162->setMaximumHeight( m7traild3 );
ui->est2162->setMaxLength(24);
ui->est2162->setFrame(globalFrame);

ui->est2163->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "216   ") );
connect( ui->est2163, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2163, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2163->installEventFilter(this);
ui->est2163->setAlignment(Qt::AlignCenter);
ui->est2163->setMaximumWidth( m11trail);
ui->est2163->setMinimumWidth( m6trail);
ui->est2163->setMaximumHeight( m7traild3 );
ui->est2163->setMaxLength(8);
ui->est2163->setFrame(globalFrame);

ui->est2164->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "216   ") );
connect( ui->est2164, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2164, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2164->installEventFilter(this);
ui->est2164->setAlignment(Qt::AlignCenter);
ui->est2164->setMaximumWidth( m12trail);
ui->est2164->setMinimumWidth( m6trail);
ui->est2164->setMaximumHeight( m7traild3 );
ui->est2164->setMaxLength(11);
ui->est2164->setFrame(globalFrame);

ui->est2165->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "216   ") );
connect( ui->est2165, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2165, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2165->installEventFilter(this);
ui->est2165->setAlignment(Qt::AlignCenter);
ui->est2165->setMaximumWidth( m12trail);
ui->est2165->setMinimumWidth( m6trail);
ui->est2165->setMaximumHeight( m7traild3 );
ui->est2165->setMaxLength(11);
ui->est2165->setFrame(globalFrame);

ui->est2166->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "216   ") );
ui->est2166->setReadOnly(true);
ui->est2166->setAlignment(Qt::AlignRight);
ui->est2166->setMaximumWidth( m14trail);
ui->est2166->setMinimumWidth( m9trail);
ui->est2166->setMaximumHeight( m7traild3 );
ui->est2166->setMaxLength(15);
ui->est2166->setFrame(globalFrame);

ui->est2167->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "216   ") );
ui->est2167->setReadOnly(true);
ui->est2167->setAlignment(Qt::AlignRight);
ui->est2167->setMaximumWidth( m14trail);
ui->est2167->setMinimumWidth( m9trail);
ui->est2167->setMaximumHeight( m7traild3 );
ui->est2167->setMaxLength(15);
ui->est2167->setFrame(globalFrame);

ui->lib2171->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "217   ") );
connect( ui->lib2171, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2171, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib217, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst217, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib2171->installEventFilter(this);
ui->lib2171->setMaximumWidth( m6trail);
ui->lib2171->setMinimumWidth( m6trail);
ui->lib2171->setMaximumHeight( m7traild3 );
ui->lib2171->setMaxLength(3);
ui->lib2171->setFrame(globalFrame);

ui->lib2172->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "217   ") );
connect( ui->lib2172, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2172, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2172->installEventFilter(this);
ui->lib2172->setMaximumWidth( m26trail);
ui->lib2172->setMinimumWidth( m25trail);
ui->lib2172->setMaximumHeight( m7traild3 );
ui->lib2172->setMaxLength(24);
ui->lib2172->setFrame(globalFrame);

ui->lib2173->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "217   ") );
connect( ui->lib2173, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2173, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2173->installEventFilter(this);
ui->lib2173->setAlignment(Qt::AlignCenter);
ui->lib2173->setMaximumWidth( m12trail);
ui->lib2173->setMinimumWidth( m6trail);
ui->lib2173->setMaximumHeight( m7traild3 );
ui->lib2173->setMaxLength(11);
ui->lib2173->setFrame(globalFrame);

ui->lib2174->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "217   ") );
connect( ui->lib2174, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2174, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2174->installEventFilter(this);
ui->lib2174->setAlignment(Qt::AlignCenter);
ui->lib2174->setMaximumWidth( m12trail);
ui->lib2174->setMinimumWidth( m6trail);
ui->lib2174->setMaximumHeight( m7traild3 );
ui->lib2174->setMaxLength(11);
ui->lib2174->setFrame(globalFrame);

ui->pushButtonEst217->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "217   ") );
ui->pushButtonEst217->setMaximumWidth( m7traild3 );
ui->pushButtonEst217->setMaximumHeight( m7traild3 );
ui->pushButtonLib217->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "217   ") );
ui->pushButtonLib217->setMaximumWidth( m7traild3 );
ui->pushButtonLib217->setMaximumHeight( m7traild3 );

ui->est2171->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "217   ") );
connect( ui->est2171, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2171, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2171->installEventFilter(this);
ui->est2171->setMaximumWidth( m6trail);
ui->est2171->setMinimumWidth( m6trail);
ui->est2171->setMaximumHeight( m7traild3 );
ui->est2171->setMaxLength(3);
ui->est2171->setFrame(globalFrame);

ui->est2172->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "217   ") );
connect( ui->est2172, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2172, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2172->installEventFilter(this);
ui->est2172->setMaximumWidth( m26trail);
ui->est2172->setMinimumWidth( m25trail);
ui->est2172->setMaximumHeight( m7traild3 );
ui->est2172->setMaxLength(24);
ui->est2172->setFrame(globalFrame);

ui->est2173->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "217   ") );
connect( ui->est2173, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2173, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2173->installEventFilter(this);
ui->est2173->setAlignment(Qt::AlignCenter);
ui->est2173->setMaximumWidth( m11trail);
ui->est2173->setMinimumWidth( m6trail);
ui->est2173->setMaximumHeight( m7traild3 );
ui->est2173->setMaxLength(8);
ui->est2173->setFrame(globalFrame);

ui->est2174->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "217   ") );
connect( ui->est2174, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2174, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2174->installEventFilter(this);
ui->est2174->setAlignment(Qt::AlignCenter);
ui->est2174->setMaximumWidth( m12trail);
ui->est2174->setMinimumWidth( m6trail);
ui->est2174->setMaximumHeight( m7traild3 );
ui->est2174->setMaxLength(11);
ui->est2174->setFrame(globalFrame);

ui->est2175->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "217   ") );
connect( ui->est2175, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2175, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2175->installEventFilter(this);
ui->est2175->setAlignment(Qt::AlignCenter);
ui->est2175->setMaximumWidth( m12trail);
ui->est2175->setMinimumWidth( m6trail);
ui->est2175->setMaximumHeight( m7traild3 );
ui->est2175->setMaxLength(11);
ui->est2175->setFrame(globalFrame);

ui->est2176->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "217   ") );
ui->est2176->setReadOnly(true);
ui->est2176->setAlignment(Qt::AlignRight);
ui->est2176->setMaximumWidth( m14trail);
ui->est2176->setMinimumWidth( m9trail);
ui->est2176->setMaximumHeight( m7traild3 );
ui->est2176->setMaxLength(15);
ui->est2176->setFrame(globalFrame);

ui->est2177->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "217   ") );
ui->est2177->setReadOnly(true);
ui->est2177->setAlignment(Qt::AlignRight);
ui->est2177->setMaximumWidth( m14trail);
ui->est2177->setMinimumWidth( m9trail);
ui->est2177->setMaximumHeight( m7traild3 );
ui->est2177->setMaxLength(15);
ui->est2177->setFrame(globalFrame);

ui->lib2181->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "218   ") );
connect( ui->lib2181, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2181, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib218, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst218, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib2181->installEventFilter(this);
ui->lib2181->setMaximumWidth( m6trail);
ui->lib2181->setMinimumWidth( m6trail);
ui->lib2181->setMaximumHeight( m7traild3 );
ui->lib2181->setMaxLength(3);
ui->lib2181->setFrame(globalFrame);

ui->lib2182->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "218   ") );
connect( ui->lib2182, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2182, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2182->installEventFilter(this);
ui->lib2182->setMaximumWidth( m26trail);
ui->lib2182->setMinimumWidth( m25trail);
ui->lib2182->setMaximumHeight( m7traild3 );
ui->lib2182->setMaxLength(24);
ui->lib2182->setFrame(globalFrame);

ui->lib2183->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "218   ") );
connect( ui->lib2183, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2183, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2183->installEventFilter(this);
ui->lib2183->setAlignment(Qt::AlignCenter);
ui->lib2183->setMaximumWidth( m12trail);
ui->lib2183->setMinimumWidth( m6trail);
ui->lib2183->setMaximumHeight( m7traild3 );
ui->lib2183->setMaxLength(11);
ui->lib2183->setFrame(globalFrame);

ui->lib2184->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "218   ") );
connect( ui->lib2184, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2184, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2184->installEventFilter(this);
ui->lib2184->setAlignment(Qt::AlignCenter);
ui->lib2184->setMaximumWidth( m12trail);
ui->lib2184->setMinimumWidth( m6trail);
ui->lib2184->setMaximumHeight( m7traild3 );
ui->lib2184->setMaxLength(11);
ui->lib2184->setFrame(globalFrame);

ui->pushButtonEst218->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "218   ") );
ui->pushButtonEst218->setMaximumWidth( m7traild3 );
ui->pushButtonEst218->setMaximumHeight( m7traild3 );
ui->pushButtonLib218->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "218   ") );
ui->pushButtonLib218->setMaximumWidth( m7traild3 );
ui->pushButtonLib218->setMaximumHeight( m7traild3 );

ui->est2181->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "218   ") );
connect( ui->est2181, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2181, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2181->installEventFilter(this);
ui->est2181->setMaximumWidth( m6trail);
ui->est2181->setMinimumWidth( m6trail);
ui->est2181->setMaximumHeight( m7traild3 );
ui->est2181->setMaxLength(3);
ui->est2181->setFrame(globalFrame);

ui->est2182->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "218   ") );
connect( ui->est2182, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2182, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2182->installEventFilter(this);
ui->est2182->setMaximumWidth( m26trail);
ui->est2182->setMinimumWidth( m25trail);
ui->est2182->setMaximumHeight( m7traild3 );
ui->est2182->setMaxLength(24);
ui->est2182->setFrame(globalFrame);

ui->est2183->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "218   ") );
connect( ui->est2183, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2183, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2183->installEventFilter(this);
ui->est2183->setAlignment(Qt::AlignCenter);
ui->est2183->setMaximumWidth( m11trail);
ui->est2183->setMinimumWidth( m6trail);
ui->est2183->setMaximumHeight( m7traild3 );
ui->est2183->setMaxLength(8);
ui->est2183->setFrame(globalFrame);

ui->est2184->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "218   ") );
connect( ui->est2184, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2184, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2184->installEventFilter(this);
ui->est2184->setAlignment(Qt::AlignCenter);
ui->est2184->setMaximumWidth( m12trail);
ui->est2184->setMinimumWidth( m6trail);
ui->est2184->setMaximumHeight( m7traild3 );
ui->est2184->setMaxLength(11);
ui->est2184->setFrame(globalFrame);

ui->est2185->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "218   ") );
connect( ui->est2185, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2185, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2185->installEventFilter(this);
ui->est2185->setAlignment(Qt::AlignCenter);
ui->est2185->setMaximumWidth( m12trail);
ui->est2185->setMinimumWidth( m6trail);
ui->est2185->setMaximumHeight( m7traild3 );
ui->est2185->setMaxLength(11);
ui->est2185->setFrame(globalFrame);

ui->est2186->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "218   ") );
ui->est2186->setReadOnly(true);
ui->est2186->setAlignment(Qt::AlignRight);
ui->est2186->setMaximumWidth( m14trail);
ui->est2186->setMinimumWidth( m9trail);
ui->est2186->setMaximumHeight( m7traild3 );
ui->est2186->setMaxLength(15);
ui->est2186->setFrame(globalFrame);

ui->est2187->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "218   ") );
ui->est2187->setReadOnly(true);
ui->est2187->setAlignment(Qt::AlignRight);
ui->est2187->setMaximumWidth( m14trail);
ui->est2187->setMinimumWidth( m9trail);
ui->est2187->setMaximumHeight( m7traild3 );
ui->est2187->setMaxLength(15);
ui->est2187->setFrame(globalFrame);

ui->lib2191->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "219   ") );
connect( ui->lib2191, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2191, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib219, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst219, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib2191->installEventFilter(this);
ui->lib2191->setMaximumWidth( m6trail);
ui->lib2191->setMinimumWidth( m6trail);
ui->lib2191->setMaximumHeight( m7traild3 );
ui->lib2191->setMaxLength(3);
ui->lib2191->setFrame(globalFrame);

ui->lib2192->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "219   ") );
connect( ui->lib2192, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2192, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2192->installEventFilter(this);
ui->lib2192->setMaximumWidth( m26trail);
ui->lib2192->setMinimumWidth( m25trail);
ui->lib2192->setMaximumHeight( m7traild3 );
ui->lib2192->setMaxLength(24);
ui->lib2192->setFrame(globalFrame);

ui->lib2193->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "219   ") );
connect( ui->lib2193, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2193, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2193->installEventFilter(this);
ui->lib2193->setAlignment(Qt::AlignCenter);
ui->lib2193->setMaximumWidth( m12trail);
ui->lib2193->setMinimumWidth( m6trail);
ui->lib2193->setMaximumHeight( m7traild3 );
ui->lib2193->setMaxLength(11);
ui->lib2193->setFrame(globalFrame);

ui->lib2194->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "219   ") );
connect( ui->lib2194, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2194, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2194->installEventFilter(this);
ui->lib2194->setAlignment(Qt::AlignCenter);
ui->lib2194->setMaximumWidth( m12trail);
ui->lib2194->setMinimumWidth( m6trail);
ui->lib2194->setMaximumHeight( m7traild3 );
ui->lib2194->setMaxLength(11);
ui->lib2194->setFrame(globalFrame);

ui->pushButtonEst219->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "219   ") );
ui->pushButtonEst219->setMaximumWidth( m7traild3 );
ui->pushButtonEst219->setMaximumHeight( m7traild3 );
ui->pushButtonLib219->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "219   ") );
ui->pushButtonLib219->setMaximumWidth( m7traild3 );
ui->pushButtonLib219->setMaximumHeight( m7traild3 );

ui->est2191->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "219   ") );
connect( ui->est2191, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2191, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2191->installEventFilter(this);
ui->est2191->setMaximumWidth( m6trail);
ui->est2191->setMinimumWidth( m6trail);
ui->est2191->setMaximumHeight( m7traild3 );
ui->est2191->setMaxLength(3);
ui->est2191->setFrame(globalFrame);

ui->est2192->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "219   ") );
connect( ui->est2192, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2192, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2192->installEventFilter(this);
ui->est2192->setMaximumWidth( m26trail);
ui->est2192->setMinimumWidth( m25trail);
ui->est2192->setMaximumHeight( m7traild3 );
ui->est2192->setMaxLength(24);
ui->est2192->setFrame(globalFrame);

ui->est2193->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "219   ") );
connect( ui->est2193, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2193, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2193->installEventFilter(this);
ui->est2193->setAlignment(Qt::AlignCenter);
ui->est2193->setMaximumWidth( m11trail);
ui->est2193->setMinimumWidth( m6trail);
ui->est2193->setMaximumHeight( m7traild3 );
ui->est2193->setMaxLength(8);
ui->est2193->setFrame(globalFrame);

ui->est2194->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "219   ") );
connect( ui->est2194, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2194, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2194->installEventFilter(this);
ui->est2194->setAlignment(Qt::AlignCenter);
ui->est2194->setMaximumWidth( m12trail);
ui->est2194->setMinimumWidth( m6trail);
ui->est2194->setMaximumHeight( m7traild3 );
ui->est2194->setMaxLength(11);
ui->est2194->setFrame(globalFrame);

ui->est2195->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "219   ") );
connect( ui->est2195, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2195, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2195->installEventFilter(this);
ui->est2195->setAlignment(Qt::AlignCenter);
ui->est2195->setMaximumWidth( m12trail);
ui->est2195->setMinimumWidth( m6trail);
ui->est2195->setMaximumHeight( m7traild3 );
ui->est2195->setMaxLength(11);
ui->est2195->setFrame(globalFrame);

ui->est2196->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "219   ") );
ui->est2196->setReadOnly(true);
ui->est2196->setAlignment(Qt::AlignRight);
ui->est2196->setMaximumWidth( m14trail);
ui->est2196->setMinimumWidth( m9trail);
ui->est2196->setMaximumHeight( m7traild3 );
ui->est2196->setMaxLength(15);
ui->est2196->setFrame(globalFrame);

ui->est2197->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "219   ") );
ui->est2197->setReadOnly(true);
ui->est2197->setAlignment(Qt::AlignRight);
ui->est2197->setMaximumWidth( m14trail);
ui->est2197->setMinimumWidth( m9trail);
ui->est2197->setMaximumHeight( m7traild3 );
ui->est2197->setMaxLength(15);
ui->est2197->setFrame(globalFrame);

ui->lib2201->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "220   ") );
connect( ui->lib2201, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2201, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib220, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst220, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib2201->installEventFilter(this);
ui->lib2201->setMaximumWidth( m6trail);
ui->lib2201->setMinimumWidth( m6trail);
ui->lib2201->setMaximumHeight( m7traild3 );
ui->lib2201->setMaxLength(3);
ui->lib2201->setFrame(globalFrame);

ui->lib2202->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "220   ") );
connect( ui->lib2202, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2202, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2202->installEventFilter(this);
ui->lib2202->setMaximumWidth( m26trail);
ui->lib2202->setMinimumWidth( m25trail);
ui->lib2202->setMaximumHeight( m7traild3 );
ui->lib2202->setMaxLength(24);
ui->lib2202->setFrame(globalFrame);

ui->lib2203->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "220   ") );
connect( ui->lib2203, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2203, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2203->installEventFilter(this);
ui->lib2203->setAlignment(Qt::AlignCenter);
ui->lib2203->setMaximumWidth( m12trail);
ui->lib2203->setMinimumWidth( m6trail);
ui->lib2203->setMaximumHeight( m7traild3 );
ui->lib2203->setMaxLength(11);
ui->lib2203->setFrame(globalFrame);

ui->lib2204->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "220   ") );
connect( ui->lib2204, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2204, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2204->installEventFilter(this);
ui->lib2204->setAlignment(Qt::AlignCenter);
ui->lib2204->setMaximumWidth( m12trail);
ui->lib2204->setMinimumWidth( m6trail);
ui->lib2204->setMaximumHeight( m7traild3 );
ui->lib2204->setMaxLength(11);
ui->lib2204->setFrame(globalFrame);

ui->pushButtonEst220->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "220   ") );
ui->pushButtonEst220->setMaximumWidth( m7traild3 );
ui->pushButtonEst220->setMaximumHeight( m7traild3 );
ui->pushButtonLib220->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "220   ") );
ui->pushButtonLib220->setMaximumWidth( m7traild3 );
ui->pushButtonLib220->setMaximumHeight( m7traild3 );

ui->est2201->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "220   ") );
connect( ui->est2201, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2201, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2201->installEventFilter(this);
ui->est2201->setMaximumWidth( m6trail);
ui->est2201->setMinimumWidth( m6trail);
ui->est2201->setMaximumHeight( m7traild3 );
ui->est2201->setMaxLength(3);
ui->est2201->setFrame(globalFrame);

ui->est2202->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "220   ") );
connect( ui->est2202, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2202, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2202->installEventFilter(this);
ui->est2202->setMaximumWidth( m26trail);
ui->est2202->setMinimumWidth( m25trail);
ui->est2202->setMaximumHeight( m7traild3 );
ui->est2202->setMaxLength(24);
ui->est2202->setFrame(globalFrame);

ui->est2203->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "220   ") );
connect( ui->est2203, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2203, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2203->installEventFilter(this);
ui->est2203->setAlignment(Qt::AlignCenter);
ui->est2203->setMaximumWidth( m11trail);
ui->est2203->setMinimumWidth( m6trail);
ui->est2203->setMaximumHeight( m7traild3 );
ui->est2203->setMaxLength(8);
ui->est2203->setFrame(globalFrame);

ui->est2204->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "220   ") );
connect( ui->est2204, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2204, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2204->installEventFilter(this);
ui->est2204->setAlignment(Qt::AlignCenter);
ui->est2204->setMaximumWidth( m12trail);
ui->est2204->setMinimumWidth( m6trail);
ui->est2204->setMaximumHeight( m7traild3 );
ui->est2204->setMaxLength(11);
ui->est2204->setFrame(globalFrame);

ui->est2205->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "220   ") );
connect( ui->est2205, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2205, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2205->installEventFilter(this);
ui->est2205->setAlignment(Qt::AlignCenter);
ui->est2205->setMaximumWidth( m12trail);
ui->est2205->setMinimumWidth( m6trail);
ui->est2205->setMaximumHeight( m7traild3 );
ui->est2205->setMaxLength(11);
ui->est2205->setFrame(globalFrame);

ui->est2206->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "220   ") );
ui->est2206->setReadOnly(true);
ui->est2206->setAlignment(Qt::AlignRight);
ui->est2206->setMaximumWidth( m14trail);
ui->est2206->setMinimumWidth( m9trail);
ui->est2206->setMaximumHeight( m7traild3 );
ui->est2206->setMaxLength(15);
ui->est2206->setFrame(globalFrame);

ui->est2207->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "220   ") );
ui->est2207->setReadOnly(true);
ui->est2207->setAlignment(Qt::AlignRight);
ui->est2207->setMaximumWidth( m14trail);
ui->est2207->setMinimumWidth( m9trail);
ui->est2207->setMaximumHeight( m7traild3 );
ui->est2207->setMaxLength(15);
ui->est2207->setFrame(globalFrame);

ui->lib2211->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "221   ") );
connect( ui->lib2211, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2211, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib221, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst221, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib2211->installEventFilter(this);
ui->lib2211->setMaximumWidth( m6trail);
ui->lib2211->setMinimumWidth( m6trail);
ui->lib2211->setMaximumHeight( m7traild3 );
ui->lib2211->setMaxLength(3);
ui->lib2211->setFrame(globalFrame);

ui->lib2212->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "221   ") );
connect( ui->lib2212, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2212, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2212->installEventFilter(this);
ui->lib2212->setMaximumWidth( m26trail);
ui->lib2212->setMinimumWidth( m25trail);
ui->lib2212->setMaximumHeight( m7traild3 );
ui->lib2212->setMaxLength(24);
ui->lib2212->setFrame(globalFrame);

ui->lib2213->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "221   ") );
connect( ui->lib2213, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2213, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2213->installEventFilter(this);
ui->lib2213->setAlignment(Qt::AlignCenter);
ui->lib2213->setMaximumWidth( m12trail);
ui->lib2213->setMinimumWidth( m6trail);
ui->lib2213->setMaximumHeight( m7traild3 );
ui->lib2213->setMaxLength(11);
ui->lib2213->setFrame(globalFrame);

ui->lib2214->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "221   ") );
connect( ui->lib2214, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2214, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2214->installEventFilter(this);
ui->lib2214->setAlignment(Qt::AlignCenter);
ui->lib2214->setMaximumWidth( m12trail);
ui->lib2214->setMinimumWidth( m6trail);
ui->lib2214->setMaximumHeight( m7traild3 );
ui->lib2214->setMaxLength(11);
ui->lib2214->setFrame(globalFrame);

ui->pushButtonEst221->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "221   ") );
ui->pushButtonEst221->setMaximumWidth( m7traild3 );
ui->pushButtonEst221->setMaximumHeight( m7traild3 );
ui->pushButtonLib221->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "221   ") );
ui->pushButtonLib221->setMaximumWidth( m7traild3 );
ui->pushButtonLib221->setMaximumHeight( m7traild3 );

ui->est2211->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "221   ") );
connect( ui->est2211, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2211, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2211->installEventFilter(this);
ui->est2211->setMaximumWidth( m6trail);
ui->est2211->setMinimumWidth( m6trail);
ui->est2211->setMaximumHeight( m7traild3 );
ui->est2211->setMaxLength(3);
ui->est2211->setFrame(globalFrame);

ui->est2212->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "221   ") );
connect( ui->est2212, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2212, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2212->installEventFilter(this);
ui->est2212->setMaximumWidth( m26trail);
ui->est2212->setMinimumWidth( m25trail);
ui->est2212->setMaximumHeight( m7traild3 );
ui->est2212->setMaxLength(24);
ui->est2212->setFrame(globalFrame);

ui->est2213->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "221   ") );
connect( ui->est2213, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2213, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2213->installEventFilter(this);
ui->est2213->setAlignment(Qt::AlignCenter);
ui->est2213->setMaximumWidth( m11trail);
ui->est2213->setMinimumWidth( m6trail);
ui->est2213->setMaximumHeight( m7traild3 );
ui->est2213->setMaxLength(8);
ui->est2213->setFrame(globalFrame);

ui->est2214->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "221   ") );
connect( ui->est2214, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2214, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2214->installEventFilter(this);
ui->est2214->setAlignment(Qt::AlignCenter);
ui->est2214->setMaximumWidth( m12trail);
ui->est2214->setMinimumWidth( m6trail);
ui->est2214->setMaximumHeight( m7traild3 );
ui->est2214->setMaxLength(11);
ui->est2214->setFrame(globalFrame);

ui->est2215->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "221   ") );
connect( ui->est2215, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2215, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2215->installEventFilter(this);
ui->est2215->setAlignment(Qt::AlignCenter);
ui->est2215->setMaximumWidth( m12trail);
ui->est2215->setMinimumWidth( m6trail);
ui->est2215->setMaximumHeight( m7traild3 );
ui->est2215->setMaxLength(11);
ui->est2215->setFrame(globalFrame);

ui->est2216->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "221   ") );
ui->est2216->setReadOnly(true);
ui->est2216->setAlignment(Qt::AlignRight);
ui->est2216->setMaximumWidth( m14trail);
ui->est2216->setMinimumWidth( m9trail);
ui->est2216->setMaximumHeight( m7traild3 );
ui->est2216->setMaxLength(15);
ui->est2216->setFrame(globalFrame);

ui->est2217->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "221   ") );
ui->est2217->setReadOnly(true);
ui->est2217->setAlignment(Qt::AlignRight);
ui->est2217->setMaximumWidth( m14trail);
ui->est2217->setMinimumWidth( m9trail);
ui->est2217->setMaximumHeight( m7traild3 );
ui->est2217->setMaxLength(15);
ui->est2217->setFrame(globalFrame);

ui->lib2221->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "222   ") );
connect( ui->lib2221, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2221, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib222, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst222, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib2221->installEventFilter(this);
ui->lib2221->setMaximumWidth( m6trail);
ui->lib2221->setMinimumWidth( m6trail);
ui->lib2221->setMaximumHeight( m7traild3 );
ui->lib2221->setMaxLength(3);
ui->lib2221->setFrame(globalFrame);

ui->lib2222->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "222   ") );
connect( ui->lib2222, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2222, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2222->installEventFilter(this);
ui->lib2222->setMaximumWidth( m26trail);
ui->lib2222->setMinimumWidth( m25trail);
ui->lib2222->setMaximumHeight( m7traild3 );
ui->lib2222->setMaxLength(24);
ui->lib2222->setFrame(globalFrame);

ui->lib2223->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "222   ") );
connect( ui->lib2223, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2223, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2223->installEventFilter(this);
ui->lib2223->setAlignment(Qt::AlignCenter);
ui->lib2223->setMaximumWidth( m12trail);
ui->lib2223->setMinimumWidth( m6trail);
ui->lib2223->setMaximumHeight( m7traild3 );
ui->lib2223->setMaxLength(11);
ui->lib2223->setFrame(globalFrame);

ui->lib2224->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "222   ") );
connect( ui->lib2224, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2224, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2224->installEventFilter(this);
ui->lib2224->setAlignment(Qt::AlignCenter);
ui->lib2224->setMaximumWidth( m12trail);
ui->lib2224->setMinimumWidth( m6trail);
ui->lib2224->setMaximumHeight( m7traild3 );
ui->lib2224->setMaxLength(11);
ui->lib2224->setFrame(globalFrame);

ui->pushButtonEst222->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "222   ") );
ui->pushButtonEst222->setMaximumWidth( m7traild3 );
ui->pushButtonEst222->setMaximumHeight( m7traild3 );
ui->pushButtonLib222->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "222   ") );
ui->pushButtonLib222->setMaximumWidth( m7traild3 );
ui->pushButtonLib222->setMaximumHeight( m7traild3 );

ui->est2221->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "222   ") );
connect( ui->est2221, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2221, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2221->installEventFilter(this);
ui->est2221->setMaximumWidth( m6trail);
ui->est2221->setMinimumWidth( m6trail);
ui->est2221->setMaximumHeight( m7traild3 );
ui->est2221->setMaxLength(3);
ui->est2221->setFrame(globalFrame);

ui->est2222->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "222   ") );
connect( ui->est2222, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2222, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2222->installEventFilter(this);
ui->est2222->setMaximumWidth( m26trail);
ui->est2222->setMinimumWidth( m25trail);
ui->est2222->setMaximumHeight( m7traild3 );
ui->est2222->setMaxLength(24);
ui->est2222->setFrame(globalFrame);

ui->est2223->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "222   ") );
connect( ui->est2223, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2223, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2223->installEventFilter(this);
ui->est2223->setAlignment(Qt::AlignCenter);
ui->est2223->setMaximumWidth( m11trail);
ui->est2223->setMinimumWidth( m6trail);
ui->est2223->setMaximumHeight( m7traild3 );
ui->est2223->setMaxLength(8);
ui->est2223->setFrame(globalFrame);

ui->est2224->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "222   ") );
connect( ui->est2224, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2224, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2224->installEventFilter(this);
ui->est2224->setAlignment(Qt::AlignCenter);
ui->est2224->setMaximumWidth( m12trail);
ui->est2224->setMinimumWidth( m6trail);
ui->est2224->setMaximumHeight( m7traild3 );
ui->est2224->setMaxLength(11);
ui->est2224->setFrame(globalFrame);

ui->est2225->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "222   ") );
connect( ui->est2225, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2225, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2225->installEventFilter(this);
ui->est2225->setAlignment(Qt::AlignCenter);
ui->est2225->setMaximumWidth( m12trail);
ui->est2225->setMinimumWidth( m6trail);
ui->est2225->setMaximumHeight( m7traild3 );
ui->est2225->setMaxLength(11);
ui->est2225->setFrame(globalFrame);

ui->est2226->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "222   ") );
ui->est2226->setReadOnly(true);
ui->est2226->setAlignment(Qt::AlignRight);
ui->est2226->setMaximumWidth( m14trail);
ui->est2226->setMinimumWidth( m9trail);
ui->est2226->setMaximumHeight( m7traild3 );
ui->est2226->setMaxLength(15);
ui->est2226->setFrame(globalFrame);

ui->est2227->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "222   ") );
ui->est2227->setReadOnly(true);
ui->est2227->setAlignment(Qt::AlignRight);
ui->est2227->setMaximumWidth( m14trail);
ui->est2227->setMinimumWidth( m9trail);
ui->est2227->setMaximumHeight( m7traild3 );
ui->est2227->setMaxLength(15);
ui->est2227->setFrame(globalFrame);

ui->lib2231->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "223   ") );
connect( ui->lib2231, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2231, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib223, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst223, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib2231->installEventFilter(this);
ui->lib2231->setMaximumWidth( m6trail);
ui->lib2231->setMinimumWidth( m6trail);
ui->lib2231->setMaximumHeight( m7traild3 );
ui->lib2231->setMaxLength(3);
ui->lib2231->setFrame(globalFrame);

ui->lib2232->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "223   ") );
connect( ui->lib2232, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2232, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2232->installEventFilter(this);
ui->lib2232->setMaximumWidth( m26trail);
ui->lib2232->setMinimumWidth( m25trail);
ui->lib2232->setMaximumHeight( m7traild3 );
ui->lib2232->setMaxLength(24);
ui->lib2232->setFrame(globalFrame);

ui->lib2233->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "223   ") );
connect( ui->lib2233, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2233, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2233->installEventFilter(this);
ui->lib2233->setAlignment(Qt::AlignCenter);
ui->lib2233->setMaximumWidth( m12trail);
ui->lib2233->setMinimumWidth( m6trail);
ui->lib2233->setMaximumHeight( m7traild3 );
ui->lib2233->setMaxLength(11);
ui->lib2233->setFrame(globalFrame);

ui->lib2234->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "223   ") );
connect( ui->lib2234, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2234, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2234->installEventFilter(this);
ui->lib2234->setAlignment(Qt::AlignCenter);
ui->lib2234->setMaximumWidth( m12trail);
ui->lib2234->setMinimumWidth( m6trail);
ui->lib2234->setMaximumHeight( m7traild3 );
ui->lib2234->setMaxLength(11);
ui->lib2234->setFrame(globalFrame);

ui->pushButtonEst223->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "223   ") );
ui->pushButtonEst223->setMaximumWidth( m7traild3 );
ui->pushButtonEst223->setMaximumHeight( m7traild3 );
ui->pushButtonLib223->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "223   ") );
ui->pushButtonLib223->setMaximumWidth( m7traild3 );
ui->pushButtonLib223->setMaximumHeight( m7traild3 );

ui->est2231->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "223   ") );
connect( ui->est2231, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2231, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2231->installEventFilter(this);
ui->est2231->setMaximumWidth( m6trail);
ui->est2231->setMinimumWidth( m6trail);
ui->est2231->setMaximumHeight( m7traild3 );
ui->est2231->setMaxLength(3);
ui->est2231->setFrame(globalFrame);

ui->est2232->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "223   ") );
connect( ui->est2232, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2232, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2232->installEventFilter(this);
ui->est2232->setMaximumWidth( m26trail);
ui->est2232->setMinimumWidth( m25trail);
ui->est2232->setMaximumHeight( m7traild3 );
ui->est2232->setMaxLength(24);
ui->est2232->setFrame(globalFrame);

ui->est2233->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "223   ") );
connect( ui->est2233, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2233, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2233->installEventFilter(this);
ui->est2233->setAlignment(Qt::AlignCenter);
ui->est2233->setMaximumWidth( m11trail);
ui->est2233->setMinimumWidth( m6trail);
ui->est2233->setMaximumHeight( m7traild3 );
ui->est2233->setMaxLength(8);
ui->est2233->setFrame(globalFrame);

ui->est2234->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "223   ") );
connect( ui->est2234, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2234, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2234->installEventFilter(this);
ui->est2234->setAlignment(Qt::AlignCenter);
ui->est2234->setMaximumWidth( m12trail);
ui->est2234->setMinimumWidth( m6trail);
ui->est2234->setMaximumHeight( m7traild3 );
ui->est2234->setMaxLength(11);
ui->est2234->setFrame(globalFrame);

ui->est2235->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "223   ") );
connect( ui->est2235, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2235, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2235->installEventFilter(this);
ui->est2235->setAlignment(Qt::AlignCenter);
ui->est2235->setMaximumWidth( m12trail);
ui->est2235->setMinimumWidth( m6trail);
ui->est2235->setMaximumHeight( m7traild3 );
ui->est2235->setMaxLength(11);
ui->est2235->setFrame(globalFrame);

ui->est2236->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "223   ") );
ui->est2236->setReadOnly(true);
ui->est2236->setAlignment(Qt::AlignRight);
ui->est2236->setMaximumWidth( m14trail);
ui->est2236->setMinimumWidth( m9trail);
ui->est2236->setMaximumHeight( m7traild3 );
ui->est2236->setMaxLength(15);
ui->est2236->setFrame(globalFrame);

ui->est2237->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "223   ") );
ui->est2237->setReadOnly(true);
ui->est2237->setAlignment(Qt::AlignRight);
ui->est2237->setMaximumWidth( m14trail);
ui->est2237->setMinimumWidth( m9trail);
ui->est2237->setMaximumHeight( m7traild3 );
ui->est2237->setMaxLength(15);
ui->est2237->setFrame(globalFrame);

ui->lib2241->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "224   ") );
connect( ui->lib2241, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2241, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib224, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst224, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib2241->installEventFilter(this);
ui->lib2241->setMaximumWidth( m6trail);
ui->lib2241->setMinimumWidth( m6trail);
ui->lib2241->setMaximumHeight( m7traild3 );
ui->lib2241->setMaxLength(3);
ui->lib2241->setFrame(globalFrame);

ui->lib2242->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "224   ") );
connect( ui->lib2242, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2242, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2242->installEventFilter(this);
ui->lib2242->setMaximumWidth( m26trail);
ui->lib2242->setMinimumWidth( m25trail);
ui->lib2242->setMaximumHeight( m7traild3 );
ui->lib2242->setMaxLength(24);
ui->lib2242->setFrame(globalFrame);

ui->lib2243->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "224   ") );
connect( ui->lib2243, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2243, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2243->installEventFilter(this);
ui->lib2243->setAlignment(Qt::AlignCenter);
ui->lib2243->setMaximumWidth( m12trail);
ui->lib2243->setMinimumWidth( m6trail);
ui->lib2243->setMaximumHeight( m7traild3 );
ui->lib2243->setMaxLength(11);
ui->lib2243->setFrame(globalFrame);

ui->lib2244->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "224   ") );
connect( ui->lib2244, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2244, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2244->installEventFilter(this);
ui->lib2244->setAlignment(Qt::AlignCenter);
ui->lib2244->setMaximumWidth( m12trail);
ui->lib2244->setMinimumWidth( m6trail);
ui->lib2244->setMaximumHeight( m7traild3 );
ui->lib2244->setMaxLength(11);
ui->lib2244->setFrame(globalFrame);

ui->pushButtonEst224->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "224   ") );
ui->pushButtonEst224->setMaximumWidth( m7traild3 );
ui->pushButtonEst224->setMaximumHeight( m7traild3 );
ui->pushButtonLib224->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "224   ") );
ui->pushButtonLib224->setMaximumWidth( m7traild3 );
ui->pushButtonLib224->setMaximumHeight( m7traild3 );

ui->est2241->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "224   ") );
connect( ui->est2241, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2241, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2241->installEventFilter(this);
ui->est2241->setMaximumWidth( m6trail);
ui->est2241->setMinimumWidth( m6trail);
ui->est2241->setMaximumHeight( m7traild3 );
ui->est2241->setMaxLength(3);
ui->est2241->setFrame(globalFrame);

ui->est2242->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "224   ") );
connect( ui->est2242, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2242, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2242->installEventFilter(this);
ui->est2242->setMaximumWidth( m26trail);
ui->est2242->setMinimumWidth( m25trail);
ui->est2242->setMaximumHeight( m7traild3 );
ui->est2242->setMaxLength(24);
ui->est2242->setFrame(globalFrame);

ui->est2243->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "224   ") );
connect( ui->est2243, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2243, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2243->installEventFilter(this);
ui->est2243->setAlignment(Qt::AlignCenter);
ui->est2243->setMaximumWidth( m11trail);
ui->est2243->setMinimumWidth( m6trail);
ui->est2243->setMaximumHeight( m7traild3 );
ui->est2243->setMaxLength(8);
ui->est2243->setFrame(globalFrame);

ui->est2244->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "224   ") );
connect( ui->est2244, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2244, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2244->installEventFilter(this);
ui->est2244->setAlignment(Qt::AlignCenter);
ui->est2244->setMaximumWidth( m12trail);
ui->est2244->setMinimumWidth( m6trail);
ui->est2244->setMaximumHeight( m7traild3 );
ui->est2244->setMaxLength(11);
ui->est2244->setFrame(globalFrame);

ui->est2245->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "224   ") );
connect( ui->est2245, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2245, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2245->installEventFilter(this);
ui->est2245->setAlignment(Qt::AlignCenter);
ui->est2245->setMaximumWidth( m12trail);
ui->est2245->setMinimumWidth( m6trail);
ui->est2245->setMaximumHeight( m7traild3 );
ui->est2245->setMaxLength(11);
ui->est2245->setFrame(globalFrame);

ui->est2246->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "224   ") );
ui->est2246->setReadOnly(true);
ui->est2246->setAlignment(Qt::AlignRight);
ui->est2246->setMaximumWidth( m14trail);
ui->est2246->setMinimumWidth( m9trail);
ui->est2246->setMaximumHeight( m7traild3 );
ui->est2246->setMaxLength(15);
ui->est2246->setFrame(globalFrame);

ui->est2247->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "224   ") );
ui->est2247->setReadOnly(true);
ui->est2247->setAlignment(Qt::AlignRight);
ui->est2247->setMaximumWidth( m14trail);
ui->est2247->setMinimumWidth( m9trail);
ui->est2247->setMaximumHeight( m7traild3 );
ui->est2247->setMaxLength(15);
ui->est2247->setFrame(globalFrame);

ui->lib2251->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "225   ") );
connect( ui->lib2251, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2251, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib225, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst225, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib2251->installEventFilter(this);
ui->lib2251->setMaximumWidth( m6trail);
ui->lib2251->setMinimumWidth( m6trail);
ui->lib2251->setMaximumHeight( m7traild3 );
ui->lib2251->setMaxLength(3);
ui->lib2251->setFrame(globalFrame);

ui->lib2252->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "225   ") );
connect( ui->lib2252, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2252, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2252->installEventFilter(this);
ui->lib2252->setMaximumWidth( m26trail);
ui->lib2252->setMinimumWidth( m25trail);
ui->lib2252->setMaximumHeight( m7traild3 );
ui->lib2252->setMaxLength(24);
ui->lib2252->setFrame(globalFrame);

ui->lib2253->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "225   ") );
connect( ui->lib2253, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2253, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2253->installEventFilter(this);
ui->lib2253->setAlignment(Qt::AlignCenter);
ui->lib2253->setMaximumWidth( m12trail);
ui->lib2253->setMinimumWidth( m6trail);
ui->lib2253->setMaximumHeight( m7traild3 );
ui->lib2253->setMaxLength(11);
ui->lib2253->setFrame(globalFrame);

ui->lib2254->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "225   ") );
connect( ui->lib2254, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2254, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2254->installEventFilter(this);
ui->lib2254->setAlignment(Qt::AlignCenter);
ui->lib2254->setMaximumWidth( m12trail);
ui->lib2254->setMinimumWidth( m6trail);
ui->lib2254->setMaximumHeight( m7traild3 );
ui->lib2254->setMaxLength(11);
ui->lib2254->setFrame(globalFrame);

ui->pushButtonEst225->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "225   ") );
ui->pushButtonEst225->setMaximumWidth( m7traild3 );
ui->pushButtonEst225->setMaximumHeight( m7traild3 );
ui->pushButtonLib225->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "225   ") );
ui->pushButtonLib225->setMaximumWidth( m7traild3 );
ui->pushButtonLib225->setMaximumHeight( m7traild3 );

ui->est2251->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "225   ") );
connect( ui->est2251, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2251, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2251->installEventFilter(this);
ui->est2251->setMaximumWidth( m6trail);
ui->est2251->setMinimumWidth( m6trail);
ui->est2251->setMaximumHeight( m7traild3 );
ui->est2251->setMaxLength(3);
ui->est2251->setFrame(globalFrame);

ui->est2252->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "225   ") );
connect( ui->est2252, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2252, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2252->installEventFilter(this);
ui->est2252->setMaximumWidth( m26trail);
ui->est2252->setMinimumWidth( m25trail);
ui->est2252->setMaximumHeight( m7traild3 );
ui->est2252->setMaxLength(24);
ui->est2252->setFrame(globalFrame);

ui->est2253->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "225   ") );
connect( ui->est2253, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2253, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2253->installEventFilter(this);
ui->est2253->setAlignment(Qt::AlignCenter);
ui->est2253->setMaximumWidth( m11trail);
ui->est2253->setMinimumWidth( m6trail);
ui->est2253->setMaximumHeight( m7traild3 );
ui->est2253->setMaxLength(8);
ui->est2253->setFrame(globalFrame);

ui->est2254->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "225   ") );
connect( ui->est2254, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2254, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2254->installEventFilter(this);
ui->est2254->setAlignment(Qt::AlignCenter);
ui->est2254->setMaximumWidth( m12trail);
ui->est2254->setMinimumWidth( m6trail);
ui->est2254->setMaximumHeight( m7traild3 );
ui->est2254->setMaxLength(11);
ui->est2254->setFrame(globalFrame);

ui->est2255->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "225   ") );
connect( ui->est2255, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2255, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2255->installEventFilter(this);
ui->est2255->setAlignment(Qt::AlignCenter);
ui->est2255->setMaximumWidth( m12trail);
ui->est2255->setMinimumWidth( m6trail);
ui->est2255->setMaximumHeight( m7traild3 );
ui->est2255->setMaxLength(11);
ui->est2255->setFrame(globalFrame);

ui->est2256->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "225   ") );
ui->est2256->setReadOnly(true);
ui->est2256->setAlignment(Qt::AlignRight);
ui->est2256->setMaximumWidth( m14trail);
ui->est2256->setMinimumWidth( m9trail);
ui->est2256->setMaximumHeight( m7traild3 );
ui->est2256->setMaxLength(15);
ui->est2256->setFrame(globalFrame);

ui->est2257->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "225   ") );
ui->est2257->setReadOnly(true);
ui->est2257->setAlignment(Qt::AlignRight);
ui->est2257->setMaximumWidth( m14trail);
ui->est2257->setMinimumWidth( m9trail);
ui->est2257->setMaximumHeight( m7traild3 );
ui->est2257->setMaxLength(15);
ui->est2257->setFrame(globalFrame);

ui->lib2261->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "226   ") );
connect( ui->lib2261, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2261, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib226, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst226, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib2261->installEventFilter(this);
ui->lib2261->setMaximumWidth( m6trail);
ui->lib2261->setMinimumWidth( m6trail);
ui->lib2261->setMaximumHeight( m7traild3 );
ui->lib2261->setMaxLength(3);
ui->lib2261->setFrame(globalFrame);

ui->lib2262->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "226   ") );
connect( ui->lib2262, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2262, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2262->installEventFilter(this);
ui->lib2262->setMaximumWidth( m26trail);
ui->lib2262->setMinimumWidth( m25trail);
ui->lib2262->setMaximumHeight( m7traild3 );
ui->lib2262->setMaxLength(24);
ui->lib2262->setFrame(globalFrame);

ui->lib2263->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "226   ") );
connect( ui->lib2263, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2263, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2263->installEventFilter(this);
ui->lib2263->setAlignment(Qt::AlignCenter);
ui->lib2263->setMaximumWidth( m12trail);
ui->lib2263->setMinimumWidth( m6trail);
ui->lib2263->setMaximumHeight( m7traild3 );
ui->lib2263->setMaxLength(11);
ui->lib2263->setFrame(globalFrame);

ui->lib2264->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "226   ") );
connect( ui->lib2264, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2264, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2264->installEventFilter(this);
ui->lib2264->setAlignment(Qt::AlignCenter);
ui->lib2264->setMaximumWidth( m12trail);
ui->lib2264->setMinimumWidth( m6trail);
ui->lib2264->setMaximumHeight( m7traild3 );
ui->lib2264->setMaxLength(11);
ui->lib2264->setFrame(globalFrame);

ui->pushButtonEst226->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "226   ") );
ui->pushButtonEst226->setMaximumWidth( m7traild3 );
ui->pushButtonEst226->setMaximumHeight( m7traild3 );
ui->pushButtonLib226->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "226   ") );
ui->pushButtonLib226->setMaximumWidth( m7traild3 );
ui->pushButtonLib226->setMaximumHeight( m7traild3 );

ui->est2261->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "226   ") );
connect( ui->est2261, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2261, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2261->installEventFilter(this);
ui->est2261->setMaximumWidth( m6trail);
ui->est2261->setMinimumWidth( m6trail);
ui->est2261->setMaximumHeight( m7traild3 );
ui->est2261->setMaxLength(3);
ui->est2261->setFrame(globalFrame);

ui->est2262->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "226   ") );
connect( ui->est2262, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2262, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2262->installEventFilter(this);
ui->est2262->setMaximumWidth( m26trail);
ui->est2262->setMinimumWidth( m25trail);
ui->est2262->setMaximumHeight( m7traild3 );
ui->est2262->setMaxLength(24);
ui->est2262->setFrame(globalFrame);

ui->est2263->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "226   ") );
connect( ui->est2263, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2263, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2263->installEventFilter(this);
ui->est2263->setAlignment(Qt::AlignCenter);
ui->est2263->setMaximumWidth( m11trail);
ui->est2263->setMinimumWidth( m6trail);
ui->est2263->setMaximumHeight( m7traild3 );
ui->est2263->setMaxLength(8);
ui->est2263->setFrame(globalFrame);

ui->est2264->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "226   ") );
connect( ui->est2264, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2264, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2264->installEventFilter(this);
ui->est2264->setAlignment(Qt::AlignCenter);
ui->est2264->setMaximumWidth( m12trail);
ui->est2264->setMinimumWidth( m6trail);
ui->est2264->setMaximumHeight( m7traild3 );
ui->est2264->setMaxLength(11);
ui->est2264->setFrame(globalFrame);

ui->est2265->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "226   ") );
connect( ui->est2265, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2265, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2265->installEventFilter(this);
ui->est2265->setAlignment(Qt::AlignCenter);
ui->est2265->setMaximumWidth( m12trail);
ui->est2265->setMinimumWidth( m6trail);
ui->est2265->setMaximumHeight( m7traild3 );
ui->est2265->setMaxLength(11);
ui->est2265->setFrame(globalFrame);

ui->est2266->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "226   ") );
ui->est2266->setReadOnly(true);
ui->est2266->setAlignment(Qt::AlignRight);
ui->est2266->setMaximumWidth( m14trail);
ui->est2266->setMinimumWidth( m9trail);
ui->est2266->setMaximumHeight( m7traild3 );
ui->est2266->setMaxLength(15);
ui->est2266->setFrame(globalFrame);

ui->est2267->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "226   ") );
ui->est2267->setReadOnly(true);
ui->est2267->setAlignment(Qt::AlignRight);
ui->est2267->setMaximumWidth( m14trail);
ui->est2267->setMinimumWidth( m9trail);
ui->est2267->setMaximumHeight( m7traild3 );
ui->est2267->setMaxLength(15);
ui->est2267->setFrame(globalFrame);

ui->lib2271->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "227   ") );
connect( ui->lib2271, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2271, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib227, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst227, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib2271->installEventFilter(this);
ui->lib2271->setMaximumWidth( m6trail);
ui->lib2271->setMinimumWidth( m6trail);
ui->lib2271->setMaximumHeight( m7traild3 );
ui->lib2271->setMaxLength(3);
ui->lib2271->setFrame(globalFrame);

ui->lib2272->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "227   ") );
connect( ui->lib2272, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2272, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2272->installEventFilter(this);
ui->lib2272->setMaximumWidth( m26trail);
ui->lib2272->setMinimumWidth( m25trail);
ui->lib2272->setMaximumHeight( m7traild3 );
ui->lib2272->setMaxLength(24);
ui->lib2272->setFrame(globalFrame);

ui->lib2273->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "227   ") );
connect( ui->lib2273, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2273, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2273->installEventFilter(this);
ui->lib2273->setAlignment(Qt::AlignCenter);
ui->lib2273->setMaximumWidth( m12trail);
ui->lib2273->setMinimumWidth( m6trail);
ui->lib2273->setMaximumHeight( m7traild3 );
ui->lib2273->setMaxLength(11);
ui->lib2273->setFrame(globalFrame);

ui->lib2274->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "227   ") );
connect( ui->lib2274, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2274, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2274->installEventFilter(this);
ui->lib2274->setAlignment(Qt::AlignCenter);
ui->lib2274->setMaximumWidth( m12trail);
ui->lib2274->setMinimumWidth( m6trail);
ui->lib2274->setMaximumHeight( m7traild3 );
ui->lib2274->setMaxLength(11);
ui->lib2274->setFrame(globalFrame);

ui->pushButtonEst227->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "227   ") );
ui->pushButtonEst227->setMaximumWidth( m7traild3 );
ui->pushButtonEst227->setMaximumHeight( m7traild3 );
ui->pushButtonLib227->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "227   ") );
ui->pushButtonLib227->setMaximumWidth( m7traild3 );
ui->pushButtonLib227->setMaximumHeight( m7traild3 );

ui->est2271->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "227   ") );
connect( ui->est2271, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2271, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2271->installEventFilter(this);
ui->est2271->setMaximumWidth( m6trail);
ui->est2271->setMinimumWidth( m6trail);
ui->est2271->setMaximumHeight( m7traild3 );
ui->est2271->setMaxLength(3);
ui->est2271->setFrame(globalFrame);

ui->est2272->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "227   ") );
connect( ui->est2272, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2272, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2272->installEventFilter(this);
ui->est2272->setMaximumWidth( m26trail);
ui->est2272->setMinimumWidth( m25trail);
ui->est2272->setMaximumHeight( m7traild3 );
ui->est2272->setMaxLength(24);
ui->est2272->setFrame(globalFrame);

ui->est2273->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "227   ") );
connect( ui->est2273, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2273, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2273->installEventFilter(this);
ui->est2273->setAlignment(Qt::AlignCenter);
ui->est2273->setMaximumWidth( m11trail);
ui->est2273->setMinimumWidth( m6trail);
ui->est2273->setMaximumHeight( m7traild3 );
ui->est2273->setMaxLength(8);
ui->est2273->setFrame(globalFrame);

ui->est2274->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "227   ") );
connect( ui->est2274, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2274, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2274->installEventFilter(this);
ui->est2274->setAlignment(Qt::AlignCenter);
ui->est2274->setMaximumWidth( m12trail);
ui->est2274->setMinimumWidth( m6trail);
ui->est2274->setMaximumHeight( m7traild3 );
ui->est2274->setMaxLength(11);
ui->est2274->setFrame(globalFrame);

ui->est2275->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "227   ") );
connect( ui->est2275, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2275, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2275->installEventFilter(this);
ui->est2275->setAlignment(Qt::AlignCenter);
ui->est2275->setMaximumWidth( m12trail);
ui->est2275->setMinimumWidth( m6trail);
ui->est2275->setMaximumHeight( m7traild3 );
ui->est2275->setMaxLength(11);
ui->est2275->setFrame(globalFrame);

ui->est2276->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "227   ") );
ui->est2276->setReadOnly(true);
ui->est2276->setAlignment(Qt::AlignRight);
ui->est2276->setMaximumWidth( m14trail);
ui->est2276->setMinimumWidth( m9trail);
ui->est2276->setMaximumHeight( m7traild3 );
ui->est2276->setMaxLength(15);
ui->est2276->setFrame(globalFrame);

ui->est2277->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "227   ") );
ui->est2277->setReadOnly(true);
ui->est2277->setAlignment(Qt::AlignRight);
ui->est2277->setMaximumWidth( m14trail);
ui->est2277->setMinimumWidth( m9trail);
ui->est2277->setMaximumHeight( m7traild3 );
ui->est2277->setMaxLength(15);
ui->est2277->setFrame(globalFrame);

ui->lib2281->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "228   ") );
connect( ui->lib2281, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2281, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib228, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst228, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib2281->installEventFilter(this);
ui->lib2281->setMaximumWidth( m6trail);
ui->lib2281->setMinimumWidth( m6trail);
ui->lib2281->setMaximumHeight( m7traild3 );
ui->lib2281->setMaxLength(3);
ui->lib2281->setFrame(globalFrame);

ui->lib2282->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "228   ") );
connect( ui->lib2282, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2282, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2282->installEventFilter(this);
ui->lib2282->setMaximumWidth( m26trail);
ui->lib2282->setMinimumWidth( m25trail);
ui->lib2282->setMaximumHeight( m7traild3 );
ui->lib2282->setMaxLength(24);
ui->lib2282->setFrame(globalFrame);

ui->lib2283->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "228   ") );
connect( ui->lib2283, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2283, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2283->installEventFilter(this);
ui->lib2283->setAlignment(Qt::AlignCenter);
ui->lib2283->setMaximumWidth( m12trail);
ui->lib2283->setMinimumWidth( m6trail);
ui->lib2283->setMaximumHeight( m7traild3 );
ui->lib2283->setMaxLength(11);
ui->lib2283->setFrame(globalFrame);

ui->lib2284->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "228   ") );
connect( ui->lib2284, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2284, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2284->installEventFilter(this);
ui->lib2284->setAlignment(Qt::AlignCenter);
ui->lib2284->setMaximumWidth( m12trail);
ui->lib2284->setMinimumWidth( m6trail);
ui->lib2284->setMaximumHeight( m7traild3 );
ui->lib2284->setMaxLength(11);
ui->lib2284->setFrame(globalFrame);

ui->pushButtonEst228->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "228   ") );
ui->pushButtonEst228->setMaximumWidth( m7traild3 );
ui->pushButtonEst228->setMaximumHeight( m7traild3 );
ui->pushButtonLib228->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "228   ") );
ui->pushButtonLib228->setMaximumWidth( m7traild3 );
ui->pushButtonLib228->setMaximumHeight( m7traild3 );

ui->est2281->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "228   ") );
connect( ui->est2281, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2281, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2281->installEventFilter(this);
ui->est2281->setMaximumWidth( m6trail);
ui->est2281->setMinimumWidth( m6trail);
ui->est2281->setMaximumHeight( m7traild3 );
ui->est2281->setMaxLength(3);
ui->est2281->setFrame(globalFrame);

ui->est2282->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "228   ") );
connect( ui->est2282, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2282, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2282->installEventFilter(this);
ui->est2282->setMaximumWidth( m26trail);
ui->est2282->setMinimumWidth( m25trail);
ui->est2282->setMaximumHeight( m7traild3 );
ui->est2282->setMaxLength(24);
ui->est2282->setFrame(globalFrame);

ui->est2283->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "228   ") );
connect( ui->est2283, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2283, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2283->installEventFilter(this);
ui->est2283->setAlignment(Qt::AlignCenter);
ui->est2283->setMaximumWidth( m11trail);
ui->est2283->setMinimumWidth( m6trail);
ui->est2283->setMaximumHeight( m7traild3 );
ui->est2283->setMaxLength(8);
ui->est2283->setFrame(globalFrame);

ui->est2284->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "228   ") );
connect( ui->est2284, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2284, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2284->installEventFilter(this);
ui->est2284->setAlignment(Qt::AlignCenter);
ui->est2284->setMaximumWidth( m12trail);
ui->est2284->setMinimumWidth( m6trail);
ui->est2284->setMaximumHeight( m7traild3 );
ui->est2284->setMaxLength(11);
ui->est2284->setFrame(globalFrame);

ui->est2285->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "228   ") );
connect( ui->est2285, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2285, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2285->installEventFilter(this);
ui->est2285->setAlignment(Qt::AlignCenter);
ui->est2285->setMaximumWidth( m12trail);
ui->est2285->setMinimumWidth( m6trail);
ui->est2285->setMaximumHeight( m7traild3 );
ui->est2285->setMaxLength(11);
ui->est2285->setFrame(globalFrame);

ui->est2286->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "228   ") );
ui->est2286->setReadOnly(true);
ui->est2286->setAlignment(Qt::AlignRight);
ui->est2286->setMaximumWidth( m14trail);
ui->est2286->setMinimumWidth( m9trail);
ui->est2286->setMaximumHeight( m7traild3 );
ui->est2286->setMaxLength(15);
ui->est2286->setFrame(globalFrame);

ui->est2287->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "228   ") );
ui->est2287->setReadOnly(true);
ui->est2287->setAlignment(Qt::AlignRight);
ui->est2287->setMaximumWidth( m14trail);
ui->est2287->setMinimumWidth( m9trail);
ui->est2287->setMaximumHeight( m7traild3 );
ui->est2287->setMaxLength(15);
ui->est2287->setFrame(globalFrame);

ui->lib2291->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "229   ") );
connect( ui->lib2291, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2291, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib229, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst229, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib2291->installEventFilter(this);
ui->lib2291->setMaximumWidth( m6trail);
ui->lib2291->setMinimumWidth( m6trail);
ui->lib2291->setMaximumHeight( m7traild3 );
ui->lib2291->setMaxLength(3);
ui->lib2291->setFrame(globalFrame);

ui->lib2292->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "229   ") );
connect( ui->lib2292, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2292, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2292->installEventFilter(this);
ui->lib2292->setMaximumWidth( m26trail);
ui->lib2292->setMinimumWidth( m25trail);
ui->lib2292->setMaximumHeight( m7traild3 );
ui->lib2292->setMaxLength(24);
ui->lib2292->setFrame(globalFrame);

ui->lib2293->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "229   ") );
connect( ui->lib2293, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2293, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2293->installEventFilter(this);
ui->lib2293->setAlignment(Qt::AlignCenter);
ui->lib2293->setMaximumWidth( m12trail);
ui->lib2293->setMinimumWidth( m6trail);
ui->lib2293->setMaximumHeight( m7traild3 );
ui->lib2293->setMaxLength(11);
ui->lib2293->setFrame(globalFrame);

ui->lib2294->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "229   ") );
connect( ui->lib2294, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2294, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2294->installEventFilter(this);
ui->lib2294->setAlignment(Qt::AlignCenter);
ui->lib2294->setMaximumWidth( m12trail);
ui->lib2294->setMinimumWidth( m6trail);
ui->lib2294->setMaximumHeight( m7traild3 );
ui->lib2294->setMaxLength(11);
ui->lib2294->setFrame(globalFrame);

ui->pushButtonEst229->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "229   ") );
ui->pushButtonEst229->setMaximumWidth( m7traild3 );
ui->pushButtonEst229->setMaximumHeight( m7traild3 );
ui->pushButtonLib229->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "229   ") );
ui->pushButtonLib229->setMaximumWidth( m7traild3 );
ui->pushButtonLib229->setMaximumHeight( m7traild3 );

ui->est2291->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "229   ") );
connect( ui->est2291, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2291, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2291->installEventFilter(this);
ui->est2291->setMaximumWidth( m6trail);
ui->est2291->setMinimumWidth( m6trail);
ui->est2291->setMaximumHeight( m7traild3 );
ui->est2291->setMaxLength(3);
ui->est2291->setFrame(globalFrame);

ui->est2292->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "229   ") );
connect( ui->est2292, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2292, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2292->installEventFilter(this);
ui->est2292->setMaximumWidth( m26trail);
ui->est2292->setMinimumWidth( m25trail);
ui->est2292->setMaximumHeight( m7traild3 );
ui->est2292->setMaxLength(24);
ui->est2292->setFrame(globalFrame);

ui->est2293->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "229   ") );
connect( ui->est2293, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2293, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2293->installEventFilter(this);
ui->est2293->setAlignment(Qt::AlignCenter);
ui->est2293->setMaximumWidth( m11trail);
ui->est2293->setMinimumWidth( m6trail);
ui->est2293->setMaximumHeight( m7traild3 );
ui->est2293->setMaxLength(8);
ui->est2293->setFrame(globalFrame);

ui->est2294->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "229   ") );
connect( ui->est2294, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2294, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2294->installEventFilter(this);
ui->est2294->setAlignment(Qt::AlignCenter);
ui->est2294->setMaximumWidth( m12trail);
ui->est2294->setMinimumWidth( m6trail);
ui->est2294->setMaximumHeight( m7traild3 );
ui->est2294->setMaxLength(11);
ui->est2294->setFrame(globalFrame);

ui->est2295->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "229   ") );
connect( ui->est2295, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2295, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2295->installEventFilter(this);
ui->est2295->setAlignment(Qt::AlignCenter);
ui->est2295->setMaximumWidth( m12trail);
ui->est2295->setMinimumWidth( m6trail);
ui->est2295->setMaximumHeight( m7traild3 );
ui->est2295->setMaxLength(11);
ui->est2295->setFrame(globalFrame);

ui->est2296->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "229   ") );
ui->est2296->setReadOnly(true);
ui->est2296->setAlignment(Qt::AlignRight);
ui->est2296->setMaximumWidth( m14trail);
ui->est2296->setMinimumWidth( m9trail);
ui->est2296->setMaximumHeight( m7traild3 );
ui->est2296->setMaxLength(15);
ui->est2296->setFrame(globalFrame);

ui->est2297->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "229   ") );
ui->est2297->setReadOnly(true);
ui->est2297->setAlignment(Qt::AlignRight);
ui->est2297->setMaximumWidth( m14trail);
ui->est2297->setMinimumWidth( m9trail);
ui->est2297->setMaximumHeight( m7traild3 );
ui->est2297->setMaxLength(15);
ui->est2297->setFrame(globalFrame);

ui->lib2301->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "230   ") );
connect( ui->lib2301, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2301, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib230, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst230, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib2301->installEventFilter(this);
ui->lib2301->setMaximumWidth( m6trail);
ui->lib2301->setMinimumWidth( m6trail);
ui->lib2301->setMaximumHeight( m7traild3 );
ui->lib2301->setMaxLength(3);
ui->lib2301->setFrame(globalFrame);

ui->lib2302->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "230   ") );
connect( ui->lib2302, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2302, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2302->installEventFilter(this);
ui->lib2302->setMaximumWidth( m26trail);
ui->lib2302->setMinimumWidth( m25trail);
ui->lib2302->setMaximumHeight( m7traild3 );
ui->lib2302->setMaxLength(24);
ui->lib2302->setFrame(globalFrame);

ui->lib2303->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "230   ") );
connect( ui->lib2303, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2303, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2303->installEventFilter(this);
ui->lib2303->setAlignment(Qt::AlignCenter);
ui->lib2303->setMaximumWidth( m12trail);
ui->lib2303->setMinimumWidth( m6trail);
ui->lib2303->setMaximumHeight( m7traild3 );
ui->lib2303->setMaxLength(11);
ui->lib2303->setFrame(globalFrame);

ui->lib2304->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "230   ") );
connect( ui->lib2304, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2304, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2304->installEventFilter(this);
ui->lib2304->setAlignment(Qt::AlignCenter);
ui->lib2304->setMaximumWidth( m12trail);
ui->lib2304->setMinimumWidth( m6trail);
ui->lib2304->setMaximumHeight( m7traild3 );
ui->lib2304->setMaxLength(11);
ui->lib2304->setFrame(globalFrame);

ui->pushButtonEst230->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "230   ") );
ui->pushButtonEst230->setMaximumWidth( m7traild3 );
ui->pushButtonEst230->setMaximumHeight( m7traild3 );
ui->pushButtonLib230->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "230   ") );
ui->pushButtonLib230->setMaximumWidth( m7traild3 );
ui->pushButtonLib230->setMaximumHeight( m7traild3 );

ui->est2301->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "230   ") );
connect( ui->est2301, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2301, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2301->installEventFilter(this);
ui->est2301->setMaximumWidth( m6trail);
ui->est2301->setMinimumWidth( m6trail);
ui->est2301->setMaximumHeight( m7traild3 );
ui->est2301->setMaxLength(3);
ui->est2301->setFrame(globalFrame);

ui->est2302->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "230   ") );
connect( ui->est2302, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2302, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2302->installEventFilter(this);
ui->est2302->setMaximumWidth( m26trail);
ui->est2302->setMinimumWidth( m25trail);
ui->est2302->setMaximumHeight( m7traild3 );
ui->est2302->setMaxLength(24);
ui->est2302->setFrame(globalFrame);

ui->est2303->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "230   ") );
connect( ui->est2303, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2303, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2303->installEventFilter(this);
ui->est2303->setAlignment(Qt::AlignCenter);
ui->est2303->setMaximumWidth( m11trail);
ui->est2303->setMinimumWidth( m6trail);
ui->est2303->setMaximumHeight( m7traild3 );
ui->est2303->setMaxLength(8);
ui->est2303->setFrame(globalFrame);

ui->est2304->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "230   ") );
connect( ui->est2304, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2304, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2304->installEventFilter(this);
ui->est2304->setAlignment(Qt::AlignCenter);
ui->est2304->setMaximumWidth( m12trail);
ui->est2304->setMinimumWidth( m6trail);
ui->est2304->setMaximumHeight( m7traild3 );
ui->est2304->setMaxLength(11);
ui->est2304->setFrame(globalFrame);

ui->est2305->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "230   ") );
connect( ui->est2305, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2305, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2305->installEventFilter(this);
ui->est2305->setAlignment(Qt::AlignCenter);
ui->est2305->setMaximumWidth( m12trail);
ui->est2305->setMinimumWidth( m6trail);
ui->est2305->setMaximumHeight( m7traild3 );
ui->est2305->setMaxLength(11);
ui->est2305->setFrame(globalFrame);

ui->est2306->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "230   ") );
ui->est2306->setReadOnly(true);
ui->est2306->setAlignment(Qt::AlignRight);
ui->est2306->setMaximumWidth( m14trail);
ui->est2306->setMinimumWidth( m9trail);
ui->est2306->setMaximumHeight( m7traild3 );
ui->est2306->setMaxLength(15);
ui->est2306->setFrame(globalFrame);

ui->est2307->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "230   ") );
ui->est2307->setReadOnly(true);
ui->est2307->setAlignment(Qt::AlignRight);
ui->est2307->setMaximumWidth( m14trail);
ui->est2307->setMinimumWidth( m9trail);
ui->est2307->setMaximumHeight( m7traild3 );
ui->est2307->setMaxLength(15);
ui->est2307->setFrame(globalFrame);

ui->lib2311->setStatusTip( libcol1.replace( OFFSET, DIGITSforROW, "231   ") );
connect( ui->lib2311, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2311, &QLineEdit::inputRejected, this, &MainWindow::validateField );
connect( ui->pushButtonLib231, &QPushButton::released, this, &MainWindow::libraryLibtoEst );
connect( ui->pushButtonEst231, &QPushButton::released, this, &MainWindow::libraryEsttoLib );
ui->lib2311->installEventFilter(this);
ui->lib2311->setMaximumWidth( m6trail);
ui->lib2311->setMinimumWidth( m6trail);
ui->lib2311->setMaximumHeight( m7traild3 );
ui->lib2311->setMaxLength(3);
ui->lib2311->setFrame(globalFrame);

ui->lib2312->setStatusTip( libcol2.replace( OFFSET, DIGITSforROW, "231   ") );
connect( ui->lib2312, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2312, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2312->installEventFilter(this);
ui->lib2312->setMaximumWidth( m26trail);
ui->lib2312->setMinimumWidth( m25trail);
ui->lib2312->setMaximumHeight( m7traild3 );
ui->lib2312->setMaxLength(24);
ui->lib2312->setFrame(globalFrame);

ui->lib2313->setStatusTip( libcol3.replace( OFFSET, DIGITSforROW, "231   ") );
connect( ui->lib2313, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2313, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2313->installEventFilter(this);
ui->lib2313->setAlignment(Qt::AlignCenter);
ui->lib2313->setMaximumWidth( m12trail);
ui->lib2313->setMinimumWidth( m6trail);
ui->lib2313->setMaximumHeight( m7traild3 );
ui->lib2313->setMaxLength(11);
ui->lib2313->setFrame(globalFrame);

ui->lib2314->setStatusTip( libcol4.replace( OFFSET, DIGITSforROW, "231   ") );
connect( ui->lib2314, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->lib2314, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->lib2314->installEventFilter(this);
ui->lib2314->setAlignment(Qt::AlignCenter);
ui->lib2314->setMaximumWidth( m12trail);
ui->lib2314->setMinimumWidth( m6trail);
ui->lib2314->setMaximumHeight( m7traild3 );
ui->lib2314->setMaxLength(11);
ui->lib2314->setFrame(globalFrame);

ui->pushButtonEst231->setStatusTip( esttolib.replace( OFFSET, DIGITSforROW, "231   ") );
ui->pushButtonEst231->setMaximumWidth( m7traild3 );
ui->pushButtonEst231->setMaximumHeight( m7traild3 );
ui->pushButtonLib231->setStatusTip( libtoest.replace( OFFSET, DIGITSforROW, "231   ") );
ui->pushButtonLib231->setMaximumWidth( m7traild3 );
ui->pushButtonLib231->setMaximumHeight( m7traild3 );

ui->est2311->setStatusTip( estcol1.replace( OFFSET, DIGITSforROW, "231   ") );
connect( ui->est2311, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2311, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2311->installEventFilter(this);
ui->est2311->setMaximumWidth( m6trail);
ui->est2311->setMinimumWidth( m6trail);
ui->est2311->setMaximumHeight( m7traild3 );
ui->est2311->setMaxLength(3);
ui->est2311->setFrame(globalFrame);

ui->est2312->setStatusTip( estcol2.replace( OFFSET, DIGITSforROW, "231   ") );
connect( ui->est2312, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2312, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2312->installEventFilter(this);
ui->est2312->setMaximumWidth( m26trail);
ui->est2312->setMinimumWidth( m25trail);
ui->est2312->setMaximumHeight( m7traild3 );
ui->est2312->setMaxLength(24);
ui->est2312->setFrame(globalFrame);

ui->est2313->setStatusTip( estcol3.replace( OFFSET, DIGITSforROW, "231   ") );
connect( ui->est2313, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2313, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2313->installEventFilter(this);
ui->est2313->setAlignment(Qt::AlignCenter);
ui->est2313->setMaximumWidth( m11trail);
ui->est2313->setMinimumWidth( m6trail);
ui->est2313->setMaximumHeight( m7traild3 );
ui->est2313->setMaxLength(8);
ui->est2313->setFrame(globalFrame);

ui->est2314->setStatusTip( estcol4.replace( OFFSET, DIGITSforROW, "231   ") );
connect( ui->est2314, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2314, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2314->installEventFilter(this);
ui->est2314->setAlignment(Qt::AlignCenter);
ui->est2314->setMaximumWidth( m12trail);
ui->est2314->setMinimumWidth( m6trail);
ui->est2314->setMaximumHeight( m7traild3 );
ui->est2314->setMaxLength(11);
ui->est2314->setFrame(globalFrame);

ui->est2315->setStatusTip( estcol5.replace( OFFSET, DIGITSforROW, "231   ") );
connect( ui->est2315, &QLineEdit::editingFinished, this, &MainWindow::doCalc );
connect( ui->est2315, &QLineEdit::inputRejected, this, &MainWindow::validateField );
ui->est2315->installEventFilter(this);
ui->est2315->setAlignment(Qt::AlignCenter);
ui->est2315->setMaximumWidth( m12trail);
ui->est2315->setMinimumWidth( m6trail);
ui->est2315->setMaximumHeight( m7traild3 );
ui->est2315->setMaxLength(11);
ui->est2315->setFrame(globalFrame);

ui->est2316->setStatusTip( estcol6.replace( OFFSET, DIGITSforROW, "231   ") );
ui->est2316->setReadOnly(true);
ui->est2316->setAlignment(Qt::AlignRight);
ui->est2316->setMaximumWidth( m14trail);
ui->est2316->setMinimumWidth( m9trail);
ui->est2316->setMaximumHeight( m7traild3 );
ui->est2316->setMaxLength(15);
ui->est2316->setFrame(globalFrame);

ui->est2317->setStatusTip( estcol7.replace( OFFSET, DIGITSforROW, "231   ") );
ui->est2317->setReadOnly(true);
ui->est2317->setAlignment(Qt::AlignRight);
ui->est2317->setMaximumWidth( m14trail);
ui->est2317->setMinimumWidth( m9trail);
ui->est2317->setMaximumHeight( m7traild3 );
ui->est2317->setMaxLength(15);
ui->est2317->setFrame(globalFrame);
#endif

#endif
    show();
    return;
}
